<?php

include("check_session.php");

?>

<?php

  // Get Token Id
  $token_id = $_POST["token_id"];

  // Generate temporary filenames
  $filename = "pov_scene_".$token_id;
  $stdlog = "pov_stdout_".$token_id.".log";
  $errlog = "pov_stderr_".$token_id.".log";
  $dat_filename = $filename.".pov";
  $png_filename = $filename.".png";

  // Web root directory
  $web_root = "/var/services/web";

  // Read content of scene and generate dat file
  $content = $_POST["scene"];

  $file = fopen($web_root."/web_images/".$dat_filename ,"w");
  fwrite($file,$content);
  fclose($file);

  // Read parameters
  $width = $_POST["widthvalue"];
  $height = $_POST["heightvalue"];
  $antialiasing = $_POST["antialiasing"];
  $quality = $_POST["quality"];

  // Generate scene in background with DKB Trace with log file and remove std log file at the end
  exec("/volume1/web/povray/exec.sh ".chr(34)."/usr/local/povray/bin/povray +i".$web_root."/web_images/".$dat_filename." +w$width +h$height +l/usr/local/povray/share/povray-3.7/include/ +o".$web_root."/web_images/".$png_filename ." +a$antialiasing +q$quality +v ".chr(34)." ".chr(34)."mv ".$web_root."/web_images/".$stdlog." ".$web_root."/web_images/pov_stdout.log".chr(34)." >".$web_root."/web_images/".$stdlog."  2>".$web_root."/web_images/".$errlog." &", $output, $return);

?>

<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>POV-Ray Render</title>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="/povray/css/bootstrap.min.css">
  <script src="/povray/js/bootstrap.min.js"></script>
</head>

<body>


<?php

  // Error when rendering scene : ie errlog file not empty
  sleep(1);
  exec("cat ".$web_root."/web_images/".$errlog." | grep 'Fatal error'", $output);
  //if (0 != filesize( $web_root."/web_images/".$errlog ) )
  if ($output[0]!="")
  {
 
?>

<h2><span class="label label-primary">POV-Ray Renderer 3.7</span></h2><br><br>

<div class="panel panel-default">
  <div class="panel-heading">
    <h3 class="panel-title">Control Panel</h3>
  </div>
  <div class="panel-body">
	  
    <button type="button" class="btn btn-warning" onclick=" window.history.back();">
      <span class="glyphicon glyphicon-step-backward"></span> Back
    </button>
	  
    <button type="button" class="btn btn-default" onclick="window.open('help/index.html','POV-Ray Documentation','left=100,top=100,width=1100,height=600');">
      <span class="glyphicon glyphicon-question-sign"></span> Documentation
    </button>

  </div>
</div>


<div class="panel panel-default">
  <div class="panel-heading">
    <h3 class="panel-title">Error detected </h3>
  </div>
  <div class="panel-body">
	 
  
<?php
	$errfile = fopen($web_root."/web_images/".$errlog, "r");
    $errlineno = 1;
    // Display error lines
	while(!feof($errfile)) 
	{
	  $errline = fgets($errfile);

	  // Find err line number 
	  $pattern = '/line [0-9]+/';
	  if (preg_match($pattern, $errline, $matches) == 1)
	  {
		  $errlineno = str_replace("line ", "", $matches[0])-1;
	  }
	}
	fclose($errfile);
	// Display 3 lines corresponding to error details
	exec("cat ".$web_root."/web_images/".$errlog." | grep 'File'", $details1);
	echo $details1[0]."<br>";
	exec("cat ".$web_root."/web_images/".$errlog." | grep 'Error'", $details2);
	echo $details2[0]."<br>";
	exec("cat ".$web_root."/web_images/".$errlog." | grep 'instead'", $details3);
	echo $details3[0]."<br>";


?>	
  </div>

  <div class="panel-heading">
    <h3 class="panel-title">Scene Description </h3>
  </div>
  <div class="panel-body">
    <pre>
<?php

    // Read pov filename
    $filename = "pov_scene_".$token_id;
    $dat_filename = $filename.".pov";
	
	$file = fopen($web_root."/web_images/".$dat_filename ,"r");
    $content = fread($file, filesize($web_root."/web_images/".$dat_filename));
	fclose($file);

    $content_lines = explode("\n", $content);
	
	$errline = $errlineno;
	$topline = $errline-10;
	$bottomline = $errline+10;
	$line = 0;
	echo "...\n";
	foreach($content_lines as $key => $value)
	{
	  if ($line >= $topline and $line <= $bottomline)
	  {
	    if ($line == $errline)
	    {
	      echo "<font color=red>".$line." ".$value."</font>";
	    }
		else
		{
	      echo $line." ".$value;
		}
	  }
	  $line = $line+1;
	}
	echo "\n...";
	
	
?>
    </pre>
  </div>
</div>

<div class="panel panel-default">
  <div class="panel-heading">
    <h3 class="panel-title">Control Panel</h3>
  </div>
  <div class="panel-body">
	  
    <button type="button" class="btn btn-warning" onclick=" window.history.back();">
      <span class="glyphicon glyphicon-step-backward"></span> Back
    </button>
	  
    <button type="button" class="btn btn-default" onclick="window.open('help/index.html','POV-Ray Documentation','left=100,top=100,width=1100,height=600');">
      <span class="glyphicon glyphicon-question-sign"></span> Documentation
    </button>

  </div>
</div>


<?php	
}
// Redirect to status page
else
{
?>
  <script type="text/javascript">
    window.location.replace("status.php?<?php echo "token_id=".$token_id."&width=".$width."&height=".$height."&antialiasing=".$antialiasing."&quality=".$quality; ?>");
  </script>
   
<?php
}
?>

</body>
</html>



