<?php

include("check_session.php");

?>

<!DOCTYPE html>
<html>
<head>
  <title>POV-Ray</title>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  
  <link rel="stylesheet" href="/povray/css/bootstrap.min.css">
  <script src="/povray/js/jquery-3.2.0.min.js"></script>
  <script src="/povray/js/bootstrap.min.js"></script>

</head>


<body onload="generateTokenId();">
	<h2><span class="label label-primary">POV-Ray Renderer 3.7</span></h2><br><br>

			
<form method="post" action="render.php">

<div class="panel panel-default">
  <div class="panel-heading">
    <h3 class="panel-title">Control Panel</h3>
  </div>
  <div class="panel-body">

  <!-- Token Id --> 
  <input type="text" name="token_id" id="token_id" style="display:none;">
	  
  <div class="dropdown">

    <button type="reset" class="btn btn-default">
      <span class="glyphicon glyphicon-cog"></span> Reset
    </button>
	
    <button type="button" class="btn btn-default" onclick="window.open('help/index.html','POV-Ray Documentation','left=100,top=100,width=1100,height=600');">
      <span class="glyphicon glyphicon-question-sign"></span> Documentation
    </button>

    <button class="btn btn-default dropdown-toggle" type="button" data-toggle="dropdown">
	<span class="glyphicon glyphicon-star-empty"></span>
		Samples
    <span class="caret"></span></button>
    <ul class="dropdown-menu dropdown-menu-right">
      <li><a href="#">abyss.pov</a></li>
      <li><a href="#">archimedean_example.pov</a></li>
      <li><a href="#">biscuit.pov</a></li>
      <li><a href="#">boyssurface.pov</a></li>
      <li><a href="#">brushes.pov</a></li>
      <li><a href="#">cluster.pov</a></li>
      <li><a href="#">cornell.pov</a></li>
      <li><a href="#">crack1.pov</a></li>
      <li><a href="#">chromes.pov</a></li>
      <li><a href="#">dodec.pov</a></li>
      <li><a href="#">fractal1.pov</a></li>
      <li><a href="#">irid.pov</a></li>
      <li><a href="#">isocacti.pov</a></li>
      <li><a href="#">lostbus.pov</a></li>
      <li><a href="#">patio-radio_36.pov</a></li>
      <li><a href="#">quilt1.pov</a></li>
      <li><a href="#">radiosity2.pov</a></li>
      <li><a href="#">sample_scene.pov</a></li>
      <li><a href="#">sombrero.pov</a></li>
      <li><a href="#">stackerday.pov</a></li>
      <li><a href="#">tango.pov</a></li>
      <li><a href="#">teapot2.pov</a></li>
      <li><a href="#">torusknot.pov</a></li>
      <li><a href="#">trace-wicker.pov</a></li>
      <li><a href="#">tree.pov</a></li>
    </ul>


    <button type="submit" class="btn btn-success">
      <span class="glyphicon glyphicon-play-circle"></span> Render
    </button>

  </div>

  </div>
</div>

		
<div class="panel panel-default">
  <div class="panel-heading">
    <h3 class="panel-title">Parameters</h3>
  </div>
  <div class="panel-body">
	  

    <!-- wxxx = width of the screen -->
	Width : <input type="number" name="widthvalue" id="widthvalue" value="800" min="0" max="2560" step="10" onchange="changeWidthSliderValue(this.value)">
    (0 - 2560) <input type="range" name="witdh" id="widthslider" min="0" max="2560" value="800" step="10" style="width: 200px;" onchange="changeWidthValue(this.value)" > <br>
		
		
	<!-- hxxx = height of the screen -->
	Height : <input type="number" name="heightvalue" id="heightvalue" value="600" min="0" max="1920" step="10" onchange="changeHeightSliderValue(this.value)">
    (0 - 1920) <input type="range" name="height" id="heightslider" min="0" max="1920" value="600" step="10" style="width: 200px;" onchange="changeHeightValue(this.value)" > <br>
	
    <!-- a  = perform antialiasing (yes : +a or no : -a) -->
	<!-- If the anti-aliasing threshold is 0.0, then every pixel is
         supersampled.  If the threshold is 1.0, then no anti-aliasing
         is done.  Good values seem to be around 0.2 to 0.4.
	-->
	Antialiasing : <input name="antialiasing" value="0.3">
	(0.0 every pixel is supersamples. 1.0 no anti-aliasing. good values around 0.2 to 0.4) <br><br>
	
    <!-- qx = image quality 0=rough, 9=full -->
	Image quality : <input type="number" name="quality" value="9">
    (0=rough, 9=full) <br><br>

  </div>
</div>
	
	
<div class="panel panel-default">
  <div class="panel-heading">
    <h3 class="panel-title">Scene Description : <label id="scenelabel">sample_scene.pov</label></h3>
  </div>
  <div class="panel-body">
	 
  
  <br>
  <textarea name="scene" id="scene" rows=25 cols=120>
// POV-Ray sample scene

#include "colors.inc"
#include "textures.inc"

// Camera 
camera 
{
  location <0, 5, -5.5>
  look_at  <0, 1,  0>
}

// Two light sources
light_source 
{ 
  <10, 10, 15> 
  color White
}
light_source 
{ 
  <-100, 150, -20> 
  color White
}

// Simple object : sphere
sphere 
{
   <0, 0, 2>, 3
   texture 
   {
      Vicks_Bottle_Glass
   }
}

// The sky
sky_sphere 
{
  pigment 
  {
    Blue_Sky   // Alternatives:  Blue_Sky, Blue_Sky2, Blood_Sky, Blue_Sky3, Apocalypse
  }
}

// Infinite plane with hexagonal tiling
plane 
{
   <0, 1, 0>, -3
   texture 
   {
      pigment 
      {
        hexagon rgb <0.6,0.6,0.6>, rgb <0.8,0.8,0.8>, White
        scale 2
      }
   }
}

  </textarea>
  
  
  </div>
</div>
  
  
<div class="panel panel-default">
  <div class="panel-heading">
    <h3 class="panel-title">Control Panel</h3>
  </div>
  <div class="panel-body">
	  
    <button type="button" class="btn btn-primary" onclick="window.location.href='login.html';">
      <span class="glyphicon glyphicon-user"></span> Login 
    </button>

    <button type="reset" class="btn btn-default">
      <span class="glyphicon glyphicon-cog"></span> Reset
    </button>

    <button type="button" class="btn btn-default" onclick="window.open('help/index.html','POV-Ray Documentation','left=100,top=100,width=1100,height=600');">		
      <span class="glyphicon glyphicon-question-sign"></span> Documentation
    </button>

    <button type="submit" class="btn btn-success">
      <span class="glyphicon glyphicon-play-circle"></span> Render 
    </button>

  </div>
</div>
  
  
  
</form>

<!-- Sample file : sample_scene.pov -->

<textarea id="sample_scene.pov" name="sample_scene.pov" style="display:none;">
// POV-Ray sample scene

#include "colors.inc"
#include "textures.inc"

// Camera 
camera 
{
  location <0, 5, -5.5>
  look_at  <0, 1,  0>
}

// Two light sources
light_source 
{ 
  <10, 10, 15> 
  color White
}
light_source 
{ 
  <-100, 150, -20> 
  color White
}

// Simple object : sphere
sphere 
{
   <0, 0, 2>, 3
   texture 
   {
      Vicks_Bottle_Glass
   }
}

// The sky
sky_sphere 
{
  pigment 
  {
    Blue_Sky   // Alternatives:  Blue_Sky, Blue_Sky2, Blood_Sky, Blue_Sky3, Apocalypse
  }
}

// Infinite plane with hexagonal tiling
plane 
{
   <0, 1, 0>, -3
   texture 
   {
      pigment 
      {
        hexagon rgb <0.6,0.6,0.6>, rgb <0.8,0.8,0.8>, White
        scale 2
      }
   }
}
</textarea>



<!-- Sample file : chromes.pov -->

<textarea id="chromes.pov" name="chromes.pov" style="display:none;">
// This work is licensed under the Creative Commons Attribution-ShareAlike 3.0 Unported License.
// To view a copy of this license, visit http://creativecommons.org/licenses/by-sa/3.0/ or send a
// letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.

// Persistence Of Vision Raytracer sample file.
//
// -w320 -h240
// -w800 -h600 +a0.3

#version 3.6;

global_settings {
  assumed_gamma 2.2
  max_trace_level 5
}

#include "colors.inc"
#include "shapes.inc"
#include "metals.inc"

#declare T01 = texture { T_Chrome_1A }
#declare T02 = texture { T_Chrome_1B }
#declare T03 = texture { T_Chrome_1C }
#declare T04 = texture { T_Chrome_1D }
#declare T05 = texture { T_Chrome_1E }

#declare T06 = texture { T_Chrome_2A }
#declare T07 = texture { T_Chrome_2B }
#declare T08 = texture { T_Chrome_2C }
#declare T09 = texture { T_Chrome_2D }
#declare T10 = texture { T_Chrome_2E }

#declare T11 = texture { T_Chrome_3A }
#declare T12 = texture { T_Chrome_3B }
#declare T13 = texture { T_Chrome_3C }
#declare T14 = texture { T_Chrome_3D }
#declare T15 = texture { T_Chrome_3E }

#declare T16 = texture { T_Chrome_4A }
#declare T17 = texture { T_Chrome_4B }
#declare T18 = texture { T_Chrome_4C }
#declare T19 = texture { T_Chrome_4D }
#declare T20 = texture { T_Chrome_4E }

#declare T21 = texture { T_Chrome_5A }
#declare T22 = texture { T_Chrome_5B }
#declare T23 = texture { T_Chrome_5C }
#declare T24 = texture { T_Chrome_5D }
#declare T25 = texture { T_Chrome_5E }


camera {
   location <0, 20, -30>
   direction <0, 0,  1.75>
   right x*1.33
   look_at 0*y
}

light_source {<-50, 50, -1000> color Gray50}
light_source {< 50, 30, -20> color Gray75}

//background { color Gray50 }

sky_sphere {
    pigment {
        gradient y
        color_map {[0, 1  color Gray50 color Gray80]}
    }
}

plane { y, 0
    pigment {checker color Gray40 color Gray80
        scale <1, 1, 10000>
        rotate y*45
    }
    finish { ambient 0.45 }
}

#declare Stack =
union {
   sphere{<0, 4, 0>, 1}
   cone { -y,1, y, 0.5 translate 2*y }
   object {UnitBox}
}

#declare Height = 1;

#declare Dist1 =  10;
#declare Dist2 =   5;
#declare Dist3 =   0;
#declare Dist4 =  -5;
#declare Dist5 = -10;

#declare Col1 =  -8;
#declare Col2 =  -4;
#declare Col3 =   0;
#declare Col4 =   4;
#declare Col5 =   8;


object { Stack texture{T01} translate <Col1 Height Dist1 >}
object { Stack texture{T02} translate <Col2 Height Dist1 >}
object { Stack texture{T03} translate <Col3 Height Dist1 >}
object { Stack texture{T04} translate <Col4 Height Dist1 >}
object { Stack texture{T05} translate <Col5 Height Dist1 >}

object { Stack texture{T06} translate <Col1 Height Dist2 >}
object { Stack texture{T07} translate <Col2 Height Dist2 >}
object { Stack texture{T08} translate <Col3 Height Dist2 >}
object { Stack texture{T09} translate <Col4 Height Dist2 >}
object { Stack texture{T10} translate <Col5 Height Dist2 >}

object { Stack texture{T11} translate <Col1 Height Dist3 >}
object { Stack texture{T12} translate <Col2 Height Dist3 >}
object { Stack texture{T13} translate <Col3 Height Dist3 >}
object { Stack texture{T14} translate <Col4 Height Dist3 >}
object { Stack texture{T15} translate <Col5 Height Dist3 >}

object { Stack texture{T16} translate <Col1 Height Dist4 >}
object { Stack texture{T17} translate <Col2 Height Dist4 >}
object { Stack texture{T18} translate <Col3 Height Dist4 >}
object { Stack texture{T19} translate <Col4 Height Dist4 >}
object { Stack texture{T20} translate <Col5 Height Dist4 >}

object { Stack texture{T21} translate <Col1 Height Dist5 >}
object { Stack texture{T22} translate <Col2 Height Dist5 >}
object { Stack texture{T23} translate <Col3 Height Dist5 >}
object { Stack texture{T24} translate <Col4 Height Dist5 >}
object { Stack texture{T25} translate <Col5 Height Dist5 >}

</textarea>
	
<!-- Sample file : radiosity2.pov -->

<textarea id="radiosity2.pov" name="radiosity2.pov" style="display:none;">
// This work is licensed under the Creative Commons Attribution 3.0 Unported License.
// To view a copy of this license, visit http://creativecommons.org/licenses/by/3.0/
// or send a letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View,
// California, 94041, USA.

// Persistence Of Vision Ray Tracer Scene Description File
// File: radiosity2.pov
// Desc: radiosity tutorial scene
// Date: 2000-2001
// Auth: Christoph Hormann

// -w240 -h180 +a0.3

//#version 3.6;
#version 3.7;

#declare use_light=true;

global_settings {
  assumed_gamma 1.0
  radiosity {
    pretrace_start 0.08
    pretrace_end   0.04
    count 35

    nearest_count 5
    error_bound 0.2
    recursion_limit 1

    low_error_factor .5
    gray_threshold 0.0
    minimum_reuse 0.015
    brightness 1

    adc_bailout 0.01/2

  }
}

#if (use_light)
  light_source {
    <-1.5, 1, -0.5>*10000
    color rgb <1.0, 0.92, 0.77>
  }
#end

camera {
  location <3.8, 7.8, -10>
  look_at <0.0, 0.0, 0.0>
}


sphere {
  <0, 0, 0>, 1
  texture {
   pigment {
     gradient y
     color_map {
       [0.0 color rgb < 0.880, 0.935, 0.976 >]
       [0.2 color rgb < 0.300, 0.450, 0.950 >]
     }
   }
   finish { diffuse 0 #if (version < 3.7) ambient 1 #else emission 1 #end }
  }
  hollow on
  no_shadow
  scale 30000
}


#declare FinX= finish { diffuse 0.65 #if (version < 3.7) ambient 0 #end }

#declare Wing_Length=4;
#declare Wing_Round=1.2;
#declare Wing_Rad=0.4;

#declare Wing=
union {
  cylinder { <0, 0, 0>, < 0, 0, Wing_Length>, Wing_Rad }
  intersection {
    torus { Wing_Round, Wing_Rad }
    box { <0, -5, 0>, < 5, 5, 5> }
    rotate 90*z
    rotate 180*y
    translate < 0, -Wing_Round, -Wing_Length>
  }
  cylinder { <0, -Wing_Round,    -Wing_Length-Wing_Round>,
             <0, -Wing_Round-10, -Wing_Length-Wing_Round>, Wing_Rad }
}

union {
  superellipsoid { <0.7, 0.3>
  texture {
    pigment { color rgb <1.0, 0.7, 0.6> }
    finish { FinX }
  }
  }
  object { Wing }
  object { Wing rotate 180*y }

  torus { Wing_Length+Wing_Round, 0.5 translate (0.5-4)*y }
  torus { Wing_Length+Wing_Round, 1.0 scale < 1, 0.1, 1>  translate (0.5-4)*y
  texture {
    pigment { color rgb <1.0, 0.7, 0.6> }
    finish { FinX }
  }
  }

  cylinder { < 0, -4, 0>,   < 0, -1,   0>, 1 }

  sphere { < 0, 0, 0> 1
    scale <1.7,0.2,1.7>
    translate -1*y
  }

  box { <-2.8, -3.2, -2.8>, < 2.8,  -3.1,  2.8> }

  union {
    cylinder { < -2, 0, 0>, < 2, 0, 0>, 1.0 }
    sphere { < -2, 0, 0> 1.0 }
    sphere { <  2, 0, 0> 1.0 }
    scale < 1.2, 0.2, 1.2>
  }

  translate <0, 4, 0>

  texture {
    pigment { color rgb 1 }
    finish { FinX }
  }
}



plane {
  y, 0
  texture {
    pigment { color rgb 1 }
    finish { FinX }
  }
}

</textarea>

<!-- Sample file : patio-radio_36.pov -->

<textarea id="patio-radio_36.pov" name="patio-radio_36.pov" style="display:none;">
// This work is licensed under the Creative Commons Attribution 3.0 Unported License.
// To view a copy of this license, visit http://creativecommons.org/licenses/by/3.0/
// or send a letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View,
// California, 94041, USA.

// Persistence Of Vision raytracer sample file.
//
// -w320 -h240
// -w800 -h600 +a0.3

//===================== RENAISSANCE PATIO =====================================

//===================== RADIANCE AND ENVIRONMENT SETTINGS =====================
#version 3.6;
#declare Rad_Quality = 2;

global_settings {
  assumed_gamma 1.0

#switch (Rad_Quality)
 #case (1)
  radiosity {             // --- Settings 1 (fast) ---
    pretrace_start 0.08
    pretrace_end   0.02
    count 50
    error_bound 0.5
    recursion_limit 1
  }
 #break
 #case (2)
  radiosity {             // --- Settings 2 (medium quality) ---
    pretrace_start 0.08
    pretrace_end   0.01
    count 120
    error_bound 0.25
    recursion_limit 1
  }
 #break
 #case (3)
  radiosity {             // --- Settings 3 (high quality) ---
    pretrace_start 0.08
    pretrace_end   0.005
    count 400
    error_bound 0.1
    recursion_limit 1
  }
 #break
 #case (4)
  radiosity {             // --- Settings 4 (medium quality, recursion_limit 2) ---
    pretrace_start 0.08
    pretrace_end   0.005
    count 350
    error_bound 0.15
    recursion_limit 2
  }
 #break
 #end

}

fog {
  fog_type 2
  fog_alt 1.3
  fog_offset 0
  color rgb <0.7, 0.8, 0.9>
  distance 800
}

light_source {<1000, 10000, -15000> color rgb <1.0, 0.9, 0.78>*2.3}

sphere {                  // --- Sky ---
  <0, 0, 0>, 1
  texture {
   pigment {
     gradient y
     color_map {
       [0.0 color rgb < 1.0, 1.0, 1.0 >]
       [0.3 color rgb < 0.5, 0.6, 1.0 >]
     }
   }
   finish { diffuse 0 ambient 1 }
  }
  scale 10000
  hollow on
  no_shadow
}

//===================== THE SCENERY ITSELF ====================================

#include "colors.inc"

camera { location <500,150,0> 
         angle 65 // direction z 
         right     x*image_width/image_height
         look_at <0,150,320>
       }

plane {y,0 pigment {color rgb <0.776,0.706,0.706>}}

#declare Arch_01 =
union {
 difference {
  cylinder {<-20,0,0>,<20,0,0>,140}
  cylinder {<-21,0,0>,<21,0,0>,130}
  torus {130 2 rotate z*90 translate x*20}
  torus {130 2 rotate z*90 translate x*-20}
 }
 difference {
  cylinder {<-18,0,0>,<18,0,0>,130}
  cylinder {<-21,0,0>,<21,0,0>,125}
 }
 torus {139 1 rotate z*90 translate x*20}
 torus {136 1 rotate z*90 translate x*20}
 torus {139 1 rotate z*90 translate x*-20}
 torus {136 1 rotate z*90 translate x*-20}
clipped_by {plane {y,0 inverse}}
}

#macro SphereBox (Radius)
 #local SpRad = sqrt (Radius*Radius + Radius*Radius);
 intersection {
  sphere {0,SpRad}
  box {<-Radius,0,-Radius>,<Radius,Radius,Radius>}
  }
#end

#declare Column_01 = union {
 box {<-40,0,-40>,<40,50,40>}
 box {<-35,50,-35>,<35,60,35>}
 cylinder {<0,60,0>,<0,66,0>,28}
 torus {28 3 translate y*63}
 difference {
  cylinder {<0,66,0>,<0,70,0>,25}
  torus {25 2 translate y*68}
  }
 cylinder {<0,70,0>,<0,74,0>,25}
 torus {25 2 translate y*72}
 cylinder {<0,74,0>,<0,76,0>,25}
 sphere {<0,0,0>,23 scale <1,15,1> translate y*76 clipped_by {cylinder {<0,76,0>,<0,265,0>,30}}}
 torus {20 2 translate y*255}
 torus {19 2 translate y*258}
 object {SphereBox (20) rotate z*180 translate y*(260+22)}
 box {<-25,282,-25>,<25,285,25>}
 box {<-20,285,-22>,<20,295,22>}
 difference {
  cylinder {<-22,290,0>,<22,290,0>,5}
  cylinder {<-23,290,0>,<23,290,0>,3}
  }
 box {<-23,295,-23>,<23,298,23>}
 box {<-28,298,-28>,<28,300,28>}
}

#declare Vault_01 =
difference {
 box {<-160,0,-160>,<160,250,160>}
 cylinder {<-170,0,0>,<170,0,0>,130}
 cylinder {<-170,0,0>,<170,0,0>,130 rotate y*90}
}

#declare Vault_02 = //(vault de coin)
difference {
 union {
  box {<-180,0,-160>,<180,250,160>}
  box {<-160,0,-180>,<160,250,180>}
  }
 cylinder {<-190,0,0>,<190,0,0>,130}
 cylinder {<-190,0,0>,<190,0,0>,130 rotate y*90}
}

#declare Spindle_01 =
lathe{
	cubic_spline
	12,
	<0.017005,-0.005668>,
	<0.117619,-0.004251>,
	<0.123287,0.072272>,
	<0.068020,0.124704>,
	<0.076523,0.195559>,
	<0.141709,0.444967>,
	<0.075106,0.524324>,
	<0.138875,0.616435>,
	<0.055267,0.916859>,
	<0.137458,0.973543>,
	<0.161549,1.000468>,
	<0.204061,0.991965>
}

#declare Band_01 =
union {
 box {<0,0,-25>,<-1,60,25>}
 box {<0,0,-25>,<5,2,25>}
 box {<0,8,-25>,<3,2,25>}
 box {<0,8,-25>,<6,15,25>}
 box {<0,8,-10>,<6,15,-8>}
 box {<0,8,10>,<6,15,8>}
 box {<0,20,-25>,<3,19,25>}
 box {<0,50,-25>,<5,60,25>}
 box {<0,50,-25>,<3,55,25>}
 box {<0,20,-2>,<3,40,-4>}
 box {<0,20,-6>,<3,40,-8>}
 box {<0,20,2>,<3,40,4>}
 box {<0,20,6>,<3,40,8>}
 box {<0,42,-25>,<6,40,25>}
 box {<0,0,-2>,<7,8,-4>}
 box {<0,0,-6>,<7,8,-8>}
 box {<0,0,2>,<7,8,4>}
 box {<0,0,6>,<7,8,8>}
}

#declare Balcony_01 = union {
 box {<-10,0,-.5>,<10,10,.5>}
 cylinder {<-10,5,-.5>,<-10,5,.5>,4}
 cylinder {<10,5,-.5>,<10,5,.5>,4}
}

#declare Group1 = union {
 object {Arch_01 translate <-490,300,0>}
 object {Arch_01 translate <-490,300,300>}
 object {Arch_01 translate <-490,300,-300>}

 object {Column_01 translate <-490,0,150>}
 object {Column_01 translate <-490,0,-150>}
 object {Column_01 translate <-490,0,-450>}
 object {Column_01 translate <-490,0,450>}

 object {Column_01 translate <-790,0,150>}
 object {Column_01 translate <-790,0,-150>}
 object {Column_01 translate <-790,0,-450>}
 object {Column_01 translate <-790,0,450>}
 object {Column_01 translate <-790,0,-450-40>}
 object {Column_01 translate <-790,0,450+40>}

 object {Arch_01 rotate y*90 translate <-490-150,300,150>}
 object {Arch_01 rotate y*90 translate <-490-150,300,-150>}
 object {Arch_01 rotate y*90 translate <-490-150,300,450>}
 object {Arch_01 rotate y*90 translate <-490-150,300,-450>}
 object {Arch_01 rotate y*90 translate <-490-150,300,450+40>}//doubleaux
 object {Arch_01 rotate y*90 translate <-490-150,300,-450-40>}

 object {Vault_01 translate <-640,300,0>}
 object {Vault_01 translate <-640,300,300>}
 object {Vault_01 translate <-640,300,-300>}
 object {Vault_02 translate <-640,300,640>}//coin

 #declare I=0;
 #while (I < 1000)
  object {Band_01 translate <-480,500,(-470 + I)>}
 #declare I=I+50;
 #end

 #declare I=0;
 #while (I < 1000)
  object {Spindle_01 scale <60,60,60> translate <-500,550,(-500 + I)>}
 #declare I=I+40;
 #end

 object {Balcony_01 scale <1,1,1020> translate <-500,610,0>}
 object {Balcony_01 scale <1,1,1020> translate <-500,610,0> rotate y*90}
 object {Balcony_01 scale <1,1,1020> translate <-500,610,0> rotate y*180}
 object {Balcony_01 scale <1,1,1020> translate <-500,610,0> rotate y*270}

 box {<-790,0,-810>,<-810,450,810>}

}

#declare PatioComplete = union {
 object {Group1}
 object {Group1 rotate y*90}
 object {Group1 rotate y*180}
 object {Group1 rotate y*270}
}

object {PatioComplete
        pigment {Wheat}
        finish {ambient 0.0 diffuse 0.6}
}

#declare Paving_01 =
union {
 box {<-40,0,-490>,<40,.1,490> translate x*150}
 box {<-40,0,-490>,<40,.1,490> translate x*-150}
 box {<-40,0,-490>,<40,.1,490> translate x*490}
 box {<-40,0,-490>,<40,.1,490> translate x*-480}

 texture {
    pigment {color rgb <0.706,0.714,0.776>*.8}
    finish {ambient 0.0 diffuse 0.6}
 }
}

object {Paving_01}
object {Paving_01 rotate y*90}

</textarea>


<!-- Sample file : crack1.pov -->

<textarea id="crack1.pov" name="crack1.pov" style="display:none;">
// This work is licensed under the Creative Commons Attribution 3.0 Unported License.
// To view a copy of this license, visit http://creativecommons.org/licenses/by/3.0/
// or send a letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View,
// California, 94041, USA.

// Persistence Of Vision raytracer sample file.
// Crackle pattern example
//
// -w320 -h240
// -w800 -h600 +a0.3

#version 3.7;
global_settings {assumed_gamma 1.0}

#include "colors.inc"
#include "shapes.inc"
#include "textures.inc"

camera {
    location <0,0,-3.5>
    angle 65
    right   x*image_width/image_height
    look_at <0,0,0>
}

light_source { <-200.0, 200.0, -800.0> colour White }

sphere { <-1.0 0.0 0.0> 1
    pigment {
        crackle
        colour_map {
            [0.05 colour rgb<0, 0, 0> ]
            [0.08 colour rgb<0, 1, 1> ]
            [0.10 colour rgb<0, 1, 1> ]
            [1.00 colour rgb<0, 0, 1> ]
        }
    scale 0.3
    }
    finish { Shiny }
}

sphere { <1.0 0.0 0.0> 1
    pigment {
        crackle
        turbulence 0.5
        colour_map {
            [0.05 colour rgb<0, 0, 0> ]
            [0.08 colour rgb<0, 1, 1> ]
            [0.10 colour rgb<0, 1, 1> ]
            [1.00 colour rgb<0, 0, 1> ]
        }
    scale 0.3
    }
    finish { Shiny }
}


</textarea>

<!-- Sample file : irid.pov -->

<textarea id="irid.pov" name="irid.pov" style="display:none;">
// This work is licensed under the Creative Commons Attribution 3.0 Unported License.
// To view a copy of this license, visit http://creativecommons.org/licenses/by/3.0/
// or send a letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View,
// California, 94041, USA.

// Persistence Of Vision raytracer sample file.
// Iridescence "amount" example
//
// -w320 -h240
// -w800 -h600 +a0.3

#version 3.7;
global_settings {assumed_gamma 1.0}

#include "colors.inc"
#include "textures.inc"
#include "shapes.inc"

camera {
  location <0, 0, -10>
  right   x*image_width/image_height
  angle 23
  look_at  <0, 0, 0>
}
light_source { < 150, 150, -2500> colour Gray90 }

// Top row: varies irid amount
union {
    sphere { <-1, 0, 0>, 0.45
        pigment { White }
        finish {
            Shiny
            diffuse 0.2
            irid {0.25 thickness 2/4 turbulence 0.75}
        }
    }
    sphere { < 0, 0, 0>, 0.45
        pigment { White }
        finish {
            Shiny
            diffuse 0.2
            irid {0.5 thickness 2/4 turbulence 0.75}
        }
    }
    sphere { < 1, 0, 0>, 0.45
        pigment { White }
        finish {
            Shiny
            diffuse 0.2
            irid  {0.75 thickness 2/4 turbulence 0.75}
        }
    }
translate y*1
}

// Center row: varies irid thickness
union {
    sphere { <-1, 0, 0>, 0.45
        pigment { White }
        finish {
            Shiny
            diffuse 0.2
            irid {0.5 thickness 0.5 turbulence 0.5}
        }
    }
    sphere { < 0, 0, 0>, 0.45
        pigment { White }
        finish {
            Shiny
            diffuse 0.2
            irid {0.5 thickness 2 turbulence 0.5}
        }
    }
    sphere { < 1, 0, 0>, 0.45
        pigment { White }
        finish {
            Shiny
            diffuse 0.2
            irid  {0.5 thickness 8 turbulence 0.5}
        }
    }
}

// Right bottom: varies irid turbulence
union {
    sphere { <-1, 0, 0>, 0.45
        pigment { White }
        finish {
            Shiny
            diffuse 0.2
            irid {0.5 thickness 2 turbulence 0.1}
        }
    }
    sphere { < 0, 0, 0>, 0.45
        pigment { White }
        finish {
            Shiny
            diffuse 0.2
            irid {0.5 thickness 2 turbulence 1}
        }
    }
    sphere { < 1, 0, 0>, 0.45
        pigment { White }
        finish {
            Shiny
            diffuse 0.2
            irid  {0.5 thickness 2 turbulence 2}
        }
    }
translate -y*1
}


</textarea>

<!-- Sample file : cluster.pov -->

<textarea id="cluster.pov" name="cluster.pov" style="display:none;">
// This work is licensed under the Creative Commons Attribution 3.0 Unported License.
// To view a copy of this license, visit http://creativecommons.org/licenses/by/3.0/
// or send a letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View,
// California, 94041, USA.

// Persistence Of Vision raytracer sample file.
// Recursive cluster of mirrored spheres
// After a classic, Sphereflake, by Eric Haines
//
// -w320 -h240
// -w800 -h600 +a0.3

#version 3.6;

global_settings {
  assumed_gamma 2.2
  max_trace_level 20
}

#include "colors.inc"

//-------------------------------------------------------------------------
// This scene uses a non-standard camera set-up. 
// (See CAMERA in the included documentation for details.) 
// If you are new to POV-Ray, you might want to try a different demo scene.
//-------------------------------------------------------------------------
camera { // This is an unusual camera since it is a converted file
   location <2.31, 1.43, 1.65>
   up <0, 0, 1>          // The Z axis is up and
   right  -x*image_width/image_height
   direction <0, -1.60746, 0> // Field of view 45 degrees
   sky <0, 0, 1>
   look_at <0, 0, -0.1>
}

sphere { <0, 0, 0>, 10000
   hollow on
   pigment { SkyBlue }
   finish { ambient 1 diffuse .5}
}

light_source { <4, 3, 2 > color Gray30 }
light_source { <1, -4, 4> color Gray30 }
light_source { <-3, 1, 5> color Gray30 }

plane { z, -0.5
   pigment { color red 1.0 green 0.75 blue 0.33 }
   finish { diffuse 1 } //ambient <0.15,0.1,0 .045>}
} // ambient .15 .1 .045

/*
union {
   sphere { <0.7, 0, 0>, 0.2 texture { pigment { Red }   finish { diffuse 0.7} } }
   sphere { <0, 0.7, 0>, 0.2 texture { pigment { Green } finish { diffuse 0.7} } }
   sphere { <0, 0, 0.7>, 0.2 texture { pigment { Blue }  finish { diffuse 0.7} } }
}
*/

#declare Texture =
texture {
   finish {
      ambient 0.03
      diffuse 1
      reflection 0.4
      phong 1
      phong_size 3
   }
   pigment { color red 0.5 green 0.45 blue 0.35 }
}

union {
   sphere { <0, 0, 0>, 0.5
      texture {
         Texture
          normal {
             bumps 0.4
             sine_wave
             scale 0.025
          }
      }
   }

   union {
      sphere { <0.272166, 0.272166, 0.544331>, 0.166667  }
      sphere { <0.643951, 0.172546, 0>, 0.166667  }
      sphere { <0.172546, 0.643951, 0>, 0.166667 }
      sphere { <-0.371785, 0.0996195, 0.544331>, 0.166667  }
      sphere { <-0.471405, 0.471405, 0>, 0.166667  }
      sphere { <-0.643951, -0.172546, 0>, 0.166667  }
      sphere { <0.0996195, -0.371785, 0.544331>, 0.166667  }
      sphere { <-0.172546, -0.643951, 0>, 0.166667  }
      sphere { <0.471405, -0.471405, 0>, 0.166667  }
      texture { Texture }
   }
}


</textarea>


<!-- Sample file : cornell.pov -->

<textarea id="cornell.pov" name="cornell.pov" style="display:none;">
// This work is licensed under the Creative Commons Attribution 3.0 Unported License.
// To view a copy of this license, visit http://creativecommons.org/licenses/by/3.0/
// or send a letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View,
// California, 94041, USA.

// Persistence Of Vision Ray Tracer Scene Description File
// File: cornell.pov
// Desc: Radiosity demo scene. See also http://www.Graphics.Cornell.EDU/online/box/
// Date: August 2001
// Auth: Kari Kivisalo

// +w300 +h300

#version 3.7;
global_settings {
  assumed_gamma 1.0
  radiosity{
    pretrace_start 0.04
    pretrace_end 0.01
    count 200
    recursion_limit 3
    nearest_count 10
    error_bound 0.5
  }
}

#declare Finish=finish{diffuse 0.75 ambient 0}

#declare White=texture{pigment{rgb<1,1,1>} finish{Finish}}
#declare Red=texture{pigment{rgb<0.57,0.025,0.025>} finish{Finish}}
#declare Green=texture{pigment{rgb<0.025,0.236,0.025>} finish{Finish}}

#declare LightColor=<1,0.67,0.21>;

#declare N=3;       // Divisions per side
#declare DX=13/N;   // Dimensions of sub patches
#declare DZ=10.5/N;

#declare SubPatch=
  light_source{
    <27.8,54.88,27.95>
    color LightColor*7
    area_light DX*x, DZ*z, 4, 4 jitter adaptive 0
    spotlight radius -90 falloff 90 tightness 1 point_at <27.8,0,27.95> // for cosine falloff
    fade_power 2 fade_distance  (DX+DZ)/2
  }

#declare i=0;#while (i<N)
  #declare j=0;#while (j<N)
     light_source{SubPatch translate<i*DX-(13-DX)/2,0,j*DZ-(10.5-DZ)/2>}
  #declare j=j+1;#end
#declare i=i+1;#end




camera{
  location  <27.8, 27.3,-80.0>
  direction <0, 0, 1>
  up        <0, 1, 0>
  right     <-1, 0, 0>
  angle 39.5
}


// ------------------------ OBJECTS ----------------------------

// Light Patch

box{
  <21.3,54.87,33.2><34.3,54.88,22.7> no_shadow
  pigment{rgb<1,1,1>} finish{ambient 0.78 diffuse 0}
}

union{
  // Floor
  triangle{<55.28, 0.0, 0.0>,<0.0, 0.0, 0.0>,<0.0, 0.0, 55.92>}
  triangle{<55.28, 0.0, 0.0>,<0.0, 0.0, 55.92>,<54.96, 0.0, 55.92>}
  // Ceiling
  triangle{<55.60, 54.88, 0.0>,<55.60, 54.88, 55.92>,<0.0, 54.88, 55.92>}
  triangle{<55.60, 54.88, 0.0>,<0.0, 54.88, 55.92>,<0.0, 54.88, 0.0>}
  // Back wall
  triangle{<0.0, 54.88, 55.92>,<55.60, 54.88, 55.92>,<54.96, 0.0, 55.92>}
  triangle{<0.0, 54.88, 55.92>,<54.96, 0.0, 55.92>,<0.0, 0.0, 55.92>}
  texture {White}
}

union {
  // Right wall
  triangle{<0.0, 54.88, 0.0>,<0.0, 54.88, 55.92>,<0.0, 0.0, 55.92>}
  triangle{<0.0, 54.88, 0.0>,<0.0, 0.0, 55.92>,<0.0, 0.0, 0.0>}
  texture {Green}
}

union {
  // Left wall
  triangle{<55.28, 0.0, 0.0>,<54.96, 0.0, 55.92>,<55.60, 54.88, 55.92>}
  triangle{<55.28, 0.0, 0.0>,<55.60, 54.88, 55.92>,<55.60, 54.88, 0.0>}
  texture {Red}
}

union {
  // Short block
  triangle{<13.00, 16.50, 6.50>,<8.20, 16.50, 22.50>,<24.00, 16.50, 27.20>}
  triangle{<13.00, 16.50, 6.50>,<24.00, 16.50, 27.20>,<29.00, 16.50, 11.40>}
  triangle{<29.00, 0.0, 11.40>,<29.00, 16.50, 11.40>,<24.00, 16.50, 27.20>}
  triangle{<29.00, 0.0, 11.40>,<24.00, 16.50, 27.20>,<24.00, 0.0, 27.20>}
  triangle{<13.00, 0.0, 6.50>,<13.00, 16.50, 6.50>,<29.00, 16.50, 11.40>}
  triangle{<13.00, 0.0, 6.50>,<29.00, 16.50, 11.40>,<29.00, 0.0, 11.40>}
  triangle{<8.20, 0.0, 22.50>,<8.20, 16.50, 22.50>,<13.00, 16.50, 6.50>}
  triangle{<8.20, 0.0, 22.50>,<13.00, 16.50, 6.50>,<13.00, 0.0, 6.50>}
  triangle{<24.00, 0.0, 27.20>,<24.00, 16.50, 27.20>,<8.20, 16.50, 22.50>}
  triangle{<24.00, 0.0, 27.20>,<8.20, 16.50, 22.50>,<8.20, 0.0, 22.50>}
  texture { White }
}

union {
  // Tall block
  triangle{<42.30, 33.00, 24.70>,<26.50, 33.00, 29.60>,<31.40, 33.00, 45.60>}
  triangle{<42.30, 33.00, 24.70>,<31.40, 33.00, 45.60>,<47.20 33.00 40.60>}
  triangle{<42.30, 0.0, 24.70>,<42.30, 33.00, 24.70>,<47.20, 33.00, 40.60>}
  triangle{<42.30, 0.0, 24.70>,<47.20, 33.00, 40.60>,<47.20, 0.0, 40.60>}
  triangle{<47.20, 0.0, 40.60>,<47.20, 33.00, 40.60>,<31.40, 33.00, 45.60>}
  triangle{<47.20, 0.0, 40.60>,<31.40, 33.00, 45.60>,<31.40, 0.0 45.60>}
  triangle{<31.40, 0.0, 45.60>,<31.40, 33.00, 45.60>,<26.50, 33.00, 29.60>}
  triangle{<31.40, 0.0, 45.60>,<26.50, 33.00, 29.60>,<26.50, 0.0, 29.60>}
  triangle{<26.50, 0.0, 29.60>,<26.50, 33.00, 29.60>,<42.30, 33.00, 24.70>}
  triangle{<26.50, 0.0, 29.60>,<42.30, 33.00, 24.70>,<42.30, 0.0, 24.70>}
  texture {White}
}

</textarea>

<!-- Sample file : fractal1.pov -->

<textarea id="fractal1.pov" name="fractal1.pov" style="display:none;">
// This work is licensed under the Creative Commons Attribution 3.0 Unported License.
// To view a copy of this license, visit http://creativecommons.org/licenses/by/3.0/
// or send a letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View,
// California, 94041, USA.

// Persistence Of Vision raytracer version 3.5 sample file.
//
// -w320 -h240
// -w800 -h600 +a0.3

#version 3.7;
global_settings { assumed_gamma 2.2 }

#include "colors.inc"
#include "textures.inc"
#include "shapes.inc"

camera {
    location  <0.0, 0.0, -12.0>
    angle 40  
    right     x*image_width/image_height
    look_at   <0.0, 1.5, 0.00>
}

light_source { <-20.00, 30.00, -100.00> color Coral }
light_source { <200.00, 300.00, -500.00> color Wheat }

#default { pigment { White } finish { Shiny }}

#declare PREC = 15;

#declare Z2_1 =
julia_fractal {
    <-0.083,0.0,-0.83,-0.025>
    quaternion
    sqr
    max_iteration 8
    precision PREC
}

#declare Z2_2 =
julia_fractal {
    <-0.03,0.5,-0.2,-0.5>
    quaternion
    sqr
    max_iteration 8
    precision PREC
}

#declare Z3_1 =
julia_fractal {
    <-0.083,0.0,-0.83,-0.025>
    max_iteration 8
    precision PREC
    quaternion
    cube
}

#declare Z3_2 =
julia_fractal {
    <-0.03,0.5,-0.2,-0.5>
    max_iteration 8
    precision PREC
    quaternion
    cube
}

object { Z2_1             translate <-2, 3,  0> }
object { Z2_2 rotate y*90 translate < 2, 3,  0> }
object { Z3_1 scale 1.5   translate <-2, 0,  0>  }
object { Z3_2 scale 1.5   translate < 2, 0,  0>  }


</textarea>

<!-- Sample file : trace-wicker.pov -->

<textarea id="trace-wicker.pov" name="trace-wicker.pov" style="display:none;">
// This work is licensed under the Creative Commons Attribution 3.0 Unported License.
// To view a copy of this license, visit http://creativecommons.org/licenses/by/3.0/
// or send a letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View,
// California, 94041, USA.

// Persistence Of Vision raytracer sample file.
//
//=================================================================================
//                                 WICKER WORK with "trace ()".
//=================================================================================
// [Fabien Mosen - August 2001]
//
// -w320 -h240
// -w800 -h600 +a0.3

//This scene demonstrates the use of the "trace" function to create shapes
//that fits irregular shapes.  We are going to model a wicker work surrounding
//a bottle, like the old Italian wine bottles.

#version 3.6;
global_settings {assumed_gamma 1.0}

#include "colors.inc"

//=========================================== WAVY RINGS =========================
//A macro to produce the wavy wicker rings
//freq : frequency, amplit : amplitude, phase : phase between -1 et 1 (usually 1)
//radius1 : big radius of ring, radius2 : radius of wicker
//Degree_Resolution : lenght of the little cylinders making the ring

// Updated: 10Aug2008 (jh) for v3.7 distribution

#macro WickerRing (Freq, Amplit, Phase, Radius1, Radius2,Degree_Resolution)
 union {
  #local P1=<Radius1,0,0>+.0001;
  #local Boucle=0;
  #while (Boucle < 360)
   #local Position = Phase*Amplit*sin(radians(Boucle*Freq));
   #local P2 = P1;
   #local P1 = vrotate(<Radius1+Position, 0, 0>,y*Boucle);
   cylinder {P1,P2, Radius2}
  #local Boucle=Boucle+Degree_Resolution;
  #end
  cylinder {P2,<Radius1,0,0>, Radius2}
 }
#end

//=========================================== THE BOTTLE ======================
//This bottle was produced by SpilinEditor, and exported with height normalized
//to 1 unit (which allows easy scaling afterwards).

#declare BottleLathe =
lathe{
	cubic_spline
	15,
	<0.036140,0.004819>,<0.228886,0.036140>,<0.293938,0.279482>,
	<0.106010,0.599923>,<0.055415,0.850493>,<0.103601,0.951684>,
	<0.072280,0.990234>,<0.038549,0.963731>,<0.062643,0.619197>,
	<0.277073,0.257798>,<0.185518,0.038549>,<0.014456,0.060233>,
	<0.036140,0.004819>,<0.228886,0.036140>,<0.293938,0.279482>
}

#declare BigBottle = object {
 BottleLathe
 scale 50
 pigment {MediumForestGreen} finish {phong .9}
}

object {BigBottle}

//================================== PLACING THE RINGS ========================

//"scanning" the bottle from bottom to top.

#declare Loop=0;    //from 0
#while (Loop < 25)  //to 25, wicker stopping at middle height
                    //but you can change that.

   #declare StartTrace = <50,Loop,0>; //50 is the distance for the start of
                                      //the tracing ray.  Adjust to your
                                      //bottle's maximum diameter

   #declare FoundPoint = trace (BigBottle, StartTrace, <-1,0,0>);
   //now, we know the radius of the bottle at a given height.

   //then we call the ring macro, using the found radius, with a frequency
   //of 20

   object {WickerRing (20, .5, 1, 1+FoundPoint.x, .2, 2)
           translate y*Loop pigment {rgb <255/255,212/255,117/255>}
                              finish {phong .5 specular .5}
                              normal {bumps .2 scale .3}
           rotate y*Loop*18 //rotate each time to alternate the rings '
                            //phases (360/20 = 18)
           }

#declare Loop=Loop+.5;
#end

//================================== VERTICAL FIBERS ========================
//creating the vertical fiber passing trough all rings, using the
//same method than previously.
#declare V_Fiber = union {
   #declare StartTrace = <50,0,0>;
   #declare FoundPoint = trace (BigBottle, StartTrace, <-1,0,0>);
   #declare P1=FoundPoint+.0001;
#declare Loop=0;
#while (Loop < 35)
   #declare StartTrace = <50,Loop,0>;
   #declare FoundPoint = trace (BigBottle, StartTrace, <-1,0,0>);
   #declare P2=P1;
   #declare P1=FoundPoint+.5;
    cylinder {P1,P2,.3}
#declare Loop=Loop+1;
#end
   }//end of union

object {BigBottle}

//placing vertical fibers
#declare I=-1;
#while (I < 360)
 object {V_Fiber rotate y*I
                              pigment {rgb <255/255,201/255,107/255>}
                              finish {phong .5 specular .5}
                              normal {bumps .2 scale .3}
                              }
#declare I=I+9;//rotation  = 0.5*(rings rotation)
#end

//=========================================== SCENERY =========================
light_source {<100,300,200> White*2}
camera { location <100,100,100> 
         right x*image_width/image_height
         angle 25 //  direction z*3 
         look_at <0,25,0>
       }
plane {y,0 pigment {White}}

</textarea>



<!-- Sample file : tango.pov -->

<textarea id="tango.pov" name="tango.pov" style="display:none;">
// This work is licensed under the Creative Commons Attribution-ShareAlike 3.0 Unported License.
// To view a copy of this license, visit http://creativecommons.org/licenses/by-sa/3.0/ or send a
// letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.

// Persistence Of Vision Raytracer sample file.
// BSP test scene by Lance Birch - thezone.firewave.com.au
// Render with +BM2 to enable BSP tree bounding (POV-Ray v3.7 beta 12 or later).

/***************************************************************
 * $File: //depot/povray/smp/distribution/scenes/bsp/Tango.pov $
 * $Revision: #1 $
 * $Change: 5418 $
 * $DateTime: 2011/03/06 09:25:00 $
 * $Author: jholsenback $
 **************************************************************/

#version 3.7;

global_settings {assumed_gamma 1.0}
#default {texture {finish {ambient 0.03}} pigment {rgb 1}}
background {rgb 1}

camera {ultra_wide_angle location <0,0,-55> look_at <0,0,0> angle 100 rotate <0,32,45> translate <-25,-25,0>}
light_source {0*x color rgb 2.9 area_light <8,0,0> <0,0,8> 8, 8 adaptive 2 jitter circular orient translate <100,0,-100>}

#declare StrandCorner = difference {
	cylinder {<0,0,0> <0,0,.1> 1}
	cylinder {<0,0,-0.1> <0,0,.2> .25}
	box {<-1.1,1.1,-0.1> <1.1,0,.2>}
	box {<-1.1,1.1,-0.1> <0,-1.1,.2>}
};

#declare S = seed(12);
#declare CStrand = 1;
#declare CDir = 1;

#while (CStrand <= 300)
	#declare StartOffset = (rand(S)*30)-15;
	#declare CHeight = <70-StartOffset,70+StartOffset,-CStrand/10>;

	#while ((CHeight.y > -45) & (CHeight.x > -45))
		#declare CDir = -CDir;
		#declare StrandSegLength = floor(rand(S)*12)+1;
		#if (CDir = 1)
			box {CHeight+<-0.375,0,0> CHeight+<0.375,-StrandSegLength,.1>}
			#declare CHeight = CHeight + <-0.625,-(StrandSegLength+0.625),0>;
			object {StrandCorner translate CHeight+<0,0.625,0>}
		#else
			box {CHeight+<0,-0.375,0> CHeight+<-StrandSegLength,0.375,.1>}
			#declare CHeight = CHeight + <-(StrandSegLength+0.625),-0.625,0>;
			object {StrandCorner rotate <0,0,180> translate CHeight+<0.625,0,0>}
		#end
	#end
	#if (CDir = 1)
		object {StrandCorner rotate <0,0,270> translate CHeight+<0,0.625,0>}
	#else
		object {StrandCorner rotate <0,0,270> translate CHeight+<0.625,0,0>}
	#end

	#declare CStrand = CStrand + 1;
#end

</textarea>


<!-- Sample file : teapot2.pov -->

<textarea id="teapot2.pov" name="teapot2.pov" style="display:none;">
// This work is licensed under the Creative Commons Attribution 3.0 Unported License.
// To view a copy of this license, visit http://creativecommons.org/licenses/by/3.0/
// or send a letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View,
// California, 94041, USA.

// Persistence Of Vision raytracer sample file.
//
// -w320 -h240
// -w800 -h600 +a0.3

#version 3.6;

global_settings {
  assumed_gamma 2.2
  max_trace_level 5
}

#include "colors.inc"
#include "textures.inc"
#include "golds.inc"
#include "metals.inc"
#include "skies.inc"

camera {
   location  <0, 4, -5.5>
   angle 65 //  direction <0, 0,  1.1>
   up        <0, 1,  0>
   right     x*image_width/image_height
   look_at   <0.5, 0.5, 0>
}

light_source {<10, 20, -30> color White}
light_source {<15, 30, 10> color White shadowless }

plane { y, 0
    pigment { color rgb <0.13, 0.41, 0.37> * 0.35 }
    finish {
        ambient 0.1
        diffuse 0.5
        reflection 0.35
    }
}

sky_sphere { S_Cloud1 }

#declare Teapot_Sphere_Radius = 0.05;
#declare Sph_Pot = union 
{
sphere {<1.3804,0.0000,2.4630>,Teapot_Sphere_Radius}
sphere {<1.4000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<1.3297,-0.4467,2.4000>,Teapot_Sphere_Radius}
sphere {<1.3110,-0.4404,2.4630>,Teapot_Sphere_Radius}
sphere {<1.3902,0.0000,2.4945>,Teapot_Sphere_Radius}
sphere {<1.3804,0.0000,2.4630>,Teapot_Sphere_Radius}
sphere {<1.3110,-0.4404,2.4630>,Teapot_Sphere_Radius}
sphere {<1.3204,-0.4435,2.4945>,Teapot_Sphere_Radius}
sphere {<1.4198,0.0000,2.4945>,Teapot_Sphere_Radius}
sphere {<1.3902,0.0000,2.4945>,Teapot_Sphere_Radius}
sphere {<1.3204,-0.4435,2.4945>,Teapot_Sphere_Radius}
sphere {<1.3485,-0.4530,2.4945>,Teapot_Sphere_Radius}
sphere {<1.4596,0.0000,2.4630>,Teapot_Sphere_Radius}
sphere {<1.4198,0.0000,2.4945>,Teapot_Sphere_Radius}
sphere {<1.3485,-0.4530,2.4945>,Teapot_Sphere_Radius}
sphere {<1.3863,-0.4657,2.4630>,Teapot_Sphere_Radius}
sphere {<1.5000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<1.4596,0.0000,2.4630>,Teapot_Sphere_Radius}
sphere {<1.3863,-0.4657,2.4630>,Teapot_Sphere_Radius}
sphere {<1.4246,-0.4786,2.4000>,Teapot_Sphere_Radius}
sphere {<1.3110,-0.4404,2.4630>,Teapot_Sphere_Radius}
sphere {<1.3297,-0.4467,2.4000>,Teapot_Sphere_Radius}
sphere {<1.1330,-0.8315,2.4000>,Teapot_Sphere_Radius}
sphere {<1.1171,-0.8198,2.4630>,Teapot_Sphere_Radius}
sphere {<1.3204,-0.4435,2.4945>,Teapot_Sphere_Radius}
sphere {<1.3110,-0.4404,2.4630>,Teapot_Sphere_Radius}
sphere {<1.1171,-0.8198,2.4630>,Teapot_Sphere_Radius}
sphere {<1.1251,-0.8257,2.4945>,Teapot_Sphere_Radius}
sphere {<1.3485,-0.4530,2.4945>,Teapot_Sphere_Radius}
sphere {<1.3204,-0.4435,2.4945>,Teapot_Sphere_Radius}
sphere {<1.1251,-0.8257,2.4945>,Teapot_Sphere_Radius}
sphere {<1.1490,-0.8432,2.4945>,Teapot_Sphere_Radius}
sphere {<1.3863,-0.4657,2.4630>,Teapot_Sphere_Radius}
sphere {<1.3485,-0.4530,2.4945>,Teapot_Sphere_Radius}
sphere {<1.1490,-0.8432,2.4945>,Teapot_Sphere_Radius}
sphere {<1.1812,-0.8669,2.4630>,Teapot_Sphere_Radius}
sphere {<1.4246,-0.4786,2.4000>,Teapot_Sphere_Radius}
sphere {<1.3863,-0.4657,2.4630>,Teapot_Sphere_Radius}
sphere {<1.1812,-0.8669,2.4630>,Teapot_Sphere_Radius}
sphere {<1.2139,-0.8909,2.4000>,Teapot_Sphere_Radius}
sphere {<1.1171,-0.8198,2.4630>,Teapot_Sphere_Radius}
sphere {<1.1330,-0.8315,2.4000>,Teapot_Sphere_Radius}
sphere {<0.8315,-1.1330,2.4000>,Teapot_Sphere_Radius}
sphere {<0.8198,-1.1171,2.4630>,Teapot_Sphere_Radius}
sphere {<1.1251,-0.8257,2.4945>,Teapot_Sphere_Radius}
sphere {<1.1171,-0.8198,2.4630>,Teapot_Sphere_Radius}
sphere {<0.8198,-1.1171,2.4630>,Teapot_Sphere_Radius}
sphere {<0.8257,-1.1251,2.4945>,Teapot_Sphere_Radius}
sphere {<1.1490,-0.8432,2.4945>,Teapot_Sphere_Radius}
sphere {<1.1251,-0.8257,2.4945>,Teapot_Sphere_Radius}
sphere {<0.8257,-1.1251,2.4945>,Teapot_Sphere_Radius}
sphere {<0.8432,-1.1490,2.4945>,Teapot_Sphere_Radius}
sphere {<1.1812,-0.8669,2.4630>,Teapot_Sphere_Radius}
sphere {<1.1490,-0.8432,2.4945>,Teapot_Sphere_Radius}
sphere {<0.8432,-1.1490,2.4945>,Teapot_Sphere_Radius}
sphere {<0.8669,-1.1812,2.4630>,Teapot_Sphere_Radius}
sphere {<1.2139,-0.8909,2.4000>,Teapot_Sphere_Radius}
sphere {<1.1812,-0.8669,2.4630>,Teapot_Sphere_Radius}
sphere {<0.8669,-1.1812,2.4630>,Teapot_Sphere_Radius}
sphere {<0.8909,-1.2139,2.4000>,Teapot_Sphere_Radius}
sphere {<0.8198,-1.1171,2.4630>,Teapot_Sphere_Radius}
sphere {<0.8315,-1.1330,2.4000>,Teapot_Sphere_Radius}
sphere {<0.4467,-1.3297,2.4000>,Teapot_Sphere_Radius}
sphere {<0.4404,-1.3110,2.4630>,Teapot_Sphere_Radius}
sphere {<0.8257,-1.1251,2.4945>,Teapot_Sphere_Radius}
sphere {<0.8198,-1.1171,2.4630>,Teapot_Sphere_Radius}
sphere {<0.4404,-1.3110,2.4630>,Teapot_Sphere_Radius}
sphere {<0.4435,-1.3204,2.4945>,Teapot_Sphere_Radius}
sphere {<0.8432,-1.1490,2.4945>,Teapot_Sphere_Radius}
sphere {<0.8257,-1.1251,2.4945>,Teapot_Sphere_Radius}
sphere {<0.4435,-1.3204,2.4945>,Teapot_Sphere_Radius}
sphere {<0.4530,-1.3485,2.4945>,Teapot_Sphere_Radius}
sphere {<0.8669,-1.1812,2.4630>,Teapot_Sphere_Radius}
sphere {<0.8432,-1.1490,2.4945>,Teapot_Sphere_Radius}
sphere {<0.4530,-1.3485,2.4945>,Teapot_Sphere_Radius}
sphere {<0.4657,-1.3863,2.4630>,Teapot_Sphere_Radius}
sphere {<0.8909,-1.2139,2.4000>,Teapot_Sphere_Radius}
sphere {<0.8669,-1.1812,2.4630>,Teapot_Sphere_Radius}
sphere {<0.4657,-1.3863,2.4630>,Teapot_Sphere_Radius}
sphere {<0.4786,-1.4246,2.4000>,Teapot_Sphere_Radius}
sphere {<0.4404,-1.3110,2.4630>,Teapot_Sphere_Radius}
sphere {<0.4467,-1.3297,2.4000>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.4000,2.4000>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.3804,2.4630>,Teapot_Sphere_Radius}
sphere {<0.4435,-1.3204,2.4945>,Teapot_Sphere_Radius}
sphere {<0.4404,-1.3110,2.4630>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.3804,2.4630>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.3902,2.4945>,Teapot_Sphere_Radius}
sphere {<0.4530,-1.3485,2.4945>,Teapot_Sphere_Radius}
sphere {<0.4435,-1.3204,2.4945>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.3902,2.4945>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.4198,2.4945>,Teapot_Sphere_Radius}
sphere {<0.4657,-1.3863,2.4630>,Teapot_Sphere_Radius}
sphere {<0.4530,-1.3485,2.4945>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.4198,2.4945>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.4596,2.4630>,Teapot_Sphere_Radius}
sphere {<0.4786,-1.4246,2.4000>,Teapot_Sphere_Radius}
sphere {<0.4657,-1.3863,2.4630>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.4596,2.4630>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.5000,2.4000>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.3804,2.4630>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.4000,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.4467,-1.3297,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.4404,-1.3110,2.4630>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.3902,2.4945>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.3804,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.4404,-1.3110,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.4435,-1.3204,2.4945>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.4198,2.4945>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.3902,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.4435,-1.3204,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.4530,-1.3485,2.4945>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.4596,2.4630>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.4198,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.4530,-1.3485,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.4657,-1.3863,2.4630>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.5000,2.4000>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.4596,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.4657,-1.3863,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.4786,-1.4246,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.4404,-1.3110,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.4467,-1.3297,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.8315,-1.1330,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.8198,-1.1171,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.4435,-1.3204,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.4404,-1.3110,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.8198,-1.1171,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.8257,-1.1251,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.4530,-1.3485,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.4435,-1.3204,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.8257,-1.1251,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.8432,-1.1490,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.4657,-1.3863,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.4530,-1.3485,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.8432,-1.1490,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.8669,-1.1812,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.4786,-1.4246,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.4657,-1.3863,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.8669,-1.1812,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.8909,-1.2139,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.8198,-1.1171,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.8315,-1.1330,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.1330,-0.8315,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.1171,-0.8198,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.8257,-1.1251,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.8198,-1.1171,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.1171,-0.8198,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.1251,-0.8257,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.8432,-1.1490,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.8257,-1.1251,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.1251,-0.8257,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.1490,-0.8432,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.8669,-1.1812,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.8432,-1.1490,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.1490,-0.8432,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.1812,-0.8669,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.8909,-1.2139,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.8669,-1.1812,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.1812,-0.8669,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.2139,-0.8909,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.1171,-0.8198,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.1330,-0.8315,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.3297,-0.4467,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.3110,-0.4404,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.1251,-0.8257,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.1171,-0.8198,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.3110,-0.4404,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.3204,-0.4435,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.1490,-0.8432,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.1251,-0.8257,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.3204,-0.4435,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.3485,-0.4530,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.1812,-0.8669,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.1490,-0.8432,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.3485,-0.4530,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.3863,-0.4657,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.2139,-0.8909,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.1812,-0.8669,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.3863,-0.4657,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.4246,-0.4786,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.3110,-0.4404,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.3297,-0.4467,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.4000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.3804,0.0000,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.3204,-0.4435,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.3110,-0.4404,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.3804,0.0000,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.3902,0.0000,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.3485,-0.4530,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.3204,-0.4435,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.3902,0.0000,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.4198,0.0000,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.3863,-0.4657,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.3485,-0.4530,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.4198,0.0000,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.4596,0.0000,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.4246,-0.4786,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.3863,-0.4657,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.4596,0.0000,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.5000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.3804,0.0000,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.4000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.3297,0.4467,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.3110,0.4404,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.3902,0.0000,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.3804,0.0000,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.3110,0.4404,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.3204,0.4435,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.4198,0.0000,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.3902,0.0000,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.3204,0.4435,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.3485,0.4530,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.4596,0.0000,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.4198,0.0000,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.3485,0.4530,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.3863,0.4657,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.5000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.4596,0.0000,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.3863,0.4657,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.4246,0.4786,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.3110,0.4404,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.3297,0.4467,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.1330,0.8315,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.1171,0.8198,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.3204,0.4435,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.3110,0.4404,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.1171,0.8198,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.1251,0.8257,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.3485,0.4530,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.3204,0.4435,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.1251,0.8257,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.1490,0.8432,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.3863,0.4657,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.3485,0.4530,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.1490,0.8432,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.1812,0.8669,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.4246,0.4786,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.3863,0.4657,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.1812,0.8669,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.2139,0.8909,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.1171,0.8198,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.1330,0.8315,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.8315,1.1330,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.8198,1.1171,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.1251,0.8257,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.1171,0.8198,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.8198,1.1171,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.8257,1.1251,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.1490,0.8432,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.1251,0.8257,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.8257,1.1251,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.8432,1.1490,2.4945>,Teapot_Sphere_Radius}
sphere {<-1.1812,0.8669,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.1490,0.8432,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.8432,1.1490,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.8669,1.1812,2.4630>,Teapot_Sphere_Radius}
sphere {<-1.2139,0.8909,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.1812,0.8669,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.8669,1.1812,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.8909,1.2139,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.8198,1.1171,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.8315,1.1330,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.4467,1.3297,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.4404,1.3110,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.8257,1.1251,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.8198,1.1171,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.4404,1.3110,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.4435,1.3204,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.8432,1.1490,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.8257,1.1251,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.4435,1.3204,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.4530,1.3485,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.8669,1.1812,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.8432,1.1490,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.4530,1.3485,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.4657,1.3863,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.8909,1.2139,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.8669,1.1812,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.4657,1.3863,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.4786,1.4246,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.4404,1.3110,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.4467,1.3297,2.4000>,Teapot_Sphere_Radius}
sphere {<0.0000,1.4000,2.4000>,Teapot_Sphere_Radius}
sphere {<0.0000,1.3804,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.4435,1.3204,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.4404,1.3110,2.4630>,Teapot_Sphere_Radius}
sphere {<0.0000,1.3804,2.4630>,Teapot_Sphere_Radius}
sphere {<0.0000,1.3902,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.4530,1.3485,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.4435,1.3204,2.4945>,Teapot_Sphere_Radius}
sphere {<0.0000,1.3902,2.4945>,Teapot_Sphere_Radius}
sphere {<0.0000,1.4198,2.4945>,Teapot_Sphere_Radius}
sphere {<-0.4657,1.3863,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.4530,1.3485,2.4945>,Teapot_Sphere_Radius}
sphere {<0.0000,1.4198,2.4945>,Teapot_Sphere_Radius}
sphere {<0.0000,1.4596,2.4630>,Teapot_Sphere_Radius}
sphere {<-0.4786,1.4246,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.4657,1.3863,2.4630>,Teapot_Sphere_Radius}
sphere {<0.0000,1.4596,2.4630>,Teapot_Sphere_Radius}
sphere {<0.0000,1.5000,2.4000>,Teapot_Sphere_Radius}
sphere {<0.0000,1.3804,2.4630>,Teapot_Sphere_Radius}
sphere {<0.0000,1.4000,2.4000>,Teapot_Sphere_Radius}
sphere {<0.4467,1.3297,2.4000>,Teapot_Sphere_Radius}
sphere {<0.4404,1.3110,2.4630>,Teapot_Sphere_Radius}
sphere {<0.0000,1.3902,2.4945>,Teapot_Sphere_Radius}
sphere {<0.0000,1.3804,2.4630>,Teapot_Sphere_Radius}
sphere {<0.4404,1.3110,2.4630>,Teapot_Sphere_Radius}
sphere {<0.4435,1.3204,2.4945>,Teapot_Sphere_Radius}
sphere {<0.0000,1.4198,2.4945>,Teapot_Sphere_Radius}
sphere {<0.0000,1.3902,2.4945>,Teapot_Sphere_Radius}
sphere {<0.4435,1.3204,2.4945>,Teapot_Sphere_Radius}
sphere {<0.4530,1.3485,2.4945>,Teapot_Sphere_Radius}
sphere {<0.0000,1.4596,2.4630>,Teapot_Sphere_Radius}
sphere {<0.0000,1.4198,2.4945>,Teapot_Sphere_Radius}
sphere {<0.4530,1.3485,2.4945>,Teapot_Sphere_Radius}
sphere {<0.4657,1.3863,2.4630>,Teapot_Sphere_Radius}
sphere {<0.0000,1.5000,2.4000>,Teapot_Sphere_Radius}
sphere {<0.0000,1.4596,2.4630>,Teapot_Sphere_Radius}
sphere {<0.4657,1.3863,2.4630>,Teapot_Sphere_Radius}
sphere {<0.4786,1.4246,2.4000>,Teapot_Sphere_Radius}
sphere {<0.4404,1.3110,2.4630>,Teapot_Sphere_Radius}
sphere {<0.4467,1.3297,2.4000>,Teapot_Sphere_Radius}
sphere {<0.8315,1.1330,2.4000>,Teapot_Sphere_Radius}
sphere {<0.8198,1.1171,2.4630>,Teapot_Sphere_Radius}
sphere {<0.4435,1.3204,2.4945>,Teapot_Sphere_Radius}
sphere {<0.4404,1.3110,2.4630>,Teapot_Sphere_Radius}
sphere {<0.8198,1.1171,2.4630>,Teapot_Sphere_Radius}
sphere {<0.8257,1.1251,2.4945>,Teapot_Sphere_Radius}
sphere {<0.4530,1.3485,2.4945>,Teapot_Sphere_Radius}
sphere {<0.4435,1.3204,2.4945>,Teapot_Sphere_Radius}
sphere {<0.8257,1.1251,2.4945>,Teapot_Sphere_Radius}
sphere {<0.8432,1.1490,2.4945>,Teapot_Sphere_Radius}
sphere {<0.4657,1.3863,2.4630>,Teapot_Sphere_Radius}
sphere {<0.4530,1.3485,2.4945>,Teapot_Sphere_Radius}
sphere {<0.8432,1.1490,2.4945>,Teapot_Sphere_Radius}
sphere {<0.8669,1.1812,2.4630>,Teapot_Sphere_Radius}
sphere {<0.4786,1.4246,2.4000>,Teapot_Sphere_Radius}
sphere {<0.4657,1.3863,2.4630>,Teapot_Sphere_Radius}
sphere {<0.8669,1.1812,2.4630>,Teapot_Sphere_Radius}
sphere {<0.8909,1.2139,2.4000>,Teapot_Sphere_Radius}
sphere {<0.8198,1.1171,2.4630>,Teapot_Sphere_Radius}
sphere {<0.8315,1.1330,2.4000>,Teapot_Sphere_Radius}
sphere {<1.1330,0.8315,2.4000>,Teapot_Sphere_Radius}
sphere {<1.1171,0.8198,2.4630>,Teapot_Sphere_Radius}
sphere {<0.8257,1.1251,2.4945>,Teapot_Sphere_Radius}
sphere {<0.8198,1.1171,2.4630>,Teapot_Sphere_Radius}
sphere {<1.1171,0.8198,2.4630>,Teapot_Sphere_Radius}
sphere {<1.1251,0.8257,2.4945>,Teapot_Sphere_Radius}
sphere {<0.8432,1.1490,2.4945>,Teapot_Sphere_Radius}
sphere {<0.8257,1.1251,2.4945>,Teapot_Sphere_Radius}
sphere {<1.1251,0.8257,2.4945>,Teapot_Sphere_Radius}
sphere {<1.1490,0.8432,2.4945>,Teapot_Sphere_Radius}
sphere {<0.8669,1.1812,2.4630>,Teapot_Sphere_Radius}
sphere {<0.8432,1.1490,2.4945>,Teapot_Sphere_Radius}
sphere {<1.1490,0.8432,2.4945>,Teapot_Sphere_Radius}
sphere {<1.1812,0.8669,2.4630>,Teapot_Sphere_Radius}
sphere {<0.8909,1.2139,2.4000>,Teapot_Sphere_Radius}
sphere {<0.8669,1.1812,2.4630>,Teapot_Sphere_Radius}
sphere {<1.1812,0.8669,2.4630>,Teapot_Sphere_Radius}
sphere {<1.2139,0.8909,2.4000>,Teapot_Sphere_Radius}
sphere {<1.1171,0.8198,2.4630>,Teapot_Sphere_Radius}
sphere {<1.1330,0.8315,2.4000>,Teapot_Sphere_Radius}
sphere {<1.3297,0.4467,2.4000>,Teapot_Sphere_Radius}
sphere {<1.3110,0.4404,2.4630>,Teapot_Sphere_Radius}
sphere {<1.1251,0.8257,2.4945>,Teapot_Sphere_Radius}
sphere {<1.1171,0.8198,2.4630>,Teapot_Sphere_Radius}
sphere {<1.3110,0.4404,2.4630>,Teapot_Sphere_Radius}
sphere {<1.3204,0.4435,2.4945>,Teapot_Sphere_Radius}
sphere {<1.1490,0.8432,2.4945>,Teapot_Sphere_Radius}
sphere {<1.1251,0.8257,2.4945>,Teapot_Sphere_Radius}
sphere {<1.3204,0.4435,2.4945>,Teapot_Sphere_Radius}
sphere {<1.3485,0.4530,2.4945>,Teapot_Sphere_Radius}
sphere {<1.1812,0.8669,2.4630>,Teapot_Sphere_Radius}
sphere {<1.1490,0.8432,2.4945>,Teapot_Sphere_Radius}
sphere {<1.3485,0.4530,2.4945>,Teapot_Sphere_Radius}
sphere {<1.3863,0.4657,2.4630>,Teapot_Sphere_Radius}
sphere {<1.2139,0.8909,2.4000>,Teapot_Sphere_Radius}
sphere {<1.1812,0.8669,2.4630>,Teapot_Sphere_Radius}
sphere {<1.3863,0.4657,2.4630>,Teapot_Sphere_Radius}
sphere {<1.4246,0.4786,2.4000>,Teapot_Sphere_Radius}
sphere {<1.3110,0.4404,2.4630>,Teapot_Sphere_Radius}
sphere {<1.3297,0.4467,2.4000>,Teapot_Sphere_Radius}
sphere {<1.4000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<1.3804,0.0000,2.4630>,Teapot_Sphere_Radius}
sphere {<1.3204,0.4435,2.4945>,Teapot_Sphere_Radius}
sphere {<1.3110,0.4404,2.4630>,Teapot_Sphere_Radius}
sphere {<1.3804,0.0000,2.4630>,Teapot_Sphere_Radius}
sphere {<1.3902,0.0000,2.4945>,Teapot_Sphere_Radius}
sphere {<1.3485,0.4530,2.4945>,Teapot_Sphere_Radius}
sphere {<1.3204,0.4435,2.4945>,Teapot_Sphere_Radius}
sphere {<1.3902,0.0000,2.4945>,Teapot_Sphere_Radius}
sphere {<1.4198,0.0000,2.4945>,Teapot_Sphere_Radius}
sphere {<1.3863,0.4657,2.4630>,Teapot_Sphere_Radius}
sphere {<1.3485,0.4530,2.4945>,Teapot_Sphere_Radius}
sphere {<1.4198,0.0000,2.4945>,Teapot_Sphere_Radius}
sphere {<1.4596,0.0000,2.4630>,Teapot_Sphere_Radius}
sphere {<1.4246,0.4786,2.4000>,Teapot_Sphere_Radius}
sphere {<1.3863,0.4657,2.4630>,Teapot_Sphere_Radius}
sphere {<1.4596,0.0000,2.4630>,Teapot_Sphere_Radius}
sphere {<1.5000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<1.6480,0.0000,2.0856>,Teapot_Sphere_Radius}
sphere {<1.5000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<1.4246,-0.4786,2.4000>,Teapot_Sphere_Radius}
sphere {<1.5652,-0.5258,2.0856>,Teapot_Sphere_Radius}
sphere {<1.7840,0.0000,1.7748>,Teapot_Sphere_Radius}
sphere {<1.6480,0.0000,2.0856>,Teapot_Sphere_Radius}
sphere {<1.5652,-0.5258,2.0856>,Teapot_Sphere_Radius}
sphere {<1.6944,-0.5692,1.7748>,Teapot_Sphere_Radius}
sphere {<1.8960,0.0000,1.4712>,Teapot_Sphere_Radius}
sphere {<1.7840,0.0000,1.7748>,Teapot_Sphere_Radius}
sphere {<1.6944,-0.5692,1.7748>,Teapot_Sphere_Radius}
sphere {<1.8007,-0.6049,1.4712>,Teapot_Sphere_Radius}
sphere {<1.9720,0.0000,1.1784>,Teapot_Sphere_Radius}
sphere {<1.8960,0.0000,1.4712>,Teapot_Sphere_Radius}
sphere {<1.8007,-0.6049,1.4712>,Teapot_Sphere_Radius}
sphere {<1.8729,-0.6291,1.1784>,Teapot_Sphere_Radius}
sphere {<2.0000,0.0000,0.9000>,Teapot_Sphere_Radius}
sphere {<1.9720,0.0000,1.1784>,Teapot_Sphere_Radius}
sphere {<1.8729,-0.6291,1.1784>,Teapot_Sphere_Radius}
sphere {<1.8995,-0.6381,0.9000>,Teapot_Sphere_Radius}
sphere {<1.5652,-0.5258,2.0856>,Teapot_Sphere_Radius}
sphere {<1.4246,-0.4786,2.4000>,Teapot_Sphere_Radius}
sphere {<1.2139,-0.8909,2.4000>,Teapot_Sphere_Radius}
sphere {<1.3337,-0.9788,2.0856>,Teapot_Sphere_Radius}
sphere {<1.6944,-0.5692,1.7748>,Teapot_Sphere_Radius}
sphere {<1.5652,-0.5258,2.0856>,Teapot_Sphere_Radius}
sphere {<1.3337,-0.9788,2.0856>,Teapot_Sphere_Radius}
sphere {<1.4438,-1.0596,1.7748>,Teapot_Sphere_Radius}
sphere {<1.8007,-0.6049,1.4712>,Teapot_Sphere_Radius}
sphere {<1.6944,-0.5692,1.7748>,Teapot_Sphere_Radius}
sphere {<1.4438,-1.0596,1.7748>,Teapot_Sphere_Radius}
sphere {<1.5344,-1.1261,1.4712>,Teapot_Sphere_Radius}
sphere {<1.8729,-0.6291,1.1784>,Teapot_Sphere_Radius}
sphere {<1.8007,-0.6049,1.4712>,Teapot_Sphere_Radius}
sphere {<1.5344,-1.1261,1.4712>,Teapot_Sphere_Radius}
sphere {<1.5959,-1.1712,1.1784>,Teapot_Sphere_Radius}
sphere {<1.8995,-0.6381,0.9000>,Teapot_Sphere_Radius}
sphere {<1.8729,-0.6291,1.1784>,Teapot_Sphere_Radius}
sphere {<1.5959,-1.1712,1.1784>,Teapot_Sphere_Radius}
sphere {<1.6186,-1.1878,0.9000>,Teapot_Sphere_Radius}
sphere {<1.3337,-0.9788,2.0856>,Teapot_Sphere_Radius}
sphere {<1.2139,-0.8909,2.4000>,Teapot_Sphere_Radius}
sphere {<0.8909,-1.2139,2.4000>,Teapot_Sphere_Radius}
sphere {<0.9788,-1.3337,2.0856>,Teapot_Sphere_Radius}
sphere {<1.4438,-1.0596,1.7748>,Teapot_Sphere_Radius}
sphere {<1.3337,-0.9788,2.0856>,Teapot_Sphere_Radius}
sphere {<0.9788,-1.3337,2.0856>,Teapot_Sphere_Radius}
sphere {<1.0596,-1.4438,1.7748>,Teapot_Sphere_Radius}
sphere {<1.5344,-1.1261,1.4712>,Teapot_Sphere_Radius}
sphere {<1.4438,-1.0596,1.7748>,Teapot_Sphere_Radius}
sphere {<1.0596,-1.4438,1.7748>,Teapot_Sphere_Radius}
sphere {<1.1261,-1.5344,1.4712>,Teapot_Sphere_Radius}
sphere {<1.5959,-1.1712,1.1784>,Teapot_Sphere_Radius}
sphere {<1.5344,-1.1261,1.4712>,Teapot_Sphere_Radius}
sphere {<1.1261,-1.5344,1.4712>,Teapot_Sphere_Radius}
sphere {<1.1712,-1.5959,1.1784>,Teapot_Sphere_Radius}
sphere {<1.6186,-1.1878,0.9000>,Teapot_Sphere_Radius}
sphere {<1.5959,-1.1712,1.1784>,Teapot_Sphere_Radius}
sphere {<1.1712,-1.5959,1.1784>,Teapot_Sphere_Radius}
sphere {<1.1878,-1.6186,0.9000>,Teapot_Sphere_Radius}
sphere {<0.9788,-1.3337,2.0856>,Teapot_Sphere_Radius}
sphere {<0.8909,-1.2139,2.4000>,Teapot_Sphere_Radius}
sphere {<0.4786,-1.4246,2.4000>,Teapot_Sphere_Radius}
sphere {<0.5258,-1.5652,2.0856>,Teapot_Sphere_Radius}
sphere {<1.0596,-1.4438,1.7748>,Teapot_Sphere_Radius}
sphere {<0.9788,-1.3337,2.0856>,Teapot_Sphere_Radius}
sphere {<0.5258,-1.5652,2.0856>,Teapot_Sphere_Radius}
sphere {<0.5692,-1.6944,1.7748>,Teapot_Sphere_Radius}
sphere {<1.1261,-1.5344,1.4712>,Teapot_Sphere_Radius}
sphere {<1.0596,-1.4438,1.7748>,Teapot_Sphere_Radius}
sphere {<0.5692,-1.6944,1.7748>,Teapot_Sphere_Radius}
sphere {<0.6049,-1.8007,1.4712>,Teapot_Sphere_Radius}
sphere {<1.1712,-1.5959,1.1784>,Teapot_Sphere_Radius}
sphere {<1.1261,-1.5344,1.4712>,Teapot_Sphere_Radius}
sphere {<0.6049,-1.8007,1.4712>,Teapot_Sphere_Radius}
sphere {<0.6291,-1.8729,1.1784>,Teapot_Sphere_Radius}
sphere {<1.1878,-1.6186,0.9000>,Teapot_Sphere_Radius}
sphere {<1.1712,-1.5959,1.1784>,Teapot_Sphere_Radius}
sphere {<0.6291,-1.8729,1.1784>,Teapot_Sphere_Radius}
sphere {<0.6381,-1.8995,0.9000>,Teapot_Sphere_Radius}
sphere {<0.5258,-1.5652,2.0856>,Teapot_Sphere_Radius}
sphere {<0.4786,-1.4246,2.4000>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.5000,2.4000>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.6480,2.0856>,Teapot_Sphere_Radius}
sphere {<0.5692,-1.6944,1.7748>,Teapot_Sphere_Radius}
sphere {<0.5258,-1.5652,2.0856>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.6480,2.0856>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.7840,1.7748>,Teapot_Sphere_Radius}
sphere {<0.6049,-1.8007,1.4712>,Teapot_Sphere_Radius}
sphere {<0.5692,-1.6944,1.7748>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.7840,1.7748>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.8960,1.4712>,Teapot_Sphere_Radius}
sphere {<0.6291,-1.8729,1.1784>,Teapot_Sphere_Radius}
sphere {<0.6049,-1.8007,1.4712>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.8960,1.4712>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.9720,1.1784>,Teapot_Sphere_Radius}
sphere {<0.6381,-1.8995,0.9000>,Teapot_Sphere_Radius}
sphere {<0.6291,-1.8729,1.1784>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.9720,1.1784>,Teapot_Sphere_Radius}
sphere {<0.0000,-2.0000,0.9000>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.6480,2.0856>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.5000,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.4786,-1.4246,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.5258,-1.5652,2.0856>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.7840,1.7748>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.6480,2.0856>,Teapot_Sphere_Radius}
sphere {<-0.5258,-1.5652,2.0856>,Teapot_Sphere_Radius}
sphere {<-0.5692,-1.6944,1.7748>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.8960,1.4712>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.7840,1.7748>,Teapot_Sphere_Radius}
sphere {<-0.5692,-1.6944,1.7748>,Teapot_Sphere_Radius}
sphere {<-0.6049,-1.8007,1.4712>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.9720,1.1784>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.8960,1.4712>,Teapot_Sphere_Radius}
sphere {<-0.6049,-1.8007,1.4712>,Teapot_Sphere_Radius}
sphere {<-0.6291,-1.8729,1.1784>,Teapot_Sphere_Radius}
sphere {<0.0000,-2.0000,0.9000>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.9720,1.1784>,Teapot_Sphere_Radius}
sphere {<-0.6291,-1.8729,1.1784>,Teapot_Sphere_Radius}
sphere {<-0.6381,-1.8995,0.9000>,Teapot_Sphere_Radius}
sphere {<-0.5258,-1.5652,2.0856>,Teapot_Sphere_Radius}
sphere {<-0.4786,-1.4246,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.8909,-1.2139,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.9788,-1.3337,2.0856>,Teapot_Sphere_Radius}
sphere {<-0.5692,-1.6944,1.7748>,Teapot_Sphere_Radius}
sphere {<-0.5258,-1.5652,2.0856>,Teapot_Sphere_Radius}
sphere {<-0.9788,-1.3337,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.0596,-1.4438,1.7748>,Teapot_Sphere_Radius}
sphere {<-0.6049,-1.8007,1.4712>,Teapot_Sphere_Radius}
sphere {<-0.5692,-1.6944,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.0596,-1.4438,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.1261,-1.5344,1.4712>,Teapot_Sphere_Radius}
sphere {<-0.6291,-1.8729,1.1784>,Teapot_Sphere_Radius}
sphere {<-0.6049,-1.8007,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.1261,-1.5344,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.1712,-1.5959,1.1784>,Teapot_Sphere_Radius}
sphere {<-0.6381,-1.8995,0.9000>,Teapot_Sphere_Radius}
sphere {<-0.6291,-1.8729,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.1712,-1.5959,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.1878,-1.6186,0.9000>,Teapot_Sphere_Radius}
sphere {<-0.9788,-1.3337,2.0856>,Teapot_Sphere_Radius}
sphere {<-0.8909,-1.2139,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.2139,-0.8909,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.3337,-0.9788,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.0596,-1.4438,1.7748>,Teapot_Sphere_Radius}
sphere {<-0.9788,-1.3337,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.3337,-0.9788,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.4438,-1.0596,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.1261,-1.5344,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.0596,-1.4438,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.4438,-1.0596,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.5344,-1.1261,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.1712,-1.5959,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.1261,-1.5344,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.5344,-1.1261,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.5959,-1.1712,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.1878,-1.6186,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.1712,-1.5959,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.5959,-1.1712,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.6186,-1.1878,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.3337,-0.9788,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.2139,-0.8909,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.4246,-0.4786,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.5652,-0.5258,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.4438,-1.0596,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.3337,-0.9788,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.5652,-0.5258,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.6944,-0.5692,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.5344,-1.1261,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.4438,-1.0596,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.6944,-0.5692,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.8007,-0.6049,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.5959,-1.1712,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.5344,-1.1261,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.8007,-0.6049,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.8729,-0.6291,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.6186,-1.1878,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.5959,-1.1712,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.8729,-0.6291,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.8995,-0.6381,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.5652,-0.5258,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.4246,-0.4786,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.5000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.6480,0.0000,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.6944,-0.5692,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.5652,-0.5258,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.6480,0.0000,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.7840,0.0000,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.8007,-0.6049,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.6944,-0.5692,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.7840,0.0000,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.8960,0.0000,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.8729,-0.6291,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.8007,-0.6049,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.8960,0.0000,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.9720,0.0000,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.8995,-0.6381,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.8729,-0.6291,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.9720,0.0000,1.1784>,Teapot_Sphere_Radius}
sphere {<-2.0000,0.0000,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.6480,0.0000,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.5000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.4246,0.4786,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.5652,0.5258,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.7840,0.0000,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.6480,0.0000,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.5652,0.5258,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.6944,0.5692,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.8960,0.0000,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.7840,0.0000,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.6944,0.5692,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.8007,0.6049,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.9720,0.0000,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.8960,0.0000,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.8007,0.6049,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.8729,0.6291,1.1784>,Teapot_Sphere_Radius}
sphere {<-2.0000,0.0000,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.9720,0.0000,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.8729,0.6291,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.8995,0.6381,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.5652,0.5258,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.4246,0.4786,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.2139,0.8909,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.3337,0.9788,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.6944,0.5692,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.5652,0.5258,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.3337,0.9788,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.4438,1.0596,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.8007,0.6049,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.6944,0.5692,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.4438,1.0596,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.5344,1.1261,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.8729,0.6291,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.8007,0.6049,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.5344,1.1261,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.5959,1.1712,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.8995,0.6381,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.8729,0.6291,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.5959,1.1712,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.6186,1.1878,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.3337,0.9788,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.2139,0.8909,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.8909,1.2139,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.9788,1.3337,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.4438,1.0596,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.3337,0.9788,2.0856>,Teapot_Sphere_Radius}
sphere {<-0.9788,1.3337,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.0596,1.4438,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.5344,1.1261,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.4438,1.0596,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.0596,1.4438,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.1261,1.5344,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.5959,1.1712,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.5344,1.1261,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.1261,1.5344,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.1712,1.5959,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.6186,1.1878,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.5959,1.1712,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.1712,1.5959,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.1878,1.6186,0.9000>,Teapot_Sphere_Radius}
sphere {<-0.9788,1.3337,2.0856>,Teapot_Sphere_Radius}
sphere {<-0.8909,1.2139,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.4786,1.4246,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.5258,1.5652,2.0856>,Teapot_Sphere_Radius}
sphere {<-1.0596,1.4438,1.7748>,Teapot_Sphere_Radius}
sphere {<-0.9788,1.3337,2.0856>,Teapot_Sphere_Radius}
sphere {<-0.5258,1.5652,2.0856>,Teapot_Sphere_Radius}
sphere {<-0.5692,1.6944,1.7748>,Teapot_Sphere_Radius}
sphere {<-1.1261,1.5344,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.0596,1.4438,1.7748>,Teapot_Sphere_Radius}
sphere {<-0.5692,1.6944,1.7748>,Teapot_Sphere_Radius}
sphere {<-0.6049,1.8007,1.4712>,Teapot_Sphere_Radius}
sphere {<-1.1712,1.5959,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.1261,1.5344,1.4712>,Teapot_Sphere_Radius}
sphere {<-0.6049,1.8007,1.4712>,Teapot_Sphere_Radius}
sphere {<-0.6291,1.8729,1.1784>,Teapot_Sphere_Radius}
sphere {<-1.1878,1.6186,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.1712,1.5959,1.1784>,Teapot_Sphere_Radius}
sphere {<-0.6291,1.8729,1.1784>,Teapot_Sphere_Radius}
sphere {<-0.6381,1.8995,0.9000>,Teapot_Sphere_Radius}
sphere {<-0.5258,1.5652,2.0856>,Teapot_Sphere_Radius}
sphere {<-0.4786,1.4246,2.4000>,Teapot_Sphere_Radius}
sphere {<0.0000,1.5000,2.4000>,Teapot_Sphere_Radius}
sphere {<0.0000,1.6480,2.0856>,Teapot_Sphere_Radius}
sphere {<-0.5692,1.6944,1.7748>,Teapot_Sphere_Radius}
sphere {<-0.5258,1.5652,2.0856>,Teapot_Sphere_Radius}
sphere {<0.0000,1.6480,2.0856>,Teapot_Sphere_Radius}
sphere {<0.0000,1.7840,1.7748>,Teapot_Sphere_Radius}
sphere {<-0.6049,1.8007,1.4712>,Teapot_Sphere_Radius}
sphere {<-0.5692,1.6944,1.7748>,Teapot_Sphere_Radius}
sphere {<0.0000,1.7840,1.7748>,Teapot_Sphere_Radius}
sphere {<0.0000,1.8960,1.4712>,Teapot_Sphere_Radius}
sphere {<-0.6291,1.8729,1.1784>,Teapot_Sphere_Radius}
sphere {<-0.6049,1.8007,1.4712>,Teapot_Sphere_Radius}
sphere {<0.0000,1.8960,1.4712>,Teapot_Sphere_Radius}
sphere {<0.0000,1.9720,1.1784>,Teapot_Sphere_Radius}
sphere {<-0.6381,1.8995,0.9000>,Teapot_Sphere_Radius}
sphere {<-0.6291,1.8729,1.1784>,Teapot_Sphere_Radius}
sphere {<0.0000,1.9720,1.1784>,Teapot_Sphere_Radius}
sphere {<0.0000,2.0000,0.9000>,Teapot_Sphere_Radius}
sphere {<0.0000,1.6480,2.0856>,Teapot_Sphere_Radius}
sphere {<0.0000,1.5000,2.4000>,Teapot_Sphere_Radius}
sphere {<0.4786,1.4246,2.4000>,Teapot_Sphere_Radius}
sphere {<0.5258,1.5652,2.0856>,Teapot_Sphere_Radius}
sphere {<0.0000,1.7840,1.7748>,Teapot_Sphere_Radius}
sphere {<0.0000,1.6480,2.0856>,Teapot_Sphere_Radius}
sphere {<0.5258,1.5652,2.0856>,Teapot_Sphere_Radius}
sphere {<0.5692,1.6944,1.7748>,Teapot_Sphere_Radius}
sphere {<0.0000,1.8960,1.4712>,Teapot_Sphere_Radius}
sphere {<0.0000,1.7840,1.7748>,Teapot_Sphere_Radius}
sphere {<0.5692,1.6944,1.7748>,Teapot_Sphere_Radius}
sphere {<0.6049,1.8007,1.4712>,Teapot_Sphere_Radius}
sphere {<0.0000,1.9720,1.1784>,Teapot_Sphere_Radius}
sphere {<0.0000,1.8960,1.4712>,Teapot_Sphere_Radius}
sphere {<0.6049,1.8007,1.4712>,Teapot_Sphere_Radius}
sphere {<0.6291,1.8729,1.1784>,Teapot_Sphere_Radius}
sphere {<0.0000,2.0000,0.9000>,Teapot_Sphere_Radius}
sphere {<0.0000,1.9720,1.1784>,Teapot_Sphere_Radius}
sphere {<0.6291,1.8729,1.1784>,Teapot_Sphere_Radius}
sphere {<0.6381,1.8995,0.9000>,Teapot_Sphere_Radius}
sphere {<0.5258,1.5652,2.0856>,Teapot_Sphere_Radius}
sphere {<0.4786,1.4246,2.4000>,Teapot_Sphere_Radius}
sphere {<0.8909,1.2139,2.4000>,Teapot_Sphere_Radius}
sphere {<0.9788,1.3337,2.0856>,Teapot_Sphere_Radius}
sphere {<0.5692,1.6944,1.7748>,Teapot_Sphere_Radius}
sphere {<0.5258,1.5652,2.0856>,Teapot_Sphere_Radius}
sphere {<0.9788,1.3337,2.0856>,Teapot_Sphere_Radius}
sphere {<1.0596,1.4438,1.7748>,Teapot_Sphere_Radius}
sphere {<0.6049,1.8007,1.4712>,Teapot_Sphere_Radius}
sphere {<0.5692,1.6944,1.7748>,Teapot_Sphere_Radius}
sphere {<1.0596,1.4438,1.7748>,Teapot_Sphere_Radius}
sphere {<1.1261,1.5344,1.4712>,Teapot_Sphere_Radius}
sphere {<0.6291,1.8729,1.1784>,Teapot_Sphere_Radius}
sphere {<0.6049,1.8007,1.4712>,Teapot_Sphere_Radius}
sphere {<1.1261,1.5344,1.4712>,Teapot_Sphere_Radius}
sphere {<1.1712,1.5959,1.1784>,Teapot_Sphere_Radius}
sphere {<0.6381,1.8995,0.9000>,Teapot_Sphere_Radius}
sphere {<0.6291,1.8729,1.1784>,Teapot_Sphere_Radius}
sphere {<1.1712,1.5959,1.1784>,Teapot_Sphere_Radius}
sphere {<1.1878,1.6186,0.9000>,Teapot_Sphere_Radius}
sphere {<0.9788,1.3337,2.0856>,Teapot_Sphere_Radius}
sphere {<0.8909,1.2139,2.4000>,Teapot_Sphere_Radius}
sphere {<1.2139,0.8909,2.4000>,Teapot_Sphere_Radius}
sphere {<1.3337,0.9788,2.0856>,Teapot_Sphere_Radius}
sphere {<1.0596,1.4438,1.7748>,Teapot_Sphere_Radius}
sphere {<0.9788,1.3337,2.0856>,Teapot_Sphere_Radius}
sphere {<1.3337,0.9788,2.0856>,Teapot_Sphere_Radius}
sphere {<1.4438,1.0596,1.7748>,Teapot_Sphere_Radius}
sphere {<1.1261,1.5344,1.4712>,Teapot_Sphere_Radius}
sphere {<1.0596,1.4438,1.7748>,Teapot_Sphere_Radius}
sphere {<1.4438,1.0596,1.7748>,Teapot_Sphere_Radius}
sphere {<1.5344,1.1261,1.4712>,Teapot_Sphere_Radius}
sphere {<1.1712,1.5959,1.1784>,Teapot_Sphere_Radius}
sphere {<1.1261,1.5344,1.4712>,Teapot_Sphere_Radius}
sphere {<1.5344,1.1261,1.4712>,Teapot_Sphere_Radius}
sphere {<1.5959,1.1712,1.1784>,Teapot_Sphere_Radius}
sphere {<1.1878,1.6186,0.9000>,Teapot_Sphere_Radius}
sphere {<1.1712,1.5959,1.1784>,Teapot_Sphere_Radius}
sphere {<1.5959,1.1712,1.1784>,Teapot_Sphere_Radius}
sphere {<1.6186,1.1878,0.9000>,Teapot_Sphere_Radius}
sphere {<1.3337,0.9788,2.0856>,Teapot_Sphere_Radius}
sphere {<1.2139,0.8909,2.4000>,Teapot_Sphere_Radius}
sphere {<1.4246,0.4786,2.4000>,Teapot_Sphere_Radius}
sphere {<1.5652,0.5258,2.0856>,Teapot_Sphere_Radius}
sphere {<1.4438,1.0596,1.7748>,Teapot_Sphere_Radius}
sphere {<1.3337,0.9788,2.0856>,Teapot_Sphere_Radius}
sphere {<1.5652,0.5258,2.0856>,Teapot_Sphere_Radius}
sphere {<1.6944,0.5692,1.7748>,Teapot_Sphere_Radius}
sphere {<1.5344,1.1261,1.4712>,Teapot_Sphere_Radius}
sphere {<1.4438,1.0596,1.7748>,Teapot_Sphere_Radius}
sphere {<1.6944,0.5692,1.7748>,Teapot_Sphere_Radius}
sphere {<1.8007,0.6049,1.4712>,Teapot_Sphere_Radius}
sphere {<1.5959,1.1712,1.1784>,Teapot_Sphere_Radius}
sphere {<1.5344,1.1261,1.4712>,Teapot_Sphere_Radius}
sphere {<1.8007,0.6049,1.4712>,Teapot_Sphere_Radius}
sphere {<1.8729,0.6291,1.1784>,Teapot_Sphere_Radius}
sphere {<1.6186,1.1878,0.9000>,Teapot_Sphere_Radius}
sphere {<1.5959,1.1712,1.1784>,Teapot_Sphere_Radius}
sphere {<1.8729,0.6291,1.1784>,Teapot_Sphere_Radius}
sphere {<1.8995,0.6381,0.9000>,Teapot_Sphere_Radius}
sphere {<1.5652,0.5258,2.0856>,Teapot_Sphere_Radius}
sphere {<1.4246,0.4786,2.4000>,Teapot_Sphere_Radius}
sphere {<1.5000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<1.6480,0.0000,2.0856>,Teapot_Sphere_Radius}
sphere {<1.6944,0.5692,1.7748>,Teapot_Sphere_Radius}
sphere {<1.5652,0.5258,2.0856>,Teapot_Sphere_Radius}
sphere {<1.6480,0.0000,2.0856>,Teapot_Sphere_Radius}
sphere {<1.7840,0.0000,1.7748>,Teapot_Sphere_Radius}
sphere {<1.8007,0.6049,1.4712>,Teapot_Sphere_Radius}
sphere {<1.6944,0.5692,1.7748>,Teapot_Sphere_Radius}
sphere {<1.7840,0.0000,1.7748>,Teapot_Sphere_Radius}
sphere {<1.8960,0.0000,1.4712>,Teapot_Sphere_Radius}
sphere {<1.8729,0.6291,1.1784>,Teapot_Sphere_Radius}
sphere {<1.8007,0.6049,1.4712>,Teapot_Sphere_Radius}
sphere {<1.8960,0.0000,1.4712>,Teapot_Sphere_Radius}
sphere {<1.9720,0.0000,1.1784>,Teapot_Sphere_Radius}
sphere {<1.8995,0.6381,0.9000>,Teapot_Sphere_Radius}
sphere {<1.8729,0.6291,1.1784>,Teapot_Sphere_Radius}
sphere {<1.9720,0.0000,1.1784>,Teapot_Sphere_Radius}
sphere {<2.0000,0.0000,0.9000>,Teapot_Sphere_Radius}
sphere {<1.9480,0.0000,0.6564>,Teapot_Sphere_Radius}
sphere {<2.0000,0.0000,0.9000>,Teapot_Sphere_Radius}
sphere {<1.8995,-0.6381,0.9000>,Teapot_Sphere_Radius}
sphere {<1.8501,-0.6215,0.6564>,Teapot_Sphere_Radius}
sphere {<1.8240,0.0000,0.4632>,Teapot_Sphere_Radius}
sphere {<1.9480,0.0000,0.6564>,Teapot_Sphere_Radius}
sphere {<1.8501,-0.6215,0.6564>,Teapot_Sphere_Radius}
sphere {<1.7324,-0.5819,0.4632>,Teapot_Sphere_Radius}
sphere {<1.6760,0.0000,0.3168>,Teapot_Sphere_Radius}
sphere {<1.8240,0.0000,0.4632>,Teapot_Sphere_Radius}
sphere {<1.7324,-0.5819,0.4632>,Teapot_Sphere_Radius}
sphere {<1.5918,-0.5347,0.3168>,Teapot_Sphere_Radius}
sphere {<1.5520,0.0000,0.2136>,Teapot_Sphere_Radius}
sphere {<1.6760,0.0000,0.3168>,Teapot_Sphere_Radius}
sphere {<1.5918,-0.5347,0.3168>,Teapot_Sphere_Radius}
sphere {<1.4740,-0.4951,0.2136>,Teapot_Sphere_Radius}
sphere {<1.5000,0.0000,0.1500>,Teapot_Sphere_Radius}
sphere {<1.5520,0.0000,0.2136>,Teapot_Sphere_Radius}
sphere {<1.4740,-0.4951,0.2136>,Teapot_Sphere_Radius}
sphere {<1.4246,-0.4786,0.1500>,Teapot_Sphere_Radius}
sphere {<1.8501,-0.6215,0.6564>,Teapot_Sphere_Radius}
sphere {<1.8995,-0.6381,0.9000>,Teapot_Sphere_Radius}
sphere {<1.6186,-1.1878,0.9000>,Teapot_Sphere_Radius}
sphere {<1.5765,-1.1570,0.6564>,Teapot_Sphere_Radius}
sphere {<1.7324,-0.5819,0.4632>,Teapot_Sphere_Radius}
sphere {<1.8501,-0.6215,0.6564>,Teapot_Sphere_Radius}
sphere {<1.5765,-1.1570,0.6564>,Teapot_Sphere_Radius}
sphere {<1.4761,-1.0833,0.4632>,Teapot_Sphere_Radius}
sphere {<1.5918,-0.5347,0.3168>,Teapot_Sphere_Radius}
sphere {<1.7324,-0.5819,0.4632>,Teapot_Sphere_Radius}
sphere {<1.4761,-1.0833,0.4632>,Teapot_Sphere_Radius}
sphere {<1.3564,-0.9954,0.3168>,Teapot_Sphere_Radius}
sphere {<1.4740,-0.4951,0.2136>,Teapot_Sphere_Radius}
sphere {<1.5918,-0.5347,0.3168>,Teapot_Sphere_Radius}
sphere {<1.3564,-0.9954,0.3168>,Teapot_Sphere_Radius}
sphere {<1.2560,-0.9218,0.2136>,Teapot_Sphere_Radius}
sphere {<1.4246,-0.4786,0.1500>,Teapot_Sphere_Radius}
sphere {<1.4740,-0.4951,0.2136>,Teapot_Sphere_Radius}
sphere {<1.2560,-0.9218,0.2136>,Teapot_Sphere_Radius}
sphere {<1.2139,-0.8909,0.1500>,Teapot_Sphere_Radius}
sphere {<1.5765,-1.1570,0.6564>,Teapot_Sphere_Radius}
sphere {<1.6186,-1.1878,0.9000>,Teapot_Sphere_Radius}
sphere {<1.1878,-1.6186,0.9000>,Teapot_Sphere_Radius}
sphere {<1.1570,-1.5765,0.6564>,Teapot_Sphere_Radius}
sphere {<1.4761,-1.0833,0.4632>,Teapot_Sphere_Radius}
sphere {<1.5765,-1.1570,0.6564>,Teapot_Sphere_Radius}
sphere {<1.1570,-1.5765,0.6564>,Teapot_Sphere_Radius}
sphere {<1.0833,-1.4761,0.4632>,Teapot_Sphere_Radius}
sphere {<1.3564,-0.9954,0.3168>,Teapot_Sphere_Radius}
sphere {<1.4761,-1.0833,0.4632>,Teapot_Sphere_Radius}
sphere {<1.0833,-1.4761,0.4632>,Teapot_Sphere_Radius}
sphere {<0.9954,-1.3564,0.3168>,Teapot_Sphere_Radius}
sphere {<1.2560,-0.9218,0.2136>,Teapot_Sphere_Radius}
sphere {<1.3564,-0.9954,0.3168>,Teapot_Sphere_Radius}
sphere {<0.9954,-1.3564,0.3168>,Teapot_Sphere_Radius}
sphere {<0.9218,-1.2560,0.2136>,Teapot_Sphere_Radius}
sphere {<1.2139,-0.8909,0.1500>,Teapot_Sphere_Radius}
sphere {<1.2560,-0.9218,0.2136>,Teapot_Sphere_Radius}
sphere {<0.9218,-1.2560,0.2136>,Teapot_Sphere_Radius}
sphere {<0.8909,-1.2139,0.1500>,Teapot_Sphere_Radius}
sphere {<1.1570,-1.5765,0.6564>,Teapot_Sphere_Radius}
sphere {<1.1878,-1.6186,0.9000>,Teapot_Sphere_Radius}
sphere {<0.6381,-1.8995,0.9000>,Teapot_Sphere_Radius}
sphere {<0.6215,-1.8501,0.6564>,Teapot_Sphere_Radius}
sphere {<1.0833,-1.4761,0.4632>,Teapot_Sphere_Radius}
sphere {<1.1570,-1.5765,0.6564>,Teapot_Sphere_Radius}
sphere {<0.6215,-1.8501,0.6564>,Teapot_Sphere_Radius}
sphere {<0.5819,-1.7324,0.4632>,Teapot_Sphere_Radius}
sphere {<0.9954,-1.3564,0.3168>,Teapot_Sphere_Radius}
sphere {<1.0833,-1.4761,0.4632>,Teapot_Sphere_Radius}
sphere {<0.5819,-1.7324,0.4632>,Teapot_Sphere_Radius}
sphere {<0.5347,-1.5918,0.3168>,Teapot_Sphere_Radius}
sphere {<0.9218,-1.2560,0.2136>,Teapot_Sphere_Radius}
sphere {<0.9954,-1.3564,0.3168>,Teapot_Sphere_Radius}
sphere {<0.5347,-1.5918,0.3168>,Teapot_Sphere_Radius}
sphere {<0.4951,-1.4740,0.2136>,Teapot_Sphere_Radius}
sphere {<0.8909,-1.2139,0.1500>,Teapot_Sphere_Radius}
sphere {<0.9218,-1.2560,0.2136>,Teapot_Sphere_Radius}
sphere {<0.4951,-1.4740,0.2136>,Teapot_Sphere_Radius}
sphere {<0.4786,-1.4246,0.1500>,Teapot_Sphere_Radius}
sphere {<0.6215,-1.8501,0.6564>,Teapot_Sphere_Radius}
sphere {<0.6381,-1.8995,0.9000>,Teapot_Sphere_Radius}
sphere {<0.0000,-2.0000,0.9000>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.9480,0.6564>,Teapot_Sphere_Radius}
sphere {<0.5819,-1.7324,0.4632>,Teapot_Sphere_Radius}
sphere {<0.6215,-1.8501,0.6564>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.9480,0.6564>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.8240,0.4632>,Teapot_Sphere_Radius}
sphere {<0.5347,-1.5918,0.3168>,Teapot_Sphere_Radius}
sphere {<0.5819,-1.7324,0.4632>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.8240,0.4632>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.6760,0.3168>,Teapot_Sphere_Radius}
sphere {<0.4951,-1.4740,0.2136>,Teapot_Sphere_Radius}
sphere {<0.5347,-1.5918,0.3168>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.6760,0.3168>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.5520,0.2136>,Teapot_Sphere_Radius}
sphere {<0.4786,-1.4246,0.1500>,Teapot_Sphere_Radius}
sphere {<0.4951,-1.4740,0.2136>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.5520,0.2136>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.5000,0.1500>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.9480,0.6564>,Teapot_Sphere_Radius}
sphere {<0.0000,-2.0000,0.9000>,Teapot_Sphere_Radius}
sphere {<-0.6381,-1.8995,0.9000>,Teapot_Sphere_Radius}
sphere {<-0.6215,-1.8501,0.6564>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.8240,0.4632>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.9480,0.6564>,Teapot_Sphere_Radius}
sphere {<-0.6215,-1.8501,0.6564>,Teapot_Sphere_Radius}
sphere {<-0.5819,-1.7324,0.4632>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.6760,0.3168>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.8240,0.4632>,Teapot_Sphere_Radius}
sphere {<-0.5819,-1.7324,0.4632>,Teapot_Sphere_Radius}
sphere {<-0.5347,-1.5918,0.3168>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.5520,0.2136>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.6760,0.3168>,Teapot_Sphere_Radius}
sphere {<-0.5347,-1.5918,0.3168>,Teapot_Sphere_Radius}
sphere {<-0.4951,-1.4740,0.2136>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.5000,0.1500>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.5520,0.2136>,Teapot_Sphere_Radius}
sphere {<-0.4951,-1.4740,0.2136>,Teapot_Sphere_Radius}
sphere {<-0.4786,-1.4246,0.1500>,Teapot_Sphere_Radius}
sphere {<-0.6215,-1.8501,0.6564>,Teapot_Sphere_Radius}
sphere {<-0.6381,-1.8995,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.1878,-1.6186,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.1570,-1.5765,0.6564>,Teapot_Sphere_Radius}
sphere {<-0.5819,-1.7324,0.4632>,Teapot_Sphere_Radius}
sphere {<-0.6215,-1.8501,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.1570,-1.5765,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.0833,-1.4761,0.4632>,Teapot_Sphere_Radius}
sphere {<-0.5347,-1.5918,0.3168>,Teapot_Sphere_Radius}
sphere {<-0.5819,-1.7324,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.0833,-1.4761,0.4632>,Teapot_Sphere_Radius}
sphere {<-0.9954,-1.3564,0.3168>,Teapot_Sphere_Radius}
sphere {<-0.4951,-1.4740,0.2136>,Teapot_Sphere_Radius}
sphere {<-0.5347,-1.5918,0.3168>,Teapot_Sphere_Radius}
sphere {<-0.9954,-1.3564,0.3168>,Teapot_Sphere_Radius}
sphere {<-0.9218,-1.2560,0.2136>,Teapot_Sphere_Radius}
sphere {<-0.4786,-1.4246,0.1500>,Teapot_Sphere_Radius}
sphere {<-0.4951,-1.4740,0.2136>,Teapot_Sphere_Radius}
sphere {<-0.9218,-1.2560,0.2136>,Teapot_Sphere_Radius}
sphere {<-0.8909,-1.2139,0.1500>,Teapot_Sphere_Radius}
sphere {<-1.1570,-1.5765,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.1878,-1.6186,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.6186,-1.1878,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.5765,-1.1570,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.0833,-1.4761,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.1570,-1.5765,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.5765,-1.1570,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.4761,-1.0833,0.4632>,Teapot_Sphere_Radius}
sphere {<-0.9954,-1.3564,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.0833,-1.4761,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.4761,-1.0833,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.3564,-0.9954,0.3168>,Teapot_Sphere_Radius}
sphere {<-0.9218,-1.2560,0.2136>,Teapot_Sphere_Radius}
sphere {<-0.9954,-1.3564,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.3564,-0.9954,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.2560,-0.9218,0.2136>,Teapot_Sphere_Radius}
sphere {<-0.8909,-1.2139,0.1500>,Teapot_Sphere_Radius}
sphere {<-0.9218,-1.2560,0.2136>,Teapot_Sphere_Radius}
sphere {<-1.2560,-0.9218,0.2136>,Teapot_Sphere_Radius}
sphere {<-1.2139,-0.8909,0.1500>,Teapot_Sphere_Radius}
sphere {<-1.5765,-1.1570,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.6186,-1.1878,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.8995,-0.6381,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.8501,-0.6215,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.4761,-1.0833,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.5765,-1.1570,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.8501,-0.6215,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.7324,-0.5819,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.3564,-0.9954,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.4761,-1.0833,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.7324,-0.5819,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.5918,-0.5347,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.2560,-0.9218,0.2136>,Teapot_Sphere_Radius}
sphere {<-1.3564,-0.9954,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.5918,-0.5347,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.4740,-0.4951,0.2136>,Teapot_Sphere_Radius}
sphere {<-1.2139,-0.8909,0.1500>,Teapot_Sphere_Radius}
sphere {<-1.2560,-0.9218,0.2136>,Teapot_Sphere_Radius}
sphere {<-1.4740,-0.4951,0.2136>,Teapot_Sphere_Radius}
sphere {<-1.4246,-0.4786,0.1500>,Teapot_Sphere_Radius}
sphere {<-1.8501,-0.6215,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.8995,-0.6381,0.9000>,Teapot_Sphere_Radius}
sphere {<-2.0000,0.0000,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.9480,0.0000,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.7324,-0.5819,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.8501,-0.6215,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.9480,0.0000,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.8240,0.0000,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.5918,-0.5347,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.7324,-0.5819,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.8240,0.0000,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.6760,0.0000,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.4740,-0.4951,0.2136>,Teapot_Sphere_Radius}
sphere {<-1.5918,-0.5347,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.6760,0.0000,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.5520,0.0000,0.2136>,Teapot_Sphere_Radius}
sphere {<-1.4246,-0.4786,0.1500>,Teapot_Sphere_Radius}
sphere {<-1.4740,-0.4951,0.2136>,Teapot_Sphere_Radius}
sphere {<-1.5520,0.0000,0.2136>,Teapot_Sphere_Radius}
sphere {<-1.5000,0.0000,0.1500>,Teapot_Sphere_Radius}
sphere {<-1.9480,0.0000,0.6564>,Teapot_Sphere_Radius}
sphere {<-2.0000,0.0000,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.8995,0.6381,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.8501,0.6215,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.8240,0.0000,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.9480,0.0000,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.8501,0.6215,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.7324,0.5819,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.6760,0.0000,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.8240,0.0000,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.7324,0.5819,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.5918,0.5347,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.5520,0.0000,0.2136>,Teapot_Sphere_Radius}
sphere {<-1.6760,0.0000,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.5918,0.5347,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.4740,0.4951,0.2136>,Teapot_Sphere_Radius}
sphere {<-1.5000,0.0000,0.1500>,Teapot_Sphere_Radius}
sphere {<-1.5520,0.0000,0.2136>,Teapot_Sphere_Radius}
sphere {<-1.4740,0.4951,0.2136>,Teapot_Sphere_Radius}
sphere {<-1.4246,0.4786,0.1500>,Teapot_Sphere_Radius}
sphere {<-1.8501,0.6215,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.8995,0.6381,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.6186,1.1878,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.5765,1.1570,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.7324,0.5819,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.8501,0.6215,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.5765,1.1570,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.4761,1.0833,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.5918,0.5347,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.7324,0.5819,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.4761,1.0833,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.3564,0.9954,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.4740,0.4951,0.2136>,Teapot_Sphere_Radius}
sphere {<-1.5918,0.5347,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.3564,0.9954,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.2560,0.9218,0.2136>,Teapot_Sphere_Radius}
sphere {<-1.4246,0.4786,0.1500>,Teapot_Sphere_Radius}
sphere {<-1.4740,0.4951,0.2136>,Teapot_Sphere_Radius}
sphere {<-1.2560,0.9218,0.2136>,Teapot_Sphere_Radius}
sphere {<-1.2139,0.8909,0.1500>,Teapot_Sphere_Radius}
sphere {<-1.5765,1.1570,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.6186,1.1878,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.1878,1.6186,0.9000>,Teapot_Sphere_Radius}
sphere {<-1.1570,1.5765,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.4761,1.0833,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.5765,1.1570,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.1570,1.5765,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.0833,1.4761,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.3564,0.9954,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.4761,1.0833,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.0833,1.4761,0.4632>,Teapot_Sphere_Radius}
sphere {<-0.9954,1.3564,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.2560,0.9218,0.2136>,Teapot_Sphere_Radius}
sphere {<-1.3564,0.9954,0.3168>,Teapot_Sphere_Radius}
sphere {<-0.9954,1.3564,0.3168>,Teapot_Sphere_Radius}
sphere {<-0.9218,1.2560,0.2136>,Teapot_Sphere_Radius}
sphere {<-1.2139,0.8909,0.1500>,Teapot_Sphere_Radius}
sphere {<-1.2560,0.9218,0.2136>,Teapot_Sphere_Radius}
sphere {<-0.9218,1.2560,0.2136>,Teapot_Sphere_Radius}
sphere {<-0.8909,1.2139,0.1500>,Teapot_Sphere_Radius}
sphere {<-1.1570,1.5765,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.1878,1.6186,0.9000>,Teapot_Sphere_Radius}
sphere {<-0.6381,1.8995,0.9000>,Teapot_Sphere_Radius}
sphere {<-0.6215,1.8501,0.6564>,Teapot_Sphere_Radius}
sphere {<-1.0833,1.4761,0.4632>,Teapot_Sphere_Radius}
sphere {<-1.1570,1.5765,0.6564>,Teapot_Sphere_Radius}
sphere {<-0.6215,1.8501,0.6564>,Teapot_Sphere_Radius}
sphere {<-0.5819,1.7324,0.4632>,Teapot_Sphere_Radius}
sphere {<-0.9954,1.3564,0.3168>,Teapot_Sphere_Radius}
sphere {<-1.0833,1.4761,0.4632>,Teapot_Sphere_Radius}
sphere {<-0.5819,1.7324,0.4632>,Teapot_Sphere_Radius}
sphere {<-0.5347,1.5918,0.3168>,Teapot_Sphere_Radius}
sphere {<-0.9218,1.2560,0.2136>,Teapot_Sphere_Radius}
sphere {<-0.9954,1.3564,0.3168>,Teapot_Sphere_Radius}
sphere {<-0.5347,1.5918,0.3168>,Teapot_Sphere_Radius}
sphere {<-0.4951,1.4740,0.2136>,Teapot_Sphere_Radius}
sphere {<-0.8909,1.2139,0.1500>,Teapot_Sphere_Radius}
sphere {<-0.9218,1.2560,0.2136>,Teapot_Sphere_Radius}
sphere {<-0.4951,1.4740,0.2136>,Teapot_Sphere_Radius}
sphere {<-0.4786,1.4246,0.1500>,Teapot_Sphere_Radius}
sphere {<-0.6215,1.8501,0.6564>,Teapot_Sphere_Radius}
sphere {<-0.6381,1.8995,0.9000>,Teapot_Sphere_Radius}
sphere {<0.0000,2.0000,0.9000>,Teapot_Sphere_Radius}
sphere {<0.0000,1.9480,0.6564>,Teapot_Sphere_Radius}
sphere {<-0.5819,1.7324,0.4632>,Teapot_Sphere_Radius}
sphere {<-0.6215,1.8501,0.6564>,Teapot_Sphere_Radius}
sphere {<0.0000,1.9480,0.6564>,Teapot_Sphere_Radius}
sphere {<0.0000,1.8240,0.4632>,Teapot_Sphere_Radius}
sphere {<-0.5347,1.5918,0.3168>,Teapot_Sphere_Radius}
sphere {<-0.5819,1.7324,0.4632>,Teapot_Sphere_Radius}
sphere {<0.0000,1.8240,0.4632>,Teapot_Sphere_Radius}
sphere {<0.0000,1.6760,0.3168>,Teapot_Sphere_Radius}
sphere {<-0.4951,1.4740,0.2136>,Teapot_Sphere_Radius}
sphere {<-0.5347,1.5918,0.3168>,Teapot_Sphere_Radius}
sphere {<0.0000,1.6760,0.3168>,Teapot_Sphere_Radius}
sphere {<0.0000,1.5520,0.2136>,Teapot_Sphere_Radius}
sphere {<-0.4786,1.4246,0.1500>,Teapot_Sphere_Radius}
sphere {<-0.4951,1.4740,0.2136>,Teapot_Sphere_Radius}
sphere {<0.0000,1.5520,0.2136>,Teapot_Sphere_Radius}
sphere {<0.0000,1.5000,0.1500>,Teapot_Sphere_Radius}
sphere {<0.0000,1.9480,0.6564>,Teapot_Sphere_Radius}
sphere {<0.0000,2.0000,0.9000>,Teapot_Sphere_Radius}
sphere {<0.6381,1.8995,0.9000>,Teapot_Sphere_Radius}
sphere {<0.6215,1.8501,0.6564>,Teapot_Sphere_Radius}
sphere {<0.0000,1.8240,0.4632>,Teapot_Sphere_Radius}
sphere {<0.0000,1.9480,0.6564>,Teapot_Sphere_Radius}
sphere {<0.6215,1.8501,0.6564>,Teapot_Sphere_Radius}
sphere {<0.5819,1.7324,0.4632>,Teapot_Sphere_Radius}
sphere {<0.0000,1.6760,0.3168>,Teapot_Sphere_Radius}
sphere {<0.0000,1.8240,0.4632>,Teapot_Sphere_Radius}
sphere {<0.5819,1.7324,0.4632>,Teapot_Sphere_Radius}
sphere {<0.5347,1.5918,0.3168>,Teapot_Sphere_Radius}
sphere {<0.0000,1.5520,0.2136>,Teapot_Sphere_Radius}
sphere {<0.0000,1.6760,0.3168>,Teapot_Sphere_Radius}
sphere {<0.5347,1.5918,0.3168>,Teapot_Sphere_Radius}
sphere {<0.4951,1.4740,0.2136>,Teapot_Sphere_Radius}
sphere {<0.0000,1.5000,0.1500>,Teapot_Sphere_Radius}
sphere {<0.0000,1.5520,0.2136>,Teapot_Sphere_Radius}
sphere {<0.4951,1.4740,0.2136>,Teapot_Sphere_Radius}
sphere {<0.4786,1.4246,0.1500>,Teapot_Sphere_Radius}
sphere {<0.6215,1.8501,0.6564>,Teapot_Sphere_Radius}
sphere {<0.6381,1.8995,0.9000>,Teapot_Sphere_Radius}
sphere {<1.1878,1.6186,0.9000>,Teapot_Sphere_Radius}
sphere {<1.1570,1.5765,0.6564>,Teapot_Sphere_Radius}
sphere {<0.5819,1.7324,0.4632>,Teapot_Sphere_Radius}
sphere {<0.6215,1.8501,0.6564>,Teapot_Sphere_Radius}
sphere {<1.1570,1.5765,0.6564>,Teapot_Sphere_Radius}
sphere {<1.0833,1.4761,0.4632>,Teapot_Sphere_Radius}
sphere {<0.5347,1.5918,0.3168>,Teapot_Sphere_Radius}
sphere {<0.5819,1.7324,0.4632>,Teapot_Sphere_Radius}
sphere {<1.0833,1.4761,0.4632>,Teapot_Sphere_Radius}
sphere {<0.9954,1.3564,0.3168>,Teapot_Sphere_Radius}
sphere {<0.4951,1.4740,0.2136>,Teapot_Sphere_Radius}
sphere {<0.5347,1.5918,0.3168>,Teapot_Sphere_Radius}
sphere {<0.9954,1.3564,0.3168>,Teapot_Sphere_Radius}
sphere {<0.9218,1.2560,0.2136>,Teapot_Sphere_Radius}
sphere {<0.4786,1.4246,0.1500>,Teapot_Sphere_Radius}
sphere {<0.4951,1.4740,0.2136>,Teapot_Sphere_Radius}
sphere {<0.9218,1.2560,0.2136>,Teapot_Sphere_Radius}
sphere {<0.8909,1.2139,0.1500>,Teapot_Sphere_Radius}
sphere {<1.1570,1.5765,0.6564>,Teapot_Sphere_Radius}
sphere {<1.1878,1.6186,0.9000>,Teapot_Sphere_Radius}
sphere {<1.6186,1.1878,0.9000>,Teapot_Sphere_Radius}
sphere {<1.5765,1.1570,0.6564>,Teapot_Sphere_Radius}
sphere {<1.0833,1.4761,0.4632>,Teapot_Sphere_Radius}
sphere {<1.1570,1.5765,0.6564>,Teapot_Sphere_Radius}
sphere {<1.5765,1.1570,0.6564>,Teapot_Sphere_Radius}
sphere {<1.4761,1.0833,0.4632>,Teapot_Sphere_Radius}
sphere {<0.9954,1.3564,0.3168>,Teapot_Sphere_Radius}
sphere {<1.0833,1.4761,0.4632>,Teapot_Sphere_Radius}
sphere {<1.4761,1.0833,0.4632>,Teapot_Sphere_Radius}
sphere {<1.3564,0.9954,0.3168>,Teapot_Sphere_Radius}
sphere {<0.9218,1.2560,0.2136>,Teapot_Sphere_Radius}
sphere {<0.9954,1.3564,0.3168>,Teapot_Sphere_Radius}
sphere {<1.3564,0.9954,0.3168>,Teapot_Sphere_Radius}
sphere {<1.2560,0.9218,0.2136>,Teapot_Sphere_Radius}
sphere {<0.8909,1.2139,0.1500>,Teapot_Sphere_Radius}
sphere {<0.9218,1.2560,0.2136>,Teapot_Sphere_Radius}
sphere {<1.2560,0.9218,0.2136>,Teapot_Sphere_Radius}
sphere {<1.2139,0.8909,0.1500>,Teapot_Sphere_Radius}
sphere {<1.5765,1.1570,0.6564>,Teapot_Sphere_Radius}
sphere {<1.6186,1.1878,0.9000>,Teapot_Sphere_Radius}
sphere {<1.8995,0.6381,0.9000>,Teapot_Sphere_Radius}
sphere {<1.8501,0.6215,0.6564>,Teapot_Sphere_Radius}
sphere {<1.4761,1.0833,0.4632>,Teapot_Sphere_Radius}
sphere {<1.5765,1.1570,0.6564>,Teapot_Sphere_Radius}
sphere {<1.8501,0.6215,0.6564>,Teapot_Sphere_Radius}
sphere {<1.7324,0.5819,0.4632>,Teapot_Sphere_Radius}
sphere {<1.3564,0.9954,0.3168>,Teapot_Sphere_Radius}
sphere {<1.4761,1.0833,0.4632>,Teapot_Sphere_Radius}
sphere {<1.7324,0.5819,0.4632>,Teapot_Sphere_Radius}
sphere {<1.5918,0.5347,0.3168>,Teapot_Sphere_Radius}
sphere {<1.2560,0.9218,0.2136>,Teapot_Sphere_Radius}
sphere {<1.3564,0.9954,0.3168>,Teapot_Sphere_Radius}
sphere {<1.5918,0.5347,0.3168>,Teapot_Sphere_Radius}
sphere {<1.4740,0.4951,0.2136>,Teapot_Sphere_Radius}
sphere {<1.2139,0.8909,0.1500>,Teapot_Sphere_Radius}
sphere {<1.2560,0.9218,0.2136>,Teapot_Sphere_Radius}
sphere {<1.4740,0.4951,0.2136>,Teapot_Sphere_Radius}
sphere {<1.4246,0.4786,0.1500>,Teapot_Sphere_Radius}
sphere {<1.8501,0.6215,0.6564>,Teapot_Sphere_Radius}
sphere {<1.8995,0.6381,0.9000>,Teapot_Sphere_Radius}
sphere {<2.0000,0.0000,0.9000>,Teapot_Sphere_Radius}
sphere {<1.9480,0.0000,0.6564>,Teapot_Sphere_Radius}
sphere {<1.7324,0.5819,0.4632>,Teapot_Sphere_Radius}
sphere {<1.8501,0.6215,0.6564>,Teapot_Sphere_Radius}
sphere {<1.9480,0.0000,0.6564>,Teapot_Sphere_Radius}
sphere {<1.8240,0.0000,0.4632>,Teapot_Sphere_Radius}
sphere {<1.5918,0.5347,0.3168>,Teapot_Sphere_Radius}
sphere {<1.7324,0.5819,0.4632>,Teapot_Sphere_Radius}
sphere {<1.8240,0.0000,0.4632>,Teapot_Sphere_Radius}
sphere {<1.6760,0.0000,0.3168>,Teapot_Sphere_Radius}
sphere {<1.4740,0.4951,0.2136>,Teapot_Sphere_Radius}
sphere {<1.5918,0.5347,0.3168>,Teapot_Sphere_Radius}
sphere {<1.6760,0.0000,0.3168>,Teapot_Sphere_Radius}
sphere {<1.5520,0.0000,0.2136>,Teapot_Sphere_Radius}
sphere {<1.4246,0.4786,0.1500>,Teapot_Sphere_Radius}
sphere {<1.4740,0.4951,0.2136>,Teapot_Sphere_Radius}
sphere {<1.5520,0.0000,0.2136>,Teapot_Sphere_Radius}
sphere {<1.5000,0.0000,0.1500>,Teapot_Sphere_Radius}
sphere {<-1.9832,0.0000,2.0232>,Teapot_Sphere_Radius}
sphere {<-1.6000,0.0000,2.0250>,Teapot_Sphere_Radius}
sphere {<-1.5896,-0.1440,2.0484>,Teapot_Sphere_Radius}
sphere {<-1.9891,-0.1440,2.0464>,Teapot_Sphere_Radius}
sphere {<-2.2896,0.0000,2.0106>,Teapot_Sphere_Radius}
sphere {<-1.9832,0.0000,2.0232>,Teapot_Sphere_Radius}
sphere {<-1.9891,-0.1440,2.0464>,Teapot_Sphere_Radius}
sphere {<-2.3073,-0.1440,2.0325>,Teapot_Sphere_Radius}
sphere {<-2.5144,0.0000,1.9764>,Teapot_Sphere_Radius}
sphere {<-2.2896,0.0000,2.0106>,Teapot_Sphere_Radius}
sphere {<-2.3073,-0.1440,2.0325>,Teapot_Sphere_Radius}
sphere {<-2.5399,-0.1440,1.9947>,Teapot_Sphere_Radius}
sphere {<-2.6528,0.0000,1.9098>,Teapot_Sphere_Radius}
sphere {<-2.5144,0.0000,1.9764>,Teapot_Sphere_Radius}
sphere {<-2.5399,-0.1440,1.9947>,Teapot_Sphere_Radius}
sphere {<-2.6827,-0.1440,1.9212>,Teapot_Sphere_Radius}
sphere {<-2.7000,0.0000,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.6528,0.0000,1.9098>,Teapot_Sphere_Radius}
sphere {<-2.6827,-0.1440,1.9212>,Teapot_Sphere_Radius}
sphere {<-2.7312,-0.1440,1.8000>,Teapot_Sphere_Radius}
sphere {<-1.9891,-0.1440,2.0464>,Teapot_Sphere_Radius}
sphere {<-1.5896,-0.1440,2.0484>,Teapot_Sphere_Radius}
sphere {<-1.5648,-0.2160,2.1042>,Teapot_Sphere_Radius}
sphere {<-2.0032,-0.2160,2.1018>,Teapot_Sphere_Radius}
sphere {<-2.3073,-0.1440,2.0325>,Teapot_Sphere_Radius}
sphere {<-1.9891,-0.1440,2.0464>,Teapot_Sphere_Radius}
sphere {<-2.0032,-0.2160,2.1018>,Teapot_Sphere_Radius}
sphere {<-2.3496,-0.2160,2.0847>,Teapot_Sphere_Radius}
sphere {<-2.5399,-0.1440,1.9947>,Teapot_Sphere_Radius}
sphere {<-2.3073,-0.1440,2.0325>,Teapot_Sphere_Radius}
sphere {<-2.3496,-0.2160,2.0847>,Teapot_Sphere_Radius}
sphere {<-2.6009,-0.2160,2.0385>,Teapot_Sphere_Radius}
sphere {<-2.6827,-0.1440,1.9212>,Teapot_Sphere_Radius}
sphere {<-2.5399,-0.1440,1.9947>,Teapot_Sphere_Radius}
sphere {<-2.6009,-0.2160,2.0385>,Teapot_Sphere_Radius}
sphere {<-2.7539,-0.2160,1.9484>,Teapot_Sphere_Radius}
sphere {<-2.7312,-0.1440,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.6827,-0.1440,1.9212>,Teapot_Sphere_Radius}
sphere {<-2.7539,-0.2160,1.9484>,Teapot_Sphere_Radius}
sphere {<-2.8056,-0.2160,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.0032,-0.2160,2.1018>,Teapot_Sphere_Radius}
sphere {<-1.5648,-0.2160,2.1042>,Teapot_Sphere_Radius}
sphere {<-1.5352,-0.2160,2.1708>,Teapot_Sphere_Radius}
sphere {<-2.0200,-0.2160,2.1678>,Teapot_Sphere_Radius}
sphere {<-2.3496,-0.2160,2.0847>,Teapot_Sphere_Radius}
sphere {<-2.0032,-0.2160,2.1018>,Teapot_Sphere_Radius}
sphere {<-2.0200,-0.2160,2.1678>,Teapot_Sphere_Radius}
sphere {<-2.4000,-0.2160,2.1471>,Teapot_Sphere_Radius}
sphere {<-2.6009,-0.2160,2.0385>,Teapot_Sphere_Radius}
sphere {<-2.3496,-0.2160,2.0847>,Teapot_Sphere_Radius}
sphere {<-2.4000,-0.2160,2.1471>,Teapot_Sphere_Radius}
sphere {<-2.6735,-0.2160,2.0907>,Teapot_Sphere_Radius}
sphere {<-2.7539,-0.2160,1.9484>,Teapot_Sphere_Radius}
sphere {<-2.6009,-0.2160,2.0385>,Teapot_Sphere_Radius}
sphere {<-2.6735,-0.2160,2.0907>,Teapot_Sphere_Radius}
sphere {<-2.8389,-0.2160,1.9809>,Teapot_Sphere_Radius}
sphere {<-2.8056,-0.2160,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.7539,-0.2160,1.9484>,Teapot_Sphere_Radius}
sphere {<-2.8389,-0.2160,1.9809>,Teapot_Sphere_Radius}
sphere {<-2.8944,-0.2160,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.0200,-0.2160,2.1678>,Teapot_Sphere_Radius}
sphere {<-1.5352,-0.2160,2.1708>,Teapot_Sphere_Radius}
sphere {<-1.5104,-0.1440,2.2266>,Teapot_Sphere_Radius}
sphere {<-2.0341,-0.1440,2.2232>,Teapot_Sphere_Radius}
sphere {<-2.4000,-0.2160,2.1471>,Teapot_Sphere_Radius}
sphere {<-2.0200,-0.2160,2.1678>,Teapot_Sphere_Radius}
sphere {<-2.0341,-0.1440,2.2232>,Teapot_Sphere_Radius}
sphere {<-2.4423,-0.1440,2.1993>,Teapot_Sphere_Radius}
sphere {<-2.6735,-0.2160,2.0907>,Teapot_Sphere_Radius}
sphere {<-2.4000,-0.2160,2.1471>,Teapot_Sphere_Radius}
sphere {<-2.4423,-0.1440,2.1993>,Teapot_Sphere_Radius}
sphere {<-2.7345,-0.1440,2.1345>,Teapot_Sphere_Radius}
sphere {<-2.8389,-0.2160,1.9809>,Teapot_Sphere_Radius}
sphere {<-2.6735,-0.2160,2.0907>,Teapot_Sphere_Radius}
sphere {<-2.7345,-0.1440,2.1345>,Teapot_Sphere_Radius}
sphere {<-2.9101,-0.1440,2.0082>,Teapot_Sphere_Radius}
sphere {<-2.8944,-0.2160,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.8389,-0.2160,1.9809>,Teapot_Sphere_Radius}
sphere {<-2.9101,-0.1440,2.0082>,Teapot_Sphere_Radius}
sphere {<-2.9688,-0.1440,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.0341,-0.1440,2.2232>,Teapot_Sphere_Radius}
sphere {<-1.5104,-0.1440,2.2266>,Teapot_Sphere_Radius}
sphere {<-1.5000,0.0000,2.2500>,Teapot_Sphere_Radius}
sphere {<-2.0400,0.0000,2.2464>,Teapot_Sphere_Radius}
sphere {<-2.4423,-0.1440,2.1993>,Teapot_Sphere_Radius}
sphere {<-2.0341,-0.1440,2.2232>,Teapot_Sphere_Radius}
sphere {<-2.0400,0.0000,2.2464>,Teapot_Sphere_Radius}
sphere {<-2.4600,0.0000,2.2212>,Teapot_Sphere_Radius}
sphere {<-2.7345,-0.1440,2.1345>,Teapot_Sphere_Radius}
sphere {<-2.4423,-0.1440,2.1993>,Teapot_Sphere_Radius}
sphere {<-2.4600,0.0000,2.2212>,Teapot_Sphere_Radius}
sphere {<-2.7600,0.0000,2.1528>,Teapot_Sphere_Radius}
sphere {<-2.9101,-0.1440,2.0082>,Teapot_Sphere_Radius}
sphere {<-2.7345,-0.1440,2.1345>,Teapot_Sphere_Radius}
sphere {<-2.7600,0.0000,2.1528>,Teapot_Sphere_Radius}
sphere {<-2.9400,0.0000,2.0196>,Teapot_Sphere_Radius}
sphere {<-2.9688,-0.1440,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.9101,-0.1440,2.0082>,Teapot_Sphere_Radius}
sphere {<-2.9400,0.0000,2.0196>,Teapot_Sphere_Radius}
sphere {<-3.0000,0.0000,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.0400,0.0000,2.2464>,Teapot_Sphere_Radius}
sphere {<-1.5000,0.0000,2.2500>,Teapot_Sphere_Radius}
sphere {<-1.5104,0.1440,2.2266>,Teapot_Sphere_Radius}
sphere {<-2.0341,0.1440,2.2232>,Teapot_Sphere_Radius}
sphere {<-2.4600,0.0000,2.2212>,Teapot_Sphere_Radius}
sphere {<-2.0400,0.0000,2.2464>,Teapot_Sphere_Radius}
sphere {<-2.0341,0.1440,2.2232>,Teapot_Sphere_Radius}
sphere {<-2.4423,0.1440,2.1993>,Teapot_Sphere_Radius}
sphere {<-2.7600,0.0000,2.1528>,Teapot_Sphere_Radius}
sphere {<-2.4600,0.0000,2.2212>,Teapot_Sphere_Radius}
sphere {<-2.4423,0.1440,2.1993>,Teapot_Sphere_Radius}
sphere {<-2.7345,0.1440,2.1345>,Teapot_Sphere_Radius}
sphere {<-2.9400,0.0000,2.0196>,Teapot_Sphere_Radius}
sphere {<-2.7600,0.0000,2.1528>,Teapot_Sphere_Radius}
sphere {<-2.7345,0.1440,2.1345>,Teapot_Sphere_Radius}
sphere {<-2.9101,0.1440,2.0082>,Teapot_Sphere_Radius}
sphere {<-3.0000,0.0000,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.9400,0.0000,2.0196>,Teapot_Sphere_Radius}
sphere {<-2.9101,0.1440,2.0082>,Teapot_Sphere_Radius}
sphere {<-2.9688,0.1440,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.0341,0.1440,2.2232>,Teapot_Sphere_Radius}
sphere {<-1.5104,0.1440,2.2266>,Teapot_Sphere_Radius}
sphere {<-1.5352,0.2160,2.1708>,Teapot_Sphere_Radius}
sphere {<-2.0200,0.2160,2.1678>,Teapot_Sphere_Radius}
sphere {<-2.4423,0.1440,2.1993>,Teapot_Sphere_Radius}
sphere {<-2.0341,0.1440,2.2232>,Teapot_Sphere_Radius}
sphere {<-2.0200,0.2160,2.1678>,Teapot_Sphere_Radius}
sphere {<-2.4000,0.2160,2.1471>,Teapot_Sphere_Radius}
sphere {<-2.7345,0.1440,2.1345>,Teapot_Sphere_Radius}
sphere {<-2.4423,0.1440,2.1993>,Teapot_Sphere_Radius}
sphere {<-2.4000,0.2160,2.1471>,Teapot_Sphere_Radius}
sphere {<-2.6735,0.2160,2.0907>,Teapot_Sphere_Radius}
sphere {<-2.9101,0.1440,2.0082>,Teapot_Sphere_Radius}
sphere {<-2.7345,0.1440,2.1345>,Teapot_Sphere_Radius}
sphere {<-2.6735,0.2160,2.0907>,Teapot_Sphere_Radius}
sphere {<-2.8389,0.2160,1.9809>,Teapot_Sphere_Radius}
sphere {<-2.9688,0.1440,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.9101,0.1440,2.0082>,Teapot_Sphere_Radius}
sphere {<-2.8389,0.2160,1.9809>,Teapot_Sphere_Radius}
sphere {<-2.8944,0.2160,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.0200,0.2160,2.1678>,Teapot_Sphere_Radius}
sphere {<-1.5352,0.2160,2.1708>,Teapot_Sphere_Radius}
sphere {<-1.5648,0.2160,2.1042>,Teapot_Sphere_Radius}
sphere {<-2.0032,0.2160,2.1018>,Teapot_Sphere_Radius}
sphere {<-2.4000,0.2160,2.1471>,Teapot_Sphere_Radius}
sphere {<-2.0200,0.2160,2.1678>,Teapot_Sphere_Radius}
sphere {<-2.0032,0.2160,2.1018>,Teapot_Sphere_Radius}
sphere {<-2.3496,0.2160,2.0847>,Teapot_Sphere_Radius}
sphere {<-2.6735,0.2160,2.0907>,Teapot_Sphere_Radius}
sphere {<-2.4000,0.2160,2.1471>,Teapot_Sphere_Radius}
sphere {<-2.3496,0.2160,2.0847>,Teapot_Sphere_Radius}
sphere {<-2.6009,0.2160,2.0385>,Teapot_Sphere_Radius}
sphere {<-2.8389,0.2160,1.9809>,Teapot_Sphere_Radius}
sphere {<-2.6735,0.2160,2.0907>,Teapot_Sphere_Radius}
sphere {<-2.6009,0.2160,2.0385>,Teapot_Sphere_Radius}
sphere {<-2.7539,0.2160,1.9484>,Teapot_Sphere_Radius}
sphere {<-2.8944,0.2160,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.8389,0.2160,1.9809>,Teapot_Sphere_Radius}
sphere {<-2.7539,0.2160,1.9484>,Teapot_Sphere_Radius}
sphere {<-2.8056,0.2160,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.0032,0.2160,2.1018>,Teapot_Sphere_Radius}
sphere {<-1.5648,0.2160,2.1042>,Teapot_Sphere_Radius}
sphere {<-1.5896,0.1440,2.0484>,Teapot_Sphere_Radius}
sphere {<-1.9891,0.1440,2.0464>,Teapot_Sphere_Radius}
sphere {<-2.3496,0.2160,2.0847>,Teapot_Sphere_Radius}
sphere {<-2.0032,0.2160,2.1018>,Teapot_Sphere_Radius}
sphere {<-1.9891,0.1440,2.0464>,Teapot_Sphere_Radius}
sphere {<-2.3073,0.1440,2.0325>,Teapot_Sphere_Radius}
sphere {<-2.6009,0.2160,2.0385>,Teapot_Sphere_Radius}
sphere {<-2.3496,0.2160,2.0847>,Teapot_Sphere_Radius}
sphere {<-2.3073,0.1440,2.0325>,Teapot_Sphere_Radius}
sphere {<-2.5399,0.1440,1.9947>,Teapot_Sphere_Radius}
sphere {<-2.7539,0.2160,1.9484>,Teapot_Sphere_Radius}
sphere {<-2.6009,0.2160,2.0385>,Teapot_Sphere_Radius}
sphere {<-2.5399,0.1440,1.9947>,Teapot_Sphere_Radius}
sphere {<-2.6827,0.1440,1.9212>,Teapot_Sphere_Radius}
sphere {<-2.8056,0.2160,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.7539,0.2160,1.9484>,Teapot_Sphere_Radius}
sphere {<-2.6827,0.1440,1.9212>,Teapot_Sphere_Radius}
sphere {<-2.7312,0.1440,1.8000>,Teapot_Sphere_Radius}
sphere {<-1.9891,0.1440,2.0464>,Teapot_Sphere_Radius}
sphere {<-1.5896,0.1440,2.0484>,Teapot_Sphere_Radius}
sphere {<-1.6000,0.0000,2.0250>,Teapot_Sphere_Radius}
sphere {<-1.9832,0.0000,2.0232>,Teapot_Sphere_Radius}
sphere {<-2.3073,0.1440,2.0325>,Teapot_Sphere_Radius}
sphere {<-1.9891,0.1440,2.0464>,Teapot_Sphere_Radius}
sphere {<-1.9832,0.0000,2.0232>,Teapot_Sphere_Radius}
sphere {<-2.2896,0.0000,2.0106>,Teapot_Sphere_Radius}
sphere {<-2.5399,0.1440,1.9947>,Teapot_Sphere_Radius}
sphere {<-2.3073,0.1440,2.0325>,Teapot_Sphere_Radius}
sphere {<-2.2896,0.0000,2.0106>,Teapot_Sphere_Radius}
sphere {<-2.5144,0.0000,1.9764>,Teapot_Sphere_Radius}
sphere {<-2.6827,0.1440,1.9212>,Teapot_Sphere_Radius}
sphere {<-2.5399,0.1440,1.9947>,Teapot_Sphere_Radius}
sphere {<-2.5144,0.0000,1.9764>,Teapot_Sphere_Radius}
sphere {<-2.6528,0.0000,1.9098>,Teapot_Sphere_Radius}
sphere {<-2.7312,0.1440,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.6827,0.1440,1.9212>,Teapot_Sphere_Radius}
sphere {<-2.6528,0.0000,1.9098>,Teapot_Sphere_Radius}
sphere {<-2.7000,0.0000,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.6752,0.0000,1.6416>,Teapot_Sphere_Radius}
sphere {<-2.7000,0.0000,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.7312,-0.1440,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.7046,-0.1440,1.6305>,Teapot_Sphere_Radius}
sphere {<-2.5976,0.0000,1.4508>,Teapot_Sphere_Radius}
sphere {<-2.6752,0.0000,1.6416>,Teapot_Sphere_Radius}
sphere {<-2.7046,-0.1440,1.6305>,Teapot_Sphere_Radius}
sphere {<-2.6216,-0.1440,1.4331>,Teapot_Sphere_Radius}
sphere {<-2.4624,0.0000,1.2492>,Teapot_Sphere_Radius}
sphere {<-2.5976,0.0000,1.4508>,Teapot_Sphere_Radius}
sphere {<-2.6216,-0.1440,1.4331>,Teapot_Sphere_Radius}
sphere {<-2.4779,-0.1440,1.2273>,Teapot_Sphere_Radius}
sphere {<-2.2648,0.0000,1.0584>,Teapot_Sphere_Radius}
sphere {<-2.4624,0.0000,1.2492>,Teapot_Sphere_Radius}
sphere {<-2.4779,-0.1440,1.2273>,Teapot_Sphere_Radius}
sphere {<-2.2687,-0.1440,1.0327>,Teapot_Sphere_Radius}
sphere {<-2.0000,0.0000,0.9000>,Teapot_Sphere_Radius}
sphere {<-2.2648,0.0000,1.0584>,Teapot_Sphere_Radius}
sphere {<-2.2687,-0.1440,1.0327>,Teapot_Sphere_Radius}
sphere {<-1.9896,-0.1440,0.8688>,Teapot_Sphere_Radius}
sphere {<-2.7046,-0.1440,1.6305>,Teapot_Sphere_Radius}
sphere {<-2.7312,-0.1440,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.8056,-0.2160,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.7746,-0.2160,1.6040>,Teapot_Sphere_Radius}
sphere {<-2.6216,-0.1440,1.4331>,Teapot_Sphere_Radius}
sphere {<-2.7046,-0.1440,1.6305>,Teapot_Sphere_Radius}
sphere {<-2.7746,-0.2160,1.6040>,Teapot_Sphere_Radius}
sphere {<-2.6790,-0.2160,1.3908>,Teapot_Sphere_Radius}
sphere {<-2.4779,-0.1440,1.2273>,Teapot_Sphere_Radius}
sphere {<-2.6216,-0.1440,1.4331>,Teapot_Sphere_Radius}
sphere {<-2.6790,-0.2160,1.3908>,Teapot_Sphere_Radius}
sphere {<-2.5148,-0.2160,1.1751>,Teapot_Sphere_Radius}
sphere {<-2.2687,-0.1440,1.0327>,Teapot_Sphere_Radius}
sphere {<-2.4779,-0.1440,1.2273>,Teapot_Sphere_Radius}
sphere {<-2.5148,-0.2160,1.1751>,Teapot_Sphere_Radius}
sphere {<-2.2780,-0.2160,0.9714>,Teapot_Sphere_Radius}
sphere {<-1.9896,-0.1440,0.8688>,Teapot_Sphere_Radius}
sphere {<-2.2687,-0.1440,1.0327>,Teapot_Sphere_Radius}
sphere {<-2.2780,-0.2160,0.9714>,Teapot_Sphere_Radius}
sphere {<-1.9648,-0.2160,0.7944>,Teapot_Sphere_Radius}
sphere {<-2.7746,-0.2160,1.6040>,Teapot_Sphere_Radius}
sphere {<-2.8056,-0.2160,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.8944,-0.2160,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.8582,-0.2160,1.5724>,Teapot_Sphere_Radius}
sphere {<-2.6790,-0.2160,1.3908>,Teapot_Sphere_Radius}
sphere {<-2.7746,-0.2160,1.6040>,Teapot_Sphere_Radius}
sphere {<-2.8582,-0.2160,1.5724>,Teapot_Sphere_Radius}
sphere {<-2.7474,-0.2160,1.3404>,Teapot_Sphere_Radius}
sphere {<-2.5148,-0.2160,1.1751>,Teapot_Sphere_Radius}
sphere {<-2.6790,-0.2160,1.3908>,Teapot_Sphere_Radius}
sphere {<-2.7474,-0.2160,1.3404>,Teapot_Sphere_Radius}
sphere {<-2.5588,-0.2160,1.1127>,Teapot_Sphere_Radius}
sphere {<-2.2780,-0.2160,0.9714>,Teapot_Sphere_Radius}
sphere {<-2.5148,-0.2160,1.1751>,Teapot_Sphere_Radius}
sphere {<-2.5588,-0.2160,1.1127>,Teapot_Sphere_Radius}
sphere {<-2.2892,-0.2160,0.8982>,Teapot_Sphere_Radius}
sphere {<-1.9648,-0.2160,0.7944>,Teapot_Sphere_Radius}
sphere {<-2.2780,-0.2160,0.9714>,Teapot_Sphere_Radius}
sphere {<-2.2892,-0.2160,0.8982>,Teapot_Sphere_Radius}
sphere {<-1.9352,-0.2160,0.7056>,Teapot_Sphere_Radius}
sphere {<-2.8582,-0.2160,1.5724>,Teapot_Sphere_Radius}
sphere {<-2.8944,-0.2160,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.9688,-0.1440,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.9282,-0.1440,1.5459>,Teapot_Sphere_Radius}
sphere {<-2.7474,-0.2160,1.3404>,Teapot_Sphere_Radius}
sphere {<-2.8582,-0.2160,1.5724>,Teapot_Sphere_Radius}
sphere {<-2.9282,-0.1440,1.5459>,Teapot_Sphere_Radius}
sphere {<-2.8048,-0.1440,1.2981>,Teapot_Sphere_Radius}
sphere {<-2.5588,-0.2160,1.1127>,Teapot_Sphere_Radius}
sphere {<-2.7474,-0.2160,1.3404>,Teapot_Sphere_Radius}
sphere {<-2.8048,-0.1440,1.2981>,Teapot_Sphere_Radius}
sphere {<-2.5957,-0.1440,1.0605>,Teapot_Sphere_Radius}
sphere {<-2.2892,-0.2160,0.8982>,Teapot_Sphere_Radius}
sphere {<-2.5588,-0.2160,1.1127>,Teapot_Sphere_Radius}
sphere {<-2.5957,-0.1440,1.0605>,Teapot_Sphere_Radius}
sphere {<-2.2985,-0.1440,0.8369>,Teapot_Sphere_Radius}
sphere {<-1.9352,-0.2160,0.7056>,Teapot_Sphere_Radius}
sphere {<-2.2892,-0.2160,0.8982>,Teapot_Sphere_Radius}
sphere {<-2.2985,-0.1440,0.8369>,Teapot_Sphere_Radius}
sphere {<-1.9104,-0.1440,0.6312>,Teapot_Sphere_Radius}
sphere {<-2.9282,-0.1440,1.5459>,Teapot_Sphere_Radius}
sphere {<-2.9688,-0.1440,1.8000>,Teapot_Sphere_Radius}
sphere {<-3.0000,0.0000,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.9576,0.0000,1.5348>,Teapot_Sphere_Radius}
sphere {<-2.8048,-0.1440,1.2981>,Teapot_Sphere_Radius}
sphere {<-2.9282,-0.1440,1.5459>,Teapot_Sphere_Radius}
sphere {<-2.9576,0.0000,1.5348>,Teapot_Sphere_Radius}
sphere {<-2.8288,0.0000,1.2804>,Teapot_Sphere_Radius}
sphere {<-2.5957,-0.1440,1.0605>,Teapot_Sphere_Radius}
sphere {<-2.8048,-0.1440,1.2981>,Teapot_Sphere_Radius}
sphere {<-2.8288,0.0000,1.2804>,Teapot_Sphere_Radius}
sphere {<-2.6112,0.0000,1.0386>,Teapot_Sphere_Radius}
sphere {<-2.2985,-0.1440,0.8369>,Teapot_Sphere_Radius}
sphere {<-2.5957,-0.1440,1.0605>,Teapot_Sphere_Radius}
sphere {<-2.6112,0.0000,1.0386>,Teapot_Sphere_Radius}
sphere {<-2.3024,0.0000,0.8112>,Teapot_Sphere_Radius}
sphere {<-1.9104,-0.1440,0.6312>,Teapot_Sphere_Radius}
sphere {<-2.2985,-0.1440,0.8369>,Teapot_Sphere_Radius}
sphere {<-2.3024,0.0000,0.8112>,Teapot_Sphere_Radius}
sphere {<-1.9000,0.0000,0.6000>,Teapot_Sphere_Radius}
sphere {<-2.9576,0.0000,1.5348>,Teapot_Sphere_Radius}
sphere {<-3.0000,0.0000,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.9688,0.1440,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.9282,0.1440,1.5459>,Teapot_Sphere_Radius}
sphere {<-2.8288,0.0000,1.2804>,Teapot_Sphere_Radius}
sphere {<-2.9576,0.0000,1.5348>,Teapot_Sphere_Radius}
sphere {<-2.9282,0.1440,1.5459>,Teapot_Sphere_Radius}
sphere {<-2.8048,0.1440,1.2981>,Teapot_Sphere_Radius}
sphere {<-2.6112,0.0000,1.0386>,Teapot_Sphere_Radius}
sphere {<-2.8288,0.0000,1.2804>,Teapot_Sphere_Radius}
sphere {<-2.8048,0.1440,1.2981>,Teapot_Sphere_Radius}
sphere {<-2.5957,0.1440,1.0605>,Teapot_Sphere_Radius}
sphere {<-2.3024,0.0000,0.8112>,Teapot_Sphere_Radius}
sphere {<-2.6112,0.0000,1.0386>,Teapot_Sphere_Radius}
sphere {<-2.5957,0.1440,1.0605>,Teapot_Sphere_Radius}
sphere {<-2.2985,0.1440,0.8369>,Teapot_Sphere_Radius}
sphere {<-1.9000,0.0000,0.6000>,Teapot_Sphere_Radius}
sphere {<-2.3024,0.0000,0.8112>,Teapot_Sphere_Radius}
sphere {<-2.2985,0.1440,0.8369>,Teapot_Sphere_Radius}
sphere {<-1.9104,0.1440,0.6312>,Teapot_Sphere_Radius}
sphere {<-2.9282,0.1440,1.5459>,Teapot_Sphere_Radius}
sphere {<-2.9688,0.1440,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.8944,0.2160,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.8582,0.2160,1.5724>,Teapot_Sphere_Radius}
sphere {<-2.8048,0.1440,1.2981>,Teapot_Sphere_Radius}
sphere {<-2.9282,0.1440,1.5459>,Teapot_Sphere_Radius}
sphere {<-2.8582,0.2160,1.5724>,Teapot_Sphere_Radius}
sphere {<-2.7474,0.2160,1.3404>,Teapot_Sphere_Radius}
sphere {<-2.5957,0.1440,1.0605>,Teapot_Sphere_Radius}
sphere {<-2.8048,0.1440,1.2981>,Teapot_Sphere_Radius}
sphere {<-2.7474,0.2160,1.3404>,Teapot_Sphere_Radius}
sphere {<-2.5588,0.2160,1.1127>,Teapot_Sphere_Radius}
sphere {<-2.2985,0.1440,0.8369>,Teapot_Sphere_Radius}
sphere {<-2.5957,0.1440,1.0605>,Teapot_Sphere_Radius}
sphere {<-2.5588,0.2160,1.1127>,Teapot_Sphere_Radius}
sphere {<-2.2892,0.2160,0.8982>,Teapot_Sphere_Radius}
sphere {<-1.9104,0.1440,0.6312>,Teapot_Sphere_Radius}
sphere {<-2.2985,0.1440,0.8369>,Teapot_Sphere_Radius}
sphere {<-2.2892,0.2160,0.8982>,Teapot_Sphere_Radius}
sphere {<-1.9352,0.2160,0.7056>,Teapot_Sphere_Radius}
sphere {<-2.8582,0.2160,1.5724>,Teapot_Sphere_Radius}
sphere {<-2.8944,0.2160,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.8056,0.2160,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.7746,0.2160,1.6040>,Teapot_Sphere_Radius}
sphere {<-2.7474,0.2160,1.3404>,Teapot_Sphere_Radius}
sphere {<-2.8582,0.2160,1.5724>,Teapot_Sphere_Radius}
sphere {<-2.7746,0.2160,1.6040>,Teapot_Sphere_Radius}
sphere {<-2.6790,0.2160,1.3908>,Teapot_Sphere_Radius}
sphere {<-2.5588,0.2160,1.1127>,Teapot_Sphere_Radius}
sphere {<-2.7474,0.2160,1.3404>,Teapot_Sphere_Radius}
sphere {<-2.6790,0.2160,1.3908>,Teapot_Sphere_Radius}
sphere {<-2.5148,0.2160,1.1751>,Teapot_Sphere_Radius}
sphere {<-2.2892,0.2160,0.8982>,Teapot_Sphere_Radius}
sphere {<-2.5588,0.2160,1.1127>,Teapot_Sphere_Radius}
sphere {<-2.5148,0.2160,1.1751>,Teapot_Sphere_Radius}
sphere {<-2.2780,0.2160,0.9714>,Teapot_Sphere_Radius}
sphere {<-1.9352,0.2160,0.7056>,Teapot_Sphere_Radius}
sphere {<-2.2892,0.2160,0.8982>,Teapot_Sphere_Radius}
sphere {<-2.2780,0.2160,0.9714>,Teapot_Sphere_Radius}
sphere {<-1.9648,0.2160,0.7944>,Teapot_Sphere_Radius}
sphere {<-2.7746,0.2160,1.6040>,Teapot_Sphere_Radius}
sphere {<-2.8056,0.2160,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.7312,0.1440,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.7046,0.1440,1.6305>,Teapot_Sphere_Radius}
sphere {<-2.6790,0.2160,1.3908>,Teapot_Sphere_Radius}
sphere {<-2.7746,0.2160,1.6040>,Teapot_Sphere_Radius}
sphere {<-2.7046,0.1440,1.6305>,Teapot_Sphere_Radius}
sphere {<-2.6216,0.1440,1.4331>,Teapot_Sphere_Radius}
sphere {<-2.5148,0.2160,1.1751>,Teapot_Sphere_Radius}
sphere {<-2.6790,0.2160,1.3908>,Teapot_Sphere_Radius}
sphere {<-2.6216,0.1440,1.4331>,Teapot_Sphere_Radius}
sphere {<-2.4779,0.1440,1.2273>,Teapot_Sphere_Radius}
sphere {<-2.2780,0.2160,0.9714>,Teapot_Sphere_Radius}
sphere {<-2.5148,0.2160,1.1751>,Teapot_Sphere_Radius}
sphere {<-2.4779,0.1440,1.2273>,Teapot_Sphere_Radius}
sphere {<-2.2687,0.1440,1.0327>,Teapot_Sphere_Radius}
sphere {<-1.9648,0.2160,0.7944>,Teapot_Sphere_Radius}
sphere {<-2.2780,0.2160,0.9714>,Teapot_Sphere_Radius}
sphere {<-2.2687,0.1440,1.0327>,Teapot_Sphere_Radius}
sphere {<-1.9896,0.1440,0.8688>,Teapot_Sphere_Radius}
sphere {<-2.7046,0.1440,1.6305>,Teapot_Sphere_Radius}
sphere {<-2.7312,0.1440,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.7000,0.0000,1.8000>,Teapot_Sphere_Radius}
sphere {<-2.6752,0.0000,1.6416>,Teapot_Sphere_Radius}
sphere {<-2.6216,0.1440,1.4331>,Teapot_Sphere_Radius}
sphere {<-2.7046,0.1440,1.6305>,Teapot_Sphere_Radius}
sphere {<-2.6752,0.0000,1.6416>,Teapot_Sphere_Radius}
sphere {<-2.5976,0.0000,1.4508>,Teapot_Sphere_Radius}
sphere {<-2.4779,0.1440,1.2273>,Teapot_Sphere_Radius}
sphere {<-2.6216,0.1440,1.4331>,Teapot_Sphere_Radius}
sphere {<-2.5976,0.0000,1.4508>,Teapot_Sphere_Radius}
sphere {<-2.4624,0.0000,1.2492>,Teapot_Sphere_Radius}
sphere {<-2.2687,0.1440,1.0327>,Teapot_Sphere_Radius}
sphere {<-2.4779,0.1440,1.2273>,Teapot_Sphere_Radius}
sphere {<-2.4624,0.0000,1.2492>,Teapot_Sphere_Radius}
sphere {<-2.2648,0.0000,1.0584>,Teapot_Sphere_Radius}
sphere {<-1.9896,0.1440,0.8688>,Teapot_Sphere_Radius}
sphere {<-2.2687,0.1440,1.0327>,Teapot_Sphere_Radius}
sphere {<-2.2648,0.0000,1.0584>,Teapot_Sphere_Radius}
sphere {<-2.0000,0.0000,0.9000>,Teapot_Sphere_Radius}
sphere {<2.1112,0.0000,1.4976>,Teapot_Sphere_Radius}
sphere {<1.7000,0.0000,1.4250>,Teapot_Sphere_Radius}
sphere {<1.7000,-0.3168,1.3392>,Teapot_Sphere_Radius}
sphere {<2.1327,-0.2963,1.4290>,Teapot_Sphere_Radius}
sphere {<2.3256,0.0000,1.6818>,Teapot_Sphere_Radius}
sphere {<2.1112,0.0000,1.4976>,Teapot_Sphere_Radius}
sphere {<2.1327,-0.2963,1.4290>,Teapot_Sphere_Radius}
sphere {<2.3551,-0.2475,1.6341>,Teapot_Sphere_Radius}
sphere {<2.4344,0.0000,1.9272>,Teapot_Sphere_Radius}
sphere {<2.3256,0.0000,1.6818>,Teapot_Sphere_Radius}
sphere {<2.3551,-0.2475,1.6341>,Teapot_Sphere_Radius}
sphere {<2.4673,-0.1893,1.9004>,Teapot_Sphere_Radius}
sphere {<2.5288,0.0000,2.1834>,Teapot_Sphere_Radius}
sphere {<2.4344,0.0000,1.9272>,Teapot_Sphere_Radius}
sphere {<2.4673,-0.1893,1.9004>,Teapot_Sphere_Radius}
sphere {<2.5697,-0.1405,2.1737>,Teapot_Sphere_Radius}
sphere {<2.7000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<2.5288,0.0000,2.1834>,Teapot_Sphere_Radius}
sphere {<2.5697,-0.1405,2.1737>,Teapot_Sphere_Radius}
sphere {<2.7624,-0.1200,2.4000>,Teapot_Sphere_Radius}
sphere {<2.1327,-0.2963,1.4290>,Teapot_Sphere_Radius}
sphere {<1.7000,-0.3168,1.3392>,Teapot_Sphere_Radius}
sphere {<1.7000,-0.4752,1.1346>,Teapot_Sphere_Radius}
sphere {<2.1839,-0.4445,1.2653>,Teapot_Sphere_Radius}
sphere {<2.3551,-0.2475,1.6341>,Teapot_Sphere_Radius}
sphere {<2.1327,-0.2963,1.4290>,Teapot_Sphere_Radius}
sphere {<2.1839,-0.4445,1.2653>,Teapot_Sphere_Radius}
sphere {<2.4253,-0.3713,1.5202>,Teapot_Sphere_Radius}
sphere {<2.4673,-0.1893,1.9004>,Teapot_Sphere_Radius}
sphere {<2.3551,-0.2475,1.6341>,Teapot_Sphere_Radius}
sphere {<2.4253,-0.3713,1.5202>,Teapot_Sphere_Radius}
sphere {<2.5459,-0.2839,1.8364>,Teapot_Sphere_Radius}
sphere {<2.5697,-0.1405,2.1737>,Teapot_Sphere_Radius}
sphere {<2.4673,-0.1893,1.9004>,Teapot_Sphere_Radius}
sphere {<2.5459,-0.2839,1.8364>,Teapot_Sphere_Radius}
sphere {<2.6673,-0.2107,2.1507>,Teapot_Sphere_Radius}
sphere {<2.7624,-0.1200,2.4000>,Teapot_Sphere_Radius}
sphere {<2.5697,-0.1405,2.1737>,Teapot_Sphere_Radius}
sphere {<2.6673,-0.2107,2.1507>,Teapot_Sphere_Radius}
sphere {<2.9112,-0.1800,2.4000>,Teapot_Sphere_Radius}
sphere {<2.1839,-0.4445,1.2653>,Teapot_Sphere_Radius}
sphere {<1.7000,-0.4752,1.1346>,Teapot_Sphere_Radius}
sphere {<1.7000,-0.4752,0.8904>,Teapot_Sphere_Radius}
sphere {<2.2449,-0.4445,1.0699>,Teapot_Sphere_Radius}
sphere {<2.4253,-0.3713,1.5202>,Teapot_Sphere_Radius}
sphere {<2.1839,-0.4445,1.2653>,Teapot_Sphere_Radius}
sphere {<2.2449,-0.4445,1.0699>,Teapot_Sphere_Radius}
sphere {<2.5091,-0.3713,1.3844>,Teapot_Sphere_Radius}
sphere {<2.5459,-0.2839,1.8364>,Teapot_Sphere_Radius}
sphere {<2.4253,-0.3713,1.5202>,Teapot_Sphere_Radius}
sphere {<2.5091,-0.3713,1.3844>,Teapot_Sphere_Radius}
sphere {<2.6397,-0.2839,1.7600>,Teapot_Sphere_Radius}
sphere {<2.6673,-0.2107,2.1507>,Teapot_Sphere_Radius}
sphere {<2.5459,-0.2839,1.8364>,Teapot_Sphere_Radius}
sphere {<2.6397,-0.2839,1.7600>,Teapot_Sphere_Radius}
sphere {<2.7839,-0.2107,2.1231>,Teapot_Sphere_Radius}
sphere {<2.9112,-0.1800,2.4000>,Teapot_Sphere_Radius}
sphere {<2.6673,-0.2107,2.1507>,Teapot_Sphere_Radius}
sphere {<2.7839,-0.2107,2.1231>,Teapot_Sphere_Radius}
sphere {<3.0888,-0.1800,2.4000>,Teapot_Sphere_Radius}
sphere {<2.2449,-0.4445,1.0699>,Teapot_Sphere_Radius}
sphere {<1.7000,-0.4752,0.8904>,Teapot_Sphere_Radius}
sphere {<1.7000,-0.3168,0.6858>,Teapot_Sphere_Radius}
sphere {<2.2961,-0.2963,0.9062>,Teapot_Sphere_Radius}
sphere {<2.5091,-0.3713,1.3844>,Teapot_Sphere_Radius}
sphere {<2.2449,-0.4445,1.0699>,Teapot_Sphere_Radius}
sphere {<2.2961,-0.2963,0.9062>,Teapot_Sphere_Radius}
sphere {<2.5793,-0.2475,1.2705>,Teapot_Sphere_Radius}
sphere {<2.6397,-0.2839,1.7600>,Teapot_Sphere_Radius}
sphere {<2.5091,-0.3713,1.3844>,Teapot_Sphere_Radius}
sphere {<2.5793,-0.2475,1.2705>,Teapot_Sphere_Radius}
sphere {<2.7183,-0.1893,1.6960>,Teapot_Sphere_Radius}
sphere {<2.7839,-0.2107,2.1231>,Teapot_Sphere_Radius}
sphere {<2.6397,-0.2839,1.7600>,Teapot_Sphere_Radius}
sphere {<2.7183,-0.1893,1.6960>,Teapot_Sphere_Radius}
sphere {<2.8815,-0.1405,2.1001>,Teapot_Sphere_Radius}
sphere {<3.0888,-0.1800,2.4000>,Teapot_Sphere_Radius}
sphere {<2.7839,-0.2107,2.1231>,Teapot_Sphere_Radius}
sphere {<2.8815,-0.1405,2.1001>,Teapot_Sphere_Radius}
sphere {<3.2376,-0.1200,2.4000>,Teapot_Sphere_Radius}
sphere {<2.2961,-0.2963,0.9062>,Teapot_Sphere_Radius}
sphere {<1.7000,-0.3168,0.6858>,Teapot_Sphere_Radius}
sphere {<1.7000,0.0000,0.6000>,Teapot_Sphere_Radius}
sphere {<2.3176,0.0000,0.8376>,Teapot_Sphere_Radius}
sphere {<2.5793,-0.2475,1.2705>,Teapot_Sphere_Radius}
sphere {<2.2961,-0.2963,0.9062>,Teapot_Sphere_Radius}
sphere {<2.3176,0.0000,0.8376>,Teapot_Sphere_Radius}
sphere {<2.6088,0.0000,1.2228>,Teapot_Sphere_Radius}
sphere {<2.7183,-0.1893,1.6960>,Teapot_Sphere_Radius}
sphere {<2.5793,-0.2475,1.2705>,Teapot_Sphere_Radius}
sphere {<2.6088,0.0000,1.2228>,Teapot_Sphere_Radius}
sphere {<2.7512,0.0000,1.6692>,Teapot_Sphere_Radius}
sphere {<2.8815,-0.1405,2.1001>,Teapot_Sphere_Radius}
sphere {<2.7183,-0.1893,1.6960>,Teapot_Sphere_Radius}
sphere {<2.7512,0.0000,1.6692>,Teapot_Sphere_Radius}
sphere {<2.9224,0.0000,2.0904>,Teapot_Sphere_Radius}
sphere {<3.2376,-0.1200,2.4000>,Teapot_Sphere_Radius}
sphere {<2.8815,-0.1405,2.1001>,Teapot_Sphere_Radius}
sphere {<2.9224,0.0000,2.0904>,Teapot_Sphere_Radius}
sphere {<3.3000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<2.3176,0.0000,0.8376>,Teapot_Sphere_Radius}
sphere {<1.7000,0.0000,0.6000>,Teapot_Sphere_Radius}
sphere {<1.7000,0.3168,0.6858>,Teapot_Sphere_Radius}
sphere {<2.2961,0.2963,0.9062>,Teapot_Sphere_Radius}
sphere {<2.6088,0.0000,1.2228>,Teapot_Sphere_Radius}
sphere {<2.3176,0.0000,0.8376>,Teapot_Sphere_Radius}
sphere {<2.2961,0.2963,0.9062>,Teapot_Sphere_Radius}
sphere {<2.5793,0.2475,1.2705>,Teapot_Sphere_Radius}
sphere {<2.7512,0.0000,1.6692>,Teapot_Sphere_Radius}
sphere {<2.6088,0.0000,1.2228>,Teapot_Sphere_Radius}
sphere {<2.5793,0.2475,1.2705>,Teapot_Sphere_Radius}
sphere {<2.7183,0.1893,1.6960>,Teapot_Sphere_Radius}
sphere {<2.9224,0.0000,2.0904>,Teapot_Sphere_Radius}
sphere {<2.7512,0.0000,1.6692>,Teapot_Sphere_Radius}
sphere {<2.7183,0.1893,1.6960>,Teapot_Sphere_Radius}
sphere {<2.8815,0.1405,2.1001>,Teapot_Sphere_Radius}
sphere {<3.3000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<2.9224,0.0000,2.0904>,Teapot_Sphere_Radius}
sphere {<2.8815,0.1405,2.1001>,Teapot_Sphere_Radius}
sphere {<3.2376,0.1200,2.4000>,Teapot_Sphere_Radius}
sphere {<2.2961,0.2963,0.9062>,Teapot_Sphere_Radius}
sphere {<1.7000,0.3168,0.6858>,Teapot_Sphere_Radius}
sphere {<1.7000,0.4752,0.8904>,Teapot_Sphere_Radius}
sphere {<2.2449,0.4445,1.0699>,Teapot_Sphere_Radius}
sphere {<2.5793,0.2475,1.2705>,Teapot_Sphere_Radius}
sphere {<2.2961,0.2963,0.9062>,Teapot_Sphere_Radius}
sphere {<2.2449,0.4445,1.0699>,Teapot_Sphere_Radius}
sphere {<2.5091,0.3713,1.3844>,Teapot_Sphere_Radius}
sphere {<2.7183,0.1893,1.6960>,Teapot_Sphere_Radius}
sphere {<2.5793,0.2475,1.2705>,Teapot_Sphere_Radius}
sphere {<2.5091,0.3713,1.3844>,Teapot_Sphere_Radius}
sphere {<2.6397,0.2839,1.7600>,Teapot_Sphere_Radius}
sphere {<2.8815,0.1405,2.1001>,Teapot_Sphere_Radius}
sphere {<2.7183,0.1893,1.6960>,Teapot_Sphere_Radius}
sphere {<2.6397,0.2839,1.7600>,Teapot_Sphere_Radius}
sphere {<2.7839,0.2107,2.1231>,Teapot_Sphere_Radius}
sphere {<3.2376,0.1200,2.4000>,Teapot_Sphere_Radius}
sphere {<2.8815,0.1405,2.1001>,Teapot_Sphere_Radius}
sphere {<2.7839,0.2107,2.1231>,Teapot_Sphere_Radius}
sphere {<3.0888,0.1800,2.4000>,Teapot_Sphere_Radius}
sphere {<2.2449,0.4445,1.0699>,Teapot_Sphere_Radius}
sphere {<1.7000,0.4752,0.8904>,Teapot_Sphere_Radius}
sphere {<1.7000,0.4752,1.1346>,Teapot_Sphere_Radius}
sphere {<2.1839,0.4445,1.2653>,Teapot_Sphere_Radius}
sphere {<2.5091,0.3713,1.3844>,Teapot_Sphere_Radius}
sphere {<2.2449,0.4445,1.0699>,Teapot_Sphere_Radius}
sphere {<2.1839,0.4445,1.2653>,Teapot_Sphere_Radius}
sphere {<2.4253,0.3713,1.5202>,Teapot_Sphere_Radius}
sphere {<2.6397,0.2839,1.7600>,Teapot_Sphere_Radius}
sphere {<2.5091,0.3713,1.3844>,Teapot_Sphere_Radius}
sphere {<2.4253,0.3713,1.5202>,Teapot_Sphere_Radius}
sphere {<2.5459,0.2839,1.8364>,Teapot_Sphere_Radius}
sphere {<2.7839,0.2107,2.1231>,Teapot_Sphere_Radius}
sphere {<2.6397,0.2839,1.7600>,Teapot_Sphere_Radius}
sphere {<2.5459,0.2839,1.8364>,Teapot_Sphere_Radius}
sphere {<2.6673,0.2107,2.1507>,Teapot_Sphere_Radius}
sphere {<3.0888,0.1800,2.4000>,Teapot_Sphere_Radius}
sphere {<2.7839,0.2107,2.1231>,Teapot_Sphere_Radius}
sphere {<2.6673,0.2107,2.1507>,Teapot_Sphere_Radius}
sphere {<2.9112,0.1800,2.4000>,Teapot_Sphere_Radius}
sphere {<2.1839,0.4445,1.2653>,Teapot_Sphere_Radius}
sphere {<1.7000,0.4752,1.1346>,Teapot_Sphere_Radius}
sphere {<1.7000,0.3168,1.3392>,Teapot_Sphere_Radius}
sphere {<2.1327,0.2963,1.4290>,Teapot_Sphere_Radius}
sphere {<2.4253,0.3713,1.5202>,Teapot_Sphere_Radius}
sphere {<2.1839,0.4445,1.2653>,Teapot_Sphere_Radius}
sphere {<2.1327,0.2963,1.4290>,Teapot_Sphere_Radius}
sphere {<2.3551,0.2475,1.6341>,Teapot_Sphere_Radius}
sphere {<2.5459,0.2839,1.8364>,Teapot_Sphere_Radius}
sphere {<2.4253,0.3713,1.5202>,Teapot_Sphere_Radius}
sphere {<2.3551,0.2475,1.6341>,Teapot_Sphere_Radius}
sphere {<2.4673,0.1893,1.9004>,Teapot_Sphere_Radius}
sphere {<2.6673,0.2107,2.1507>,Teapot_Sphere_Radius}
sphere {<2.5459,0.2839,1.8364>,Teapot_Sphere_Radius}
sphere {<2.4673,0.1893,1.9004>,Teapot_Sphere_Radius}
sphere {<2.5697,0.1405,2.1737>,Teapot_Sphere_Radius}
sphere {<2.9112,0.1800,2.4000>,Teapot_Sphere_Radius}
sphere {<2.6673,0.2107,2.1507>,Teapot_Sphere_Radius}
sphere {<2.5697,0.1405,2.1737>,Teapot_Sphere_Radius}
sphere {<2.7624,0.1200,2.4000>,Teapot_Sphere_Radius}
sphere {<2.1327,0.2963,1.4290>,Teapot_Sphere_Radius}
sphere {<1.7000,0.3168,1.3392>,Teapot_Sphere_Radius}
sphere {<1.7000,0.0000,1.4250>,Teapot_Sphere_Radius}
sphere {<2.1112,0.0000,1.4976>,Teapot_Sphere_Radius}
sphere {<2.3551,0.2475,1.6341>,Teapot_Sphere_Radius}
sphere {<2.1327,0.2963,1.4290>,Teapot_Sphere_Radius}
sphere {<2.1112,0.0000,1.4976>,Teapot_Sphere_Radius}
sphere {<2.3256,0.0000,1.6818>,Teapot_Sphere_Radius}
sphere {<2.4673,0.1893,1.9004>,Teapot_Sphere_Radius}
sphere {<2.3551,0.2475,1.6341>,Teapot_Sphere_Radius}
sphere {<2.3256,0.0000,1.6818>,Teapot_Sphere_Radius}
sphere {<2.4344,0.0000,1.9272>,Teapot_Sphere_Radius}
sphere {<2.5697,0.1405,2.1737>,Teapot_Sphere_Radius}
sphere {<2.4673,0.1893,1.9004>,Teapot_Sphere_Radius}
sphere {<2.4344,0.0000,1.9272>,Teapot_Sphere_Radius}
sphere {<2.5288,0.0000,2.1834>,Teapot_Sphere_Radius}
sphere {<2.7624,0.1200,2.4000>,Teapot_Sphere_Radius}
sphere {<2.5697,0.1405,2.1737>,Teapot_Sphere_Radius}
sphere {<2.5288,0.0000,2.1834>,Teapot_Sphere_Radius}
sphere {<2.7000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<2.7584,0.0000,2.4360>,Teapot_Sphere_Radius}
sphere {<2.7000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<2.7624,-0.1200,2.4000>,Teapot_Sphere_Radius}
sphere {<2.8251,-0.1150,2.4371>,Teapot_Sphere_Radius}
sphere {<2.8072,0.0000,2.4540>,Teapot_Sphere_Radius}
sphere {<2.7584,0.0000,2.4360>,Teapot_Sphere_Radius}
sphere {<2.8251,-0.1150,2.4371>,Teapot_Sphere_Radius}
sphere {<2.8724,-0.1031,2.4560>,Teapot_Sphere_Radius}
sphere {<2.8368,0.0000,2.4540>,Teapot_Sphere_Radius}
sphere {<2.8072,0.0000,2.4540>,Teapot_Sphere_Radius}
sphere {<2.8724,-0.1031,2.4560>,Teapot_Sphere_Radius}
sphere {<2.8962,-0.0889,2.4562>,Teapot_Sphere_Radius}
sphere {<2.8376,0.0000,2.4360>,Teapot_Sphere_Radius}
sphere {<2.8368,0.0000,2.4540>,Teapot_Sphere_Radius}
sphere {<2.8962,-0.0889,2.4562>,Teapot_Sphere_Radius}
sphere {<2.8886,-0.0770,2.4377>,Teapot_Sphere_Radius}
sphere {<2.8000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<2.8376,0.0000,2.4360>,Teapot_Sphere_Radius}
sphere {<2.8886,-0.0770,2.4377>,Teapot_Sphere_Radius}
sphere {<2.8416,-0.0720,2.4000>,Teapot_Sphere_Radius}
sphere {<2.8251,-0.1150,2.4371>,Teapot_Sphere_Radius}
sphere {<2.7624,-0.1200,2.4000>,Teapot_Sphere_Radius}
sphere {<2.9112,-0.1800,2.4000>,Teapot_Sphere_Radius}
sphere {<2.9842,-0.1725,2.4398>,Teapot_Sphere_Radius}
sphere {<2.8724,-0.1031,2.4560>,Teapot_Sphere_Radius}
sphere {<2.8251,-0.1150,2.4371>,Teapot_Sphere_Radius}
sphere {<2.9842,-0.1725,2.4398>,Teapot_Sphere_Radius}
sphere {<3.0278,-0.1547,2.4607>,Teapot_Sphere_Radius}
sphere {<2.8962,-0.0889,2.4562>,Teapot_Sphere_Radius}
sphere {<2.8724,-0.1031,2.4560>,Teapot_Sphere_Radius}
sphere {<3.0278,-0.1547,2.4607>,Teapot_Sphere_Radius}
sphere {<3.0379,-0.1333,2.4616>,Teapot_Sphere_Radius}
sphere {<2.8886,-0.0770,2.4377>,Teapot_Sphere_Radius}
sphere {<2.8962,-0.0889,2.4562>,Teapot_Sphere_Radius}
sphere {<3.0379,-0.1333,2.4616>,Teapot_Sphere_Radius}
sphere {<3.0102,-0.1155,2.4417>,Teapot_Sphere_Radius}
sphere {<2.8416,-0.0720,2.4000>,Teapot_Sphere_Radius}
sphere {<2.8886,-0.0770,2.4377>,Teapot_Sphere_Radius}
sphere {<3.0102,-0.1155,2.4417>,Teapot_Sphere_Radius}
sphere {<2.9408,-0.1080,2.4000>,Teapot_Sphere_Radius}
sphere {<2.9842,-0.1725,2.4398>,Teapot_Sphere_Radius}
sphere {<2.9112,-0.1800,2.4000>,Teapot_Sphere_Radius}
sphere {<3.0888,-0.1800,2.4000>,Teapot_Sphere_Radius}
sphere {<3.1742,-0.1725,2.4430>,Teapot_Sphere_Radius}
sphere {<3.0278,-0.1547,2.4607>,Teapot_Sphere_Radius}
sphere {<2.9842,-0.1725,2.4398>,Teapot_Sphere_Radius}
sphere {<3.1742,-0.1725,2.4430>,Teapot_Sphere_Radius}
sphere {<3.2134,-0.1547,2.4662>,Teapot_Sphere_Radius}
sphere {<3.0379,-0.1333,2.4616>,Teapot_Sphere_Radius}
sphere {<3.0278,-0.1547,2.4607>,Teapot_Sphere_Radius}
sphere {<3.2134,-0.1547,2.4662>,Teapot_Sphere_Radius}
sphere {<3.2069,-0.1333,2.4680>,Teapot_Sphere_Radius}
sphere {<3.0102,-0.1155,2.4417>,Teapot_Sphere_Radius}
sphere {<3.0379,-0.1333,2.4616>,Teapot_Sphere_Radius}
sphere {<3.2069,-0.1333,2.4680>,Teapot_Sphere_Radius}
sphere {<3.1554,-0.1155,2.4465>,Teapot_Sphere_Radius}
sphere {<2.9408,-0.1080,2.4000>,Teapot_Sphere_Radius}
sphere {<3.0102,-0.1155,2.4417>,Teapot_Sphere_Radius}
sphere {<3.1554,-0.1155,2.4465>,Teapot_Sphere_Radius}
sphere {<3.0592,-0.1080,2.4000>,Teapot_Sphere_Radius}
sphere {<3.1742,-0.1725,2.4430>,Teapot_Sphere_Radius}
sphere {<3.0888,-0.1800,2.4000>,Teapot_Sphere_Radius}
sphere {<3.2376,-0.1200,2.4000>,Teapot_Sphere_Radius}
sphere {<3.3333,-0.1150,2.4457>,Teapot_Sphere_Radius}
sphere {<3.2134,-0.1547,2.4662>,Teapot_Sphere_Radius}
sphere {<3.1742,-0.1725,2.4430>,Teapot_Sphere_Radius}
sphere {<3.3333,-0.1150,2.4457>,Teapot_Sphere_Radius}
sphere {<3.3688,-0.1031,2.4709>,Teapot_Sphere_Radius}
sphere {<3.2069,-0.1333,2.4680>,Teapot_Sphere_Radius}
sphere {<3.2134,-0.1547,2.4662>,Teapot_Sphere_Radius}
sphere {<3.3688,-0.1031,2.4709>,Teapot_Sphere_Radius}
sphere {<3.3486,-0.0889,2.4734>,Teapot_Sphere_Radius}
sphere {<3.1554,-0.1155,2.4465>,Teapot_Sphere_Radius}
sphere {<3.2069,-0.1333,2.4680>,Teapot_Sphere_Radius}
sphere {<3.3486,-0.0889,2.4734>,Teapot_Sphere_Radius}
sphere {<3.2770,-0.0770,2.4505>,Teapot_Sphere_Radius}
sphere {<3.0592,-0.1080,2.4000>,Teapot_Sphere_Radius}
sphere {<3.1554,-0.1155,2.4465>,Teapot_Sphere_Radius}
sphere {<3.2770,-0.0770,2.4505>,Teapot_Sphere_Radius}
sphere {<3.1584,-0.0720,2.4000>,Teapot_Sphere_Radius}
sphere {<3.3333,-0.1150,2.4457>,Teapot_Sphere_Radius}
sphere {<3.2376,-0.1200,2.4000>,Teapot_Sphere_Radius}
sphere {<3.3000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<3.4000,0.0000,2.4468>,Teapot_Sphere_Radius}
sphere {<3.3688,-0.1031,2.4709>,Teapot_Sphere_Radius}
sphere {<3.3333,-0.1150,2.4457>,Teapot_Sphere_Radius}
sphere {<3.4000,0.0000,2.4468>,Teapot_Sphere_Radius}
sphere {<3.4340,0.0000,2.4729>,Teapot_Sphere_Radius}
sphere {<3.3486,-0.0889,2.4734>,Teapot_Sphere_Radius}
sphere {<3.3688,-0.1031,2.4709>,Teapot_Sphere_Radius}
sphere {<3.4340,0.0000,2.4729>,Teapot_Sphere_Radius}
sphere {<3.4080,0.0000,2.4756>,Teapot_Sphere_Radius}
sphere {<3.2770,-0.0770,2.4505>,Teapot_Sphere_Radius}
sphere {<3.3486,-0.0889,2.4734>,Teapot_Sphere_Radius}
sphere {<3.4080,0.0000,2.4756>,Teapot_Sphere_Radius}
sphere {<3.3280,0.0000,2.4522>,Teapot_Sphere_Radius}
sphere {<3.1584,-0.0720,2.4000>,Teapot_Sphere_Radius}
sphere {<3.2770,-0.0770,2.4505>,Teapot_Sphere_Radius}
sphere {<3.3280,0.0000,2.4522>,Teapot_Sphere_Radius}
sphere {<3.2000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<3.4000,0.0000,2.4468>,Teapot_Sphere_Radius}
sphere {<3.3000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<3.2376,0.1200,2.4000>,Teapot_Sphere_Radius}
sphere {<3.3333,0.1150,2.4457>,Teapot_Sphere_Radius}
sphere {<3.4340,0.0000,2.4729>,Teapot_Sphere_Radius}
sphere {<3.4000,0.0000,2.4468>,Teapot_Sphere_Radius}
sphere {<3.3333,0.1150,2.4457>,Teapot_Sphere_Radius}
sphere {<3.3688,0.1031,2.4709>,Teapot_Sphere_Radius}
sphere {<3.4080,0.0000,2.4756>,Teapot_Sphere_Radius}
sphere {<3.4340,0.0000,2.4729>,Teapot_Sphere_Radius}
sphere {<3.3688,0.1031,2.4709>,Teapot_Sphere_Radius}
sphere {<3.3486,0.0889,2.4734>,Teapot_Sphere_Radius}
sphere {<3.3280,0.0000,2.4522>,Teapot_Sphere_Radius}
sphere {<3.4080,0.0000,2.4756>,Teapot_Sphere_Radius}
sphere {<3.3486,0.0889,2.4734>,Teapot_Sphere_Radius}
sphere {<3.2770,0.0770,2.4505>,Teapot_Sphere_Radius}
sphere {<3.2000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<3.3280,0.0000,2.4522>,Teapot_Sphere_Radius}
sphere {<3.2770,0.0770,2.4505>,Teapot_Sphere_Radius}
sphere {<3.1584,0.0720,2.4000>,Teapot_Sphere_Radius}
sphere {<3.3333,0.1150,2.4457>,Teapot_Sphere_Radius}
sphere {<3.2376,0.1200,2.4000>,Teapot_Sphere_Radius}
sphere {<3.0888,0.1800,2.4000>,Teapot_Sphere_Radius}
sphere {<3.1742,0.1725,2.4430>,Teapot_Sphere_Radius}
sphere {<3.3688,0.1031,2.4709>,Teapot_Sphere_Radius}
sphere {<3.3333,0.1150,2.4457>,Teapot_Sphere_Radius}
sphere {<3.1742,0.1725,2.4430>,Teapot_Sphere_Radius}
sphere {<3.2134,0.1547,2.4662>,Teapot_Sphere_Radius}
sphere {<3.3486,0.0889,2.4734>,Teapot_Sphere_Radius}
sphere {<3.3688,0.1031,2.4709>,Teapot_Sphere_Radius}
sphere {<3.2134,0.1547,2.4662>,Teapot_Sphere_Radius}
sphere {<3.2069,0.1333,2.4680>,Teapot_Sphere_Radius}
sphere {<3.2770,0.0770,2.4505>,Teapot_Sphere_Radius}
sphere {<3.3486,0.0889,2.4734>,Teapot_Sphere_Radius}
sphere {<3.2069,0.1333,2.4680>,Teapot_Sphere_Radius}
sphere {<3.1554,0.1155,2.4465>,Teapot_Sphere_Radius}
sphere {<3.1584,0.0720,2.4000>,Teapot_Sphere_Radius}
sphere {<3.2770,0.0770,2.4505>,Teapot_Sphere_Radius}
sphere {<3.1554,0.1155,2.4465>,Teapot_Sphere_Radius}
sphere {<3.0592,0.1080,2.4000>,Teapot_Sphere_Radius}
sphere {<3.1742,0.1725,2.4430>,Teapot_Sphere_Radius}
sphere {<3.0888,0.1800,2.4000>,Teapot_Sphere_Radius}
sphere {<2.9112,0.1800,2.4000>,Teapot_Sphere_Radius}
sphere {<2.9842,0.1725,2.4398>,Teapot_Sphere_Radius}
sphere {<3.2134,0.1547,2.4662>,Teapot_Sphere_Radius}
sphere {<3.1742,0.1725,2.4430>,Teapot_Sphere_Radius}
sphere {<2.9842,0.1725,2.4398>,Teapot_Sphere_Radius}
sphere {<3.0278,0.1547,2.4607>,Teapot_Sphere_Radius}
sphere {<3.2069,0.1333,2.4680>,Teapot_Sphere_Radius}
sphere {<3.2134,0.1547,2.4662>,Teapot_Sphere_Radius}
sphere {<3.0278,0.1547,2.4607>,Teapot_Sphere_Radius}
sphere {<3.0379,0.1333,2.4616>,Teapot_Sphere_Radius}
sphere {<3.1554,0.1155,2.4465>,Teapot_Sphere_Radius}
sphere {<3.2069,0.1333,2.4680>,Teapot_Sphere_Radius}
sphere {<3.0379,0.1333,2.4616>,Teapot_Sphere_Radius}
sphere {<3.0102,0.1155,2.4417>,Teapot_Sphere_Radius}
sphere {<3.0592,0.1080,2.4000>,Teapot_Sphere_Radius}
sphere {<3.1554,0.1155,2.4465>,Teapot_Sphere_Radius}
sphere {<3.0102,0.1155,2.4417>,Teapot_Sphere_Radius}
sphere {<2.9408,0.1080,2.4000>,Teapot_Sphere_Radius}
sphere {<2.9842,0.1725,2.4398>,Teapot_Sphere_Radius}
sphere {<2.9112,0.1800,2.4000>,Teapot_Sphere_Radius}
sphere {<2.7624,0.1200,2.4000>,Teapot_Sphere_Radius}
sphere {<2.8251,0.1150,2.4371>,Teapot_Sphere_Radius}
sphere {<3.0278,0.1547,2.4607>,Teapot_Sphere_Radius}
sphere {<2.9842,0.1725,2.4398>,Teapot_Sphere_Radius}
sphere {<2.8251,0.1150,2.4371>,Teapot_Sphere_Radius}
sphere {<2.8724,0.1031,2.4560>,Teapot_Sphere_Radius}
sphere {<3.0379,0.1333,2.4616>,Teapot_Sphere_Radius}
sphere {<3.0278,0.1547,2.4607>,Teapot_Sphere_Radius}
sphere {<2.8724,0.1031,2.4560>,Teapot_Sphere_Radius}
sphere {<2.8962,0.0889,2.4562>,Teapot_Sphere_Radius}
sphere {<3.0102,0.1155,2.4417>,Teapot_Sphere_Radius}
sphere {<3.0379,0.1333,2.4616>,Teapot_Sphere_Radius}
sphere {<2.8962,0.0889,2.4562>,Teapot_Sphere_Radius}
sphere {<2.8886,0.0770,2.4377>,Teapot_Sphere_Radius}
sphere {<2.9408,0.1080,2.4000>,Teapot_Sphere_Radius}
sphere {<3.0102,0.1155,2.4417>,Teapot_Sphere_Radius}
sphere {<2.8886,0.0770,2.4377>,Teapot_Sphere_Radius}
sphere {<2.8416,0.0720,2.4000>,Teapot_Sphere_Radius}
sphere {<2.8251,0.1150,2.4371>,Teapot_Sphere_Radius}
sphere {<2.7624,0.1200,2.4000>,Teapot_Sphere_Radius}
sphere {<2.7000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<2.7584,0.0000,2.4360>,Teapot_Sphere_Radius}
sphere {<2.8724,0.1031,2.4560>,Teapot_Sphere_Radius}
sphere {<2.8251,0.1150,2.4371>,Teapot_Sphere_Radius}
sphere {<2.7584,0.0000,2.4360>,Teapot_Sphere_Radius}
sphere {<2.8072,0.0000,2.4540>,Teapot_Sphere_Radius}
sphere {<2.8962,0.0889,2.4562>,Teapot_Sphere_Radius}
sphere {<2.8724,0.1031,2.4560>,Teapot_Sphere_Radius}
sphere {<2.8072,0.0000,2.4540>,Teapot_Sphere_Radius}
sphere {<2.8368,0.0000,2.4540>,Teapot_Sphere_Radius}
sphere {<2.8886,0.0770,2.4377>,Teapot_Sphere_Radius}
sphere {<2.8962,0.0889,2.4562>,Teapot_Sphere_Radius}
sphere {<2.8368,0.0000,2.4540>,Teapot_Sphere_Radius}
sphere {<2.8376,0.0000,2.4360>,Teapot_Sphere_Radius}
sphere {<2.8416,0.0720,2.4000>,Teapot_Sphere_Radius}
sphere {<2.8886,0.0770,2.4377>,Teapot_Sphere_Radius}
sphere {<2.8376,0.0000,2.4360>,Teapot_Sphere_Radius}
sphere {<2.8000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<0.2934,-0.0988,3.1176>,Teapot_Sphere_Radius}
sphere {<0.2934,-0.0988,3.1176>,Teapot_Sphere_Radius}
sphere {<0.3584,0.0000,3.0348>,Teapot_Sphere_Radius}
sphere {<0.3088,0.0000,3.1176>,Teapot_Sphere_Radius}
sphere {<0.2934,-0.0988,3.1176>,Teapot_Sphere_Radius}
sphere {<0.3405,-0.1147,3.0348>,Teapot_Sphere_Radius}
sphere {<0.2736,0.0000,2.9232>,Teapot_Sphere_Radius}
sphere {<0.3584,0.0000,3.0348>,Teapot_Sphere_Radius}
sphere {<0.3405,-0.1147,3.0348>,Teapot_Sphere_Radius}
sphere {<0.2599,-0.0875,2.9232>,Teapot_Sphere_Radius}
sphere {<0.1792,0.0000,2.8044>,Teapot_Sphere_Radius}
sphere {<0.2736,0.0000,2.9232>,Teapot_Sphere_Radius}
sphere {<0.2599,-0.0875,2.9232>,Teapot_Sphere_Radius}
sphere {<0.1702,-0.0572,2.8044>,Teapot_Sphere_Radius}
sphere {<0.2000,0.0000,2.7000>,Teapot_Sphere_Radius}
sphere {<0.1792,0.0000,2.8044>,Teapot_Sphere_Radius}
sphere {<0.1702,-0.0572,2.8044>,Teapot_Sphere_Radius}
sphere {<0.1900,-0.0638,2.7000>,Teapot_Sphere_Radius}
sphere {<0.2501,-0.1837,3.1176>,Teapot_Sphere_Radius}
sphere {<0.2501,-0.1837,3.1176>,Teapot_Sphere_Radius}
sphere {<0.3405,-0.1147,3.0348>,Teapot_Sphere_Radius}
sphere {<0.2934,-0.0988,3.1176>,Teapot_Sphere_Radius}
sphere {<0.2501,-0.1837,3.1176>,Teapot_Sphere_Radius}
sphere {<0.2903,-0.2132,3.0348>,Teapot_Sphere_Radius}
sphere {<0.2599,-0.0875,2.9232>,Teapot_Sphere_Radius}
sphere {<0.3405,-0.1147,3.0348>,Teapot_Sphere_Radius}
sphere {<0.2903,-0.2132,3.0348>,Teapot_Sphere_Radius}
sphere {<0.2216,-0.1627,2.9232>,Teapot_Sphere_Radius}
sphere {<0.1702,-0.0572,2.8044>,Teapot_Sphere_Radius}
sphere {<0.2599,-0.0875,2.9232>,Teapot_Sphere_Radius}
sphere {<0.2216,-0.1627,2.9232>,Teapot_Sphere_Radius}
sphere {<0.1451,-0.1065,2.8044>,Teapot_Sphere_Radius}
sphere {<0.1900,-0.0638,2.7000>,Teapot_Sphere_Radius}
sphere {<0.1702,-0.0572,2.8044>,Teapot_Sphere_Radius}
sphere {<0.1451,-0.1065,2.8044>,Teapot_Sphere_Radius}
sphere {<0.1619,-0.1188,2.7000>,Teapot_Sphere_Radius}
sphere {<0.1837,-0.2501,3.1176>,Teapot_Sphere_Radius}
sphere {<0.1837,-0.2501,3.1176>,Teapot_Sphere_Radius}
sphere {<0.2903,-0.2132,3.0348>,Teapot_Sphere_Radius}
sphere {<0.2501,-0.1837,3.1176>,Teapot_Sphere_Radius}
sphere {<0.1837,-0.2501,3.1176>,Teapot_Sphere_Radius}
sphere {<0.2132,-0.2903,3.0348>,Teapot_Sphere_Radius}
sphere {<0.2216,-0.1627,2.9232>,Teapot_Sphere_Radius}
sphere {<0.2903,-0.2132,3.0348>,Teapot_Sphere_Radius}
sphere {<0.2132,-0.2903,3.0348>,Teapot_Sphere_Radius}
sphere {<0.1627,-0.2216,2.9232>,Teapot_Sphere_Radius}
sphere {<0.1451,-0.1065,2.8044>,Teapot_Sphere_Radius}
sphere {<0.2216,-0.1627,2.9232>,Teapot_Sphere_Radius}
sphere {<0.1627,-0.2216,2.9232>,Teapot_Sphere_Radius}
sphere {<0.1065,-0.1451,2.8044>,Teapot_Sphere_Radius}
sphere {<0.1619,-0.1188,2.7000>,Teapot_Sphere_Radius}
sphere {<0.1451,-0.1065,2.8044>,Teapot_Sphere_Radius}
sphere {<0.1065,-0.1451,2.8044>,Teapot_Sphere_Radius}
sphere {<0.1188,-0.1619,2.7000>,Teapot_Sphere_Radius}
sphere {<0.0988,-0.2934,3.1176>,Teapot_Sphere_Radius}
sphere {<0.0988,-0.2934,3.1176>,Teapot_Sphere_Radius}
sphere {<0.2132,-0.2903,3.0348>,Teapot_Sphere_Radius}
sphere {<0.1837,-0.2501,3.1176>,Teapot_Sphere_Radius}
sphere {<0.0988,-0.2934,3.1176>,Teapot_Sphere_Radius}
sphere {<0.1147,-0.3405,3.0348>,Teapot_Sphere_Radius}
sphere {<0.1627,-0.2216,2.9232>,Teapot_Sphere_Radius}
sphere {<0.2132,-0.2903,3.0348>,Teapot_Sphere_Radius}
sphere {<0.1147,-0.3405,3.0348>,Teapot_Sphere_Radius}
sphere {<0.0875,-0.2599,2.9232>,Teapot_Sphere_Radius}
sphere {<0.1065,-0.1451,2.8044>,Teapot_Sphere_Radius}
sphere {<0.1627,-0.2216,2.9232>,Teapot_Sphere_Radius}
sphere {<0.0875,-0.2599,2.9232>,Teapot_Sphere_Radius}
sphere {<0.0572,-0.1702,2.8044>,Teapot_Sphere_Radius}
sphere {<0.1188,-0.1619,2.7000>,Teapot_Sphere_Radius}
sphere {<0.1065,-0.1451,2.8044>,Teapot_Sphere_Radius}
sphere {<0.0572,-0.1702,2.8044>,Teapot_Sphere_Radius}
sphere {<0.0638,-0.1900,2.7000>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.3088,3.1176>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.3088,3.1176>,Teapot_Sphere_Radius}
sphere {<0.1147,-0.3405,3.0348>,Teapot_Sphere_Radius}
sphere {<0.0988,-0.2934,3.1176>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.3088,3.1176>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.3584,3.0348>,Teapot_Sphere_Radius}
sphere {<0.0875,-0.2599,2.9232>,Teapot_Sphere_Radius}
sphere {<0.1147,-0.3405,3.0348>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.3584,3.0348>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.2736,2.9232>,Teapot_Sphere_Radius}
sphere {<0.0572,-0.1702,2.8044>,Teapot_Sphere_Radius}
sphere {<0.0875,-0.2599,2.9232>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.2736,2.9232>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.1792,2.8044>,Teapot_Sphere_Radius}
sphere {<0.0638,-0.1900,2.7000>,Teapot_Sphere_Radius}
sphere {<0.0572,-0.1702,2.8044>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.1792,2.8044>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.2000,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.0988,-0.2934,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.0988,-0.2934,3.1176>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.3584,3.0348>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.3088,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.0988,-0.2934,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.1147,-0.3405,3.0348>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.2736,2.9232>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.3584,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.1147,-0.3405,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.0875,-0.2599,2.9232>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.1792,2.8044>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.2736,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.0875,-0.2599,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.0572,-0.1702,2.8044>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.2000,2.7000>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.1792,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.0572,-0.1702,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.0638,-0.1900,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.1837,-0.2501,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.1837,-0.2501,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.1147,-0.3405,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.0988,-0.2934,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.1837,-0.2501,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.2132,-0.2903,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.0875,-0.2599,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.1147,-0.3405,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.2132,-0.2903,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.1627,-0.2216,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.0572,-0.1702,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.0875,-0.2599,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.1627,-0.2216,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.1065,-0.1451,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.0638,-0.1900,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.0572,-0.1702,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.1065,-0.1451,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.1188,-0.1619,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.2501,-0.1837,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.2501,-0.1837,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.2132,-0.2903,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.1837,-0.2501,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.2501,-0.1837,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.2903,-0.2132,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.1627,-0.2216,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.2132,-0.2903,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.2903,-0.2132,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.2216,-0.1627,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.1065,-0.1451,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.1627,-0.2216,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.2216,-0.1627,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.1451,-0.1065,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.1188,-0.1619,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.1065,-0.1451,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.1451,-0.1065,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.1619,-0.1188,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.2934,-0.0988,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.2934,-0.0988,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.2903,-0.2132,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.2501,-0.1837,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.2934,-0.0988,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.3405,-0.1147,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.2216,-0.1627,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.2903,-0.2132,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.3405,-0.1147,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.2599,-0.0875,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.1451,-0.1065,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.2216,-0.1627,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.2599,-0.0875,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.1702,-0.0572,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.1619,-0.1188,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.1451,-0.1065,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.1702,-0.0572,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.1900,-0.0638,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.3088,0.0000,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.3088,0.0000,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.3405,-0.1147,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.2934,-0.0988,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.3088,0.0000,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.3584,0.0000,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.2599,-0.0875,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.3405,-0.1147,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.3584,0.0000,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.2736,0.0000,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.1702,-0.0572,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.2599,-0.0875,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.2736,0.0000,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.1792,0.0000,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.1900,-0.0638,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.1702,-0.0572,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.1792,0.0000,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.2000,0.0000,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.2934,0.0988,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.2934,0.0988,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.3584,0.0000,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.3088,0.0000,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.2934,0.0988,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.3405,0.1147,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.2736,0.0000,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.3584,0.0000,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.3405,0.1147,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.2599,0.0875,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.1792,0.0000,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.2736,0.0000,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.2599,0.0875,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.1702,0.0572,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.2000,0.0000,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.1792,0.0000,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.1702,0.0572,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.1900,0.0638,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.2501,0.1837,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.2501,0.1837,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.3405,0.1147,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.2934,0.0988,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.2501,0.1837,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.2903,0.2132,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.2599,0.0875,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.3405,0.1147,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.2903,0.2132,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.2216,0.1627,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.1702,0.0572,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.2599,0.0875,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.2216,0.1627,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.1451,0.1065,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.1900,0.0638,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.1702,0.0572,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.1451,0.1065,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.1619,0.1188,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.1837,0.2501,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.1837,0.2501,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.2903,0.2132,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.2501,0.1837,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.1837,0.2501,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.2132,0.2903,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.2216,0.1627,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.2903,0.2132,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.2132,0.2903,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.1627,0.2216,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.1451,0.1065,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.2216,0.1627,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.1627,0.2216,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.1065,0.1451,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.1619,0.1188,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.1451,0.1065,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.1065,0.1451,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.1188,0.1619,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.0988,0.2934,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.0988,0.2934,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.2132,0.2903,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.1837,0.2501,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.0988,0.2934,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.1147,0.3405,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.1627,0.2216,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.2132,0.2903,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.1147,0.3405,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.0875,0.2599,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.1065,0.1451,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.1627,0.2216,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.0875,0.2599,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.0572,0.1702,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.1188,0.1619,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.1065,0.1451,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.0572,0.1702,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.0638,0.1900,2.7000>,Teapot_Sphere_Radius}
sphere {<0.0000,0.3088,3.1176>,Teapot_Sphere_Radius}
sphere {<0.0000,0.3088,3.1176>,Teapot_Sphere_Radius}
sphere {<-0.1147,0.3405,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.0988,0.2934,3.1176>,Teapot_Sphere_Radius}
sphere {<0.0000,0.3088,3.1176>,Teapot_Sphere_Radius}
sphere {<0.0000,0.3584,3.0348>,Teapot_Sphere_Radius}
sphere {<-0.0875,0.2599,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.1147,0.3405,3.0348>,Teapot_Sphere_Radius}
sphere {<0.0000,0.3584,3.0348>,Teapot_Sphere_Radius}
sphere {<0.0000,0.2736,2.9232>,Teapot_Sphere_Radius}
sphere {<-0.0572,0.1702,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.0875,0.2599,2.9232>,Teapot_Sphere_Radius}
sphere {<0.0000,0.2736,2.9232>,Teapot_Sphere_Radius}
sphere {<0.0000,0.1792,2.8044>,Teapot_Sphere_Radius}
sphere {<-0.0638,0.1900,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.0572,0.1702,2.8044>,Teapot_Sphere_Radius}
sphere {<0.0000,0.1792,2.8044>,Teapot_Sphere_Radius}
sphere {<0.0000,0.2000,2.7000>,Teapot_Sphere_Radius}
sphere {<0.0988,0.2934,3.1176>,Teapot_Sphere_Radius}
sphere {<0.0988,0.2934,3.1176>,Teapot_Sphere_Radius}
sphere {<0.0000,0.3584,3.0348>,Teapot_Sphere_Radius}
sphere {<0.0000,0.3088,3.1176>,Teapot_Sphere_Radius}
sphere {<0.0988,0.2934,3.1176>,Teapot_Sphere_Radius}
sphere {<0.1147,0.3405,3.0348>,Teapot_Sphere_Radius}
sphere {<0.0000,0.2736,2.9232>,Teapot_Sphere_Radius}
sphere {<0.0000,0.3584,3.0348>,Teapot_Sphere_Radius}
sphere {<0.1147,0.3405,3.0348>,Teapot_Sphere_Radius}
sphere {<0.0875,0.2599,2.9232>,Teapot_Sphere_Radius}
sphere {<0.0000,0.1792,2.8044>,Teapot_Sphere_Radius}
sphere {<0.0000,0.2736,2.9232>,Teapot_Sphere_Radius}
sphere {<0.0875,0.2599,2.9232>,Teapot_Sphere_Radius}
sphere {<0.0572,0.1702,2.8044>,Teapot_Sphere_Radius}
sphere {<0.0000,0.2000,2.7000>,Teapot_Sphere_Radius}
sphere {<0.0000,0.1792,2.8044>,Teapot_Sphere_Radius}
sphere {<0.0572,0.1702,2.8044>,Teapot_Sphere_Radius}
sphere {<0.0638,0.1900,2.7000>,Teapot_Sphere_Radius}
sphere {<0.1837,0.2501,3.1176>,Teapot_Sphere_Radius}
sphere {<0.1837,0.2501,3.1176>,Teapot_Sphere_Radius}
sphere {<0.1147,0.3405,3.0348>,Teapot_Sphere_Radius}
sphere {<0.0988,0.2934,3.1176>,Teapot_Sphere_Radius}
sphere {<0.1837,0.2501,3.1176>,Teapot_Sphere_Radius}
sphere {<0.2132,0.2903,3.0348>,Teapot_Sphere_Radius}
sphere {<0.0875,0.2599,2.9232>,Teapot_Sphere_Radius}
sphere {<0.1147,0.3405,3.0348>,Teapot_Sphere_Radius}
sphere {<0.2132,0.2903,3.0348>,Teapot_Sphere_Radius}
sphere {<0.1627,0.2216,2.9232>,Teapot_Sphere_Radius}
sphere {<0.0572,0.1702,2.8044>,Teapot_Sphere_Radius}
sphere {<0.0875,0.2599,2.9232>,Teapot_Sphere_Radius}
sphere {<0.1627,0.2216,2.9232>,Teapot_Sphere_Radius}
sphere {<0.1065,0.1451,2.8044>,Teapot_Sphere_Radius}
sphere {<0.0638,0.1900,2.7000>,Teapot_Sphere_Radius}
sphere {<0.0572,0.1702,2.8044>,Teapot_Sphere_Radius}
sphere {<0.1065,0.1451,2.8044>,Teapot_Sphere_Radius}
sphere {<0.1188,0.1619,2.7000>,Teapot_Sphere_Radius}
sphere {<0.2501,0.1837,3.1176>,Teapot_Sphere_Radius}
sphere {<0.2501,0.1837,3.1176>,Teapot_Sphere_Radius}
sphere {<0.2132,0.2903,3.0348>,Teapot_Sphere_Radius}
sphere {<0.1837,0.2501,3.1176>,Teapot_Sphere_Radius}
sphere {<0.2501,0.1837,3.1176>,Teapot_Sphere_Radius}
sphere {<0.2903,0.2132,3.0348>,Teapot_Sphere_Radius}
sphere {<0.1627,0.2216,2.9232>,Teapot_Sphere_Radius}
sphere {<0.2132,0.2903,3.0348>,Teapot_Sphere_Radius}
sphere {<0.2903,0.2132,3.0348>,Teapot_Sphere_Radius}
sphere {<0.2216,0.1627,2.9232>,Teapot_Sphere_Radius}
sphere {<0.1065,0.1451,2.8044>,Teapot_Sphere_Radius}
sphere {<0.1627,0.2216,2.9232>,Teapot_Sphere_Radius}
sphere {<0.2216,0.1627,2.9232>,Teapot_Sphere_Radius}
sphere {<0.1451,0.1065,2.8044>,Teapot_Sphere_Radius}
sphere {<0.1188,0.1619,2.7000>,Teapot_Sphere_Radius}
sphere {<0.1065,0.1451,2.8044>,Teapot_Sphere_Radius}
sphere {<0.1451,0.1065,2.8044>,Teapot_Sphere_Radius}
sphere {<0.1619,0.1188,2.7000>,Teapot_Sphere_Radius}
sphere {<0.2934,0.0988,3.1176>,Teapot_Sphere_Radius}
sphere {<0.2934,0.0988,3.1176>,Teapot_Sphere_Radius}
sphere {<0.2903,0.2132,3.0348>,Teapot_Sphere_Radius}
sphere {<0.2501,0.1837,3.1176>,Teapot_Sphere_Radius}
sphere {<0.2934,0.0988,3.1176>,Teapot_Sphere_Radius}
sphere {<0.3405,0.1147,3.0348>,Teapot_Sphere_Radius}
sphere {<0.2216,0.1627,2.9232>,Teapot_Sphere_Radius}
sphere {<0.2903,0.2132,3.0348>,Teapot_Sphere_Radius}
sphere {<0.3405,0.1147,3.0348>,Teapot_Sphere_Radius}
sphere {<0.2599,0.0875,2.9232>,Teapot_Sphere_Radius}
sphere {<0.1451,0.1065,2.8044>,Teapot_Sphere_Radius}
sphere {<0.2216,0.1627,2.9232>,Teapot_Sphere_Radius}
sphere {<0.2599,0.0875,2.9232>,Teapot_Sphere_Radius}
sphere {<0.1702,0.0572,2.8044>,Teapot_Sphere_Radius}
sphere {<0.1619,0.1188,2.7000>,Teapot_Sphere_Radius}
sphere {<0.1451,0.1065,2.8044>,Teapot_Sphere_Radius}
sphere {<0.1702,0.0572,2.8044>,Teapot_Sphere_Radius}
sphere {<0.1900,0.0638,2.7000>,Teapot_Sphere_Radius}
sphere {<0.3088,0.0000,3.1176>,Teapot_Sphere_Radius}
sphere {<0.3088,0.0000,3.1176>,Teapot_Sphere_Radius}
sphere {<0.3405,0.1147,3.0348>,Teapot_Sphere_Radius}
sphere {<0.2934,0.0988,3.1176>,Teapot_Sphere_Radius}
sphere {<0.3088,0.0000,3.1176>,Teapot_Sphere_Radius}
sphere {<0.3584,0.0000,3.0348>,Teapot_Sphere_Radius}
sphere {<0.2599,0.0875,2.9232>,Teapot_Sphere_Radius}
sphere {<0.3405,0.1147,3.0348>,Teapot_Sphere_Radius}
sphere {<0.3584,0.0000,3.0348>,Teapot_Sphere_Radius}
sphere {<0.2736,0.0000,2.9232>,Teapot_Sphere_Radius}
sphere {<0.1702,0.0572,2.8044>,Teapot_Sphere_Radius}
sphere {<0.2599,0.0875,2.9232>,Teapot_Sphere_Radius}
sphere {<0.2736,0.0000,2.9232>,Teapot_Sphere_Radius}
sphere {<0.1792,0.0000,2.8044>,Teapot_Sphere_Radius}
sphere {<0.1900,0.0638,2.7000>,Teapot_Sphere_Radius}
sphere {<0.1702,0.0572,2.8044>,Teapot_Sphere_Radius}
sphere {<0.1792,0.0000,2.8044>,Teapot_Sphere_Radius}
sphere {<0.2000,0.0000,2.7000>,Teapot_Sphere_Radius}
sphere {<0.3912,0.0000,2.6256>,Teapot_Sphere_Radius}
sphere {<0.2000,0.0000,2.7000>,Teapot_Sphere_Radius}
sphere {<0.1900,-0.0638,2.7000>,Teapot_Sphere_Radius}
sphere {<0.3715,-0.1248,2.6256>,Teapot_Sphere_Radius}
sphere {<0.6736,0.0000,2.5728>,Teapot_Sphere_Radius}
sphere {<0.3912,0.0000,2.6256>,Teapot_Sphere_Radius}
sphere {<0.3715,-0.1248,2.6256>,Teapot_Sphere_Radius}
sphere {<0.6398,-0.2149,2.5728>,Teapot_Sphere_Radius}
sphere {<0.9704,0.0000,2.5272>,Teapot_Sphere_Radius}
sphere {<0.6736,0.0000,2.5728>,Teapot_Sphere_Radius}
sphere {<0.6398,-0.2149,2.5728>,Teapot_Sphere_Radius}
sphere {<0.9216,-0.3096,2.5272>,Teapot_Sphere_Radius}
sphere {<1.2048,0.0000,2.4744>,Teapot_Sphere_Radius}
sphere {<0.9704,0.0000,2.5272>,Teapot_Sphere_Radius}
sphere {<0.9216,-0.3096,2.5272>,Teapot_Sphere_Radius}
sphere {<1.1443,-0.3844,2.4744>,Teapot_Sphere_Radius}
sphere {<1.3000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<1.2048,0.0000,2.4744>,Teapot_Sphere_Radius}
sphere {<1.1443,-0.3844,2.4744>,Teapot_Sphere_Radius}
sphere {<1.2347,-0.4148,2.4000>,Teapot_Sphere_Radius}
sphere {<0.3715,-0.1248,2.6256>,Teapot_Sphere_Radius}
sphere {<0.1900,-0.0638,2.7000>,Teapot_Sphere_Radius}
sphere {<0.1619,-0.1188,2.7000>,Teapot_Sphere_Radius}
sphere {<0.3166,-0.2323,2.6256>,Teapot_Sphere_Radius}
sphere {<0.6398,-0.2149,2.5728>,Teapot_Sphere_Radius}
sphere {<0.3715,-0.1248,2.6256>,Teapot_Sphere_Radius}
sphere {<0.3166,-0.2323,2.6256>,Teapot_Sphere_Radius}
sphere {<0.5451,-0.4001,2.5728>,Teapot_Sphere_Radius}
sphere {<0.9216,-0.3096,2.5272>,Teapot_Sphere_Radius}
sphere {<0.6398,-0.2149,2.5728>,Teapot_Sphere_Radius}
sphere {<0.5451,-0.4001,2.5728>,Teapot_Sphere_Radius}
sphere {<0.7853,-0.5763,2.5272>,Teapot_Sphere_Radius}
sphere {<1.1443,-0.3844,2.4744>,Teapot_Sphere_Radius}
sphere {<0.9216,-0.3096,2.5272>,Teapot_Sphere_Radius}
sphere {<0.7853,-0.5763,2.5272>,Teapot_Sphere_Radius}
sphere {<0.9750,-0.7156,2.4744>,Teapot_Sphere_Radius}
sphere {<1.2347,-0.4148,2.4000>,Teapot_Sphere_Radius}
sphere {<1.1443,-0.3844,2.4744>,Teapot_Sphere_Radius}
sphere {<0.9750,-0.7156,2.4744>,Teapot_Sphere_Radius}
sphere {<1.0521,-0.7721,2.4000>,Teapot_Sphere_Radius}
sphere {<0.3166,-0.2323,2.6256>,Teapot_Sphere_Radius}
sphere {<0.1619,-0.1188,2.7000>,Teapot_Sphere_Radius}
sphere {<0.1188,-0.1619,2.7000>,Teapot_Sphere_Radius}
sphere {<0.2323,-0.3166,2.6256>,Teapot_Sphere_Radius}
sphere {<0.5451,-0.4001,2.5728>,Teapot_Sphere_Radius}
sphere {<0.3166,-0.2323,2.6256>,Teapot_Sphere_Radius}
sphere {<0.2323,-0.3166,2.6256>,Teapot_Sphere_Radius}
sphere {<0.4001,-0.5451,2.5728>,Teapot_Sphere_Radius}
sphere {<0.7853,-0.5763,2.5272>,Teapot_Sphere_Radius}
sphere {<0.5451,-0.4001,2.5728>,Teapot_Sphere_Radius}
sphere {<0.4001,-0.5451,2.5728>,Teapot_Sphere_Radius}
sphere {<0.5763,-0.7853,2.5272>,Teapot_Sphere_Radius}
sphere {<0.9750,-0.7156,2.4744>,Teapot_Sphere_Radius}
sphere {<0.7853,-0.5763,2.5272>,Teapot_Sphere_Radius}
sphere {<0.5763,-0.7853,2.5272>,Teapot_Sphere_Radius}
sphere {<0.7156,-0.9750,2.4744>,Teapot_Sphere_Radius}
sphere {<1.0521,-0.7721,2.4000>,Teapot_Sphere_Radius}
sphere {<0.9750,-0.7156,2.4744>,Teapot_Sphere_Radius}
sphere {<0.7156,-0.9750,2.4744>,Teapot_Sphere_Radius}
sphere {<0.7721,-1.0521,2.4000>,Teapot_Sphere_Radius}
sphere {<0.2323,-0.3166,2.6256>,Teapot_Sphere_Radius}
sphere {<0.1188,-0.1619,2.7000>,Teapot_Sphere_Radius}
sphere {<0.0638,-0.1900,2.7000>,Teapot_Sphere_Radius}
sphere {<0.1248,-0.3715,2.6256>,Teapot_Sphere_Radius}
sphere {<0.4001,-0.5451,2.5728>,Teapot_Sphere_Radius}
sphere {<0.2323,-0.3166,2.6256>,Teapot_Sphere_Radius}
sphere {<0.1248,-0.3715,2.6256>,Teapot_Sphere_Radius}
sphere {<0.2149,-0.6398,2.5728>,Teapot_Sphere_Radius}
sphere {<0.5763,-0.7853,2.5272>,Teapot_Sphere_Radius}
sphere {<0.4001,-0.5451,2.5728>,Teapot_Sphere_Radius}
sphere {<0.2149,-0.6398,2.5728>,Teapot_Sphere_Radius}
sphere {<0.3096,-0.9216,2.5272>,Teapot_Sphere_Radius}
sphere {<0.7156,-0.9750,2.4744>,Teapot_Sphere_Radius}
sphere {<0.5763,-0.7853,2.5272>,Teapot_Sphere_Radius}
sphere {<0.3096,-0.9216,2.5272>,Teapot_Sphere_Radius}
sphere {<0.3844,-1.1443,2.4744>,Teapot_Sphere_Radius}
sphere {<0.7721,-1.0521,2.4000>,Teapot_Sphere_Radius}
sphere {<0.7156,-0.9750,2.4744>,Teapot_Sphere_Radius}
sphere {<0.3844,-1.1443,2.4744>,Teapot_Sphere_Radius}
sphere {<0.4148,-1.2347,2.4000>,Teapot_Sphere_Radius}
sphere {<0.1248,-0.3715,2.6256>,Teapot_Sphere_Radius}
sphere {<0.0638,-0.1900,2.7000>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.2000,2.7000>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.3912,2.6256>,Teapot_Sphere_Radius}
sphere {<0.2149,-0.6398,2.5728>,Teapot_Sphere_Radius}
sphere {<0.1248,-0.3715,2.6256>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.3912,2.6256>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.6736,2.5728>,Teapot_Sphere_Radius}
sphere {<0.3096,-0.9216,2.5272>,Teapot_Sphere_Radius}
sphere {<0.2149,-0.6398,2.5728>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.6736,2.5728>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.9704,2.5272>,Teapot_Sphere_Radius}
sphere {<0.3844,-1.1443,2.4744>,Teapot_Sphere_Radius}
sphere {<0.3096,-0.9216,2.5272>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.9704,2.5272>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.2048,2.4744>,Teapot_Sphere_Radius}
sphere {<0.4148,-1.2347,2.4000>,Teapot_Sphere_Radius}
sphere {<0.3844,-1.1443,2.4744>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.2048,2.4744>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.3000,2.4000>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.3912,2.6256>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.2000,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.0638,-0.1900,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.1248,-0.3715,2.6256>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.6736,2.5728>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.3912,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.1248,-0.3715,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.2149,-0.6398,2.5728>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.9704,2.5272>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.6736,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.2149,-0.6398,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.3096,-0.9216,2.5272>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.2048,2.4744>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.9704,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.3096,-0.9216,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.3844,-1.1443,2.4744>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.3000,2.4000>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.2048,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.3844,-1.1443,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.4148,-1.2347,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.1248,-0.3715,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.0638,-0.1900,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.1188,-0.1619,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.2323,-0.3166,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.2149,-0.6398,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.1248,-0.3715,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.2323,-0.3166,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.4001,-0.5451,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.3096,-0.9216,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.2149,-0.6398,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.4001,-0.5451,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.5763,-0.7853,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.3844,-1.1443,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.3096,-0.9216,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.5763,-0.7853,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.7156,-0.9750,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.4148,-1.2347,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.3844,-1.1443,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.7156,-0.9750,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.7721,-1.0521,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.2323,-0.3166,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.1188,-0.1619,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.1619,-0.1188,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.3166,-0.2323,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.4001,-0.5451,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.2323,-0.3166,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.3166,-0.2323,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.5451,-0.4001,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.5763,-0.7853,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.4001,-0.5451,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.5451,-0.4001,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.7853,-0.5763,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.7156,-0.9750,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.5763,-0.7853,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.7853,-0.5763,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.9750,-0.7156,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.7721,-1.0521,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.7156,-0.9750,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.9750,-0.7156,2.4744>,Teapot_Sphere_Radius}
sphere {<-1.0521,-0.7721,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.3166,-0.2323,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.1619,-0.1188,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.1900,-0.0638,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.3715,-0.1248,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.5451,-0.4001,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.3166,-0.2323,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.3715,-0.1248,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.6398,-0.2149,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.7853,-0.5763,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.5451,-0.4001,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.6398,-0.2149,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.9216,-0.3096,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.9750,-0.7156,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.7853,-0.5763,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.9216,-0.3096,2.5272>,Teapot_Sphere_Radius}
sphere {<-1.1443,-0.3844,2.4744>,Teapot_Sphere_Radius}
sphere {<-1.0521,-0.7721,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.9750,-0.7156,2.4744>,Teapot_Sphere_Radius}
sphere {<-1.1443,-0.3844,2.4744>,Teapot_Sphere_Radius}
sphere {<-1.2347,-0.4148,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.3715,-0.1248,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.1900,-0.0638,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.2000,0.0000,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.3912,0.0000,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.6398,-0.2149,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.3715,-0.1248,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.3912,0.0000,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.6736,0.0000,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.9216,-0.3096,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.6398,-0.2149,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.6736,0.0000,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.9704,0.0000,2.5272>,Teapot_Sphere_Radius}
sphere {<-1.1443,-0.3844,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.9216,-0.3096,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.9704,0.0000,2.5272>,Teapot_Sphere_Radius}
sphere {<-1.2048,0.0000,2.4744>,Teapot_Sphere_Radius}
sphere {<-1.2347,-0.4148,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.1443,-0.3844,2.4744>,Teapot_Sphere_Radius}
sphere {<-1.2048,0.0000,2.4744>,Teapot_Sphere_Radius}
sphere {<-1.3000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.3912,0.0000,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.2000,0.0000,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.1900,0.0638,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.3715,0.1248,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.6736,0.0000,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.3912,0.0000,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.3715,0.1248,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.6398,0.2149,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.9704,0.0000,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.6736,0.0000,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.6398,0.2149,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.9216,0.3096,2.5272>,Teapot_Sphere_Radius}
sphere {<-1.2048,0.0000,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.9704,0.0000,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.9216,0.3096,2.5272>,Teapot_Sphere_Radius}
sphere {<-1.1443,0.3844,2.4744>,Teapot_Sphere_Radius}
sphere {<-1.3000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.2048,0.0000,2.4744>,Teapot_Sphere_Radius}
sphere {<-1.1443,0.3844,2.4744>,Teapot_Sphere_Radius}
sphere {<-1.2347,0.4148,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.3715,0.1248,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.1900,0.0638,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.1619,0.1188,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.3166,0.2323,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.6398,0.2149,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.3715,0.1248,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.3166,0.2323,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.5451,0.4001,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.9216,0.3096,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.6398,0.2149,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.5451,0.4001,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.7853,0.5763,2.5272>,Teapot_Sphere_Radius}
sphere {<-1.1443,0.3844,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.9216,0.3096,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.7853,0.5763,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.9750,0.7156,2.4744>,Teapot_Sphere_Radius}
sphere {<-1.2347,0.4148,2.4000>,Teapot_Sphere_Radius}
sphere {<-1.1443,0.3844,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.9750,0.7156,2.4744>,Teapot_Sphere_Radius}
sphere {<-1.0521,0.7721,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.3166,0.2323,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.1619,0.1188,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.1188,0.1619,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.2323,0.3166,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.5451,0.4001,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.3166,0.2323,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.2323,0.3166,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.4001,0.5451,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.7853,0.5763,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.5451,0.4001,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.4001,0.5451,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.5763,0.7853,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.9750,0.7156,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.7853,0.5763,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.5763,0.7853,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.7156,0.9750,2.4744>,Teapot_Sphere_Radius}
sphere {<-1.0521,0.7721,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.9750,0.7156,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.7156,0.9750,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.7721,1.0521,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.2323,0.3166,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.1188,0.1619,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.0638,0.1900,2.7000>,Teapot_Sphere_Radius}
sphere {<-0.1248,0.3715,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.4001,0.5451,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.2323,0.3166,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.1248,0.3715,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.2149,0.6398,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.5763,0.7853,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.4001,0.5451,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.2149,0.6398,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.3096,0.9216,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.7156,0.9750,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.5763,0.7853,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.3096,0.9216,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.3844,1.1443,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.7721,1.0521,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.7156,0.9750,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.3844,1.1443,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.4148,1.2347,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.1248,0.3715,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.0638,0.1900,2.7000>,Teapot_Sphere_Radius}
sphere {<0.0000,0.2000,2.7000>,Teapot_Sphere_Radius}
sphere {<0.0000,0.3912,2.6256>,Teapot_Sphere_Radius}
sphere {<-0.2149,0.6398,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.1248,0.3715,2.6256>,Teapot_Sphere_Radius}
sphere {<0.0000,0.3912,2.6256>,Teapot_Sphere_Radius}
sphere {<0.0000,0.6736,2.5728>,Teapot_Sphere_Radius}
sphere {<-0.3096,0.9216,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.2149,0.6398,2.5728>,Teapot_Sphere_Radius}
sphere {<0.0000,0.6736,2.5728>,Teapot_Sphere_Radius}
sphere {<0.0000,0.9704,2.5272>,Teapot_Sphere_Radius}
sphere {<-0.3844,1.1443,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.3096,0.9216,2.5272>,Teapot_Sphere_Radius}
sphere {<0.0000,0.9704,2.5272>,Teapot_Sphere_Radius}
sphere {<0.0000,1.2048,2.4744>,Teapot_Sphere_Radius}
sphere {<-0.4148,1.2347,2.4000>,Teapot_Sphere_Radius}
sphere {<-0.3844,1.1443,2.4744>,Teapot_Sphere_Radius}
sphere {<0.0000,1.2048,2.4744>,Teapot_Sphere_Radius}
sphere {<0.0000,1.3000,2.4000>,Teapot_Sphere_Radius}
sphere {<0.0000,0.3912,2.6256>,Teapot_Sphere_Radius}
sphere {<0.0000,0.2000,2.7000>,Teapot_Sphere_Radius}
sphere {<0.0638,0.1900,2.7000>,Teapot_Sphere_Radius}
sphere {<0.1248,0.3715,2.6256>,Teapot_Sphere_Radius}
sphere {<0.0000,0.6736,2.5728>,Teapot_Sphere_Radius}
sphere {<0.0000,0.3912,2.6256>,Teapot_Sphere_Radius}
sphere {<0.1248,0.3715,2.6256>,Teapot_Sphere_Radius}
sphere {<0.2149,0.6398,2.5728>,Teapot_Sphere_Radius}
sphere {<0.0000,0.9704,2.5272>,Teapot_Sphere_Radius}
sphere {<0.0000,0.6736,2.5728>,Teapot_Sphere_Radius}
sphere {<0.2149,0.6398,2.5728>,Teapot_Sphere_Radius}
sphere {<0.3096,0.9216,2.5272>,Teapot_Sphere_Radius}
sphere {<0.0000,1.2048,2.4744>,Teapot_Sphere_Radius}
sphere {<0.0000,0.9704,2.5272>,Teapot_Sphere_Radius}
sphere {<0.3096,0.9216,2.5272>,Teapot_Sphere_Radius}
sphere {<0.3844,1.1443,2.4744>,Teapot_Sphere_Radius}
sphere {<0.0000,1.3000,2.4000>,Teapot_Sphere_Radius}
sphere {<0.0000,1.2048,2.4744>,Teapot_Sphere_Radius}
sphere {<0.3844,1.1443,2.4744>,Teapot_Sphere_Radius}
sphere {<0.4148,1.2347,2.4000>,Teapot_Sphere_Radius}
sphere {<0.1248,0.3715,2.6256>,Teapot_Sphere_Radius}
sphere {<0.0638,0.1900,2.7000>,Teapot_Sphere_Radius}
sphere {<0.1188,0.1619,2.7000>,Teapot_Sphere_Radius}
sphere {<0.2323,0.3166,2.6256>,Teapot_Sphere_Radius}
sphere {<0.2149,0.6398,2.5728>,Teapot_Sphere_Radius}
sphere {<0.1248,0.3715,2.6256>,Teapot_Sphere_Radius}
sphere {<0.2323,0.3166,2.6256>,Teapot_Sphere_Radius}
sphere {<0.4001,0.5451,2.5728>,Teapot_Sphere_Radius}
sphere {<0.3096,0.9216,2.5272>,Teapot_Sphere_Radius}
sphere {<0.2149,0.6398,2.5728>,Teapot_Sphere_Radius}
sphere {<0.4001,0.5451,2.5728>,Teapot_Sphere_Radius}
sphere {<0.5763,0.7853,2.5272>,Teapot_Sphere_Radius}
sphere {<0.3844,1.1443,2.4744>,Teapot_Sphere_Radius}
sphere {<0.3096,0.9216,2.5272>,Teapot_Sphere_Radius}
sphere {<0.5763,0.7853,2.5272>,Teapot_Sphere_Radius}
sphere {<0.7156,0.9750,2.4744>,Teapot_Sphere_Radius}
sphere {<0.4148,1.2347,2.4000>,Teapot_Sphere_Radius}
sphere {<0.3844,1.1443,2.4744>,Teapot_Sphere_Radius}
sphere {<0.7156,0.9750,2.4744>,Teapot_Sphere_Radius}
sphere {<0.7721,1.0521,2.4000>,Teapot_Sphere_Radius}
sphere {<0.2323,0.3166,2.6256>,Teapot_Sphere_Radius}
sphere {<0.1188,0.1619,2.7000>,Teapot_Sphere_Radius}
sphere {<0.1619,0.1188,2.7000>,Teapot_Sphere_Radius}
sphere {<0.3166,0.2323,2.6256>,Teapot_Sphere_Radius}
sphere {<0.4001,0.5451,2.5728>,Teapot_Sphere_Radius}
sphere {<0.2323,0.3166,2.6256>,Teapot_Sphere_Radius}
sphere {<0.3166,0.2323,2.6256>,Teapot_Sphere_Radius}
sphere {<0.5451,0.4001,2.5728>,Teapot_Sphere_Radius}
sphere {<0.5763,0.7853,2.5272>,Teapot_Sphere_Radius}
sphere {<0.4001,0.5451,2.5728>,Teapot_Sphere_Radius}
sphere {<0.5451,0.4001,2.5728>,Teapot_Sphere_Radius}
sphere {<0.7853,0.5763,2.5272>,Teapot_Sphere_Radius}
sphere {<0.7156,0.9750,2.4744>,Teapot_Sphere_Radius}
sphere {<0.5763,0.7853,2.5272>,Teapot_Sphere_Radius}
sphere {<0.7853,0.5763,2.5272>,Teapot_Sphere_Radius}
sphere {<0.9750,0.7156,2.4744>,Teapot_Sphere_Radius}
sphere {<0.7721,1.0521,2.4000>,Teapot_Sphere_Radius}
sphere {<0.7156,0.9750,2.4744>,Teapot_Sphere_Radius}
sphere {<0.9750,0.7156,2.4744>,Teapot_Sphere_Radius}
sphere {<1.0521,0.7721,2.4000>,Teapot_Sphere_Radius}
sphere {<0.3166,0.2323,2.6256>,Teapot_Sphere_Radius}
sphere {<0.1619,0.1188,2.7000>,Teapot_Sphere_Radius}
sphere {<0.1900,0.0638,2.7000>,Teapot_Sphere_Radius}
sphere {<0.3715,0.1248,2.6256>,Teapot_Sphere_Radius}
sphere {<0.5451,0.4001,2.5728>,Teapot_Sphere_Radius}
sphere {<0.3166,0.2323,2.6256>,Teapot_Sphere_Radius}
sphere {<0.3715,0.1248,2.6256>,Teapot_Sphere_Radius}
sphere {<0.6398,0.2149,2.5728>,Teapot_Sphere_Radius}
sphere {<0.7853,0.5763,2.5272>,Teapot_Sphere_Radius}
sphere {<0.5451,0.4001,2.5728>,Teapot_Sphere_Radius}
sphere {<0.6398,0.2149,2.5728>,Teapot_Sphere_Radius}
sphere {<0.9216,0.3096,2.5272>,Teapot_Sphere_Radius}
sphere {<0.9750,0.7156,2.4744>,Teapot_Sphere_Radius}
sphere {<0.7853,0.5763,2.5272>,Teapot_Sphere_Radius}
sphere {<0.9216,0.3096,2.5272>,Teapot_Sphere_Radius}
sphere {<1.1443,0.3844,2.4744>,Teapot_Sphere_Radius}
sphere {<1.0521,0.7721,2.4000>,Teapot_Sphere_Radius}
sphere {<0.9750,0.7156,2.4744>,Teapot_Sphere_Radius}
sphere {<1.1443,0.3844,2.4744>,Teapot_Sphere_Radius}
sphere {<1.2347,0.4148,2.4000>,Teapot_Sphere_Radius}
sphere {<0.3715,0.1248,2.6256>,Teapot_Sphere_Radius}
sphere {<0.1900,0.0638,2.7000>,Teapot_Sphere_Radius}
sphere {<0.2000,0.0000,2.7000>,Teapot_Sphere_Radius}
sphere {<0.3912,0.0000,2.6256>,Teapot_Sphere_Radius}
sphere {<0.6398,0.2149,2.5728>,Teapot_Sphere_Radius}
sphere {<0.3715,0.1248,2.6256>,Teapot_Sphere_Radius}
sphere {<0.3912,0.0000,2.6256>,Teapot_Sphere_Radius}
sphere {<0.6736,0.0000,2.5728>,Teapot_Sphere_Radius}
sphere {<0.9216,0.3096,2.5272>,Teapot_Sphere_Radius}
sphere {<0.6398,0.2149,2.5728>,Teapot_Sphere_Radius}
sphere {<0.6736,0.0000,2.5728>,Teapot_Sphere_Radius}
sphere {<0.9704,0.0000,2.5272>,Teapot_Sphere_Radius}
sphere {<1.1443,0.3844,2.4744>,Teapot_Sphere_Radius}
sphere {<0.9216,0.3096,2.5272>,Teapot_Sphere_Radius}
sphere {<0.9704,0.0000,2.5272>,Teapot_Sphere_Radius}
sphere {<1.2048,0.0000,2.4744>,Teapot_Sphere_Radius}
sphere {<1.2347,0.4148,2.4000>,Teapot_Sphere_Radius}
sphere {<1.1443,0.3844,2.4744>,Teapot_Sphere_Radius}
sphere {<1.2048,0.0000,2.4744>,Teapot_Sphere_Radius}
sphere {<1.3000,0.0000,2.4000>,Teapot_Sphere_Radius}
sphere {<0.7032,0.0000,0.0084>,Teapot_Sphere_Radius}
sphere {<0.7032,0.0000,0.0084>,Teapot_Sphere_Radius}
sphere {<1.1436,0.0000,0.0312>,Teapot_Sphere_Radius}
sphere {<0.7032,0.0000,0.0084>,Teapot_Sphere_Radius}
sphere {<0.6679,0.2243,0.0084>,Teapot_Sphere_Radius}
sphere {<1.0861,0.3649,0.0312>,Teapot_Sphere_Radius}
sphere {<1.3824,0.0000,0.0648>,Teapot_Sphere_Radius}
sphere {<1.1436,0.0000,0.0312>,Teapot_Sphere_Radius}
sphere {<1.0861,0.3649,0.0312>,Teapot_Sphere_Radius}
sphere {<1.3129,0.4410,0.0648>,Teapot_Sphere_Radius}
sphere {<1.4808,0.0000,0.1056>,Teapot_Sphere_Radius}
sphere {<1.3824,0.0000,0.0648>,Teapot_Sphere_Radius}
sphere {<1.3129,0.4410,0.0648>,Teapot_Sphere_Radius}
sphere {<1.4064,0.4724,0.1056>,Teapot_Sphere_Radius}
sphere {<1.5000,0.0000,0.1500>,Teapot_Sphere_Radius}
sphere {<1.4808,0.0000,0.1056>,Teapot_Sphere_Radius}
sphere {<1.4064,0.4724,0.1056>,Teapot_Sphere_Radius}
sphere {<1.4246,0.4786,0.1500>,Teapot_Sphere_Radius}
sphere {<0.6679,0.2243,0.0084>,Teapot_Sphere_Radius}
sphere {<0.6679,0.2243,0.0084>,Teapot_Sphere_Radius}
sphere {<1.0861,0.3649,0.0312>,Teapot_Sphere_Radius}
sphere {<0.6679,0.2243,0.0084>,Teapot_Sphere_Radius}
sphere {<0.5691,0.4176,0.0084>,Teapot_Sphere_Radius}
sphere {<0.9255,0.6792,0.0312>,Teapot_Sphere_Radius}
sphere {<1.3129,0.4410,0.0648>,Teapot_Sphere_Radius}
sphere {<1.0861,0.3649,0.0312>,Teapot_Sphere_Radius}
sphere {<0.9255,0.6792,0.0312>,Teapot_Sphere_Radius}
sphere {<1.1187,0.8210,0.0648>,Teapot_Sphere_Radius}
sphere {<1.4064,0.4724,0.1056>,Teapot_Sphere_Radius}
sphere {<1.3129,0.4410,0.0648>,Teapot_Sphere_Radius}
sphere {<1.1187,0.8210,0.0648>,Teapot_Sphere_Radius}
sphere {<1.1984,0.8795,0.1056>,Teapot_Sphere_Radius}
sphere {<1.4246,0.4786,0.1500>,Teapot_Sphere_Radius}
sphere {<1.4064,0.4724,0.1056>,Teapot_Sphere_Radius}
sphere {<1.1984,0.8795,0.1056>,Teapot_Sphere_Radius}
sphere {<1.2139,0.8909,0.1500>,Teapot_Sphere_Radius}
sphere {<0.5691,0.4176,0.0084>,Teapot_Sphere_Radius}
sphere {<0.5691,0.4176,0.0084>,Teapot_Sphere_Radius}
sphere {<0.9255,0.6792,0.0312>,Teapot_Sphere_Radius}
sphere {<0.5691,0.4176,0.0084>,Teapot_Sphere_Radius}
sphere {<0.4176,0.5691,0.0084>,Teapot_Sphere_Radius}
sphere {<0.6792,0.9255,0.0312>,Teapot_Sphere_Radius}
sphere {<1.1187,0.8210,0.0648>,Teapot_Sphere_Radius}
sphere {<0.9255,0.6792,0.0312>,Teapot_Sphere_Radius}
sphere {<0.6792,0.9255,0.0312>,Teapot_Sphere_Radius}
sphere {<0.8210,1.1187,0.0648>,Teapot_Sphere_Radius}
sphere {<1.1984,0.8795,0.1056>,Teapot_Sphere_Radius}
sphere {<1.1187,0.8210,0.0648>,Teapot_Sphere_Radius}
sphere {<0.8210,1.1187,0.0648>,Teapot_Sphere_Radius}
sphere {<0.8795,1.1984,0.1056>,Teapot_Sphere_Radius}
sphere {<1.2139,0.8909,0.1500>,Teapot_Sphere_Radius}
sphere {<1.1984,0.8795,0.1056>,Teapot_Sphere_Radius}
sphere {<0.8795,1.1984,0.1056>,Teapot_Sphere_Radius}
sphere {<0.8909,1.2139,0.1500>,Teapot_Sphere_Radius}
sphere {<0.4176,0.5691,0.0084>,Teapot_Sphere_Radius}
sphere {<0.4176,0.5691,0.0084>,Teapot_Sphere_Radius}
sphere {<0.6792,0.9255,0.0312>,Teapot_Sphere_Radius}
sphere {<0.4176,0.5691,0.0084>,Teapot_Sphere_Radius}
sphere {<0.2243,0.6679,0.0084>,Teapot_Sphere_Radius}
sphere {<0.3649,1.0861,0.0312>,Teapot_Sphere_Radius}
sphere {<0.8210,1.1187,0.0648>,Teapot_Sphere_Radius}
sphere {<0.6792,0.9255,0.0312>,Teapot_Sphere_Radius}
sphere {<0.3649,1.0861,0.0312>,Teapot_Sphere_Radius}
sphere {<0.4410,1.3129,0.0648>,Teapot_Sphere_Radius}
sphere {<0.8795,1.1984,0.1056>,Teapot_Sphere_Radius}
sphere {<0.8210,1.1187,0.0648>,Teapot_Sphere_Radius}
sphere {<0.4410,1.3129,0.0648>,Teapot_Sphere_Radius}
sphere {<0.4724,1.4064,0.1056>,Teapot_Sphere_Radius}
sphere {<0.8909,1.2139,0.1500>,Teapot_Sphere_Radius}
sphere {<0.8795,1.1984,0.1056>,Teapot_Sphere_Radius}
sphere {<0.4724,1.4064,0.1056>,Teapot_Sphere_Radius}
sphere {<0.4786,1.4246,0.1500>,Teapot_Sphere_Radius}
sphere {<0.2243,0.6679,0.0084>,Teapot_Sphere_Radius}
sphere {<0.2243,0.6679,0.0084>,Teapot_Sphere_Radius}
sphere {<0.3649,1.0861,0.0312>,Teapot_Sphere_Radius}
sphere {<0.2243,0.6679,0.0084>,Teapot_Sphere_Radius}
sphere {<0.0000,0.7032,0.0084>,Teapot_Sphere_Radius}
sphere {<0.0000,1.1436,0.0312>,Teapot_Sphere_Radius}
sphere {<0.4410,1.3129,0.0648>,Teapot_Sphere_Radius}
sphere {<0.3649,1.0861,0.0312>,Teapot_Sphere_Radius}
sphere {<0.0000,1.1436,0.0312>,Teapot_Sphere_Radius}
sphere {<0.0000,1.3824,0.0648>,Teapot_Sphere_Radius}
sphere {<0.4724,1.4064,0.1056>,Teapot_Sphere_Radius}
sphere {<0.4410,1.3129,0.0648>,Teapot_Sphere_Radius}
sphere {<0.0000,1.3824,0.0648>,Teapot_Sphere_Radius}
sphere {<0.0000,1.4808,0.1056>,Teapot_Sphere_Radius}
sphere {<0.4786,1.4246,0.1500>,Teapot_Sphere_Radius}
sphere {<0.4724,1.4064,0.1056>,Teapot_Sphere_Radius}
sphere {<0.0000,1.4808,0.1056>,Teapot_Sphere_Radius}
sphere {<0.0000,1.5000,0.1500>,Teapot_Sphere_Radius}
sphere {<0.0000,0.7032,0.0084>,Teapot_Sphere_Radius}
sphere {<0.0000,0.7032,0.0084>,Teapot_Sphere_Radius}
sphere {<0.0000,1.1436,0.0312>,Teapot_Sphere_Radius}
sphere {<0.0000,0.7032,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.2243,0.6679,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.3649,1.0861,0.0312>,Teapot_Sphere_Radius}
sphere {<0.0000,1.3824,0.0648>,Teapot_Sphere_Radius}
sphere {<0.0000,1.1436,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.3649,1.0861,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.4410,1.3129,0.0648>,Teapot_Sphere_Radius}
sphere {<0.0000,1.4808,0.1056>,Teapot_Sphere_Radius}
sphere {<0.0000,1.3824,0.0648>,Teapot_Sphere_Radius}
sphere {<-0.4410,1.3129,0.0648>,Teapot_Sphere_Radius}
sphere {<-0.4724,1.4064,0.1056>,Teapot_Sphere_Radius}
sphere {<0.0000,1.5000,0.1500>,Teapot_Sphere_Radius}
sphere {<0.0000,1.4808,0.1056>,Teapot_Sphere_Radius}
sphere {<-0.4724,1.4064,0.1056>,Teapot_Sphere_Radius}
sphere {<-0.4786,1.4246,0.1500>,Teapot_Sphere_Radius}
sphere {<-0.2243,0.6679,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.2243,0.6679,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.3649,1.0861,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.2243,0.6679,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.4176,0.5691,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.6792,0.9255,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.4410,1.3129,0.0648>,Teapot_Sphere_Radius}
sphere {<-0.3649,1.0861,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.6792,0.9255,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.8210,1.1187,0.0648>,Teapot_Sphere_Radius}
sphere {<-0.4724,1.4064,0.1056>,Teapot_Sphere_Radius}
sphere {<-0.4410,1.3129,0.0648>,Teapot_Sphere_Radius}
sphere {<-0.8210,1.1187,0.0648>,Teapot_Sphere_Radius}
sphere {<-0.8795,1.1984,0.1056>,Teapot_Sphere_Radius}
sphere {<-0.4786,1.4246,0.1500>,Teapot_Sphere_Radius}
sphere {<-0.4724,1.4064,0.1056>,Teapot_Sphere_Radius}
sphere {<-0.8795,1.1984,0.1056>,Teapot_Sphere_Radius}
sphere {<-0.8909,1.2139,0.1500>,Teapot_Sphere_Radius}
sphere {<-0.4176,0.5691,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.4176,0.5691,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.6792,0.9255,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.4176,0.5691,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.5691,0.4176,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.9255,0.6792,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.8210,1.1187,0.0648>,Teapot_Sphere_Radius}
sphere {<-0.6792,0.9255,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.9255,0.6792,0.0312>,Teapot_Sphere_Radius}
sphere {<-1.1187,0.8210,0.0648>,Teapot_Sphere_Radius}
sphere {<-0.8795,1.1984,0.1056>,Teapot_Sphere_Radius}
sphere {<-0.8210,1.1187,0.0648>,Teapot_Sphere_Radius}
sphere {<-1.1187,0.8210,0.0648>,Teapot_Sphere_Radius}
sphere {<-1.1984,0.8795,0.1056>,Teapot_Sphere_Radius}
sphere {<-0.8909,1.2139,0.1500>,Teapot_Sphere_Radius}
sphere {<-0.8795,1.1984,0.1056>,Teapot_Sphere_Radius}
sphere {<-1.1984,0.8795,0.1056>,Teapot_Sphere_Radius}
sphere {<-1.2139,0.8909,0.1500>,Teapot_Sphere_Radius}
sphere {<-0.5691,0.4176,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.5691,0.4176,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.9255,0.6792,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.5691,0.4176,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.6679,0.2243,0.0084>,Teapot_Sphere_Radius}
sphere {<-1.0861,0.3649,0.0312>,Teapot_Sphere_Radius}
sphere {<-1.1187,0.8210,0.0648>,Teapot_Sphere_Radius}
sphere {<-0.9255,0.6792,0.0312>,Teapot_Sphere_Radius}
sphere {<-1.0861,0.3649,0.0312>,Teapot_Sphere_Radius}
sphere {<-1.3129,0.4410,0.0648>,Teapot_Sphere_Radius}
sphere {<-1.1984,0.8795,0.1056>,Teapot_Sphere_Radius}
sphere {<-1.1187,0.8210,0.0648>,Teapot_Sphere_Radius}
sphere {<-1.3129,0.4410,0.0648>,Teapot_Sphere_Radius}
sphere {<-1.4064,0.4724,0.1056>,Teapot_Sphere_Radius}
sphere {<-1.2139,0.8909,0.1500>,Teapot_Sphere_Radius}
sphere {<-1.1984,0.8795,0.1056>,Teapot_Sphere_Radius}
sphere {<-1.4064,0.4724,0.1056>,Teapot_Sphere_Radius}
sphere {<-1.4246,0.4786,0.1500>,Teapot_Sphere_Radius}
sphere {<-0.6679,0.2243,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.6679,0.2243,0.0084>,Teapot_Sphere_Radius}
sphere {<-1.0861,0.3649,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.6679,0.2243,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.7032,0.0000,0.0084>,Teapot_Sphere_Radius}
sphere {<-1.1436,0.0000,0.0312>,Teapot_Sphere_Radius}
sphere {<-1.3129,0.4410,0.0648>,Teapot_Sphere_Radius}
sphere {<-1.0861,0.3649,0.0312>,Teapot_Sphere_Radius}
sphere {<-1.1436,0.0000,0.0312>,Teapot_Sphere_Radius}
sphere {<-1.3824,0.0000,0.0648>,Teapot_Sphere_Radius}
sphere {<-1.4064,0.4724,0.1056>,Teapot_Sphere_Radius}
sphere {<-1.3129,0.4410,0.0648>,Teapot_Sphere_Radius}
sphere {<-1.3824,0.0000,0.0648>,Teapot_Sphere_Radius}
sphere {<-1.4808,0.0000,0.1056>,Teapot_Sphere_Radius}
sphere {<-1.4246,0.4786,0.1500>,Teapot_Sphere_Radius}
sphere {<-1.4064,0.4724,0.1056>,Teapot_Sphere_Radius}
sphere {<-1.4808,0.0000,0.1056>,Teapot_Sphere_Radius}
sphere {<-1.5000,0.0000,0.1500>,Teapot_Sphere_Radius}
sphere {<-0.7032,0.0000,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.7032,0.0000,0.0084>,Teapot_Sphere_Radius}
sphere {<-1.1436,0.0000,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.7032,0.0000,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.6679,-0.2243,0.0084>,Teapot_Sphere_Radius}
sphere {<-1.0861,-0.3649,0.0312>,Teapot_Sphere_Radius}
sphere {<-1.3824,0.0000,0.0648>,Teapot_Sphere_Radius}
sphere {<-1.1436,0.0000,0.0312>,Teapot_Sphere_Radius}
sphere {<-1.0861,-0.3649,0.0312>,Teapot_Sphere_Radius}
sphere {<-1.3129,-0.4410,0.0648>,Teapot_Sphere_Radius}
sphere {<-1.4808,0.0000,0.1056>,Teapot_Sphere_Radius}
sphere {<-1.3824,0.0000,0.0648>,Teapot_Sphere_Radius}
sphere {<-1.3129,-0.4410,0.0648>,Teapot_Sphere_Radius}
sphere {<-1.4064,-0.4724,0.1056>,Teapot_Sphere_Radius}
sphere {<-1.5000,0.0000,0.1500>,Teapot_Sphere_Radius}
sphere {<-1.4808,0.0000,0.1056>,Teapot_Sphere_Radius}
sphere {<-1.4064,-0.4724,0.1056>,Teapot_Sphere_Radius}
sphere {<-1.4246,-0.4786,0.1500>,Teapot_Sphere_Radius}
sphere {<-0.6679,-0.2243,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.6679,-0.2243,0.0084>,Teapot_Sphere_Radius}
sphere {<-1.0861,-0.3649,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.6679,-0.2243,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.5691,-0.4176,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.9255,-0.6792,0.0312>,Teapot_Sphere_Radius}
sphere {<-1.3129,-0.4410,0.0648>,Teapot_Sphere_Radius}
sphere {<-1.0861,-0.3649,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.9255,-0.6792,0.0312>,Teapot_Sphere_Radius}
sphere {<-1.1187,-0.8210,0.0648>,Teapot_Sphere_Radius}
sphere {<-1.4064,-0.4724,0.1056>,Teapot_Sphere_Radius}
sphere {<-1.3129,-0.4410,0.0648>,Teapot_Sphere_Radius}
sphere {<-1.1187,-0.8210,0.0648>,Teapot_Sphere_Radius}
sphere {<-1.1984,-0.8795,0.1056>,Teapot_Sphere_Radius}
sphere {<-1.4246,-0.4786,0.1500>,Teapot_Sphere_Radius}
sphere {<-1.4064,-0.4724,0.1056>,Teapot_Sphere_Radius}
sphere {<-1.1984,-0.8795,0.1056>,Teapot_Sphere_Radius}
sphere {<-1.2139,-0.8909,0.1500>,Teapot_Sphere_Radius}
sphere {<-0.5691,-0.4176,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.5691,-0.4176,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.9255,-0.6792,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.5691,-0.4176,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.4176,-0.5691,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.6792,-0.9255,0.0312>,Teapot_Sphere_Radius}
sphere {<-1.1187,-0.8210,0.0648>,Teapot_Sphere_Radius}
sphere {<-0.9255,-0.6792,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.6792,-0.9255,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.8210,-1.1187,0.0648>,Teapot_Sphere_Radius}
sphere {<-1.1984,-0.8795,0.1056>,Teapot_Sphere_Radius}
sphere {<-1.1187,-0.8210,0.0648>,Teapot_Sphere_Radius}
sphere {<-0.8210,-1.1187,0.0648>,Teapot_Sphere_Radius}
sphere {<-0.8795,-1.1984,0.1056>,Teapot_Sphere_Radius}
sphere {<-1.2139,-0.8909,0.1500>,Teapot_Sphere_Radius}
sphere {<-1.1984,-0.8795,0.1056>,Teapot_Sphere_Radius}
sphere {<-0.8795,-1.1984,0.1056>,Teapot_Sphere_Radius}
sphere {<-0.8909,-1.2139,0.1500>,Teapot_Sphere_Radius}
sphere {<-0.4176,-0.5691,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.4176,-0.5691,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.6792,-0.9255,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.4176,-0.5691,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.2243,-0.6679,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.3649,-1.0861,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.8210,-1.1187,0.0648>,Teapot_Sphere_Radius}
sphere {<-0.6792,-0.9255,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.3649,-1.0861,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.4410,-1.3129,0.0648>,Teapot_Sphere_Radius}
sphere {<-0.8795,-1.1984,0.1056>,Teapot_Sphere_Radius}
sphere {<-0.8210,-1.1187,0.0648>,Teapot_Sphere_Radius}
sphere {<-0.4410,-1.3129,0.0648>,Teapot_Sphere_Radius}
sphere {<-0.4724,-1.4064,0.1056>,Teapot_Sphere_Radius}
sphere {<-0.8909,-1.2139,0.1500>,Teapot_Sphere_Radius}
sphere {<-0.8795,-1.1984,0.1056>,Teapot_Sphere_Radius}
sphere {<-0.4724,-1.4064,0.1056>,Teapot_Sphere_Radius}
sphere {<-0.4786,-1.4246,0.1500>,Teapot_Sphere_Radius}
sphere {<-0.2243,-0.6679,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.2243,-0.6679,0.0084>,Teapot_Sphere_Radius}
sphere {<-0.3649,-1.0861,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.2243,-0.6679,0.0084>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.7032,0.0084>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.1436,0.0312>,Teapot_Sphere_Radius}
sphere {<-0.4410,-1.3129,0.0648>,Teapot_Sphere_Radius}
sphere {<-0.3649,-1.0861,0.0312>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.1436,0.0312>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.3824,0.0648>,Teapot_Sphere_Radius}
sphere {<-0.4724,-1.4064,0.1056>,Teapot_Sphere_Radius}
sphere {<-0.4410,-1.3129,0.0648>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.3824,0.0648>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.4808,0.1056>,Teapot_Sphere_Radius}
sphere {<-0.4786,-1.4246,0.1500>,Teapot_Sphere_Radius}
sphere {<-0.4724,-1.4064,0.1056>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.4808,0.1056>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.5000,0.1500>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.7032,0.0084>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.7032,0.0084>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.1436,0.0312>,Teapot_Sphere_Radius}
sphere {<0.0000,-0.7032,0.0084>,Teapot_Sphere_Radius}
sphere {<0.2243,-0.6679,0.0084>,Teapot_Sphere_Radius}
sphere {<0.3649,-1.0861,0.0312>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.3824,0.0648>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.1436,0.0312>,Teapot_Sphere_Radius}
sphere {<0.3649,-1.0861,0.0312>,Teapot_Sphere_Radius}
sphere {<0.4410,-1.3129,0.0648>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.4808,0.1056>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.3824,0.0648>,Teapot_Sphere_Radius}
sphere {<0.4410,-1.3129,0.0648>,Teapot_Sphere_Radius}
sphere {<0.4724,-1.4064,0.1056>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.5000,0.1500>,Teapot_Sphere_Radius}
sphere {<0.0000,-1.4808,0.1056>,Teapot_Sphere_Radius}
sphere {<0.4724,-1.4064,0.1056>,Teapot_Sphere_Radius}
sphere {<0.4786,-1.4246,0.1500>,Teapot_Sphere_Radius}
sphere {<0.2243,-0.6679,0.0084>,Teapot_Sphere_Radius}
sphere {<0.2243,-0.6679,0.0084>,Teapot_Sphere_Radius}
sphere {<0.3649,-1.0861,0.0312>,Teapot_Sphere_Radius}
sphere {<0.2243,-0.6679,0.0084>,Teapot_Sphere_Radius}
sphere {<0.4176,-0.5691,0.0084>,Teapot_Sphere_Radius}
sphere {<0.6792,-0.9255,0.0312>,Teapot_Sphere_Radius}
sphere {<0.4410,-1.3129,0.0648>,Teapot_Sphere_Radius}
sphere {<0.3649,-1.0861,0.0312>,Teapot_Sphere_Radius}
sphere {<0.6792,-0.9255,0.0312>,Teapot_Sphere_Radius}
sphere {<0.8210,-1.1187,0.0648>,Teapot_Sphere_Radius}
sphere {<0.4724,-1.4064,0.1056>,Teapot_Sphere_Radius}
sphere {<0.4410,-1.3129,0.0648>,Teapot_Sphere_Radius}
sphere {<0.8210,-1.1187,0.0648>,Teapot_Sphere_Radius}
sphere {<0.8795,-1.1984,0.1056>,Teapot_Sphere_Radius}
sphere {<0.4786,-1.4246,0.1500>,Teapot_Sphere_Radius}
sphere {<0.4724,-1.4064,0.1056>,Teapot_Sphere_Radius}
sphere {<0.8795,-1.1984,0.1056>,Teapot_Sphere_Radius}
sphere {<0.8909,-1.2139,0.1500>,Teapot_Sphere_Radius}
sphere {<0.4176,-0.5691,0.0084>,Teapot_Sphere_Radius}
sphere {<0.4176,-0.5691,0.0084>,Teapot_Sphere_Radius}
sphere {<0.6792,-0.9255,0.0312>,Teapot_Sphere_Radius}
sphere {<0.4176,-0.5691,0.0084>,Teapot_Sphere_Radius}
sphere {<0.5691,-0.4176,0.0084>,Teapot_Sphere_Radius}
sphere {<0.9255,-0.6792,0.0312>,Teapot_Sphere_Radius}
sphere {<0.8210,-1.1187,0.0648>,Teapot_Sphere_Radius}
sphere {<0.6792,-0.9255,0.0312>,Teapot_Sphere_Radius}
sphere {<0.9255,-0.6792,0.0312>,Teapot_Sphere_Radius}
sphere {<1.1187,-0.8210,0.0648>,Teapot_Sphere_Radius}
sphere {<0.8795,-1.1984,0.1056>,Teapot_Sphere_Radius}
sphere {<0.8210,-1.1187,0.0648>,Teapot_Sphere_Radius}
sphere {<1.1187,-0.8210,0.0648>,Teapot_Sphere_Radius}
sphere {<1.1984,-0.8795,0.1056>,Teapot_Sphere_Radius}
sphere {<0.8909,-1.2139,0.1500>,Teapot_Sphere_Radius}
sphere {<0.8795,-1.1984,0.1056>,Teapot_Sphere_Radius}
sphere {<1.1984,-0.8795,0.1056>,Teapot_Sphere_Radius}
sphere {<1.2139,-0.8909,0.1500>,Teapot_Sphere_Radius}
sphere {<0.5691,-0.4176,0.0084>,Teapot_Sphere_Radius}
sphere {<0.5691,-0.4176,0.0084>,Teapot_Sphere_Radius}
sphere {<0.9255,-0.6792,0.0312>,Teapot_Sphere_Radius}
sphere {<0.5691,-0.4176,0.0084>,Teapot_Sphere_Radius}
sphere {<0.6679,-0.2243,0.0084>,Teapot_Sphere_Radius}
sphere {<1.0861,-0.3649,0.0312>,Teapot_Sphere_Radius}
sphere {<1.1187,-0.8210,0.0648>,Teapot_Sphere_Radius}
sphere {<0.9255,-0.6792,0.0312>,Teapot_Sphere_Radius}
sphere {<1.0861,-0.3649,0.0312>,Teapot_Sphere_Radius}
sphere {<1.3129,-0.4410,0.0648>,Teapot_Sphere_Radius}
sphere {<1.1984,-0.8795,0.1056>,Teapot_Sphere_Radius}
sphere {<1.1187,-0.8210,0.0648>,Teapot_Sphere_Radius}
sphere {<1.3129,-0.4410,0.0648>,Teapot_Sphere_Radius}
sphere {<1.4064,-0.4724,0.1056>,Teapot_Sphere_Radius}
sphere {<1.2139,-0.8909,0.1500>,Teapot_Sphere_Radius}
sphere {<1.1984,-0.8795,0.1056>,Teapot_Sphere_Radius}
sphere {<1.4064,-0.4724,0.1056>,Teapot_Sphere_Radius}
sphere {<1.4246,-0.4786,0.1500>,Teapot_Sphere_Radius}
sphere {<0.6679,-0.2243,0.0084>,Teapot_Sphere_Radius}
sphere {<0.6679,-0.2243,0.0084>,Teapot_Sphere_Radius}
sphere {<1.0861,-0.3649,0.0312>,Teapot_Sphere_Radius}
sphere {<0.6679,-0.2243,0.0084>,Teapot_Sphere_Radius}
sphere {<0.7032,0.0000,0.0084>,Teapot_Sphere_Radius}
sphere {<1.1436,0.0000,0.0312>,Teapot_Sphere_Radius}
sphere {<1.3129,-0.4410,0.0648>,Teapot_Sphere_Radius}
sphere {<1.0861,-0.3649,0.0312>,Teapot_Sphere_Radius}
sphere {<1.1436,0.0000,0.0312>,Teapot_Sphere_Radius}
sphere {<1.3824,0.0000,0.0648>,Teapot_Sphere_Radius}
sphere {<1.4064,-0.4724,0.1056>,Teapot_Sphere_Radius}
sphere {<1.3129,-0.4410,0.0648>,Teapot_Sphere_Radius}
sphere {<1.3824,0.0000,0.0648>,Teapot_Sphere_Radius}
sphere {<1.4808,0.0000,0.1056>,Teapot_Sphere_Radius}
sphere {<1.4246,-0.4786,0.1500>,Teapot_Sphere_Radius}
sphere {<1.4064,-0.4724,0.1056>,Teapot_Sphere_Radius}
sphere {<1.4808,0.0000,0.1056>,Teapot_Sphere_Radius}
sphere {<1.5000,0.0000,0.1500>,Teapot_Sphere_Radius}

}
#declare Cyl2_Pot = union 
{ 
cylinder{<1.4000,0.0000,2.4000>,<1.3297,-0.4467,2.4000>,0.025}
cylinder{<1.3110,-0.4404,2.4630>,<1.3804,0.0000,2.4630>,0.025}
cylinder{<1.3804,0.0000,2.4630>,<1.3110,-0.4404,2.4630>,0.025}
cylinder{<1.3204,-0.4435,2.4945>,<1.3902,0.0000,2.4945>,0.025}
cylinder{<1.3902,0.0000,2.4945>,<1.3204,-0.4435,2.4945>,0.025}
cylinder{<1.3485,-0.4530,2.4945>,<1.4198,0.0000,2.4945>,0.025}
cylinder{<1.4198,0.0000,2.4945>,<1.3485,-0.4530,2.4945>,0.025}
cylinder{<1.3863,-0.4657,2.4630>,<1.4596,0.0000,2.4630>,0.025}
cylinder{<1.4596,0.0000,2.4630>,<1.3863,-0.4657,2.4630>,0.025}
cylinder{<1.4246,-0.4786,2.4000>,<1.5000,0.0000,2.4000>,0.025}
cylinder{<1.3297,-0.4467,2.4000>,<1.1330,-0.8315,2.4000>,0.025}
cylinder{<1.1171,-0.8198,2.4630>,<1.3110,-0.4404,2.4630>,0.025}
cylinder{<1.3110,-0.4404,2.4630>,<1.1171,-0.8198,2.4630>,0.025}
cylinder{<1.1251,-0.8257,2.4945>,<1.3204,-0.4435,2.4945>,0.025}
cylinder{<1.3204,-0.4435,2.4945>,<1.1251,-0.8257,2.4945>,0.025}
cylinder{<1.1490,-0.8432,2.4945>,<1.3485,-0.4530,2.4945>,0.025}
cylinder{<1.3485,-0.4530,2.4945>,<1.1490,-0.8432,2.4945>,0.025}
cylinder{<1.1812,-0.8669,2.4630>,<1.3863,-0.4657,2.4630>,0.025}
cylinder{<1.3863,-0.4657,2.4630>,<1.1812,-0.8669,2.4630>,0.025}
cylinder{<1.2139,-0.8909,2.4000>,<1.4246,-0.4786,2.4000>,0.025}
cylinder{<1.1330,-0.8315,2.4000>,<0.8315,-1.1330,2.4000>,0.025}
cylinder{<0.8198,-1.1171,2.4630>,<1.1171,-0.8198,2.4630>,0.025}
cylinder{<1.1171,-0.8198,2.4630>,<0.8198,-1.1171,2.4630>,0.025}
cylinder{<0.8257,-1.1251,2.4945>,<1.1251,-0.8257,2.4945>,0.025}
cylinder{<1.1251,-0.8257,2.4945>,<0.8257,-1.1251,2.4945>,0.025}
cylinder{<0.8432,-1.1490,2.4945>,<1.1490,-0.8432,2.4945>,0.025}
cylinder{<1.1490,-0.8432,2.4945>,<0.8432,-1.1490,2.4945>,0.025}
cylinder{<0.8669,-1.1812,2.4630>,<1.1812,-0.8669,2.4630>,0.025}
cylinder{<1.1812,-0.8669,2.4630>,<0.8669,-1.1812,2.4630>,0.025}
cylinder{<0.8909,-1.2139,2.4000>,<1.2139,-0.8909,2.4000>,0.025}
cylinder{<0.8315,-1.1330,2.4000>,<0.4467,-1.3297,2.4000>,0.025}
cylinder{<0.4404,-1.3110,2.4630>,<0.8198,-1.1171,2.4630>,0.025}
cylinder{<0.8198,-1.1171,2.4630>,<0.4404,-1.3110,2.4630>,0.025}
cylinder{<0.4435,-1.3204,2.4945>,<0.8257,-1.1251,2.4945>,0.025}
cylinder{<0.8257,-1.1251,2.4945>,<0.4435,-1.3204,2.4945>,0.025}
cylinder{<0.4530,-1.3485,2.4945>,<0.8432,-1.1490,2.4945>,0.025}
cylinder{<0.8432,-1.1490,2.4945>,<0.4530,-1.3485,2.4945>,0.025}
cylinder{<0.4657,-1.3863,2.4630>,<0.8669,-1.1812,2.4630>,0.025}
cylinder{<0.8669,-1.1812,2.4630>,<0.4657,-1.3863,2.4630>,0.025}
cylinder{<0.4786,-1.4246,2.4000>,<0.8909,-1.2139,2.4000>,0.025}
cylinder{<0.4467,-1.3297,2.4000>,<0.0000,-1.4000,2.4000>,0.025}
cylinder{<0.0000,-1.3804,2.4630>,<0.4404,-1.3110,2.4630>,0.025}
cylinder{<0.4404,-1.3110,2.4630>,<0.0000,-1.3804,2.4630>,0.025}
cylinder{<0.0000,-1.3902,2.4945>,<0.4435,-1.3204,2.4945>,0.025}
cylinder{<0.4435,-1.3204,2.4945>,<0.0000,-1.3902,2.4945>,0.025}
cylinder{<0.0000,-1.4198,2.4945>,<0.4530,-1.3485,2.4945>,0.025}
cylinder{<0.4530,-1.3485,2.4945>,<0.0000,-1.4198,2.4945>,0.025}
cylinder{<0.0000,-1.4596,2.4630>,<0.4657,-1.3863,2.4630>,0.025}
cylinder{<0.4657,-1.3863,2.4630>,<0.0000,-1.4596,2.4630>,0.025}
cylinder{<0.0000,-1.5000,2.4000>,<0.4786,-1.4246,2.4000>,0.025}
cylinder{<0.0000,-1.4000,2.4000>,<-0.4467,-1.3297,2.4000>,0.025}
cylinder{<-0.4404,-1.3110,2.4630>,<0.0000,-1.3804,2.4630>,0.025}
cylinder{<0.0000,-1.3804,2.4630>,<-0.4404,-1.3110,2.4630>,0.025}
cylinder{<-0.4435,-1.3204,2.4945>,<0.0000,-1.3902,2.4945>,0.025}
cylinder{<0.0000,-1.3902,2.4945>,<-0.4435,-1.3204,2.4945>,0.025}
cylinder{<-0.4530,-1.3485,2.4945>,<0.0000,-1.4198,2.4945>,0.025}
cylinder{<0.0000,-1.4198,2.4945>,<-0.4530,-1.3485,2.4945>,0.025}
cylinder{<-0.4657,-1.3863,2.4630>,<0.0000,-1.4596,2.4630>,0.025}
cylinder{<0.0000,-1.4596,2.4630>,<-0.4657,-1.3863,2.4630>,0.025}
cylinder{<-0.4786,-1.4246,2.4000>,<0.0000,-1.5000,2.4000>,0.025}
cylinder{<-0.4467,-1.3297,2.4000>,<-0.8315,-1.1330,2.4000>,0.025}
cylinder{<-0.8198,-1.1171,2.4630>,<-0.4404,-1.3110,2.4630>,0.025}
cylinder{<-0.4404,-1.3110,2.4630>,<-0.8198,-1.1171,2.4630>,0.025}
cylinder{<-0.8257,-1.1251,2.4945>,<-0.4435,-1.3204,2.4945>,0.025}
cylinder{<-0.4435,-1.3204,2.4945>,<-0.8257,-1.1251,2.4945>,0.025}
cylinder{<-0.8432,-1.1490,2.4945>,<-0.4530,-1.3485,2.4945>,0.025}
cylinder{<-0.4530,-1.3485,2.4945>,<-0.8432,-1.1490,2.4945>,0.025}
cylinder{<-0.8669,-1.1812,2.4630>,<-0.4657,-1.3863,2.4630>,0.025}
cylinder{<-0.4657,-1.3863,2.4630>,<-0.8669,-1.1812,2.4630>,0.025}
cylinder{<-0.8909,-1.2139,2.4000>,<-0.4786,-1.4246,2.4000>,0.025}
cylinder{<-0.8315,-1.1330,2.4000>,<-1.1330,-0.8315,2.4000>,0.025}
cylinder{<-1.1171,-0.8198,2.4630>,<-0.8198,-1.1171,2.4630>,0.025}
cylinder{<-0.8198,-1.1171,2.4630>,<-1.1171,-0.8198,2.4630>,0.025}
cylinder{<-1.1251,-0.8257,2.4945>,<-0.8257,-1.1251,2.4945>,0.025}
cylinder{<-0.8257,-1.1251,2.4945>,<-1.1251,-0.8257,2.4945>,0.025}
cylinder{<-1.1490,-0.8432,2.4945>,<-0.8432,-1.1490,2.4945>,0.025}
cylinder{<-0.8432,-1.1490,2.4945>,<-1.1490,-0.8432,2.4945>,0.025}
cylinder{<-1.1812,-0.8669,2.4630>,<-0.8669,-1.1812,2.4630>,0.025}
cylinder{<-0.8669,-1.1812,2.4630>,<-1.1812,-0.8669,2.4630>,0.025}
cylinder{<-1.2139,-0.8909,2.4000>,<-0.8909,-1.2139,2.4000>,0.025}
cylinder{<-1.1330,-0.8315,2.4000>,<-1.3297,-0.4467,2.4000>,0.025}
cylinder{<-1.3110,-0.4404,2.4630>,<-1.1171,-0.8198,2.4630>,0.025}
cylinder{<-1.1171,-0.8198,2.4630>,<-1.3110,-0.4404,2.4630>,0.025}
cylinder{<-1.3204,-0.4435,2.4945>,<-1.1251,-0.8257,2.4945>,0.025}
cylinder{<-1.1251,-0.8257,2.4945>,<-1.3204,-0.4435,2.4945>,0.025}
cylinder{<-1.3485,-0.4530,2.4945>,<-1.1490,-0.8432,2.4945>,0.025}
cylinder{<-1.1490,-0.8432,2.4945>,<-1.3485,-0.4530,2.4945>,0.025}
cylinder{<-1.3863,-0.4657,2.4630>,<-1.1812,-0.8669,2.4630>,0.025}
cylinder{<-1.1812,-0.8669,2.4630>,<-1.3863,-0.4657,2.4630>,0.025}
cylinder{<-1.4246,-0.4786,2.4000>,<-1.2139,-0.8909,2.4000>,0.025}
cylinder{<-1.3297,-0.4467,2.4000>,<-1.4000,0.0000,2.4000>,0.025}
cylinder{<-1.3804,0.0000,2.4630>,<-1.3110,-0.4404,2.4630>,0.025}
cylinder{<-1.3110,-0.4404,2.4630>,<-1.3804,0.0000,2.4630>,0.025}
cylinder{<-1.3902,0.0000,2.4945>,<-1.3204,-0.4435,2.4945>,0.025}
cylinder{<-1.3204,-0.4435,2.4945>,<-1.3902,0.0000,2.4945>,0.025}
cylinder{<-1.4198,0.0000,2.4945>,<-1.3485,-0.4530,2.4945>,0.025}
cylinder{<-1.3485,-0.4530,2.4945>,<-1.4198,0.0000,2.4945>,0.025}
cylinder{<-1.4596,0.0000,2.4630>,<-1.3863,-0.4657,2.4630>,0.025}
cylinder{<-1.3863,-0.4657,2.4630>,<-1.4596,0.0000,2.4630>,0.025}
cylinder{<-1.5000,0.0000,2.4000>,<-1.4246,-0.4786,2.4000>,0.025}
cylinder{<-1.4000,0.0000,2.4000>,<-1.3297,0.4467,2.4000>,0.025}
cylinder{<-1.3110,0.4404,2.4630>,<-1.3804,0.0000,2.4630>,0.025}
cylinder{<-1.3804,0.0000,2.4630>,<-1.3110,0.4404,2.4630>,0.025}
cylinder{<-1.3204,0.4435,2.4945>,<-1.3902,0.0000,2.4945>,0.025}
cylinder{<-1.3902,0.0000,2.4945>,<-1.3204,0.4435,2.4945>,0.025}
cylinder{<-1.3485,0.4530,2.4945>,<-1.4198,0.0000,2.4945>,0.025}
cylinder{<-1.4198,0.0000,2.4945>,<-1.3485,0.4530,2.4945>,0.025}
cylinder{<-1.3863,0.4657,2.4630>,<-1.4596,0.0000,2.4630>,0.025}
cylinder{<-1.4596,0.0000,2.4630>,<-1.3863,0.4657,2.4630>,0.025}
cylinder{<-1.4246,0.4786,2.4000>,<-1.5000,0.0000,2.4000>,0.025}
cylinder{<-1.3297,0.4467,2.4000>,<-1.1330,0.8315,2.4000>,0.025}
cylinder{<-1.1171,0.8198,2.4630>,<-1.3110,0.4404,2.4630>,0.025}
cylinder{<-1.3110,0.4404,2.4630>,<-1.1171,0.8198,2.4630>,0.025}
cylinder{<-1.1251,0.8257,2.4945>,<-1.3204,0.4435,2.4945>,0.025}
cylinder{<-1.3204,0.4435,2.4945>,<-1.1251,0.8257,2.4945>,0.025}
cylinder{<-1.1490,0.8432,2.4945>,<-1.3485,0.4530,2.4945>,0.025}
cylinder{<-1.3485,0.4530,2.4945>,<-1.1490,0.8432,2.4945>,0.025}
cylinder{<-1.1812,0.8669,2.4630>,<-1.3863,0.4657,2.4630>,0.025}
cylinder{<-1.3863,0.4657,2.4630>,<-1.1812,0.8669,2.4630>,0.025}
cylinder{<-1.2139,0.8909,2.4000>,<-1.4246,0.4786,2.4000>,0.025}
cylinder{<-1.1330,0.8315,2.4000>,<-0.8315,1.1330,2.4000>,0.025}
cylinder{<-0.8198,1.1171,2.4630>,<-1.1171,0.8198,2.4630>,0.025}
cylinder{<-1.1171,0.8198,2.4630>,<-0.8198,1.1171,2.4630>,0.025}
cylinder{<-0.8257,1.1251,2.4945>,<-1.1251,0.8257,2.4945>,0.025}
cylinder{<-1.1251,0.8257,2.4945>,<-0.8257,1.1251,2.4945>,0.025}
cylinder{<-0.8432,1.1490,2.4945>,<-1.1490,0.8432,2.4945>,0.025}
cylinder{<-1.1490,0.8432,2.4945>,<-0.8432,1.1490,2.4945>,0.025}
cylinder{<-0.8669,1.1812,2.4630>,<-1.1812,0.8669,2.4630>,0.025}
cylinder{<-1.1812,0.8669,2.4630>,<-0.8669,1.1812,2.4630>,0.025}
cylinder{<-0.8909,1.2139,2.4000>,<-1.2139,0.8909,2.4000>,0.025}
cylinder{<-0.8315,1.1330,2.4000>,<-0.4467,1.3297,2.4000>,0.025}
cylinder{<-0.4404,1.3110,2.4630>,<-0.8198,1.1171,2.4630>,0.025}
cylinder{<-0.8198,1.1171,2.4630>,<-0.4404,1.3110,2.4630>,0.025}
cylinder{<-0.4435,1.3204,2.4945>,<-0.8257,1.1251,2.4945>,0.025}
cylinder{<-0.8257,1.1251,2.4945>,<-0.4435,1.3204,2.4945>,0.025}
cylinder{<-0.4530,1.3485,2.4945>,<-0.8432,1.1490,2.4945>,0.025}
cylinder{<-0.8432,1.1490,2.4945>,<-0.4530,1.3485,2.4945>,0.025}
cylinder{<-0.4657,1.3863,2.4630>,<-0.8669,1.1812,2.4630>,0.025}
cylinder{<-0.8669,1.1812,2.4630>,<-0.4657,1.3863,2.4630>,0.025}
cylinder{<-0.4786,1.4246,2.4000>,<-0.8909,1.2139,2.4000>,0.025}
cylinder{<-0.4467,1.3297,2.4000>,<0.0000,1.4000,2.4000>,0.025}
cylinder{<0.0000,1.3804,2.4630>,<-0.4404,1.3110,2.4630>,0.025}
cylinder{<-0.4404,1.3110,2.4630>,<0.0000,1.3804,2.4630>,0.025}
cylinder{<0.0000,1.3902,2.4945>,<-0.4435,1.3204,2.4945>,0.025}
cylinder{<-0.4435,1.3204,2.4945>,<0.0000,1.3902,2.4945>,0.025}
cylinder{<0.0000,1.4198,2.4945>,<-0.4530,1.3485,2.4945>,0.025}
cylinder{<-0.4530,1.3485,2.4945>,<0.0000,1.4198,2.4945>,0.025}
cylinder{<0.0000,1.4596,2.4630>,<-0.4657,1.3863,2.4630>,0.025}
cylinder{<-0.4657,1.3863,2.4630>,<0.0000,1.4596,2.4630>,0.025}
cylinder{<0.0000,1.5000,2.4000>,<-0.4786,1.4246,2.4000>,0.025}
cylinder{<0.0000,1.4000,2.4000>,<0.4467,1.3297,2.4000>,0.025}
cylinder{<0.4404,1.3110,2.4630>,<0.0000,1.3804,2.4630>,0.025}
cylinder{<0.0000,1.3804,2.4630>,<0.4404,1.3110,2.4630>,0.025}
cylinder{<0.4435,1.3204,2.4945>,<0.0000,1.3902,2.4945>,0.025}
cylinder{<0.0000,1.3902,2.4945>,<0.4435,1.3204,2.4945>,0.025}
cylinder{<0.4530,1.3485,2.4945>,<0.0000,1.4198,2.4945>,0.025}
cylinder{<0.0000,1.4198,2.4945>,<0.4530,1.3485,2.4945>,0.025}
cylinder{<0.4657,1.3863,2.4630>,<0.0000,1.4596,2.4630>,0.025}
cylinder{<0.0000,1.4596,2.4630>,<0.4657,1.3863,2.4630>,0.025}
cylinder{<0.4786,1.4246,2.4000>,<0.0000,1.5000,2.4000>,0.025}
cylinder{<0.4467,1.3297,2.4000>,<0.8315,1.1330,2.4000>,0.025}
cylinder{<0.8198,1.1171,2.4630>,<0.4404,1.3110,2.4630>,0.025}
cylinder{<0.4404,1.3110,2.4630>,<0.8198,1.1171,2.4630>,0.025}
cylinder{<0.8257,1.1251,2.4945>,<0.4435,1.3204,2.4945>,0.025}
cylinder{<0.4435,1.3204,2.4945>,<0.8257,1.1251,2.4945>,0.025}
cylinder{<0.8432,1.1490,2.4945>,<0.4530,1.3485,2.4945>,0.025}
cylinder{<0.4530,1.3485,2.4945>,<0.8432,1.1490,2.4945>,0.025}
cylinder{<0.8669,1.1812,2.4630>,<0.4657,1.3863,2.4630>,0.025}
cylinder{<0.4657,1.3863,2.4630>,<0.8669,1.1812,2.4630>,0.025}
cylinder{<0.8909,1.2139,2.4000>,<0.4786,1.4246,2.4000>,0.025}
cylinder{<0.8315,1.1330,2.4000>,<1.1330,0.8315,2.4000>,0.025}
cylinder{<1.1171,0.8198,2.4630>,<0.8198,1.1171,2.4630>,0.025}
cylinder{<0.8198,1.1171,2.4630>,<1.1171,0.8198,2.4630>,0.025}
cylinder{<1.1251,0.8257,2.4945>,<0.8257,1.1251,2.4945>,0.025}
cylinder{<0.8257,1.1251,2.4945>,<1.1251,0.8257,2.4945>,0.025}
cylinder{<1.1490,0.8432,2.4945>,<0.8432,1.1490,2.4945>,0.025}
cylinder{<0.8432,1.1490,2.4945>,<1.1490,0.8432,2.4945>,0.025}
cylinder{<1.1812,0.8669,2.4630>,<0.8669,1.1812,2.4630>,0.025}
cylinder{<0.8669,1.1812,2.4630>,<1.1812,0.8669,2.4630>,0.025}
cylinder{<1.2139,0.8909,2.4000>,<0.8909,1.2139,2.4000>,0.025}
cylinder{<1.1330,0.8315,2.4000>,<1.3297,0.4467,2.4000>,0.025}
cylinder{<1.3110,0.4404,2.4630>,<1.1171,0.8198,2.4630>,0.025}
cylinder{<1.1171,0.8198,2.4630>,<1.3110,0.4404,2.4630>,0.025}
cylinder{<1.3204,0.4435,2.4945>,<1.1251,0.8257,2.4945>,0.025}
cylinder{<1.1251,0.8257,2.4945>,<1.3204,0.4435,2.4945>,0.025}
cylinder{<1.3485,0.4530,2.4945>,<1.1490,0.8432,2.4945>,0.025}
cylinder{<1.1490,0.8432,2.4945>,<1.3485,0.4530,2.4945>,0.025}
cylinder{<1.3863,0.4657,2.4630>,<1.1812,0.8669,2.4630>,0.025}
cylinder{<1.1812,0.8669,2.4630>,<1.3863,0.4657,2.4630>,0.025}
cylinder{<1.4246,0.4786,2.4000>,<1.2139,0.8909,2.4000>,0.025}
cylinder{<1.3297,0.4467,2.4000>,<1.4000,0.0000,2.4000>,0.025}
cylinder{<1.3804,0.0000,2.4630>,<1.3110,0.4404,2.4630>,0.025}
cylinder{<1.3110,0.4404,2.4630>,<1.3804,0.0000,2.4630>,0.025}
cylinder{<1.3902,0.0000,2.4945>,<1.3204,0.4435,2.4945>,0.025}
cylinder{<1.3204,0.4435,2.4945>,<1.3902,0.0000,2.4945>,0.025}
cylinder{<1.4198,0.0000,2.4945>,<1.3485,0.4530,2.4945>,0.025}
cylinder{<1.3485,0.4530,2.4945>,<1.4198,0.0000,2.4945>,0.025}
cylinder{<1.4596,0.0000,2.4630>,<1.3863,0.4657,2.4630>,0.025}
cylinder{<1.3863,0.4657,2.4630>,<1.4596,0.0000,2.4630>,0.025}
cylinder{<1.5000,0.0000,2.4000>,<1.4246,0.4786,2.4000>,0.025}
cylinder{<1.5000,0.0000,2.4000>,<1.4246,-0.4786,2.4000>,0.025}
cylinder{<1.5652,-0.5258,2.0856>,<1.6480,0.0000,2.0856>,0.025}
cylinder{<1.6480,0.0000,2.0856>,<1.5652,-0.5258,2.0856>,0.025}
cylinder{<1.6944,-0.5692,1.7748>,<1.7840,0.0000,1.7748>,0.025}
cylinder{<1.7840,0.0000,1.7748>,<1.6944,-0.5692,1.7748>,0.025}
cylinder{<1.8007,-0.6049,1.4712>,<1.8960,0.0000,1.4712>,0.025}
cylinder{<1.8960,0.0000,1.4712>,<1.8007,-0.6049,1.4712>,0.025}
cylinder{<1.8729,-0.6291,1.1784>,<1.9720,0.0000,1.1784>,0.025}
cylinder{<1.9720,0.0000,1.1784>,<1.8729,-0.6291,1.1784>,0.025}
cylinder{<1.8995,-0.6381,0.9000>,<2.0000,0.0000,0.9000>,0.025}
cylinder{<1.4246,-0.4786,2.4000>,<1.2139,-0.8909,2.4000>,0.025}
cylinder{<1.3337,-0.9788,2.0856>,<1.5652,-0.5258,2.0856>,0.025}
cylinder{<1.5652,-0.5258,2.0856>,<1.3337,-0.9788,2.0856>,0.025}
cylinder{<1.4438,-1.0596,1.7748>,<1.6944,-0.5692,1.7748>,0.025}
cylinder{<1.6944,-0.5692,1.7748>,<1.4438,-1.0596,1.7748>,0.025}
cylinder{<1.5344,-1.1261,1.4712>,<1.8007,-0.6049,1.4712>,0.025}
cylinder{<1.8007,-0.6049,1.4712>,<1.5344,-1.1261,1.4712>,0.025}
cylinder{<1.5959,-1.1712,1.1784>,<1.8729,-0.6291,1.1784>,0.025}
cylinder{<1.8729,-0.6291,1.1784>,<1.5959,-1.1712,1.1784>,0.025}
cylinder{<1.6186,-1.1878,0.9000>,<1.8995,-0.6381,0.9000>,0.025}
cylinder{<1.2139,-0.8909,2.4000>,<0.8909,-1.2139,2.4000>,0.025}
cylinder{<0.9788,-1.3337,2.0856>,<1.3337,-0.9788,2.0856>,0.025}
cylinder{<1.3337,-0.9788,2.0856>,<0.9788,-1.3337,2.0856>,0.025}
cylinder{<1.0596,-1.4438,1.7748>,<1.4438,-1.0596,1.7748>,0.025}
cylinder{<1.4438,-1.0596,1.7748>,<1.0596,-1.4438,1.7748>,0.025}
cylinder{<1.1261,-1.5344,1.4712>,<1.5344,-1.1261,1.4712>,0.025}
cylinder{<1.5344,-1.1261,1.4712>,<1.1261,-1.5344,1.4712>,0.025}
cylinder{<1.1712,-1.5959,1.1784>,<1.5959,-1.1712,1.1784>,0.025}
cylinder{<1.5959,-1.1712,1.1784>,<1.1712,-1.5959,1.1784>,0.025}
cylinder{<1.1878,-1.6186,0.9000>,<1.6186,-1.1878,0.9000>,0.025}
cylinder{<0.8909,-1.2139,2.4000>,<0.4786,-1.4246,2.4000>,0.025}
cylinder{<0.5258,-1.5652,2.0856>,<0.9788,-1.3337,2.0856>,0.025}
cylinder{<0.9788,-1.3337,2.0856>,<0.5258,-1.5652,2.0856>,0.025}
cylinder{<0.5692,-1.6944,1.7748>,<1.0596,-1.4438,1.7748>,0.025}
cylinder{<1.0596,-1.4438,1.7748>,<0.5692,-1.6944,1.7748>,0.025}
cylinder{<0.6049,-1.8007,1.4712>,<1.1261,-1.5344,1.4712>,0.025}
cylinder{<1.1261,-1.5344,1.4712>,<0.6049,-1.8007,1.4712>,0.025}
cylinder{<0.6291,-1.8729,1.1784>,<1.1712,-1.5959,1.1784>,0.025}
cylinder{<1.1712,-1.5959,1.1784>,<0.6291,-1.8729,1.1784>,0.025}
cylinder{<0.6381,-1.8995,0.9000>,<1.1878,-1.6186,0.9000>,0.025}
cylinder{<0.4786,-1.4246,2.4000>,<0.0000,-1.5000,2.4000>,0.025}
cylinder{<0.0000,-1.6480,2.0856>,<0.5258,-1.5652,2.0856>,0.025}
cylinder{<0.5258,-1.5652,2.0856>,<0.0000,-1.6480,2.0856>,0.025}
cylinder{<0.0000,-1.7840,1.7748>,<0.5692,-1.6944,1.7748>,0.025}
cylinder{<0.5692,-1.6944,1.7748>,<0.0000,-1.7840,1.7748>,0.025}
cylinder{<0.0000,-1.8960,1.4712>,<0.6049,-1.8007,1.4712>,0.025}
cylinder{<0.6049,-1.8007,1.4712>,<0.0000,-1.8960,1.4712>,0.025}
cylinder{<0.0000,-1.9720,1.1784>,<0.6291,-1.8729,1.1784>,0.025}
cylinder{<0.6291,-1.8729,1.1784>,<0.0000,-1.9720,1.1784>,0.025}
cylinder{<0.0000,-2.0000,0.9000>,<0.6381,-1.8995,0.9000>,0.025}
cylinder{<0.0000,-1.5000,2.4000>,<-0.4786,-1.4246,2.4000>,0.025}
cylinder{<-0.5258,-1.5652,2.0856>,<0.0000,-1.6480,2.0856>,0.025}
cylinder{<0.0000,-1.6480,2.0856>,<-0.5258,-1.5652,2.0856>,0.025}
cylinder{<-0.5692,-1.6944,1.7748>,<0.0000,-1.7840,1.7748>,0.025}
cylinder{<0.0000,-1.7840,1.7748>,<-0.5692,-1.6944,1.7748>,0.025}
cylinder{<-0.6049,-1.8007,1.4712>,<0.0000,-1.8960,1.4712>,0.025}
cylinder{<0.0000,-1.8960,1.4712>,<-0.6049,-1.8007,1.4712>,0.025}
cylinder{<-0.6291,-1.8729,1.1784>,<0.0000,-1.9720,1.1784>,0.025}
cylinder{<0.0000,-1.9720,1.1784>,<-0.6291,-1.8729,1.1784>,0.025}
cylinder{<-0.6381,-1.8995,0.9000>,<0.0000,-2.0000,0.9000>,0.025}
cylinder{<-0.4786,-1.4246,2.4000>,<-0.8909,-1.2139,2.4000>,0.025}
cylinder{<-0.9788,-1.3337,2.0856>,<-0.5258,-1.5652,2.0856>,0.025}
cylinder{<-0.5258,-1.5652,2.0856>,<-0.9788,-1.3337,2.0856>,0.025}
cylinder{<-1.0596,-1.4438,1.7748>,<-0.5692,-1.6944,1.7748>,0.025}
cylinder{<-0.5692,-1.6944,1.7748>,<-1.0596,-1.4438,1.7748>,0.025}
cylinder{<-1.1261,-1.5344,1.4712>,<-0.6049,-1.8007,1.4712>,0.025}
cylinder{<-0.6049,-1.8007,1.4712>,<-1.1261,-1.5344,1.4712>,0.025}
cylinder{<-1.1712,-1.5959,1.1784>,<-0.6291,-1.8729,1.1784>,0.025}
cylinder{<-0.6291,-1.8729,1.1784>,<-1.1712,-1.5959,1.1784>,0.025}
cylinder{<-1.1878,-1.6186,0.9000>,<-0.6381,-1.8995,0.9000>,0.025}
cylinder{<-0.8909,-1.2139,2.4000>,<-1.2139,-0.8909,2.4000>,0.025}
cylinder{<-1.3337,-0.9788,2.0856>,<-0.9788,-1.3337,2.0856>,0.025}
cylinder{<-0.9788,-1.3337,2.0856>,<-1.3337,-0.9788,2.0856>,0.025}
cylinder{<-1.4438,-1.0596,1.7748>,<-1.0596,-1.4438,1.7748>,0.025}
cylinder{<-1.0596,-1.4438,1.7748>,<-1.4438,-1.0596,1.7748>,0.025}
cylinder{<-1.5344,-1.1261,1.4712>,<-1.1261,-1.5344,1.4712>,0.025}
cylinder{<-1.1261,-1.5344,1.4712>,<-1.5344,-1.1261,1.4712>,0.025}
cylinder{<-1.5959,-1.1712,1.1784>,<-1.1712,-1.5959,1.1784>,0.025}
cylinder{<-1.1712,-1.5959,1.1784>,<-1.5959,-1.1712,1.1784>,0.025}
cylinder{<-1.6186,-1.1878,0.9000>,<-1.1878,-1.6186,0.9000>,0.025}
cylinder{<-1.2139,-0.8909,2.4000>,<-1.4246,-0.4786,2.4000>,0.025}
cylinder{<-1.5652,-0.5258,2.0856>,<-1.3337,-0.9788,2.0856>,0.025}
cylinder{<-1.3337,-0.9788,2.0856>,<-1.5652,-0.5258,2.0856>,0.025}
cylinder{<-1.6944,-0.5692,1.7748>,<-1.4438,-1.0596,1.7748>,0.025}
cylinder{<-1.4438,-1.0596,1.7748>,<-1.6944,-0.5692,1.7748>,0.025}
cylinder{<-1.8007,-0.6049,1.4712>,<-1.5344,-1.1261,1.4712>,0.025}
cylinder{<-1.5344,-1.1261,1.4712>,<-1.8007,-0.6049,1.4712>,0.025}
cylinder{<-1.8729,-0.6291,1.1784>,<-1.5959,-1.1712,1.1784>,0.025}
cylinder{<-1.5959,-1.1712,1.1784>,<-1.8729,-0.6291,1.1784>,0.025}
cylinder{<-1.8995,-0.6381,0.9000>,<-1.6186,-1.1878,0.9000>,0.025}
cylinder{<-1.4246,-0.4786,2.4000>,<-1.5000,0.0000,2.4000>,0.025}
cylinder{<-1.6480,0.0000,2.0856>,<-1.5652,-0.5258,2.0856>,0.025}
cylinder{<-1.5652,-0.5258,2.0856>,<-1.6480,0.0000,2.0856>,0.025}
cylinder{<-1.7840,0.0000,1.7748>,<-1.6944,-0.5692,1.7748>,0.025}
cylinder{<-1.6944,-0.5692,1.7748>,<-1.7840,0.0000,1.7748>,0.025}
cylinder{<-1.8960,0.0000,1.4712>,<-1.8007,-0.6049,1.4712>,0.025}
cylinder{<-1.8007,-0.6049,1.4712>,<-1.8960,0.0000,1.4712>,0.025}
cylinder{<-1.9720,0.0000,1.1784>,<-1.8729,-0.6291,1.1784>,0.025}
cylinder{<-1.8729,-0.6291,1.1784>,<-1.9720,0.0000,1.1784>,0.025}
cylinder{<-2.0000,0.0000,0.9000>,<-1.8995,-0.6381,0.9000>,0.025}
cylinder{<-1.5000,0.0000,2.4000>,<-1.4246,0.4786,2.4000>,0.025}
cylinder{<-1.5652,0.5258,2.0856>,<-1.6480,0.0000,2.0856>,0.025}
cylinder{<-1.6480,0.0000,2.0856>,<-1.5652,0.5258,2.0856>,0.025}
cylinder{<-1.6944,0.5692,1.7748>,<-1.7840,0.0000,1.7748>,0.025}
cylinder{<-1.7840,0.0000,1.7748>,<-1.6944,0.5692,1.7748>,0.025}
cylinder{<-1.8007,0.6049,1.4712>,<-1.8960,0.0000,1.4712>,0.025}
cylinder{<-1.8960,0.0000,1.4712>,<-1.8007,0.6049,1.4712>,0.025}
cylinder{<-1.8729,0.6291,1.1784>,<-1.9720,0.0000,1.1784>,0.025}
cylinder{<-1.9720,0.0000,1.1784>,<-1.8729,0.6291,1.1784>,0.025}
cylinder{<-1.8995,0.6381,0.9000>,<-2.0000,0.0000,0.9000>,0.025}
cylinder{<-1.4246,0.4786,2.4000>,<-1.2139,0.8909,2.4000>,0.025}
cylinder{<-1.3337,0.9788,2.0856>,<-1.5652,0.5258,2.0856>,0.025}
cylinder{<-1.5652,0.5258,2.0856>,<-1.3337,0.9788,2.0856>,0.025}
cylinder{<-1.4438,1.0596,1.7748>,<-1.6944,0.5692,1.7748>,0.025}
cylinder{<-1.6944,0.5692,1.7748>,<-1.4438,1.0596,1.7748>,0.025}
cylinder{<-1.5344,1.1261,1.4712>,<-1.8007,0.6049,1.4712>,0.025}
cylinder{<-1.8007,0.6049,1.4712>,<-1.5344,1.1261,1.4712>,0.025}
cylinder{<-1.5959,1.1712,1.1784>,<-1.8729,0.6291,1.1784>,0.025}
cylinder{<-1.8729,0.6291,1.1784>,<-1.5959,1.1712,1.1784>,0.025}
cylinder{<-1.6186,1.1878,0.9000>,<-1.8995,0.6381,0.9000>,0.025}
cylinder{<-1.2139,0.8909,2.4000>,<-0.8909,1.2139,2.4000>,0.025}
cylinder{<-0.9788,1.3337,2.0856>,<-1.3337,0.9788,2.0856>,0.025}
cylinder{<-1.3337,0.9788,2.0856>,<-0.9788,1.3337,2.0856>,0.025}
cylinder{<-1.0596,1.4438,1.7748>,<-1.4438,1.0596,1.7748>,0.025}
cylinder{<-1.4438,1.0596,1.7748>,<-1.0596,1.4438,1.7748>,0.025}
cylinder{<-1.1261,1.5344,1.4712>,<-1.5344,1.1261,1.4712>,0.025}
cylinder{<-1.5344,1.1261,1.4712>,<-1.1261,1.5344,1.4712>,0.025}
cylinder{<-1.1712,1.5959,1.1784>,<-1.5959,1.1712,1.1784>,0.025}
cylinder{<-1.5959,1.1712,1.1784>,<-1.1712,1.5959,1.1784>,0.025}
cylinder{<-1.1878,1.6186,0.9000>,<-1.6186,1.1878,0.9000>,0.025}
cylinder{<-0.8909,1.2139,2.4000>,<-0.4786,1.4246,2.4000>,0.025}
cylinder{<-0.5258,1.5652,2.0856>,<-0.9788,1.3337,2.0856>,0.025}
cylinder{<-0.9788,1.3337,2.0856>,<-0.5258,1.5652,2.0856>,0.025}
cylinder{<-0.5692,1.6944,1.7748>,<-1.0596,1.4438,1.7748>,0.025}
cylinder{<-1.0596,1.4438,1.7748>,<-0.5692,1.6944,1.7748>,0.025}
cylinder{<-0.6049,1.8007,1.4712>,<-1.1261,1.5344,1.4712>,0.025}
cylinder{<-1.1261,1.5344,1.4712>,<-0.6049,1.8007,1.4712>,0.025}
cylinder{<-0.6291,1.8729,1.1784>,<-1.1712,1.5959,1.1784>,0.025}
cylinder{<-1.1712,1.5959,1.1784>,<-0.6291,1.8729,1.1784>,0.025}
cylinder{<-0.6381,1.8995,0.9000>,<-1.1878,1.6186,0.9000>,0.025}
cylinder{<-0.4786,1.4246,2.4000>,<0.0000,1.5000,2.4000>,0.025}
cylinder{<0.0000,1.6480,2.0856>,<-0.5258,1.5652,2.0856>,0.025}
cylinder{<-0.5258,1.5652,2.0856>,<0.0000,1.6480,2.0856>,0.025}
cylinder{<0.0000,1.7840,1.7748>,<-0.5692,1.6944,1.7748>,0.025}
cylinder{<-0.5692,1.6944,1.7748>,<0.0000,1.7840,1.7748>,0.025}
cylinder{<0.0000,1.8960,1.4712>,<-0.6049,1.8007,1.4712>,0.025}
cylinder{<-0.6049,1.8007,1.4712>,<0.0000,1.8960,1.4712>,0.025}
cylinder{<0.0000,1.9720,1.1784>,<-0.6291,1.8729,1.1784>,0.025}
cylinder{<-0.6291,1.8729,1.1784>,<0.0000,1.9720,1.1784>,0.025}
cylinder{<0.0000,2.0000,0.9000>,<-0.6381,1.8995,0.9000>,0.025}
cylinder{<0.0000,1.5000,2.4000>,<0.4786,1.4246,2.4000>,0.025}
cylinder{<0.5258,1.5652,2.0856>,<0.0000,1.6480,2.0856>,0.025}
cylinder{<0.0000,1.6480,2.0856>,<0.5258,1.5652,2.0856>,0.025}
cylinder{<0.5692,1.6944,1.7748>,<0.0000,1.7840,1.7748>,0.025}
cylinder{<0.0000,1.7840,1.7748>,<0.5692,1.6944,1.7748>,0.025}
cylinder{<0.6049,1.8007,1.4712>,<0.0000,1.8960,1.4712>,0.025}
cylinder{<0.0000,1.8960,1.4712>,<0.6049,1.8007,1.4712>,0.025}
cylinder{<0.6291,1.8729,1.1784>,<0.0000,1.9720,1.1784>,0.025}
cylinder{<0.0000,1.9720,1.1784>,<0.6291,1.8729,1.1784>,0.025}
cylinder{<0.6381,1.8995,0.9000>,<0.0000,2.0000,0.9000>,0.025}
cylinder{<0.4786,1.4246,2.4000>,<0.8909,1.2139,2.4000>,0.025}
cylinder{<0.9788,1.3337,2.0856>,<0.5258,1.5652,2.0856>,0.025}
cylinder{<0.5258,1.5652,2.0856>,<0.9788,1.3337,2.0856>,0.025}
cylinder{<1.0596,1.4438,1.7748>,<0.5692,1.6944,1.7748>,0.025}
cylinder{<0.5692,1.6944,1.7748>,<1.0596,1.4438,1.7748>,0.025}
cylinder{<1.1261,1.5344,1.4712>,<0.6049,1.8007,1.4712>,0.025}
cylinder{<0.6049,1.8007,1.4712>,<1.1261,1.5344,1.4712>,0.025}
cylinder{<1.1712,1.5959,1.1784>,<0.6291,1.8729,1.1784>,0.025}
cylinder{<0.6291,1.8729,1.1784>,<1.1712,1.5959,1.1784>,0.025}
cylinder{<1.1878,1.6186,0.9000>,<0.6381,1.8995,0.9000>,0.025}
cylinder{<0.8909,1.2139,2.4000>,<1.2139,0.8909,2.4000>,0.025}
cylinder{<1.3337,0.9788,2.0856>,<0.9788,1.3337,2.0856>,0.025}
cylinder{<0.9788,1.3337,2.0856>,<1.3337,0.9788,2.0856>,0.025}
cylinder{<1.4438,1.0596,1.7748>,<1.0596,1.4438,1.7748>,0.025}
cylinder{<1.0596,1.4438,1.7748>,<1.4438,1.0596,1.7748>,0.025}
cylinder{<1.5344,1.1261,1.4712>,<1.1261,1.5344,1.4712>,0.025}
cylinder{<1.1261,1.5344,1.4712>,<1.5344,1.1261,1.4712>,0.025}
cylinder{<1.5959,1.1712,1.1784>,<1.1712,1.5959,1.1784>,0.025}
cylinder{<1.1712,1.5959,1.1784>,<1.5959,1.1712,1.1784>,0.025}
cylinder{<1.6186,1.1878,0.9000>,<1.1878,1.6186,0.9000>,0.025}
cylinder{<1.2139,0.8909,2.4000>,<1.4246,0.4786,2.4000>,0.025}
cylinder{<1.5652,0.5258,2.0856>,<1.3337,0.9788,2.0856>,0.025}
cylinder{<1.3337,0.9788,2.0856>,<1.5652,0.5258,2.0856>,0.025}
cylinder{<1.6944,0.5692,1.7748>,<1.4438,1.0596,1.7748>,0.025}
cylinder{<1.4438,1.0596,1.7748>,<1.6944,0.5692,1.7748>,0.025}
cylinder{<1.8007,0.6049,1.4712>,<1.5344,1.1261,1.4712>,0.025}
cylinder{<1.5344,1.1261,1.4712>,<1.8007,0.6049,1.4712>,0.025}
cylinder{<1.8729,0.6291,1.1784>,<1.5959,1.1712,1.1784>,0.025}
cylinder{<1.5959,1.1712,1.1784>,<1.8729,0.6291,1.1784>,0.025}
cylinder{<1.8995,0.6381,0.9000>,<1.6186,1.1878,0.9000>,0.025}
cylinder{<1.4246,0.4786,2.4000>,<1.5000,0.0000,2.4000>,0.025}
cylinder{<1.6480,0.0000,2.0856>,<1.5652,0.5258,2.0856>,0.025}
cylinder{<1.5652,0.5258,2.0856>,<1.6480,0.0000,2.0856>,0.025}
cylinder{<1.7840,0.0000,1.7748>,<1.6944,0.5692,1.7748>,0.025}
cylinder{<1.6944,0.5692,1.7748>,<1.7840,0.0000,1.7748>,0.025}
cylinder{<1.8960,0.0000,1.4712>,<1.8007,0.6049,1.4712>,0.025}
cylinder{<1.8007,0.6049,1.4712>,<1.8960,0.0000,1.4712>,0.025}
cylinder{<1.9720,0.0000,1.1784>,<1.8729,0.6291,1.1784>,0.025}
cylinder{<1.8729,0.6291,1.1784>,<1.9720,0.0000,1.1784>,0.025}
cylinder{<2.0000,0.0000,0.9000>,<1.8995,0.6381,0.9000>,0.025}
cylinder{<2.0000,0.0000,0.9000>,<1.8995,-0.6381,0.9000>,0.025}
cylinder{<1.8501,-0.6215,0.6564>,<1.9480,0.0000,0.6564>,0.025}
cylinder{<1.9480,0.0000,0.6564>,<1.8501,-0.6215,0.6564>,0.025}
cylinder{<1.7324,-0.5819,0.4632>,<1.8240,0.0000,0.4632>,0.025}
cylinder{<1.8240,0.0000,0.4632>,<1.7324,-0.5819,0.4632>,0.025}
cylinder{<1.5918,-0.5347,0.3168>,<1.6760,0.0000,0.3168>,0.025}
cylinder{<1.6760,0.0000,0.3168>,<1.5918,-0.5347,0.3168>,0.025}
cylinder{<1.4740,-0.4951,0.2136>,<1.5520,0.0000,0.2136>,0.025}
cylinder{<1.5520,0.0000,0.2136>,<1.4740,-0.4951,0.2136>,0.025}
cylinder{<1.4246,-0.4786,0.1500>,<1.5000,0.0000,0.1500>,0.025}
cylinder{<1.8995,-0.6381,0.9000>,<1.6186,-1.1878,0.9000>,0.025}
cylinder{<1.5765,-1.1570,0.6564>,<1.8501,-0.6215,0.6564>,0.025}
cylinder{<1.8501,-0.6215,0.6564>,<1.5765,-1.1570,0.6564>,0.025}
cylinder{<1.4761,-1.0833,0.4632>,<1.7324,-0.5819,0.4632>,0.025}
cylinder{<1.7324,-0.5819,0.4632>,<1.4761,-1.0833,0.4632>,0.025}
cylinder{<1.3564,-0.9954,0.3168>,<1.5918,-0.5347,0.3168>,0.025}
cylinder{<1.5918,-0.5347,0.3168>,<1.3564,-0.9954,0.3168>,0.025}
cylinder{<1.2560,-0.9218,0.2136>,<1.4740,-0.4951,0.2136>,0.025}
cylinder{<1.4740,-0.4951,0.2136>,<1.2560,-0.9218,0.2136>,0.025}
cylinder{<1.2139,-0.8909,0.1500>,<1.4246,-0.4786,0.1500>,0.025}
cylinder{<1.6186,-1.1878,0.9000>,<1.1878,-1.6186,0.9000>,0.025}
cylinder{<1.1570,-1.5765,0.6564>,<1.5765,-1.1570,0.6564>,0.025}
cylinder{<1.5765,-1.1570,0.6564>,<1.1570,-1.5765,0.6564>,0.025}
cylinder{<1.0833,-1.4761,0.4632>,<1.4761,-1.0833,0.4632>,0.025}
cylinder{<1.4761,-1.0833,0.4632>,<1.0833,-1.4761,0.4632>,0.025}
cylinder{<0.9954,-1.3564,0.3168>,<1.3564,-0.9954,0.3168>,0.025}
cylinder{<1.3564,-0.9954,0.3168>,<0.9954,-1.3564,0.3168>,0.025}
cylinder{<0.9218,-1.2560,0.2136>,<1.2560,-0.9218,0.2136>,0.025}
cylinder{<1.2560,-0.9218,0.2136>,<0.9218,-1.2560,0.2136>,0.025}
cylinder{<0.8909,-1.2139,0.1500>,<1.2139,-0.8909,0.1500>,0.025}
cylinder{<1.1878,-1.6186,0.9000>,<0.6381,-1.8995,0.9000>,0.025}
cylinder{<0.6215,-1.8501,0.6564>,<1.1570,-1.5765,0.6564>,0.025}
cylinder{<1.1570,-1.5765,0.6564>,<0.6215,-1.8501,0.6564>,0.025}
cylinder{<0.5819,-1.7324,0.4632>,<1.0833,-1.4761,0.4632>,0.025}
cylinder{<1.0833,-1.4761,0.4632>,<0.5819,-1.7324,0.4632>,0.025}
cylinder{<0.5347,-1.5918,0.3168>,<0.9954,-1.3564,0.3168>,0.025}
cylinder{<0.9954,-1.3564,0.3168>,<0.5347,-1.5918,0.3168>,0.025}
cylinder{<0.4951,-1.4740,0.2136>,<0.9218,-1.2560,0.2136>,0.025}
cylinder{<0.9218,-1.2560,0.2136>,<0.4951,-1.4740,0.2136>,0.025}
cylinder{<0.4786,-1.4246,0.1500>,<0.8909,-1.2139,0.1500>,0.025}
cylinder{<0.6381,-1.8995,0.9000>,<0.0000,-2.0000,0.9000>,0.025}
cylinder{<0.0000,-1.9480,0.6564>,<0.6215,-1.8501,0.6564>,0.025}
cylinder{<0.6215,-1.8501,0.6564>,<0.0000,-1.9480,0.6564>,0.025}
cylinder{<0.0000,-1.8240,0.4632>,<0.5819,-1.7324,0.4632>,0.025}
cylinder{<0.5819,-1.7324,0.4632>,<0.0000,-1.8240,0.4632>,0.025}
cylinder{<0.0000,-1.6760,0.3168>,<0.5347,-1.5918,0.3168>,0.025}
cylinder{<0.5347,-1.5918,0.3168>,<0.0000,-1.6760,0.3168>,0.025}
cylinder{<0.0000,-1.5520,0.2136>,<0.4951,-1.4740,0.2136>,0.025}
cylinder{<0.4951,-1.4740,0.2136>,<0.0000,-1.5520,0.2136>,0.025}
cylinder{<0.0000,-1.5000,0.1500>,<0.4786,-1.4246,0.1500>,0.025}
cylinder{<0.0000,-2.0000,0.9000>,<-0.6381,-1.8995,0.9000>,0.025}
cylinder{<-0.6215,-1.8501,0.6564>,<0.0000,-1.9480,0.6564>,0.025}
cylinder{<0.0000,-1.9480,0.6564>,<-0.6215,-1.8501,0.6564>,0.025}
cylinder{<-0.5819,-1.7324,0.4632>,<0.0000,-1.8240,0.4632>,0.025}
cylinder{<0.0000,-1.8240,0.4632>,<-0.5819,-1.7324,0.4632>,0.025}
cylinder{<-0.5347,-1.5918,0.3168>,<0.0000,-1.6760,0.3168>,0.025}
cylinder{<0.0000,-1.6760,0.3168>,<-0.5347,-1.5918,0.3168>,0.025}
cylinder{<-0.4951,-1.4740,0.2136>,<0.0000,-1.5520,0.2136>,0.025}
cylinder{<0.0000,-1.5520,0.2136>,<-0.4951,-1.4740,0.2136>,0.025}
cylinder{<-0.4786,-1.4246,0.1500>,<0.0000,-1.5000,0.1500>,0.025}
cylinder{<-0.6381,-1.8995,0.9000>,<-1.1878,-1.6186,0.9000>,0.025}
cylinder{<-1.1570,-1.5765,0.6564>,<-0.6215,-1.8501,0.6564>,0.025}
cylinder{<-0.6215,-1.8501,0.6564>,<-1.1570,-1.5765,0.6564>,0.025}
cylinder{<-1.0833,-1.4761,0.4632>,<-0.5819,-1.7324,0.4632>,0.025}
cylinder{<-0.5819,-1.7324,0.4632>,<-1.0833,-1.4761,0.4632>,0.025}
cylinder{<-0.9954,-1.3564,0.3168>,<-0.5347,-1.5918,0.3168>,0.025}
cylinder{<-0.5347,-1.5918,0.3168>,<-0.9954,-1.3564,0.3168>,0.025}
cylinder{<-0.9218,-1.2560,0.2136>,<-0.4951,-1.4740,0.2136>,0.025}
cylinder{<-0.4951,-1.4740,0.2136>,<-0.9218,-1.2560,0.2136>,0.025}
cylinder{<-0.8909,-1.2139,0.1500>,<-0.4786,-1.4246,0.1500>,0.025}
cylinder{<-1.1878,-1.6186,0.9000>,<-1.6186,-1.1878,0.9000>,0.025}
cylinder{<-1.5765,-1.1570,0.6564>,<-1.1570,-1.5765,0.6564>,0.025}
cylinder{<-1.1570,-1.5765,0.6564>,<-1.5765,-1.1570,0.6564>,0.025}
cylinder{<-1.4761,-1.0833,0.4632>,<-1.0833,-1.4761,0.4632>,0.025}
cylinder{<-1.0833,-1.4761,0.4632>,<-1.4761,-1.0833,0.4632>,0.025}
cylinder{<-1.3564,-0.9954,0.3168>,<-0.9954,-1.3564,0.3168>,0.025}
cylinder{<-0.9954,-1.3564,0.3168>,<-1.3564,-0.9954,0.3168>,0.025}
cylinder{<-1.2560,-0.9218,0.2136>,<-0.9218,-1.2560,0.2136>,0.025}
cylinder{<-0.9218,-1.2560,0.2136>,<-1.2560,-0.9218,0.2136>,0.025}
cylinder{<-1.2139,-0.8909,0.1500>,<-0.8909,-1.2139,0.1500>,0.025}
cylinder{<-1.6186,-1.1878,0.9000>,<-1.8995,-0.6381,0.9000>,0.025}
cylinder{<-1.8501,-0.6215,0.6564>,<-1.5765,-1.1570,0.6564>,0.025}
cylinder{<-1.5765,-1.1570,0.6564>,<-1.8501,-0.6215,0.6564>,0.025}
cylinder{<-1.7324,-0.5819,0.4632>,<-1.4761,-1.0833,0.4632>,0.025}
cylinder{<-1.4761,-1.0833,0.4632>,<-1.7324,-0.5819,0.4632>,0.025}
cylinder{<-1.5918,-0.5347,0.3168>,<-1.3564,-0.9954,0.3168>,0.025}
cylinder{<-1.3564,-0.9954,0.3168>,<-1.5918,-0.5347,0.3168>,0.025}
cylinder{<-1.4740,-0.4951,0.2136>,<-1.2560,-0.9218,0.2136>,0.025}
cylinder{<-1.2560,-0.9218,0.2136>,<-1.4740,-0.4951,0.2136>,0.025}
cylinder{<-1.4246,-0.4786,0.1500>,<-1.2139,-0.8909,0.1500>,0.025}
cylinder{<-1.8995,-0.6381,0.9000>,<-2.0000,0.0000,0.9000>,0.025}
cylinder{<-1.9480,0.0000,0.6564>,<-1.8501,-0.6215,0.6564>,0.025}
cylinder{<-1.8501,-0.6215,0.6564>,<-1.9480,0.0000,0.6564>,0.025}
cylinder{<-1.8240,0.0000,0.4632>,<-1.7324,-0.5819,0.4632>,0.025}
cylinder{<-1.7324,-0.5819,0.4632>,<-1.8240,0.0000,0.4632>,0.025}
cylinder{<-1.6760,0.0000,0.3168>,<-1.5918,-0.5347,0.3168>,0.025}
cylinder{<-1.5918,-0.5347,0.3168>,<-1.6760,0.0000,0.3168>,0.025}
cylinder{<-1.5520,0.0000,0.2136>,<-1.4740,-0.4951,0.2136>,0.025}
cylinder{<-1.4740,-0.4951,0.2136>,<-1.5520,0.0000,0.2136>,0.025}
cylinder{<-1.5000,0.0000,0.1500>,<-1.4246,-0.4786,0.1500>,0.025}
cylinder{<-2.0000,0.0000,0.9000>,<-1.8995,0.6381,0.9000>,0.025}
cylinder{<-1.8501,0.6215,0.6564>,<-1.9480,0.0000,0.6564>,0.025}
cylinder{<-1.9480,0.0000,0.6564>,<-1.8501,0.6215,0.6564>,0.025}
cylinder{<-1.7324,0.5819,0.4632>,<-1.8240,0.0000,0.4632>,0.025}
cylinder{<-1.8240,0.0000,0.4632>,<-1.7324,0.5819,0.4632>,0.025}
cylinder{<-1.5918,0.5347,0.3168>,<-1.6760,0.0000,0.3168>,0.025}
cylinder{<-1.6760,0.0000,0.3168>,<-1.5918,0.5347,0.3168>,0.025}
cylinder{<-1.4740,0.4951,0.2136>,<-1.5520,0.0000,0.2136>,0.025}
cylinder{<-1.5520,0.0000,0.2136>,<-1.4740,0.4951,0.2136>,0.025}
cylinder{<-1.4246,0.4786,0.1500>,<-1.5000,0.0000,0.1500>,0.025}
cylinder{<-1.8995,0.6381,0.9000>,<-1.6186,1.1878,0.9000>,0.025}
cylinder{<-1.5765,1.1570,0.6564>,<-1.8501,0.6215,0.6564>,0.025}
cylinder{<-1.8501,0.6215,0.6564>,<-1.5765,1.1570,0.6564>,0.025}
cylinder{<-1.4761,1.0833,0.4632>,<-1.7324,0.5819,0.4632>,0.025}
cylinder{<-1.7324,0.5819,0.4632>,<-1.4761,1.0833,0.4632>,0.025}
cylinder{<-1.3564,0.9954,0.3168>,<-1.5918,0.5347,0.3168>,0.025}
cylinder{<-1.5918,0.5347,0.3168>,<-1.3564,0.9954,0.3168>,0.025}
cylinder{<-1.2560,0.9218,0.2136>,<-1.4740,0.4951,0.2136>,0.025}
cylinder{<-1.4740,0.4951,0.2136>,<-1.2560,0.9218,0.2136>,0.025}
cylinder{<-1.2139,0.8909,0.1500>,<-1.4246,0.4786,0.1500>,0.025}
cylinder{<-1.6186,1.1878,0.9000>,<-1.1878,1.6186,0.9000>,0.025}
cylinder{<-1.1570,1.5765,0.6564>,<-1.5765,1.1570,0.6564>,0.025}
cylinder{<-1.5765,1.1570,0.6564>,<-1.1570,1.5765,0.6564>,0.025}
cylinder{<-1.0833,1.4761,0.4632>,<-1.4761,1.0833,0.4632>,0.025}
cylinder{<-1.4761,1.0833,0.4632>,<-1.0833,1.4761,0.4632>,0.025}
cylinder{<-0.9954,1.3564,0.3168>,<-1.3564,0.9954,0.3168>,0.025}
cylinder{<-1.3564,0.9954,0.3168>,<-0.9954,1.3564,0.3168>,0.025}
cylinder{<-0.9218,1.2560,0.2136>,<-1.2560,0.9218,0.2136>,0.025}
cylinder{<-1.2560,0.9218,0.2136>,<-0.9218,1.2560,0.2136>,0.025}
cylinder{<-0.8909,1.2139,0.1500>,<-1.2139,0.8909,0.1500>,0.025}
cylinder{<-1.1878,1.6186,0.9000>,<-0.6381,1.8995,0.9000>,0.025}
cylinder{<-0.6215,1.8501,0.6564>,<-1.1570,1.5765,0.6564>,0.025}
cylinder{<-1.1570,1.5765,0.6564>,<-0.6215,1.8501,0.6564>,0.025}
cylinder{<-0.5819,1.7324,0.4632>,<-1.0833,1.4761,0.4632>,0.025}
cylinder{<-1.0833,1.4761,0.4632>,<-0.5819,1.7324,0.4632>,0.025}
cylinder{<-0.5347,1.5918,0.3168>,<-0.9954,1.3564,0.3168>,0.025}
cylinder{<-0.9954,1.3564,0.3168>,<-0.5347,1.5918,0.3168>,0.025}
cylinder{<-0.4951,1.4740,0.2136>,<-0.9218,1.2560,0.2136>,0.025}
cylinder{<-0.9218,1.2560,0.2136>,<-0.4951,1.4740,0.2136>,0.025}
cylinder{<-0.4786,1.4246,0.1500>,<-0.8909,1.2139,0.1500>,0.025}
cylinder{<-0.6381,1.8995,0.9000>,<0.0000,2.0000,0.9000>,0.025}
cylinder{<0.0000,1.9480,0.6564>,<-0.6215,1.8501,0.6564>,0.025}
cylinder{<-0.6215,1.8501,0.6564>,<0.0000,1.9480,0.6564>,0.025}
cylinder{<0.0000,1.8240,0.4632>,<-0.5819,1.7324,0.4632>,0.025}
cylinder{<-0.5819,1.7324,0.4632>,<0.0000,1.8240,0.4632>,0.025}
cylinder{<0.0000,1.6760,0.3168>,<-0.5347,1.5918,0.3168>,0.025}
cylinder{<-0.5347,1.5918,0.3168>,<0.0000,1.6760,0.3168>,0.025}
cylinder{<0.0000,1.5520,0.2136>,<-0.4951,1.4740,0.2136>,0.025}
cylinder{<-0.4951,1.4740,0.2136>,<0.0000,1.5520,0.2136>,0.025}
cylinder{<0.0000,1.5000,0.1500>,<-0.4786,1.4246,0.1500>,0.025}
cylinder{<0.0000,2.0000,0.9000>,<0.6381,1.8995,0.9000>,0.025}
cylinder{<0.6215,1.8501,0.6564>,<0.0000,1.9480,0.6564>,0.025}
cylinder{<0.0000,1.9480,0.6564>,<0.6215,1.8501,0.6564>,0.025}
cylinder{<0.5819,1.7324,0.4632>,<0.0000,1.8240,0.4632>,0.025}
cylinder{<0.0000,1.8240,0.4632>,<0.5819,1.7324,0.4632>,0.025}
cylinder{<0.5347,1.5918,0.3168>,<0.0000,1.6760,0.3168>,0.025}
cylinder{<0.0000,1.6760,0.3168>,<0.5347,1.5918,0.3168>,0.025}
cylinder{<0.4951,1.4740,0.2136>,<0.0000,1.5520,0.2136>,0.025}
cylinder{<0.0000,1.5520,0.2136>,<0.4951,1.4740,0.2136>,0.025}
cylinder{<0.4786,1.4246,0.1500>,<0.0000,1.5000,0.1500>,0.025}
cylinder{<0.6381,1.8995,0.9000>,<1.1878,1.6186,0.9000>,0.025}
cylinder{<1.1570,1.5765,0.6564>,<0.6215,1.8501,0.6564>,0.025}
cylinder{<0.6215,1.8501,0.6564>,<1.1570,1.5765,0.6564>,0.025}
cylinder{<1.0833,1.4761,0.4632>,<0.5819,1.7324,0.4632>,0.025}
cylinder{<0.5819,1.7324,0.4632>,<1.0833,1.4761,0.4632>,0.025}
cylinder{<0.9954,1.3564,0.3168>,<0.5347,1.5918,0.3168>,0.025}
cylinder{<0.5347,1.5918,0.3168>,<0.9954,1.3564,0.3168>,0.025}
cylinder{<0.9218,1.2560,0.2136>,<0.4951,1.4740,0.2136>,0.025}
cylinder{<0.4951,1.4740,0.2136>,<0.9218,1.2560,0.2136>,0.025}
cylinder{<0.8909,1.2139,0.1500>,<0.4786,1.4246,0.1500>,0.025}
cylinder{<1.1878,1.6186,0.9000>,<1.6186,1.1878,0.9000>,0.025}
cylinder{<1.5765,1.1570,0.6564>,<1.1570,1.5765,0.6564>,0.025}
cylinder{<1.1570,1.5765,0.6564>,<1.5765,1.1570,0.6564>,0.025}
cylinder{<1.4761,1.0833,0.4632>,<1.0833,1.4761,0.4632>,0.025}
cylinder{<1.0833,1.4761,0.4632>,<1.4761,1.0833,0.4632>,0.025}
cylinder{<1.3564,0.9954,0.3168>,<0.9954,1.3564,0.3168>,0.025}
cylinder{<0.9954,1.3564,0.3168>,<1.3564,0.9954,0.3168>,0.025}
cylinder{<1.2560,0.9218,0.2136>,<0.9218,1.2560,0.2136>,0.025}
cylinder{<0.9218,1.2560,0.2136>,<1.2560,0.9218,0.2136>,0.025}
cylinder{<1.2139,0.8909,0.1500>,<0.8909,1.2139,0.1500>,0.025}
cylinder{<1.6186,1.1878,0.9000>,<1.8995,0.6381,0.9000>,0.025}
cylinder{<1.8501,0.6215,0.6564>,<1.5765,1.1570,0.6564>,0.025}
cylinder{<1.5765,1.1570,0.6564>,<1.8501,0.6215,0.6564>,0.025}
cylinder{<1.7324,0.5819,0.4632>,<1.4761,1.0833,0.4632>,0.025}
cylinder{<1.4761,1.0833,0.4632>,<1.7324,0.5819,0.4632>,0.025}
cylinder{<1.5918,0.5347,0.3168>,<1.3564,0.9954,0.3168>,0.025}
cylinder{<1.3564,0.9954,0.3168>,<1.5918,0.5347,0.3168>,0.025}
cylinder{<1.4740,0.4951,0.2136>,<1.2560,0.9218,0.2136>,0.025}
cylinder{<1.2560,0.9218,0.2136>,<1.4740,0.4951,0.2136>,0.025}
cylinder{<1.4246,0.4786,0.1500>,<1.2139,0.8909,0.1500>,0.025}
cylinder{<1.8995,0.6381,0.9000>,<2.0000,0.0000,0.9000>,0.025}
cylinder{<1.9480,0.0000,0.6564>,<1.8501,0.6215,0.6564>,0.025}
cylinder{<1.8501,0.6215,0.6564>,<1.9480,0.0000,0.6564>,0.025}
cylinder{<1.8240,0.0000,0.4632>,<1.7324,0.5819,0.4632>,0.025}
cylinder{<1.7324,0.5819,0.4632>,<1.8240,0.0000,0.4632>,0.025}
cylinder{<1.6760,0.0000,0.3168>,<1.5918,0.5347,0.3168>,0.025}
cylinder{<1.5918,0.5347,0.3168>,<1.6760,0.0000,0.3168>,0.025}
cylinder{<1.5520,0.0000,0.2136>,<1.4740,0.4951,0.2136>,0.025}
cylinder{<1.4740,0.4951,0.2136>,<1.5520,0.0000,0.2136>,0.025}
cylinder{<1.5000,0.0000,0.1500>,<1.4246,0.4786,0.1500>,0.025}
cylinder{<-1.6000,0.0000,2.0250>,<-1.5896,-0.1440,2.0484>,0.025}
cylinder{<-1.9891,-0.1440,2.0464>,<-1.9832,0.0000,2.0232>,0.025}
cylinder{<-1.9832,0.0000,2.0232>,<-1.9891,-0.1440,2.0464>,0.025}
cylinder{<-2.3073,-0.1440,2.0325>,<-2.2896,0.0000,2.0106>,0.025}
cylinder{<-2.2896,0.0000,2.0106>,<-2.3073,-0.1440,2.0325>,0.025}
cylinder{<-2.5399,-0.1440,1.9947>,<-2.5144,0.0000,1.9764>,0.025}
cylinder{<-2.5144,0.0000,1.9764>,<-2.5399,-0.1440,1.9947>,0.025}
cylinder{<-2.6827,-0.1440,1.9212>,<-2.6528,0.0000,1.9098>,0.025}
cylinder{<-2.6528,0.0000,1.9098>,<-2.6827,-0.1440,1.9212>,0.025}
cylinder{<-2.7312,-0.1440,1.8000>,<-2.7000,0.0000,1.8000>,0.025}
cylinder{<-1.5896,-0.1440,2.0484>,<-1.5648,-0.2160,2.1042>,0.025}
cylinder{<-2.0032,-0.2160,2.1018>,<-1.9891,-0.1440,2.0464>,0.025}
cylinder{<-1.9891,-0.1440,2.0464>,<-2.0032,-0.2160,2.1018>,0.025}
cylinder{<-2.3496,-0.2160,2.0847>,<-2.3073,-0.1440,2.0325>,0.025}
cylinder{<-2.3073,-0.1440,2.0325>,<-2.3496,-0.2160,2.0847>,0.025}
cylinder{<-2.6009,-0.2160,2.0385>,<-2.5399,-0.1440,1.9947>,0.025}
cylinder{<-2.5399,-0.1440,1.9947>,<-2.6009,-0.2160,2.0385>,0.025}
cylinder{<-2.7539,-0.2160,1.9484>,<-2.6827,-0.1440,1.9212>,0.025}
cylinder{<-2.6827,-0.1440,1.9212>,<-2.7539,-0.2160,1.9484>,0.025}
cylinder{<-2.8056,-0.2160,1.8000>,<-2.7312,-0.1440,1.8000>,0.025}
cylinder{<-1.5648,-0.2160,2.1042>,<-1.5352,-0.2160,2.1708>,0.025}
cylinder{<-2.0200,-0.2160,2.1678>,<-2.0032,-0.2160,2.1018>,0.025}
cylinder{<-2.0032,-0.2160,2.1018>,<-2.0200,-0.2160,2.1678>,0.025}
cylinder{<-2.4000,-0.2160,2.1471>,<-2.3496,-0.2160,2.0847>,0.025}
cylinder{<-2.3496,-0.2160,2.0847>,<-2.4000,-0.2160,2.1471>,0.025}
cylinder{<-2.6735,-0.2160,2.0907>,<-2.6009,-0.2160,2.0385>,0.025}
cylinder{<-2.6009,-0.2160,2.0385>,<-2.6735,-0.2160,2.0907>,0.025}
cylinder{<-2.8389,-0.2160,1.9809>,<-2.7539,-0.2160,1.9484>,0.025}
cylinder{<-2.7539,-0.2160,1.9484>,<-2.8389,-0.2160,1.9809>,0.025}
cylinder{<-2.8944,-0.2160,1.8000>,<-2.8056,-0.2160,1.8000>,0.025}
cylinder{<-1.5352,-0.2160,2.1708>,<-1.5104,-0.1440,2.2266>,0.025}
cylinder{<-2.0341,-0.1440,2.2232>,<-2.0200,-0.2160,2.1678>,0.025}
cylinder{<-2.0200,-0.2160,2.1678>,<-2.0341,-0.1440,2.2232>,0.025}
cylinder{<-2.4423,-0.1440,2.1993>,<-2.4000,-0.2160,2.1471>,0.025}
cylinder{<-2.4000,-0.2160,2.1471>,<-2.4423,-0.1440,2.1993>,0.025}
cylinder{<-2.7345,-0.1440,2.1345>,<-2.6735,-0.2160,2.0907>,0.025}
cylinder{<-2.6735,-0.2160,2.0907>,<-2.7345,-0.1440,2.1345>,0.025}
cylinder{<-2.9101,-0.1440,2.0082>,<-2.8389,-0.2160,1.9809>,0.025}
cylinder{<-2.8389,-0.2160,1.9809>,<-2.9101,-0.1440,2.0082>,0.025}
cylinder{<-2.9688,-0.1440,1.8000>,<-2.8944,-0.2160,1.8000>,0.025}
cylinder{<-1.5104,-0.1440,2.2266>,<-1.5000,0.0000,2.2500>,0.025}
cylinder{<-2.0400,0.0000,2.2464>,<-2.0341,-0.1440,2.2232>,0.025}
cylinder{<-2.0341,-0.1440,2.2232>,<-2.0400,0.0000,2.2464>,0.025}
cylinder{<-2.4600,0.0000,2.2212>,<-2.4423,-0.1440,2.1993>,0.025}
cylinder{<-2.4423,-0.1440,2.1993>,<-2.4600,0.0000,2.2212>,0.025}
cylinder{<-2.7600,0.0000,2.1528>,<-2.7345,-0.1440,2.1345>,0.025}
cylinder{<-2.7345,-0.1440,2.1345>,<-2.7600,0.0000,2.1528>,0.025}
cylinder{<-2.9400,0.0000,2.0196>,<-2.9101,-0.1440,2.0082>,0.025}
cylinder{<-2.9101,-0.1440,2.0082>,<-2.9400,0.0000,2.0196>,0.025}
cylinder{<-3.0000,0.0000,1.8000>,<-2.9688,-0.1440,1.8000>,0.025}
cylinder{<-1.5000,0.0000,2.2500>,<-1.5104,0.1440,2.2266>,0.025}
cylinder{<-2.0341,0.1440,2.2232>,<-2.0400,0.0000,2.2464>,0.025}
cylinder{<-2.0400,0.0000,2.2464>,<-2.0341,0.1440,2.2232>,0.025}
cylinder{<-2.4423,0.1440,2.1993>,<-2.4600,0.0000,2.2212>,0.025}
cylinder{<-2.4600,0.0000,2.2212>,<-2.4423,0.1440,2.1993>,0.025}
cylinder{<-2.7345,0.1440,2.1345>,<-2.7600,0.0000,2.1528>,0.025}
cylinder{<-2.7600,0.0000,2.1528>,<-2.7345,0.1440,2.1345>,0.025}
cylinder{<-2.9101,0.1440,2.0082>,<-2.9400,0.0000,2.0196>,0.025}
cylinder{<-2.9400,0.0000,2.0196>,<-2.9101,0.1440,2.0082>,0.025}
cylinder{<-2.9688,0.1440,1.8000>,<-3.0000,0.0000,1.8000>,0.025}
cylinder{<-1.5104,0.1440,2.2266>,<-1.5352,0.2160,2.1708>,0.025}
cylinder{<-2.0200,0.2160,2.1678>,<-2.0341,0.1440,2.2232>,0.025}
cylinder{<-2.0341,0.1440,2.2232>,<-2.0200,0.2160,2.1678>,0.025}
cylinder{<-2.4000,0.2160,2.1471>,<-2.4423,0.1440,2.1993>,0.025}
cylinder{<-2.4423,0.1440,2.1993>,<-2.4000,0.2160,2.1471>,0.025}
cylinder{<-2.6735,0.2160,2.0907>,<-2.7345,0.1440,2.1345>,0.025}
cylinder{<-2.7345,0.1440,2.1345>,<-2.6735,0.2160,2.0907>,0.025}
cylinder{<-2.8389,0.2160,1.9809>,<-2.9101,0.1440,2.0082>,0.025}
cylinder{<-2.9101,0.1440,2.0082>,<-2.8389,0.2160,1.9809>,0.025}
cylinder{<-2.8944,0.2160,1.8000>,<-2.9688,0.1440,1.8000>,0.025}
cylinder{<-1.5352,0.2160,2.1708>,<-1.5648,0.2160,2.1042>,0.025}
cylinder{<-2.0032,0.2160,2.1018>,<-2.0200,0.2160,2.1678>,0.025}
cylinder{<-2.0200,0.2160,2.1678>,<-2.0032,0.2160,2.1018>,0.025}
cylinder{<-2.3496,0.2160,2.0847>,<-2.4000,0.2160,2.1471>,0.025}
cylinder{<-2.4000,0.2160,2.1471>,<-2.3496,0.2160,2.0847>,0.025}
cylinder{<-2.6009,0.2160,2.0385>,<-2.6735,0.2160,2.0907>,0.025}
cylinder{<-2.6735,0.2160,2.0907>,<-2.6009,0.2160,2.0385>,0.025}
cylinder{<-2.7539,0.2160,1.9484>,<-2.8389,0.2160,1.9809>,0.025}
cylinder{<-2.8389,0.2160,1.9809>,<-2.7539,0.2160,1.9484>,0.025}
cylinder{<-2.8056,0.2160,1.8000>,<-2.8944,0.2160,1.8000>,0.025}
cylinder{<-1.5648,0.2160,2.1042>,<-1.5896,0.1440,2.0484>,0.025}
cylinder{<-1.9891,0.1440,2.0464>,<-2.0032,0.2160,2.1018>,0.025}
cylinder{<-2.0032,0.2160,2.1018>,<-1.9891,0.1440,2.0464>,0.025}
cylinder{<-2.3073,0.1440,2.0325>,<-2.3496,0.2160,2.0847>,0.025}
cylinder{<-2.3496,0.2160,2.0847>,<-2.3073,0.1440,2.0325>,0.025}
cylinder{<-2.5399,0.1440,1.9947>,<-2.6009,0.2160,2.0385>,0.025}
cylinder{<-2.6009,0.2160,2.0385>,<-2.5399,0.1440,1.9947>,0.025}
cylinder{<-2.6827,0.1440,1.9212>,<-2.7539,0.2160,1.9484>,0.025}
cylinder{<-2.7539,0.2160,1.9484>,<-2.6827,0.1440,1.9212>,0.025}
cylinder{<-2.7312,0.1440,1.8000>,<-2.8056,0.2160,1.8000>,0.025}
cylinder{<-1.5896,0.1440,2.0484>,<-1.6000,0.0000,2.0250>,0.025}
cylinder{<-1.9832,0.0000,2.0232>,<-1.9891,0.1440,2.0464>,0.025}
cylinder{<-1.9891,0.1440,2.0464>,<-1.9832,0.0000,2.0232>,0.025}
cylinder{<-2.2896,0.0000,2.0106>,<-2.3073,0.1440,2.0325>,0.025}
cylinder{<-2.3073,0.1440,2.0325>,<-2.2896,0.0000,2.0106>,0.025}
cylinder{<-2.5144,0.0000,1.9764>,<-2.5399,0.1440,1.9947>,0.025}
cylinder{<-2.5399,0.1440,1.9947>,<-2.5144,0.0000,1.9764>,0.025}
cylinder{<-2.6528,0.0000,1.9098>,<-2.6827,0.1440,1.9212>,0.025}
cylinder{<-2.6827,0.1440,1.9212>,<-2.6528,0.0000,1.9098>,0.025}
cylinder{<-2.7000,0.0000,1.8000>,<-2.7312,0.1440,1.8000>,0.025}
cylinder{<-2.7000,0.0000,1.8000>,<-2.7312,-0.1440,1.8000>,0.025}
cylinder{<-2.7046,-0.1440,1.6305>,<-2.6752,0.0000,1.6416>,0.025}
cylinder{<-2.6752,0.0000,1.6416>,<-2.7046,-0.1440,1.6305>,0.025}
cylinder{<-2.6216,-0.1440,1.4331>,<-2.5976,0.0000,1.4508>,0.025}
cylinder{<-2.5976,0.0000,1.4508>,<-2.6216,-0.1440,1.4331>,0.025}
cylinder{<-2.4779,-0.1440,1.2273>,<-2.4624,0.0000,1.2492>,0.025}
cylinder{<-2.4624,0.0000,1.2492>,<-2.4779,-0.1440,1.2273>,0.025}
cylinder{<-2.2687,-0.1440,1.0327>,<-2.2648,0.0000,1.0584>,0.025}
cylinder{<-2.2648,0.0000,1.0584>,<-2.2687,-0.1440,1.0327>,0.025}
cylinder{<-1.9896,-0.1440,0.8688>,<-2.0000,0.0000,0.9000>,0.025}
cylinder{<-2.7312,-0.1440,1.8000>,<-2.8056,-0.2160,1.8000>,0.025}
cylinder{<-2.7746,-0.2160,1.6040>,<-2.7046,-0.1440,1.6305>,0.025}
cylinder{<-2.7046,-0.1440,1.6305>,<-2.7746,-0.2160,1.6040>,0.025}
cylinder{<-2.6790,-0.2160,1.3908>,<-2.6216,-0.1440,1.4331>,0.025}
cylinder{<-2.6216,-0.1440,1.4331>,<-2.6790,-0.2160,1.3908>,0.025}
cylinder{<-2.5148,-0.2160,1.1751>,<-2.4779,-0.1440,1.2273>,0.025}
cylinder{<-2.4779,-0.1440,1.2273>,<-2.5148,-0.2160,1.1751>,0.025}
cylinder{<-2.2780,-0.2160,0.9714>,<-2.2687,-0.1440,1.0327>,0.025}
cylinder{<-2.2687,-0.1440,1.0327>,<-2.2780,-0.2160,0.9714>,0.025}
cylinder{<-1.9648,-0.2160,0.7944>,<-1.9896,-0.1440,0.8688>,0.025}
cylinder{<-2.8056,-0.2160,1.8000>,<-2.8944,-0.2160,1.8000>,0.025}
cylinder{<-2.8582,-0.2160,1.5724>,<-2.7746,-0.2160,1.6040>,0.025}
cylinder{<-2.7746,-0.2160,1.6040>,<-2.8582,-0.2160,1.5724>,0.025}
cylinder{<-2.7474,-0.2160,1.3404>,<-2.6790,-0.2160,1.3908>,0.025}
cylinder{<-2.6790,-0.2160,1.3908>,<-2.7474,-0.2160,1.3404>,0.025}
cylinder{<-2.5588,-0.2160,1.1127>,<-2.5148,-0.2160,1.1751>,0.025}
cylinder{<-2.5148,-0.2160,1.1751>,<-2.5588,-0.2160,1.1127>,0.025}
cylinder{<-2.2892,-0.2160,0.8982>,<-2.2780,-0.2160,0.9714>,0.025}
cylinder{<-2.2780,-0.2160,0.9714>,<-2.2892,-0.2160,0.8982>,0.025}
cylinder{<-1.9352,-0.2160,0.7056>,<-1.9648,-0.2160,0.7944>,0.025}
cylinder{<-2.8944,-0.2160,1.8000>,<-2.9688,-0.1440,1.8000>,0.025}
cylinder{<-2.9282,-0.1440,1.5459>,<-2.8582,-0.2160,1.5724>,0.025}
cylinder{<-2.8582,-0.2160,1.5724>,<-2.9282,-0.1440,1.5459>,0.025}
cylinder{<-2.8048,-0.1440,1.2981>,<-2.7474,-0.2160,1.3404>,0.025}
cylinder{<-2.7474,-0.2160,1.3404>,<-2.8048,-0.1440,1.2981>,0.025}
cylinder{<-2.5957,-0.1440,1.0605>,<-2.5588,-0.2160,1.1127>,0.025}
cylinder{<-2.5588,-0.2160,1.1127>,<-2.5957,-0.1440,1.0605>,0.025}
cylinder{<-2.2985,-0.1440,0.8369>,<-2.2892,-0.2160,0.8982>,0.025}
cylinder{<-2.2892,-0.2160,0.8982>,<-2.2985,-0.1440,0.8369>,0.025}
cylinder{<-1.9104,-0.1440,0.6312>,<-1.9352,-0.2160,0.7056>,0.025}
cylinder{<-2.9688,-0.1440,1.8000>,<-3.0000,0.0000,1.8000>,0.025}
cylinder{<-2.9576,0.0000,1.5348>,<-2.9282,-0.1440,1.5459>,0.025}
cylinder{<-2.9282,-0.1440,1.5459>,<-2.9576,0.0000,1.5348>,0.025}
cylinder{<-2.8288,0.0000,1.2804>,<-2.8048,-0.1440,1.2981>,0.025}
cylinder{<-2.8048,-0.1440,1.2981>,<-2.8288,0.0000,1.2804>,0.025}
cylinder{<-2.6112,0.0000,1.0386>,<-2.5957,-0.1440,1.0605>,0.025}
cylinder{<-2.5957,-0.1440,1.0605>,<-2.6112,0.0000,1.0386>,0.025}
cylinder{<-2.3024,0.0000,0.8112>,<-2.2985,-0.1440,0.8369>,0.025}
cylinder{<-2.2985,-0.1440,0.8369>,<-2.3024,0.0000,0.8112>,0.025}
cylinder{<-1.9000,0.0000,0.6000>,<-1.9104,-0.1440,0.6312>,0.025}
cylinder{<-3.0000,0.0000,1.8000>,<-2.9688,0.1440,1.8000>,0.025}
cylinder{<-2.9282,0.1440,1.5459>,<-2.9576,0.0000,1.5348>,0.025}
cylinder{<-2.9576,0.0000,1.5348>,<-2.9282,0.1440,1.5459>,0.025}
cylinder{<-2.8048,0.1440,1.2981>,<-2.8288,0.0000,1.2804>,0.025}
cylinder{<-2.8288,0.0000,1.2804>,<-2.8048,0.1440,1.2981>,0.025}
cylinder{<-2.5957,0.1440,1.0605>,<-2.6112,0.0000,1.0386>,0.025}
cylinder{<-2.6112,0.0000,1.0386>,<-2.5957,0.1440,1.0605>,0.025}
cylinder{<-2.2985,0.1440,0.8369>,<-2.3024,0.0000,0.8112>,0.025}
cylinder{<-2.3024,0.0000,0.8112>,<-2.2985,0.1440,0.8369>,0.025}
cylinder{<-1.9104,0.1440,0.6312>,<-1.9000,0.0000,0.6000>,0.025}
cylinder{<-2.9688,0.1440,1.8000>,<-2.8944,0.2160,1.8000>,0.025}
cylinder{<-2.8582,0.2160,1.5724>,<-2.9282,0.1440,1.5459>,0.025}
cylinder{<-2.9282,0.1440,1.5459>,<-2.8582,0.2160,1.5724>,0.025}
cylinder{<-2.7474,0.2160,1.3404>,<-2.8048,0.1440,1.2981>,0.025}
cylinder{<-2.8048,0.1440,1.2981>,<-2.7474,0.2160,1.3404>,0.025}
cylinder{<-2.5588,0.2160,1.1127>,<-2.5957,0.1440,1.0605>,0.025}
cylinder{<-2.5957,0.1440,1.0605>,<-2.5588,0.2160,1.1127>,0.025}
cylinder{<-2.2892,0.2160,0.8982>,<-2.2985,0.1440,0.8369>,0.025}
cylinder{<-2.2985,0.1440,0.8369>,<-2.2892,0.2160,0.8982>,0.025}
cylinder{<-1.9352,0.2160,0.7056>,<-1.9104,0.1440,0.6312>,0.025}
cylinder{<-2.8944,0.2160,1.8000>,<-2.8056,0.2160,1.8000>,0.025}
cylinder{<-2.7746,0.2160,1.6040>,<-2.8582,0.2160,1.5724>,0.025}
cylinder{<-2.8582,0.2160,1.5724>,<-2.7746,0.2160,1.6040>,0.025}
cylinder{<-2.6790,0.2160,1.3908>,<-2.7474,0.2160,1.3404>,0.025}
cylinder{<-2.7474,0.2160,1.3404>,<-2.6790,0.2160,1.3908>,0.025}
cylinder{<-2.5148,0.2160,1.1751>,<-2.5588,0.2160,1.1127>,0.025}
cylinder{<-2.5588,0.2160,1.1127>,<-2.5148,0.2160,1.1751>,0.025}
cylinder{<-2.2780,0.2160,0.9714>,<-2.2892,0.2160,0.8982>,0.025}
cylinder{<-2.2892,0.2160,0.8982>,<-2.2780,0.2160,0.9714>,0.025}
cylinder{<-1.9648,0.2160,0.7944>,<-1.9352,0.2160,0.7056>,0.025}
cylinder{<-2.8056,0.2160,1.8000>,<-2.7312,0.1440,1.8000>,0.025}
cylinder{<-2.7046,0.1440,1.6305>,<-2.7746,0.2160,1.6040>,0.025}
cylinder{<-2.7746,0.2160,1.6040>,<-2.7046,0.1440,1.6305>,0.025}
cylinder{<-2.6216,0.1440,1.4331>,<-2.6790,0.2160,1.3908>,0.025}
cylinder{<-2.6790,0.2160,1.3908>,<-2.6216,0.1440,1.4331>,0.025}
cylinder{<-2.4779,0.1440,1.2273>,<-2.5148,0.2160,1.1751>,0.025}
cylinder{<-2.5148,0.2160,1.1751>,<-2.4779,0.1440,1.2273>,0.025}
cylinder{<-2.2687,0.1440,1.0327>,<-2.2780,0.2160,0.9714>,0.025}
cylinder{<-2.2780,0.2160,0.9714>,<-2.2687,0.1440,1.0327>,0.025}
cylinder{<-1.9896,0.1440,0.8688>,<-1.9648,0.2160,0.7944>,0.025}
cylinder{<-2.7312,0.1440,1.8000>,<-2.7000,0.0000,1.8000>,0.025}
cylinder{<-2.6752,0.0000,1.6416>,<-2.7046,0.1440,1.6305>,0.025}
cylinder{<-2.7046,0.1440,1.6305>,<-2.6752,0.0000,1.6416>,0.025}
cylinder{<-2.5976,0.0000,1.4508>,<-2.6216,0.1440,1.4331>,0.025}
cylinder{<-2.6216,0.1440,1.4331>,<-2.5976,0.0000,1.4508>,0.025}
cylinder{<-2.4624,0.0000,1.2492>,<-2.4779,0.1440,1.2273>,0.025}
cylinder{<-2.4779,0.1440,1.2273>,<-2.4624,0.0000,1.2492>,0.025}
cylinder{<-2.2648,0.0000,1.0584>,<-2.2687,0.1440,1.0327>,0.025}
cylinder{<-2.2687,0.1440,1.0327>,<-2.2648,0.0000,1.0584>,0.025}
cylinder{<-2.0000,0.0000,0.9000>,<-1.9896,0.1440,0.8688>,0.025}
cylinder{<1.7000,0.0000,1.4250>,<1.7000,-0.3168,1.3392>,0.025}
cylinder{<2.1327,-0.2963,1.4290>,<2.1112,0.0000,1.4976>,0.025}
cylinder{<2.1112,0.0000,1.4976>,<2.1327,-0.2963,1.4290>,0.025}
cylinder{<2.3551,-0.2475,1.6341>,<2.3256,0.0000,1.6818>,0.025}
cylinder{<2.3256,0.0000,1.6818>,<2.3551,-0.2475,1.6341>,0.025}
cylinder{<2.4673,-0.1893,1.9004>,<2.4344,0.0000,1.9272>,0.025}
cylinder{<2.4344,0.0000,1.9272>,<2.4673,-0.1893,1.9004>,0.025}
cylinder{<2.5697,-0.1405,2.1737>,<2.5288,0.0000,2.1834>,0.025}
cylinder{<2.5288,0.0000,2.1834>,<2.5697,-0.1405,2.1737>,0.025}
cylinder{<2.7624,-0.1200,2.4000>,<2.7000,0.0000,2.4000>,0.025}
cylinder{<1.7000,-0.3168,1.3392>,<1.7000,-0.4752,1.1346>,0.025}
cylinder{<2.1839,-0.4445,1.2653>,<2.1327,-0.2963,1.4290>,0.025}
cylinder{<2.1327,-0.2963,1.4290>,<2.1839,-0.4445,1.2653>,0.025}
cylinder{<2.4253,-0.3713,1.5202>,<2.3551,-0.2475,1.6341>,0.025}
cylinder{<2.3551,-0.2475,1.6341>,<2.4253,-0.3713,1.5202>,0.025}
cylinder{<2.5459,-0.2839,1.8364>,<2.4673,-0.1893,1.9004>,0.025}
cylinder{<2.4673,-0.1893,1.9004>,<2.5459,-0.2839,1.8364>,0.025}
cylinder{<2.6673,-0.2107,2.1507>,<2.5697,-0.1405,2.1737>,0.025}
cylinder{<2.5697,-0.1405,2.1737>,<2.6673,-0.2107,2.1507>,0.025}
cylinder{<2.9112,-0.1800,2.4000>,<2.7624,-0.1200,2.4000>,0.025}
cylinder{<1.7000,-0.4752,1.1346>,<1.7000,-0.4752,0.8904>,0.025}
cylinder{<2.2449,-0.4445,1.0699>,<2.1839,-0.4445,1.2653>,0.025}
cylinder{<2.1839,-0.4445,1.2653>,<2.2449,-0.4445,1.0699>,0.025}
cylinder{<2.5091,-0.3713,1.3844>,<2.4253,-0.3713,1.5202>,0.025}
cylinder{<2.4253,-0.3713,1.5202>,<2.5091,-0.3713,1.3844>,0.025}
cylinder{<2.6397,-0.2839,1.7600>,<2.5459,-0.2839,1.8364>,0.025}
cylinder{<2.5459,-0.2839,1.8364>,<2.6397,-0.2839,1.7600>,0.025}
cylinder{<2.7839,-0.2107,2.1231>,<2.6673,-0.2107,2.1507>,0.025}
cylinder{<2.6673,-0.2107,2.1507>,<2.7839,-0.2107,2.1231>,0.025}
cylinder{<3.0888,-0.1800,2.4000>,<2.9112,-0.1800,2.4000>,0.025}
cylinder{<1.7000,-0.4752,0.8904>,<1.7000,-0.3168,0.6858>,0.025}
cylinder{<2.2961,-0.2963,0.9062>,<2.2449,-0.4445,1.0699>,0.025}
cylinder{<2.2449,-0.4445,1.0699>,<2.2961,-0.2963,0.9062>,0.025}
cylinder{<2.5793,-0.2475,1.2705>,<2.5091,-0.3713,1.3844>,0.025}
cylinder{<2.5091,-0.3713,1.3844>,<2.5793,-0.2475,1.2705>,0.025}
cylinder{<2.7183,-0.1893,1.6960>,<2.6397,-0.2839,1.7600>,0.025}
cylinder{<2.6397,-0.2839,1.7600>,<2.7183,-0.1893,1.6960>,0.025}
cylinder{<2.8815,-0.1405,2.1001>,<2.7839,-0.2107,2.1231>,0.025}
cylinder{<2.7839,-0.2107,2.1231>,<2.8815,-0.1405,2.1001>,0.025}
cylinder{<3.2376,-0.1200,2.4000>,<3.0888,-0.1800,2.4000>,0.025}
cylinder{<1.7000,-0.3168,0.6858>,<1.7000,0.0000,0.6000>,0.025}
cylinder{<2.3176,0.0000,0.8376>,<2.2961,-0.2963,0.9062>,0.025}
cylinder{<2.2961,-0.2963,0.9062>,<2.3176,0.0000,0.8376>,0.025}
cylinder{<2.6088,0.0000,1.2228>,<2.5793,-0.2475,1.2705>,0.025}
cylinder{<2.5793,-0.2475,1.2705>,<2.6088,0.0000,1.2228>,0.025}
cylinder{<2.7512,0.0000,1.6692>,<2.7183,-0.1893,1.6960>,0.025}
cylinder{<2.7183,-0.1893,1.6960>,<2.7512,0.0000,1.6692>,0.025}
cylinder{<2.9224,0.0000,2.0904>,<2.8815,-0.1405,2.1001>,0.025}
cylinder{<2.8815,-0.1405,2.1001>,<2.9224,0.0000,2.0904>,0.025}
cylinder{<3.3000,0.0000,2.4000>,<3.2376,-0.1200,2.4000>,0.025}
cylinder{<1.7000,0.0000,0.6000>,<1.7000,0.3168,0.6858>,0.025}
cylinder{<2.2961,0.2963,0.9062>,<2.3176,0.0000,0.8376>,0.025}
cylinder{<2.3176,0.0000,0.8376>,<2.2961,0.2963,0.9062>,0.025}
cylinder{<2.5793,0.2475,1.2705>,<2.6088,0.0000,1.2228>,0.025}
cylinder{<2.6088,0.0000,1.2228>,<2.5793,0.2475,1.2705>,0.025}
cylinder{<2.7183,0.1893,1.6960>,<2.7512,0.0000,1.6692>,0.025}
cylinder{<2.7512,0.0000,1.6692>,<2.7183,0.1893,1.6960>,0.025}
cylinder{<2.8815,0.1405,2.1001>,<2.9224,0.0000,2.0904>,0.025}
cylinder{<2.9224,0.0000,2.0904>,<2.8815,0.1405,2.1001>,0.025}
cylinder{<3.2376,0.1200,2.4000>,<3.3000,0.0000,2.4000>,0.025}
cylinder{<1.7000,0.3168,0.6858>,<1.7000,0.4752,0.8904>,0.025}
cylinder{<2.2449,0.4445,1.0699>,<2.2961,0.2963,0.9062>,0.025}
cylinder{<2.2961,0.2963,0.9062>,<2.2449,0.4445,1.0699>,0.025}
cylinder{<2.5091,0.3713,1.3844>,<2.5793,0.2475,1.2705>,0.025}
cylinder{<2.5793,0.2475,1.2705>,<2.5091,0.3713,1.3844>,0.025}
cylinder{<2.6397,0.2839,1.7600>,<2.7183,0.1893,1.6960>,0.025}
cylinder{<2.7183,0.1893,1.6960>,<2.6397,0.2839,1.7600>,0.025}
cylinder{<2.7839,0.2107,2.1231>,<2.8815,0.1405,2.1001>,0.025}
cylinder{<2.8815,0.1405,2.1001>,<2.7839,0.2107,2.1231>,0.025}
cylinder{<3.0888,0.1800,2.4000>,<3.2376,0.1200,2.4000>,0.025}
cylinder{<1.7000,0.4752,0.8904>,<1.7000,0.4752,1.1346>,0.025}
cylinder{<2.1839,0.4445,1.2653>,<2.2449,0.4445,1.0699>,0.025}
cylinder{<2.2449,0.4445,1.0699>,<2.1839,0.4445,1.2653>,0.025}
cylinder{<2.4253,0.3713,1.5202>,<2.5091,0.3713,1.3844>,0.025}
cylinder{<2.5091,0.3713,1.3844>,<2.4253,0.3713,1.5202>,0.025}
cylinder{<2.5459,0.2839,1.8364>,<2.6397,0.2839,1.7600>,0.025}
cylinder{<2.6397,0.2839,1.7600>,<2.5459,0.2839,1.8364>,0.025}
cylinder{<2.6673,0.2107,2.1507>,<2.7839,0.2107,2.1231>,0.025}
cylinder{<2.7839,0.2107,2.1231>,<2.6673,0.2107,2.1507>,0.025}
cylinder{<2.9112,0.1800,2.4000>,<3.0888,0.1800,2.4000>,0.025}
cylinder{<1.7000,0.4752,1.1346>,<1.7000,0.3168,1.3392>,0.025}
cylinder{<2.1327,0.2963,1.4290>,<2.1839,0.4445,1.2653>,0.025}
cylinder{<2.1839,0.4445,1.2653>,<2.1327,0.2963,1.4290>,0.025}
cylinder{<2.3551,0.2475,1.6341>,<2.4253,0.3713,1.5202>,0.025}
cylinder{<2.4253,0.3713,1.5202>,<2.3551,0.2475,1.6341>,0.025}
cylinder{<2.4673,0.1893,1.9004>,<2.5459,0.2839,1.8364>,0.025}
cylinder{<2.5459,0.2839,1.8364>,<2.4673,0.1893,1.9004>,0.025}
cylinder{<2.5697,0.1405,2.1737>,<2.6673,0.2107,2.1507>,0.025}
cylinder{<2.6673,0.2107,2.1507>,<2.5697,0.1405,2.1737>,0.025}
cylinder{<2.7624,0.1200,2.4000>,<2.9112,0.1800,2.4000>,0.025}
cylinder{<1.7000,0.3168,1.3392>,<1.7000,0.0000,1.4250>,0.025}
cylinder{<2.1112,0.0000,1.4976>,<2.1327,0.2963,1.4290>,0.025}
cylinder{<2.1327,0.2963,1.4290>,<2.1112,0.0000,1.4976>,0.025}
cylinder{<2.3256,0.0000,1.6818>,<2.3551,0.2475,1.6341>,0.025}
cylinder{<2.3551,0.2475,1.6341>,<2.3256,0.0000,1.6818>,0.025}
cylinder{<2.4344,0.0000,1.9272>,<2.4673,0.1893,1.9004>,0.025}
cylinder{<2.4673,0.1893,1.9004>,<2.4344,0.0000,1.9272>,0.025}
cylinder{<2.5288,0.0000,2.1834>,<2.5697,0.1405,2.1737>,0.025}
cylinder{<2.5697,0.1405,2.1737>,<2.5288,0.0000,2.1834>,0.025}
cylinder{<2.7000,0.0000,2.4000>,<2.7624,0.1200,2.4000>,0.025}
cylinder{<2.7000,0.0000,2.4000>,<2.7624,-0.1200,2.4000>,0.025}
cylinder{<2.8251,-0.1150,2.4371>,<2.7584,0.0000,2.4360>,0.025}
cylinder{<2.7584,0.0000,2.4360>,<2.8251,-0.1150,2.4371>,0.025}
cylinder{<2.8724,-0.1031,2.4560>,<2.8072,0.0000,2.4540>,0.025}
cylinder{<2.8072,0.0000,2.4540>,<2.8724,-0.1031,2.4560>,0.025}
cylinder{<2.8962,-0.0889,2.4562>,<2.8368,0.0000,2.4540>,0.025}
cylinder{<2.8368,0.0000,2.4540>,<2.8962,-0.0889,2.4562>,0.025}
cylinder{<2.8886,-0.0770,2.4377>,<2.8376,0.0000,2.4360>,0.025}
cylinder{<2.8376,0.0000,2.4360>,<2.8886,-0.0770,2.4377>,0.025}
cylinder{<2.8416,-0.0720,2.4000>,<2.8000,0.0000,2.4000>,0.025}
cylinder{<2.7624,-0.1200,2.4000>,<2.9112,-0.1800,2.4000>,0.025}
cylinder{<2.9842,-0.1725,2.4398>,<2.8251,-0.1150,2.4371>,0.025}
cylinder{<2.8251,-0.1150,2.4371>,<2.9842,-0.1725,2.4398>,0.025}
cylinder{<3.0278,-0.1547,2.4607>,<2.8724,-0.1031,2.4560>,0.025}
cylinder{<2.8724,-0.1031,2.4560>,<3.0278,-0.1547,2.4607>,0.025}
cylinder{<3.0379,-0.1333,2.4616>,<2.8962,-0.0889,2.4562>,0.025}
cylinder{<2.8962,-0.0889,2.4562>,<3.0379,-0.1333,2.4616>,0.025}
cylinder{<3.0102,-0.1155,2.4417>,<2.8886,-0.0770,2.4377>,0.025}
cylinder{<2.8886,-0.0770,2.4377>,<3.0102,-0.1155,2.4417>,0.025}
cylinder{<2.9408,-0.1080,2.4000>,<2.8416,-0.0720,2.4000>,0.025}
cylinder{<2.9112,-0.1800,2.4000>,<3.0888,-0.1800,2.4000>,0.025}
cylinder{<3.1742,-0.1725,2.4430>,<2.9842,-0.1725,2.4398>,0.025}
cylinder{<2.9842,-0.1725,2.4398>,<3.1742,-0.1725,2.4430>,0.025}
cylinder{<3.2134,-0.1547,2.4662>,<3.0278,-0.1547,2.4607>,0.025}
cylinder{<3.0278,-0.1547,2.4607>,<3.2134,-0.1547,2.4662>,0.025}
cylinder{<3.2069,-0.1333,2.4680>,<3.0379,-0.1333,2.4616>,0.025}
cylinder{<3.0379,-0.1333,2.4616>,<3.2069,-0.1333,2.4680>,0.025}
cylinder{<3.1554,-0.1155,2.4465>,<3.0102,-0.1155,2.4417>,0.025}
cylinder{<3.0102,-0.1155,2.4417>,<3.1554,-0.1155,2.4465>,0.025}
cylinder{<3.0592,-0.1080,2.4000>,<2.9408,-0.1080,2.4000>,0.025}
cylinder{<3.0888,-0.1800,2.4000>,<3.2376,-0.1200,2.4000>,0.025}
cylinder{<3.3333,-0.1150,2.4457>,<3.1742,-0.1725,2.4430>,0.025}
cylinder{<3.1742,-0.1725,2.4430>,<3.3333,-0.1150,2.4457>,0.025}
cylinder{<3.3688,-0.1031,2.4709>,<3.2134,-0.1547,2.4662>,0.025}
cylinder{<3.2134,-0.1547,2.4662>,<3.3688,-0.1031,2.4709>,0.025}
cylinder{<3.3486,-0.0889,2.4734>,<3.2069,-0.1333,2.4680>,0.025}
cylinder{<3.2069,-0.1333,2.4680>,<3.3486,-0.0889,2.4734>,0.025}
cylinder{<3.2770,-0.0770,2.4505>,<3.1554,-0.1155,2.4465>,0.025}
cylinder{<3.1554,-0.1155,2.4465>,<3.2770,-0.0770,2.4505>,0.025}
cylinder{<3.1584,-0.0720,2.4000>,<3.0592,-0.1080,2.4000>,0.025}
cylinder{<3.2376,-0.1200,2.4000>,<3.3000,0.0000,2.4000>,0.025}
cylinder{<3.4000,0.0000,2.4468>,<3.3333,-0.1150,2.4457>,0.025}
cylinder{<3.3333,-0.1150,2.4457>,<3.4000,0.0000,2.4468>,0.025}
cylinder{<3.4340,0.0000,2.4729>,<3.3688,-0.1031,2.4709>,0.025}
cylinder{<3.3688,-0.1031,2.4709>,<3.4340,0.0000,2.4729>,0.025}
cylinder{<3.4080,0.0000,2.4756>,<3.3486,-0.0889,2.4734>,0.025}
cylinder{<3.3486,-0.0889,2.4734>,<3.4080,0.0000,2.4756>,0.025}
cylinder{<3.3280,0.0000,2.4522>,<3.2770,-0.0770,2.4505>,0.025}
cylinder{<3.2770,-0.0770,2.4505>,<3.3280,0.0000,2.4522>,0.025}
cylinder{<3.2000,0.0000,2.4000>,<3.1584,-0.0720,2.4000>,0.025}
cylinder{<3.3000,0.0000,2.4000>,<3.2376,0.1200,2.4000>,0.025}
cylinder{<3.3333,0.1150,2.4457>,<3.4000,0.0000,2.4468>,0.025}
cylinder{<3.4000,0.0000,2.4468>,<3.3333,0.1150,2.4457>,0.025}
cylinder{<3.3688,0.1031,2.4709>,<3.4340,0.0000,2.4729>,0.025}
cylinder{<3.4340,0.0000,2.4729>,<3.3688,0.1031,2.4709>,0.025}
cylinder{<3.3486,0.0889,2.4734>,<3.4080,0.0000,2.4756>,0.025}
cylinder{<3.4080,0.0000,2.4756>,<3.3486,0.0889,2.4734>,0.025}
cylinder{<3.2770,0.0770,2.4505>,<3.3280,0.0000,2.4522>,0.025}
cylinder{<3.3280,0.0000,2.4522>,<3.2770,0.0770,2.4505>,0.025}
cylinder{<3.1584,0.0720,2.4000>,<3.2000,0.0000,2.4000>,0.025}
cylinder{<3.2376,0.1200,2.4000>,<3.0888,0.1800,2.4000>,0.025}
cylinder{<3.1742,0.1725,2.4430>,<3.3333,0.1150,2.4457>,0.025}
cylinder{<3.3333,0.1150,2.4457>,<3.1742,0.1725,2.4430>,0.025}
cylinder{<3.2134,0.1547,2.4662>,<3.3688,0.1031,2.4709>,0.025}
cylinder{<3.3688,0.1031,2.4709>,<3.2134,0.1547,2.4662>,0.025}
cylinder{<3.2069,0.1333,2.4680>,<3.3486,0.0889,2.4734>,0.025}
cylinder{<3.3486,0.0889,2.4734>,<3.2069,0.1333,2.4680>,0.025}
cylinder{<3.1554,0.1155,2.4465>,<3.2770,0.0770,2.4505>,0.025}
cylinder{<3.2770,0.0770,2.4505>,<3.1554,0.1155,2.4465>,0.025}
cylinder{<3.0592,0.1080,2.4000>,<3.1584,0.0720,2.4000>,0.025}
cylinder{<3.0888,0.1800,2.4000>,<2.9112,0.1800,2.4000>,0.025}
cylinder{<2.9842,0.1725,2.4398>,<3.1742,0.1725,2.4430>,0.025}
cylinder{<3.1742,0.1725,2.4430>,<2.9842,0.1725,2.4398>,0.025}
cylinder{<3.0278,0.1547,2.4607>,<3.2134,0.1547,2.4662>,0.025}
cylinder{<3.2134,0.1547,2.4662>,<3.0278,0.1547,2.4607>,0.025}
cylinder{<3.0379,0.1333,2.4616>,<3.2069,0.1333,2.4680>,0.025}
cylinder{<3.2069,0.1333,2.4680>,<3.0379,0.1333,2.4616>,0.025}
cylinder{<3.0102,0.1155,2.4417>,<3.1554,0.1155,2.4465>,0.025}
cylinder{<3.1554,0.1155,2.4465>,<3.0102,0.1155,2.4417>,0.025}
cylinder{<2.9408,0.1080,2.4000>,<3.0592,0.1080,2.4000>,0.025}
cylinder{<2.9112,0.1800,2.4000>,<2.7624,0.1200,2.4000>,0.025}
cylinder{<2.8251,0.1150,2.4371>,<2.9842,0.1725,2.4398>,0.025}
cylinder{<2.9842,0.1725,2.4398>,<2.8251,0.1150,2.4371>,0.025}
cylinder{<2.8724,0.1031,2.4560>,<3.0278,0.1547,2.4607>,0.025}
cylinder{<3.0278,0.1547,2.4607>,<2.8724,0.1031,2.4560>,0.025}
cylinder{<2.8962,0.0889,2.4562>,<3.0379,0.1333,2.4616>,0.025}
cylinder{<3.0379,0.1333,2.4616>,<2.8962,0.0889,2.4562>,0.025}
cylinder{<2.8886,0.0770,2.4377>,<3.0102,0.1155,2.4417>,0.025}
cylinder{<3.0102,0.1155,2.4417>,<2.8886,0.0770,2.4377>,0.025}
cylinder{<2.8416,0.0720,2.4000>,<2.9408,0.1080,2.4000>,0.025}
cylinder{<2.7624,0.1200,2.4000>,<2.7000,0.0000,2.4000>,0.025}
cylinder{<2.7584,0.0000,2.4360>,<2.8251,0.1150,2.4371>,0.025}
cylinder{<2.8251,0.1150,2.4371>,<2.7584,0.0000,2.4360>,0.025}
cylinder{<2.8072,0.0000,2.4540>,<2.8724,0.1031,2.4560>,0.025}
cylinder{<2.8724,0.1031,2.4560>,<2.8072,0.0000,2.4540>,0.025}
cylinder{<2.8368,0.0000,2.4540>,<2.8962,0.0889,2.4562>,0.025}
cylinder{<2.8962,0.0889,2.4562>,<2.8368,0.0000,2.4540>,0.025}
cylinder{<2.8376,0.0000,2.4360>,<2.8886,0.0770,2.4377>,0.025}
cylinder{<2.8886,0.0770,2.4377>,<2.8376,0.0000,2.4360>,0.025}
cylinder{<2.8000,0.0000,2.4000>,<2.8416,0.0720,2.4000>,0.025}
cylinder{<0.2934,-0.0988,3.1176>,<0.3088,0.0000,3.1176>,0.025}
cylinder{<0.3088,0.0000,3.1176>,<0.2934,-0.0988,3.1176>,0.025}
cylinder{<0.3405,-0.1147,3.0348>,<0.3584,0.0000,3.0348>,0.025}
cylinder{<0.3584,0.0000,3.0348>,<0.3405,-0.1147,3.0348>,0.025}
cylinder{<0.2599,-0.0875,2.9232>,<0.2736,0.0000,2.9232>,0.025}
cylinder{<0.2736,0.0000,2.9232>,<0.2599,-0.0875,2.9232>,0.025}
cylinder{<0.1702,-0.0572,2.8044>,<0.1792,0.0000,2.8044>,0.025}
cylinder{<0.1792,0.0000,2.8044>,<0.1702,-0.0572,2.8044>,0.025}
cylinder{<0.1900,-0.0638,2.7000>,<0.2000,0.0000,2.7000>,0.025}
cylinder{<0.2501,-0.1837,3.1176>,<0.2934,-0.0988,3.1176>,0.025}
cylinder{<0.2934,-0.0988,3.1176>,<0.2501,-0.1837,3.1176>,0.025}
cylinder{<0.2903,-0.2132,3.0348>,<0.3405,-0.1147,3.0348>,0.025}
cylinder{<0.3405,-0.1147,3.0348>,<0.2903,-0.2132,3.0348>,0.025}
cylinder{<0.2216,-0.1627,2.9232>,<0.2599,-0.0875,2.9232>,0.025}
cylinder{<0.2599,-0.0875,2.9232>,<0.2216,-0.1627,2.9232>,0.025}
cylinder{<0.1451,-0.1065,2.8044>,<0.1702,-0.0572,2.8044>,0.025}
cylinder{<0.1702,-0.0572,2.8044>,<0.1451,-0.1065,2.8044>,0.025}
cylinder{<0.1619,-0.1188,2.7000>,<0.1900,-0.0638,2.7000>,0.025}
cylinder{<0.1837,-0.2501,3.1176>,<0.2501,-0.1837,3.1176>,0.025}
cylinder{<0.2501,-0.1837,3.1176>,<0.1837,-0.2501,3.1176>,0.025}
cylinder{<0.2132,-0.2903,3.0348>,<0.2903,-0.2132,3.0348>,0.025}
cylinder{<0.2903,-0.2132,3.0348>,<0.2132,-0.2903,3.0348>,0.025}
cylinder{<0.1627,-0.2216,2.9232>,<0.2216,-0.1627,2.9232>,0.025}
cylinder{<0.2216,-0.1627,2.9232>,<0.1627,-0.2216,2.9232>,0.025}
cylinder{<0.1065,-0.1451,2.8044>,<0.1451,-0.1065,2.8044>,0.025}
cylinder{<0.1451,-0.1065,2.8044>,<0.1065,-0.1451,2.8044>,0.025}
cylinder{<0.1188,-0.1619,2.7000>,<0.1619,-0.1188,2.7000>,0.025}
cylinder{<0.0988,-0.2934,3.1176>,<0.1837,-0.2501,3.1176>,0.025}
cylinder{<0.1837,-0.2501,3.1176>,<0.0988,-0.2934,3.1176>,0.025}
cylinder{<0.1147,-0.3405,3.0348>,<0.2132,-0.2903,3.0348>,0.025}
cylinder{<0.2132,-0.2903,3.0348>,<0.1147,-0.3405,3.0348>,0.025}
cylinder{<0.0875,-0.2599,2.9232>,<0.1627,-0.2216,2.9232>,0.025}
cylinder{<0.1627,-0.2216,2.9232>,<0.0875,-0.2599,2.9232>,0.025}
cylinder{<0.0572,-0.1702,2.8044>,<0.1065,-0.1451,2.8044>,0.025}
cylinder{<0.1065,-0.1451,2.8044>,<0.0572,-0.1702,2.8044>,0.025}
cylinder{<0.0638,-0.1900,2.7000>,<0.1188,-0.1619,2.7000>,0.025}
cylinder{<0.0000,-0.3088,3.1176>,<0.0988,-0.2934,3.1176>,0.025}
cylinder{<0.0988,-0.2934,3.1176>,<0.0000,-0.3088,3.1176>,0.025}
cylinder{<0.0000,-0.3584,3.0348>,<0.1147,-0.3405,3.0348>,0.025}
cylinder{<0.1147,-0.3405,3.0348>,<0.0000,-0.3584,3.0348>,0.025}
cylinder{<0.0000,-0.2736,2.9232>,<0.0875,-0.2599,2.9232>,0.025}
cylinder{<0.0875,-0.2599,2.9232>,<0.0000,-0.2736,2.9232>,0.025}
cylinder{<0.0000,-0.1792,2.8044>,<0.0572,-0.1702,2.8044>,0.025}
cylinder{<0.0572,-0.1702,2.8044>,<0.0000,-0.1792,2.8044>,0.025}
cylinder{<0.0000,-0.2000,2.7000>,<0.0638,-0.1900,2.7000>,0.025}
cylinder{<-0.0988,-0.2934,3.1176>,<0.0000,-0.3088,3.1176>,0.025}
cylinder{<0.0000,-0.3088,3.1176>,<-0.0988,-0.2934,3.1176>,0.025}
cylinder{<-0.1147,-0.3405,3.0348>,<0.0000,-0.3584,3.0348>,0.025}
cylinder{<0.0000,-0.3584,3.0348>,<-0.1147,-0.3405,3.0348>,0.025}
cylinder{<-0.0875,-0.2599,2.9232>,<0.0000,-0.2736,2.9232>,0.025}
cylinder{<0.0000,-0.2736,2.9232>,<-0.0875,-0.2599,2.9232>,0.025}
cylinder{<-0.0572,-0.1702,2.8044>,<0.0000,-0.1792,2.8044>,0.025}
cylinder{<0.0000,-0.1792,2.8044>,<-0.0572,-0.1702,2.8044>,0.025}
cylinder{<-0.0638,-0.1900,2.7000>,<0.0000,-0.2000,2.7000>,0.025}
cylinder{<-0.1837,-0.2501,3.1176>,<-0.0988,-0.2934,3.1176>,0.025}
cylinder{<-0.0988,-0.2934,3.1176>,<-0.1837,-0.2501,3.1176>,0.025}
cylinder{<-0.2132,-0.2903,3.0348>,<-0.1147,-0.3405,3.0348>,0.025}
cylinder{<-0.1147,-0.3405,3.0348>,<-0.2132,-0.2903,3.0348>,0.025}
cylinder{<-0.1627,-0.2216,2.9232>,<-0.0875,-0.2599,2.9232>,0.025}
cylinder{<-0.0875,-0.2599,2.9232>,<-0.1627,-0.2216,2.9232>,0.025}
cylinder{<-0.1065,-0.1451,2.8044>,<-0.0572,-0.1702,2.8044>,0.025}
cylinder{<-0.0572,-0.1702,2.8044>,<-0.1065,-0.1451,2.8044>,0.025}
cylinder{<-0.1188,-0.1619,2.7000>,<-0.0638,-0.1900,2.7000>,0.025}
cylinder{<-0.2501,-0.1837,3.1176>,<-0.1837,-0.2501,3.1176>,0.025}
cylinder{<-0.1837,-0.2501,3.1176>,<-0.2501,-0.1837,3.1176>,0.025}
cylinder{<-0.2903,-0.2132,3.0348>,<-0.2132,-0.2903,3.0348>,0.025}
cylinder{<-0.2132,-0.2903,3.0348>,<-0.2903,-0.2132,3.0348>,0.025}
cylinder{<-0.2216,-0.1627,2.9232>,<-0.1627,-0.2216,2.9232>,0.025}
cylinder{<-0.1627,-0.2216,2.9232>,<-0.2216,-0.1627,2.9232>,0.025}
cylinder{<-0.1451,-0.1065,2.8044>,<-0.1065,-0.1451,2.8044>,0.025}
cylinder{<-0.1065,-0.1451,2.8044>,<-0.1451,-0.1065,2.8044>,0.025}
cylinder{<-0.1619,-0.1188,2.7000>,<-0.1188,-0.1619,2.7000>,0.025}
cylinder{<-0.2934,-0.0988,3.1176>,<-0.2501,-0.1837,3.1176>,0.025}
cylinder{<-0.2501,-0.1837,3.1176>,<-0.2934,-0.0988,3.1176>,0.025}
cylinder{<-0.3405,-0.1147,3.0348>,<-0.2903,-0.2132,3.0348>,0.025}
cylinder{<-0.2903,-0.2132,3.0348>,<-0.3405,-0.1147,3.0348>,0.025}
cylinder{<-0.2599,-0.0875,2.9232>,<-0.2216,-0.1627,2.9232>,0.025}
cylinder{<-0.2216,-0.1627,2.9232>,<-0.2599,-0.0875,2.9232>,0.025}
cylinder{<-0.1702,-0.0572,2.8044>,<-0.1451,-0.1065,2.8044>,0.025}
cylinder{<-0.1451,-0.1065,2.8044>,<-0.1702,-0.0572,2.8044>,0.025}
cylinder{<-0.1900,-0.0638,2.7000>,<-0.1619,-0.1188,2.7000>,0.025}
cylinder{<-0.3088,0.0000,3.1176>,<-0.2934,-0.0988,3.1176>,0.025}
cylinder{<-0.2934,-0.0988,3.1176>,<-0.3088,0.0000,3.1176>,0.025}
cylinder{<-0.3584,0.0000,3.0348>,<-0.3405,-0.1147,3.0348>,0.025}
cylinder{<-0.3405,-0.1147,3.0348>,<-0.3584,0.0000,3.0348>,0.025}
cylinder{<-0.2736,0.0000,2.9232>,<-0.2599,-0.0875,2.9232>,0.025}
cylinder{<-0.2599,-0.0875,2.9232>,<-0.2736,0.0000,2.9232>,0.025}
cylinder{<-0.1792,0.0000,2.8044>,<-0.1702,-0.0572,2.8044>,0.025}
cylinder{<-0.1702,-0.0572,2.8044>,<-0.1792,0.0000,2.8044>,0.025}
cylinder{<-0.2000,0.0000,2.7000>,<-0.1900,-0.0638,2.7000>,0.025}
cylinder{<-0.2934,0.0988,3.1176>,<-0.3088,0.0000,3.1176>,0.025}
cylinder{<-0.3088,0.0000,3.1176>,<-0.2934,0.0988,3.1176>,0.025}
cylinder{<-0.3405,0.1147,3.0348>,<-0.3584,0.0000,3.0348>,0.025}
cylinder{<-0.3584,0.0000,3.0348>,<-0.3405,0.1147,3.0348>,0.025}
cylinder{<-0.2599,0.0875,2.9232>,<-0.2736,0.0000,2.9232>,0.025}
cylinder{<-0.2736,0.0000,2.9232>,<-0.2599,0.0875,2.9232>,0.025}
cylinder{<-0.1702,0.0572,2.8044>,<-0.1792,0.0000,2.8044>,0.025}
cylinder{<-0.1792,0.0000,2.8044>,<-0.1702,0.0572,2.8044>,0.025}
cylinder{<-0.1900,0.0638,2.7000>,<-0.2000,0.0000,2.7000>,0.025}
cylinder{<-0.2501,0.1837,3.1176>,<-0.2934,0.0988,3.1176>,0.025}
cylinder{<-0.2934,0.0988,3.1176>,<-0.2501,0.1837,3.1176>,0.025}
cylinder{<-0.2903,0.2132,3.0348>,<-0.3405,0.1147,3.0348>,0.025}
cylinder{<-0.3405,0.1147,3.0348>,<-0.2903,0.2132,3.0348>,0.025}
cylinder{<-0.2216,0.1627,2.9232>,<-0.2599,0.0875,2.9232>,0.025}
cylinder{<-0.2599,0.0875,2.9232>,<-0.2216,0.1627,2.9232>,0.025}
cylinder{<-0.1451,0.1065,2.8044>,<-0.1702,0.0572,2.8044>,0.025}
cylinder{<-0.1702,0.0572,2.8044>,<-0.1451,0.1065,2.8044>,0.025}
cylinder{<-0.1619,0.1188,2.7000>,<-0.1900,0.0638,2.7000>,0.025}
cylinder{<-0.1837,0.2501,3.1176>,<-0.2501,0.1837,3.1176>,0.025}
cylinder{<-0.2501,0.1837,3.1176>,<-0.1837,0.2501,3.1176>,0.025}
cylinder{<-0.2132,0.2903,3.0348>,<-0.2903,0.2132,3.0348>,0.025}
cylinder{<-0.2903,0.2132,3.0348>,<-0.2132,0.2903,3.0348>,0.025}
cylinder{<-0.1627,0.2216,2.9232>,<-0.2216,0.1627,2.9232>,0.025}
cylinder{<-0.2216,0.1627,2.9232>,<-0.1627,0.2216,2.9232>,0.025}
cylinder{<-0.1065,0.1451,2.8044>,<-0.1451,0.1065,2.8044>,0.025}
cylinder{<-0.1451,0.1065,2.8044>,<-0.1065,0.1451,2.8044>,0.025}
cylinder{<-0.1188,0.1619,2.7000>,<-0.1619,0.1188,2.7000>,0.025}
cylinder{<-0.0988,0.2934,3.1176>,<-0.1837,0.2501,3.1176>,0.025}
cylinder{<-0.1837,0.2501,3.1176>,<-0.0988,0.2934,3.1176>,0.025}
cylinder{<-0.1147,0.3405,3.0348>,<-0.2132,0.2903,3.0348>,0.025}
cylinder{<-0.2132,0.2903,3.0348>,<-0.1147,0.3405,3.0348>,0.025}
cylinder{<-0.0875,0.2599,2.9232>,<-0.1627,0.2216,2.9232>,0.025}
cylinder{<-0.1627,0.2216,2.9232>,<-0.0875,0.2599,2.9232>,0.025}
cylinder{<-0.0572,0.1702,2.8044>,<-0.1065,0.1451,2.8044>,0.025}
cylinder{<-0.1065,0.1451,2.8044>,<-0.0572,0.1702,2.8044>,0.025}
cylinder{<-0.0638,0.1900,2.7000>,<-0.1188,0.1619,2.7000>,0.025}
cylinder{<0.0000,0.3088,3.1176>,<-0.0988,0.2934,3.1176>,0.025}
cylinder{<-0.0988,0.2934,3.1176>,<0.0000,0.3088,3.1176>,0.025}
cylinder{<0.0000,0.3584,3.0348>,<-0.1147,0.3405,3.0348>,0.025}
cylinder{<-0.1147,0.3405,3.0348>,<0.0000,0.3584,3.0348>,0.025}
cylinder{<0.0000,0.2736,2.9232>,<-0.0875,0.2599,2.9232>,0.025}
cylinder{<-0.0875,0.2599,2.9232>,<0.0000,0.2736,2.9232>,0.025}
cylinder{<0.0000,0.1792,2.8044>,<-0.0572,0.1702,2.8044>,0.025}
cylinder{<-0.0572,0.1702,2.8044>,<0.0000,0.1792,2.8044>,0.025}
cylinder{<0.0000,0.2000,2.7000>,<-0.0638,0.1900,2.7000>,0.025}
cylinder{<0.0988,0.2934,3.1176>,<0.0000,0.3088,3.1176>,0.025}
cylinder{<0.0000,0.3088,3.1176>,<0.0988,0.2934,3.1176>,0.025}
cylinder{<0.1147,0.3405,3.0348>,<0.0000,0.3584,3.0348>,0.025}
cylinder{<0.0000,0.3584,3.0348>,<0.1147,0.3405,3.0348>,0.025}
cylinder{<0.0875,0.2599,2.9232>,<0.0000,0.2736,2.9232>,0.025}
cylinder{<0.0000,0.2736,2.9232>,<0.0875,0.2599,2.9232>,0.025}
cylinder{<0.0572,0.1702,2.8044>,<0.0000,0.1792,2.8044>,0.025}
cylinder{<0.0000,0.1792,2.8044>,<0.0572,0.1702,2.8044>,0.025}
cylinder{<0.0638,0.1900,2.7000>,<0.0000,0.2000,2.7000>,0.025}
cylinder{<0.1837,0.2501,3.1176>,<0.0988,0.2934,3.1176>,0.025}
cylinder{<0.0988,0.2934,3.1176>,<0.1837,0.2501,3.1176>,0.025}
cylinder{<0.2132,0.2903,3.0348>,<0.1147,0.3405,3.0348>,0.025}
cylinder{<0.1147,0.3405,3.0348>,<0.2132,0.2903,3.0348>,0.025}
cylinder{<0.1627,0.2216,2.9232>,<0.0875,0.2599,2.9232>,0.025}
cylinder{<0.0875,0.2599,2.9232>,<0.1627,0.2216,2.9232>,0.025}
cylinder{<0.1065,0.1451,2.8044>,<0.0572,0.1702,2.8044>,0.025}
cylinder{<0.0572,0.1702,2.8044>,<0.1065,0.1451,2.8044>,0.025}
cylinder{<0.1188,0.1619,2.7000>,<0.0638,0.1900,2.7000>,0.025}
cylinder{<0.2501,0.1837,3.1176>,<0.1837,0.2501,3.1176>,0.025}
cylinder{<0.1837,0.2501,3.1176>,<0.2501,0.1837,3.1176>,0.025}
cylinder{<0.2903,0.2132,3.0348>,<0.2132,0.2903,3.0348>,0.025}
cylinder{<0.2132,0.2903,3.0348>,<0.2903,0.2132,3.0348>,0.025}
cylinder{<0.2216,0.1627,2.9232>,<0.1627,0.2216,2.9232>,0.025}
cylinder{<0.1627,0.2216,2.9232>,<0.2216,0.1627,2.9232>,0.025}
cylinder{<0.1451,0.1065,2.8044>,<0.1065,0.1451,2.8044>,0.025}
cylinder{<0.1065,0.1451,2.8044>,<0.1451,0.1065,2.8044>,0.025}
cylinder{<0.1619,0.1188,2.7000>,<0.1188,0.1619,2.7000>,0.025}
cylinder{<0.2934,0.0988,3.1176>,<0.2501,0.1837,3.1176>,0.025}
cylinder{<0.2501,0.1837,3.1176>,<0.2934,0.0988,3.1176>,0.025}
cylinder{<0.3405,0.1147,3.0348>,<0.2903,0.2132,3.0348>,0.025}
cylinder{<0.2903,0.2132,3.0348>,<0.3405,0.1147,3.0348>,0.025}
cylinder{<0.2599,0.0875,2.9232>,<0.2216,0.1627,2.9232>,0.025}
cylinder{<0.2216,0.1627,2.9232>,<0.2599,0.0875,2.9232>,0.025}
cylinder{<0.1702,0.0572,2.8044>,<0.1451,0.1065,2.8044>,0.025}
cylinder{<0.1451,0.1065,2.8044>,<0.1702,0.0572,2.8044>,0.025}
cylinder{<0.1900,0.0638,2.7000>,<0.1619,0.1188,2.7000>,0.025}
cylinder{<0.3088,0.0000,3.1176>,<0.2934,0.0988,3.1176>,0.025}
cylinder{<0.2934,0.0988,3.1176>,<0.3088,0.0000,3.1176>,0.025}
cylinder{<0.3584,0.0000,3.0348>,<0.3405,0.1147,3.0348>,0.025}
cylinder{<0.3405,0.1147,3.0348>,<0.3584,0.0000,3.0348>,0.025}
cylinder{<0.2736,0.0000,2.9232>,<0.2599,0.0875,2.9232>,0.025}
cylinder{<0.2599,0.0875,2.9232>,<0.2736,0.0000,2.9232>,0.025}
cylinder{<0.1792,0.0000,2.8044>,<0.1702,0.0572,2.8044>,0.025}
cylinder{<0.1702,0.0572,2.8044>,<0.1792,0.0000,2.8044>,0.025}
cylinder{<0.2000,0.0000,2.7000>,<0.1900,0.0638,2.7000>,0.025}
cylinder{<0.2000,0.0000,2.7000>,<0.1900,-0.0638,2.7000>,0.025}
cylinder{<0.3715,-0.1248,2.6256>,<0.3912,0.0000,2.6256>,0.025}
cylinder{<0.3912,0.0000,2.6256>,<0.3715,-0.1248,2.6256>,0.025}
cylinder{<0.6398,-0.2149,2.5728>,<0.6736,0.0000,2.5728>,0.025}
cylinder{<0.6736,0.0000,2.5728>,<0.6398,-0.2149,2.5728>,0.025}
cylinder{<0.9216,-0.3096,2.5272>,<0.9704,0.0000,2.5272>,0.025}
cylinder{<0.9704,0.0000,2.5272>,<0.9216,-0.3096,2.5272>,0.025}
cylinder{<1.1443,-0.3844,2.4744>,<1.2048,0.0000,2.4744>,0.025}
cylinder{<1.2048,0.0000,2.4744>,<1.1443,-0.3844,2.4744>,0.025}
cylinder{<1.2347,-0.4148,2.4000>,<1.3000,0.0000,2.4000>,0.025}
cylinder{<0.1900,-0.0638,2.7000>,<0.1619,-0.1188,2.7000>,0.025}
cylinder{<0.3166,-0.2323,2.6256>,<0.3715,-0.1248,2.6256>,0.025}
cylinder{<0.3715,-0.1248,2.6256>,<0.3166,-0.2323,2.6256>,0.025}
cylinder{<0.5451,-0.4001,2.5728>,<0.6398,-0.2149,2.5728>,0.025}
cylinder{<0.6398,-0.2149,2.5728>,<0.5451,-0.4001,2.5728>,0.025}
cylinder{<0.7853,-0.5763,2.5272>,<0.9216,-0.3096,2.5272>,0.025}
cylinder{<0.9216,-0.3096,2.5272>,<0.7853,-0.5763,2.5272>,0.025}
cylinder{<0.9750,-0.7156,2.4744>,<1.1443,-0.3844,2.4744>,0.025}
cylinder{<1.1443,-0.3844,2.4744>,<0.9750,-0.7156,2.4744>,0.025}
cylinder{<1.0521,-0.7721,2.4000>,<1.2347,-0.4148,2.4000>,0.025}
cylinder{<0.1619,-0.1188,2.7000>,<0.1188,-0.1619,2.7000>,0.025}
cylinder{<0.2323,-0.3166,2.6256>,<0.3166,-0.2323,2.6256>,0.025}
cylinder{<0.3166,-0.2323,2.6256>,<0.2323,-0.3166,2.6256>,0.025}
cylinder{<0.4001,-0.5451,2.5728>,<0.5451,-0.4001,2.5728>,0.025}
cylinder{<0.5451,-0.4001,2.5728>,<0.4001,-0.5451,2.5728>,0.025}
cylinder{<0.5763,-0.7853,2.5272>,<0.7853,-0.5763,2.5272>,0.025}
cylinder{<0.7853,-0.5763,2.5272>,<0.5763,-0.7853,2.5272>,0.025}
cylinder{<0.7156,-0.9750,2.4744>,<0.9750,-0.7156,2.4744>,0.025}
cylinder{<0.9750,-0.7156,2.4744>,<0.7156,-0.9750,2.4744>,0.025}
cylinder{<0.7721,-1.0521,2.4000>,<1.0521,-0.7721,2.4000>,0.025}
cylinder{<0.1188,-0.1619,2.7000>,<0.0638,-0.1900,2.7000>,0.025}
cylinder{<0.1248,-0.3715,2.6256>,<0.2323,-0.3166,2.6256>,0.025}
cylinder{<0.2323,-0.3166,2.6256>,<0.1248,-0.3715,2.6256>,0.025}
cylinder{<0.2149,-0.6398,2.5728>,<0.4001,-0.5451,2.5728>,0.025}
cylinder{<0.4001,-0.5451,2.5728>,<0.2149,-0.6398,2.5728>,0.025}
cylinder{<0.3096,-0.9216,2.5272>,<0.5763,-0.7853,2.5272>,0.025}
cylinder{<0.5763,-0.7853,2.5272>,<0.3096,-0.9216,2.5272>,0.025}
cylinder{<0.3844,-1.1443,2.4744>,<0.7156,-0.9750,2.4744>,0.025}
cylinder{<0.7156,-0.9750,2.4744>,<0.3844,-1.1443,2.4744>,0.025}
cylinder{<0.4148,-1.2347,2.4000>,<0.7721,-1.0521,2.4000>,0.025}
cylinder{<0.0638,-0.1900,2.7000>,<0.0000,-0.2000,2.7000>,0.025}
cylinder{<0.0000,-0.3912,2.6256>,<0.1248,-0.3715,2.6256>,0.025}
cylinder{<0.1248,-0.3715,2.6256>,<0.0000,-0.3912,2.6256>,0.025}
cylinder{<0.0000,-0.6736,2.5728>,<0.2149,-0.6398,2.5728>,0.025}
cylinder{<0.2149,-0.6398,2.5728>,<0.0000,-0.6736,2.5728>,0.025}
cylinder{<0.0000,-0.9704,2.5272>,<0.3096,-0.9216,2.5272>,0.025}
cylinder{<0.3096,-0.9216,2.5272>,<0.0000,-0.9704,2.5272>,0.025}
cylinder{<0.0000,-1.2048,2.4744>,<0.3844,-1.1443,2.4744>,0.025}
cylinder{<0.3844,-1.1443,2.4744>,<0.0000,-1.2048,2.4744>,0.025}
cylinder{<0.0000,-1.3000,2.4000>,<0.4148,-1.2347,2.4000>,0.025}
cylinder{<0.0000,-0.2000,2.7000>,<-0.0638,-0.1900,2.7000>,0.025}
cylinder{<-0.1248,-0.3715,2.6256>,<0.0000,-0.3912,2.6256>,0.025}
cylinder{<0.0000,-0.3912,2.6256>,<-0.1248,-0.3715,2.6256>,0.025}
cylinder{<-0.2149,-0.6398,2.5728>,<0.0000,-0.6736,2.5728>,0.025}
cylinder{<0.0000,-0.6736,2.5728>,<-0.2149,-0.6398,2.5728>,0.025}
cylinder{<-0.3096,-0.9216,2.5272>,<0.0000,-0.9704,2.5272>,0.025}
cylinder{<0.0000,-0.9704,2.5272>,<-0.3096,-0.9216,2.5272>,0.025}
cylinder{<-0.3844,-1.1443,2.4744>,<0.0000,-1.2048,2.4744>,0.025}
cylinder{<0.0000,-1.2048,2.4744>,<-0.3844,-1.1443,2.4744>,0.025}
cylinder{<-0.4148,-1.2347,2.4000>,<0.0000,-1.3000,2.4000>,0.025}
cylinder{<-0.0638,-0.1900,2.7000>,<-0.1188,-0.1619,2.7000>,0.025}
cylinder{<-0.2323,-0.3166,2.6256>,<-0.1248,-0.3715,2.6256>,0.025}
cylinder{<-0.1248,-0.3715,2.6256>,<-0.2323,-0.3166,2.6256>,0.025}
cylinder{<-0.4001,-0.5451,2.5728>,<-0.2149,-0.6398,2.5728>,0.025}
cylinder{<-0.2149,-0.6398,2.5728>,<-0.4001,-0.5451,2.5728>,0.025}
cylinder{<-0.5763,-0.7853,2.5272>,<-0.3096,-0.9216,2.5272>,0.025}
cylinder{<-0.3096,-0.9216,2.5272>,<-0.5763,-0.7853,2.5272>,0.025}
cylinder{<-0.7156,-0.9750,2.4744>,<-0.3844,-1.1443,2.4744>,0.025}
cylinder{<-0.3844,-1.1443,2.4744>,<-0.7156,-0.9750,2.4744>,0.025}
cylinder{<-0.7721,-1.0521,2.4000>,<-0.4148,-1.2347,2.4000>,0.025}
cylinder{<-0.1188,-0.1619,2.7000>,<-0.1619,-0.1188,2.7000>,0.025}
cylinder{<-0.3166,-0.2323,2.6256>,<-0.2323,-0.3166,2.6256>,0.025}
cylinder{<-0.2323,-0.3166,2.6256>,<-0.3166,-0.2323,2.6256>,0.025}
cylinder{<-0.5451,-0.4001,2.5728>,<-0.4001,-0.5451,2.5728>,0.025}
cylinder{<-0.4001,-0.5451,2.5728>,<-0.5451,-0.4001,2.5728>,0.025}
cylinder{<-0.7853,-0.5763,2.5272>,<-0.5763,-0.7853,2.5272>,0.025}
cylinder{<-0.5763,-0.7853,2.5272>,<-0.7853,-0.5763,2.5272>,0.025}
cylinder{<-0.9750,-0.7156,2.4744>,<-0.7156,-0.9750,2.4744>,0.025}
cylinder{<-0.7156,-0.9750,2.4744>,<-0.9750,-0.7156,2.4744>,0.025}
cylinder{<-1.0521,-0.7721,2.4000>,<-0.7721,-1.0521,2.4000>,0.025}
cylinder{<-0.1619,-0.1188,2.7000>,<-0.1900,-0.0638,2.7000>,0.025}
cylinder{<-0.3715,-0.1248,2.6256>,<-0.3166,-0.2323,2.6256>,0.025}
cylinder{<-0.3166,-0.2323,2.6256>,<-0.3715,-0.1248,2.6256>,0.025}
cylinder{<-0.6398,-0.2149,2.5728>,<-0.5451,-0.4001,2.5728>,0.025}
cylinder{<-0.5451,-0.4001,2.5728>,<-0.6398,-0.2149,2.5728>,0.025}
cylinder{<-0.9216,-0.3096,2.5272>,<-0.7853,-0.5763,2.5272>,0.025}
cylinder{<-0.7853,-0.5763,2.5272>,<-0.9216,-0.3096,2.5272>,0.025}
cylinder{<-1.1443,-0.3844,2.4744>,<-0.9750,-0.7156,2.4744>,0.025}
cylinder{<-0.9750,-0.7156,2.4744>,<-1.1443,-0.3844,2.4744>,0.025}
cylinder{<-1.2347,-0.4148,2.4000>,<-1.0521,-0.7721,2.4000>,0.025}
cylinder{<-0.1900,-0.0638,2.7000>,<-0.2000,0.0000,2.7000>,0.025}
cylinder{<-0.3912,0.0000,2.6256>,<-0.3715,-0.1248,2.6256>,0.025}
cylinder{<-0.3715,-0.1248,2.6256>,<-0.3912,0.0000,2.6256>,0.025}
cylinder{<-0.6736,0.0000,2.5728>,<-0.6398,-0.2149,2.5728>,0.025}
cylinder{<-0.6398,-0.2149,2.5728>,<-0.6736,0.0000,2.5728>,0.025}
cylinder{<-0.9704,0.0000,2.5272>,<-0.9216,-0.3096,2.5272>,0.025}
cylinder{<-0.9216,-0.3096,2.5272>,<-0.9704,0.0000,2.5272>,0.025}
cylinder{<-1.2048,0.0000,2.4744>,<-1.1443,-0.3844,2.4744>,0.025}
cylinder{<-1.1443,-0.3844,2.4744>,<-1.2048,0.0000,2.4744>,0.025}
cylinder{<-1.3000,0.0000,2.4000>,<-1.2347,-0.4148,2.4000>,0.025}
cylinder{<-0.2000,0.0000,2.7000>,<-0.1900,0.0638,2.7000>,0.025}
cylinder{<-0.3715,0.1248,2.6256>,<-0.3912,0.0000,2.6256>,0.025}
cylinder{<-0.3912,0.0000,2.6256>,<-0.3715,0.1248,2.6256>,0.025}
cylinder{<-0.6398,0.2149,2.5728>,<-0.6736,0.0000,2.5728>,0.025}
cylinder{<-0.6736,0.0000,2.5728>,<-0.6398,0.2149,2.5728>,0.025}
cylinder{<-0.9216,0.3096,2.5272>,<-0.9704,0.0000,2.5272>,0.025}
cylinder{<-0.9704,0.0000,2.5272>,<-0.9216,0.3096,2.5272>,0.025}
cylinder{<-1.1443,0.3844,2.4744>,<-1.2048,0.0000,2.4744>,0.025}
cylinder{<-1.2048,0.0000,2.4744>,<-1.1443,0.3844,2.4744>,0.025}
cylinder{<-1.2347,0.4148,2.4000>,<-1.3000,0.0000,2.4000>,0.025}
cylinder{<-0.1900,0.0638,2.7000>,<-0.1619,0.1188,2.7000>,0.025}
cylinder{<-0.3166,0.2323,2.6256>,<-0.3715,0.1248,2.6256>,0.025}
cylinder{<-0.3715,0.1248,2.6256>,<-0.3166,0.2323,2.6256>,0.025}
cylinder{<-0.5451,0.4001,2.5728>,<-0.6398,0.2149,2.5728>,0.025}
cylinder{<-0.6398,0.2149,2.5728>,<-0.5451,0.4001,2.5728>,0.025}
cylinder{<-0.7853,0.5763,2.5272>,<-0.9216,0.3096,2.5272>,0.025}
cylinder{<-0.9216,0.3096,2.5272>,<-0.7853,0.5763,2.5272>,0.025}
cylinder{<-0.9750,0.7156,2.4744>,<-1.1443,0.3844,2.4744>,0.025}
cylinder{<-1.1443,0.3844,2.4744>,<-0.9750,0.7156,2.4744>,0.025}
cylinder{<-1.0521,0.7721,2.4000>,<-1.2347,0.4148,2.4000>,0.025}
cylinder{<-0.1619,0.1188,2.7000>,<-0.1188,0.1619,2.7000>,0.025}
cylinder{<-0.2323,0.3166,2.6256>,<-0.3166,0.2323,2.6256>,0.025}
cylinder{<-0.3166,0.2323,2.6256>,<-0.2323,0.3166,2.6256>,0.025}
cylinder{<-0.4001,0.5451,2.5728>,<-0.5451,0.4001,2.5728>,0.025}
cylinder{<-0.5451,0.4001,2.5728>,<-0.4001,0.5451,2.5728>,0.025}
cylinder{<-0.5763,0.7853,2.5272>,<-0.7853,0.5763,2.5272>,0.025}
cylinder{<-0.7853,0.5763,2.5272>,<-0.5763,0.7853,2.5272>,0.025}
cylinder{<-0.7156,0.9750,2.4744>,<-0.9750,0.7156,2.4744>,0.025}
cylinder{<-0.9750,0.7156,2.4744>,<-0.7156,0.9750,2.4744>,0.025}
cylinder{<-0.7721,1.0521,2.4000>,<-1.0521,0.7721,2.4000>,0.025}
cylinder{<-0.1188,0.1619,2.7000>,<-0.0638,0.1900,2.7000>,0.025}
cylinder{<-0.1248,0.3715,2.6256>,<-0.2323,0.3166,2.6256>,0.025}
cylinder{<-0.2323,0.3166,2.6256>,<-0.1248,0.3715,2.6256>,0.025}
cylinder{<-0.2149,0.6398,2.5728>,<-0.4001,0.5451,2.5728>,0.025}
cylinder{<-0.4001,0.5451,2.5728>,<-0.2149,0.6398,2.5728>,0.025}
cylinder{<-0.3096,0.9216,2.5272>,<-0.5763,0.7853,2.5272>,0.025}
cylinder{<-0.5763,0.7853,2.5272>,<-0.3096,0.9216,2.5272>,0.025}
cylinder{<-0.3844,1.1443,2.4744>,<-0.7156,0.9750,2.4744>,0.025}
cylinder{<-0.7156,0.9750,2.4744>,<-0.3844,1.1443,2.4744>,0.025}
cylinder{<-0.4148,1.2347,2.4000>,<-0.7721,1.0521,2.4000>,0.025}
cylinder{<-0.0638,0.1900,2.7000>,<0.0000,0.2000,2.7000>,0.025}
cylinder{<0.0000,0.3912,2.6256>,<-0.1248,0.3715,2.6256>,0.025}
cylinder{<-0.1248,0.3715,2.6256>,<0.0000,0.3912,2.6256>,0.025}
cylinder{<0.0000,0.6736,2.5728>,<-0.2149,0.6398,2.5728>,0.025}
cylinder{<-0.2149,0.6398,2.5728>,<0.0000,0.6736,2.5728>,0.025}
cylinder{<0.0000,0.9704,2.5272>,<-0.3096,0.9216,2.5272>,0.025}
cylinder{<-0.3096,0.9216,2.5272>,<0.0000,0.9704,2.5272>,0.025}
cylinder{<0.0000,1.2048,2.4744>,<-0.3844,1.1443,2.4744>,0.025}
cylinder{<-0.3844,1.1443,2.4744>,<0.0000,1.2048,2.4744>,0.025}
cylinder{<0.0000,1.3000,2.4000>,<-0.4148,1.2347,2.4000>,0.025}
cylinder{<0.0000,0.2000,2.7000>,<0.0638,0.1900,2.7000>,0.025}
cylinder{<0.1248,0.3715,2.6256>,<0.0000,0.3912,2.6256>,0.025}
cylinder{<0.0000,0.3912,2.6256>,<0.1248,0.3715,2.6256>,0.025}
cylinder{<0.2149,0.6398,2.5728>,<0.0000,0.6736,2.5728>,0.025}
cylinder{<0.0000,0.6736,2.5728>,<0.2149,0.6398,2.5728>,0.025}
cylinder{<0.3096,0.9216,2.5272>,<0.0000,0.9704,2.5272>,0.025}
cylinder{<0.0000,0.9704,2.5272>,<0.3096,0.9216,2.5272>,0.025}
cylinder{<0.3844,1.1443,2.4744>,<0.0000,1.2048,2.4744>,0.025}
cylinder{<0.0000,1.2048,2.4744>,<0.3844,1.1443,2.4744>,0.025}
cylinder{<0.4148,1.2347,2.4000>,<0.0000,1.3000,2.4000>,0.025}
cylinder{<0.0638,0.1900,2.7000>,<0.1188,0.1619,2.7000>,0.025}
cylinder{<0.2323,0.3166,2.6256>,<0.1248,0.3715,2.6256>,0.025}
cylinder{<0.1248,0.3715,2.6256>,<0.2323,0.3166,2.6256>,0.025}
cylinder{<0.4001,0.5451,2.5728>,<0.2149,0.6398,2.5728>,0.025}
cylinder{<0.2149,0.6398,2.5728>,<0.4001,0.5451,2.5728>,0.025}
cylinder{<0.5763,0.7853,2.5272>,<0.3096,0.9216,2.5272>,0.025}
cylinder{<0.3096,0.9216,2.5272>,<0.5763,0.7853,2.5272>,0.025}
cylinder{<0.7156,0.9750,2.4744>,<0.3844,1.1443,2.4744>,0.025}
cylinder{<0.3844,1.1443,2.4744>,<0.7156,0.9750,2.4744>,0.025}
cylinder{<0.7721,1.0521,2.4000>,<0.4148,1.2347,2.4000>,0.025}
cylinder{<0.1188,0.1619,2.7000>,<0.1619,0.1188,2.7000>,0.025}
cylinder{<0.3166,0.2323,2.6256>,<0.2323,0.3166,2.6256>,0.025}
cylinder{<0.2323,0.3166,2.6256>,<0.3166,0.2323,2.6256>,0.025}
cylinder{<0.5451,0.4001,2.5728>,<0.4001,0.5451,2.5728>,0.025}
cylinder{<0.4001,0.5451,2.5728>,<0.5451,0.4001,2.5728>,0.025}
cylinder{<0.7853,0.5763,2.5272>,<0.5763,0.7853,2.5272>,0.025}
cylinder{<0.5763,0.7853,2.5272>,<0.7853,0.5763,2.5272>,0.025}
cylinder{<0.9750,0.7156,2.4744>,<0.7156,0.9750,2.4744>,0.025}
cylinder{<0.7156,0.9750,2.4744>,<0.9750,0.7156,2.4744>,0.025}
cylinder{<1.0521,0.7721,2.4000>,<0.7721,1.0521,2.4000>,0.025}
cylinder{<0.1619,0.1188,2.7000>,<0.1900,0.0638,2.7000>,0.025}
cylinder{<0.3715,0.1248,2.6256>,<0.3166,0.2323,2.6256>,0.025}
cylinder{<0.3166,0.2323,2.6256>,<0.3715,0.1248,2.6256>,0.025}
cylinder{<0.6398,0.2149,2.5728>,<0.5451,0.4001,2.5728>,0.025}
cylinder{<0.5451,0.4001,2.5728>,<0.6398,0.2149,2.5728>,0.025}
cylinder{<0.9216,0.3096,2.5272>,<0.7853,0.5763,2.5272>,0.025}
cylinder{<0.7853,0.5763,2.5272>,<0.9216,0.3096,2.5272>,0.025}
cylinder{<1.1443,0.3844,2.4744>,<0.9750,0.7156,2.4744>,0.025}
cylinder{<0.9750,0.7156,2.4744>,<1.1443,0.3844,2.4744>,0.025}
cylinder{<1.2347,0.4148,2.4000>,<1.0521,0.7721,2.4000>,0.025}
cylinder{<0.1900,0.0638,2.7000>,<0.2000,0.0000,2.7000>,0.025}
cylinder{<0.3912,0.0000,2.6256>,<0.3715,0.1248,2.6256>,0.025}
cylinder{<0.3715,0.1248,2.6256>,<0.3912,0.0000,2.6256>,0.025}
cylinder{<0.6736,0.0000,2.5728>,<0.6398,0.2149,2.5728>,0.025}
cylinder{<0.6398,0.2149,2.5728>,<0.6736,0.0000,2.5728>,0.025}
cylinder{<0.9704,0.0000,2.5272>,<0.9216,0.3096,2.5272>,0.025}
cylinder{<0.9216,0.3096,2.5272>,<0.9704,0.0000,2.5272>,0.025}
cylinder{<1.2048,0.0000,2.4744>,<1.1443,0.3844,2.4744>,0.025}
cylinder{<1.1443,0.3844,2.4744>,<1.2048,0.0000,2.4744>,0.025}
cylinder{<1.3000,0.0000,2.4000>,<1.2347,0.4148,2.4000>,0.025}
cylinder{<0.7032,0.0000,0.0084>,<0.6679,0.2243,0.0084>,0.025}
cylinder{<1.0861,0.3649,0.0312>,<1.1436,0.0000,0.0312>,0.025}
cylinder{<1.1436,0.0000,0.0312>,<1.0861,0.3649,0.0312>,0.025}
cylinder{<1.3129,0.4410,0.0648>,<1.3824,0.0000,0.0648>,0.025}
cylinder{<1.3824,0.0000,0.0648>,<1.3129,0.4410,0.0648>,0.025}
cylinder{<1.4064,0.4724,0.1056>,<1.4808,0.0000,0.1056>,0.025}
cylinder{<1.4808,0.0000,0.1056>,<1.4064,0.4724,0.1056>,0.025}
cylinder{<1.4246,0.4786,0.1500>,<1.5000,0.0000,0.1500>,0.025}
cylinder{<0.6679,0.2243,0.0084>,<0.5691,0.4176,0.0084>,0.025}
cylinder{<0.9255,0.6792,0.0312>,<1.0861,0.3649,0.0312>,0.025}
cylinder{<1.0861,0.3649,0.0312>,<0.9255,0.6792,0.0312>,0.025}
cylinder{<1.1187,0.8210,0.0648>,<1.3129,0.4410,0.0648>,0.025}
cylinder{<1.3129,0.4410,0.0648>,<1.1187,0.8210,0.0648>,0.025}
cylinder{<1.1984,0.8795,0.1056>,<1.4064,0.4724,0.1056>,0.025}
cylinder{<1.4064,0.4724,0.1056>,<1.1984,0.8795,0.1056>,0.025}
cylinder{<1.2139,0.8909,0.1500>,<1.4246,0.4786,0.1500>,0.025}
cylinder{<0.5691,0.4176,0.0084>,<0.4176,0.5691,0.0084>,0.025}
cylinder{<0.6792,0.9255,0.0312>,<0.9255,0.6792,0.0312>,0.025}
cylinder{<0.9255,0.6792,0.0312>,<0.6792,0.9255,0.0312>,0.025}
cylinder{<0.8210,1.1187,0.0648>,<1.1187,0.8210,0.0648>,0.025}
cylinder{<1.1187,0.8210,0.0648>,<0.8210,1.1187,0.0648>,0.025}
cylinder{<0.8795,1.1984,0.1056>,<1.1984,0.8795,0.1056>,0.025}
cylinder{<1.1984,0.8795,0.1056>,<0.8795,1.1984,0.1056>,0.025}
cylinder{<0.8909,1.2139,0.1500>,<1.2139,0.8909,0.1500>,0.025}
cylinder{<0.4176,0.5691,0.0084>,<0.2243,0.6679,0.0084>,0.025}
cylinder{<0.3649,1.0861,0.0312>,<0.6792,0.9255,0.0312>,0.025}
cylinder{<0.6792,0.9255,0.0312>,<0.3649,1.0861,0.0312>,0.025}
cylinder{<0.4410,1.3129,0.0648>,<0.8210,1.1187,0.0648>,0.025}
cylinder{<0.8210,1.1187,0.0648>,<0.4410,1.3129,0.0648>,0.025}
cylinder{<0.4724,1.4064,0.1056>,<0.8795,1.1984,0.1056>,0.025}
cylinder{<0.8795,1.1984,0.1056>,<0.4724,1.4064,0.1056>,0.025}
cylinder{<0.4786,1.4246,0.1500>,<0.8909,1.2139,0.1500>,0.025}
cylinder{<0.2243,0.6679,0.0084>,<0.0000,0.7032,0.0084>,0.025}
cylinder{<0.0000,1.1436,0.0312>,<0.3649,1.0861,0.0312>,0.025}
cylinder{<0.3649,1.0861,0.0312>,<0.0000,1.1436,0.0312>,0.025}
cylinder{<0.0000,1.3824,0.0648>,<0.4410,1.3129,0.0648>,0.025}
cylinder{<0.4410,1.3129,0.0648>,<0.0000,1.3824,0.0648>,0.025}
cylinder{<0.0000,1.4808,0.1056>,<0.4724,1.4064,0.1056>,0.025}
cylinder{<0.4724,1.4064,0.1056>,<0.0000,1.4808,0.1056>,0.025}
cylinder{<0.0000,1.5000,0.1500>,<0.4786,1.4246,0.1500>,0.025}
cylinder{<0.0000,0.7032,0.0084>,<-0.2243,0.6679,0.0084>,0.025}
cylinder{<-0.3649,1.0861,0.0312>,<0.0000,1.1436,0.0312>,0.025}
cylinder{<0.0000,1.1436,0.0312>,<-0.3649,1.0861,0.0312>,0.025}
cylinder{<-0.4410,1.3129,0.0648>,<0.0000,1.3824,0.0648>,0.025}
cylinder{<0.0000,1.3824,0.0648>,<-0.4410,1.3129,0.0648>,0.025}
cylinder{<-0.4724,1.4064,0.1056>,<0.0000,1.4808,0.1056>,0.025}
cylinder{<0.0000,1.4808,0.1056>,<-0.4724,1.4064,0.1056>,0.025}
cylinder{<-0.4786,1.4246,0.1500>,<0.0000,1.5000,0.1500>,0.025}
cylinder{<-0.2243,0.6679,0.0084>,<-0.4176,0.5691,0.0084>,0.025}
cylinder{<-0.6792,0.9255,0.0312>,<-0.3649,1.0861,0.0312>,0.025}
cylinder{<-0.3649,1.0861,0.0312>,<-0.6792,0.9255,0.0312>,0.025}
cylinder{<-0.8210,1.1187,0.0648>,<-0.4410,1.3129,0.0648>,0.025}
cylinder{<-0.4410,1.3129,0.0648>,<-0.8210,1.1187,0.0648>,0.025}
cylinder{<-0.8795,1.1984,0.1056>,<-0.4724,1.4064,0.1056>,0.025}
cylinder{<-0.4724,1.4064,0.1056>,<-0.8795,1.1984,0.1056>,0.025}
cylinder{<-0.8909,1.2139,0.1500>,<-0.4786,1.4246,0.1500>,0.025}
cylinder{<-0.4176,0.5691,0.0084>,<-0.5691,0.4176,0.0084>,0.025}
cylinder{<-0.9255,0.6792,0.0312>,<-0.6792,0.9255,0.0312>,0.025}
cylinder{<-0.6792,0.9255,0.0312>,<-0.9255,0.6792,0.0312>,0.025}
cylinder{<-1.1187,0.8210,0.0648>,<-0.8210,1.1187,0.0648>,0.025}
cylinder{<-0.8210,1.1187,0.0648>,<-1.1187,0.8210,0.0648>,0.025}
cylinder{<-1.1984,0.8795,0.1056>,<-0.8795,1.1984,0.1056>,0.025}
cylinder{<-0.8795,1.1984,0.1056>,<-1.1984,0.8795,0.1056>,0.025}
cylinder{<-1.2139,0.8909,0.1500>,<-0.8909,1.2139,0.1500>,0.025}
cylinder{<-0.5691,0.4176,0.0084>,<-0.6679,0.2243,0.0084>,0.025}
cylinder{<-1.0861,0.3649,0.0312>,<-0.9255,0.6792,0.0312>,0.025}
cylinder{<-0.9255,0.6792,0.0312>,<-1.0861,0.3649,0.0312>,0.025}
cylinder{<-1.3129,0.4410,0.0648>,<-1.1187,0.8210,0.0648>,0.025}
cylinder{<-1.1187,0.8210,0.0648>,<-1.3129,0.4410,0.0648>,0.025}
cylinder{<-1.4064,0.4724,0.1056>,<-1.1984,0.8795,0.1056>,0.025}
cylinder{<-1.1984,0.8795,0.1056>,<-1.4064,0.4724,0.1056>,0.025}
cylinder{<-1.4246,0.4786,0.1500>,<-1.2139,0.8909,0.1500>,0.025}
cylinder{<-0.6679,0.2243,0.0084>,<-0.7032,0.0000,0.0084>,0.025}
cylinder{<-1.1436,0.0000,0.0312>,<-1.0861,0.3649,0.0312>,0.025}
cylinder{<-1.0861,0.3649,0.0312>,<-1.1436,0.0000,0.0312>,0.025}
cylinder{<-1.3824,0.0000,0.0648>,<-1.3129,0.4410,0.0648>,0.025}
cylinder{<-1.3129,0.4410,0.0648>,<-1.3824,0.0000,0.0648>,0.025}
cylinder{<-1.4808,0.0000,0.1056>,<-1.4064,0.4724,0.1056>,0.025}
cylinder{<-1.4064,0.4724,0.1056>,<-1.4808,0.0000,0.1056>,0.025}
cylinder{<-1.5000,0.0000,0.1500>,<-1.4246,0.4786,0.1500>,0.025}
cylinder{<-0.7032,0.0000,0.0084>,<-0.6679,-0.2243,0.0084>,0.025}
cylinder{<-1.0861,-0.3649,0.0312>,<-1.1436,0.0000,0.0312>,0.025}
cylinder{<-1.1436,0.0000,0.0312>,<-1.0861,-0.3649,0.0312>,0.025}
cylinder{<-1.3129,-0.4410,0.0648>,<-1.3824,0.0000,0.0648>,0.025}
cylinder{<-1.3824,0.0000,0.0648>,<-1.3129,-0.4410,0.0648>,0.025}
cylinder{<-1.4064,-0.4724,0.1056>,<-1.4808,0.0000,0.1056>,0.025}
cylinder{<-1.4808,0.0000,0.1056>,<-1.4064,-0.4724,0.1056>,0.025}
cylinder{<-1.4246,-0.4786,0.1500>,<-1.5000,0.0000,0.1500>,0.025}
cylinder{<-0.6679,-0.2243,0.0084>,<-0.5691,-0.4176,0.0084>,0.025}
cylinder{<-0.9255,-0.6792,0.0312>,<-1.0861,-0.3649,0.0312>,0.025}
cylinder{<-1.0861,-0.3649,0.0312>,<-0.9255,-0.6792,0.0312>,0.025}
cylinder{<-1.1187,-0.8210,0.0648>,<-1.3129,-0.4410,0.0648>,0.025}
cylinder{<-1.3129,-0.4410,0.0648>,<-1.1187,-0.8210,0.0648>,0.025}
cylinder{<-1.1984,-0.8795,0.1056>,<-1.4064,-0.4724,0.1056>,0.025}
cylinder{<-1.4064,-0.4724,0.1056>,<-1.1984,-0.8795,0.1056>,0.025}
cylinder{<-1.2139,-0.8909,0.1500>,<-1.4246,-0.4786,0.1500>,0.025}
cylinder{<-0.5691,-0.4176,0.0084>,<-0.4176,-0.5691,0.0084>,0.025}
cylinder{<-0.6792,-0.9255,0.0312>,<-0.9255,-0.6792,0.0312>,0.025}
cylinder{<-0.9255,-0.6792,0.0312>,<-0.6792,-0.9255,0.0312>,0.025}
cylinder{<-0.8210,-1.1187,0.0648>,<-1.1187,-0.8210,0.0648>,0.025}
cylinder{<-1.1187,-0.8210,0.0648>,<-0.8210,-1.1187,0.0648>,0.025}
cylinder{<-0.8795,-1.1984,0.1056>,<-1.1984,-0.8795,0.1056>,0.025}
cylinder{<-1.1984,-0.8795,0.1056>,<-0.8795,-1.1984,0.1056>,0.025}
cylinder{<-0.8909,-1.2139,0.1500>,<-1.2139,-0.8909,0.1500>,0.025}
cylinder{<-0.4176,-0.5691,0.0084>,<-0.2243,-0.6679,0.0084>,0.025}
cylinder{<-0.3649,-1.0861,0.0312>,<-0.6792,-0.9255,0.0312>,0.025}
cylinder{<-0.6792,-0.9255,0.0312>,<-0.3649,-1.0861,0.0312>,0.025}
cylinder{<-0.4410,-1.3129,0.0648>,<-0.8210,-1.1187,0.0648>,0.025}
cylinder{<-0.8210,-1.1187,0.0648>,<-0.4410,-1.3129,0.0648>,0.025}
cylinder{<-0.4724,-1.4064,0.1056>,<-0.8795,-1.1984,0.1056>,0.025}
cylinder{<-0.8795,-1.1984,0.1056>,<-0.4724,-1.4064,0.1056>,0.025}
cylinder{<-0.4786,-1.4246,0.1500>,<-0.8909,-1.2139,0.1500>,0.025}
cylinder{<-0.2243,-0.6679,0.0084>,<0.0000,-0.7032,0.0084>,0.025}
cylinder{<0.0000,-1.1436,0.0312>,<-0.3649,-1.0861,0.0312>,0.025}
cylinder{<-0.3649,-1.0861,0.0312>,<0.0000,-1.1436,0.0312>,0.025}
cylinder{<0.0000,-1.3824,0.0648>,<-0.4410,-1.3129,0.0648>,0.025}
cylinder{<-0.4410,-1.3129,0.0648>,<0.0000,-1.3824,0.0648>,0.025}
cylinder{<0.0000,-1.4808,0.1056>,<-0.4724,-1.4064,0.1056>,0.025}
cylinder{<-0.4724,-1.4064,0.1056>,<0.0000,-1.4808,0.1056>,0.025}
cylinder{<0.0000,-1.5000,0.1500>,<-0.4786,-1.4246,0.1500>,0.025}
cylinder{<0.0000,-0.7032,0.0084>,<0.2243,-0.6679,0.0084>,0.025}
cylinder{<0.3649,-1.0861,0.0312>,<0.0000,-1.1436,0.0312>,0.025}
cylinder{<0.0000,-1.1436,0.0312>,<0.3649,-1.0861,0.0312>,0.025}
cylinder{<0.4410,-1.3129,0.0648>,<0.0000,-1.3824,0.0648>,0.025}
cylinder{<0.0000,-1.3824,0.0648>,<0.4410,-1.3129,0.0648>,0.025}
cylinder{<0.4724,-1.4064,0.1056>,<0.0000,-1.4808,0.1056>,0.025}
cylinder{<0.0000,-1.4808,0.1056>,<0.4724,-1.4064,0.1056>,0.025}
cylinder{<0.4786,-1.4246,0.1500>,<0.0000,-1.5000,0.1500>,0.025}
cylinder{<0.2243,-0.6679,0.0084>,<0.4176,-0.5691,0.0084>,0.025}
cylinder{<0.6792,-0.9255,0.0312>,<0.3649,-1.0861,0.0312>,0.025}
cylinder{<0.3649,-1.0861,0.0312>,<0.6792,-0.9255,0.0312>,0.025}
cylinder{<0.8210,-1.1187,0.0648>,<0.4410,-1.3129,0.0648>,0.025}
cylinder{<0.4410,-1.3129,0.0648>,<0.8210,-1.1187,0.0648>,0.025}
cylinder{<0.8795,-1.1984,0.1056>,<0.4724,-1.4064,0.1056>,0.025}
cylinder{<0.4724,-1.4064,0.1056>,<0.8795,-1.1984,0.1056>,0.025}
cylinder{<0.8909,-1.2139,0.1500>,<0.4786,-1.4246,0.1500>,0.025}
cylinder{<0.4176,-0.5691,0.0084>,<0.5691,-0.4176,0.0084>,0.025}
cylinder{<0.9255,-0.6792,0.0312>,<0.6792,-0.9255,0.0312>,0.025}
cylinder{<0.6792,-0.9255,0.0312>,<0.9255,-0.6792,0.0312>,0.025}
cylinder{<1.1187,-0.8210,0.0648>,<0.8210,-1.1187,0.0648>,0.025}
cylinder{<0.8210,-1.1187,0.0648>,<1.1187,-0.8210,0.0648>,0.025}
cylinder{<1.1984,-0.8795,0.1056>,<0.8795,-1.1984,0.1056>,0.025}
cylinder{<0.8795,-1.1984,0.1056>,<1.1984,-0.8795,0.1056>,0.025}
cylinder{<1.2139,-0.8909,0.1500>,<0.8909,-1.2139,0.1500>,0.025}
cylinder{<0.5691,-0.4176,0.0084>,<0.6679,-0.2243,0.0084>,0.025}
cylinder{<1.0861,-0.3649,0.0312>,<0.9255,-0.6792,0.0312>,0.025}
cylinder{<0.9255,-0.6792,0.0312>,<1.0861,-0.3649,0.0312>,0.025}
cylinder{<1.3129,-0.4410,0.0648>,<1.1187,-0.8210,0.0648>,0.025}
cylinder{<1.1187,-0.8210,0.0648>,<1.3129,-0.4410,0.0648>,0.025}
cylinder{<1.4064,-0.4724,0.1056>,<1.1984,-0.8795,0.1056>,0.025}
cylinder{<1.1984,-0.8795,0.1056>,<1.4064,-0.4724,0.1056>,0.025}
cylinder{<1.4246,-0.4786,0.1500>,<1.2139,-0.8909,0.1500>,0.025}
cylinder{<0.6679,-0.2243,0.0084>,<0.7032,0.0000,0.0084>,0.025}
cylinder{<1.1436,0.0000,0.0312>,<1.0861,-0.3649,0.0312>,0.025}
cylinder{<1.0861,-0.3649,0.0312>,<1.1436,0.0000,0.0312>,0.025}
cylinder{<1.3824,0.0000,0.0648>,<1.3129,-0.4410,0.0648>,0.025}
cylinder{<1.3129,-0.4410,0.0648>,<1.3824,0.0000,0.0648>,0.025}
cylinder{<1.4808,0.0000,0.1056>,<1.4064,-0.4724,0.1056>,0.025}
cylinder{<1.4064,-0.4724,0.1056>,<1.4808,0.0000,0.1056>,0.025}
cylinder{<1.5000,0.0000,0.1500>,<1.4246,-0.4786,0.1500>,0.025}	
}

union {
    object { Cyl2_Pot texture { T_Gold_5C } }
    object { Sph_Pot texture { T_Silver_3C } }
    translate ((3.15-2.0)/2) * z
    rotate -x*90
    translate -y*0.65
    rotate y*60
}

</textarea>


<!-- Sample file : stackerday.pov -->

<textarea id="stackerday.pov" name="stackerday.pov" style="display:none;">
// This work is licensed under the Creative Commons Attribution-ShareAlike 3.0 Unported License.
// To view a copy of this license, visit http://creativecommons.org/licenses/by-sa/3.0/ or send a
// letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.

// Features pseudo-Gaussian distribution and use of trace function
// Scene concept and collision algorithm by Greg M. Johnson 2001
// Textures by Gilles Tran
// ------------------------------
// This file creates piles of cubes
// The cubes are generated using a collision detection algorithm
// and the cubes rotations and positions are written to a file called "stacks.inc"
// If you want to run the script a second time without re-generating this file (and thus save on parsing time)
// just uncomment the #declare WriteFile=false line below
// ------------------------------
// THIS SCENE USES RADIOSITY
// ------------------------------
// Stats on a PIII 733 @ 640*480, default antialiasing
// Parsing time with WriteFile=true : 1 min
// Tracing time : > 1 hour
// Peak memory : > 100 Mb
// ------------------------------
//
// -w320 -h240
// -w800 -h600 +a0.3

#version 3.6;

#declare WriteFile=true;  // turns on the generation of the stacks and write them to a file
#declare WriteFile=false; // turns off the generation of the file, just read them from the previous file
// ------------------------------
// choose a number of cubes (has no effect unless WriteFile=True)
// large n values give long parsing time
#declare num=400;
//#declare num=100; 
//#declare num=10; 
//#declare num=5;     
// ------------------------------

// ------------------------------
#include "colors.inc"

// ------------------------------
// Set settings : radiosity only
// ------------------------------
global_settings{
    assumed_gamma 1.0
    radiosity{
        pretrace_start 1
        pretrace_end 1
        count 400
//        count 50 // use this for tests
        recursion_limit 1
        nearest_count 1
        error_bound 0.05
//        error_bound 0.1 // use this for tests
    }
}

#default {finish { ambient 0 diffuse 1 }}

#declare CamLoc=<0,7,-21>; 
#declare CamEye=<0,4.5,-10>;
#declare CamSky=y;
#declare CamZoom=1;

camera {
        location CamLoc
        direction z*CamZoom
        right x*image_width/image_height
        look_at CamEye
}

sky_sphere{  // white sky sphere with a blue far end
    pigment{
        gradient z
        poly_wave 2
        color_map{
            [0  White*1.5]            
            [1 rgb <116,138,176>/255]            
        }
        scale 2
        translate -z
    }
}                         


plane{y,0 texture{pigment{White} finish{ambient 0 diffuse 1}}} 
plane{y,0 rotate x*-20 texture{pigment{White} finish{ambient 0 diffuse 1}} translate z*10000} 

// ------------------------------
// centers the text
// ------------------------------
#macro centertext(Text)
        #local MinText=min_extent(Text);
        #local MaxText=max_extent(Text);
        translate -(MinText+(MaxText-MinText)/2)
#end

// ------------------------------
// creates the cube
// ------------------------------
#macro unitbox()
#local COL=<rand(rd),rand(rd),rand(rd)>;
union{
    difference{
        box{<-0.5,-0.5,-0.5>,<0.5,0.5,0.5>}
        box{<-0.45,-0.45,-1>,<0.45,0.45,1>}
        box{<-1,-0.45,-0.45>,<1,0.45,0.45>}
        box{<-0.45,-1,-0.45>,<0.45,1,0.45>}
        txtBox(COL)
    }                
    box{-0.45,0.45 texture{pigment{White*1.4}}}                                
    #declare Font="cyrvetic"
    #declare sFont=<0.76,0.76,0.05>;
    #local P=text { ttf Font "P" 1, 0 scale sFont}
    #local O=text { ttf Font "O" 1, 0 scale sFont}
    #local V=text { ttf Font "V" 1, 0 scale sFont}
    #local R=text { ttf Font "R" 1, 0 scale sFont}
    #local A=text { ttf Font "A" 1, 0 scale sFont}
    #local Y=text { ttf Font "Y" 1, 0 scale sFont}
    union{
        object{P centertext(P) translate -0.5*z rotate y*90 txtBox(COL)}
        object{O centertext(O) translate -0.5*z  txtBox(COL)}                        
        object{V centertext(V) translate -0.5*z rotate -90*y txtBox(COL)}   
        object{R centertext(R) translate -0.5*z rotate 180*y txtBox(COL)}                   
        object{A centertext(A) translate -0.5*z rotate 90*x txtBox(COL)}  
        object{Y centertext(Y) translate -0.5*z rotate -90*x txtBox(COL)}  
    }
}
#end

// ------------------------------
// cube texture
// ------------------------------
#declare rd=seed(0); // color random stream
#declare sc1=0.5;
#declare sc2=1;
#macro txtBox(COL)
    texture{
       pigment { rgb <COL.x+rand(rd)*sc1,COL.y+rand(rd)*sc1,COL.z+rand(rd)*sc1>*sc2}
       finish{ambient 0 diffuse 1}
    }                   
#end                                                    


// ------------------------------
// scene
// ------------------------------
#if (WriteFile) 

// ------------------------------
// Features pseudo-Gaussian distribution and use of trace function
// Collision algorithm by Greg M. Johnson 2001
// ------------------------------
// ------------------------------
// visibility test
// code by Gilles Tran, derived from work by John Van Sickle and Christoph Hormann
// ------------------------------
#declare CamD=vnormalize(CamEye-CamLoc);         // direction of camera view
#declare CamR=vnormalize(vcross(CamSky,CamD));   // to the right
#declare CamU=vnormalize(vcross(CamD,CamR));     // camera up

#declare Screen= // pseudo screen to test the visibility of an object
  mesh{
    triangle{0,x,x+y}
    triangle{0,y,x+y}
    translate -0.5*(x+y)
    scale <AspectRatio,1,1>
    translate CamZoom*z
    matrix < CamR.x,  CamR.y,  CamR.z,
             CamU.x,  CamU.y,  CamU.z,
             CamD.x,  CamD.y,  CamD.z,
             CamLoc.x,CamLoc.y,CamLoc.z >
  }
#macro IsObjectVisible(PosObject)
// this macro tests the position of the object against the pseudo screen
// note: it also returns false when the position is higher than y=10
#local Norm1 = <0, 0, 0>;
#local PosTemp= trace (Screen,PosObject,-PosObject+CamLoc,Norm1);
    #if (vlength(Norm1)!=0 & PosObject.y <10)
        true;
    #else
        false;
    #end
#end
//object{Screen pigment{rgbf<1,0,0,0.9>}}

// ------------------------------
// Greg Johnson's algorithm
// ------------------------------
// cube random position
// ------------------------------
#macro randsq(RRR)
        #local A=360*rand(RRR);
        #local D=5*(1/rand(RRR)-0.75);
        #if (D*sin(radians(A))>9) // clipped to let the POVRAY letters visible
            #local A = A+180;
        #end
        vaxis_rotate(x*D,y,A)

#end

// ------------------------------
// cube placement routine
// ------------------------------

#declare R2R=seed(1923);
#declare S = seed(14400);
#declare Norm=<0,0,0>;

#declare ntests=10;

#declare stored=array[ntests+2][ntests+2]
#declare Posy=array[num]

#declare Posy[0]=randsq(S);

// pseudo box used for collision testing
#declare Pseudo=mesh{triangle{0,x,x+z}triangle{0,z,x+z} translate -x*0.5-z*0.5+y*0.5}

// ------------------------------
// generates the first set of cubes that read POVRAY
// ------------------------------
#declare R=array[6]
#declare T=array[6]
#declare i=0;
#while (i<6) // rotations and positions are put in arrays so that they're the same in the file and in the "ally" object
    #declare R[i]=<0,-10+25*rand(R2R),0>;
    #declare T[i]=<-0.5+rand(R2R),0,rand(R2R)-0.5>;
    #declare i=i+1;
#end
#declare ally=union{
    object{Pseudo rotate R[0] translate <-4,0.5,-10>+0.35*T[0]}
    object{Pseudo rotate R[1] translate <-2.50,0.5,-10>+0.35*T[1]}
    object{Pseudo rotate x*90 rotate R[2] translate  <-1,0.5,-10>+0.35*T[2]}
    object{Pseudo rotate x*90 rotate R[3] translate < 0.50,0.5,-10>+0.35*T[3]}
    object{Pseudo rotate R[4] translate < 2,0.5,-10>+0.35*T[4]}
    object{Pseudo rotate R[5] translate  < 4,0.5,-10>+0.35*T[5]}
}



#fopen StackFile "stacks.inc" write
#write (StackFile, "union{\n")
#write (StackFile, "object{unitbox() rotate -90*y rotate ",R[0]," translate <-4,0.5,-10>+0.35*",T[0],"}\n")
#write (StackFile, "object{unitbox() rotate ",R[1]," translate <-2.5,0.5,-10>+0.35*",T[1],"}\n")
#write (StackFile, "object{unitbox() rotate 90*y rotate ",R[2]," translate <-1,0.5,-10>+0.35*",T[2],"}\n")
#write (StackFile, "object{unitbox() rotate 180*y rotate ",R[3]," translate <0.5,0.5,-10>+0.35*",T[3],"}\n")
#write (StackFile, "object{unitbox() rotate -90*x rotate ",R[4]," translate <2,0.5,-10>+0.35*",T[4],"}\n")
#write (StackFile, "object{unitbox() rotate 90*x rotate ",R[5]," translate <4,0.5,-10>+0.35*",T[5],"}\n")



// ------------------------------
// main placement loop
// runs only if WriteFile is true
// ------------------------------
#declare n=1;
#while(n<num)

        #debug concat(str(n,4,0),":")
        #declare rotey=rand(R2R)*360;

        #declare okayness=no;
        #declare counter=0 ;
        #while(counter<50)

            #declare testcenter=randsq(S);
            #declare Visible=IsObjectVisible(testcenter)
            #if (Visible)
                #declare maxy=-1000;

                #declare nx=0;
                #while(nx<ntests)
                    #declare nz=0;
                    #while (nz<ntests)

                        #declare testpoint=<-0.5,-0.5,-0.5>+<nx/ntests,0,nz/ntests>;

                        #declare tracey=trace(ally,testcenter+y*1000+vaxis_rotate(testpoint,y,rotey),-y,Norm);

                        #if (maxy<tracey.y)
                                #declare maxy=tracey.y;
                        #end

                        #declare stored[nx][nz]=tracey.y;

                        #declare nz=nz+1;
                    #end
                    #declare nx=nx+1;
                #end

                #declare nnnn=int(ntests/2);

                #if(abs(stored[nnnn][nnnn]-maxy)<0.01)
                    #declare okayness=yes;
                    #debug "[y]"
                #else

                    #debug "[n]"
                    #declare netbalancevect=<0,0,0>;

                    #declare nx=0;
                    #while(nx<ntests)
                        #declare nz=0;
                        #while (nz<ntests)

                            #if (abs(stored[nx][nz]-maxy)<0.01)
                                #declare netbalancevect=netbalancevect+<nx-nnnn,0,nz-nnnn>;

                            #end

                            #declare nz=nz+1;

                        #end
                        #declare nx=nx+1;
                    #end

                    #if (vlength(netbalancevect)<0.5)
                        #declare okayness=yes;
                    #end

                #end

                #if(okayness=yes)
                    #declare counter=counter+100;
                #end

                #declare counter=counter+1;
            #else
                #declare counter=counter+100;
                #debug "[out]"
            #end
        #end
        #if(Visible)
            #declare Posy[n]=testcenter+<0,maxy+0.5,0>;
            #declare Visible=IsObjectVisible(Posy[n])
            #if (Visible)
                #declare R[0]=<int(rand(R2R)*4)*90,0,int(rand(R2R)*4)*90>;
                #write (StackFile, "object{unitbox() rotate ",R[0]," rotate y*",rotey," translate ", Posy[n],"}\n")
                #declare ally=union{
                    object{ally}
                    object{Pseudo rotate y*rotey translate Posy[n]}
                }
            #else
                #debug "[out]"
            #end
        #end
        #debug "\n"

#declare n=n+1;
#end

#write (StackFile, "}")
#fclose StackFile


#end    



union{
object{unitbox() rotate -90*y rotate <0,2.16936,0>  translate <-4,0.5,-10>+0.35*<0.498663,0,0.305443> }
object{unitbox() rotate <0,12.9675,0>  translate <-2.5,0.5,-10>+0.35*<-0.0397514,0,-0.0164205> }
object{unitbox() rotate 90*y rotate <0,14.6869,0>  translate <-1,0.5,-10>+0.35*<0.0617607,0,-0.462948> }
object{unitbox() rotate 180*y rotate <0,4.43588,0>  translate <0.5,0.5,-10>+0.35*<-0.249256,0,0.38154> }
object{unitbox() rotate -90*x rotate <0,-7.07376,0>  translate <2,0.5,-10>+0.35*<0.0858621,0,-0.444883> }
object{unitbox() rotate 90*x rotate <0,7.20588,0>  translate <4,0.5,-10>+0.35*<-0.425282,0,-0.365786> }
object{unitbox() rotate <0,0,180>  rotate y*59.4019 translate <-1.7975,0.5,0.501206> }
object{unitbox() rotate <0,0,90>  rotate y*317.557 translate <1.85863,0.5,1.13745> }
object{unitbox() rotate <180,0,270>  rotate y*356.668 translate <-2.38072,0.5,3.10355> }
object{unitbox() rotate <90,0,270>  rotate y*249.352 translate <-6.55942,0.5,1.52928> }
object{unitbox() rotate <0,0,180>  rotate y*167.726 translate <6.20887,0.5,-1.12826> }
object{unitbox() rotate <270,0,180>  rotate y*27.0216 translate <13.146,0.5,24.963> }
object{unitbox() rotate <180,0,180>  rotate y*126.019 translate <-0.435362,0.5,1.25805> }
object{unitbox() rotate <270,0,0>  rotate y*137.299 translate <10.861,0.5,18.4054> }
object{unitbox() rotate <180,0,90>  rotate y*150.921 translate <0.373544,0.5,4.39588> }
object{unitbox() rotate <270,0,0>  rotate y*194.635 translate <4.38974,0.5,1.34125> }
object{unitbox() rotate <0,0,270>  rotate y*246.606 translate <-13.8283,0.5,2.0766> }
object{unitbox() rotate <0,0,90>  rotate y*320.135 translate <-4.12151,0.5,5.49531> }
object{unitbox() rotate <270,0,270>  rotate y*249.017 translate <-0.524719,0.5,-1.90412> }
object{unitbox() rotate <270,0,180>  rotate y*97.3903 translate <15.9352,0.5,12.8873> }
object{unitbox() rotate <180,0,90>  rotate y*202.632 translate <-0.370583,1.5,-1.57746> }
object{unitbox() rotate <0,0,270>  rotate y*231.013 translate <8.15139,0.5,-1.42905> }
object{unitbox() rotate <90,0,180>  rotate y*197.658 translate <-8.79873,0.5,38.9939> }
object{unitbox() rotate <270,0,0>  rotate y*119.783 translate <-14.5888,0.5,23.7798> }
object{unitbox() rotate <0,0,90>  rotate y*296.559 translate <0.215388,0.5,-4.04273> }
object{unitbox() rotate <180,0,270>  rotate y*359.863 translate <0.747795,0.5,1.19436> }
object{unitbox() rotate <270,0,180>  rotate y*358.644 translate <6.85141,0.5,25.8912> }
object{unitbox() rotate <270,0,0>  rotate y*11.1073 translate <-0.794179,0.5,4.51349> }
object{unitbox() rotate <270,0,0>  rotate y*75.3571 translate <-8.86178,0.5,-0.777232> }
object{unitbox() rotate <270,0,0>  rotate y*144.938 translate <-0.82293,0.5,-5.61959> }
object{unitbox() rotate <0,0,270>  rotate y*355.126 translate <-10.2238,0.5,5.44334> }
object{unitbox() rotate <0,0,180>  rotate y*174.182 translate <4.96448,0.5,-3.22208> }
object{unitbox() rotate <180,0,270>  rotate y*109.688 translate <1.26656,0.5,-1.31574> }
object{unitbox() rotate <90,0,90>  rotate y*84.9207 translate <10.0465,0.5,19.9986> }
object{unitbox() rotate <0,0,180>  rotate y*294.416 translate <-1.70917,0.5,-0.930977> }
object{unitbox() rotate <0,0,90>  rotate y*191.844 translate <4.49874,1.5,1.3924> }
object{unitbox() rotate <180,0,270>  rotate y*137.148 translate <-9.91813,0.5,12.6704> }
object{unitbox() rotate <0,0,180>  rotate y*104.172 translate <16.9827,0.5,6.4178> }
object{unitbox() rotate <90,0,180>  rotate y*7.66698 translate <-5.44028,0.5,2.10656> }
object{unitbox() rotate <180,0,270>  rotate y*65.4391 translate <-1.98683,0.5,-5.08983> }
object{unitbox() rotate <270,0,0>  rotate y*71.7765 translate <0.868632,1.5,0.98221> }
object{unitbox() rotate <0,0,90>  rotate y*74.443 translate <0.605519,0.5,9.88032> }
object{unitbox() rotate <90,0,0>  rotate y*300.969 translate <35.9656,0.5,58.0507> }
object{unitbox() rotate <180,0,180>  rotate y*204.133 translate <9.2581,0.5,29.775> }
object{unitbox() rotate <180,0,0>  rotate y*87.5576 translate <1.2154,1.5,-1.55119> }
object{unitbox() rotate <90,0,180>  rotate y*249.164 translate <19.5569,0.5,9.97825> }
object{unitbox() rotate <90,0,270>  rotate y*62.4682 translate <-20.2665,0.5,30.3332> }
object{unitbox() rotate <90,0,0>  rotate y*183.59 translate <-4.28824,0.5,27.1292> }
object{unitbox() rotate <180,0,0>  rotate y*258.272 translate <4.03026,0.5,-2.18578> }
object{unitbox() rotate <0,0,270>  rotate y*56.8962 translate <6.01684,0.5,15.727> }
object{unitbox() rotate <180,0,270>  rotate y*340.771 translate <40.1583,0.5,40.3819> }
object{unitbox() rotate <270,0,180>  rotate y*89.9586 translate <292.394,0.5,720.19> }
object{unitbox() rotate <90,0,0>  rotate y*9.24733 translate <4.74127,0.5,9.29309> }
object{unitbox() rotate <0,0,270>  rotate y*107.527 translate <1.20853,0.5,-4.91139> }
object{unitbox() rotate <270,0,270>  rotate y*249.855 translate <-2.25422,0.5,35.8768> }
object{unitbox() rotate <270,0,0>  rotate y*216.784 translate <2.69235,0.5,-0.384308> }
object{unitbox() rotate <0,0,90>  rotate y*16.8541 translate <-1.28063,1.5,0.404247> }
object{unitbox() rotate <90,0,270>  rotate y*195.801 translate <-28.6049,0.5,60.6956> }
object{unitbox() rotate <0,0,270>  rotate y*60.9178 translate <-0.348248,1.5,1.65987> }
object{unitbox() rotate <180,0,90>  rotate y*156.503 translate <-1.37164,2.5,0.168345> }
object{unitbox() rotate <0,0,180>  rotate y*322.364 translate <1.11032,0.5,17.9805> }
object{unitbox() rotate <90,0,90>  rotate y*326.636 translate <7.27323,0.5,0.426231> }
object{unitbox() rotate <90,0,0>  rotate y*300.222 translate <-6.74021,0.5,-2.42571> }
object{unitbox() rotate <0,0,270>  rotate y*294.903 translate <-30.9601,0.5,156.056> }
object{unitbox() rotate <180,0,90>  rotate y*204.888 translate <-3.03242,0.5,0.929319> }
object{unitbox() rotate <90,0,270>  rotate y*259.892 translate <7.575,0.5,9.64743> }
object{unitbox() rotate <0,0,0>  rotate y*156.601 translate <2.33109,0.5,2.80805> }
object{unitbox() rotate <180,0,180>  rotate y*8.18049 translate <5.54387,0.5,3.4845> }
object{unitbox() rotate <90,0,90>  rotate y*90.3104 translate <1.17483,0.5,2.75916> }
object{unitbox() rotate <90,0,0>  rotate y*227.986 translate <-2.36779,0.5,-2.89101> }
object{unitbox() rotate <270,0,270>  rotate y*186.231 translate <13.9582,0.5,109.167> }
object{unitbox() rotate <90,0,0>  rotate y*172.067 translate <1.06424,0.5,7.4713> }
object{unitbox() rotate <0,0,270>  rotate y*234.283 translate <-9.27958,0.5,4.25945> }
object{unitbox() rotate <0,0,90>  rotate y*20.5317 translate <9.47142,0.5,-0.730245> }
object{unitbox() rotate <180,0,180>  rotate y*41.6539 translate <4.69526,1.5,9.2461> }
object{unitbox() rotate <270,0,180>  rotate y*246.881 translate <-1.5735,0.5,21.462> }
object{unitbox() rotate <0,0,0>  rotate y*295.803 translate <7.7574,0.5,7.24534> }
object{unitbox() rotate <0,0,90>  rotate y*216.516 translate <-9.01206,0.5,15.1413> }
object{unitbox() rotate <0,0,0>  rotate y*196.961 translate <11.7866,0.5,14.3296> }
object{unitbox() rotate <270,0,270>  rotate y*102.236 translate <-2.24611,0.5,6.521> }
object{unitbox() rotate <90,0,0>  rotate y*352.895 translate <-4.22004,0.5,0.303669> }
object{unitbox() rotate <270,0,180>  rotate y*333.462 translate <-0.335984,2.5,-1.27055> }
object{unitbox() rotate <90,0,0>  rotate y*281.406 translate <-3.49031,0.5,-4.34965> }
object{unitbox() rotate <0,0,0>  rotate y*318.593 translate <-0.224248,3.5,-1.63493> }
object{unitbox() rotate <90,0,0>  rotate y*40.7481 translate <-27.7247,0.5,85.3619> }
object{unitbox() rotate <270,0,0>  rotate y*342.407 translate <8.05515,0.5,5.75783> }
object{unitbox() rotate <0,0,0>  rotate y*16.5101 translate <0.0180265,4.5,-1.94427> }
object{unitbox() rotate <0,0,0>  rotate y*155.017 translate <-1.77757,0.5,9.16922> }
object{unitbox() rotate <90,0,90>  rotate y*126.716 translate <1.07258,2.5,0.978808> }
object{unitbox() rotate <270,0,180>  rotate y*102.53 translate <0.964732,1.5,-4.84322> }
object{unitbox() rotate <180,0,90>  rotate y*166.747 translate <-19.0985,0.5,10.3324> }
object{unitbox() rotate <90,0,180>  rotate y*93.4903 translate <-3.59148,0.5,-8.4065> }
object{unitbox() rotate <270,0,90>  rotate y*182.467 translate <0.0562264,5.5,-1.45531> }
object{unitbox() rotate <90,0,270>  rotate y*240.383 translate <-1.23477,1.5,9.14998> }
object{unitbox() rotate <0,0,0>  rotate y*123.394 translate <2.00724,0.5,-3.64264> }
object{unitbox() rotate <180,0,90>  rotate y*308.728 translate <1.40172,1.5,2.61306> }
object{unitbox() rotate <180,0,90>  rotate y*18.9398 translate <2.39666,1.5,-0.0919108> }
object{unitbox() rotate <180,0,180>  rotate y*77.5059 translate <8.68202,0.5,9.62416> }
object{unitbox() rotate <270,0,90>  rotate y*28.8897 translate <-0.833374,0.5,-3.63379> }
object{unitbox() rotate <0,0,0>  rotate y*154.518 translate <-5.58335,0.5,3.88039> }
object{unitbox() rotate <0,0,90>  rotate y*336.212 translate <-8.51316,0.5,-5.05228> }
object{unitbox() rotate <0,0,90>  rotate y*260.872 translate <1.69149,2.5,2.28445> }
object{unitbox() rotate <0,0,180>  rotate y*134.084 translate <0.862814,3.5,1.09047> }
object{unitbox() rotate <270,0,270>  rotate y*171.892 translate <6.03543,0.5,11.1052> }
object{unitbox() rotate <270,0,270>  rotate y*118.425 translate <0.960995,4.5,0.960187> }
object{unitbox() rotate <270,0,270>  rotate y*277.285 translate <-1.4001,3.5,-0.327084> }
object{unitbox() rotate <270,0,270>  rotate y*6.99458 translate <-0.127162,6.5,-1.59552> }
object{unitbox() rotate <180,0,0>  rotate y*130.724 translate <-1237.15,0.5,1949.4> }
object{unitbox() rotate <180,0,0>  rotate y*25.3366 translate <-13.3543,0.5,6.62508> }
object{unitbox() rotate <0,0,90>  rotate y*344.252 translate <-9.79909,0.5,6.68711> }
object{unitbox() rotate <90,0,90>  rotate y*290.408 translate <1.51771,2.5,-1.97202> }
object{unitbox() rotate <90,0,0>  rotate y*48.8692 translate <-1.02592,1.5,-5.17853> }
object{unitbox() rotate <270,0,90>  rotate y*251.051 translate <-22.4859,0.5,12.5007> }
object{unitbox() rotate <180,0,0>  rotate y*218.968 translate <-12.4792,0.5,-2.72215> }
object{unitbox() rotate <0,0,270>  rotate y*351.869 translate <0.591977,0.5,31.3103> }
object{unitbox() rotate <0,0,0>  rotate y*107.379 translate <3.51479,0.5,-3.84875> }
object{unitbox() rotate <270,0,270>  rotate y*165.984 translate <3.01255,0.5,4.84018> }
object{unitbox() rotate <90,0,270>  rotate y*228.201 translate <-3.50666,0.5,3.75258> }
object{unitbox() rotate <180,0,90>  rotate y*171.855 translate <-20.5999,0.5,49.9105> }
object{unitbox() rotate <90,0,0>  rotate y*174.876 translate <4.3447,0.5,3.73545> }
object{unitbox() rotate <180,0,0>  rotate y*94.2477 translate <-1.75371,4.5,-0.283184> }
object{unitbox() rotate <0,0,90>  rotate y*71.0048 translate <7.97524,0.5,-3.20109> }
object{unitbox() rotate <270,0,270>  rotate y*181.443 translate <-8.62334,0.5,32.9226> }
object{unitbox() rotate <0,0,270>  rotate y*155.266 translate <4.62609,0.5,5.25244> }
object{unitbox() rotate <180,0,90>  rotate y*111.902 translate <6.90588,0.5,7.81297> }
object{unitbox() rotate <90,0,180>  rotate y*246.295 translate <-2.2438,0.5,5.18529> }
object{unitbox() rotate <0,0,90>  rotate y*201.24 translate <0.273264,7.5,-2.11002> }
object{unitbox() rotate <270,0,0>  rotate y*126.16 translate <-0.368343,0.5,11.407> }
object{unitbox() rotate <270,0,270>  rotate y*321.767 translate <21.7813,0.5,24.4684> }
object{unitbox() rotate <180,0,0>  rotate y*236.375 translate <-7.42695,0.5,3.74673> }
object{unitbox() rotate <90,0,270>  rotate y*188.752 translate <-1.28474,0.5,-6.78247> }
object{unitbox() rotate <270,0,270>  rotate y*356.288 translate <-12.7327,0.5,15.1807> }
object{unitbox() rotate <180,0,270>  rotate y*160.976 translate <-0.80351,0.5,14.956> }
object{unitbox() rotate <90,0,270>  rotate y*215.059 translate <1.78543,0.5,4.14127> }
object{unitbox() rotate <180,0,180>  rotate y*14.3167 translate <11.2994,0.5,12.579> }
object{unitbox() rotate <180,0,180>  rotate y*313.579 translate <10.1013,0.5,22.6372> }
object{unitbox() rotate <0,0,270>  rotate y*326.431 translate <1.97261,2.5,-0.134645> }
object{unitbox() rotate <0,0,90>  rotate y*46.1255 translate <-6.95886,1.5,-2.84861> }
object{unitbox() rotate <90,0,0>  rotate y*56.3635 translate <30.0249,0.5,81.5167> }
object{unitbox() rotate <270,0,0>  rotate y*255.362 translate <-3.1373,0.5,30.7053> }
object{unitbox() rotate <90,0,270>  rotate y*87.8276 translate <10.2386,0.5,2.74778> }
object{unitbox() rotate <270,0,180>  rotate y*232.69 translate <-4.10314,0.5,-5.43726> }
object{unitbox() rotate <270,0,0>  rotate y*313.361 translate <-5.57777,0.5,0.624729> }
object{unitbox() rotate <270,0,90>  rotate y*100.881 translate <-9.82419,0.5,-4.63837> }
object{unitbox() rotate <180,0,180>  rotate y*256.332 translate <-3.75508,1.5,3.90715> }
object{unitbox() rotate <270,0,180>  rotate y*337.884 translate <5.17173,0.5,-6.38884> }
object{unitbox() rotate <90,0,180>  rotate y*327.164 translate <2.7714,0.5,7.65073> }
object{unitbox() rotate <270,0,0>  rotate y*241.373 translate <-16.0271,0.5,38.1607> }
object{unitbox() rotate <180,0,90>  rotate y*342.275 translate <-2.26359,1.5,-2.81474> }
object{unitbox() rotate <90,0,180>  rotate y*22.4721 translate <3.69466,0.5,16.3329> }
object{unitbox() rotate <0,0,180>  rotate y*241.634 translate <4.69109,1.5,3.32863> }
object{unitbox() rotate <0,0,0>  rotate y*235.126 translate <-1.95993,5.5,-0.261735> }
object{unitbox() rotate <0,0,90>  rotate y*191.152 translate <-6.93351,0.5,-4.20652> }
object{unitbox() rotate <270,0,180>  rotate y*155.011 translate <11.7073,0.5,0.326266> }
object{unitbox() rotate <180,0,90>  rotate y*50.0561 translate <9.24588,1.5,-0.401653> }
object{unitbox() rotate <270,0,270>  rotate y*43.3034 translate <-5.3857,0.5,-1.43289> }
object{unitbox() rotate <0,0,180>  rotate y*266.674 translate <-15.7203,0.5,14.4261> }
object{unitbox() rotate <90,0,180>  rotate y*19.1707 translate <0.599197,5.5,1.20186> }
object{unitbox() rotate <270,0,180>  rotate y*29.5496 translate <2.42903,0.5,-4.99037> }
object{unitbox() rotate <0,0,270>  rotate y*156.924 translate <-3.13586,0.5,8.63449> }
object{unitbox() rotate <180,0,270>  rotate y*117.305 translate <62.1026,0.5,169.717> }
object{unitbox() rotate <180,0,90>  rotate y*25.1487 translate <1.56774,3.5,-2.08278> }
object{unitbox() rotate <180,0,0>  rotate y*93.0571 translate <-12.2358,0.5,3.05674> }
object{unitbox() rotate <180,0,270>  rotate y*314.135 translate <6.96128,0.5,3.08993> }
object{unitbox() rotate <270,0,90>  rotate y*96.5019 translate <-5.46174,1.5,0.199535> }
object{unitbox() rotate <0,0,90>  rotate y*90.5614 translate <27.5108,0.5,40.1335> }
object{unitbox() rotate <0,0,270>  rotate y*222.355 translate <1.88695,3.5,-0.440273> }
object{unitbox() rotate <90,0,270>  rotate y*307.157 translate <-2.92616,0.5,39.7904> }
object{unitbox() rotate <270,0,270>  rotate y*345.11 translate <-4.14522,0.5,-1.27146> }
object{unitbox() rotate <90,0,180>  rotate y*55.9413 translate <-1.64022,6.5,-0.353508> }
object{unitbox() rotate <270,0,0>  rotate y*130.849 translate <0.0978536,1.5,-4.16582> }
object{unitbox() rotate <90,0,180>  rotate y*274.214 translate <-17.5255,0.5,5.42688> }
object{unitbox() rotate <270,0,270>  rotate y*210.802 translate <6.05508,0.5,-4.52361> }
object{unitbox() rotate <90,0,180>  rotate y*321.89 translate <-63.4562,0.5,107.873> }
object{unitbox() rotate <90,0,180>  rotate y*102.708 translate <-40.6833,0.5,73.6806> }
object{unitbox() rotate <90,0,0>  rotate y*283.054 translate <12.1113,0.5,-1.79498> }
object{unitbox() rotate <90,0,180>  rotate y*280.682 translate <0.408623,6.5,1.77314> }
object{unitbox() rotate <0,0,0>  rotate y*356.556 translate <-1.87671,7.5,-0.880925> }
object{unitbox() rotate <0,0,90>  rotate y*262.392 translate <-17.9959,0.5,20.4082> }
object{unitbox() rotate <90,0,90>  rotate y*79.4726 translate <12.0925,0.5,10.734> }
object{unitbox() rotate <270,0,90>  rotate y*242.185 translate <-2.14062,8.5,-1.06502> }
object{unitbox() rotate <0,0,270>  rotate y*334.139 translate <1.76538,4.5,-0.148578> }
object{unitbox() rotate <270,0,90>  rotate y*142.92 translate <7.41957,0.5,11.0751> }
object{unitbox() rotate <90,0,180>  rotate y*262.032 translate <3.75341,0.5,-0.0108443> }
object{unitbox() rotate <270,0,0>  rotate y*106.637 translate <0.843871,0.5,12.2073> }
object{unitbox() rotate <270,0,90>  rotate y*16.0956 translate <-6.29588,0.5,12.2161> }
object{unitbox() rotate <270,0,180>  rotate y*328.802 translate <2.61143,1.5,-4.64474> }
object{unitbox() rotate <180,0,0>  rotate y*197.083 translate <2.35706,0.5,-6.23256> }
object{unitbox() rotate <270,0,270>  rotate y*116.652 translate <2.66644,0.5,-2.78769> }
object{unitbox() rotate <270,0,0>  rotate y*177.804 translate <-3.45191,0.5,-7.36375> }
object{unitbox() rotate <90,0,270>  rotate y*19.5697 translate <-9.88215,0.5,42.2624> }
object{unitbox() rotate <270,0,270>  rotate y*59.5224 translate <-0.672581,1.5,4.98759> }
object{unitbox() rotate <270,0,90>  rotate y*258.441 translate <14.3772,0.5,2.94272> }
object{unitbox() rotate <180,0,0>  rotate y*272.945 translate <4.55663,0.5,-5.14236> }
object{unitbox() rotate <0,0,0>  rotate y*149.988 translate <42.1847,0.5,64.617> }
object{unitbox() rotate <0,0,0>  rotate y*187.568 translate <3.35773,1.5,-0.302406> }
object{unitbox() rotate <270,0,0>  rotate y*256.196 translate <0.215367,8.5,-2.13057> }
object{unitbox() rotate <0,0,0>  rotate y*79.4628 translate <3.81088,0.5,19.0667> }
object{unitbox() rotate <180,0,270>  rotate y*47.4184 translate <1.82994,0.5,-7.26035> }
object{unitbox() rotate <90,0,270>  rotate y*30.7929 translate <0.673066,9.5,-2.06784> }
object{unitbox() rotate <270,0,0>  rotate y*261.659 translate <90.8038,0.5,229.642> }
object{unitbox() rotate <180,0,180>  rotate y*239.349 translate <-18.2648,0.5,13.2691> }
object{unitbox() rotate <270,0,90>  rotate y*103.126 translate <-40.4933,0.5,55.0273> }
object{unitbox() rotate <0,0,0>  rotate y*177.954 translate <10.2525,0.5,8.31959> }
object{unitbox() rotate <180,0,270>  rotate y*263.669 translate <-2.83149,1.5,2.97014> }
object{unitbox() rotate <180,0,0>  rotate y*23.351 translate <-3.10549,0.5,-1.95829> }
object{unitbox() rotate <0,0,90>  rotate y*192.238 translate <16.3314,0.5,16.9902> }
object{unitbox() rotate <90,0,270>  rotate y*278.232 translate <0.00992513,7.5,2.09914> }
object{unitbox() rotate <0,0,180>  rotate y*164.698 translate <5.84255,0.5,5.86071> }
object{unitbox() rotate <180,0,180>  rotate y*45.9651 translate <8.46398,0.5,1.63473> }
object{unitbox() rotate <0,0,0>  rotate y*153.998 translate <-7.82231,0.5,5.03124> }
object{unitbox() rotate <270,0,90>  rotate y*163.806 translate <5.67822,1.5,-4.28978> }
object{unitbox() rotate <180,0,0>  rotate y*137.729 translate <13.1813,0.5,3.49279> }
object{unitbox() rotate <270,0,270>  rotate y*290.651 translate <-6.8184,0.5,10.2297> }
object{unitbox() rotate <180,0,180>  rotate y*105.343 translate <7.53495,0.5,46.305> }
object{unitbox() rotate <270,0,270>  rotate y*317.753 translate <14.5513,0.5,16.3535> }
object{unitbox() rotate <270,0,180>  rotate y*22.8801 translate <5.25268,1.5,-6.50054> }
object{unitbox() rotate <270,0,0>  rotate y*341.389 translate <17.535,0.5,12.7296> }
object{unitbox() rotate <0,0,180>  rotate y*0.526245 translate <-2.44409,0.5,18.62> }
object{unitbox() rotate <270,0,90>  rotate y*232.977 translate <7.27866,0.5,29.5935> }
object{unitbox() rotate <270,0,0>  rotate y*12.8888 translate <5.93099,0.5,114.705> }
object{unitbox() rotate <90,0,90>  rotate y*73.8054 translate <6.25518,1.5,-1.35455> }
object{unitbox() rotate <270,0,180>  rotate y*24.3382 translate <20.0265,0.5,27.842> }
object{unitbox() rotate <90,0,90>  rotate y*335.765 translate <-2.94351,2.5,2.48059> }
object{unitbox() rotate <270,0,0>  rotate y*270.338 translate <1.00583,0.5,15.7539> }
object{unitbox() rotate <180,0,270>  rotate y*339.645 translate <5.73904,0.5,194.506> }
object{unitbox() rotate <270,0,0>  rotate y*303.677 translate <6.29067,0.5,-2.45716> }
object{unitbox() rotate <0,0,90>  rotate y*265.851 translate <-24.1797,0.5,27.6548> }
object{unitbox() rotate <0,0,0>  rotate y*335.094 translate <-90.9126,0.5,211.052> }
object{unitbox() rotate <0,0,270>  rotate y*354.771 translate <61.2997,0.5,103.86> }
object{unitbox() rotate <270,0,0>  rotate y*249.84 translate <-5.88783,0.5,14.567> }
object{unitbox() rotate <180,0,90>  rotate y*116.047 translate <0.315177,0.5,5.98052> }
object{unitbox() rotate <90,0,270>  rotate y*23.3981 translate <3.21679,0.5,1.82056> }
object{unitbox() rotate <180,0,180>  rotate y*171.924 translate <17.6339,0.5,22.5379> }
object{unitbox() rotate <270,0,270>  rotate y*138.151 translate <4.45326,1.5,5.20162> }
object{unitbox() rotate <0,0,180>  rotate y*141.939 translate <-31.7325,0.5,32.7855> }
object{unitbox() rotate <270,0,0>  rotate y*183.441 translate <-1.56994,0.5,1.64393> }
object{unitbox() rotate <180,0,270>  rotate y*164.563 translate <-2.03313,0.5,24.3658> }
object{unitbox() rotate <270,0,270>  rotate y*234.159 translate <-6.51745,1.5,-4.26195> }
object{unitbox() rotate <180,0,0>  rotate y*268.502 translate <-16.6463,0.5,19.4633> }
object{unitbox() rotate <180,0,180>  rotate y*351.423 translate <-11.1627,0.5,17.549> }
object{unitbox() rotate <270,0,0>  rotate y*96.1868 translate <0.0782479,1.5,10.2123> }
object{unitbox() rotate <0,0,270>  rotate y*251.224 translate <-6.4928,0.5,8.49094> }
object{unitbox() rotate <90,0,180>  rotate y*174.627 translate <5.30951,2.5,-4.58369> }
object{unitbox() rotate <0,0,0>  rotate y*324.098 translate <9.37207,0.5,57.0495> }
object{unitbox() rotate <180,0,270>  rotate y*141.286 translate <21.7387,0.5,16.5165> }
object{unitbox() rotate <180,0,0>  rotate y*240.408 translate <0.278769,8.5,1.637> }
object{unitbox() rotate <270,0,0>  rotate y*99.3215 translate <-13.7783,0.5,11.1427> }
object{unitbox() rotate <270,0,270>  rotate y*334.555 translate <-8.61481,0.5,13.083> }
object{unitbox() rotate <0,0,0>  rotate y*318.011 translate <-7.68688,0.5,0.880124> }
object{unitbox() rotate <90,0,0>  rotate y*95.2524 translate <-3.4047,1.5,-8.46629> }
object{unitbox() rotate <180,0,180>  rotate y*87.2902 translate <-0.903009,0.5,3.2671> }
object{unitbox() rotate <270,0,180>  rotate y*181.834 translate <-2.21205,2.5,-2.64787> }
object{unitbox() rotate <90,0,180>  rotate y*129.269 translate <-2.98477,3.5,2.80079> }
object{unitbox() rotate <270,0,270>  rotate y*311.415 translate <13.991,0.5,17.2746> }
object{unitbox() rotate <270,0,0>  rotate y*271.596 translate <-11.5115,0.5,12.6091> }
object{unitbox() rotate <90,0,180>  rotate y*339.376 translate <-2.46159,4.5,3.01844> }
object{unitbox() rotate <270,0,0>  rotate y*46.0612 translate <5.11689,0.5,-0.617044> }
object{unitbox() rotate <180,0,180>  rotate y*149.886 translate <3.29974,2.5,0.0666807> }
object{unitbox() rotate <270,0,90>  rotate y*117.3 translate <0.72525,9.5,1.79428> }
object{unitbox() rotate <180,0,180>  rotate y*83.5914 translate <-1.88324,9.5,-0.629167> }
object{unitbox() rotate <180,0,0>  rotate y*212.528 translate <-12.7911,0.5,42.6679> }
object{unitbox() rotate <180,0,90>  rotate y*245.722 translate <13.27,0.5,19.6607> }
object{unitbox() rotate <270,0,180>  rotate y*67.9034 translate <9.88076,0.5,-6.53584> }
object{unitbox() rotate <90,0,90>  rotate y*284.95 translate <0.647432,1.5,15.5675> }
object{unitbox() rotate <270,0,90>  rotate y*13.1745 translate <-6.72173,0.5,-6.31653> }
object{unitbox() rotate <270,0,90>  rotate y*229.345 translate <0.461576,2.5,10.1936> }
object{unitbox() rotate <270,0,180>  rotate y*122.445 translate <0.55618,3.5,10.181> }
object{unitbox() rotate <270,0,0>  rotate y*89.0618 translate <1.99748,0.5,13.7101> }
object{unitbox() rotate <0,0,0>  rotate y*332.642 translate <-2.50251,0.5,103.717> }
object{unitbox() rotate <90,0,0>  rotate y*113.849 translate <0.596083,2.5,-4.11751> }
object{unitbox() rotate <270,0,0>  rotate y*252.475 translate <-5.56128,1.5,2.53616> }
object{unitbox() rotate <90,0,90>  rotate y*44.0525 translate <1.98608,0.5,-8.8859> }
object{unitbox() rotate <90,0,180>  rotate y*199.877 translate <1.87357,5.5,-0.161911> }
object{unitbox() rotate <180,0,270>  rotate y*93.5687 translate <1.00671,1.5,4.23987> }
object{unitbox() rotate <0,0,180>  rotate y*98.4262 translate <-0.943277,1.5,3.46469> }
object{unitbox() rotate <180,0,180>  rotate y*206.98 translate <7.84365,0.5,-8.94064> }
object{unitbox() rotate <180,0,90>  rotate y*119.777 translate <-0.890287,1.5,-7.27275> }
object{unitbox() rotate <90,0,90>  rotate y*76.2177 translate <1.04415,0.5,-8.12383> }
object{unitbox() rotate <180,0,90>  rotate y*245.468 translate <2.48951,1.5,1.07994> }
object{unitbox() rotate <270,0,180>  rotate y*88.55 translate <-2.1476,5.5,2.74753> }
object{unitbox() rotate <0,0,90>  rotate y*304.895 translate <5.54329,0.5,13.9932> }
object{unitbox() rotate <0,0,270>  rotate y*264.367 translate <5.02712,3.5,-4.29653> }
object{unitbox() rotate <0,0,180>  rotate y*44.4677 translate <-3.25693,1.5,0.75606> }
object{unitbox() rotate <180,0,0>  rotate y*276.032 translate <-4.74793,0.5,15.8626> }
object{unitbox() rotate <90,0,180>  rotate y*353.8 translate <-12.0946,0.5,-0.536307> }
object{unitbox() rotate <0,0,270>  rotate y*280.669 translate <-1.32625,2.5,3.93275> }
object{unitbox() rotate <180,0,0>  rotate y*116.024 translate <1.60438,1.5,-7.09215> }
object{unitbox() rotate <0,0,90>  rotate y*211.574 translate <-2.43532,0.5,10.6571> }
object{unitbox() rotate <0,0,270>  rotate y*73.0497 translate <0.788694,2.5,4.31601> }
object{unitbox() rotate <180,0,180>  rotate y*196.251 translate <-12.7449,0.5,29.4167> }
object{unitbox() rotate <90,0,270>  rotate y*287.307 translate <-3.21245,1.5,-1.70956> }
object{unitbox() rotate <180,0,180>  rotate y*83.7367 translate <-3.33882,2.5,0.557081> }
object{unitbox() rotate <0,0,270>  rotate y*189.451 translate <7.36824,1.5,7.68382> }
object{unitbox() rotate <90,0,180>  rotate y*172.714 translate <-11.1215,0.5,-0.465867> }
object{unitbox() rotate <180,0,90>  rotate y*245.898 translate <-3.95137,0.5,12.498> }
object{unitbox() rotate <0,0,0>  rotate y*195.98 translate <1.7004,3.5,2.48787> }
object{unitbox() rotate <90,0,270>  rotate y*162.624 translate <4.68349,4.5,-4.47579> }
object{unitbox() rotate <90,0,0>  rotate y*281.787 translate <-11.2206,0.5,-3.08951> }
object{unitbox() rotate <180,0,90>  rotate y*337.928 translate <-55.4383,0.5,211.722> }
object{unitbox() rotate <90,0,90>  rotate y*11.4465 translate <-12.0402,0.5,66.2247> }
object{unitbox() rotate <0,0,90>  rotate y*201.158 translate <0.00613388,0.5,8.52706> }
object{unitbox() rotate <0,0,90>  rotate y*291.994 translate <17.6902,0.5,24.8213> }
object{unitbox() rotate <270,0,0>  rotate y*120.821 translate <-1045.05,0.5,2915.77> }
object{unitbox() rotate <180,0,270>  rotate y*247.891 translate <7.97402,0.5,17.0193> }
object{unitbox() rotate <90,0,270>  rotate y*356.426 translate <-6.71579,1.5,12.0595> }
object{unitbox() rotate <90,0,180>  rotate y*197.111 translate <-25.1897,0.5,16.96> }
object{unitbox() rotate <180,0,90>  rotate y*152.452 translate <31.2318,0.5,25.8022> }
object{unitbox() rotate <0,0,180>  rotate y*267.923 translate <-5.22768,0.5,-7.95861> }
object{unitbox() rotate <0,0,270>  rotate y*299.756 translate <6.43933,1.5,11.1745> }
object{unitbox() rotate <270,0,0>  rotate y*222.417 translate <12.53,0.5,-3.05808> }
object{unitbox() rotate <0,0,0>  rotate y*66.7347 translate <-6.20704,1.5,8.91191> }
object{unitbox() rotate <0,0,0>  rotate y*18.2187 translate <-26.0804,0.5,31.3607> }
object{unitbox() rotate <270,0,0>  rotate y*205.909 translate <1.66305,4.5,-2.54914> }
object{unitbox() rotate <270,0,270>  rotate y*326.566 translate <-8.9462,0.5,-3.44876> }
object{unitbox() rotate <0,0,270>  rotate y*302.614 translate <4.27933,0.5,12.4232> }
object{unitbox() rotate <90,0,90>  rotate y*337.825 translate <-28.0338,0.5,24.6339> }
object{unitbox() rotate <180,0,90>  rotate y*117.406 translate <-5.92373,1.5,-1.56056> }
object{unitbox() rotate <0,0,0>  rotate y*178.803 translate <13.4702,0.5,5.15733> }
}

</textarea>


<!-- Sample file : abyss.pov -->

<textarea id="abyss.pov" name="abyss.pov" style="display:none;">
// This work is licensed under the Creative Commons Attribution-ShareAlike 3.0 Unported License.
// To view a copy of this license, visit http://creativecommons.org/licenses/by-sa/3.0/ or send a
// letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.

// Persistence Of Vision raytracer sample file.
//============================================
// The field, new improved version  October. 2001
// Copyright Gilles Tran 2001 
// http://www.oyonale.com
//--------------------------------------------
// Render with a 2.67 ratio such as 320*120, 640*240, 1024*384, 1280*480
//--------------------------------------------
// -w320 -h120
// -w640 -h240 +a0.1
// -w768 -h288 +a0.1
// -w1024 -h384 +a0.1

// Uncomment AreaOK=true below to turn on the area light
// This will blur the shadow under the submarine
// but the rendering time will extremely slow

#version 3.6;

global_settings{ assumed_gamma 1.0 max_trace_level 15 }

#declare AreaOK=false;
//#declare AreaOK=true;

#include "colors.inc"
#include "functions.inc"
//============================================
// General
//============================================
//--------------------------------------------
// Camera
//--------------------------------------------
#declare PdV=<-20, -20, -400>;
camera{
        location PdV
        angle 65 //   direction z*2
        up y
        right x*image_width/image_height // keep propotions with any aspect ratio  //right 8*x/3
        look_at <-20, 30, 0>
}

//--------------------------------------------
// reorientation macro
//--------------------------------------------
#macro mOrient(P1,P2)
#local yV1=vnormalize(P2-P1);
#local xV1=vnormalize(vcross(yV1,z));
#local zV1=vcross(xV1,yV1);
                matrix <xV1.x,xV1.y,xV1.z,yV1.x,yV1.y,yV1.z,zV1.x,zV1.y,zV1.z,P1.x,P1.y,P1.z>
#end

//--------------------------------------------
// colors
//--------------------------------------------
#declare colWater1=rgb<0,79,159>/255;
#declare colWater2=rgb<7,146,217>/255;
#declare colWater3=rgb<82,239,238>/255;
#declare colSub=<7/255,146/255,217/255>;

//--------------------------------------------
// lights
//--------------------------------------------
light_source {<-10, 1000, -10> color colWater2*10
#if (AreaOK)
    area_light x*200,z*200, 3,3 adaptive 1 jitter orient
#end

}
light_source {<-200, -1000, -300> color colWater2*2 shadowless media_interaction off}
light_source {PdV color colWater2*2 shadowless media_interaction off}

//--------------------------------------------
// mine textures
//--------------------------------------------
#declare txtMine=texture {
        pigment{color colWater3*0.1}
        finish{ambient 0 diffuse 0.4 specular 0.03 roughness 0.2 reflection 0.05}
}
#declare txtCable=texture {
        pigment{color colWater3*0.1}
        finish{ambient 0 diffuse 0.1 specular 0.02 roughness 0.2}
}

//--------------------------------------------
// sub textures
//--------------------------------------------
#declare txtSkin=texture{
        pigment{
                function{min(1,max(0,y))}
                turbulence 0.01 omega 1.5 lambda 5 poly_wave 1.5
                color_map{[0 Clear][0.25  rgbt<0,0,0,0.7>] [0.4 rgbt<0,0,0,0.3>]}
                scale 38 translate -y*17
                }
                
        finish{ambient 0 diffuse 0.6 specular 0.1 roughness 1/10}
}
#declare trb=0.0001;
#declare pigLettre=pigment{bozo color_map{[0 White*1.3][1 White*0.5]}}
#declare txtLettre=texture{ // submarine name
        pigment {
                object {
                        text{ttf "cyrvetic.ttf" "PERSISTENCE" 10, 0.3*x
                             translate -z*0.5 scale <1,1,10>
                        }
                        pigment{color Clear}, pigment{pigLettre}
                }
                rotate y*90
        scale 1.5 translate <-10,-1,-25>
        }

        finish{ambient 0 diffuse 0.4}

}

#declare txtSub0=texture {
    pigment{rgb colSub*0.2}
    finish {ambient 0 diffuse 0.3 specular 0.05   roughness 0.1}
}
// Thanks to Bob H. for the help regarding these textures
#declare txtSubBase=texture {
    pigment {
    
        cells
        color_map {
            [.45 rgb <colSub.x*0.1,colSub.y*0.1,colSub.z*0.1>]
            [.55 rgb <colSub.x,colSub.y,colSub.z>*0.8]
        }
        scale <100,.125,1>
    }
    
    scale 3
    finish {ambient 0 diffuse 0.3 specular 0.05   roughness 0.1}
}

#declare txtSubTop=

    texture{txtSubBase}
    texture {
        pigment {
            cells
            color_map {
                [.25 rgbf <colSub.x*0.1,colSub.y*0.1,colSub.z*0.1,0>]
                [.75 rgbf <colSub.x,colSub.y,colSub.z,1>]
            }
            scale <100,0.75,1>
        }
        scale 3.5
        finish {ambient 0 diffuse 0.3 specular 0.05   roughness 0.1}
    }

    texture {
        pigment {
            cells
            color_map {
                [.25 rgbf <colSub.x*0.4,colSub.y*0.4,colSub.z*0.4,0>]
                [.75 rgbf <colSub.x,colSub.y,colSub.z,1>]
            }
            scale <100,0.45,1>
        }
        scale 2.5
        finish {ambient 0 diffuse 0.3 specular 0.05   roughness 0.1}
    }                                 
    
    texture{txtSkin}

#declare txtSubBottom=

    texture{txtSubBase}
    
    texture {
        pigment {
            cells
            color_map {
                [.25 rgbf <colSub.x*0.5,colSub.y*0.5,colSub.z*0.5,0>]
                [.75 rgbf <colSub.x,colSub.y,colSub.z,1>]
            }
            scale <100,.75,1>
        }
        scale 5
        finish {ambient 0 diffuse 0.3 specular 0.05   roughness 0.1}
    }
    
    texture {
        pigment {
            cells
            color_map {
                [0 rgbf <colSub.x*0.5,colSub.y*0.5,colSub.z*0.5,.5>]
                [1 rgbf <colSub.x,colSub.y,colSub.z,1>]
            }
            scale <100,0.25,1>
        }
        scale 5
        translate 1
        finish {ambient 0 diffuse 0.3 specular 0.05   roughness 0.1}
    } 
    
    texture{txtLettre}  
    texture{txtSkin}


//============================================
// Mine
//============================================
//--------------------------------------------
// Spikes
//--------------------------------------------

#declare Spike = union{
        #declare rSpike1=0.08;
        #declare rSpike2=rSpike1*0.3;
        #declare ySpike=0.4;
        cone{0,rSpike1,y*ySpike,rSpike2}
        sphere{0,rSpike2 translate y*ySpike}
        sphere{0,rSpike1*1.5 scale <1,0.3,1>}
        #declare i=0;#while (i<360) sphere{0,0.015 scale <2,1,2> translate <rSpike1*2.8,-0.04,0> rotate y*i} #declare i=i+30;#end
        translate y
}





//--------------------------------------------
// Mine body
//--------------------------------------------
#declare rd=seed(0);
#declare MineBody=union {
        isosurface {
                function{x*x+y*y+z*z-1 +f_noise3d(x*10,y*10,z*10)*0.05}
                max_gradient 2.492
                contained_by{sphere{0,1}}
        }

        #declare i=0;
        #while (i<360)
                #declare j=0;
                #while (j<180)
                        object{Spike rotate z*(i+rand(rd)*2) rotate y*(j+rand(rd)*2)}
                        #declare j=j+45;
                #end
                #declare i=i+45;
        #end

        object{Spike rotate 90*y}
        object{Spike rotate -90*y}
        rotate 360*rand(rd)

}

//--------------------------------------------
// Mine cable and decorative collar
//--------------------------------------------
#declare rFil=0.03;
#declare yFil=100;
#declare MineCable=isosurface{
        function{f_helix1(x,y,z,3,35,0.35*rFil,0.55*rFil,2,1,0)}
        contained_by {box {<-rFil,0,-rFil>,<rFil,yFil,rFil>}}
        max_gradient 2.552
        scale <1,-1,1>*3 translate -y
}


#declare MineCollar=lathe{
	cubic_spline
	15,
	<0.058,0.003>,<0.081,0.000>,<0.101,0.055>,<0.099,0.085>,<0.104,0.132>,<0.066,0.152>,
	<0.095,0.169>,<0.089,0.194>,<0.144,0.227>,<0.143,0.281>,<0.145,0.307>,<0.109,0.325>,
	<0.067,0.353>,<0.031,0.362>,<0.030,0.363>
	translate -y*0.363
}

//--------------------------------------------
// Mine
//--------------------------------------------
#declare Mine=union{
        object{MineBody}
        sphere{0,1 scale <0.4,0.14,0.4> translate -y*0.91}
        #declare i=0;#while (i<360) cylinder{0,-y*0.1,0.02 translate <0.35,-0.91,0> rotate y*i} #declare i=i+30;#end
        object{MineCollar scale <1.2,2,1.2> translate -y*0.92}
        object{MineCollar translate -y*2}
        object{MineCable}
        texture{txtMine}
}



//============================================
// Submarine
//============================================
#declare Sc=3; // general scaling parameter
#declare SX=6*Sc; // x scaling
#declare SYbot=10*Sc;// y scaling for the bottom
#declare SYtop=2*Sc; // y scaling for the top
#declare SZfront=20*Sc; // z scaling for the front
#declare SZrear=100*Sc;// z scaling for the rear

//--------------------------------------------
// Main parts
//--------------------------------------------
#declare Part1=blob{ // bottom front
        threshold 0.6
        sphere{0,1,1}
        cylinder{-z*2,z,0.04,-1 translate <-0.2,-0.3,1> pigment{Black}}
        cylinder{-z*2,z,0.04,-1 translate <-0.17,-0.18,1> pigment{Black}}
        sphere{0,1,1 scale <0.1,0.45,1.05>}
        sphere{0,1,1 scale <0.3,0.45,0.8>}
}
#declare Part2=blob{ // top front
        threshold 0.6
        sphere{0,1,1}
        sphere{0,1,1 scale <0.3,0.45,0.8>}
        sphere{0,1,1 scale <0.2,1.2,1.05>}
}
#declare Part3=blob{ // bottom rear
        threshold 0.6
        sphere{0,1,1}
        cylinder{-x,0,1,1 scale <0.5,0.03,0.02> translate <0,-0.05,0.45>}
        cylinder{-y,0,1,1 scale <0.03,0.2,0.02> translate <0,-0.05,0.45>}
}
#declare Part4=blob{ // top rear
        threshold 0.6
        sphere{0,1,1}
        cylinder{-y,y,2,2 scale <0.03,0.3,0.012> translate <0,0.5,0.45>}
        sphere{0,1,1 scale <0.2,1.2,0.4>}

        cylinder{-x,0,1,1 scale <0.2,0.2,0.04> rotate x*-10 translate <0,1.5,0.2>}
        cylinder{0,y,0.2,2 scale <0.6,2.5,0.4>*0.7  translate <0,-0.05,0.16>}
        cylinder{0,y,0.2,2 scale <0.4,2.5,0.4>*0.7  translate <0,-0.05,0.165>}
        cylinder{0,y,0.2,2 scale <0.2,2.5,0.4>*0.7  translate <0,-0.05,0.17>}
}


//--------------------------------------------
// Top
//--------------------------------------------
#declare HalfSubTop=union{
       difference{
                object{Part2} // top front
                plane{y,0}
                plane{z,0 inverse}
                plane{x,0 inverse}
                scale <SX,SYtop,SZfront>
        }
        difference{
                object{Part4} // top rear
                plane{y,0}
                plane{z,0}
                plane{x,0 inverse}
                scale <SX,SYtop,SZrear>
        }
}
#declare SubTop=union{
        object{HalfSubTop}
        object{HalfSubTop scale <-1,1,1>}
        texture{txtSubTop}
}
//--------------------------------------------
// Bottom
//--------------------------------------------
#declare HalfSubBottom=union{
         difference{
                object{Part1} // bottom front
                plane{y,0 inverse}
                plane{z,0 inverse}
                plane{x,0 inverse}
                scale <SX,SYbot,SZfront>
        }
        difference{
                object{Part3} // bottom rear
                plane{y,0 inverse}
                plane{z,0}
                plane{x,0 inverse}
                scale <SX,SYbot,SZrear>
        }
}

#declare SubBottom=union{
        object{HalfSubBottom}
        object{HalfSubBottom scale <-1,1,1>}
        texture{txtSubBottom}
}
//--------------------------------------------
// Decorative elements
//--------------------------------------------
#declare Balustrade=union{
        #declare rB1=0.02;
        #declare rB2=0.04;
        #declare yB=1;
        #declare rB3=yB*6;
        #declare rB4=3;
        #declare zB=20;
        #declare zB2=8;
        #declare i=0;
        #while (i<zB)
                cylinder{0,y*yB,rB1 translate z*i}
                #declare i=i+zB/12;
        #end
        cylinder{0,z*zB,rB2 translate y*yB}
        cylinder{0,z*zB,rB2 translate y*yB*0.3}
        cylinder{0,z*zB,rB2 translate y*yB*0.6}
        union{
                difference{torus{rB3,rB2 rotate z*90} plane{y,0} plane{z,0 inverse} plane{z,0 rotate x*-45}}
                cylinder{0,-z*zB*0.1,rB2 translate y*rB3 rotate x*-45}
                translate y*(yB-rB3)
        }
        union{
                difference{torus{rB4,rB2} plane{x,0 inverse} translate <0,yB,0>}
                difference{torus{rB4,rB1} plane{x,0 inverse} translate <0,yB*0.5,0>}
                #while (i<180)
                        cylinder{0,y*yB,rB1 translate -z*rB4 rotate y*i}
                        #declare i=i+180/14;
                #end
                scale <0.4,1,1>
                translate z*(rB4+zB)
        }
        union{
                difference{torus{rB3,rB2 rotate z*90} plane{y,0} plane{z,0 inverse} plane{z,0 rotate x*-65}}
                cylinder{0,-z*zB*0.1,rB2 translate y*rB3 rotate x*-65}
                translate y*(yB-rB3)
                scale <1,1,-1>
                translate z*(zB+rB4*2)
        }

}



//--------------------------------------------
// guns
//--------------------------------------------
#declare Guns0=union{
        superellipsoid{<0.3,0.3> translate z scale <0.8,1,4>}
        union{
                cone{0,0.4,z*12,0.3}
                union{
                        cone{0,0.3,z*1.5,0.5}
                        difference{
                                sphere{0,0.5}
                                cylinder{-z,z,0.3}
                                translate z*1.5
                        }
                        translate z*12
                }
                translate z*8
        }
        translate -z*3
}

#declare Wheel=blob{
        threshold 0.6
        sphere{0,1.3,1 scale <1,1.2,1>}
        cylinder{0,-y*3,0.8,1}
        #declare Teta=0;
        #while (Teta<360)
                cylinder{0,x*3.4,0.4,1  rotate y*Teta}
                cylinder{0,y,0.4,1  translate x*3 rotate y*Teta}
                sphere{0,0.6,1 translate x*3 rotate y*Teta}
                sphere{0,0.4,1 translate x*3 rotate y*(Teta+6)}
                sphere{0,0.4,1 translate x*3 rotate y*(Teta+12)}
                sphere{0,0.4,1 translate x*3 rotate y*(Teta+18)}
                sphere{0,0.4,1 translate x*3 rotate y*(Teta+24)}
                sphere{0,0.4,1 translate x*3 rotate y*(Teta+30)}
                sphere{0,0.4,1 translate x*3 rotate y*(Teta+36)}
                sphere{0,0.4,1 translate x*3 rotate y*(Teta+42)}
                sphere{0,0.4,1 translate x*3 rotate y*(Teta+48)}
                sphere{0,0.4,1 translate x*3 rotate y*(Teta+54)}
                sphere{0,0.5,1 translate x*3 rotate y*(Teta+60)}
                sphere{0,0.5,1 translate x*3 rotate y*(Teta+66)}
                #declare Teta=Teta+72;
        #end
}
#declare Guns1=union{
             object{Guns0}
             object{Wheel rotate y*10 scale 0.7 rotate z*90 translate -x*1.5}

}
#declare Eye=union{
        torus{4.5,0.5}
        difference{
                sphere{0,4.3}
                box{-5,5 scale <1,1,0.05>}
                box{-5,5 scale <1,1,0.05> translate z}
                box{-5,5 scale <1,1,0.05> translate z*2}
                box{-5,5 scale <1,1,0.05> translate z*3}
                box{-5,5 scale <1,1,0.05> translate z*4}
                box{-5,5 scale <1,1,0.05> translate -z}
                box{-5,5 scale <1,1,0.05> translate -z*2}
                box{-5,5 scale <1,1,0.05> translate -z*3}
                box{-5,5 scale <1,1,0.05> translate -z*4}
                scale <1,0.7,1>
        }
}
#declare Ring1=union{
        cylinder{-0.2*x,0.2*x,1.2}
        torus{1.1,0.1 rotate z*90 scale <2,1,1> translate -x*0.2}
        torus{1.1,0.1 rotate z*90 scale <2,1,1> translate x*0.2}
}
#declare Elbow1=intersection{torus{2,1} plane{z,0 inverse} plane{x,0 inverse} }


#declare Thingie=union{
        torus{1.5,0.3 rotate z*90 translate -x}
        cylinder{-x,x,1.5}
        superellipsoid{<0.2,0.2> scale <1.5,2,2.5> translate x*2.5}
        object{Eye scale 1.5/7 rotate -x*90 translate <2.5,0,-2.5>}
        object{Eye scale 1.5/7 rotate -x*90 translate <2.5,0,-2.5> scale <1,1,-1>}
        sphere{0,1.5 scale <0.5,1,1> translate x*4}
        sphere{0,1.5 scale <0.5,1,1> translate x*16}
        cylinder{x*4,x*16,1.2}
        torus{1.9,0.1 rotate z*90 translate x*16.5}
        cylinder{x*16.5,x*17.5,2}
        torus{1.9,0.1 rotate z*90 translate x*17.5}
        cylinder{x*17.5,x*23,1.5}
        union{
              torus{0.5,0.1}
              intersection{torus{2.5,0.5 rotate x*90} plane{y,0 inverse} plane{x,0} translate x*2.5}
              torus{0.5,0.1 translate -x*2.5 rotate z*-30 translate x*2.5 }
              torus{0.5,0.1 translate -x*2.5 rotate z*-60 translate x*2.5 }
              torus{0.5,0.1 translate -x*2.5 rotate z*-90 translate x*2.5 }
              union{
                    cylinder{0,9*x,0.5}
                    cylinder{2*x,5*x,0.7}
                    torus{0.5,0.2 rotate z*90 translate x*2}
                    torus{0.7,0.2 scale <0.2,1,1> rotate z*90 translate x*2.3}
                    torus{0.7,0.2 scale <0.2,1,1> rotate z*90 translate x*2.6}
                    torus{0.7,0.2 scale <0.2,1,1> rotate z*90 translate x*2.9}
                    torus{0.7,0.2 scale <0.2,1,1> rotate z*90 translate x*3.2}
                    torus{0.7,0.2 scale <0.2,1,1> rotate z*90 translate x*3.5}
                    torus{0.7,0.2 scale <0.2,1,1> rotate z*90 translate x*3.8}
                    torus{0.7,0.2 scale <0.2,1,1> rotate z*90 translate x*4.1}
                    torus{0.7,0.2 scale <0.2,1,1> rotate z*90 translate x*4.4}
                    torus{0.7,0.2 scale <0.2,1,1> rotate z*90 translate x*4.7}
                    torus{0.5,0.2 rotate z*90 translate x*5}
                    torus{0.5,0.3 rotate z*90 translate x*8}
                    cone{0,0.7,x,0.9 translate x*8}
                    torus{0.9,0.2 rotate z*90 translate x*9}
                    translate <2.5,2.5,0>
                    }
               translate <2.5,2,1.7>
        }
        union{
              torus{0.5,0.1}
              intersection{torus{2.5,0.5 rotate x*90} plane{y,0 inverse} plane{x,0} translate x*2.5}
              torus{0.5,0.1 translate -x*2.5 rotate z*-30 translate x*2.5 }
              torus{0.5,0.1 translate -x*2.5 rotate z*-60 translate x*2.5 }
              torus{0.5,0.1 translate -x*2.5 rotate z*-90 translate x*2.5 }
              union{
                    cylinder{0,9*x,0.5}
                    cylinder{3*x,6*x,0.7}
                    torus{0.5,0.2 rotate z*90 translate x*3}
                    torus{0.7,0.2 scale <0.2,1,1> rotate z*90 translate x*3.3}
                    torus{0.7,0.2 scale <0.2,1,1> rotate z*90 translate x*3.6}
                    torus{0.7,0.2 scale <0.2,1,1> rotate z*90 translate x*3.9}
                    torus{0.7,0.2 scale <0.2,1,1> rotate z*90 translate x*4.2}
                    torus{0.7,0.2 scale <0.2,1,1> rotate z*90 translate x*4.5}
                    torus{0.7,0.2 scale <0.2,1,1> rotate z*90 translate x*4.8}
                    torus{0.7,0.2 scale <0.2,1,1> rotate z*90 translate x*5.1}
                    torus{0.7,0.2 scale <0.2,1,1> rotate z*90 translate x*5.4}
                    torus{0.7,0.2 scale <0.2,1,1> rotate z*90 translate x*5.7}
                    torus{0.5,0.2 rotate z*90 translate x*6}
                    torus{0.5,0.3 rotate z*90 translate x*8}
                    cone{0,0.7,x,0.9 translate x*8}
                    torus{0.9,0.2 rotate z*90 translate x*9}
                    translate <2.5,2.5,0>
                    }
               translate <2.5,2,-1.7>
        }
        union{
                superellipsoid{<0.2,0.2> scale <1,1.3,2.6>}
                object{Eye scale 1/7 rotate -x*90 translate z*-2.6}
                object{Eye scale 1/7 rotate -x*90 translate z*2.6}
                object{Eye scale 1/7 rotate y*90 translate <0,1.3,1.7>}
                object{Eye scale 1/7 rotate y*90 translate <0,1.3,-1.7>}
                cylinder{x,x*3,1}
                torus{1,0.2 rotate z*90 translate x*3}
                intersection{torus{4.5,1 rotate x*90} plane{y,0 inverse} plane{x,0 inverse} scale <0.5,1,1> translate <3,-4.5,0>}
                torus{1,0.3 scale <0.5,4,1> translate <3+2.25,-3,0>}
                translate <15,4.5,0>
        }
        #declare Teta=0;
        #while (Teta<360)
        union{
                box{<0,-0.1,-0.05>,<12,0.1,0.05> translate <4,1.2,0>}
                cylinder{-x,2*x,0.1 translate y*1.5}
                sphere{0,0.2 translate <20,1.5,0>}
                sphere{0,0.1 translate <16.8,2,0>}
                sphere{0,0.1 translate <17.2,2,0> rotate x*10}
                cylinder{x*20,x*23,0.18 translate y*1.5}
                rotate x*Teta
        }
        #declare Teta=Teta+20;
        #end

        translate x
}
#declare GunSupport=union{
        superellipsoid{<0.6,0.6> translate y scale <0.3,3,1> translate -z*2}
        union{
                union{
                        superellipsoid{<0.7,0.7> translate y scale <1.5,3.8,1>}
                        #declare i=0;
                        #while (i<6)
                                sphere{0,0.2 translate <-1,i+0.5,0.8>}
                                sphere{0,0.2 translate <0,i+0.1,1>}
                                sphere{0,0.2 translate <1,i+0.5,0.8>}
                                #declare i=i+0.7;
                        #end
                        rotate -x*10 translate z*0.6
                }

                cylinder{y*4,y*9,0.6}
                sphere{0,1 scale <4,1,4>}
        }
}
#declare Guns=union{
        union{
                object{Thingie rotate y*180 scale 0.5 rotate y*-90 rotate z*45 translate <0,4,5>}
                superellipsoid{<0.6,0.6> translate -z scale <0.6,1,3> translate -x*0.5}
                object{Guns1 translate -x*1.7}
                object{Guns1 translate -x*1.7 scale <-1,1,1>}
                rotate x*-20
                translate y*10
        }
        object{GunSupport}
}

#declare GunsBack=union{
        union{
                object{Thingie rotate y*180 scale 0.5 rotate y*-90 rotate z*45 translate <0,4,5>}
                superellipsoid{<0.6,0.6> translate -z scale <0.6,1,3> translate -x*0.5}
                object{Guns1 translate -x*1.7}
                object{Guns1 translate -x*1.7 scale <-1,1,1>}
                rotate x*-5
                translate y*10
        }
        object{GunSupport}
}

//--------------------------------------------
// snorkels and vertical thingies
//--------------------------------------------
#declare Snorkel1=union{
        cone{0,0.3,y*2,0.25}
        cone{y*2,0.25,y*3,0.1}
        union{
                difference{sphere{0,1 scale<0.3,0.2,0.3>}plane{y,0 inverse}}
                difference{sphere{0,1 scale<0.3,0.6,0.3>}plane{y,0}}
                translate y*3
        }
        scale <0.8,1,0.8>
}
#declare Snorkel2=blob{
        threshold 0.6
        cylinder{-y,y*4,0.2,1}
        sphere{0,0.4,1 scale <1,1,2> translate y*3.5}
        sphere{0,0.3,1 scale <3,1,1> translate y*2.5}
        scale <0.8,1,0.8>
        }
#declare Snorkel3=union{
        blob{
                threshold 0.6
                cylinder{0,y*3.4,0.25,1 scale <1,1,3>}
                cylinder{0,y*5,0.03,1 translate <0,0,-0.5>}

        }
        union{
                cylinder{0,y*4,0.03}
                sphere{0,0.1 translate y*4}
                translate  <-0.1,0,0.5>
        }
        scale <0.8,1,0.8>
}

//--------------------------------------------
// lots of decorative stuff
//--------------------------------------------
#declare nDeco=13;
#declare Deco=array[nDeco]
#declare Deco[0]=union{
        cylinder{0,y*2,0.2}
        torus{1,0.2 rotate x*90 translate y*3}
        scale 0.5
}
#declare Deco[1]=cone{-y*0.5,0.2,y*4,0.1}
#declare Deco[2]=blob{
        threshold 0.6
        cylinder{-x,x,0.25,1 scale <1,1,2>}
        cylinder{0,-y,0.21,1 translate -x*0.8}
        cylinder{0,-y,0.21,1 translate x*0.8}
        translate y*0.7
        scale 1
}
#declare Deco[3]=object{Deco[2] rotate y*90}
#declare Deco[4]=torus{1,0.2 rotate z*90}
#declare Deco[5]=object{Deco[3] rotate y*90 scale <1,1.4,1>}
#declare Deco[6]=union{
        cylinder{0,y*0.4,0.1}
        sphere{0,1 scale <0.1,0.1,0.5> translate y*0.4}
}
#declare Deco[7]=difference{sphere{0,1} cylinder{-z,0,0.8} scale <2,0.5,2>translate -y*0.2}
#declare Deco[8]=difference{sphere{0,1} cylinder{-z,0,0.9} scale <2,0.5,4>translate -y*0.2}
#declare Deco[9]=cone{0,0.08,y*2,0.03 scale <1,1,2>}
#declare Deco[10]=sphere{0,1 scale <0.2,0.1,0.4>}
#declare Deco[11]=object{Deco[4] scale 1.2}
#declare Deco[12]=object{Deco[5] scale 1.3}
#declare Ladder=union{
        #declare i=0;
        #while (i<9)
                object{Deco[3] scale 0.8 rotate z*90 translate y*i*0.8}
                #declare i=i+1;
        #end
}

#declare Decos=union{
        #declare rd=seed(4);
        #declare Start0=-40;
        #declare End0=40;
        #declare nstep=200;
        #declare i=0;
        #declare k=0;
        #while (i<1)
                #declare j=i;
                #declare Start=<-rand(rd)*5*(mod(k,2)*2-1),1,(1-j)*Start0+j*End0>;
                #declare Dir=y;
                #declare Norm1=<0,0,0>;
                #declare Inter=trace( SubTop, Start, Dir, Norm1);
                #if (vlength(Norm1)!=0)
                    #if (vlength(vcross(Norm1,y))<0.9)
                        #declare n=int(rand(rd)*nDeco);
                        object{Deco[n]  scale 0.4 mOrient(Inter,Inter+Norm1)}
                    #end
                #end
                #declare k=k+1;
                #declare i=i+1/nstep;
        #end
}


#declare Submarine=union{
        union{
                object{SubTop}
                object{Decos texture{txtSubTop}}
                object{Ladder translate <-1.5,4,40>}
                object{Ladder translate <1.5,4,40>}
                object{Guns rotate y*180 scale 0.3 translate <0,4,30>}
                object{GunsBack scale 0.3 translate <0,4,70>}
                union{
                        object{Snorkel1 translate z*3}
                        object{Snorkel2}
                        object{Snorkel3 translate -z*2}
                        scale 2*<1,1.1,1>
                        translate <0,10,50>
                }
                object{Balustrade scale 2.5 translate <-4,2,5>}
                object{Balustrade scale 2.5 translate <-4,2,5> scale <-1,1,1>}
                union{
                        object{Balustrade scale 2 translate <-3,2,5>}
                        object{Balustrade scale 2 translate <-3,2,5> scale <-1,1,1>}
                        rotate y*180
                        translate z*100
                }
                texture{txtSub0}
                scale <1,1.3,1>
        }
        object{SubBottom}
}



//============================================
// Final
//============================================
#declare posSub=<19,5,0>;
#declare rotSub=-15;

//--------------------------------------------
// mines
//--------------------------------------------
union{
    light_group{
        object{Mine rotate y*80 scale 14 }
        light_source{<-10,-20,-40> color rgb -4 shadowless} // negative light !!!
        translate <-110, 41, -205>
        global_lights on
    }
    light_group{
        object{Mine rotate -y*10 scale 8 }
        light_source{<-10,-20,-40> color rgb -2 shadowless}
        translate <-75, 25, -165>
        global_lights on
    }
    object{Mine rotate y*125 scale 5 translate <105, -5, -155>}
    translate y*-8
}
union{
        #declare rd=seed(0);
        #declare i=0;
        #while (i<20)

                object{Mine rotate y*125 scale 3 translate <50+rand(rd)*(200+i*10),(0.5-rand(rd))*60,i*30>}
                object{Mine rotate y*150 scale 3 translate <-50-rand(rd)*(200+i*10),(0.5-rand(rd))*60,i*30>}

                object{Mine rotate y*10 scale 3 translate <50+rand(rd)*(200+i*10),(0.5-rand(rd))*140+50+i*10,i*30>}
                object{Mine rotate y*37 scale 3 translate <-50-rand(rd)*(200+i*10),(0.5-rand(rd))*140+50+i*10,i*30>}
                #declare i=i+1;
        #end
        rotate y*rotSub translate posSub
        translate -z*150
        translate x*30
}
//--------------------------------------------
// submarine and media
//--------------------------------------------
union{
        object{Submarine scale 3/4 translate z*-10 translate y*10}
        sphere{0,1 scale 410 hollow
                texture{pigment{Clear}finish{ambient 0 diffuse 0}}
                interior{
                        media{
                                scattering {5,0.00034 eccentricity 0.7 extinction 0.8}
                                absorption <255-23,255-171,255-239>*0.0005/255
                                intervals 3
                                method 3
                        }
                }
        }

        scale 4
        rotate y*rotSub  translate posSub
}

</textarea>


<!-- Sample file : biscuit.pov -->

<textarea id="biscuit.pov" name="biscuit.pov" style="display:none;">
// This work is licensed under the Creative Commons Attribution-ShareAlike 3.0 Unported License.
// To view a copy of this license, visit http://creativecommons.org/licenses/by-sa/3.0/ or send a
// letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.

//oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo//
//                                                                        //
// Windows users: to start rendering this image, press Alt+G or the 'Run' //
// button on the toobar.                                                  //
//                                                                        //
// Experienced windows users: try right-clicking on the line below ...    //
//                                                                        //
// +w320 +h240
// +w800 +h600 +a0.3 +am2
//                                                                        //
// See the docs for full explanations of new features such as the above.  //
//                                                                        //
//oooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo//

// Persistence Of Vision raytracer sample file.
// Copyright 2001 Fabien Mosen
// 
// Updated: 2013/02/15 for 3.7
// 
#version 3.6;
global_settings{ assumed_gamma 1.3 max_trace_level 5}

#include "colors.inc"
#include "functions.inc"
#include "logo.inc"


camera{ location  <20,40,28>  
        angle 40 // direction 2*z 
        right     x*image_width/image_height // keep propotions with any aspect ratio
        look_at   <0,2,0>
      }

light_source {<-140,200, 300> rgb <1.0, 1.0, 0.95>*1.5}
light_source {< 140,200,-300> rgb <0.9, 0.9, 1.00>*0.9 shadowless}

#declare r1 = seed(0);

//----------------------- THE TABLE
#declare Pig_1 =
pigment {
   gradient z
   color_map {
      [0.00, rgb <0.01, 0.59, 0.81>]
      [0.70, rgb <0.01, 0.59, 0.81>]
      [0.70, rgb <0.98, 0.98, 0.87>]
      [1.00, rgb <0.98, 0.98, 0.87>]
   }
   frequency 4
}

#declare Pig_2 =
pigment {
   bozo
   color_map {
      [0.00, rgb <0.35, 0.58, 0.88>*1.0]
      [0.25, rgb <0.35, 0.58, 0.88>*1.1]
      [0.50, rgb <0.35, 0.58, 0.88>*0.9]
      [0.75, rgb <0.35, 0.58, 0.88>*1.0]
      [1.00, rgb <0.35, 0.58, 0.88>*0.8]
   }
   scale 0.1
}

#declare Nappe =
cylinder {0,y*-1,50
   texture {
      pigment {
         gradient x
         pigment_map {
            [0.0, Pig_1]
            [0.5, Pig_1]
            [0.5, Pig_2]
            [1.0, Pig_2]
         }
         warp {turbulence .05 octaves 2}
      }
      normal {quilted 0.6 scale 0.025 warp {turbulence 0.05 octaves 2}}
      scale 5
      translate 10
   }
}

object {Nappe}

//----------------------- BISCUITS
#declare Tex_Biscuit =
texture {
   pigment {color rgb <0.98, 0.83, 0.58>}
   normal {dents 1.2 scale 0.01}
   finish {phong 0 brilliance 0.7}
}

#declare Base_Biscuit =
union {
   blob {
      threshold 0.7
      #declare I = 0;
      #while (I < 359)
         sphere {<4,0,0>, 1+rand(r1)*0.1, 1 rotate y*I}
         #declare I = I+(360/28);
      #end
   }
   cylinder {<0,0,0>, <0,0.5,0>, 4}
   texture {Tex_Biscuit}
}

#declare Chocolate =
union {
   difference {
      cone {<0,0,0>, 4.2, <0,0.4,0>, 4}
      cone {<0,0.1,0>, 3.6, <0,0.401,0>, 3.75}
   }
   torus {
      3.55, 0.1
      translate y*0.2
      clipped_by {torus {3.55+0.1, 0.1 translate y*0.1}}
   }
   union {
      #declare I = -4;
      #while (I < 4)
         cylinder {<-4,0.1,I>,<4,0.1,I>, 0.05}
         #declare I = I+0.5;
      #end
      clipped_by {cone {<0,0,0>, 4.2, <0,0.4,0>, 4}}
   }
   torus {3.96, 0.04 translate y*0.4}
   torus {3.79, 0.04 translate y*0.4}
}

#declare LogoFun =
object{Povray_Logo_Prism rotate x*90 scale 2.2 translate -0.3*z}

#declare ProjLogo =
blob {
   threshold 0.6
   #declare I = 0;
   #while (I < 1)
      #declare Pos = <-2+rand(r1)*4, 0, -2+rand(r1)*4>;
      #if (inside(LogoFun,Pos))
         sphere {Pos, 0.08, 1}
      #end
      #declare I = I+0.0002;
   #end
}

#declare Black_Chocolate =
texture {
   pigment {color rgb <0.24, 0.10, 0.03>}
   normal {wrinkles 0.2}
   finish {specular 0.3}
   }
#declare Milk_Chocolate =
texture {
   pigment {color rgb <0.48, 0.26, 0.13>}
   normal {wrinkles 0.2}
   finish {specular 0.2}
}
#declare White_Chocolate =
texture {
   pigment {color rgb <0.96, 0.95, 0.75>}
   normal {wrinkles 0.2}
   finish {ambient 0.3 specular 0.01}
}

#declare Icing = texture {
   pigment {rgbf <0.95, 0.95, 1.00, 0.1>*1.2}
   normal {bumps 0.1}
}

#declare Biscuit_1 =
union {
   object {Base_Biscuit}
   object {Chocolate translate y*0.5 texture {Black_Chocolate}}
   disc {
      <0,0.101,0>, y, 3.6
      translate y*0.5
      texture {Black_Chocolate} normal {bumps 0.3 scale 0.05}
   }
   object {ProjLogo scale 1.5 rotate y*-90 translate <-0.4,0.6,0.5> texture {Icing}}
   translate y*0.5
}
#declare Biscuit_2 =
union {
   object {Base_Biscuit}
   object {Chocolate translate y*0.5 texture {Milk_Chocolate}}
   disc {
      <0,0.101,0>, y, 3.6
      translate y*0.5
      texture {Milk_Chocolate} normal {bumps 0.3 scale 0.05}
   }
   object {ProjLogo scale 1.5 rotate y*-90 translate <-0.4,0.6,0.5> texture {White_Chocolate}}
   translate y*0.5
}
#declare Biscuit_3 =
union {
   object {Base_Biscuit}
   object {Chocolate translate y*0.5 texture {White_Chocolate}}
   disc {
      <0,0.101,0>, y, 3.6
      translate y*0.5
      texture {White_Chocolate} normal {bumps 0.3 scale 0.05}
   }
   object {ProjLogo scale 1.5 rotate y*-90 translate <-0.4,0.6,0.5> texture {Milk_Chocolate}}
   translate y*0.5
}

object {Biscuit_2 rotate y*-80 translate <-3.5,0,2>}
object {Biscuit_1 rotate y*-120 translate <3.5,0,-4>}
object {Biscuit_3 rotate x*-4 translate <8.5,0.9,0>}

#macro SevenBiscuits (Bisc,Num)
   union {
      #declare I = 0;
      #while (I < Num)
         object {Bisc translate x*9 rotate y*60*I}
         #declare I = I+1;
      #end
      object {Bisc}
   }
#end

//----------------------- CRUMBS
#declare Fun_Sphere = function {x*x + y*y +z*z}

#declare Crumb =
isosurface {
   function {Fun_Sphere(x,y,z) + f_noise3d(x*2,y*2,z*2)*1}
   threshold 1
   max_gradient 3.9
   //max_gradient 15
   accuracy 0.01
   contained_by {box {-1,1}}
   scale 0.5
}

#declare r1 = seed(0);

#declare I = 0;
#while (I < 1)
   object {
      Crumb
      rotate rand(r1)*360
      scale 0.2+rand(r1)*0.3
      translate <rand(r1)*10,0,rand(r1)*10>
      texture {Tex_Biscuit}
   }
   object {
      Crumb
      rotate rand(r1)*360
      scale 0.1+rand(r1)*0.15
      translate <rand(r1)*10,0,rand(r1)*10>
      texture {Tex_Biscuit}
   }
   #declare I = I+0.03;
#end

//----------------------- METAL BOX
#declare Pig3 =
pigment {
   gradient y
   color_map {
      [0, rgb <0.1, 0.5, 0.7>]
      [1, rgb <0.7, 0.6, 0.4>]
   }
   scale 0.5
}

#declare Pig4 =
pigment {
   crackle
   color_map {
      [0, rgb <1.0, 0.5, 0.6>]
      [1, rgb <0.0, 0.0, 0.0>]
   }
   scale 0.2
}

#declare MetalBoxPig =
pigment {
   radial frequency 60
   pigment_map {
      [0.0, Pig3]
      [0.5, Pig3]
      [0.5, Pig4]
      [1.0, Pig4]
   }
}

#declare BiscuitBox =
union {
   difference {
      cylinder {<0,0,0>, <0,5,0>, 14}
      cylinder {<0,0.1,0>, <0,5.1,0>, 13.9}
   }
   torus {14, 0.1 translate y*5}
   torus {14, 0.1 translate y*0.1}
   torus {14, 0.1 scale <1,2,1> translate y*4}
   cylinder {
      <0,0.3,0>,<0,3.5,0>, 14.01 open
      pigment {MetalBoxPig}
      finish {phong 0.8 reflection {0.01, 0.15}}
   }
   pigment {Gray60}
   finish {phong 0.8 metallic reflection {0.5, 0.7}}
}

union {
   object {BiscuitBox}
   object {SevenBiscuits (Biscuit_1,6)}
   object {SevenBiscuits (Biscuit_3,6) rotate y*30 translate y*1}
   object {SevenBiscuits (Biscuit_2,5) rotate y*0 translate y*2}
   rotate y*-75 translate <-18,0,-12>
}

//-----------------------CUP OF TEA
#declare TeaCup =
union {
   difference {
      cylinder {<0,1.2,0>, <0,6,0>, 4.2}
      cylinder {<0,1,0>, <0,6.2,0>, 3.8}
   }

   difference {
      cylinder {<0,0.2,0>, <0,2.5,0>, 4}
      torus {2.8, 1 translate y*2.5}
      torus {4, 1 translate y*0}
      cylinder {<0,1.5,0>, <0,2.6,0>, 2.8}
   }

   difference {
      #declare LiquidLevel = 5;
      cylinder {<0,1.4,0>, <0,LiquidLevel,0>, 4}
      torus {3.6, 0.2 translate y*LiquidLevel}
      cylinder {<0,LiquidLevel-0.2,0>,<0,LiquidLevel+0.3,0>,3.6}
      pigment {Orange*0.8 filter 0.6}
      finish {phong 0.7 reflection 0.15}
      normal {bumps 0.05 scale 1}
   }

   torus {4.0, 0.2 translate y*6.0}
   torus {4.0, 0.2 translate y*1.2}
   torus {2.8, 0.2 translate y*0.2}

   union {
      difference {
         cylinder {<0.2,0,0>,<-0.2,0,0>,0.5}
         torus {0.5, 0.2 rotate z*90 translate x*0.2}
         translate y*1.25
      }
      difference {
         cylinder {<0.2,0,0>,<-0.2,0,0>,0.5}
         torus {0.5, 0.2 rotate z*90 translate x*0.2}
         translate y*-1.25
      }
      torus {1.25, 0.3 rotate x*90 clipped_by {plane {x,0 inverse}} translate x*0.8}
      cylinder {<0,-1.25,0>,<0.8,-1.25,0>,0.3}
      cylinder {<0,1.25,0>,<0.8,1.25,0>,0.3}
      scale <1,1,1.5> translate <4.2,4,0> rotate y*-90
   }

   pigment {White}
   normal {bumps 0.05 scale 3}
   finish {phong 0.8 reflection 0.1}
}

object {TeaCup rotate y*50 translate <4,0,-14>}

</textarea>


<!-- Sample file : isocacti.pov -->

<textarea id="isocacti.pov" name="isocacti.pov" style="display:none;">
// This work is licensed under the Creative Commons Attribution-ShareAlike 3.0 Unported License.
// To view a copy of this license, visit http://creativecommons.org/licenses/by-sa/3.0/ or send a
// letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.

// Persistence Of Vision raytracer sample file.
// Updated: Feb-2013 for 3.7
//
// -w320 -h240
// -w800 -h600 +a0.3

#version 3.7;
global_settings { assumed_gamma 1.3 }
 
#include "stdinc.inc"
#include "arrays.inc"



sky_sphere {
	pigment {gradient y
		color_map {
			[0 color Blue*0.6]
			[1 color White]
		}
	}
}

#default {finish {ambient 0}}
#declare RS = seed(464786);
//----------------------------------------
#declare CamLoc = < 5, 10,-10>;
camera {
	location CamLoc
        right x*image_width/image_height // keep propotions with any aspect ratio
	angle 45
	look_at <0, 0, 0>
}

light_source {<-20, 30, -30>*3 color White*1.5}
light_source {CamLoc color rgb 0.3}
//----------------------------------------

#declare Ground =
isosurface {
	function {y - f_snoise3d(x/7, 0, z/2)*0.5}
	threshold 0
	max_gradient 1.1
	contained_by {box {<-100,-3,-100>, < 100, 1, 100>}}

/*	texture {
		pigment {color rgb < 1, 0.9, 0.65>}
		normal {granite bump_size 0.1 scale 0.01}
	}*/
	texture {
		pigment {color rgb < 1, 0.9, 0.65>}
		normal {granite 0.2 scale 0.02}
		finish {
			brilliance 1.6
			specular 0.3
		}
	}
}
object {Ground}

#declare RockColors = array[5]
{
	color rgb < 0.5, 0.4, 0.35>,
	color rgb < 0.4, 0.5, 0.4>,
	color rgb < 0.8, 0.75, 0.65>,
	color rgb 0.8,
	color rgb 0.5
}

#declare CtrlPtrn = function {pattern {bozo scale < 7, 1, 2>}}
#declare L = 0;
#while(L < 750)
	#declare Pt = trace(Ground, < rand(RS)*25 - 15, 10, rand(RS)*25 - 10>, -y);
	#if(rand(RS) > CtrlPtrn(Pt.x, Pt.y, Pt.z))
//		sphere {o, 0.03 + pow(rand(RS), 2)*0.15
		isosurface {
			function {f_r(x, y, z) - 1 + f_noise3d(x, y, z)*0.5}
			threshold 0
			contained_by {sphere {o, 1}}
			#if(rand(RS) < 0.5) scale VRand_In_Box(< 1, 0.9, 1>, < 2, 1, 3>, RS) #end
			rotate y*rand(RS)*360
			translate -y*0.35
			scale 0.03 + pow(rand(RS),2)*0.35
			texture {
				pigment {Rand_Array_Item(RockColors, RS)*RRand(0.1, 1, RS)}
				normal {granite bump_size 0.5 scale 0.01}
			}
			translate Pt
		}
		#declare L = L + 1;
	#end
#end

#macro MakeSpineBunch(Pt, Dir, Jitter, Len, BaseRad, Num)
	#local L = 0;
	#while(L < Num)
		#local NewDir = vnormalize(Dir + Jitter*(< rand(RS), rand(RS), rand(RS)>*2 - 1));
		cone {Pt, BaseRad, Pt + NewDir*Len, 0}
		#local L = L + 1;
	#end
#end
#macro MakeSpineRows(Body, Stretch, AltJitter, Ridges, Bunches, Spines, SpineJitter, SpineLen, SpineRad)
	#declare J = 0;
	#local AltDelta = 180/Bunches;
	union {
		#while(J < Ridges)
			#declare K = 0;
			#while(K < Bunches)
				#declare Orig = vrotate(-y*50, x*(K + rand(RS)*AltJitter)*AltDelta);
				#declare Orig = vrotate(Orig, y*(360*J/Ridges + 360/(Ridges*4)))*Stretch;
				#declare PtNorm = y;
				#declare Pt = trace(Body, Orig,-Orig, PtNorm);
				MakeSpineBunch(Pt, PtNorm, SpineJitter, SpineLen, SpineRad, Spines)
				#declare K = K + 1;
			#end
			#declare J = J + 1;
		#end
	}
#end

#declare sinw = function (x) {(sin(x) + 1)/2}

#declare Ridges = 40;
#declare RidgeDepth = 0.075;

#declare cactus1Body =
isosurface {
	function {sqrt(x*x + pow(y - sqrt((x*x/4) + (z*z/4))*1.5, 2) + z*z) - 1 -
		(sin(atan2(x, z)*Ridges)*0.5*RidgeDepth)
	}
	threshold 0
        max_gradient 5
        
	contained_by {sphere {< 0, 0, 0>, 3.1}}
	texture {
		pigment {radial
			color_map {
				[0.00 color rgb < 0.3, 0.65, 0.4>*0.8]
				[0.65 color rgb < 0.3, 0.65, 0.4>*0.8]
				[1.00 color rgb < 0.3, 0.65, 0.4>*0.2]
			}
			frequency Ridges sine_wave
		}
		normal {dents 0.1 poly_wave 2 scale < 1, 0.15, 1>}
	}
}
#declare Cactus1 =
union {
	object {cactus1Body}
	object {MakeSpineRows(cactus1Body, 1, 0.2, Ridges, 24, 3, 0.5, 1, 0.01)
		texture {pigment {color rgb < 0.98, 0.98, 0.5>}}
	}
	scale < 1, 0.75, 1>
	translate y*0.35
}


#declare Ridges = 32;
#declare RidgeDepth = 0.1;
#declare cactus2Body =

isosurface {
	function {
		f_r(x, y*0.35, z) - 1 - sqrt(x*x + z*z)*0.2
		- (sinw(atan2(x, z)*Ridges)*RidgeDepth)
	}
	threshold 0
	max_gradient 5
	contained_by {sphere {< 0, 0, 0>, 3.1}}
	texture {
		pigment {color rgb < 0.3, 0.65, 0.4>}
		normal {bozo 0.1 scale < 1, 0.15, 1>}
	}
}

#declare Cactus2 =
union {
	object {cactus2Body}
	object {MakeSpineRows(cactus2Body, < 1, 3, 1>, 1, Ridges, 64, 3, 1, 0.5, 0.01)
		texture {pigment {color rgb < 0.98, 0.98, 0.5>}}
	}
	translate y*2
}



#declare Ridges = 75;
#declare RidgeDepth = 0.05;
#declare cactus3Body =

isosurface {
	function {
		sqrt(x*x + pow((y/1.5),2) + z*z) - 1 - sqrt(x*x + z*z)*0.2
		- (sinw(atan2(x, z)*Ridges)*RidgeDepth)
	}
	threshold 0
	max_gradient 5
	contained_by {sphere {< 0, 0, 0>, 3.1}}
	texture {
		pigment {color rgb < 0.1, 0.5, 0.25>}
		normal {bozo 0.1 scale 0.15}
	}
}
#declare Cactus3 =
union {
	object {cactus3Body}
	object {MakeSpineRows(cactus3Body, < 1, 1.5, 1>, 1, Ridges, 24, 5, 1, 0.35, 0.01)
		texture {pigment {color rgb < 0.98, 0.98, 0.85>}}
	}
	translate y*1.25
}

object {Cactus1 translate < 3, 0,-3>}
object {Cactus2}
object {Cactus3 translate <-2, 0,-3.5>}

//----------------------------------------

</textarea>


<!-- Sample file : quilt1.pov -->

<textarea id="quilt1.pov" name="quilt1.pov" style="display:none;">
// This work is licensed under the Creative Commons Attribution-ShareAlike 3.0 Unported License.
// To view a copy of this license, visit http://creativecommons.org/licenses/by-sa/3.0/ or send a
// letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.

// Persistence Of Vision raytracer sample file.
// Demonstrates quilted normals
// Updated: 2013/02/15 for 3.7
//
// -w320 -h240
// -w800 -h600 +a0.3

#version 3.7;

global_settings {
  assumed_gamma 2.2
  }

 #include "colors.inc"
 #include "textures.inc"
 #include "shapes.inc"

 camera {
   location <-5, 6, -13>
   angle 40 //   direction <0, 0, 2>
   right x*image_width/image_height // keep propotions with any aspect ratio
   look_at <0, 0, 0>
 }

 light_source { < -10, 0.5, -4> colour SkyBlue }
 light_source { < 10, 20, -2> colour Gray90
     area_light <4 0 0> <0 0 4> 10 10
     adaptive 1
     jitter

 }

 // Sky
 sphere {
   <0, 0, 0>, 1
   hollow on
   texture {
     pigment {
       gradient y
       color_map {[0, 1 color White color SkyBlue]}
     }
     finish {ambient 1 diffuse 0}
   }
   scale 100000
 }

 #declare X_Scale = 100;
 union {
     plane { z, 0 hollow on}
     plane { y, 0 inverse }
     cylinder { <-2*X_Scale, 1, -1>,<2*X_Scale, 1, -1>, 1
         clipped_by { box { <-X_Scale, 0, -1> <X_Scale, 1, 0> }}
     }
     texture {
         normal { quilted 1 }
         pigment { checker color SkyBlue color Wheat }
         finish {  Shiny }
     scale <0.5,0.5,0.5>
     translate y*100
     translate .1
     }
     clipped_by { box { <-X_Scale+0.1, -0.1, -10000> <X_Scale+0.1, 1000, 1> }}
     rotate -y*2
 }

 sphere { <0, 1, 0>, 2
     texture {
         pigment { White }
         finish { Mirror }
         normal { quilted 1  control0 0.5  control1 1
             scale 0.45
             turbulence 0.5
             lambda 0.5
             omega 0.707
             octaves 4
         }
     }
     translate <-2, 1, -4>
 }


</textarea>


<!-- Sample file : sombrero.pov -->

<textarea id="sombrero.pov" name="sombrero.pov" style="display:none;">
// This work is licensed under the Creative Commons Attribution-ShareAlike 3.0 Unported License.
// To view a copy of this license, visit http://creativecommons.org/licenses/by-sa/3.0/ or send a
// letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.

// Persistence Of Vision raytracer sample file.
// File: Sombrero.POV
// Desc: Create the famous Sinusoidal rippled surface,
//       using a 3-D sheet of spheres.
//       Shows off the use of the while loop for creating a surface,
//       and for smoothly changing colors.
// Date: 10/1/95
// Auth: Eduard Schwan
// Updated: 2013/02/15 for 3.7
//
// -w320 -h240
// -w800 -h600 +a0.3

#version 3.7;
global_settings { assumed_gamma 1.0 }

// ------------------------------------------------------------------
// Look down at an angle at our creation
camera
{
  location  <0,1.5,-2>
  angle 60 // direction 1.1*z
  right x*image_width/image_height // keep propotions with any aspect ratio
  look_at   <0,-0.2,0>
}


// ------------------------------------------------------------------
// Simple background for a simple scene
background { color rgb <0.9, 0.87, 0.85>*0.1}


// ------------------------------------------------------------------
// A light source
light_source { <20, 20, -10> colour 1 }


// ------------------------------------------------------------------
// create a simple shape to use as a dot
#declare BasicShape = sphere {  0, 1 }


// ------------------------------------------------------------------
// Set up the loop variables:
// the Xc & Zc variables will go from -1.0 to +1.0
// in NumIterations loops.
#declare NumIterations = 8; // try 6 to 16
#declare Increment     = 1.0/(NumIterations*2);


// ------------------------------------------------------------------
// Create a surface built from our basic shape
// Zc goes from -1 to +1
#declare Zc = -1.0;
#while (Zc<=1.0)
  union
  {

  // Xc goes from -1 to +1
  #declare Xc = -1.0;
  #while (Xc<=1.0)
    // precalculate height, since it is used several places below
    #declare YHeight = sin(sqrt(Xc*Xc+Zc*Zc)*6.28*2);
    object
    {
      BasicShape scale Increment
      translate <Xc, YHeight/4, Zc>
      texture
      {
        // colors change across the object, and also go from black
        // in the valleys to full saturation at the peaks
        pigment { color rgb <Xc/2+1, 1-Zc/2, YHeight/2+1>*YHeight }
        finish { ambient 0.2 specular 0.5 roughness 0.05 reflection 0.2}
      }
    }
    // manually increment our counter inside the loop
    #declare Xc=Xc+Increment;
  #end
  }

  // manually increment our counters inside the loop
  #declare Zc=Zc+Increment;

#end



</textarea>


<!-- Sample file : archimedean_example.pov-->

<textarea id="archimedean_example.pov" name="archimedean_example.pov" style="display:none;">
// Example file for using archimedean_solids.inc
// Bill Pragnell 2009
//
// This file is licensed under the terms of the CC-LGPL 

/* -------------------
archimedean_solids.inc

Original vertex and face index data by George W. Hart:
http://www.georgehart.com/virtual-polyhedra/vp.html

Skeleton edges and POV-Ray conversion by Bill Pragnell, 2009
This file is licensed under the terms of the CC-LGPL

This file defines the following polyhedra:

  Archimedean_truncated_tetrahedron (12 vertices)
  Archimedean_cuboctahedron (12 vertices)
  Archimedean_truncated_cube (24 vertices)
  Archimedean_truncated_octahedron (24 vertices)
  Archimedean_rhombicuboctahedron (24 vertices)
  Archimedean_truncated_cuboctahedron (48 vertices)
  Archimedean_snub_cuboctahedron (24 vertices) (2 chiral forms)
  Archimedean_icosidodecahedron (30 vertices)
  Archimedean_truncated_dodecahedron (60 vertices)
  Archimedean_truncated_icosahedron (60 vertices)
  Archimedean_rhombicosidodecahedron (60 vertices)
  Archimedean_truncated_icosidodecahedron (120 vertices)
  Archimedean_snub_icosidodecahedron (60 vertices) (2 chiral forms)

-------------------- */

#include "transforms.inc"

#declare Archimedean_truncated_tetrahedron_verts = array[12]
{
<0, 0, 1.105542>,
<0.8528029, 0, 0.7035265>,
<-0.7106691, 0.4714045, 0.7035265>,
<0.3316456, -0.7856742, 0.7035265>,
<0.9949367, 0.4714045, -0.1005038>,
<-1.089693, 0.1571348, -0.1005038>,
<-0.5685352, 0.942809, -0.1005038>,
<-0.04737794, -1.099944, -0.1005038>,
<0.6159132, 0.1571348, -0.904534>,
<0.2842676, 0.942809, -0.5025189>,
<-0.758047, -0.6285394, -0.5025189>,
<0.09475587, -0.6285394, -0.904534>,
}
#local P0 = Archimedean_truncated_tetrahedron_verts[5];
#local P1 = Archimedean_truncated_tetrahedron_verts[6];
#local P2 = Archimedean_truncated_tetrahedron_verts[9];
#local V1 = P1 - P0;
#local V2 = P2 - P0;
#local Axis = vcross(V2, V1);
#local Tran1 = transform { Reorient_Trans(Axis, y) }
#local TV1 = vtransform(V1, Tran1);
#local The_Tran = transform {
 Reorient_Trans(Axis, y)
 Reorient_Trans(TV1, x) }
#local Num = 0;
#while (Num < 12)
 #declare Archimedean_truncated_tetrahedron_verts[Num] = vtransform(Archimedean_truncated_tetrahedron_verts[Num], The_Tran);
 #local Num = Num + 1;
#end

#macro Archimedean_truncated_tetrahedron_faces(Tex3, Tex6, OnPlane)
#local Archimedean_truncated_tetrahedron_obj = mesh2 {
 vertex_vectors {
  12,
  Archimedean_truncated_tetrahedron_verts[0],
  Archimedean_truncated_tetrahedron_verts[1],
  Archimedean_truncated_tetrahedron_verts[2],
  Archimedean_truncated_tetrahedron_verts[3],
  Archimedean_truncated_tetrahedron_verts[4],
  Archimedean_truncated_tetrahedron_verts[5],
  Archimedean_truncated_tetrahedron_verts[6],
  Archimedean_truncated_tetrahedron_verts[7],
  Archimedean_truncated_tetrahedron_verts[8],
  Archimedean_truncated_tetrahedron_verts[9],
  Archimedean_truncated_tetrahedron_verts[10],
  Archimedean_truncated_tetrahedron_verts[11]
 }
 texture_list {
  2,
  texture { Tex3 },
  texture { Tex6 }
 }
 face_indices {
  20,
  <0, 3, 1>, 0,
  <2, 6, 5>, 0,
  <4, 8, 9>, 0,
  <7, 10, 11>, 0,
  <0, 1, 4>, 1,
  <0, 4, 9>, 1,
  <0, 9, 6>, 1,
  <0, 6, 2>, 1,
  <0, 2, 5>, 1,
  <0, 5, 10>, 1,
  <0, 10, 7>, 1,
  <0, 7, 3>, 1,
  <1, 3, 7>, 1,
  <1, 7, 11>, 1,
  <1, 11, 8>, 1,
  <1, 8, 4>, 1,
  <5, 6, 9>, 1,
  <5, 9, 8>, 1,
  <5, 8, 11>, 1,
  <5, 11, 10>, 1
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_truncated_tetrahedron_verts[5];
 #local P1 = Archimedean_truncated_tetrahedron_verts[6];
 #local P2 = Archimedean_truncated_tetrahedron_verts[9];
 #local P3 = Archimedean_truncated_tetrahedron_verts[8];
 #local P4 = Archimedean_truncated_tetrahedron_verts[11];
 #local P5 = Archimedean_truncated_tetrahedron_verts[10];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_truncated_tetrahedron_obj
  translate -(P0+P1+P2+P3+P4+P5)/6
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_truncated_tetrahedron_obj }
#end
#end

#macro Archimedean_truncated_tetrahedron_faces2(OnPlane)
#local Archimedean_truncated_tetrahedron_obj = mesh2 {
 vertex_vectors {
  12,
  Archimedean_truncated_tetrahedron_verts[0],
  Archimedean_truncated_tetrahedron_verts[1],
  Archimedean_truncated_tetrahedron_verts[2],
  Archimedean_truncated_tetrahedron_verts[3],
  Archimedean_truncated_tetrahedron_verts[4],
  Archimedean_truncated_tetrahedron_verts[5],
  Archimedean_truncated_tetrahedron_verts[6],
  Archimedean_truncated_tetrahedron_verts[7],
  Archimedean_truncated_tetrahedron_verts[8],
  Archimedean_truncated_tetrahedron_verts[9],
  Archimedean_truncated_tetrahedron_verts[10],
  Archimedean_truncated_tetrahedron_verts[11]
 }
 face_indices {
  20,
  <0, 3, 1>,
  <2, 6, 5>,
  <4, 8, 9>,
  <7, 10, 11>,
  <0, 1, 4>,
  <0, 4, 9>,
  <0, 9, 6>,
  <0, 6, 2>,
  <0, 2, 5>,
  <0, 5, 10>,
  <0, 10, 7>,
  <0, 7, 3>,
  <1, 3, 7>,
  <1, 7, 11>,
  <1, 11, 8>,
  <1, 8, 4>,
  <5, 6, 9>,
  <5, 9, 8>,
  <5, 8, 11>,
  <5, 11, 10>
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_truncated_tetrahedron_verts[5];
 #local P1 = Archimedean_truncated_tetrahedron_verts[6];
 #local P2 = Archimedean_truncated_tetrahedron_verts[9];
 #local P3 = Archimedean_truncated_tetrahedron_verts[8];
 #local P4 = Archimedean_truncated_tetrahedron_verts[11];
 #local P5 = Archimedean_truncated_tetrahedron_verts[10];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_truncated_tetrahedron_obj
  translate -(P0+P1+P2+P3+P4+P5)/6
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_truncated_tetrahedron_obj }
#end
#end

#macro Archimedean_truncated_tetrahedron_edges(RadEdg, RadVer, TexEdg, TexVer, OnPlane)
union {
 union {
  sphere { Archimedean_truncated_tetrahedron_verts[0], RadVer }
  sphere { Archimedean_truncated_tetrahedron_verts[1], RadVer }
  sphere { Archimedean_truncated_tetrahedron_verts[2], RadVer }
  sphere { Archimedean_truncated_tetrahedron_verts[3], RadVer }
  sphere { Archimedean_truncated_tetrahedron_verts[4], RadVer }
  sphere { Archimedean_truncated_tetrahedron_verts[5], RadVer }
  sphere { Archimedean_truncated_tetrahedron_verts[6], RadVer }
  sphere { Archimedean_truncated_tetrahedron_verts[7], RadVer }
  sphere { Archimedean_truncated_tetrahedron_verts[8], RadVer }
  sphere { Archimedean_truncated_tetrahedron_verts[9], RadVer }
  sphere { Archimedean_truncated_tetrahedron_verts[10], RadVer }
  sphere { Archimedean_truncated_tetrahedron_verts[11], RadVer }
  texture { TexVer } }
 union {
  cylinder { Archimedean_truncated_tetrahedron_verts[0], Archimedean_truncated_tetrahedron_verts[3], RadEdg }
  cylinder { Archimedean_truncated_tetrahedron_verts[3], Archimedean_truncated_tetrahedron_verts[1], RadEdg }
  cylinder { Archimedean_truncated_tetrahedron_verts[1], Archimedean_truncated_tetrahedron_verts[0], RadEdg }
  cylinder { Archimedean_truncated_tetrahedron_verts[2], Archimedean_truncated_tetrahedron_verts[6], RadEdg }
  cylinder { Archimedean_truncated_tetrahedron_verts[6], Archimedean_truncated_tetrahedron_verts[5], RadEdg }
  cylinder { Archimedean_truncated_tetrahedron_verts[5], Archimedean_truncated_tetrahedron_verts[2], RadEdg }
  cylinder { Archimedean_truncated_tetrahedron_verts[4], Archimedean_truncated_tetrahedron_verts[8], RadEdg }
  cylinder { Archimedean_truncated_tetrahedron_verts[8], Archimedean_truncated_tetrahedron_verts[9], RadEdg }
  cylinder { Archimedean_truncated_tetrahedron_verts[9], Archimedean_truncated_tetrahedron_verts[4], RadEdg }
  cylinder { Archimedean_truncated_tetrahedron_verts[7], Archimedean_truncated_tetrahedron_verts[10], RadEdg }
  cylinder { Archimedean_truncated_tetrahedron_verts[10], Archimedean_truncated_tetrahedron_verts[11], RadEdg }
  cylinder { Archimedean_truncated_tetrahedron_verts[11], Archimedean_truncated_tetrahedron_verts[7], RadEdg }
  cylinder { Archimedean_truncated_tetrahedron_verts[1], Archimedean_truncated_tetrahedron_verts[4], RadEdg }
  cylinder { Archimedean_truncated_tetrahedron_verts[9], Archimedean_truncated_tetrahedron_verts[6], RadEdg }
  cylinder { Archimedean_truncated_tetrahedron_verts[2], Archimedean_truncated_tetrahedron_verts[0], RadEdg }
  cylinder { Archimedean_truncated_tetrahedron_verts[5], Archimedean_truncated_tetrahedron_verts[10], RadEdg }
  cylinder { Archimedean_truncated_tetrahedron_verts[7], Archimedean_truncated_tetrahedron_verts[3], RadEdg }
  cylinder { Archimedean_truncated_tetrahedron_verts[11], Archimedean_truncated_tetrahedron_verts[8], RadEdg }
  texture { TexEdg } }
#if (OnPlane)
 #local P0 = Archimedean_truncated_tetrahedron_verts[5];
 #local P1 = Archimedean_truncated_tetrahedron_verts[6];
 #local P2 = Archimedean_truncated_tetrahedron_verts[9];
 #local P3 = Archimedean_truncated_tetrahedron_verts[8];
 #local P4 = Archimedean_truncated_tetrahedron_verts[11];
 #local P5 = Archimedean_truncated_tetrahedron_verts[10];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
  translate -(P0+P1+P2+P3+P4+P5)/6
  Reorient_Trans(Axis, y)
  translate y*max(RadEdg, RadVer)
#end
 }
#end

#declare Archimedean_cuboctahedron_verts = array[12]
{
<0, 0, 1.154701>,
<1., 0, 0.5773503>,
<0.3333333, 0.942809, 0.5773503>,
<-1., 0, 0.5773503>,
<-0.3333333, -0.942809, 0.5773503>,
<1., 0, -0.5773503>,
<0.6666667, -0.942809, 0>,
<-0.6666667, 0.942809, 0>,
<0.3333333, 0.942809, -0.5773503>,
<-1., 0, -0.5773503>,
<-0.3333333, -0.942809, -0.5773503>,
<0, 0, -1.154701>,
}
#local P0 = Archimedean_cuboctahedron_verts[7];
#local P1 = Archimedean_cuboctahedron_verts[8];
#local P2 = Archimedean_cuboctahedron_verts[11];
#local V1 = P1 - P0;
#local V2 = P2 - P0;
#local Axis = vcross(V2, V1);
#local Tran1 = transform { Reorient_Trans(Axis, y) }
#local TV1 = vtransform(V1, Tran1);
#local The_Tran = transform {
 Reorient_Trans(Axis, y)
 Reorient_Trans(TV1, x) }
#local Num = 0;
#while (Num < 12)
 #declare Archimedean_cuboctahedron_verts[Num] = vtransform(Archimedean_cuboctahedron_verts[Num], The_Tran);
 #local Num = Num + 1;
#end

#macro Archimedean_cuboctahedron_faces(Tex3, Tex4, OnPlane)
#local Archimedean_cuboctahedron_obj = mesh2 {
 vertex_vectors {
  12,
  Archimedean_cuboctahedron_verts[0],
  Archimedean_cuboctahedron_verts[1],
  Archimedean_cuboctahedron_verts[2],
  Archimedean_cuboctahedron_verts[3],
  Archimedean_cuboctahedron_verts[4],
  Archimedean_cuboctahedron_verts[5],
  Archimedean_cuboctahedron_verts[6],
  Archimedean_cuboctahedron_verts[7],
  Archimedean_cuboctahedron_verts[8],
  Archimedean_cuboctahedron_verts[9],
  Archimedean_cuboctahedron_verts[10],
  Archimedean_cuboctahedron_verts[11]
 }
 texture_list {
  2,
  texture { Tex3 },
  texture { Tex4 }
 }
 face_indices {
  20,
  <0, 1, 2>, 0,
  <0, 3, 4>, 0,
  <1, 6, 5>, 0,
  <2, 8, 7>, 0,
  <3, 7, 9>, 0,
  <4, 10, 6>, 0,
  <5, 11, 8>, 0,
  <9, 11, 10>, 0,
  <0, 2, 7>, 1,
  <0, 7, 3>, 1,
  <0, 4, 6>, 1,
  <0, 6, 1>, 1,
  <1, 5, 8>, 1,
  <1, 8, 2>, 1,
  <3, 9, 10>, 1,
  <3, 10, 4>, 1,
  <5, 6, 10>, 1,
  <5, 10, 11>, 1,
  <7, 8, 11>, 1,
  <7, 11, 9>, 1
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_cuboctahedron_verts[7];
 #local P1 = Archimedean_cuboctahedron_verts[8];
 #local P2 = Archimedean_cuboctahedron_verts[11];
 #local P3 = Archimedean_cuboctahedron_verts[9];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_cuboctahedron_obj
  translate -(P0+P1+P2+P3)/4
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_cuboctahedron_obj }
#end
#end

#macro Archimedean_cuboctahedron_faces2(OnPlane)
#local Archimedean_cuboctahedron_obj = mesh2 {
 vertex_vectors {
  12,
  Archimedean_cuboctahedron_verts[0],
  Archimedean_cuboctahedron_verts[1],
  Archimedean_cuboctahedron_verts[2],
  Archimedean_cuboctahedron_verts[3],
  Archimedean_cuboctahedron_verts[4],
  Archimedean_cuboctahedron_verts[5],
  Archimedean_cuboctahedron_verts[6],
  Archimedean_cuboctahedron_verts[7],
  Archimedean_cuboctahedron_verts[8],
  Archimedean_cuboctahedron_verts[9],
  Archimedean_cuboctahedron_verts[10],
  Archimedean_cuboctahedron_verts[11]
 }
 face_indices {
  20,
  <0, 1, 2>,
  <0, 3, 4>,
  <1, 6, 5>,
  <2, 8, 7>,
  <3, 7, 9>,
  <4, 10, 6>,
  <5, 11, 8>,
  <9, 11, 10>,
  <0, 2, 7>,
  <0, 7, 3>,
  <0, 4, 6>,
  <0, 6, 1>,
  <1, 5, 8>,
  <1, 8, 2>,
  <3, 9, 10>,
  <3, 10, 4>,
  <5, 6, 10>,
  <5, 10, 11>,
  <7, 8, 11>,
  <7, 11, 9>
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_cuboctahedron_verts[7];
 #local P1 = Archimedean_cuboctahedron_verts[8];
 #local P2 = Archimedean_cuboctahedron_verts[11];
 #local P3 = Archimedean_cuboctahedron_verts[9];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_cuboctahedron_obj
  translate -(P0+P1+P2+P3)/4
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_cuboctahedron_obj }
#end
#end

#macro Archimedean_cuboctahedron_edges(RadEdg, RadVer, TexEdg, TexVer, OnPlane)
union {
 union {
  sphere { Archimedean_cuboctahedron_verts[0], RadVer }
  sphere { Archimedean_cuboctahedron_verts[1], RadVer }
  sphere { Archimedean_cuboctahedron_verts[2], RadVer }
  sphere { Archimedean_cuboctahedron_verts[3], RadVer }
  sphere { Archimedean_cuboctahedron_verts[4], RadVer }
  sphere { Archimedean_cuboctahedron_verts[5], RadVer }
  sphere { Archimedean_cuboctahedron_verts[6], RadVer }
  sphere { Archimedean_cuboctahedron_verts[7], RadVer }
  sphere { Archimedean_cuboctahedron_verts[8], RadVer }
  sphere { Archimedean_cuboctahedron_verts[9], RadVer }
  sphere { Archimedean_cuboctahedron_verts[10], RadVer }
  sphere { Archimedean_cuboctahedron_verts[11], RadVer }
  texture { TexVer } }
 union {
  cylinder { Archimedean_cuboctahedron_verts[0], Archimedean_cuboctahedron_verts[1], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[1], Archimedean_cuboctahedron_verts[2], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[2], Archimedean_cuboctahedron_verts[0], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[0], Archimedean_cuboctahedron_verts[3], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[3], Archimedean_cuboctahedron_verts[4], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[4], Archimedean_cuboctahedron_verts[0], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[1], Archimedean_cuboctahedron_verts[6], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[6], Archimedean_cuboctahedron_verts[5], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[5], Archimedean_cuboctahedron_verts[1], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[2], Archimedean_cuboctahedron_verts[8], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[8], Archimedean_cuboctahedron_verts[7], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[7], Archimedean_cuboctahedron_verts[2], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[3], Archimedean_cuboctahedron_verts[7], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[7], Archimedean_cuboctahedron_verts[9], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[9], Archimedean_cuboctahedron_verts[3], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[4], Archimedean_cuboctahedron_verts[10], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[10], Archimedean_cuboctahedron_verts[6], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[6], Archimedean_cuboctahedron_verts[4], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[5], Archimedean_cuboctahedron_verts[11], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[11], Archimedean_cuboctahedron_verts[8], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[8], Archimedean_cuboctahedron_verts[5], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[9], Archimedean_cuboctahedron_verts[11], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[11], Archimedean_cuboctahedron_verts[10], RadEdg }
  cylinder { Archimedean_cuboctahedron_verts[10], Archimedean_cuboctahedron_verts[9], RadEdg }
  texture { TexEdg } }
#if (OnPlane)
 #local P0 = Archimedean_cuboctahedron_verts[7];
 #local P1 = Archimedean_cuboctahedron_verts[8];
 #local P2 = Archimedean_cuboctahedron_verts[11];
 #local P3 = Archimedean_cuboctahedron_verts[9];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
  translate -(P0+P1+P2+P3)/4
  Reorient_Trans(Axis, y)
  translate y*max(RadEdg, RadVer)
#end
 }
#end

#declare Archimedean_truncated_cube_verts = array[24]
{
<0, 0, 1.042011>,
<0.5621693, 0, 0.8773552>,
<-0.4798415, 0.2928932, 0.8773552>,
<0.2569714, -0.5, 0.8773552>,
<0.8773552, 0.2928932, 0.4798415>,
<-0.9014684, 0.2071068, 0.4798415>,
<-0.5962706, 0.7071068, 0.4798415>,
<0.1405423, -0.9142136, 0.4798415>,
<1.017898, 0.2071068, -0.08232778>,
<0.7609261, 0.7071068, 0.08232778>,
<-1.017898, -0.2071068, 0.08232778>,
<-0.2810846, 1., 0.08232778>,
<-0.2810846, -1., 0.08232778>,
<0.2810846, -1., -0.08232778>,
<0.9014684, -0.2071068, -0.4798415>,
<0.2810846, 1., -0.08232778>,
<-0.7609261, -0.7071068, -0.08232778>,
<-0.8773552, -0.2928932, -0.4798415>,
<-0.1405423, 0.9142136, -0.4798415>,
<0.5962706, -0.7071068, -0.4798415>,
<0.4798415, -0.2928932, -0.8773552>,
<-0.5621693, 0, -0.8773552>,
<-0.2569714, 0.5, -0.8773552>,
<0, 0, -1.042011>
}
#local P0 = Archimedean_truncated_cube_verts[12];
#local P1 = Archimedean_truncated_cube_verts[16];
#local P2 = Archimedean_truncated_cube_verts[17];
#local V1 = P1 - P0;
#local V2 = P2 - P0;
#local Axis = vcross(V2, V1);
#local Tran1 = transform { Reorient_Trans(Axis, y) }
#local TV1 = vtransform(V1, Tran1);
#local The_Tran = transform {
 Reorient_Trans(Axis, y)
 Reorient_Trans(TV1, x) }
#local Num = 0;
#while (Num < 24)
 #declare Archimedean_truncated_cube_verts[Num] = vtransform(Archimedean_truncated_cube_verts[Num], The_Tran);
 #local Num = Num + 1;
#end

#macro Archimedean_truncated_cube_faces(Tex3, Tex8, OnPlane)
#local Archimedean_truncated_cube_obj = mesh2 {
 vertex_vectors {
  24,
  Archimedean_truncated_cube_verts[0],
  Archimedean_truncated_cube_verts[1],
  Archimedean_truncated_cube_verts[2],
  Archimedean_truncated_cube_verts[3],
  Archimedean_truncated_cube_verts[4],
  Archimedean_truncated_cube_verts[5],
  Archimedean_truncated_cube_verts[6],
  Archimedean_truncated_cube_verts[7],
  Archimedean_truncated_cube_verts[8],
  Archimedean_truncated_cube_verts[9],
  Archimedean_truncated_cube_verts[10],
  Archimedean_truncated_cube_verts[11],
  Archimedean_truncated_cube_verts[12],
  Archimedean_truncated_cube_verts[13],
  Archimedean_truncated_cube_verts[14],
  Archimedean_truncated_cube_verts[15],
  Archimedean_truncated_cube_verts[16],
  Archimedean_truncated_cube_verts[17],
  Archimedean_truncated_cube_verts[18],
  Archimedean_truncated_cube_verts[19],
  Archimedean_truncated_cube_verts[20],
  Archimedean_truncated_cube_verts[21],
  Archimedean_truncated_cube_verts[22],
  Archimedean_truncated_cube_verts[23]
 }
 texture_list {
  2,
  texture { Tex3 },
  texture { Tex8 }
 }
 face_indices {
  44,
  <0, 3, 1>, 0,
  <2, 6, 5>, 0,
  <4, 8, 9>, 0,
  <7, 12, 13>, 0,
  <10, 17, 16>, 0,
  <11, 15, 18>, 0,
  <14, 19, 20>, 0,
  <21, 22, 23>, 0,
  <0, 1, 4>, 1,
  <0, 4, 9>, 1,
  <0, 9, 15>, 1,
  <0, 15, 11>, 1,
  <0, 11, 6>, 1,
  <0, 6, 2>, 1,
  <0, 2, 5>, 1,
  <0, 5, 10>, 1,
  <0, 10, 16>, 1,
  <0, 16, 12>, 1,
  <0, 12, 7>, 1,
  <0, 7, 3>, 1,
  <1, 3, 7>, 1,
  <1, 7, 13>, 1,
  <1, 13, 19>, 1,
  <1, 19, 14>, 1,
  <1, 14, 8>, 1,
  <1, 8, 4>, 1,
  <5, 6, 11>, 1,
  <5, 11, 18>, 1,
  <5, 18, 22>, 1,
  <5, 22, 21>, 1,
  <5, 21, 17>, 1,
  <5, 17, 10>, 1,
  <8, 14, 20>, 1,
  <8, 20, 23>, 1,
  <8, 23, 22>, 1,
  <8, 22, 18>, 1,
  <8, 18, 15>, 1,
  <8, 15, 9>, 1,
  <12, 16, 17>, 1,
  <12, 17, 21>, 1,
  <12, 21, 23>, 1,
  <12, 23, 20>, 1,
  <12, 20, 19>, 1,
  <12, 19, 13>, 1
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_truncated_cube_verts[12];
 #local P1 = Archimedean_truncated_cube_verts[16];
 #local P2 = Archimedean_truncated_cube_verts[17];
 #local P3 = Archimedean_truncated_cube_verts[21];
 #local P4 = Archimedean_truncated_cube_verts[23];
 #local P5 = Archimedean_truncated_cube_verts[20];
 #local P6 = Archimedean_truncated_cube_verts[19];
 #local P7 = Archimedean_truncated_cube_verts[13];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_truncated_cube_obj
  translate -(P0+P1+P2+P3+P4+P5+P6+P7)/8
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_truncated_cube_obj }
#end
#end

#macro Archimedean_truncated_cube_faces2(OnPlane)
#local Archimedean_truncated_cube_obj = mesh2 {
 vertex_vectors {
  24,
  Archimedean_truncated_cube_verts[0],
  Archimedean_truncated_cube_verts[1],
  Archimedean_truncated_cube_verts[2],
  Archimedean_truncated_cube_verts[3],
  Archimedean_truncated_cube_verts[4],
  Archimedean_truncated_cube_verts[5],
  Archimedean_truncated_cube_verts[6],
  Archimedean_truncated_cube_verts[7],
  Archimedean_truncated_cube_verts[8],
  Archimedean_truncated_cube_verts[9],
  Archimedean_truncated_cube_verts[10],
  Archimedean_truncated_cube_verts[11],
  Archimedean_truncated_cube_verts[12],
  Archimedean_truncated_cube_verts[13],
  Archimedean_truncated_cube_verts[14],
  Archimedean_truncated_cube_verts[15],
  Archimedean_truncated_cube_verts[16],
  Archimedean_truncated_cube_verts[17],
  Archimedean_truncated_cube_verts[18],
  Archimedean_truncated_cube_verts[19],
  Archimedean_truncated_cube_verts[20],
  Archimedean_truncated_cube_verts[21],
  Archimedean_truncated_cube_verts[22],
  Archimedean_truncated_cube_verts[23]
 }
 face_indices {
  44,
  <0, 3, 1>,
  <2, 6, 5>,
  <4, 8, 9>,
  <7, 12, 13>,
  <10, 17, 16>,
  <11, 15, 18>,
  <14, 19, 20>,
  <21, 22, 23>,
  <0, 1, 4>,
  <0, 4, 9>,
  <0, 9, 15>,
  <0, 15, 11>,
  <0, 11, 6>,
  <0, 6, 2>,
  <0, 2, 5>,
  <0, 5, 10>,
  <0, 10, 16>,
  <0, 16, 12>,
  <0, 12, 7>,
  <0, 7, 3>,
  <1, 3, 7>,
  <1, 7, 13>,
  <1, 13, 19>,
  <1, 19, 14>,
  <1, 14, 8>,
  <1, 8, 4>,
  <5, 6, 11>,
  <5, 11, 18>,
  <5, 18, 22>,
  <5, 22, 21>,
  <5, 21, 17>,
  <5, 17, 10>,
  <8, 14, 20>,
  <8, 20, 23>,
  <8, 23, 22>,
  <8, 22, 18>,
  <8, 18, 15>,
  <8, 15, 9>,
  <12, 16, 17>,
  <12, 17, 21>,
  <12, 21, 23>,
  <12, 23, 20>,
  <12, 20, 19>,
  <12, 19, 13>
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_truncated_cube_verts[12];
 #local P1 = Archimedean_truncated_cube_verts[16];
 #local P2 = Archimedean_truncated_cube_verts[17];
 #local P3 = Archimedean_truncated_cube_verts[21];
 #local P4 = Archimedean_truncated_cube_verts[23];
 #local P5 = Archimedean_truncated_cube_verts[20];
 #local P6 = Archimedean_truncated_cube_verts[19];
 #local P7 = Archimedean_truncated_cube_verts[13];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_truncated_cube_obj
  translate -(P0+P1+P2+P3+P4+P5+P6+P7)/8
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_truncated_cube_obj }
#end
#end

#macro Archimedean_truncated_cube_edges(RadEdg, RadVer, TexEdg, TexVer, OnPlane)
union {
 union {
  sphere { Archimedean_truncated_cube_verts[0], RadVer }
  sphere { Archimedean_truncated_cube_verts[1], RadVer }
  sphere { Archimedean_truncated_cube_verts[2], RadVer }
  sphere { Archimedean_truncated_cube_verts[3], RadVer }
  sphere { Archimedean_truncated_cube_verts[4], RadVer }
  sphere { Archimedean_truncated_cube_verts[5], RadVer }
  sphere { Archimedean_truncated_cube_verts[6], RadVer }
  sphere { Archimedean_truncated_cube_verts[7], RadVer }
  sphere { Archimedean_truncated_cube_verts[8], RadVer }
  sphere { Archimedean_truncated_cube_verts[9], RadVer }
  sphere { Archimedean_truncated_cube_verts[10], RadVer }
  sphere { Archimedean_truncated_cube_verts[11], RadVer }
  sphere { Archimedean_truncated_cube_verts[12], RadVer }
  sphere { Archimedean_truncated_cube_verts[13], RadVer }
  sphere { Archimedean_truncated_cube_verts[14], RadVer }
  sphere { Archimedean_truncated_cube_verts[15], RadVer }
  sphere { Archimedean_truncated_cube_verts[16], RadVer }
  sphere { Archimedean_truncated_cube_verts[17], RadVer }
  sphere { Archimedean_truncated_cube_verts[18], RadVer }
  sphere { Archimedean_truncated_cube_verts[19], RadVer }
  sphere { Archimedean_truncated_cube_verts[20], RadVer }
  sphere { Archimedean_truncated_cube_verts[21], RadVer }
  sphere { Archimedean_truncated_cube_verts[22], RadVer }
  sphere { Archimedean_truncated_cube_verts[23], RadVer }
  texture { TexVer } }
 union {
  cylinder { Archimedean_truncated_cube_verts[0], Archimedean_truncated_cube_verts[3], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[3], Archimedean_truncated_cube_verts[1], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[1], Archimedean_truncated_cube_verts[0], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[2], Archimedean_truncated_cube_verts[6], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[6], Archimedean_truncated_cube_verts[5], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[5], Archimedean_truncated_cube_verts[2], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[4], Archimedean_truncated_cube_verts[8], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[8], Archimedean_truncated_cube_verts[9], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[9], Archimedean_truncated_cube_verts[4], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[7], Archimedean_truncated_cube_verts[12], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[12], Archimedean_truncated_cube_verts[13], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[13], Archimedean_truncated_cube_verts[7], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[10], Archimedean_truncated_cube_verts[17], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[17], Archimedean_truncated_cube_verts[16], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[16], Archimedean_truncated_cube_verts[10], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[11], Archimedean_truncated_cube_verts[15], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[15], Archimedean_truncated_cube_verts[18], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[18], Archimedean_truncated_cube_verts[11], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[14], Archimedean_truncated_cube_verts[19], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[19], Archimedean_truncated_cube_verts[20], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[20], Archimedean_truncated_cube_verts[14], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[21], Archimedean_truncated_cube_verts[22], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[22], Archimedean_truncated_cube_verts[23], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[23], Archimedean_truncated_cube_verts[21], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[1], Archimedean_truncated_cube_verts[4], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[9], Archimedean_truncated_cube_verts[15], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[11], Archimedean_truncated_cube_verts[6], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[2], Archimedean_truncated_cube_verts[0], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[5], Archimedean_truncated_cube_verts[10], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[16], Archimedean_truncated_cube_verts[12], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[7], Archimedean_truncated_cube_verts[3], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[13], Archimedean_truncated_cube_verts[19], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[14], Archimedean_truncated_cube_verts[8], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[18], Archimedean_truncated_cube_verts[22], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[21], Archimedean_truncated_cube_verts[17], RadEdg }
  cylinder { Archimedean_truncated_cube_verts[20], Archimedean_truncated_cube_verts[23], RadEdg }
  texture { TexEdg } }
#if (OnPlane)
 #local P0 = Archimedean_truncated_cube_verts[12];
 #local P1 = Archimedean_truncated_cube_verts[16];
 #local P2 = Archimedean_truncated_cube_verts[17];
 #local P3 = Archimedean_truncated_cube_verts[21];
 #local P4 = Archimedean_truncated_cube_verts[23];
 #local P5 = Archimedean_truncated_cube_verts[20];
 #local P6 = Archimedean_truncated_cube_verts[19];
 #local P7 = Archimedean_truncated_cube_verts[13];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
  translate -(P0+P1+P2+P3+P4+P5+P6+P7)/8
  Reorient_Trans(Axis, y)
  translate y*max(RadEdg, RadVer)
#end
 }
#end

#declare Archimedean_truncated_octahedron_verts = array[24]
{
<0, 0, 1.054093>,
<0.6324555, 0, 0.843274>,
<-0.421637, 0.4714045, 0.843274>,
<-0.07027284, -0.6285394, 0.843274>,
<0.843274, 0.4714045, 0.421637>,
<0.5621827, -0.6285394, 0.6324555>,
<-0.9135469, 0.3142697, 0.421637>,
<-0.2108185, 0.942809, 0.421637>,
<-0.5621827, -0.7856742, 0.421637>,
<0.9838197, 0.3142697, -0.2108185>,
<0.421637, 0.942809, 0.2108185>,
<0.7027284, -0.7856742, 0>,
<-0.7027284, 0.7856742, 0>,
<-0.9838197, -0.3142697, 0.2108185>,
<-0.421637, -0.942809, -0.2108185>,
<0.5621827, 0.7856742, -0.421637>,
<0.9135469, -0.3142697, -0.421637>,
<0.2108185, -0.942809, -0.421637>,
<-0.5621827, 0.6285394, -0.6324555>,
<-0.843274, -0.4714045, -0.421637>,
<0.07027284, 0.6285394, -0.843274>,
<0.421637, -0.4714045, -0.843274>,
<-0.6324555, 0, -0.843274>,
<0, 0, -1.054093>
}
#local P0 = Archimedean_truncated_octahedron_verts[0];
#local P1 = Archimedean_truncated_octahedron_verts[1];
#local P2 = Archimedean_truncated_octahedron_verts[3];
#local V1 = P1 - P0;
#local V2 = P2 - P0;
#local Axis = vcross(V2, V1);
#local Tran1 = transform { Reorient_Trans(Axis, y) }
#local TV1 = vtransform(V1, Tran1);
#local The_Tran = transform {
 Reorient_Trans(Axis, y)
 Reorient_Trans(TV1, x) }
#local Num = 0;
#while (Num < 24)
 #declare Archimedean_truncated_octahedron_verts[Num] = vtransform(Archimedean_truncated_octahedron_verts[Num], The_Tran);
 #local Num = Num + 1;
#end

#macro Archimedean_truncated_octahedron_faces(Tex4, Tex6, OnPlane)
#local Archimedean_truncated_octahedron_obj = mesh2 {
 vertex_vectors {
  24,
  Archimedean_truncated_octahedron_verts[0],
  Archimedean_truncated_octahedron_verts[1],
  Archimedean_truncated_octahedron_verts[2],
  Archimedean_truncated_octahedron_verts[3],
  Archimedean_truncated_octahedron_verts[4],
  Archimedean_truncated_octahedron_verts[5],
  Archimedean_truncated_octahedron_verts[6],
  Archimedean_truncated_octahedron_verts[7],
  Archimedean_truncated_octahedron_verts[8],
  Archimedean_truncated_octahedron_verts[9],
  Archimedean_truncated_octahedron_verts[10],
  Archimedean_truncated_octahedron_verts[11],
  Archimedean_truncated_octahedron_verts[12],
  Archimedean_truncated_octahedron_verts[13],
  Archimedean_truncated_octahedron_verts[14],
  Archimedean_truncated_octahedron_verts[15],
  Archimedean_truncated_octahedron_verts[16],
  Archimedean_truncated_octahedron_verts[17],
  Archimedean_truncated_octahedron_verts[18],
  Archimedean_truncated_octahedron_verts[19],
  Archimedean_truncated_octahedron_verts[20],
  Archimedean_truncated_octahedron_verts[21],
  Archimedean_truncated_octahedron_verts[22],
  Archimedean_truncated_octahedron_verts[23]
 }
 texture_list {
  2,
  texture { Tex4 },
  texture { Tex6 }
 }
 face_indices {
  44,
  <0, 3, 5>, 0,
  <0, 5, 1>, 0,
  <2, 7, 12>, 0,
  <2, 12, 6>, 0,
  <4, 9, 15>, 0,
  <4, 15, 10>, 0,
  <8, 13, 19>, 0,
  <8, 19, 14>, 0,
  <11, 17, 21>, 0,
  <11, 21, 16>, 0,
  <18, 20, 23>, 0,
  <18, 23, 22>, 0,
  <0, 1, 4>, 1,
  <0, 4, 10>, 1,
  <0, 10, 7>, 1,
  <0, 7, 2>, 1,
  <0, 2, 6>, 1,
  <0, 6, 13>, 1,
  <0, 13, 8>, 1,
  <0, 8, 3>, 1,
  <1, 5, 11>, 1,
  <1, 11, 16>, 1,
  <1, 16, 9>, 1,
  <1, 9, 4>, 1,
  <3, 8, 14>, 1,
  <3, 14, 17>, 1,
  <3, 17, 11>, 1,
  <3, 11, 5>, 1,
  <6, 12, 18>, 1,
  <6, 18, 22>, 1,
  <6, 22, 19>, 1,
  <6, 19, 13>, 1,
  <7, 10, 15>, 1,
  <7, 15, 20>, 1,
  <7, 20, 18>, 1,
  <7, 18, 12>, 1,
  <9, 16, 21>, 1,
  <9, 21, 23>, 1,
  <9, 23, 20>, 1,
  <9, 20, 15>, 1,
  <14, 19, 22>, 1,
  <14, 22, 23>, 1,
  <14, 23, 21>, 1,
  <14, 21, 17>, 1
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_truncated_octahedron_verts[14];
 #local P1 = Archimedean_truncated_octahedron_verts[19];
 #local P2 = Archimedean_truncated_octahedron_verts[22];
 #local P3 = Archimedean_truncated_octahedron_verts[23];
 #local P4 = Archimedean_truncated_octahedron_verts[21];
 #local P5 = Archimedean_truncated_octahedron_verts[17];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_truncated_octahedron_obj
  translate -(P0+P1+P2+P3+P4+P5)/6
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_truncated_octahedron_obj }
#end
#end

#macro Archimedean_truncated_octahedron_faces2(OnPlane)
#local Archimedean_truncated_octahedron_obj = mesh2 {
 vertex_vectors {
  24,
  Archimedean_truncated_octahedron_verts[0],
  Archimedean_truncated_octahedron_verts[1],
  Archimedean_truncated_octahedron_verts[2],
  Archimedean_truncated_octahedron_verts[3],
  Archimedean_truncated_octahedron_verts[4],
  Archimedean_truncated_octahedron_verts[5],
  Archimedean_truncated_octahedron_verts[6],
  Archimedean_truncated_octahedron_verts[7],
  Archimedean_truncated_octahedron_verts[8],
  Archimedean_truncated_octahedron_verts[9],
  Archimedean_truncated_octahedron_verts[10],
  Archimedean_truncated_octahedron_verts[11],
  Archimedean_truncated_octahedron_verts[12],
  Archimedean_truncated_octahedron_verts[13],
  Archimedean_truncated_octahedron_verts[14],
  Archimedean_truncated_octahedron_verts[15],
  Archimedean_truncated_octahedron_verts[16],
  Archimedean_truncated_octahedron_verts[17],
  Archimedean_truncated_octahedron_verts[18],
  Archimedean_truncated_octahedron_verts[19],
  Archimedean_truncated_octahedron_verts[20],
  Archimedean_truncated_octahedron_verts[21],
  Archimedean_truncated_octahedron_verts[22],
  Archimedean_truncated_octahedron_verts[23]
 }
 face_indices {
  44,
  <0, 3, 5>,
  <0, 5, 1>,
  <2, 7, 12>,
  <2, 12, 6>,
  <4, 9, 15>,
  <4, 15, 10>,
  <8, 13, 19>,
  <8, 19, 14>,
  <11, 17, 21>,
  <11, 21, 16>,
  <18, 20, 23>,
  <18, 23, 22>,
  <0, 1, 4>,
  <0, 4, 10>,
  <0, 10, 7>,
  <0, 7, 2>,
  <0, 2, 6>,
  <0, 6, 13>,
  <0, 13, 8>,
  <0, 8, 3>,
  <1, 5, 11>,
  <1, 11, 16>,
  <1, 16, 9>,
  <1, 9, 4>,
  <3, 8, 14>,
  <3, 14, 17>,
  <3, 17, 11>,
  <3, 11, 5>,
  <6, 12, 18>,
  <6, 18, 22>,
  <6, 22, 19>,
  <6, 19, 13>,
  <7, 10, 15>,
  <7, 15, 20>,
  <7, 20, 18>,
  <7, 18, 12>,
  <9, 16, 21>,
  <9, 21, 23>,
  <9, 23, 20>,
  <9, 20, 15>,
  <14, 19, 22>,
  <14, 22, 23>,
  <14, 23, 21>,
  <14, 21, 17>
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_truncated_octahedron_verts[14];
 #local P1 = Archimedean_truncated_octahedron_verts[19];
 #local P2 = Archimedean_truncated_octahedron_verts[22];
 #local P3 = Archimedean_truncated_octahedron_verts[23];
 #local P4 = Archimedean_truncated_octahedron_verts[21];
 #local P5 = Archimedean_truncated_octahedron_verts[17];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_truncated_octahedron_obj
  translate -(P0+P1+P2+P3+P4+P5)/6
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_truncated_octahedron_obj }
#end
#end

#macro Archimedean_truncated_octahedron_edges(RadEdg, RadVer, TexEdg, TexVer, OnPlane)
union {
 union {
  sphere { Archimedean_truncated_octahedron_verts[0], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[1], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[2], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[3], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[4], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[5], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[6], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[7], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[8], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[9], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[10], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[11], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[12], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[13], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[14], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[15], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[16], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[17], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[18], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[19], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[20], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[21], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[22], RadVer }
  sphere { Archimedean_truncated_octahedron_verts[23], RadVer }
  texture { TexVer } }
 union {
  cylinder { Archimedean_truncated_octahedron_verts[0], Archimedean_truncated_octahedron_verts[3], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[3], Archimedean_truncated_octahedron_verts[5], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[5], Archimedean_truncated_octahedron_verts[1], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[1], Archimedean_truncated_octahedron_verts[0], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[2], Archimedean_truncated_octahedron_verts[7], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[7], Archimedean_truncated_octahedron_verts[12], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[12], Archimedean_truncated_octahedron_verts[6], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[6], Archimedean_truncated_octahedron_verts[2], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[4], Archimedean_truncated_octahedron_verts[9], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[9], Archimedean_truncated_octahedron_verts[15], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[15], Archimedean_truncated_octahedron_verts[10], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[10], Archimedean_truncated_octahedron_verts[4], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[8], Archimedean_truncated_octahedron_verts[13], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[13], Archimedean_truncated_octahedron_verts[19], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[19], Archimedean_truncated_octahedron_verts[14], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[14], Archimedean_truncated_octahedron_verts[8], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[11], Archimedean_truncated_octahedron_verts[17], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[17], Archimedean_truncated_octahedron_verts[21], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[21], Archimedean_truncated_octahedron_verts[16], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[16], Archimedean_truncated_octahedron_verts[11], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[18], Archimedean_truncated_octahedron_verts[20], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[20], Archimedean_truncated_octahedron_verts[23], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[23], Archimedean_truncated_octahedron_verts[22], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[22], Archimedean_truncated_octahedron_verts[18], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[1], Archimedean_truncated_octahedron_verts[4], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[10], Archimedean_truncated_octahedron_verts[7], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[2], Archimedean_truncated_octahedron_verts[0], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[6], Archimedean_truncated_octahedron_verts[13], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[8], Archimedean_truncated_octahedron_verts[3], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[5], Archimedean_truncated_octahedron_verts[11], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[16], Archimedean_truncated_octahedron_verts[9], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[14], Archimedean_truncated_octahedron_verts[17], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[12], Archimedean_truncated_octahedron_verts[18], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[22], Archimedean_truncated_octahedron_verts[19], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[15], Archimedean_truncated_octahedron_verts[20], RadEdg }
  cylinder { Archimedean_truncated_octahedron_verts[21], Archimedean_truncated_octahedron_verts[23], RadEdg }
  texture { TexEdg } }
#if (OnPlane)
 #local P0 = Archimedean_truncated_octahedron_verts[14];
 #local P1 = Archimedean_truncated_octahedron_verts[19];
 #local P2 = Archimedean_truncated_octahedron_verts[22];
 #local P3 = Archimedean_truncated_octahedron_verts[23];
 #local P4 = Archimedean_truncated_octahedron_verts[21];
 #local P5 = Archimedean_truncated_octahedron_verts[17];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
  translate -(P0+P1+P2+P3+P4+P5)/6
  Reorient_Trans(Axis, y)
  translate y*max(RadEdg, RadVer)
#end
 }
#end

#declare Archimedean_rhombicuboctahedron_verts = array[24]
{
<0, 0, 1.070722>,
<0.7148135, 0, 0.7971752>,
<-0.104682, 0.7071068, 0.7971752>,
<-0.6841528, 0.2071068, 0.7971752>,
<-0.104682, -0.7071068, 0.7971752>,
<0.6101315, 0.7071068, 0.5236279>,
<1.04156, 0.2071068, 0.1367736>,
<0.6101315, -0.7071068, 0.5236279>,
<-0.3574067, 1., 0.1367736>,
<-0.7888348, -0.5, 0.5236279>,
<-0.9368776, 0.5, 0.1367736>,
<-0.3574067, -1., 0.1367736>,
<0.3574067, 1., -0.1367736>,
<0.9368776, -0.5, -0.1367736>,
<0.7888348, 0.5, -0.5236279>,
<0.3574067, -1., -0.1367736>,
<-0.6101315, 0.7071068, -0.5236279>,
<-1.04156, -0.2071068, -0.1367736>,
<-0.6101315, -0.7071068, -0.5236279>,
<0.104682, 0.7071068, -0.7971752>,
<0.6841528, -0.2071068, -0.7971752>,
<0.104682, -0.7071068, -0.7971752>,
<-0.7148135, 0, -0.7971752>,
<0, 0, -1.070722>
}
#local P0 = Archimedean_rhombicuboctahedron_verts[11];
#local P1 = Archimedean_rhombicuboctahedron_verts[15];
#local P2 = Archimedean_rhombicuboctahedron_verts[18];
#local V1 = P1 - P0;
#local V2 = P2 - P0;
#local Axis = vcross(V2, V1);
#local Tran1 = transform { Reorient_Trans(Axis, y) }
#local TV1 = vtransform(V1, Tran1);
#local The_Tran = transform {
 Reorient_Trans(Axis, y)
 Reorient_Trans(TV1, x) }
#local Num = 0;
#while (Num < 24)
 #declare Archimedean_rhombicuboctahedron_verts[Num] = vtransform(Archimedean_rhombicuboctahedron_verts[Num], The_Tran);
 #local Num = Num + 1;
#end

#macro Archimedean_rhombicuboctahedron_faces(Tex3, Tex4, OnPlane)
#local Archimedean_rhombicuboctahedron_obj = mesh2 {
 vertex_vectors {
  24,
  Archimedean_rhombicuboctahedron_verts[0],
  Archimedean_rhombicuboctahedron_verts[1],
  Archimedean_rhombicuboctahedron_verts[2],
  Archimedean_rhombicuboctahedron_verts[3],
  Archimedean_rhombicuboctahedron_verts[4],
  Archimedean_rhombicuboctahedron_verts[5],
  Archimedean_rhombicuboctahedron_verts[6],
  Archimedean_rhombicuboctahedron_verts[7],
  Archimedean_rhombicuboctahedron_verts[8],
  Archimedean_rhombicuboctahedron_verts[9],
  Archimedean_rhombicuboctahedron_verts[10],
  Archimedean_rhombicuboctahedron_verts[11],
  Archimedean_rhombicuboctahedron_verts[12],
  Archimedean_rhombicuboctahedron_verts[13],
  Archimedean_rhombicuboctahedron_verts[14],
  Archimedean_rhombicuboctahedron_verts[15],
  Archimedean_rhombicuboctahedron_verts[16],
  Archimedean_rhombicuboctahedron_verts[17],
  Archimedean_rhombicuboctahedron_verts[18],
  Archimedean_rhombicuboctahedron_verts[19],
  Archimedean_rhombicuboctahedron_verts[20],
  Archimedean_rhombicuboctahedron_verts[21],
  Archimedean_rhombicuboctahedron_verts[22],
  Archimedean_rhombicuboctahedron_verts[23]
 }
 texture_list {
  2,
  texture { Tex3 },
  texture { Tex4 }
 }
 face_indices {
  44,
  <0, 2, 3>, 0,
  <1, 6, 5>, 0,
  <4, 9, 11>, 0,
  <7, 15, 13>, 0,
  <8, 16, 10>, 0,
  <12, 14, 19>, 0,
  <17, 22, 18>, 0,
  <20, 21, 23>, 0,
  <0, 1, 5>, 1,
  <0, 5, 2>, 1,
  <0, 3, 9>, 1,
  <0, 9, 4>, 1,
  <0, 4, 7>, 1,
  <0, 7, 1>, 1,
  <1, 7, 13>, 1,
  <1, 13, 6>, 1,
  <2, 5, 12>, 1,
  <2, 12, 8>, 1,
  <2, 8, 10>, 1,
  <2, 10, 3>, 1,
  <3, 10, 17>, 1,
  <3, 17, 9>, 1,
  <4, 11, 15>, 1,
  <4, 15, 7>, 1,
  <5, 6, 14>, 1,
  <5, 14, 12>, 1,
  <6, 13, 20>, 1,
  <6, 20, 14>, 1,
  <8, 12, 19>, 1,
  <8, 19, 16>, 1,
  <9, 17, 18>, 1,
  <9, 18, 11>, 1,
  <10, 16, 22>, 1,
  <10, 22, 17>, 1,
  <11, 18, 21>, 1,
  <11, 21, 15>, 1,
  <13, 15, 21>, 1,
  <13, 21, 20>, 1,
  <14, 20, 23>, 1,
  <14, 23, 19>, 1,
  <16, 19, 23>, 1,
  <16, 23, 22>, 1,
  <18, 22, 23>, 1,
  <18, 23, 21>, 1
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_rhombicuboctahedron_verts[11];
 #local P1 = Archimedean_rhombicuboctahedron_verts[18];
 #local P2 = Archimedean_rhombicuboctahedron_verts[15];
 #local P3 = Archimedean_rhombicuboctahedron_verts[21];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_rhombicuboctahedron_obj
  translate -(P0+P1+P2+P3)/4
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_rhombicuboctahedron_obj }
#end
#end

#macro Archimedean_rhombicuboctahedron_faces2(OnPlane)
#local Archimedean_rhombicuboctahedron_obj = mesh2 {
 vertex_vectors {
  24,
  Archimedean_rhombicuboctahedron_verts[0],
  Archimedean_rhombicuboctahedron_verts[1],
  Archimedean_rhombicuboctahedron_verts[2],
  Archimedean_rhombicuboctahedron_verts[3],
  Archimedean_rhombicuboctahedron_verts[4],
  Archimedean_rhombicuboctahedron_verts[5],
  Archimedean_rhombicuboctahedron_verts[6],
  Archimedean_rhombicuboctahedron_verts[7],
  Archimedean_rhombicuboctahedron_verts[8],
  Archimedean_rhombicuboctahedron_verts[9],
  Archimedean_rhombicuboctahedron_verts[10],
  Archimedean_rhombicuboctahedron_verts[11],
  Archimedean_rhombicuboctahedron_verts[12],
  Archimedean_rhombicuboctahedron_verts[13],
  Archimedean_rhombicuboctahedron_verts[14],
  Archimedean_rhombicuboctahedron_verts[15],
  Archimedean_rhombicuboctahedron_verts[16],
  Archimedean_rhombicuboctahedron_verts[17],
  Archimedean_rhombicuboctahedron_verts[18],
  Archimedean_rhombicuboctahedron_verts[19],
  Archimedean_rhombicuboctahedron_verts[20],
  Archimedean_rhombicuboctahedron_verts[21],
  Archimedean_rhombicuboctahedron_verts[22],
  Archimedean_rhombicuboctahedron_verts[23]
 }
 face_indices {
  44,
  <0, 2, 3>,
  <1, 6, 5>,
  <4, 9, 11>,
  <7, 15, 13>,
  <8, 16, 10>,
  <12, 14, 19>,
  <17, 22, 18>,
  <20, 21, 23>,
  <0, 1, 5>,
  <0, 5, 2>,
  <0, 3, 9>,
  <0, 9, 4>,
  <0, 4, 7>,
  <0, 7, 1>,
  <1, 7, 13>,
  <1, 13, 6>,
  <2, 5, 12>,
  <2, 12, 8>,
  <2, 8, 10>,
  <2, 10, 3>,
  <3, 10, 17>,
  <3, 17, 9>,
  <4, 11, 15>,
  <4, 15, 7>,
  <5, 6, 14>,
  <5, 14, 12>,
  <6, 13, 20>,
  <6, 20, 14>,
  <8, 12, 19>,
  <8, 19, 16>,
  <9, 17, 18>,
  <9, 18, 11>,
  <10, 16, 22>,
  <10, 22, 17>,
  <11, 18, 21>,
  <11, 21, 15>,
  <13, 15, 21>,
  <13, 21, 20>,
  <14, 20, 23>,
  <14, 23, 19>,
  <16, 19, 23>,
  <16, 23, 22>,
  <18, 22, 23>,
  <18, 23, 21>
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_rhombicuboctahedron_verts[11];
 #local P1 = Archimedean_rhombicuboctahedron_verts[18];
 #local P2 = Archimedean_rhombicuboctahedron_verts[15];
 #local P3 = Archimedean_rhombicuboctahedron_verts[21];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_rhombicuboctahedron_obj
  translate -(P0+P1+P2+P3)/4
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_rhombicuboctahedron_obj }
#end
#end

#macro Archimedean_rhombicuboctahedron_edges(RadEdg, RadVer, TexEdg, TexVer, OnPlane)
union {
 union {
  sphere { Archimedean_rhombicuboctahedron_verts[0], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[1], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[2], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[3], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[4], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[5], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[6], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[7], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[8], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[9], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[10], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[11], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[12], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[13], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[14], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[15], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[16], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[17], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[18], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[19], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[20], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[21], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[22], RadVer }
  sphere { Archimedean_rhombicuboctahedron_verts[23], RadVer }
  texture { TexVer } }
 union {
  cylinder { Archimedean_rhombicuboctahedron_verts[0], Archimedean_rhombicuboctahedron_verts[2], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[2], Archimedean_rhombicuboctahedron_verts[3], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[3], Archimedean_rhombicuboctahedron_verts[0], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[1], Archimedean_rhombicuboctahedron_verts[6], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[6], Archimedean_rhombicuboctahedron_verts[5], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[5], Archimedean_rhombicuboctahedron_verts[1], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[4], Archimedean_rhombicuboctahedron_verts[9], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[9], Archimedean_rhombicuboctahedron_verts[11], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[11], Archimedean_rhombicuboctahedron_verts[4], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[7], Archimedean_rhombicuboctahedron_verts[15], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[15], Archimedean_rhombicuboctahedron_verts[13], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[13], Archimedean_rhombicuboctahedron_verts[7], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[8], Archimedean_rhombicuboctahedron_verts[16], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[16], Archimedean_rhombicuboctahedron_verts[10], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[10], Archimedean_rhombicuboctahedron_verts[8], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[12], Archimedean_rhombicuboctahedron_verts[14], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[14], Archimedean_rhombicuboctahedron_verts[19], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[19], Archimedean_rhombicuboctahedron_verts[12], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[17], Archimedean_rhombicuboctahedron_verts[22], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[22], Archimedean_rhombicuboctahedron_verts[18], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[18], Archimedean_rhombicuboctahedron_verts[17], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[20], Archimedean_rhombicuboctahedron_verts[21], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[21], Archimedean_rhombicuboctahedron_verts[23], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[23], Archimedean_rhombicuboctahedron_verts[20], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[0], Archimedean_rhombicuboctahedron_verts[1], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[5], Archimedean_rhombicuboctahedron_verts[2], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[3], Archimedean_rhombicuboctahedron_verts[9], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[4], Archimedean_rhombicuboctahedron_verts[0], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[4], Archimedean_rhombicuboctahedron_verts[7], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[7], Archimedean_rhombicuboctahedron_verts[1], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[13], Archimedean_rhombicuboctahedron_verts[6], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[5], Archimedean_rhombicuboctahedron_verts[12], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[12], Archimedean_rhombicuboctahedron_verts[8], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[8], Archimedean_rhombicuboctahedron_verts[2], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[10], Archimedean_rhombicuboctahedron_verts[3], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[10], Archimedean_rhombicuboctahedron_verts[17], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[17], Archimedean_rhombicuboctahedron_verts[9], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[11], Archimedean_rhombicuboctahedron_verts[15], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[6], Archimedean_rhombicuboctahedron_verts[14], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[13], Archimedean_rhombicuboctahedron_verts[20], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[20], Archimedean_rhombicuboctahedron_verts[14], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[19], Archimedean_rhombicuboctahedron_verts[16], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[18], Archimedean_rhombicuboctahedron_verts[11], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[16], Archimedean_rhombicuboctahedron_verts[22], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[18], Archimedean_rhombicuboctahedron_verts[21], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[21], Archimedean_rhombicuboctahedron_verts[15], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[23], Archimedean_rhombicuboctahedron_verts[19], RadEdg }
  cylinder { Archimedean_rhombicuboctahedron_verts[23], Archimedean_rhombicuboctahedron_verts[22], RadEdg }
  texture { TexEdg } }
#if (OnPlane)
 #local P0 = Archimedean_rhombicuboctahedron_verts[11];
 #local P1 = Archimedean_rhombicuboctahedron_verts[18];
 #local P2 = Archimedean_rhombicuboctahedron_verts[15];
 #local P3 = Archimedean_rhombicuboctahedron_verts[21];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
  translate -(P0+P1+P2+P3)/4
  Reorient_Trans(Axis, y)
  translate y*max(RadEdg, RadVer)
#end
 }
#end

#declare Archimedean_truncated_cuboctahedron_verts = array[48]
{
<0, 0, 1.024117>,
<0.4314788, 0, 0.928785>,
<-0.02106287, 0.4309644, 0.928785>,
<-0.3410582, -0.2642977, 0.928785>,
<0.4104159, 0.4309644, 0.833453>,
<0.7006238, -0.2642977, 0.6986333>,
<-0.3831839, 0.5976311, 0.7381211>,
<-0.3919084, -0.6380712, 0.6986333>,
<-0.7031792, -0.09763107, 0.7381211>,
<0.6584981, 0.5976311, 0.5079694>,
<0.6497736, -0.6380712, 0.4684816>,
<0.948706, -0.09763107, 0.3731496>,
<-0.4638216, 0.8333333, 0.3731496>,
<-0.7242421, 0.3333333, 0.6427891>,
<-0.7540295, -0.4714045, 0.5079694>,
<-0.1227634, -0.9023689, 0.4684816>,
<0.5778604, 0.8333333, 0.1429979>,
<0.9276431, 0.3333333, 0.2778177>,
<0.8978557, -0.4714045, 0.1429979>,
<0.3087154, -0.9023689, 0.3731496>,
<-0.8048797, 0.5690356, 0.2778177>,
<-0.2157394, 1., 0.04766598>,
<-0.8470055, -0.5690356, 0.08715377>,
<-0.2157394, -1., 0.04766598>
<0.8470055, 0.5690356, -0.08715377>,
<0.2157394, 1., -0.04766598>,
<0.8048797, -0.5690356, -0.2778177>,
<0.2157394, -1., -0.04766598>,
<-0.8978557, 0.4714045, -0.1429979>,
<-0.3087154, 0.9023689, -0.3731496>,
<-0.9276431, -0.3333333, -0.2778177>,
<-0.5778604, -0.8333333, -0.1429979>,
<0.7540295, 0.4714045, -0.5079694>,
<0.1227634, 0.9023689, -0.4684816>,
<0.7242421, -0.3333333, -0.6427891>,
<0.4638216, -0.8333333, -0.3731496>,
<-0.948706, 0.09763107, -0.3731496>,
<-0.6497736, 0.6380712, -0.4684816>,
<-0.6584981, -0.5976311, -0.5079694>,
<0.7031792, 0.09763107, -0.7381211>,
<0.3919084, 0.6380712, -0.6986333>,
<0.3831839, -0.5976311, -0.7381211>,
<-0.7006238, 0.2642977, -0.6986333>,
<-0.4104159, -0.4309644, -0.833453>,
<0.3410582, 0.2642977, -0.928785>,
<0.02106287, -0.4309644, -0.928785>,
<-0.4314788, 0, -0.928785>,
<0, 0, -1.024117>,
}
#local P0 = Archimedean_truncated_cuboctahedron_verts[29];
#local P1 = Archimedean_truncated_cuboctahedron_verts[33];
#local P2 = Archimedean_truncated_cuboctahedron_verts[40];
#local V1 = P1 - P0;
#local V2 = P2 - P0;
#local Axis = vcross(V2, V1);
#local Tran1 = transform { Reorient_Trans(Axis, y) }
#local TV1 = vtransform(V1, Tran1);
#local The_Tran = transform {
 Reorient_Trans(Axis, y)
 Reorient_Trans(TV1, x) }
#local Num = 0;
#while (Num < 48)
 #declare Archimedean_truncated_cuboctahedron_verts[Num] = vtransform(Archimedean_truncated_cuboctahedron_verts[Num], The_Tran);
 #local Num = Num + 1;
#end

#macro Archimedean_truncated_cuboctahedron_faces(Tex4, Tex6, Tex8, OnPlane)
#local Archimedean_truncated_cuboctahedron_obj = mesh2 {
 vertex_vectors {
  48,
  Archimedean_truncated_cuboctahedron_verts[0],
  Archimedean_truncated_cuboctahedron_verts[1],
  Archimedean_truncated_cuboctahedron_verts[2],
  Archimedean_truncated_cuboctahedron_verts[3],
  Archimedean_truncated_cuboctahedron_verts[4],
  Archimedean_truncated_cuboctahedron_verts[5],
  Archimedean_truncated_cuboctahedron_verts[6],
  Archimedean_truncated_cuboctahedron_verts[7],
  Archimedean_truncated_cuboctahedron_verts[8],
  Archimedean_truncated_cuboctahedron_verts[9],
  Archimedean_truncated_cuboctahedron_verts[10],
  Archimedean_truncated_cuboctahedron_verts[11],
  Archimedean_truncated_cuboctahedron_verts[12],
  Archimedean_truncated_cuboctahedron_verts[13],
  Archimedean_truncated_cuboctahedron_verts[14],
  Archimedean_truncated_cuboctahedron_verts[15],
  Archimedean_truncated_cuboctahedron_verts[16],
  Archimedean_truncated_cuboctahedron_verts[17],
  Archimedean_truncated_cuboctahedron_verts[18],
  Archimedean_truncated_cuboctahedron_verts[19],
  Archimedean_truncated_cuboctahedron_verts[20],
  Archimedean_truncated_cuboctahedron_verts[21],
  Archimedean_truncated_cuboctahedron_verts[22],
  Archimedean_truncated_cuboctahedron_verts[23],
  Archimedean_truncated_cuboctahedron_verts[24],
  Archimedean_truncated_cuboctahedron_verts[25],
  Archimedean_truncated_cuboctahedron_verts[26],
  Archimedean_truncated_cuboctahedron_verts[27],
  Archimedean_truncated_cuboctahedron_verts[28],
  Archimedean_truncated_cuboctahedron_verts[29],
  Archimedean_truncated_cuboctahedron_verts[30],
  Archimedean_truncated_cuboctahedron_verts[31],
  Archimedean_truncated_cuboctahedron_verts[32],
  Archimedean_truncated_cuboctahedron_verts[33],
  Archimedean_truncated_cuboctahedron_verts[34],
  Archimedean_truncated_cuboctahedron_verts[35],
  Archimedean_truncated_cuboctahedron_verts[36],
  Archimedean_truncated_cuboctahedron_verts[37],
  Archimedean_truncated_cuboctahedron_verts[38],
  Archimedean_truncated_cuboctahedron_verts[39],
  Archimedean_truncated_cuboctahedron_verts[40],
  Archimedean_truncated_cuboctahedron_verts[41],
  Archimedean_truncated_cuboctahedron_verts[42],
  Archimedean_truncated_cuboctahedron_verts[43],
  Archimedean_truncated_cuboctahedron_verts[44],
  Archimedean_truncated_cuboctahedron_verts[45],
  Archimedean_truncated_cuboctahedron_verts[46],
  Archimedean_truncated_cuboctahedron_verts[47]
 }
 texture_list {
  3,
  texture { Tex4 },
  texture { Tex6 },
  texture { Tex8 }
 }
 face_indices {
  92,
  <0, 1, 4>, 0,
  <0, 4, 2>, 0,
  <3, 8, 14>, 0,
  <3, 14, 7>, 0,
  <5, 10, 18>, 0,
  <5, 18, 11>, 0,
  <6, 12, 20>, 0,
  <6, 20, 13>, 0,
  <9, 17, 24>, 0,
  <9, 24, 16>, 0,
  <15, 23, 27>, 0,
  <15, 27, 19>, 0,
  <21, 25, 33>, 0,
  <21, 33, 29>, 0,
  <22, 30, 38>, 0,
  <22, 38, 31>, 0,
  <26, 35, 41>, 0,
  <26, 41, 34>, 0,
  <28, 37, 42>, 0,
  <28, 42, 36>, 0,
  <32, 39, 44>, 0,
  <32, 44, 40>, 0,
  <43, 46, 47>, 0,
  <43, 47, 45>, 0,
  <0, 2, 6>, 1,
  <0, 6, 13>, 1,
  <0, 13, 8>, 1,
  <0, 8, 3>, 1,
  <1, 5, 11>, 1,
  <1, 11, 17>, 1,
  <1, 17, 9>, 1,
  <1, 9, 4>, 1,
  <7, 14, 22>, 1,
  <7, 22, 31>, 1,
  <7, 31, 23>, 1,
  <7, 23, 15>, 1,
  <10, 19, 27>, 1,
  <10, 27, 35>, 1,
  <10, 35, 26>, 1,
  <10, 26, 18>, 1,
  <12, 21, 29>, 1,
  <12, 29, 37>, 1,
  <12, 37, 28>, 1,
  <12, 28, 20>, 1,
  <16, 24, 32>, 1,
  <16, 32, 40>, 1,
  <16, 40, 33>, 1,
  <16, 33, 25>, 1,
  <30, 36, 42>, 1,
  <30, 42, 46>, 1,
  <30, 46, 43>, 1,
  <30, 43, 38>, 1,
  <34, 41, 45>, 1,
  <34, 45, 47>, 1,
  <34, 47, 44>, 1,
  <34, 44, 39>, 1,
  <0, 3, 7>, 2,
  <0, 7, 15>, 2,
  <0, 15, 19>, 2,
  <0, 19, 10>, 2,
  <0, 10, 5>, 2,
  <0, 5, 1>, 2,
  <2, 4, 9>, 2,
  <2, 9, 16>, 2,
  <2, 16, 25>, 2,
  <2, 25, 21>, 2,
  <2, 21, 12>, 2,
  <2, 12, 6>, 2,
  <8, 13, 20>, 2,
  <8, 20, 28>, 2,
  <8, 28, 36>, 2,
  <8, 36, 30>, 2,
  <8, 30, 22>, 2,
  <8, 22, 14>, 2,
  <11, 18, 26>, 2,
  <11, 26, 34>, 2,
  <11, 34, 39>, 2,
  <11, 39, 32>, 2,
  <11, 32, 24>, 2,
  <11, 24, 17>, 2,
  <23, 31, 38>, 2,
  <23, 38, 43>, 2,
  <23, 43, 45>, 2,
  <23, 45, 41>, 2,
  <23, 41, 35>, 2,
  <23, 35, 27>, 2,
  <29, 33, 40>, 2,
  <29, 40, 44>, 2,
  <29, 44, 47>, 2,
  <29, 47, 46>, 2,
  <29, 46, 42>, 2,
  <29, 42, 37>, 2
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_truncated_cuboctahedron_verts[29];
 #local P1 = Archimedean_truncated_cuboctahedron_verts[33];
 #local P2 = Archimedean_truncated_cuboctahedron_verts[40];
 #local P3 = Archimedean_truncated_cuboctahedron_verts[44];
 #local P4 = Archimedean_truncated_cuboctahedron_verts[47];
 #local P5 = Archimedean_truncated_cuboctahedron_verts[46];
 #local P6 = Archimedean_truncated_cuboctahedron_verts[42];
 #local P7 = Archimedean_truncated_cuboctahedron_verts[37];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_truncated_cuboctahedron_obj
  translate -(P0+P1+P2+P3+P4+P5+P6+P7)/8
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_truncated_cuboctahedron_obj }
#end
#end

#macro Archimedean_truncated_cuboctahedron_faces2(OnPlane)
#local Archimedean_truncated_cuboctahedron_obj = mesh2 {
 vertex_vectors {
  48,
  Archimedean_truncated_cuboctahedron_verts[0],
  Archimedean_truncated_cuboctahedron_verts[1],
  Archimedean_truncated_cuboctahedron_verts[2],
  Archimedean_truncated_cuboctahedron_verts[3],
  Archimedean_truncated_cuboctahedron_verts[4],
  Archimedean_truncated_cuboctahedron_verts[5],
  Archimedean_truncated_cuboctahedron_verts[6],
  Archimedean_truncated_cuboctahedron_verts[7],
  Archimedean_truncated_cuboctahedron_verts[8],
  Archimedean_truncated_cuboctahedron_verts[9],
  Archimedean_truncated_cuboctahedron_verts[10],
  Archimedean_truncated_cuboctahedron_verts[11],
  Archimedean_truncated_cuboctahedron_verts[12],
  Archimedean_truncated_cuboctahedron_verts[13],
  Archimedean_truncated_cuboctahedron_verts[14],
  Archimedean_truncated_cuboctahedron_verts[15],
  Archimedean_truncated_cuboctahedron_verts[16],
  Archimedean_truncated_cuboctahedron_verts[17],
  Archimedean_truncated_cuboctahedron_verts[18],
  Archimedean_truncated_cuboctahedron_verts[19],
  Archimedean_truncated_cuboctahedron_verts[20],
  Archimedean_truncated_cuboctahedron_verts[21],
  Archimedean_truncated_cuboctahedron_verts[22],
  Archimedean_truncated_cuboctahedron_verts[23],
  Archimedean_truncated_cuboctahedron_verts[24],
  Archimedean_truncated_cuboctahedron_verts[25],
  Archimedean_truncated_cuboctahedron_verts[26],
  Archimedean_truncated_cuboctahedron_verts[27],
  Archimedean_truncated_cuboctahedron_verts[28],
  Archimedean_truncated_cuboctahedron_verts[29],
  Archimedean_truncated_cuboctahedron_verts[30],
  Archimedean_truncated_cuboctahedron_verts[31],
  Archimedean_truncated_cuboctahedron_verts[32],
  Archimedean_truncated_cuboctahedron_verts[33],
  Archimedean_truncated_cuboctahedron_verts[34],
  Archimedean_truncated_cuboctahedron_verts[35],
  Archimedean_truncated_cuboctahedron_verts[36],
  Archimedean_truncated_cuboctahedron_verts[37],
  Archimedean_truncated_cuboctahedron_verts[38],
  Archimedean_truncated_cuboctahedron_verts[39],
  Archimedean_truncated_cuboctahedron_verts[40],
  Archimedean_truncated_cuboctahedron_verts[41],
  Archimedean_truncated_cuboctahedron_verts[42],
  Archimedean_truncated_cuboctahedron_verts[43],
  Archimedean_truncated_cuboctahedron_verts[44],
  Archimedean_truncated_cuboctahedron_verts[45],
  Archimedean_truncated_cuboctahedron_verts[46],
  Archimedean_truncated_cuboctahedron_verts[47]
 }
 face_indices {
  92,
  <0, 1, 4>,
  <0, 4, 2>,
  <3, 8, 14>,
  <3, 14, 7>,
  <5, 10, 18>,
  <5, 18, 11>,
  <6, 12, 20>,
  <6, 20, 13>,
  <9, 17, 24>,
  <9, 24, 16>,
  <15, 23, 27>,
  <15, 27, 19>,
  <21, 25, 33>,
  <21, 33, 29>,
  <22, 30, 38>,
  <22, 38, 31>,
  <26, 35, 41>,
  <26, 41, 34>,
  <28, 37, 42>,
  <28, 42, 36>,
  <32, 39, 44>,
  <32, 44, 40>,
  <43, 46, 47>,
  <43, 47, 45>,
  <0, 2, 6>,
  <0, 6, 13>,
  <0, 13, 8>,
  <0, 8, 3>,
  <1, 5, 11>,
  <1, 11, 17>,
  <1, 17, 9>,
  <1, 9, 4>,
  <7, 14, 22>,
  <7, 22, 31>,
  <7, 31, 23>,
  <7, 23, 15>,
  <10, 19, 27>,
  <10, 27, 35>,
  <10, 35, 26>,
  <10, 26, 18>,
  <12, 21, 29>,
  <12, 29, 37>,
  <12, 37, 28>,
  <12, 28, 20>,
  <16, 24, 32>,
  <16, 32, 40>,
  <16, 40, 33>,
  <16, 33, 25>,
  <30, 36, 42>,
  <30, 42, 46>,
  <30, 46, 43>,
  <30, 43, 38>,
  <34, 41, 45>,
  <34, 45, 47>,
  <34, 47, 44>,
  <34, 44, 39>,
  <0, 3, 7>,
  <0, 7, 15>,
  <0, 15, 19>,
  <0, 19, 10>,
  <0, 10, 5>,
  <0, 5, 1>,
  <2, 4, 9>,
  <2, 9, 16>,
  <2, 16, 25>,
  <2, 25, 21>,
  <2, 21, 12>,
  <2, 12, 6>,
  <8, 13, 20>,
  <8, 20, 28>,
  <8, 28, 36>,
  <8, 36, 30>,
  <8, 30, 22>,
  <8, 22, 14>,
  <11, 18, 26>,
  <11, 26, 34>,
  <11, 34, 39>,
  <11, 39, 32>,
  <11, 32, 24>,
  <11, 24, 17>,
  <23, 31, 38>,
  <23, 38, 43>,
  <23, 43, 45>,
  <23, 45, 41>,
  <23, 41, 35>,
  <23, 35, 27>,
  <29, 33, 40>,
  <29, 40, 44>,
  <29, 44, 47>,
  <29, 47, 46>,
  <29, 46, 42>,
  <29, 42, 37>
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_truncated_cuboctahedron_verts[29];
 #local P1 = Archimedean_truncated_cuboctahedron_verts[33];
 #local P2 = Archimedean_truncated_cuboctahedron_verts[40];
 #local P3 = Archimedean_truncated_cuboctahedron_verts[44];
 #local P4 = Archimedean_truncated_cuboctahedron_verts[47];
 #local P5 = Archimedean_truncated_cuboctahedron_verts[46];
 #local P6 = Archimedean_truncated_cuboctahedron_verts[42];
 #local P7 = Archimedean_truncated_cuboctahedron_verts[37];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_truncated_cuboctahedron_obj
  translate -(P0+P1+P2+P3+P4+P5+P6+P7)/8
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_truncated_cuboctahedron_obj }
#end
#end

#macro Archimedean_truncated_cuboctahedron_edges(RadEdg, RadVer, TexEdg, TexVer, OnPlane)
union {
 union {
  sphere { Archimedean_truncated_cuboctahedron_verts[0], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[1], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[2], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[3], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[4], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[5], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[6], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[7], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[8], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[9], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[10], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[11], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[12], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[13], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[14], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[15], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[16], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[17], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[18], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[19], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[20], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[21], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[22], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[23], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[24], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[25], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[26], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[27], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[28], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[29], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[30], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[31], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[32], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[33], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[34], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[35], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[36], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[37], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[38], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[39], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[40], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[41], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[42], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[43], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[44], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[45], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[46], RadVer }
  sphere { Archimedean_truncated_cuboctahedron_verts[47], RadVer }
  texture { TexVer } }
 union {
  cylinder { Archimedean_truncated_cuboctahedron_verts[0], Archimedean_truncated_cuboctahedron_verts[1], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[1], Archimedean_truncated_cuboctahedron_verts[4], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[4], Archimedean_truncated_cuboctahedron_verts[2], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[2], Archimedean_truncated_cuboctahedron_verts[0], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[3], Archimedean_truncated_cuboctahedron_verts[8], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[8], Archimedean_truncated_cuboctahedron_verts[14], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[14], Archimedean_truncated_cuboctahedron_verts[7], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[7], Archimedean_truncated_cuboctahedron_verts[3], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[5], Archimedean_truncated_cuboctahedron_verts[10], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[10], Archimedean_truncated_cuboctahedron_verts[18], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[18], Archimedean_truncated_cuboctahedron_verts[11], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[11], Archimedean_truncated_cuboctahedron_verts[5], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[6], Archimedean_truncated_cuboctahedron_verts[12], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[12], Archimedean_truncated_cuboctahedron_verts[20], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[20], Archimedean_truncated_cuboctahedron_verts[13], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[13], Archimedean_truncated_cuboctahedron_verts[6], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[9], Archimedean_truncated_cuboctahedron_verts[17], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[17], Archimedean_truncated_cuboctahedron_verts[24], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[24], Archimedean_truncated_cuboctahedron_verts[16], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[16], Archimedean_truncated_cuboctahedron_verts[9], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[15], Archimedean_truncated_cuboctahedron_verts[23], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[23], Archimedean_truncated_cuboctahedron_verts[27], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[27], Archimedean_truncated_cuboctahedron_verts[19], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[19], Archimedean_truncated_cuboctahedron_verts[15], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[21], Archimedean_truncated_cuboctahedron_verts[25], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[25], Archimedean_truncated_cuboctahedron_verts[33], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[33], Archimedean_truncated_cuboctahedron_verts[29], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[29], Archimedean_truncated_cuboctahedron_verts[21], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[22], Archimedean_truncated_cuboctahedron_verts[30], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[30], Archimedean_truncated_cuboctahedron_verts[38], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[38], Archimedean_truncated_cuboctahedron_verts[31], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[31], Archimedean_truncated_cuboctahedron_verts[22], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[26], Archimedean_truncated_cuboctahedron_verts[35], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[35], Archimedean_truncated_cuboctahedron_verts[41], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[41], Archimedean_truncated_cuboctahedron_verts[34], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[34], Archimedean_truncated_cuboctahedron_verts[26], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[28], Archimedean_truncated_cuboctahedron_verts[37], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[37], Archimedean_truncated_cuboctahedron_verts[42], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[42], Archimedean_truncated_cuboctahedron_verts[36], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[36], Archimedean_truncated_cuboctahedron_verts[28], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[32], Archimedean_truncated_cuboctahedron_verts[39], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[39], Archimedean_truncated_cuboctahedron_verts[44], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[44], Archimedean_truncated_cuboctahedron_verts[40], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[40], Archimedean_truncated_cuboctahedron_verts[32], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[43], Archimedean_truncated_cuboctahedron_verts[46], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[46], Archimedean_truncated_cuboctahedron_verts[47], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[47], Archimedean_truncated_cuboctahedron_verts[45], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[45], Archimedean_truncated_cuboctahedron_verts[43], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[2], Archimedean_truncated_cuboctahedron_verts[6], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[13], Archimedean_truncated_cuboctahedron_verts[8], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[3], Archimedean_truncated_cuboctahedron_verts[0], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[1], Archimedean_truncated_cuboctahedron_verts[5], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[11], Archimedean_truncated_cuboctahedron_verts[17], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[9], Archimedean_truncated_cuboctahedron_verts[4], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[14], Archimedean_truncated_cuboctahedron_verts[22], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[31], Archimedean_truncated_cuboctahedron_verts[23], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[15], Archimedean_truncated_cuboctahedron_verts[7], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[10], Archimedean_truncated_cuboctahedron_verts[19], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[27], Archimedean_truncated_cuboctahedron_verts[35], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[26], Archimedean_truncated_cuboctahedron_verts[18], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[12], Archimedean_truncated_cuboctahedron_verts[21], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[29], Archimedean_truncated_cuboctahedron_verts[37], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[28], Archimedean_truncated_cuboctahedron_verts[20], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[24], Archimedean_truncated_cuboctahedron_verts[32], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[40], Archimedean_truncated_cuboctahedron_verts[33], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[25], Archimedean_truncated_cuboctahedron_verts[16], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[30], Archimedean_truncated_cuboctahedron_verts[36], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[42], Archimedean_truncated_cuboctahedron_verts[46], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[43], Archimedean_truncated_cuboctahedron_verts[38], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[41], Archimedean_truncated_cuboctahedron_verts[45], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[47], Archimedean_truncated_cuboctahedron_verts[44], RadEdg }
  cylinder { Archimedean_truncated_cuboctahedron_verts[39], Archimedean_truncated_cuboctahedron_verts[34], RadEdg }
  texture { TexEdg } }
#if (OnPlane)
 #local P0 = Archimedean_truncated_cuboctahedron_verts[29];
 #local P1 = Archimedean_truncated_cuboctahedron_verts[33];
 #local P2 = Archimedean_truncated_cuboctahedron_verts[40];
 #local P3 = Archimedean_truncated_cuboctahedron_verts[44];
 #local P4 = Archimedean_truncated_cuboctahedron_verts[47];
 #local P5 = Archimedean_truncated_cuboctahedron_verts[46];
 #local P6 = Archimedean_truncated_cuboctahedron_verts[42];
 #local P7 = Archimedean_truncated_cuboctahedron_verts[37];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
  translate -(P0+P1+P2+P3+P4+P5+P6+P7)/8
  Reorient_Trans(Axis, y)
  translate y*max(RadEdg, RadVer)
#end
 }
#end

#declare Archimedean_snub_cuboctahedron_verts = array[24]
{
<0, 0, 1.077364>,
<0.7442063, 0, 0.7790187>,
<0.3123013, 0.6755079, 0.7790187>,
<-0.482096, 0.5669449, 0.7790187>,
<-0.7169181, -0.1996786, 0.7790187>,
<-0.1196038, -0.7345325, 0.7790187>,
<0.6246025, -0.7345325, 0.4806734>,
<1.056508, -0.1996786, 0.06806912>,
<0.8867128, 0.5669449, 0.2302762>,
<0.2621103, 1.042774, 0.06806912>,
<-0.532287, 0.9342111, 0.06806912>,
<-1.006317, 0.3082417, 0.2302762>,
<-0.7020817, -0.784071, 0.2302762>,
<0.02728827, -1.074865, 0.06806912>,
<0.6667271, -0.784071, -0.3184664>,
<0.8216855, -0.09111555, -0.6908285>,
<0.6518908, 0.6755079, -0.5286215>,
<-0.1196038, 0.8751866, -0.6168117>,
<-0.8092336, 0.4758293, -0.5286215>,
<-0.9914803, -0.2761507, -0.3184664>,
<-0.4467414, -0.825648, -0.5286215>,
<0.1926974, -0.5348539, -0.915157>,
<0.1846311, 0.2587032, -1.029416>,
<-0.5049987, -0.1406541, -0.9412258>
}
#local P0 = Archimedean_snub_cuboctahedron_verts[17];
#local P1 = Archimedean_snub_cuboctahedron_verts[22];
#local P2 = Archimedean_snub_cuboctahedron_verts[23];
#local V1 = P1 - P0;
#local V2 = P2 - P0;
#local Axis = vcross(V2, V1);
#local Tran1 = transform { Reorient_Trans(Axis, y) }
#local TV1 = vtransform(V1, Tran1);
#local The_Tran = transform {
 Reorient_Trans(Axis, y)
 Reorient_Trans(TV1, x) }
#local Num = 0;
#while (Num < 24)
 #declare Archimedean_snub_cuboctahedron_verts[Num] = vtransform(Archimedean_snub_cuboctahedron_verts[Num], The_Tran);
 #local Num = Num + 1;
#end

#macro Archimedean_snub_cuboctahedron_faces(Tex3, Tex4, OnPlane)
#local Archimedean_snub_cuboctahedron_obj = mesh2 {
 vertex_vectors {
  24,
  Archimedean_snub_cuboctahedron_verts[0],
  Archimedean_snub_cuboctahedron_verts[1],
  Archimedean_snub_cuboctahedron_verts[2],
  Archimedean_snub_cuboctahedron_verts[3],
  Archimedean_snub_cuboctahedron_verts[4],
  Archimedean_snub_cuboctahedron_verts[5],
  Archimedean_snub_cuboctahedron_verts[6],
  Archimedean_snub_cuboctahedron_verts[7],
  Archimedean_snub_cuboctahedron_verts[8],
  Archimedean_snub_cuboctahedron_verts[9],
  Archimedean_snub_cuboctahedron_verts[10],
  Archimedean_snub_cuboctahedron_verts[11],
  Archimedean_snub_cuboctahedron_verts[12],
  Archimedean_snub_cuboctahedron_verts[13],
  Archimedean_snub_cuboctahedron_verts[14],
  Archimedean_snub_cuboctahedron_verts[15],
  Archimedean_snub_cuboctahedron_verts[16],
  Archimedean_snub_cuboctahedron_verts[17],
  Archimedean_snub_cuboctahedron_verts[18],
  Archimedean_snub_cuboctahedron_verts[19],
  Archimedean_snub_cuboctahedron_verts[20],
  Archimedean_snub_cuboctahedron_verts[21],
  Archimedean_snub_cuboctahedron_verts[22],
  Archimedean_snub_cuboctahedron_verts[23]
 }
 texture_list {
  2,
  texture { Tex3 },
  texture { Tex4 }
 }
 face_indices {
  44,
  <0, 1, 2>, 0,
  <0, 2, 3>, 0,
  <0, 3, 4>, 0,
  <0, 4, 5>, 0,
  <1, 6, 7>, 0,
  <1, 7, 8>, 0,
  <1, 8, 2>, 0,
  <2, 8, 9>, 0,
  <3, 10, 11>, 0,
  <3, 11, 4>, 0,
  <4, 12, 5>, 0,
  <5, 12, 13>, 0,
  <5, 13, 6>, 0,
  <6, 13, 14>, 0,
  <6, 14, 7>, 0,
  <7, 14, 15>, 0,
  <8, 16, 9>, 0,
  <9, 16, 17>, 0,
  <9, 17, 10>, 0,
  <10, 17, 18>, 0,
  <10, 18, 11>, 0,
  <11, 18, 19>, 0,
  <12, 19, 20>, 0,
  <12, 20, 13>, 0,
  <14, 21, 15>, 0,
  <15, 21, 22>, 0,
  <15, 22, 16>, 0,
  <16, 22, 17>, 0,
  <18, 23, 19>, 0,
  <19, 23, 20>, 0,
  <20, 23, 21>, 0,
  <21, 23, 22>, 0,
  <0, 5, 6>, 1,
  <0, 6, 1>, 1,
  <2, 9, 10>, 1,
  <2, 10, 3>, 1,
  <4, 11, 19>, 1,
  <4, 19, 12>, 1,
  <7, 15, 16>, 1,
  <7, 16, 8>, 1,
  <13, 20, 21>, 1,
  <13, 21, 14>, 1,
  <17, 22, 23>, 1,
  <17, 23, 18>, 1
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_snub_cuboctahedron_verts[17];
 #local P1 = Archimedean_snub_cuboctahedron_verts[22];
 #local P2 = Archimedean_snub_cuboctahedron_verts[23];
 #local P3 = Archimedean_snub_cuboctahedron_verts[18];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_snub_cuboctahedron_obj
  translate -(P0+P1+P2+P3)/4
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_snub_cuboctahedron_obj }
#end
#end

#macro Archimedean_snub_cuboctahedron_faces2(OnPlane)
#local Archimedean_snub_cuboctahedron_obj = mesh2 {
 vertex_vectors {
  24,
  Archimedean_snub_cuboctahedron_verts[0],
  Archimedean_snub_cuboctahedron_verts[1],
  Archimedean_snub_cuboctahedron_verts[2],
  Archimedean_snub_cuboctahedron_verts[3],
  Archimedean_snub_cuboctahedron_verts[4],
  Archimedean_snub_cuboctahedron_verts[5],
  Archimedean_snub_cuboctahedron_verts[6],
  Archimedean_snub_cuboctahedron_verts[7],
  Archimedean_snub_cuboctahedron_verts[8],
  Archimedean_snub_cuboctahedron_verts[9],
  Archimedean_snub_cuboctahedron_verts[10],
  Archimedean_snub_cuboctahedron_verts[11],
  Archimedean_snub_cuboctahedron_verts[12],
  Archimedean_snub_cuboctahedron_verts[13],
  Archimedean_snub_cuboctahedron_verts[14],
  Archimedean_snub_cuboctahedron_verts[15],
  Archimedean_snub_cuboctahedron_verts[16],
  Archimedean_snub_cuboctahedron_verts[17],
  Archimedean_snub_cuboctahedron_verts[18],
  Archimedean_snub_cuboctahedron_verts[19],
  Archimedean_snub_cuboctahedron_verts[20],
  Archimedean_snub_cuboctahedron_verts[21],
  Archimedean_snub_cuboctahedron_verts[22],
  Archimedean_snub_cuboctahedron_verts[23]
 }
 face_indices {
  44,
  <0, 1, 2>,
  <0, 2, 3>,
  <0, 3, 4>,
  <0, 4, 5>,
  <1, 6, 7>,
  <1, 7, 8>,
  <1, 8, 2>,
  <2, 8, 9>,
  <3, 10, 11>,
  <3, 11, 4>,
  <4, 12, 5>,
  <5, 12, 13>,
  <5, 13, 6>,
  <6, 13, 14>,
  <6, 14, 7>,
  <7, 14, 15>,
  <8, 16, 9>,
  <9, 16, 17>,
  <9, 17, 10>,
  <10, 17, 18>,
  <10, 18, 11>,
  <11, 18, 19>,
  <12, 19, 20>,
  <12, 20, 13>,
  <14, 21, 15>,
  <15, 21, 22>,
  <15, 22, 16>,
  <16, 22, 17>,
  <18, 23, 19>,
  <19, 23, 20>,
  <20, 23, 21>,
  <21, 23, 22>,
  <0, 5, 6>,
  <0, 6, 1>,
  <2, 9, 10>,
  <2, 10, 3>,
  <4, 11, 19>,
  <4, 19, 12>,
  <7, 15, 16>,
  <7, 16, 8>,
  <13, 20, 21>,
  <13, 21, 14>,
  <17, 22, 23>,
  <17, 23, 18>
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_snub_cuboctahedron_verts[17];
 #local P1 = Archimedean_snub_cuboctahedron_verts[22];
 #local P2 = Archimedean_snub_cuboctahedron_verts[23];
 #local P3 = Archimedean_snub_cuboctahedron_verts[18];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_snub_cuboctahedron_obj
  translate -(P0+P1+P2+P3)/4
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_snub_cuboctahedron_obj }
#end
#end

#macro Archimedean_snub_cuboctahedron_edges(RadEdg, RadVer, TexEdg, TexVer, OnPlane)
union {
 union {
  sphere { Archimedean_snub_cuboctahedron_verts[0], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[1], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[2], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[3], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[4], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[5], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[6], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[7], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[8], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[9], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[10], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[11], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[12], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[13], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[14], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[15], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[16], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[17], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[18], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[19], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[20], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[21], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[22], RadVer }
  sphere { Archimedean_snub_cuboctahedron_verts[23], RadVer }
  texture { TexVer } }
 union {
  cylinder { Archimedean_snub_cuboctahedron_verts[0], Archimedean_snub_cuboctahedron_verts[1], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[1], Archimedean_snub_cuboctahedron_verts[2], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[2], Archimedean_snub_cuboctahedron_verts[0], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[2], Archimedean_snub_cuboctahedron_verts[3], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[3], Archimedean_snub_cuboctahedron_verts[0], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[3], Archimedean_snub_cuboctahedron_verts[4], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[4], Archimedean_snub_cuboctahedron_verts[0], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[4], Archimedean_snub_cuboctahedron_verts[5], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[5], Archimedean_snub_cuboctahedron_verts[0], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[1], Archimedean_snub_cuboctahedron_verts[6], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[6], Archimedean_snub_cuboctahedron_verts[7], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[7], Archimedean_snub_cuboctahedron_verts[1], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[7], Archimedean_snub_cuboctahedron_verts[8], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[8], Archimedean_snub_cuboctahedron_verts[1], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[8], Archimedean_snub_cuboctahedron_verts[2], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[8], Archimedean_snub_cuboctahedron_verts[9], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[9], Archimedean_snub_cuboctahedron_verts[2], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[3], Archimedean_snub_cuboctahedron_verts[10], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[10], Archimedean_snub_cuboctahedron_verts[11], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[11], Archimedean_snub_cuboctahedron_verts[3], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[11], Archimedean_snub_cuboctahedron_verts[4], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[4], Archimedean_snub_cuboctahedron_verts[12], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[12], Archimedean_snub_cuboctahedron_verts[5], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[12], Archimedean_snub_cuboctahedron_verts[13], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[13], Archimedean_snub_cuboctahedron_verts[5], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[13], Archimedean_snub_cuboctahedron_verts[6], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[6], Archimedean_snub_cuboctahedron_verts[5], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[13], Archimedean_snub_cuboctahedron_verts[14], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[14], Archimedean_snub_cuboctahedron_verts[6], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[14], Archimedean_snub_cuboctahedron_verts[7], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[14], Archimedean_snub_cuboctahedron_verts[15], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[15], Archimedean_snub_cuboctahedron_verts[7], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[8], Archimedean_snub_cuboctahedron_verts[16], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[16], Archimedean_snub_cuboctahedron_verts[9], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[16], Archimedean_snub_cuboctahedron_verts[17], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[17], Archimedean_snub_cuboctahedron_verts[9], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[17], Archimedean_snub_cuboctahedron_verts[10], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[10], Archimedean_snub_cuboctahedron_verts[9], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[17], Archimedean_snub_cuboctahedron_verts[18], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[18], Archimedean_snub_cuboctahedron_verts[10], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[18], Archimedean_snub_cuboctahedron_verts[11], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[18], Archimedean_snub_cuboctahedron_verts[19], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[19], Archimedean_snub_cuboctahedron_verts[11], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[12], Archimedean_snub_cuboctahedron_verts[19], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[19], Archimedean_snub_cuboctahedron_verts[20], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[20], Archimedean_snub_cuboctahedron_verts[12], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[20], Archimedean_snub_cuboctahedron_verts[13], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[14], Archimedean_snub_cuboctahedron_verts[21], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[21], Archimedean_snub_cuboctahedron_verts[15], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[21], Archimedean_snub_cuboctahedron_verts[22], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[22], Archimedean_snub_cuboctahedron_verts[15], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[22], Archimedean_snub_cuboctahedron_verts[16], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[16], Archimedean_snub_cuboctahedron_verts[15], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[22], Archimedean_snub_cuboctahedron_verts[17], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[18], Archimedean_snub_cuboctahedron_verts[23], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[23], Archimedean_snub_cuboctahedron_verts[19], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[23], Archimedean_snub_cuboctahedron_verts[20], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[23], Archimedean_snub_cuboctahedron_verts[21], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[21], Archimedean_snub_cuboctahedron_verts[20], RadEdg }
  cylinder { Archimedean_snub_cuboctahedron_verts[23], Archimedean_snub_cuboctahedron_verts[22], RadEdg }
  texture { TexEdg } }
#if (OnPlane)
 #local P0 = Archimedean_snub_cuboctahedron_verts[17];
 #local P1 = Archimedean_snub_cuboctahedron_verts[22];
 #local P2 = Archimedean_snub_cuboctahedron_verts[23];
 #local P3 = Archimedean_snub_cuboctahedron_verts[18];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
  translate -(P0+P1+P2+P3)/4
  Reorient_Trans(Axis, y)
  translate y*max(RadEdg, RadVer)
#end
 }
#end

#declare Archimedean_icosidodecahedron_verts = array[30]
{
<0, 0, 1.051462>,
<0.618034, 0, 0.8506508>,
<0.2763932, 0.5527864, 0.8506508>,
<-0.618034, 0, 0.8506508>,
<-0.2763932, -0.5527864, 0.8506508>,
<1., 0, 0.3249197>,
<0.7236068, -0.5527864, 0.5257311>,
<-0.1708204, 0.8944272, 0.5257311>,
<0.4472136, 0.8944272, 0.3249197>,
<-1., 0, 0.3249197>,
<-0.7236068, 0.5527864, 0.5257311>,
<0.1708204, -0.8944272, 0.5257311>,
<-0.4472136, -0.8944272, 0.3249197>,
<1., 0, -0.3249197>,
<0.8944272, 0.5527864, 0>,
<0.5527864, -0.8944272, 0>,
<-0.5527864, 0.8944272, 0>,
<0.4472136, 0.8944272, -0.3249197>,
<-1., 0, -0.3249197>,
<-0.8944272, -0.5527864, 0>,
<-0.4472136, -0.8944272, -0.3249197>,
<0.618034, 0, -0.8506508>,
<0.7236068, -0.5527864, -0.5257311>,
<0.1708204, -0.8944272, -0.5257311>
<-0.7236068, 0.5527864, -0.5257311>,
<-0.1708204, 0.8944272, -0.5257311>,
<0.2763932, 0.5527864, -0.8506508>,
<-0.618034, 0, -0.8506508>,
<-0.2763932, -0.5527864, -0.8506508>,
<0, 0, -1.051462>,
}
#local P0 = Archimedean_icosidodecahedron_verts[24];
#local P1 = Archimedean_icosidodecahedron_verts[25];
#local P2 = Archimedean_icosidodecahedron_verts[26];
#local V1 = P1 - P0;
#local V2 = P2 - P0;
#local Axis = vcross(V2, V1);
#local Tran1 = transform { Reorient_Trans(Axis, y) }
#local TV1 = vtransform(V1, Tran1);
#local The_Tran = transform {
 Reorient_Trans(Axis, y)
 Reorient_Trans(TV1, x) }
#local Num = 0;
#while (Num < 30)
 #declare Archimedean_icosidodecahedron_verts[Num] = vtransform(Archimedean_icosidodecahedron_verts[Num], The_Tran);
 #local Num = Num + 1;
#end

#macro Archimedean_icosidodecahedron_faces(Tex3, Tex5, OnPlane)
#local Archimedean_icosidodecahedron_obj = mesh2 {
 vertex_vectors {
  30,
  Archimedean_icosidodecahedron_verts[0],
  Archimedean_icosidodecahedron_verts[1],
  Archimedean_icosidodecahedron_verts[2],
  Archimedean_icosidodecahedron_verts[3],
  Archimedean_icosidodecahedron_verts[4],
  Archimedean_icosidodecahedron_verts[5],
  Archimedean_icosidodecahedron_verts[6],
  Archimedean_icosidodecahedron_verts[7],
  Archimedean_icosidodecahedron_verts[8],
  Archimedean_icosidodecahedron_verts[9],
  Archimedean_icosidodecahedron_verts[10],
  Archimedean_icosidodecahedron_verts[11],
  Archimedean_icosidodecahedron_verts[12],
  Archimedean_icosidodecahedron_verts[13],
  Archimedean_icosidodecahedron_verts[14],
  Archimedean_icosidodecahedron_verts[15],
  Archimedean_icosidodecahedron_verts[16],
  Archimedean_icosidodecahedron_verts[17],
  Archimedean_icosidodecahedron_verts[18],
  Archimedean_icosidodecahedron_verts[19],
  Archimedean_icosidodecahedron_verts[20],
  Archimedean_icosidodecahedron_verts[21],
  Archimedean_icosidodecahedron_verts[22],
  Archimedean_icosidodecahedron_verts[23],
  Archimedean_icosidodecahedron_verts[24],
  Archimedean_icosidodecahedron_verts[25],
  Archimedean_icosidodecahedron_verts[26],
  Archimedean_icosidodecahedron_verts[27],
  Archimedean_icosidodecahedron_verts[28],
  Archimedean_icosidodecahedron_verts[29]
 }
 texture_list {
  2,
  texture { Tex3 },
  texture { Tex5 }
 }
 face_indices {
  56,
  <0, 1, 2>, 0,
  <0, 3, 4>, 0,
  <1, 6, 5>, 0,
  <2, 8, 7>, 0,
  <3, 10, 9>, 0,
  <4, 12, 11>, 0,
  <5, 13, 14>, 0,
  <6, 11, 15>, 0,
  <7, 16, 10>, 0,
  <8, 14, 17>, 0,
  <9, 18, 19>, 0,
  <12, 19, 20>, 0,
  <13, 22, 21>, 0,
  <15, 23, 22>, 0,
  <16, 25, 24>, 0,
  <17, 26, 25>, 0,
  <18, 24, 27>, 0,
  <20, 28, 23>, 0,
  <21, 29, 26>, 0,
  <27, 29, 28>, 0,
  <0, 2, 7>, 1,
  <0, 7, 10>, 1,
  <0, 10, 3>, 1,
  <0, 4, 11>, 1,
  <0, 11, 6>, 1,
  <0, 6, 1>, 1,
  <1, 5, 14>, 1,
  <1, 14, 8>, 1,
  <1, 8, 2>, 1,
  <3, 9, 19>, 1,
  <3, 19, 12>, 1,
  <3, 12, 4>, 1,
  <5, 6, 15>, 1,
  <5, 15, 22>, 1,
  <5, 22, 13>, 1,
  <7, 8, 17>, 1,
  <7, 17, 25>, 1,
  <7, 25, 16>, 1,
  <9, 10, 16>, 1,
  <9, 16, 24>, 1,
  <9, 24, 18>, 1,
  <11, 12, 20>, 1,
  <11, 20, 23>, 1,
  <11, 23, 15>, 1,
  <13, 21, 26>, 1,
  <13, 26, 17>, 1,
  <13, 17, 14>, 1,
  <18, 27, 28>, 1,
  <18, 28, 20>, 1,
  <18, 20, 19>, 1,
  <21, 22, 23>, 1,
  <21, 23, 28>, 1,
  <21, 28, 29>, 1,
  <24, 25, 26>, 1,
  <24, 26, 29>, 1,
  <24, 29, 27>, 1
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_icosidodecahedron_verts[24];
 #local P1 = Archimedean_icosidodecahedron_verts[25];
 #local P2 = Archimedean_icosidodecahedron_verts[26];
 #local P3 = Archimedean_icosidodecahedron_verts[29];
 #local P4 = Archimedean_icosidodecahedron_verts[27];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_icosidodecahedron_obj
  translate -(P0+P1+P2+P3+P4)/5
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_icosidodecahedron_obj }
#end
#end

#macro Archimedean_icosidodecahedron_faces2(OnPlane)
#local Archimedean_icosidodecahedron_obj = mesh2 {
 vertex_vectors {
  30,
  Archimedean_icosidodecahedron_verts[0],
  Archimedean_icosidodecahedron_verts[1],
  Archimedean_icosidodecahedron_verts[2],
  Archimedean_icosidodecahedron_verts[3],
  Archimedean_icosidodecahedron_verts[4],
  Archimedean_icosidodecahedron_verts[5],
  Archimedean_icosidodecahedron_verts[6],
  Archimedean_icosidodecahedron_verts[7],
  Archimedean_icosidodecahedron_verts[8],
  Archimedean_icosidodecahedron_verts[9],
  Archimedean_icosidodecahedron_verts[10],
  Archimedean_icosidodecahedron_verts[11],
  Archimedean_icosidodecahedron_verts[12],
  Archimedean_icosidodecahedron_verts[13],
  Archimedean_icosidodecahedron_verts[14],
  Archimedean_icosidodecahedron_verts[15],
  Archimedean_icosidodecahedron_verts[16],
  Archimedean_icosidodecahedron_verts[17],
  Archimedean_icosidodecahedron_verts[18],
  Archimedean_icosidodecahedron_verts[19],
  Archimedean_icosidodecahedron_verts[20],
  Archimedean_icosidodecahedron_verts[21],
  Archimedean_icosidodecahedron_verts[22],
  Archimedean_icosidodecahedron_verts[23],
  Archimedean_icosidodecahedron_verts[24],
  Archimedean_icosidodecahedron_verts[25],
  Archimedean_icosidodecahedron_verts[26],
  Archimedean_icosidodecahedron_verts[27],
  Archimedean_icosidodecahedron_verts[28],
  Archimedean_icosidodecahedron_verts[29]
 }
 face_indices {
  56,
  <0, 1, 2>,
  <0, 3, 4>,
  <1, 6, 5>,
  <2, 8, 7>,
  <3, 10, 9>,
  <4, 12, 11>,
  <5, 13, 14>,
  <6, 11, 15>,
  <7, 16, 10>,
  <8, 14, 17>,
  <9, 18, 19>,
  <12, 19, 20>,
  <13, 22, 21>,
  <15, 23, 22>,
  <16, 25, 24>,
  <17, 26, 25>,
  <18, 24, 27>,
  <20, 28, 23>,
  <21, 29, 26>,
  <27, 29, 28>,
  <0, 2, 7>,
  <0, 7, 10>,
  <0, 10, 3>,
  <0, 4, 11>,
  <0, 11, 6>,
  <0, 6, 1>,
  <1, 5, 14>,
  <1, 14, 8>,
  <1, 8, 2>,
  <3, 9, 19>,
  <3, 19, 12>,
  <3, 12, 4>,
  <5, 6, 15>,
  <5, 15, 22>,
  <5, 22, 13>,
  <7, 8, 17>,
  <7, 17, 25>,
  <7, 25, 16>,
  <9, 10, 16>,
  <9, 16, 24>,
  <9, 24, 18>,
  <11, 12, 20>,
  <11, 20, 23>,
  <11, 23, 15>,
  <13, 21, 26>,
  <13, 26, 17>,
  <13, 17, 14>,
  <18, 27, 28>,
  <18, 28, 20>,
  <18, 20, 19>,
  <21, 22, 23>,
  <21, 23, 28>,
  <21, 28, 29>,
  <24, 25, 26>,
  <24, 26, 29>,
  <24, 29, 27>
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_icosidodecahedron_verts[24];
 #local P1 = Archimedean_icosidodecahedron_verts[25];
 #local P2 = Archimedean_icosidodecahedron_verts[26];
 #local P3 = Archimedean_icosidodecahedron_verts[29];
 #local P4 = Archimedean_icosidodecahedron_verts[27];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_icosidodecahedron_obj
  translate -(P0+P1+P2+P3+P4)/5
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_icosidodecahedron_obj }
#end
#end

#macro Archimedean_icosidodecahedron_edges(RadEdg, RadVer, TexEdg, TexVer, OnPlane)
union {
 union {
  sphere { Archimedean_icosidodecahedron_verts[0], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[1], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[2], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[3], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[4], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[5], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[6], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[7], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[8], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[9], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[10], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[11], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[12], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[13], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[14], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[15], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[16], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[17], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[18], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[19], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[20], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[21], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[22], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[23], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[24], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[25], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[26], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[27], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[28], RadVer }
  sphere { Archimedean_icosidodecahedron_verts[29], RadVer }
  texture { TexVer } }
 union {
  cylinder { Archimedean_icosidodecahedron_verts[0], Archimedean_icosidodecahedron_verts[1], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[1], Archimedean_icosidodecahedron_verts[2], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[2], Archimedean_icosidodecahedron_verts[0], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[0], Archimedean_icosidodecahedron_verts[3], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[3], Archimedean_icosidodecahedron_verts[4], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[4], Archimedean_icosidodecahedron_verts[0], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[1], Archimedean_icosidodecahedron_verts[6], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[6], Archimedean_icosidodecahedron_verts[5], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[5], Archimedean_icosidodecahedron_verts[1], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[2], Archimedean_icosidodecahedron_verts[8], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[8], Archimedean_icosidodecahedron_verts[7], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[7], Archimedean_icosidodecahedron_verts[2], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[3], Archimedean_icosidodecahedron_verts[10], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[10], Archimedean_icosidodecahedron_verts[9], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[9], Archimedean_icosidodecahedron_verts[3], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[4], Archimedean_icosidodecahedron_verts[12], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[12], Archimedean_icosidodecahedron_verts[11], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[11], Archimedean_icosidodecahedron_verts[4], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[5], Archimedean_icosidodecahedron_verts[13], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[13], Archimedean_icosidodecahedron_verts[14], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[14], Archimedean_icosidodecahedron_verts[5], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[6], Archimedean_icosidodecahedron_verts[11], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[11], Archimedean_icosidodecahedron_verts[15], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[15], Archimedean_icosidodecahedron_verts[6], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[7], Archimedean_icosidodecahedron_verts[16], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[16], Archimedean_icosidodecahedron_verts[10], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[10], Archimedean_icosidodecahedron_verts[7], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[8], Archimedean_icosidodecahedron_verts[14], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[14], Archimedean_icosidodecahedron_verts[17], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[17], Archimedean_icosidodecahedron_verts[8], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[9], Archimedean_icosidodecahedron_verts[18], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[18], Archimedean_icosidodecahedron_verts[19], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[19], Archimedean_icosidodecahedron_verts[9], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[12], Archimedean_icosidodecahedron_verts[19], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[19], Archimedean_icosidodecahedron_verts[20], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[20], Archimedean_icosidodecahedron_verts[12], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[13], Archimedean_icosidodecahedron_verts[22], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[22], Archimedean_icosidodecahedron_verts[21], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[21], Archimedean_icosidodecahedron_verts[13], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[15], Archimedean_icosidodecahedron_verts[23], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[23], Archimedean_icosidodecahedron_verts[22], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[22], Archimedean_icosidodecahedron_verts[15], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[16], Archimedean_icosidodecahedron_verts[25], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[25], Archimedean_icosidodecahedron_verts[24], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[24], Archimedean_icosidodecahedron_verts[16], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[17], Archimedean_icosidodecahedron_verts[26], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[26], Archimedean_icosidodecahedron_verts[25], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[25], Archimedean_icosidodecahedron_verts[17], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[18], Archimedean_icosidodecahedron_verts[24], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[24], Archimedean_icosidodecahedron_verts[27], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[27], Archimedean_icosidodecahedron_verts[18], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[20], Archimedean_icosidodecahedron_verts[28], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[28], Archimedean_icosidodecahedron_verts[23], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[23], Archimedean_icosidodecahedron_verts[20], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[21], Archimedean_icosidodecahedron_verts[29], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[29], Archimedean_icosidodecahedron_verts[26], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[26], Archimedean_icosidodecahedron_verts[21], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[27], Archimedean_icosidodecahedron_verts[29], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[29], Archimedean_icosidodecahedron_verts[28], RadEdg }
  cylinder { Archimedean_icosidodecahedron_verts[28], Archimedean_icosidodecahedron_verts[27], RadEdg }
  texture { TexEdg } }
#if (OnPlane)
 #local P0 = Archimedean_icosidodecahedron_verts[24];
 #local P1 = Archimedean_icosidodecahedron_verts[25];
 #local P2 = Archimedean_icosidodecahedron_verts[26];
 #local P3 = Archimedean_icosidodecahedron_verts[29];
 #local P4 = Archimedean_icosidodecahedron_verts[27];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
  translate -(P0+P1+P2+P3+P4)/5
  Reorient_Trans(Axis, y)
  translate y*max(RadEdg, RadVer)
#end
 }
#end

#declare Archimedean_truncated_dodecahedron_verts = array[60]
{
<0, 0, 1.014485>,
<0.3367628, 0, 0.9569589>,
<-0.2902233, 0.1708204, 0.9569589>,
<0.1634681, -0.2944272, 0.9569589>,
<0.5914332, 0.1708204, 0.806354>,
<-0.5963465, 0.1527864, 0.806354>,
<-0.4230517, 0.4472136, 0.806354>,
<0.1377417, -0.6, 0.806354>,
<0.8302037, 0.1527864, 0.5626702>,
<0.6667356, 0.4472136, 0.6201961>,
<-0.8014407, -0.0472136, 0.6201961>,
<-0.3477493, 0.7236068, 0.6201961>,
<-0.06735256, -0.8, 0.6201961>,
<0.2694102, -0.8, 0.5626702>,
<0.9618722, -0.0472136, 0.3189863>,
<0.5339072, 0.7236068, 0.4695912>,
<-0.8271671, -0.3527864, 0.4695912>,
<-0.9599955, -0.0763932, 0.3189863>,
<-0.3992021, 0.8763932, 0.3189863>,
<-0.09307895, 0.8944272, 0.4695912>,
<-0.3734757, -0.818034, 0.4695912>,
<0.5081808, -0.818034, 0.3189863>,
<0.9361459, -0.3527864, 0.1683814>,
<1.011448, -0.0763932, -0.0177765>
<0.4824544, 0.8763932, 0.1683814>,
<0.2436839, 0.8944272, 0.4120653>,
<-0.663699, -0.6472136, 0.4120653>,
<-1.011448, 0.0763932, 0.0177765>,
<-0.5577569, 0.8472136, 0.0177765>,
<-0.5320305, -0.8472136, 0.1683814>,
<0.5577569, -0.8472136, -0.0177765>,
<0.7628511, -0.6472136, 0.1683814>,
<0.9599955, 0.0763932, -0.3189863>,
<0.5320305, 0.8472136, -0.1683814>,
<-0.9618722, 0.0472136, -0.3189863>,
<-0.9361459, 0.3527864, -0.1683814>,
<-0.7628511, 0.6472136, -0.1683814>,
<-0.5081808, 0.818034, -0.3189863>,
<-0.4824544, -0.8763932, -0.1683814>,
<0.3992021, -0.8763932, -0.3189863>,
<0.8014407, 0.0472136, -0.6201961>,
<0.8271671, 0.3527864, -0.4695912>,
<0.663699, 0.6472136, -0.4120653>,
<0.3734757, 0.818034, -0.4695912>,
<-0.8302037, -0.1527864, -0.5626702>,
<-0.2694102, 0.8, -0.5626702>,
<-0.5339072, -0.7236068, -0.4695912>,
<-0.2436839, -0.8944272, -0.4120653>,
<0.09307895, -0.8944272, -0.4695912>,
<0.3477493, -0.7236068, -0.6201961>,
<0.5963465, -0.1527864, -0.806354>,
<0.06735256, 0.8, -0.6201961>,
<-0.6667356, -0.4472136, -0.6201961>,
<-0.5914332, -0.1708204, -0.806354>,
<-0.1377417, 0.6, -0.806354>,
<0.4230517, -0.4472136, -0.806354>,
<0.2902233, -0.1708204, -0.9569589>,
<-0.3367628, 0, -0.9569589>,
<-0.1634681, 0.2944272, -0.9569589>,
<0, 0, -1.014485>,
}
#local P0 = Archimedean_truncated_dodecahedron_verts[46];
#local P1 = Archimedean_truncated_dodecahedron_verts[52];
#local P2 = Archimedean_truncated_dodecahedron_verts[53];
#local V1 = P1 - P0;
#local V2 = P2 - P0;
#local Axis = vcross(V2, V1);
#local Tran1 = transform { Reorient_Trans(Axis, y) }
#local TV1 = vtransform(V1, Tran1);
#local The_Tran = transform {
 Reorient_Trans(Axis, y)
 Reorient_Trans(TV1, x) }
#local Num = 0;
#while (Num < 60)
 #declare Archimedean_truncated_dodecahedron_verts[Num] = vtransform(Archimedean_truncated_dodecahedron_verts[Num], The_Tran);
 #local Num = Num + 1;
#end

#macro Archimedean_truncated_dodecahedron_faces(Tex3, Tex10, OnPlane)
#local Archimedean_truncated_dodecahedron_obj = mesh2 {
 vertex_vectors {
  60,
  Archimedean_truncated_dodecahedron_verts[0],
  Archimedean_truncated_dodecahedron_verts[1],
  Archimedean_truncated_dodecahedron_verts[2],
  Archimedean_truncated_dodecahedron_verts[3],
  Archimedean_truncated_dodecahedron_verts[4],
  Archimedean_truncated_dodecahedron_verts[5],
  Archimedean_truncated_dodecahedron_verts[6],
  Archimedean_truncated_dodecahedron_verts[7],
  Archimedean_truncated_dodecahedron_verts[8],
  Archimedean_truncated_dodecahedron_verts[9],
  Archimedean_truncated_dodecahedron_verts[10],
  Archimedean_truncated_dodecahedron_verts[11],
  Archimedean_truncated_dodecahedron_verts[12],
  Archimedean_truncated_dodecahedron_verts[13],
  Archimedean_truncated_dodecahedron_verts[14],
  Archimedean_truncated_dodecahedron_verts[15],
  Archimedean_truncated_dodecahedron_verts[16],
  Archimedean_truncated_dodecahedron_verts[17],
  Archimedean_truncated_dodecahedron_verts[18],
  Archimedean_truncated_dodecahedron_verts[19],
  Archimedean_truncated_dodecahedron_verts[20],
  Archimedean_truncated_dodecahedron_verts[21],
  Archimedean_truncated_dodecahedron_verts[22],
  Archimedean_truncated_dodecahedron_verts[23],
  Archimedean_truncated_dodecahedron_verts[24],
  Archimedean_truncated_dodecahedron_verts[25],
  Archimedean_truncated_dodecahedron_verts[26],
  Archimedean_truncated_dodecahedron_verts[27],
  Archimedean_truncated_dodecahedron_verts[28],
  Archimedean_truncated_dodecahedron_verts[29],
  Archimedean_truncated_dodecahedron_verts[30],
  Archimedean_truncated_dodecahedron_verts[31],
  Archimedean_truncated_dodecahedron_verts[32],
  Archimedean_truncated_dodecahedron_verts[33],
  Archimedean_truncated_dodecahedron_verts[34],
  Archimedean_truncated_dodecahedron_verts[35],
  Archimedean_truncated_dodecahedron_verts[36],
  Archimedean_truncated_dodecahedron_verts[37],
  Archimedean_truncated_dodecahedron_verts[38],
  Archimedean_truncated_dodecahedron_verts[39],
  Archimedean_truncated_dodecahedron_verts[40],
  Archimedean_truncated_dodecahedron_verts[41],
  Archimedean_truncated_dodecahedron_verts[42],
  Archimedean_truncated_dodecahedron_verts[43],
  Archimedean_truncated_dodecahedron_verts[44],
  Archimedean_truncated_dodecahedron_verts[45],
  Archimedean_truncated_dodecahedron_verts[46],
  Archimedean_truncated_dodecahedron_verts[47],
  Archimedean_truncated_dodecahedron_verts[48],
  Archimedean_truncated_dodecahedron_verts[49],
  Archimedean_truncated_dodecahedron_verts[50],
  Archimedean_truncated_dodecahedron_verts[51],
  Archimedean_truncated_dodecahedron_verts[52],
  Archimedean_truncated_dodecahedron_verts[53],
  Archimedean_truncated_dodecahedron_verts[54],
  Archimedean_truncated_dodecahedron_verts[55],
  Archimedean_truncated_dodecahedron_verts[56],
  Archimedean_truncated_dodecahedron_verts[57],
  Archimedean_truncated_dodecahedron_verts[58],
  Archimedean_truncated_dodecahedron_verts[59]
 }
 texture_list {
  2,
  texture { Tex3 },
  texture { Tex10 }
 }
 face_indices {
  116,
  <0, 3, 1>, 0,
  <2, 6, 5>, 0,
  <4, 8, 9>, 0,
  <7, 12, 13>, 0,
  <10, 17, 16>, 0,
  <11, 19, 18>, 0,
  <14, 22, 23>, 0,
  <15, 24, 25>, 0,
  <20, 26, 29>, 0,
  <21, 30, 31>, 0,
  <27, 35, 34>, 0,
  <28, 37, 36>, 0,
  <32, 40, 41>, 0,
  <33, 42, 43>, 0,
  <38, 46, 47>, 0,
  <39, 48, 49>, 0,
  <44, 53, 52>, 0,
  <45, 51, 54>, 0,
  <50, 55, 56>, 0,
  <57, 58, 59>, 0,
  <0, 1, 4>, 1,
  <0, 4, 9>, 1,
  <0, 9, 15>, 1,
  <0, 15, 25>, 1,
  <0, 25, 19>, 1,
  <0, 19, 11>, 1,
  <0, 11, 6>, 1,
  <0, 6, 2>, 1,
  <0, 2, 5>, 1,
  <0, 5, 10>, 1,
  <0, 10, 16>, 1,
  <0, 16, 26>, 1,
  <0, 26, 20>, 1,
  <0, 20, 12>, 1,
  <0, 12, 7>, 1,
  <0, 7, 3>, 1,
  <1, 3, 7>, 1,
  <1, 7, 13>, 1,
  <1, 13, 21>, 1,
  <1, 21, 31>, 1,
  <1, 31, 22>, 1,
  <1, 22, 14>, 1,
  <1, 14, 8>, 1,
  <1, 8, 4>, 1,
  <5, 6, 11>, 1,
  <5, 11, 18>, 1,
  <5, 18, 28>, 1,
  <5, 28, 36>, 1,
  <5, 36, 35>, 1,
  <5, 35, 27>, 1,
  <5, 27, 17>, 1,
  <5, 17, 10>, 1,
  <8, 14, 23>, 1,
  <8, 23, 32>, 1,
  <8, 32, 41>, 1,
  <8, 41, 42>, 1,
  <8, 42, 33>, 1,
  <8, 33, 24>, 1,
  <8, 24, 15>, 1,
  <8, 15, 9>, 1,
  <12, 20, 29>, 1,
  <12, 29, 38>, 1,
  <12, 38, 47>, 1,
  <12, 47, 48>, 1,
  <12, 48, 39>, 1,
  <12, 39, 30>, 1,
  <12, 30, 21>, 1,
  <12, 21, 13>, 1,
  <16, 17, 27>, 1,
  <16, 27, 34>, 1,
  <16, 34, 44>, 1,
  <16, 44, 52>, 1,
  <16, 52, 46>, 1,
  <16, 46, 38>, 1,
  <16, 38, 29>, 1,
  <16, 29, 26>, 1,
  <18, 19, 25>, 1,
  <18, 25, 24>, 1,
  <18, 24, 33>, 1,
  <18, 33, 43>, 1,
  <18, 43, 51>, 1,
  <18, 51, 45>, 1,
  <18, 45, 37>, 1,
  <18, 37, 28>, 1,
  <22, 31, 30>, 1,
  <22, 30, 39>, 1,
  <22, 39, 49>, 1,
  <22, 49, 55>, 1,
  <22, 55, 50>, 1,
  <22, 50, 40>, 1,
  <22, 40, 32>, 1,
  <22, 32, 23>, 1,
  <34, 35, 36>, 1,
  <34, 36, 37>, 1,
  <34, 37, 45>, 1,
  <34, 45, 54>, 1,
  <34, 54, 58>, 1,
  <34, 58, 57>, 1,
  <34, 57, 53>, 1,
  <34, 53, 44>, 1,
  <40, 50, 56>, 1,
  <40, 56, 59>, 1,
  <40, 59, 58>, 1,
  <40, 58, 54>, 1,
  <40, 54, 51>, 1,
  <40, 51, 43>, 1,
  <40, 43, 42>, 1,
  <40, 42, 41>, 1,
  <46, 52, 53>, 1,
  <46, 53, 57>, 1,
  <46, 57, 59>, 1,
  <46, 59, 56>, 1,
  <46, 56, 55>, 1,
  <46, 55, 49>, 1,
  <46, 49, 48>, 1,
  <46, 48, 47>, 1
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_truncated_dodecahedron_verts[46];
 #local P1 = Archimedean_truncated_dodecahedron_verts[52];
 #local P2 = Archimedean_truncated_dodecahedron_verts[53];
 #local P3 = Archimedean_truncated_dodecahedron_verts[57];
 #local P4 = Archimedean_truncated_dodecahedron_verts[59];
 #local P5 = Archimedean_truncated_dodecahedron_verts[56];
 #local P6 = Archimedean_truncated_dodecahedron_verts[55];
 #local P7 = Archimedean_truncated_dodecahedron_verts[49];
 #local P8 = Archimedean_truncated_dodecahedron_verts[48];
 #local P9 = Archimedean_truncated_dodecahedron_verts[47];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_truncated_dodecahedron_obj
  translate -(P0+P1+P2+P3+P4+P5+P6+P7+P8+P9)/10
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_truncated_dodecahedron_obj }
#end
#end

#macro Archimedean_truncated_dodecahedron_faces2(OnPlane)
#local Archimedean_truncated_dodecahedron_obj = mesh2 {
 vertex_vectors {
  60,
  Archimedean_truncated_dodecahedron_verts[0],
  Archimedean_truncated_dodecahedron_verts[1],
  Archimedean_truncated_dodecahedron_verts[2],
  Archimedean_truncated_dodecahedron_verts[3],
  Archimedean_truncated_dodecahedron_verts[4],
  Archimedean_truncated_dodecahedron_verts[5],
  Archimedean_truncated_dodecahedron_verts[6],
  Archimedean_truncated_dodecahedron_verts[7],
  Archimedean_truncated_dodecahedron_verts[8],
  Archimedean_truncated_dodecahedron_verts[9],
  Archimedean_truncated_dodecahedron_verts[10],
  Archimedean_truncated_dodecahedron_verts[11],
  Archimedean_truncated_dodecahedron_verts[12],
  Archimedean_truncated_dodecahedron_verts[13],
  Archimedean_truncated_dodecahedron_verts[14],
  Archimedean_truncated_dodecahedron_verts[15],
  Archimedean_truncated_dodecahedron_verts[16],
  Archimedean_truncated_dodecahedron_verts[17],
  Archimedean_truncated_dodecahedron_verts[18],
  Archimedean_truncated_dodecahedron_verts[19],
  Archimedean_truncated_dodecahedron_verts[20],
  Archimedean_truncated_dodecahedron_verts[21],
  Archimedean_truncated_dodecahedron_verts[22],
  Archimedean_truncated_dodecahedron_verts[23],
  Archimedean_truncated_dodecahedron_verts[24],
  Archimedean_truncated_dodecahedron_verts[25],
  Archimedean_truncated_dodecahedron_verts[26],
  Archimedean_truncated_dodecahedron_verts[27],
  Archimedean_truncated_dodecahedron_verts[28],
  Archimedean_truncated_dodecahedron_verts[29],
  Archimedean_truncated_dodecahedron_verts[30],
  Archimedean_truncated_dodecahedron_verts[31],
  Archimedean_truncated_dodecahedron_verts[32],
  Archimedean_truncated_dodecahedron_verts[33],
  Archimedean_truncated_dodecahedron_verts[34],
  Archimedean_truncated_dodecahedron_verts[35],
  Archimedean_truncated_dodecahedron_verts[36],
  Archimedean_truncated_dodecahedron_verts[37],
  Archimedean_truncated_dodecahedron_verts[38],
  Archimedean_truncated_dodecahedron_verts[39],
  Archimedean_truncated_dodecahedron_verts[40],
  Archimedean_truncated_dodecahedron_verts[41],
  Archimedean_truncated_dodecahedron_verts[42],
  Archimedean_truncated_dodecahedron_verts[43],
  Archimedean_truncated_dodecahedron_verts[44],
  Archimedean_truncated_dodecahedron_verts[45],
  Archimedean_truncated_dodecahedron_verts[46],
  Archimedean_truncated_dodecahedron_verts[47],
  Archimedean_truncated_dodecahedron_verts[48],
  Archimedean_truncated_dodecahedron_verts[49],
  Archimedean_truncated_dodecahedron_verts[50],
  Archimedean_truncated_dodecahedron_verts[51],
  Archimedean_truncated_dodecahedron_verts[52],
  Archimedean_truncated_dodecahedron_verts[53],
  Archimedean_truncated_dodecahedron_verts[54],
  Archimedean_truncated_dodecahedron_verts[55],
  Archimedean_truncated_dodecahedron_verts[56],
  Archimedean_truncated_dodecahedron_verts[57],
  Archimedean_truncated_dodecahedron_verts[58],
  Archimedean_truncated_dodecahedron_verts[59]
 }
 face_indices {
  116,
  <0, 3, 1>,
  <2, 6, 5>,
  <4, 8, 9>,
  <7, 12, 13>,
  <10, 17, 16>,
  <11, 19, 18>,
  <14, 22, 23>,
  <15, 24, 25>,
  <20, 26, 29>,
  <21, 30, 31>,
  <27, 35, 34>,
  <28, 37, 36>,
  <32, 40, 41>,
  <33, 42, 43>,
  <38, 46, 47>,
  <39, 48, 49>,
  <44, 53, 52>,
  <45, 51, 54>,
  <50, 55, 56>,
  <57, 58, 59>,
  <0, 1, 4>,
  <0, 4, 9>,
  <0, 9, 15>,
  <0, 15, 25>,
  <0, 25, 19>,
  <0, 19, 11>,
  <0, 11, 6>,
  <0, 6, 2>,
  <0, 2, 5>,
  <0, 5, 10>,
  <0, 10, 16>,
  <0, 16, 26>,
  <0, 26, 20>,
  <0, 20, 12>,
  <0, 12, 7>,
  <0, 7, 3>,
  <1, 3, 7>,
  <1, 7, 13>,
  <1, 13, 21>,
  <1, 21, 31>,
  <1, 31, 22>,
  <1, 22, 14>,
  <1, 14, 8>,
  <1, 8, 4>,
  <5, 6, 11>,
  <5, 11, 18>,
  <5, 18, 28>,
  <5, 28, 36>,
  <5, 36, 35>,
  <5, 35, 27>,
  <5, 27, 17>,
  <5, 17, 10>,
  <8, 14, 23>,
  <8, 23, 32>,
  <8, 32, 41>,
  <8, 41, 42>,
  <8, 42, 33>,
  <8, 33, 24>,
  <8, 24, 15>,
  <8, 15, 9>,
  <12, 20, 29>,
  <12, 29, 38>,
  <12, 38, 47>,
  <12, 47, 48>,
  <12, 48, 39>,
  <12, 39, 30>,
  <12, 30, 21>,
  <12, 21, 13>,
  <16, 17, 27>,
  <16, 27, 34>,
  <16, 34, 44>,
  <16, 44, 52>,
  <16, 52, 46>,
  <16, 46, 38>,
  <16, 38, 29>,
  <16, 29, 26>,
  <18, 19, 25>,
  <18, 25, 24>,
  <18, 24, 33>,
  <18, 33, 43>,
  <18, 43, 51>,
  <18, 51, 45>,
  <18, 45, 37>,
  <18, 37, 28>,
  <22, 31, 30>,
  <22, 30, 39>,
  <22, 39, 49>,
  <22, 49, 55>,
  <22, 55, 50>,
  <22, 50, 40>,
  <22, 40, 32>,
  <22, 32, 23>,
  <34, 35, 36>,
  <34, 36, 37>,
  <34, 37, 45>,
  <34, 45, 54>,
  <34, 54, 58>,
  <34, 58, 57>,
  <34, 57, 53>,
  <34, 53, 44>,
  <40, 50, 56>,
  <40, 56, 59>,
  <40, 59, 58>,
  <40, 58, 54>,
  <40, 54, 51>,
  <40, 51, 43>,
  <40, 43, 42>,
  <40, 42, 41>,
  <46, 52, 53>,
  <46, 53, 57>,
  <46, 57, 59>,
  <46, 59, 56>,
  <46, 56, 55>,
  <46, 55, 49>,
  <46, 49, 48>,
  <46, 48, 47>
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_truncated_dodecahedron_verts[46];
 #local P1 = Archimedean_truncated_dodecahedron_verts[52];
 #local P2 = Archimedean_truncated_dodecahedron_verts[53];
 #local P3 = Archimedean_truncated_dodecahedron_verts[57];
 #local P4 = Archimedean_truncated_dodecahedron_verts[59];
 #local P5 = Archimedean_truncated_dodecahedron_verts[56];
 #local P6 = Archimedean_truncated_dodecahedron_verts[55];
 #local P7 = Archimedean_truncated_dodecahedron_verts[49];
 #local P8 = Archimedean_truncated_dodecahedron_verts[48];
 #local P9 = Archimedean_truncated_dodecahedron_verts[47];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_truncated_dodecahedron_obj
  translate -(P0+P1+P2+P3+P4+P5+P6+P7+P8+P9)/10
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_truncated_dodecahedron_obj }
#end
#end

#macro Archimedean_truncated_dodecahedron_edges(RadEdg, RadVer, TexEdg, TexVer, OnPlane)
union {
 union {
  sphere { Archimedean_truncated_dodecahedron_verts[0], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[1], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[2], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[3], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[4], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[5], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[6], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[7], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[8], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[9], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[10], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[11], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[12], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[13], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[14], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[15], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[16], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[17], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[18], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[19], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[20], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[21], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[22], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[23], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[24], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[25], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[26], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[27], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[28], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[29], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[30], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[31], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[32], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[33], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[34], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[35], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[36], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[37], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[38], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[39], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[40], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[41], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[42], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[43], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[44], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[45], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[46], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[47], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[48], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[49], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[50], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[51], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[52], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[53], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[54], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[55], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[56], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[57], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[58], RadVer }
  sphere { Archimedean_truncated_dodecahedron_verts[59], RadVer }
  texture { TexVer } }
 union {
  cylinder { Archimedean_truncated_dodecahedron_verts[0], Archimedean_truncated_dodecahedron_verts[3], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[3], Archimedean_truncated_dodecahedron_verts[1], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[1], Archimedean_truncated_dodecahedron_verts[0], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[2], Archimedean_truncated_dodecahedron_verts[6], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[6], Archimedean_truncated_dodecahedron_verts[5], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[5], Archimedean_truncated_dodecahedron_verts[2], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[4], Archimedean_truncated_dodecahedron_verts[8], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[8], Archimedean_truncated_dodecahedron_verts[9], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[9], Archimedean_truncated_dodecahedron_verts[4], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[7], Archimedean_truncated_dodecahedron_verts[12], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[12], Archimedean_truncated_dodecahedron_verts[13], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[13], Archimedean_truncated_dodecahedron_verts[7], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[10], Archimedean_truncated_dodecahedron_verts[17], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[17], Archimedean_truncated_dodecahedron_verts[16], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[16], Archimedean_truncated_dodecahedron_verts[10], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[11], Archimedean_truncated_dodecahedron_verts[19], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[19], Archimedean_truncated_dodecahedron_verts[18], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[18], Archimedean_truncated_dodecahedron_verts[11], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[14], Archimedean_truncated_dodecahedron_verts[22], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[22], Archimedean_truncated_dodecahedron_verts[23], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[23], Archimedean_truncated_dodecahedron_verts[14], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[15], Archimedean_truncated_dodecahedron_verts[24], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[24], Archimedean_truncated_dodecahedron_verts[25], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[25], Archimedean_truncated_dodecahedron_verts[15], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[20], Archimedean_truncated_dodecahedron_verts[26], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[26], Archimedean_truncated_dodecahedron_verts[29], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[29], Archimedean_truncated_dodecahedron_verts[20], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[21], Archimedean_truncated_dodecahedron_verts[30], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[30], Archimedean_truncated_dodecahedron_verts[31], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[31], Archimedean_truncated_dodecahedron_verts[21], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[27], Archimedean_truncated_dodecahedron_verts[35], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[35], Archimedean_truncated_dodecahedron_verts[34], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[34], Archimedean_truncated_dodecahedron_verts[27], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[28], Archimedean_truncated_dodecahedron_verts[37], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[37], Archimedean_truncated_dodecahedron_verts[36], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[36], Archimedean_truncated_dodecahedron_verts[28], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[32], Archimedean_truncated_dodecahedron_verts[40], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[40], Archimedean_truncated_dodecahedron_verts[41], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[41], Archimedean_truncated_dodecahedron_verts[32], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[33], Archimedean_truncated_dodecahedron_verts[42], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[42], Archimedean_truncated_dodecahedron_verts[43], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[43], Archimedean_truncated_dodecahedron_verts[33], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[38], Archimedean_truncated_dodecahedron_verts[46], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[46], Archimedean_truncated_dodecahedron_verts[47], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[47], Archimedean_truncated_dodecahedron_verts[38], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[39], Archimedean_truncated_dodecahedron_verts[48], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[48], Archimedean_truncated_dodecahedron_verts[49], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[49], Archimedean_truncated_dodecahedron_verts[39], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[44], Archimedean_truncated_dodecahedron_verts[53], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[53], Archimedean_truncated_dodecahedron_verts[52], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[52], Archimedean_truncated_dodecahedron_verts[44], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[45], Archimedean_truncated_dodecahedron_verts[51], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[51], Archimedean_truncated_dodecahedron_verts[54], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[54], Archimedean_truncated_dodecahedron_verts[45], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[50], Archimedean_truncated_dodecahedron_verts[55], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[55], Archimedean_truncated_dodecahedron_verts[56], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[56], Archimedean_truncated_dodecahedron_verts[50], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[57], Archimedean_truncated_dodecahedron_verts[58], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[58], Archimedean_truncated_dodecahedron_verts[59], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[59], Archimedean_truncated_dodecahedron_verts[57], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[1], Archimedean_truncated_dodecahedron_verts[4], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[9], Archimedean_truncated_dodecahedron_verts[15], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[25], Archimedean_truncated_dodecahedron_verts[19], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[11], Archimedean_truncated_dodecahedron_verts[6], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[2], Archimedean_truncated_dodecahedron_verts[0], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[5], Archimedean_truncated_dodecahedron_verts[10], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[16], Archimedean_truncated_dodecahedron_verts[26], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[20], Archimedean_truncated_dodecahedron_verts[12], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[7], Archimedean_truncated_dodecahedron_verts[3], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[13], Archimedean_truncated_dodecahedron_verts[21], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[31], Archimedean_truncated_dodecahedron_verts[22], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[14], Archimedean_truncated_dodecahedron_verts[8], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[18], Archimedean_truncated_dodecahedron_verts[28], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[36], Archimedean_truncated_dodecahedron_verts[35], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[27], Archimedean_truncated_dodecahedron_verts[17], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[23], Archimedean_truncated_dodecahedron_verts[32], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[41], Archimedean_truncated_dodecahedron_verts[42], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[33], Archimedean_truncated_dodecahedron_verts[24], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[29], Archimedean_truncated_dodecahedron_verts[38], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[47], Archimedean_truncated_dodecahedron_verts[48], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[39], Archimedean_truncated_dodecahedron_verts[30], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[34], Archimedean_truncated_dodecahedron_verts[44], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[52], Archimedean_truncated_dodecahedron_verts[46], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[43], Archimedean_truncated_dodecahedron_verts[51], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[45], Archimedean_truncated_dodecahedron_verts[37], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[49], Archimedean_truncated_dodecahedron_verts[55], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[50], Archimedean_truncated_dodecahedron_verts[40], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[54], Archimedean_truncated_dodecahedron_verts[58], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[57], Archimedean_truncated_dodecahedron_verts[53], RadEdg }
  cylinder { Archimedean_truncated_dodecahedron_verts[56], Archimedean_truncated_dodecahedron_verts[59], RadEdg }
  texture { TexEdg } }
#if (OnPlane)
 #local P0 = Archimedean_truncated_dodecahedron_verts[46];
 #local P1 = Archimedean_truncated_dodecahedron_verts[52];
 #local P2 = Archimedean_truncated_dodecahedron_verts[53];
 #local P3 = Archimedean_truncated_dodecahedron_verts[57];
 #local P4 = Archimedean_truncated_dodecahedron_verts[59];
 #local P5 = Archimedean_truncated_dodecahedron_verts[56];
 #local P6 = Archimedean_truncated_dodecahedron_verts[55];
 #local P7 = Archimedean_truncated_dodecahedron_verts[49];
 #local P8 = Archimedean_truncated_dodecahedron_verts[48];
 #local P9 = Archimedean_truncated_dodecahedron_verts[47];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
  translate -(P0+P1+P2+P3+P4+P5+P6+P7+P8+P9)/10
  Reorient_Trans(Axis, y)
  translate y*max(RadEdg, RadVer)
#end
 }
#end

#declare Archimedean_truncated_icosahedron_verts = array[60]
{
<0, 0, 1.021>,
<0.4035482, 0, 0.9378643>,
<-0.2274644, 0.3333333, 0.9378643>,
<-0.1471226, -0.375774, 0.9378643>,
<0.579632, 0.3333333, 0.7715933>,
<0.5058321, -0.375774, 0.8033483>,
<-0.6020514, 0.2908927, 0.7715933>,
<-0.05138057, 0.6666667, 0.7715933>,
<0.1654988, -0.6080151, 0.8033483>,
<-0.5217096, -0.4182147, 0.7715933>,
<0.8579998, 0.2908927, 0.4708062>,
<0.3521676, 0.6666667, 0.6884578>,
<0.7841999, -0.4182147, 0.5025612>,
<-0.657475, 0.5979962, 0.5025612>,
<-0.749174, -0.08488134, 0.6884578>,
<-0.3171418, 0.8302373, 0.5025612>,
<0.1035333, -0.8826969, 0.5025612>,
<-0.5836751, -0.6928964, 0.4708062>,
<0.8025761, 0.5979962, 0.2017741>,
<0.9602837, -0.08488134, 0.3362902>,
<0.4899547, 0.8302373, 0.3362902>,
<0.7222343, -0.6928964, 0.2017741>,
<-0.8600213, 0.5293258, 0.1503935>,
<-0.9517203, -0.1535518, 0.3362902>
<-0.1793548, 0.993808, 0.1503935>,
<0.381901, -0.9251375, 0.2017741>,
<-0.2710537, -0.9251375, 0.3362902>,
<-0.8494363, -0.5293258, 0.2017741>,
<0.8494363, 0.5293258, -0.2017741>,
<1.007144, -0.1535518, -0.06725804>,
<0.2241935, 0.993808, 0.06725804>,
<0.8600213, -0.5293258, -0.1503935>,
<-0.7222343, 0.6928964, -0.2017741>,
<-1.007144, 0.1535518, 0.06725804>,
<-0.381901, 0.9251375, -0.2017741>,
<0.1793548, -0.993808, -0.1503935>,
<-0.2241935, -0.993808, -0.06725804>,
<-0.8025761, -0.5979962, -0.2017741>,
<0.5836751, 0.6928964, -0.4708062>,
<0.9517203, 0.1535518, -0.3362902>,
<0.2710537, 0.9251375, -0.3362902>,
<0.657475, -0.5979962, -0.5025612>,
<-0.7841999, 0.4182147, -0.5025612>,
<-0.9602837, 0.08488134, -0.3362902>,
<-0.1035333, 0.8826969, -0.5025612>,
<0.3171418, -0.8302373, -0.5025612>,
<-0.4899547, -0.8302373, -0.3362902>,
<-0.8579998, -0.2908927, -0.4708062>,
<0.5217096, 0.4182147, -0.7715933>,
<0.749174, 0.08488134, -0.6884578>,
<0.6020514, -0.2908927, -0.7715933>,
<-0.5058321, 0.375774, -0.8033483>,
<-0.1654988, 0.6080151, -0.8033483>,
<0.05138057, -0.6666667, -0.7715933>,
<-0.3521676, -0.6666667, -0.6884578>,
<-0.579632, -0.3333333, -0.7715933>,
<0.1471226, 0.375774, -0.9378643>,
<0.2274644, -0.3333333, -0.9378643>,
<-0.4035482, 0, -0.9378643>,
<0, 0, -1.021>,
}
#local P0 = Archimedean_truncated_icosahedron_verts[53];
#local P1 = Archimedean_truncated_icosahedron_verts[54];
#local P2 = Archimedean_truncated_icosahedron_verts[55];
#local V1 = P1 - P0;
#local V2 = P2 - P0;
#local Axis = vcross(V2, V1);
#local Tran1 = transform { Reorient_Trans(Axis, y) }
#local TV1 = vtransform(V1, Tran1);
#local The_Tran = transform {
 Reorient_Trans(Axis, y)
 Reorient_Trans(TV1, x) }
#local Num = 0;
#while (Num < 60)
 #declare Archimedean_truncated_icosahedron_verts[Num] = vtransform(Archimedean_truncated_icosahedron_verts[Num], The_Tran);
 #local Num = Num + 1;
#end

#macro Archimedean_truncated_icosahedron_faces(Tex5, Tex6, OnPlane)
#local Archimedean_truncated_icosahedron_obj = mesh2 {
 vertex_vectors {
  60,
  Archimedean_truncated_icosahedron_verts[0],
  Archimedean_truncated_icosahedron_verts[1],
  Archimedean_truncated_icosahedron_verts[2],
  Archimedean_truncated_icosahedron_verts[3],
  Archimedean_truncated_icosahedron_verts[4],
  Archimedean_truncated_icosahedron_verts[5],
  Archimedean_truncated_icosahedron_verts[6],
  Archimedean_truncated_icosahedron_verts[7],
  Archimedean_truncated_icosahedron_verts[8],
  Archimedean_truncated_icosahedron_verts[9],
  Archimedean_truncated_icosahedron_verts[10],
  Archimedean_truncated_icosahedron_verts[11],
  Archimedean_truncated_icosahedron_verts[12],
  Archimedean_truncated_icosahedron_verts[13],
  Archimedean_truncated_icosahedron_verts[14],
  Archimedean_truncated_icosahedron_verts[15],
  Archimedean_truncated_icosahedron_verts[16],
  Archimedean_truncated_icosahedron_verts[17],
  Archimedean_truncated_icosahedron_verts[18],
  Archimedean_truncated_icosahedron_verts[19],
  Archimedean_truncated_icosahedron_verts[20],
  Archimedean_truncated_icosahedron_verts[21],
  Archimedean_truncated_icosahedron_verts[22],
  Archimedean_truncated_icosahedron_verts[23],
  Archimedean_truncated_icosahedron_verts[24],
  Archimedean_truncated_icosahedron_verts[25],
  Archimedean_truncated_icosahedron_verts[26],
  Archimedean_truncated_icosahedron_verts[27],
  Archimedean_truncated_icosahedron_verts[28],
  Archimedean_truncated_icosahedron_verts[29],
  Archimedean_truncated_icosahedron_verts[30],
  Archimedean_truncated_icosahedron_verts[31],
  Archimedean_truncated_icosahedron_verts[32],
  Archimedean_truncated_icosahedron_verts[33],
  Archimedean_truncated_icosahedron_verts[34],
  Archimedean_truncated_icosahedron_verts[35],
  Archimedean_truncated_icosahedron_verts[36],
  Archimedean_truncated_icosahedron_verts[37],
  Archimedean_truncated_icosahedron_verts[38],
  Archimedean_truncated_icosahedron_verts[39],
  Archimedean_truncated_icosahedron_verts[40],
  Archimedean_truncated_icosahedron_verts[41],
  Archimedean_truncated_icosahedron_verts[42],
  Archimedean_truncated_icosahedron_verts[43],
  Archimedean_truncated_icosahedron_verts[44],
  Archimedean_truncated_icosahedron_verts[45],
  Archimedean_truncated_icosahedron_verts[46],
  Archimedean_truncated_icosahedron_verts[47],
  Archimedean_truncated_icosahedron_verts[48],
  Archimedean_truncated_icosahedron_verts[49],
  Archimedean_truncated_icosahedron_verts[50],
  Archimedean_truncated_icosahedron_verts[51],
  Archimedean_truncated_icosahedron_verts[52],
  Archimedean_truncated_icosahedron_verts[53],
  Archimedean_truncated_icosahedron_verts[54],
  Archimedean_truncated_icosahedron_verts[55],
  Archimedean_truncated_icosahedron_verts[56],
  Archimedean_truncated_icosahedron_verts[57],
  Archimedean_truncated_icosahedron_verts[58],
  Archimedean_truncated_icosahedron_verts[59]
 }
 texture_list {
  2,
  texture { Tex5 },
  texture { Tex6 }
 }
 face_indices {
  116,
  <0, 3, 8>, 0,
  <0, 8, 5>, 0,
  <0, 5, 1>, 0,
  <2, 7, 15>, 0,
  <2, 15, 13>, 0,
  <2, 13, 6>, 0,
  <4, 10, 18>, 0,
  <4, 18, 20>, 0,
  <4, 20, 11>, 0,
  <9, 14, 23>, 0,
  <9, 23, 27>, 0,
  <9, 27, 17>, 0,
  <12, 21, 31>, 0,
  <12, 31, 29>, 0,
  <12, 29, 19>, 0,
  <16, 26, 36>, 0,
  <16, 36, 35>, 0,
  <16, 35, 25>, 0,
  <22, 32, 42>, 0,
  <22, 42, 43>, 0,
  <22, 43, 33>, 0,
  <24, 30, 40>, 0,
  <24, 40, 44>, 0,
  <24, 44, 34>, 0,
  <28, 39, 49>, 0,
  <28, 49, 48>, 0,
  <28, 48, 38>, 0,
  <37, 47, 55>, 0,
  <37, 55, 54>, 0,
  <37, 54, 46>, 0,
  <41, 45, 53>, 0,
  <41, 53, 57>, 0,
  <41, 57, 50>, 0,
  <51, 52, 56>, 0,
  <51, 56, 59>, 0,
  <51, 59, 58>, 0,
  <0, 1, 4>, 1,
  <0, 4, 11>, 1,
  <0, 11, 7>, 1,
  <0, 7, 2>, 1,
  <0, 2, 6>, 1,
  <0, 6, 14>, 1,
  <0, 14, 9>, 1,
  <0, 9, 3>, 1,
  <1, 5, 12>, 1,
  <1, 12, 19>, 1,
  <1, 19, 10>, 1,
  <1, 10, 4>, 1,
  <3, 9, 17>, 1,
  <3, 17, 26>, 1,
  <3, 26, 16>, 1,
  <3, 16, 8>, 1,
  <5, 8, 16>, 1,
  <5, 16, 25>, 1,
  <5, 25, 21>, 1,
  <5, 21, 12>, 1,
  <6, 13, 22>, 1,
  <6, 22, 33>, 1,
  <6, 33, 23>, 1,
  <6, 23, 14>, 1,
  <7, 11, 20>, 1,
  <7, 20, 30>, 1,
  <7, 30, 24>, 1,
  <7, 24, 15>, 1,
  <10, 19, 29>, 1,
  <10, 29, 39>, 1,
  <10, 39, 28>, 1,
  <10, 28, 18>, 1,
  <13, 15, 24>, 1,
  <13, 24, 34>, 1,
  <13, 34, 32>, 1,
  <13, 32, 22>, 1,
  <17, 27, 37>, 1,
  <17, 37, 46>, 1,
  <17, 46, 36>, 1,
  <17, 36, 26>, 1,
  <18, 28, 38>, 1,
  <18, 38, 40>, 1,
  <18, 40, 30>, 1,
  <18, 30, 20>, 1,
  <21, 25, 35>, 1,
  <21, 35, 45>, 1,
  <21, 45, 41>, 1,
  <21, 41, 31>, 1,
  <23, 33, 43>, 1,
  <23, 43, 47>, 1,
  <23, 47, 37>, 1,
  <23, 37, 27>, 1,
  <29, 31, 41>, 1,
  <29, 41, 50>, 1,
  <29, 50, 49>, 1,
  <29, 49, 39>, 1,
  <32, 34, 44>, 1,
  <32, 44, 52>, 1,
  <32, 52, 51>, 1,
  <32, 51, 42>, 1,
  <35, 36, 46>, 1,
  <35, 46, 54>, 1,
  <35, 54, 53>, 1,
  <35, 53, 45>, 1,
  <38, 48, 56>, 1,
  <38, 56, 52>, 1,
  <38, 52, 44>, 1,
  <38, 44, 40>, 1,
  <42, 51, 58>, 1,
  <42, 58, 55>, 1,
  <42, 55, 47>, 1,
  <42, 47, 43>, 1,
  <48, 49, 50>, 1,
  <48, 50, 57>, 1,
  <48, 57, 59>, 1,
  <48, 59, 56>, 1,
  <53, 54, 55>, 1,
  <53, 55, 58>, 1,
  <53, 58, 59>, 1,
  <53, 59, 57>, 1
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_truncated_icosahedron_verts[53];
 #local P1 = Archimedean_truncated_icosahedron_verts[54];
 #local P2 = Archimedean_truncated_icosahedron_verts[55];
 #local P3 = Archimedean_truncated_icosahedron_verts[58];
 #local P4 = Archimedean_truncated_icosahedron_verts[59];
 #local P5 = Archimedean_truncated_icosahedron_verts[57];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_truncated_icosahedron_obj
  translate -(P0+P1+P2+P3+P4+P5)/6
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_truncated_icosahedron_obj }
#end
#end

#macro Archimedean_truncated_icosahedron_faces2(OnPlane)
#local Archimedean_truncated_icosahedron_obj = mesh2 {
 vertex_vectors {
  60,
  Archimedean_truncated_icosahedron_verts[0],
  Archimedean_truncated_icosahedron_verts[1],
  Archimedean_truncated_icosahedron_verts[2],
  Archimedean_truncated_icosahedron_verts[3],
  Archimedean_truncated_icosahedron_verts[4],
  Archimedean_truncated_icosahedron_verts[5],
  Archimedean_truncated_icosahedron_verts[6],
  Archimedean_truncated_icosahedron_verts[7],
  Archimedean_truncated_icosahedron_verts[8],
  Archimedean_truncated_icosahedron_verts[9],
  Archimedean_truncated_icosahedron_verts[10],
  Archimedean_truncated_icosahedron_verts[11],
  Archimedean_truncated_icosahedron_verts[12],
  Archimedean_truncated_icosahedron_verts[13],
  Archimedean_truncated_icosahedron_verts[14],
  Archimedean_truncated_icosahedron_verts[15],
  Archimedean_truncated_icosahedron_verts[16],
  Archimedean_truncated_icosahedron_verts[17],
  Archimedean_truncated_icosahedron_verts[18],
  Archimedean_truncated_icosahedron_verts[19],
  Archimedean_truncated_icosahedron_verts[20],
  Archimedean_truncated_icosahedron_verts[21],
  Archimedean_truncated_icosahedron_verts[22],
  Archimedean_truncated_icosahedron_verts[23],
  Archimedean_truncated_icosahedron_verts[24],
  Archimedean_truncated_icosahedron_verts[25],
  Archimedean_truncated_icosahedron_verts[26],
  Archimedean_truncated_icosahedron_verts[27],
  Archimedean_truncated_icosahedron_verts[28],
  Archimedean_truncated_icosahedron_verts[29],
  Archimedean_truncated_icosahedron_verts[30],
  Archimedean_truncated_icosahedron_verts[31],
  Archimedean_truncated_icosahedron_verts[32],
  Archimedean_truncated_icosahedron_verts[33],
  Archimedean_truncated_icosahedron_verts[34],
  Archimedean_truncated_icosahedron_verts[35],
  Archimedean_truncated_icosahedron_verts[36],
  Archimedean_truncated_icosahedron_verts[37],
  Archimedean_truncated_icosahedron_verts[38],
  Archimedean_truncated_icosahedron_verts[39],
  Archimedean_truncated_icosahedron_verts[40],
  Archimedean_truncated_icosahedron_verts[41],
  Archimedean_truncated_icosahedron_verts[42],
  Archimedean_truncated_icosahedron_verts[43],
  Archimedean_truncated_icosahedron_verts[44],
  Archimedean_truncated_icosahedron_verts[45],
  Archimedean_truncated_icosahedron_verts[46],
  Archimedean_truncated_icosahedron_verts[47],
  Archimedean_truncated_icosahedron_verts[48],
  Archimedean_truncated_icosahedron_verts[49],
  Archimedean_truncated_icosahedron_verts[50],
  Archimedean_truncated_icosahedron_verts[51],
  Archimedean_truncated_icosahedron_verts[52],
  Archimedean_truncated_icosahedron_verts[53],
  Archimedean_truncated_icosahedron_verts[54],
  Archimedean_truncated_icosahedron_verts[55],
  Archimedean_truncated_icosahedron_verts[56],
  Archimedean_truncated_icosahedron_verts[57],
  Archimedean_truncated_icosahedron_verts[58],
  Archimedean_truncated_icosahedron_verts[59]
 }
 face_indices {
  116,
  <0, 3, 8>,
  <0, 8, 5>,
  <0, 5, 1>,
  <2, 7, 15>,
  <2, 15, 13>,
  <2, 13, 6>,
  <4, 10, 18>,
  <4, 18, 20>,
  <4, 20, 11>,
  <9, 14, 23>,
  <9, 23, 27>,
  <9, 27, 17>,
  <12, 21, 31>,
  <12, 31, 29>,
  <12, 29, 19>,
  <16, 26, 36>,
  <16, 36, 35>,
  <16, 35, 25>,
  <22, 32, 42>,
  <22, 42, 43>,
  <22, 43, 33>,
  <24, 30, 40>,
  <24, 40, 44>,
  <24, 44, 34>,
  <28, 39, 49>,
  <28, 49, 48>,
  <28, 48, 38>,
  <37, 47, 55>,
  <37, 55, 54>,
  <37, 54, 46>,
  <41, 45, 53>,
  <41, 53, 57>,
  <41, 57, 50>,
  <51, 52, 56>,
  <51, 56, 59>,
  <51, 59, 58>,
  <0, 1, 4>,
  <0, 4, 11>,
  <0, 11, 7>,
  <0, 7, 2>,
  <0, 2, 6>,
  <0, 6, 14>,
  <0, 14, 9>,
  <0, 9, 3>,
  <1, 5, 12>,
  <1, 12, 19>,
  <1, 19, 10>,
  <1, 10, 4>,
  <3, 9, 17>,
  <3, 17, 26>,
  <3, 26, 16>,
  <3, 16, 8>,
  <5, 8, 16>,
  <5, 16, 25>,
  <5, 25, 21>,
  <5, 21, 12>,
  <6, 13, 22>,
  <6, 22, 33>,
  <6, 33, 23>,
  <6, 23, 14>,
  <7, 11, 20>,
  <7, 20, 30>,
  <7, 30, 24>,
  <7, 24, 15>,
  <10, 19, 29>,
  <10, 29, 39>,
  <10, 39, 28>,
  <10, 28, 18>,
  <13, 15, 24>,
  <13, 24, 34>,
  <13, 34, 32>,
  <13, 32, 22>,
  <17, 27, 37>,
  <17, 37, 46>,
  <17, 46, 36>,
  <17, 36, 26>,
  <18, 28, 38>,
  <18, 38, 40>,
  <18, 40, 30>,
  <18, 30, 20>,
  <21, 25, 35>,
  <21, 35, 45>,
  <21, 45, 41>,
  <21, 41, 31>,
  <23, 33, 43>,
  <23, 43, 47>,
  <23, 47, 37>,
  <23, 37, 27>,
  <29, 31, 41>,
  <29, 41, 50>,
  <29, 50, 49>,
  <29, 49, 39>,
  <32, 34, 44>,
  <32, 44, 52>,
  <32, 52, 51>,
  <32, 51, 42>,
  <35, 36, 46>,
  <35, 46, 54>,
  <35, 54, 53>,
  <35, 53, 45>,
  <38, 48, 56>,
  <38, 56, 52>,
  <38, 52, 44>,
  <38, 44, 40>,
  <42, 51, 58>,
  <42, 58, 55>,
  <42, 55, 47>,
  <42, 47, 43>,
  <48, 49, 50>,
  <48, 50, 57>,
  <48, 57, 59>,
  <48, 59, 56>,
  <53, 54, 55>,
  <53, 55, 58>,
  <53, 58, 59>,
  <53, 59, 57>
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_truncated_icosahedron_verts[53];
 #local P1 = Archimedean_truncated_icosahedron_verts[54];
 #local P2 = Archimedean_truncated_icosahedron_verts[55];
 #local P3 = Archimedean_truncated_icosahedron_verts[58];
 #local P4 = Archimedean_truncated_icosahedron_verts[59];
 #local P5 = Archimedean_truncated_icosahedron_verts[57];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_truncated_icosahedron_obj
  translate -(P0+P1+P2+P3+P4+P5)/6
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_truncated_icosahedron_obj }
#end
#end

#macro Archimedean_truncated_icosahedron_edges(RadEdg, RadVer, TexEdg, TexVer, OnPlane)
union {
 union {
  sphere { Archimedean_truncated_icosahedron_verts[0], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[1], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[2], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[3], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[4], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[5], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[6], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[7], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[8], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[9], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[10], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[11], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[12], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[13], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[14], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[15], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[16], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[17], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[18], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[19], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[20], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[21], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[22], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[23], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[24], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[25], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[26], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[27], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[28], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[29], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[30], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[31], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[32], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[33], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[34], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[35], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[36], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[37], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[38], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[39], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[40], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[41], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[42], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[43], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[44], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[45], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[46], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[47], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[48], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[49], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[50], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[51], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[52], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[53], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[54], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[55], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[56], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[57], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[58], RadVer }
  sphere { Archimedean_truncated_icosahedron_verts[59], RadVer }
  texture { TexVer } }
 union {
  cylinder { Archimedean_truncated_icosahedron_verts[0], Archimedean_truncated_icosahedron_verts[3], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[3], Archimedean_truncated_icosahedron_verts[8], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[8], Archimedean_truncated_icosahedron_verts[5], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[5], Archimedean_truncated_icosahedron_verts[1], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[1], Archimedean_truncated_icosahedron_verts[0], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[2], Archimedean_truncated_icosahedron_verts[7], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[7], Archimedean_truncated_icosahedron_verts[15], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[15], Archimedean_truncated_icosahedron_verts[13], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[13], Archimedean_truncated_icosahedron_verts[6], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[6], Archimedean_truncated_icosahedron_verts[2], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[4], Archimedean_truncated_icosahedron_verts[10], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[10], Archimedean_truncated_icosahedron_verts[18], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[18], Archimedean_truncated_icosahedron_verts[20], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[20], Archimedean_truncated_icosahedron_verts[11], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[11], Archimedean_truncated_icosahedron_verts[4], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[9], Archimedean_truncated_icosahedron_verts[14], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[14], Archimedean_truncated_icosahedron_verts[23], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[23], Archimedean_truncated_icosahedron_verts[27], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[27], Archimedean_truncated_icosahedron_verts[17], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[17], Archimedean_truncated_icosahedron_verts[9], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[12], Archimedean_truncated_icosahedron_verts[21], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[21], Archimedean_truncated_icosahedron_verts[31], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[31], Archimedean_truncated_icosahedron_verts[29], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[29], Archimedean_truncated_icosahedron_verts[19], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[19], Archimedean_truncated_icosahedron_verts[12], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[16], Archimedean_truncated_icosahedron_verts[26], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[26], Archimedean_truncated_icosahedron_verts[36], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[36], Archimedean_truncated_icosahedron_verts[35], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[35], Archimedean_truncated_icosahedron_verts[25], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[25], Archimedean_truncated_icosahedron_verts[16], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[22], Archimedean_truncated_icosahedron_verts[32], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[32], Archimedean_truncated_icosahedron_verts[42], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[42], Archimedean_truncated_icosahedron_verts[43], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[43], Archimedean_truncated_icosahedron_verts[33], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[33], Archimedean_truncated_icosahedron_verts[22], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[24], Archimedean_truncated_icosahedron_verts[30], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[30], Archimedean_truncated_icosahedron_verts[40], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[40], Archimedean_truncated_icosahedron_verts[44], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[44], Archimedean_truncated_icosahedron_verts[34], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[34], Archimedean_truncated_icosahedron_verts[24], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[28], Archimedean_truncated_icosahedron_verts[39], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[39], Archimedean_truncated_icosahedron_verts[49], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[49], Archimedean_truncated_icosahedron_verts[48], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[48], Archimedean_truncated_icosahedron_verts[38], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[38], Archimedean_truncated_icosahedron_verts[28], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[37], Archimedean_truncated_icosahedron_verts[47], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[47], Archimedean_truncated_icosahedron_verts[55], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[55], Archimedean_truncated_icosahedron_verts[54], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[54], Archimedean_truncated_icosahedron_verts[46], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[46], Archimedean_truncated_icosahedron_verts[37], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[41], Archimedean_truncated_icosahedron_verts[45], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[45], Archimedean_truncated_icosahedron_verts[53], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[53], Archimedean_truncated_icosahedron_verts[57], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[57], Archimedean_truncated_icosahedron_verts[50], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[50], Archimedean_truncated_icosahedron_verts[41], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[51], Archimedean_truncated_icosahedron_verts[52], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[52], Archimedean_truncated_icosahedron_verts[56], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[56], Archimedean_truncated_icosahedron_verts[59], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[59], Archimedean_truncated_icosahedron_verts[58], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[58], Archimedean_truncated_icosahedron_verts[51], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[1], Archimedean_truncated_icosahedron_verts[4], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[11], Archimedean_truncated_icosahedron_verts[7], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[2], Archimedean_truncated_icosahedron_verts[0], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[6], Archimedean_truncated_icosahedron_verts[14], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[9], Archimedean_truncated_icosahedron_verts[3], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[5], Archimedean_truncated_icosahedron_verts[12], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[19], Archimedean_truncated_icosahedron_verts[10], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[17], Archimedean_truncated_icosahedron_verts[26], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[16], Archimedean_truncated_icosahedron_verts[8], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[25], Archimedean_truncated_icosahedron_verts[21], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[13], Archimedean_truncated_icosahedron_verts[22], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[33], Archimedean_truncated_icosahedron_verts[23], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[20], Archimedean_truncated_icosahedron_verts[30], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[24], Archimedean_truncated_icosahedron_verts[15], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[29], Archimedean_truncated_icosahedron_verts[39], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[28], Archimedean_truncated_icosahedron_verts[18], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[34], Archimedean_truncated_icosahedron_verts[32], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[27], Archimedean_truncated_icosahedron_verts[37], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[46], Archimedean_truncated_icosahedron_verts[36], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[38], Archimedean_truncated_icosahedron_verts[40], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[35], Archimedean_truncated_icosahedron_verts[45], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[41], Archimedean_truncated_icosahedron_verts[31], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[43], Archimedean_truncated_icosahedron_verts[47], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[50], Archimedean_truncated_icosahedron_verts[49], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[44], Archimedean_truncated_icosahedron_verts[52], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[51], Archimedean_truncated_icosahedron_verts[42], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[54], Archimedean_truncated_icosahedron_verts[53], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[48], Archimedean_truncated_icosahedron_verts[56], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[58], Archimedean_truncated_icosahedron_verts[55], RadEdg }
  cylinder { Archimedean_truncated_icosahedron_verts[57], Archimedean_truncated_icosahedron_verts[59], RadEdg }
  texture { TexEdg } }
#if (OnPlane)
 #local P0 = Archimedean_truncated_icosahedron_verts[53];
 #local P1 = Archimedean_truncated_icosahedron_verts[54];
 #local P2 = Archimedean_truncated_icosahedron_verts[55];
 #local P3 = Archimedean_truncated_icosahedron_verts[58];
 #local P4 = Archimedean_truncated_icosahedron_verts[59];
 #local P5 = Archimedean_truncated_icosahedron_verts[57];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
  translate -(P0+P1+P2+P3+P4+P5)/6
  Reorient_Trans(Axis, y)
  translate y*max(RadEdg, RadVer)
#end
 }
#end

#declare Archimedean_rhombicosidodecahedron_verts = array[60]
{
<0, 0, 1.026054>,
<0.447838, 0, 0.9231617>,
<-0.02363976, 0.4472136, 0.9231617>,
<-0.4050732, 0.190983, 0.9231617>,
<-0.1693344, -0.4145898, 0.9231617>,
<0.4241982, 0.4472136, 0.8202696>,
<0.7673818, 0.190983, 0.6537868>,
<0.5552827, -0.4145898, 0.7566788>,
<-0.2312241, 0.7562306, 0.6537868>,
<-0.5744076, -0.2236068, 0.8202696>,
<-0.6126576, 0.5, 0.6537868>,
<0.1738492, -0.6708204, 0.7566788>,
<-0.4669629, -0.6381966, 0.6537868>,
<0.493393, 0.7562306, 0.4873039>,
<0.8748265, -0.2236068, 0.4873039>,
<0.8365765, 0.5, 0.320821>,
<0.7054921, -0.6381966, 0.3844118>,
<0.08831973, 0.9472136, 0.3844118>,
<-0.5434628, 0.809017, 0.320821>,
<-0.8866463, -0.1708204, 0.4873039>,
<-0.9102861, 0.2763932, 0.3844118>,
<-0.1237794, -0.8944272, 0.4873039>,
<0.3240586, -0.8944272, 0.3844118>,
<-0.7792016, -0.5854102, 0.320821>
<0.6289922, 0.809017, 0.05144604>,
<1.010426, -0.1708204, 0.05144604>,
<0.9867859, 0.2763932, -0.05144604>,
<0.8410913, -0.5854102, -0.05144604>,
<-0.223919, 1., 0.05144604>,
<0.223919, 1., -0.05144604>,
<-0.8410913, 0.5854102, 0.05144604>,
<-0.9867859, -0.2763932, 0.05144604>,
<-1.010426, 0.1708204, -0.05144604>,
<-0.223919, -1., 0.05144604>,
<0.223919, -1., -0.05144604>,
<-0.6289922, -0.809017, -0.05144604>,
<0.7792016, 0.5854102, -0.320821>,
<0.9102861, -0.2763932, -0.3844118>,
<0.8866463, 0.1708204, -0.4873039>,
<0.5434628, -0.809017, -0.320821>,
<-0.3240586, 0.8944272, -0.3844118>,
<0.1237794, 0.8944272, -0.4873039>,
<-0.7054921, 0.6381966, -0.3844118>,
<-0.8365765, -0.5, -0.320821>,
<-0.8748265, 0.2236068, -0.4873039>,
<-0.08831973, -0.9472136, -0.3844118>,
<-0.493393, -0.7562306, -0.4873039>,
<0.4669629, 0.6381966, -0.6537868>,
<0.6126576, -0.5, -0.6537868>,
<0.5744076, 0.2236068, -0.8202696>,
<0.2312241, -0.7562306, -0.6537868>,
<-0.1738492, 0.6708204, -0.7566788>,
<-0.5552827, 0.4145898, -0.7566788>,
<-0.7673818, -0.190983, -0.6537868>,
<-0.4241982, -0.4472136, -0.8202696>,
<0.1693344, 0.4145898, -0.9231617>,
<0.4050732, -0.190983, -0.9231617>,
<0.02363976, -0.4472136, -0.9231617>,
<-0.447838, 0, -0.9231617>,
<0, 0, -1.026054>,
}
#local P0 = Archimedean_rhombicosidodecahedron_verts[51];
#local P1 = Archimedean_rhombicosidodecahedron_verts[55];
#local P2 = Archimedean_rhombicosidodecahedron_verts[59];
#local V1 = P1 - P0;
#local V2 = P2 - P0;
#local Axis = vcross(V2, V1);
#local Tran1 = transform { Reorient_Trans(Axis, y) }
#local TV1 = vtransform(V1, Tran1);
#local The_Tran = transform {
 Reorient_Trans(Axis, y)
 Reorient_Trans(TV1, x) }
#local Num = 0;
#while (Num < 60)
 #declare Archimedean_rhombicosidodecahedron_verts[Num] = vtransform(Archimedean_rhombicosidodecahedron_verts[Num], The_Tran);
 #local Num = Num + 1;
#end

#macro Archimedean_rhombicosidodecahedron_faces(Tex3, Tex4, Tex5, OnPlane)
#local Archimedean_rhombicosidodecahedron_obj = mesh2 {
 vertex_vectors {
  60,
  Archimedean_rhombicosidodecahedron_verts[0],
  Archimedean_rhombicosidodecahedron_verts[1],
  Archimedean_rhombicosidodecahedron_verts[2],
  Archimedean_rhombicosidodecahedron_verts[3],
  Archimedean_rhombicosidodecahedron_verts[4],
  Archimedean_rhombicosidodecahedron_verts[5],
  Archimedean_rhombicosidodecahedron_verts[6],
  Archimedean_rhombicosidodecahedron_verts[7],
  Archimedean_rhombicosidodecahedron_verts[8],
  Archimedean_rhombicosidodecahedron_verts[9],
  Archimedean_rhombicosidodecahedron_verts[10],
  Archimedean_rhombicosidodecahedron_verts[11],
  Archimedean_rhombicosidodecahedron_verts[12],
  Archimedean_rhombicosidodecahedron_verts[13],
  Archimedean_rhombicosidodecahedron_verts[14],
  Archimedean_rhombicosidodecahedron_verts[15],
  Archimedean_rhombicosidodecahedron_verts[16],
  Archimedean_rhombicosidodecahedron_verts[17],
  Archimedean_rhombicosidodecahedron_verts[18],
  Archimedean_rhombicosidodecahedron_verts[19],
  Archimedean_rhombicosidodecahedron_verts[20],
  Archimedean_rhombicosidodecahedron_verts[21],
  Archimedean_rhombicosidodecahedron_verts[22],
  Archimedean_rhombicosidodecahedron_verts[23],
  Archimedean_rhombicosidodecahedron_verts[24],
  Archimedean_rhombicosidodecahedron_verts[25],
  Archimedean_rhombicosidodecahedron_verts[26],
  Archimedean_rhombicosidodecahedron_verts[27],
  Archimedean_rhombicosidodecahedron_verts[28],
  Archimedean_rhombicosidodecahedron_verts[29],
  Archimedean_rhombicosidodecahedron_verts[30],
  Archimedean_rhombicosidodecahedron_verts[31],
  Archimedean_rhombicosidodecahedron_verts[32],
  Archimedean_rhombicosidodecahedron_verts[33],
  Archimedean_rhombicosidodecahedron_verts[34],
  Archimedean_rhombicosidodecahedron_verts[35],
  Archimedean_rhombicosidodecahedron_verts[36],
  Archimedean_rhombicosidodecahedron_verts[37],
  Archimedean_rhombicosidodecahedron_verts[38],
  Archimedean_rhombicosidodecahedron_verts[39],
  Archimedean_rhombicosidodecahedron_verts[40],
  Archimedean_rhombicosidodecahedron_verts[41],
  Archimedean_rhombicosidodecahedron_verts[42],
  Archimedean_rhombicosidodecahedron_verts[43],
  Archimedean_rhombicosidodecahedron_verts[44],
  Archimedean_rhombicosidodecahedron_verts[45],
  Archimedean_rhombicosidodecahedron_verts[46],
  Archimedean_rhombicosidodecahedron_verts[47],
  Archimedean_rhombicosidodecahedron_verts[48],
  Archimedean_rhombicosidodecahedron_verts[49],
  Archimedean_rhombicosidodecahedron_verts[50],
  Archimedean_rhombicosidodecahedron_verts[51],
  Archimedean_rhombicosidodecahedron_verts[52],
  Archimedean_rhombicosidodecahedron_verts[53],
  Archimedean_rhombicosidodecahedron_verts[54],
  Archimedean_rhombicosidodecahedron_verts[55],
  Archimedean_rhombicosidodecahedron_verts[56],
  Archimedean_rhombicosidodecahedron_verts[57],
  Archimedean_rhombicosidodecahedron_verts[58],
  Archimedean_rhombicosidodecahedron_verts[59]
 }
 texture_list {
  3,
  texture { Tex3 },
  texture { Tex4 },
  texture { Tex5 }
 }
 face_indices {
  116,
  <0, 2, 3>, 0,
  <1, 6, 5>, 0,
  <4, 9, 12>, 0,
  <7, 16, 14>, 0,
  <8, 18, 10>, 0,
  <11, 21, 22>, 0,
  <13, 15, 24>, 0,
  <17, 29, 28>, 0,
  <19, 31, 23>, 0,
  <20, 30, 32>, 0,
  <25, 27, 37>, 0,
  <26, 38, 36>, 0,
  <33, 45, 34>, 0,
  <35, 43, 46>, 0,
  <39, 50, 48>, 0,
  <40, 41, 51>, 0,
  <42, 52, 44>, 0,
  <47, 49, 55>, 0,
  <53, 58, 54>, 0,
  <56, 57, 59>, 0,
  <0, 1, 5>, 1,
  <0, 5, 2>, 1,
  <0, 3, 9>, 1,
  <0, 9, 4>, 1,
  <1, 7, 14>, 1,
  <1, 14, 6>, 1,
  <2, 8, 10>, 1,
  <2, 10, 3>, 1,
  <4, 12, 21>, 1,
  <4, 21, 11>, 1,
  <5, 6, 15>, 1,
  <5, 15, 13>, 1,
  <7, 11, 22>, 1,
  <7, 22, 16>, 1,
  <8, 17, 28>, 1,
  <8, 28, 18>, 1,
  <9, 19, 23>, 1,
  <9, 23, 12>, 1,
  <10, 18, 30>, 1,
  <10, 30, 20>, 1,
  <13, 24, 29>, 1,
  <13, 29, 17>, 1,
  <14, 16, 27>, 1,
  <14, 27, 25>, 1,
  <15, 26, 36>, 1,
  <15, 36, 24>, 1,
  <19, 20, 32>, 1,
  <19, 32, 31>, 1,
  <21, 33, 34>, 1,
  <21, 34, 22>, 1,
  <23, 31, 43>, 1,
  <23, 43, 35>, 1,
  <25, 37, 38>, 1,
  <25, 38, 26>, 1,
  <27, 39, 48>, 1,
  <27, 48, 37>, 1,
  <28, 29, 41>, 1,
  <28, 41, 40>, 1,
  <30, 42, 44>, 1,
  <30, 44, 32>, 1,
  <33, 35, 46>, 1,
  <33, 46, 45>, 1,
  <34, 45, 50>, 1,
  <34, 50, 39>, 1,
  <36, 38, 49>, 1,
  <36, 49, 47>, 1,
  <40, 51, 52>, 1,
  <40, 52, 42>, 1,
  <41, 47, 55>, 1,
  <41, 55, 51>, 1,
  <43, 53, 54>, 1,
  <43, 54, 46>, 1,
  <44, 52, 58>, 1,
  <44, 58, 53>, 1,
  <48, 50, 57>, 1,
  <48, 57, 56>, 1,
  <49, 56, 59>, 1,
  <49, 59, 55>, 1,
  <54, 58, 59>, 1,
  <54, 59, 57>, 1,
  <0, 4, 11>, 2,
  <0, 11, 7>, 2,
  <0, 7, 1>, 2,
  <2, 5, 13>, 2,
  <2, 13, 17>, 2,
  <2, 17, 8>, 2,
  <3, 10, 20>, 2,
  <3, 20, 19>, 2,
  <3, 19, 9>, 2,
  <6, 14, 25>, 2,
  <6, 25, 26>, 2,
  <6, 26, 15>, 2,
  <12, 23, 35>, 2,
  <12, 35, 33>, 2,
  <12, 33, 21>, 2,
  <16, 22, 34>, 2,
  <16, 34, 39>, 2,
  <16, 39, 27>, 2,
  <18, 28, 40>, 2,
  <18, 40, 42>, 2,
  <18, 42, 30>, 2,
  <24, 36, 47>, 2,
  <24, 47, 41>, 2,
  <24, 41, 29>, 2,
  <31, 32, 44>, 2,
  <31, 44, 53>, 2,
  <31, 53, 43>, 2,
  <37, 48, 56>, 2,
  <37, 56, 49>, 2,
  <37, 49, 38>, 2,
  <45, 46, 54>, 2,
  <45, 54, 57>, 2,
  <45, 57, 50>, 2,
  <51, 55, 59>, 2,
  <51, 59, 58>, 2,
  <51, 58, 52>, 2
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_rhombicosidodecahedron_verts[51];
 #local P1 = Archimedean_rhombicosidodecahedron_verts[55];
 #local P2 = Archimedean_rhombicosidodecahedron_verts[59];
 #local P3 = Archimedean_rhombicosidodecahedron_verts[58];
 #local P4 = Archimedean_rhombicosidodecahedron_verts[52];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_rhombicosidodecahedron_obj
  translate -(P0+P1+P2+P3+P4)/5
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_rhombicosidodecahedron_obj }
#end
#end

#macro Archimedean_rhombicosidodecahedron_faces2(OnPlane)
#local Archimedean_rhombicosidodecahedron_obj = mesh2 {
 vertex_vectors {
  60,
  Archimedean_rhombicosidodecahedron_verts[0],
  Archimedean_rhombicosidodecahedron_verts[1],
  Archimedean_rhombicosidodecahedron_verts[2],
  Archimedean_rhombicosidodecahedron_verts[3],
  Archimedean_rhombicosidodecahedron_verts[4],
  Archimedean_rhombicosidodecahedron_verts[5],
  Archimedean_rhombicosidodecahedron_verts[6],
  Archimedean_rhombicosidodecahedron_verts[7],
  Archimedean_rhombicosidodecahedron_verts[8],
  Archimedean_rhombicosidodecahedron_verts[9],
  Archimedean_rhombicosidodecahedron_verts[10],
  Archimedean_rhombicosidodecahedron_verts[11],
  Archimedean_rhombicosidodecahedron_verts[12],
  Archimedean_rhombicosidodecahedron_verts[13],
  Archimedean_rhombicosidodecahedron_verts[14],
  Archimedean_rhombicosidodecahedron_verts[15],
  Archimedean_rhombicosidodecahedron_verts[16],
  Archimedean_rhombicosidodecahedron_verts[17],
  Archimedean_rhombicosidodecahedron_verts[18],
  Archimedean_rhombicosidodecahedron_verts[19],
  Archimedean_rhombicosidodecahedron_verts[20],
  Archimedean_rhombicosidodecahedron_verts[21],
  Archimedean_rhombicosidodecahedron_verts[22],
  Archimedean_rhombicosidodecahedron_verts[23],
  Archimedean_rhombicosidodecahedron_verts[24],
  Archimedean_rhombicosidodecahedron_verts[25],
  Archimedean_rhombicosidodecahedron_verts[26],
  Archimedean_rhombicosidodecahedron_verts[27],
  Archimedean_rhombicosidodecahedron_verts[28],
  Archimedean_rhombicosidodecahedron_verts[29],
  Archimedean_rhombicosidodecahedron_verts[30],
  Archimedean_rhombicosidodecahedron_verts[31],
  Archimedean_rhombicosidodecahedron_verts[32],
  Archimedean_rhombicosidodecahedron_verts[33],
  Archimedean_rhombicosidodecahedron_verts[34],
  Archimedean_rhombicosidodecahedron_verts[35],
  Archimedean_rhombicosidodecahedron_verts[36],
  Archimedean_rhombicosidodecahedron_verts[37],
  Archimedean_rhombicosidodecahedron_verts[38],
  Archimedean_rhombicosidodecahedron_verts[39],
  Archimedean_rhombicosidodecahedron_verts[40],
  Archimedean_rhombicosidodecahedron_verts[41],
  Archimedean_rhombicosidodecahedron_verts[42],
  Archimedean_rhombicosidodecahedron_verts[43],
  Archimedean_rhombicosidodecahedron_verts[44],
  Archimedean_rhombicosidodecahedron_verts[45],
  Archimedean_rhombicosidodecahedron_verts[46],
  Archimedean_rhombicosidodecahedron_verts[47],
  Archimedean_rhombicosidodecahedron_verts[48],
  Archimedean_rhombicosidodecahedron_verts[49],
  Archimedean_rhombicosidodecahedron_verts[50],
  Archimedean_rhombicosidodecahedron_verts[51],
  Archimedean_rhombicosidodecahedron_verts[52],
  Archimedean_rhombicosidodecahedron_verts[53],
  Archimedean_rhombicosidodecahedron_verts[54],
  Archimedean_rhombicosidodecahedron_verts[55],
  Archimedean_rhombicosidodecahedron_verts[56],
  Archimedean_rhombicosidodecahedron_verts[57],
  Archimedean_rhombicosidodecahedron_verts[58],
  Archimedean_rhombicosidodecahedron_verts[59]
 }
 face_indices {
  116,
  <0, 2, 3>,
  <1, 6, 5>,
  <4, 9, 12>,
  <7, 16, 14>,
  <8, 18, 10>,
  <11, 21, 22>,
  <13, 15, 24>,
  <17, 29, 28>,
  <19, 31, 23>,
  <20, 30, 32>,
  <25, 27, 37>,
  <26, 38, 36>,
  <33, 45, 34>,
  <35, 43, 46>,
  <39, 50, 48>,
  <40, 41, 51>,
  <42, 52, 44>,
  <47, 49, 55>,
  <53, 58, 54>,
  <56, 57, 59>,
  <0, 1, 5>,
  <0, 5, 2>,
  <0, 3, 9>,
  <0, 9, 4>,
  <1, 7, 14>,
  <1, 14, 6>,
  <2, 8, 10>,
  <2, 10, 3>,
  <4, 12, 21>,
  <4, 21, 11>,
  <5, 6, 15>,
  <5, 15, 13>,
  <7, 11, 22>,
  <7, 22, 16>,
  <8, 17, 28>,
  <8, 28, 18>,
  <9, 19, 23>,
  <9, 23, 12>,
  <10, 18, 30>,
  <10, 30, 20>,
  <13, 24, 29>,
  <13, 29, 17>,
  <14, 16, 27>,
  <14, 27, 25>,
  <15, 26, 36>,
  <15, 36, 24>,
  <19, 20, 32>,
  <19, 32, 31>,
  <21, 33, 34>,
  <21, 34, 22>,
  <23, 31, 43>,
  <23, 43, 35>,
  <25, 37, 38>,
  <25, 38, 26>,
  <27, 39, 48>,
  <27, 48, 37>,
  <28, 29, 41>,
  <28, 41, 40>,
  <30, 42, 44>,
  <30, 44, 32>,
  <33, 35, 46>,
  <33, 46, 45>,
  <34, 45, 50>,
  <34, 50, 39>,
  <36, 38, 49>,
  <36, 49, 47>,
  <40, 51, 52>,
  <40, 52, 42>,
  <41, 47, 55>,
  <41, 55, 51>,
  <43, 53, 54>,
  <43, 54, 46>,
  <44, 52, 58>,
  <44, 58, 53>,
  <48, 50, 57>,
  <48, 57, 56>,
  <49, 56, 59>,
  <49, 59, 55>,
  <54, 58, 59>,
  <54, 59, 57>,
  <0, 4, 11>,
  <0, 11, 7>,
  <0, 7, 1>,
  <2, 5, 13>,
  <2, 13, 17>,
  <2, 17, 8>,
  <3, 10, 20>,
  <3, 20, 19>,
  <3, 19, 9>,
  <6, 14, 25>,
  <6, 25, 26>,
  <6, 26, 15>,
  <12, 23, 35>,
  <12, 35, 33>,
  <12, 33, 21>,
  <16, 22, 34>,
  <16, 34, 39>,
  <16, 39, 27>,
  <18, 28, 40>,
  <18, 40, 42>,
  <18, 42, 30>,
  <24, 36, 47>,
  <24, 47, 41>,
  <24, 41, 29>,
  <31, 32, 44>,
  <31, 44, 53>,
  <31, 53, 43>,
  <37, 48, 56>,
  <37, 56, 49>,
  <37, 49, 38>,
  <45, 46, 54>,
  <45, 54, 57>,
  <45, 57, 50>,
  <51, 55, 59>,
  <51, 59, 58>,
  <51, 58, 52>
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_rhombicosidodecahedron_verts[51];
 #local P1 = Archimedean_rhombicosidodecahedron_verts[55];
 #local P2 = Archimedean_rhombicosidodecahedron_verts[59];
 #local P3 = Archimedean_rhombicosidodecahedron_verts[58];
 #local P4 = Archimedean_rhombicosidodecahedron_verts[52];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_rhombicosidodecahedron_obj
  translate -(P0+P1+P2+P3+P4)/5
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_rhombicosidodecahedron_obj }
#end
#end

#macro Archimedean_rhombicosidodecahedron_edges(RadEdg, RadVer, TexEdg, TexVer, OnPlane)
union {
 union {
  sphere { Archimedean_rhombicosidodecahedron_verts[0], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[1], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[2], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[3], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[4], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[5], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[6], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[7], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[8], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[9], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[10], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[11], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[12], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[13], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[14], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[15], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[16], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[17], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[18], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[19], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[20], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[21], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[22], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[23], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[24], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[25], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[26], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[27], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[28], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[29], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[30], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[31], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[32], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[33], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[34], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[35], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[36], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[37], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[38], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[39], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[40], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[41], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[42], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[43], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[44], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[45], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[46], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[47], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[48], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[49], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[50], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[51], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[52], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[53], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[54], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[55], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[56], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[57], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[58], RadVer }
  sphere { Archimedean_rhombicosidodecahedron_verts[59], RadVer }
  texture { TexVer } }
 union {
  cylinder { Archimedean_rhombicosidodecahedron_verts[0], Archimedean_rhombicosidodecahedron_verts[2], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[2], Archimedean_rhombicosidodecahedron_verts[3], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[3], Archimedean_rhombicosidodecahedron_verts[0], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[1], Archimedean_rhombicosidodecahedron_verts[6], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[6], Archimedean_rhombicosidodecahedron_verts[5], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[5], Archimedean_rhombicosidodecahedron_verts[1], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[4], Archimedean_rhombicosidodecahedron_verts[9], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[9], Archimedean_rhombicosidodecahedron_verts[12], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[12], Archimedean_rhombicosidodecahedron_verts[4], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[7], Archimedean_rhombicosidodecahedron_verts[16], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[16], Archimedean_rhombicosidodecahedron_verts[14], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[14], Archimedean_rhombicosidodecahedron_verts[7], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[8], Archimedean_rhombicosidodecahedron_verts[18], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[18], Archimedean_rhombicosidodecahedron_verts[10], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[10], Archimedean_rhombicosidodecahedron_verts[8], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[11], Archimedean_rhombicosidodecahedron_verts[21], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[21], Archimedean_rhombicosidodecahedron_verts[22], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[22], Archimedean_rhombicosidodecahedron_verts[11], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[13], Archimedean_rhombicosidodecahedron_verts[15], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[15], Archimedean_rhombicosidodecahedron_verts[24], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[24], Archimedean_rhombicosidodecahedron_verts[13], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[17], Archimedean_rhombicosidodecahedron_verts[29], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[29], Archimedean_rhombicosidodecahedron_verts[28], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[28], Archimedean_rhombicosidodecahedron_verts[17], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[19], Archimedean_rhombicosidodecahedron_verts[31], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[31], Archimedean_rhombicosidodecahedron_verts[23], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[23], Archimedean_rhombicosidodecahedron_verts[19], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[20], Archimedean_rhombicosidodecahedron_verts[30], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[30], Archimedean_rhombicosidodecahedron_verts[32], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[32], Archimedean_rhombicosidodecahedron_verts[20], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[25], Archimedean_rhombicosidodecahedron_verts[27], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[27], Archimedean_rhombicosidodecahedron_verts[37], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[37], Archimedean_rhombicosidodecahedron_verts[25], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[26], Archimedean_rhombicosidodecahedron_verts[38], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[38], Archimedean_rhombicosidodecahedron_verts[36], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[36], Archimedean_rhombicosidodecahedron_verts[26], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[33], Archimedean_rhombicosidodecahedron_verts[45], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[45], Archimedean_rhombicosidodecahedron_verts[34], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[34], Archimedean_rhombicosidodecahedron_verts[33], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[35], Archimedean_rhombicosidodecahedron_verts[43], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[43], Archimedean_rhombicosidodecahedron_verts[46], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[46], Archimedean_rhombicosidodecahedron_verts[35], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[39], Archimedean_rhombicosidodecahedron_verts[50], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[50], Archimedean_rhombicosidodecahedron_verts[48], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[48], Archimedean_rhombicosidodecahedron_verts[39], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[40], Archimedean_rhombicosidodecahedron_verts[41], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[41], Archimedean_rhombicosidodecahedron_verts[51], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[51], Archimedean_rhombicosidodecahedron_verts[40], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[42], Archimedean_rhombicosidodecahedron_verts[52], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[52], Archimedean_rhombicosidodecahedron_verts[44], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[44], Archimedean_rhombicosidodecahedron_verts[42], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[47], Archimedean_rhombicosidodecahedron_verts[49], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[49], Archimedean_rhombicosidodecahedron_verts[55], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[55], Archimedean_rhombicosidodecahedron_verts[47], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[53], Archimedean_rhombicosidodecahedron_verts[58], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[58], Archimedean_rhombicosidodecahedron_verts[54], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[54], Archimedean_rhombicosidodecahedron_verts[53], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[56], Archimedean_rhombicosidodecahedron_verts[57], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[57], Archimedean_rhombicosidodecahedron_verts[59], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[59], Archimedean_rhombicosidodecahedron_verts[56], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[0], Archimedean_rhombicosidodecahedron_verts[1], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[5], Archimedean_rhombicosidodecahedron_verts[2], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[3], Archimedean_rhombicosidodecahedron_verts[9], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[4], Archimedean_rhombicosidodecahedron_verts[0], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[1], Archimedean_rhombicosidodecahedron_verts[7], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[14], Archimedean_rhombicosidodecahedron_verts[6], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[2], Archimedean_rhombicosidodecahedron_verts[8], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[10], Archimedean_rhombicosidodecahedron_verts[3], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[12], Archimedean_rhombicosidodecahedron_verts[21], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[11], Archimedean_rhombicosidodecahedron_verts[4], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[6], Archimedean_rhombicosidodecahedron_verts[15], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[13], Archimedean_rhombicosidodecahedron_verts[5], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[7], Archimedean_rhombicosidodecahedron_verts[11], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[22], Archimedean_rhombicosidodecahedron_verts[16], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[8], Archimedean_rhombicosidodecahedron_verts[17], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[28], Archimedean_rhombicosidodecahedron_verts[18], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[9], Archimedean_rhombicosidodecahedron_verts[19], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[23], Archimedean_rhombicosidodecahedron_verts[12], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[18], Archimedean_rhombicosidodecahedron_verts[30], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[20], Archimedean_rhombicosidodecahedron_verts[10], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[24], Archimedean_rhombicosidodecahedron_verts[29], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[17], Archimedean_rhombicosidodecahedron_verts[13], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[16], Archimedean_rhombicosidodecahedron_verts[27], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[25], Archimedean_rhombicosidodecahedron_verts[14], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[15], Archimedean_rhombicosidodecahedron_verts[26], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[36], Archimedean_rhombicosidodecahedron_verts[24], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[19], Archimedean_rhombicosidodecahedron_verts[20], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[32], Archimedean_rhombicosidodecahedron_verts[31], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[21], Archimedean_rhombicosidodecahedron_verts[33], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[34], Archimedean_rhombicosidodecahedron_verts[22], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[31], Archimedean_rhombicosidodecahedron_verts[43], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[35], Archimedean_rhombicosidodecahedron_verts[23], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[37], Archimedean_rhombicosidodecahedron_verts[38], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[26], Archimedean_rhombicosidodecahedron_verts[25], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[27], Archimedean_rhombicosidodecahedron_verts[39], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[48], Archimedean_rhombicosidodecahedron_verts[37], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[29], Archimedean_rhombicosidodecahedron_verts[41], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[40], Archimedean_rhombicosidodecahedron_verts[28], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[30], Archimedean_rhombicosidodecahedron_verts[42], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[44], Archimedean_rhombicosidodecahedron_verts[32], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[33], Archimedean_rhombicosidodecahedron_verts[35], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[46], Archimedean_rhombicosidodecahedron_verts[45], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[45], Archimedean_rhombicosidodecahedron_verts[50], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[39], Archimedean_rhombicosidodecahedron_verts[34], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[38], Archimedean_rhombicosidodecahedron_verts[49], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[47], Archimedean_rhombicosidodecahedron_verts[36], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[51], Archimedean_rhombicosidodecahedron_verts[52], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[42], Archimedean_rhombicosidodecahedron_verts[40], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[41], Archimedean_rhombicosidodecahedron_verts[47], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[55], Archimedean_rhombicosidodecahedron_verts[51], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[43], Archimedean_rhombicosidodecahedron_verts[53], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[54], Archimedean_rhombicosidodecahedron_verts[46], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[52], Archimedean_rhombicosidodecahedron_verts[58], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[53], Archimedean_rhombicosidodecahedron_verts[44], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[50], Archimedean_rhombicosidodecahedron_verts[57], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[56], Archimedean_rhombicosidodecahedron_verts[48], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[49], Archimedean_rhombicosidodecahedron_verts[56], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[59], Archimedean_rhombicosidodecahedron_verts[55], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[58], Archimedean_rhombicosidodecahedron_verts[59], RadEdg }
  cylinder { Archimedean_rhombicosidodecahedron_verts[57], Archimedean_rhombicosidodecahedron_verts[54], RadEdg }
  texture { TexEdg } }
#if (OnPlane)
 #local P0 = Archimedean_rhombicosidodecahedron_verts[51];
 #local P1 = Archimedean_rhombicosidodecahedron_verts[55];
 #local P2 = Archimedean_rhombicosidodecahedron_verts[59];
 #local P3 = Archimedean_rhombicosidodecahedron_verts[58];
 #local P4 = Archimedean_rhombicosidodecahedron_verts[52];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
  translate -(P0+P1+P2+P3+P4)/5
  Reorient_Trans(Axis, y)
  translate y*max(RadEdg, RadVer)
#end
 }
#end

#declare Archimedean_truncated_icosidodecahedron_verts = array[120]
{
<0, 0, 1.008759>,
<0.2629922, 0, 0.973874>,
<-0.00462747, 0.2629515, 0.973874>,
<-0.2211363, -0.1423503, 0.973874>,
<0.2583647, 0.2629515, 0.9389886>,
<0.4673861, -0.1423503, 0.8825429>,
<-0.2303913, 0.3835526, 0.9041033>,
<-0.3159502, -0.372678, 0.8825429>,
<-0.4469001, -0.02174919, 0.9041033>,
<0.4581312, 0.3835526, 0.8127722>,
<0.5351104, -0.372678, 0.7696515>,
<0.6671526, -0.02174919, 0.7563265>,
<-0.3326926, 0.5786893, 0.7563265>,
<-0.4515276, 0.2412023, 0.8692179>,
<-0.541714, -0.2520769, 0.8127722>,
<-0.248226, -0.6030057, 0.7696515>,
<0.518368, 0.5786893, 0.6434351>,
<0.6625252, 0.2412023, 0.7214412>,
<0.7348768, -0.2520769, 0.6434351>,
<0.4402965, -0.6030057, 0.6783205>,
<-0.5538289, 0.436339, 0.7214412>,
<-0.2724557, 0.7738261, 0.5869894>,
<-0.6997536, -0.3618034, 0.6301101>,
<-0.04383203, -0.745356, 0.6783205>
<-0.4062656, -0.7127322, 0.5869894>,
<0.722762, 0.436339, 0.552104>,
<0.4160667, 0.7738261, 0.4956583>,
<0.8398294, -0.3618034, 0.4258876>,
<0.2191601, -0.745356, 0.6434351>,
<0.5452491, -0.7127322, 0.460773>,
<-0.7147284, 0.4891254, 0.5172187>,
<-0.07268925, 0.8944272, 0.460773>,
<-0.4333553, 0.8266125, 0.3827669>,
<-0.8606531, -0.309017, 0.4258876>,
<-0.6320294, -0.5921311, 0.5172187>,
<-0.2018716, -0.8550825, 0.4956583>,
<0.8248546, 0.4891254, 0.3129962>,
<0.1903029, 0.8944272, 0.4258876>,
<0.5181594, 0.8266125, 0.2565505>,
<0.9419221, -0.309017, 0.1867798>,
<0.7450156, -0.5921311, 0.3345566>,
<0.3241127, -0.8550825, 0.4258876>,
<-0.8727679, 0.3793989, 0.3345566>,
<-0.6544916, 0.6842621, 0.3478816>,
<-0.2335888, 0.9472136, 0.2565505>,
<-0.7929289, -0.5393447, 0.3129962>,
<-0.9629544, -0.1138803, 0.2781109>,
<-0.096919, -0.9648091, 0.2781109>,
<0.9298072, 0.3793989, 0.09544872>,
<0.7225533, 0.6842621, 0.1652194>,
<0.2923956, 0.9472136, 0.1867798>,
<0.8471082, -0.5393447, 0.09544872>,
<1.002159, -0.1138803, 0.01744268>,
<0.1660732, -0.9648091, 0.2432255>,
<-0.8125311, 0.5745356, 0.1652194>,
<-0.9675818, 0.1490712, 0.2432255>,
<-0.1314961, 1., 0.01744268>,
<-0.8275059, -0.5745356, 0.05232804>,
<-0.9975315, -0.1490712, 0.01744268>,
<-0.1314961, -1., 0.01744268>,
<0.8275059, 0.5745356, -0.05232804>,
<0.9975315, 0.1490712, -0.01744268>,
<0.1314961, 1., -0.01744268>,
<0.8125311, -0.5745356, -0.1652194>,
<0.9675818, -0.1490712, -0.2432255>,
<0.1314961, -1., -0.01744268>,
<-0.8471082, 0.5393447, -0.09544872>,
<-1.002159, 0.1138803, -0.01744268>,
<-0.1660732, 0.9648091, -0.2432255>,
<-0.7225533, -0.6842621, -0.1652194>,
<-0.9298072, -0.3793989, -0.09544872>,
<-0.2923956, -0.9472136, -0.1867798>,
<0.7929289, 0.5393447, -0.3129962>,
<0.9629544, 0.1138803, -0.2781109>,
<0.096919, 0.9648091, -0.2781109>,
<0.6544916, -0.6842621, -0.3478816>,
<0.8727679, -0.3793989, -0.3345566>,
<0.2335888, -0.9472136, -0.2565505>,
<-0.7450156, 0.5921311, -0.3345566>,
<-0.9419221, 0.309017, -0.1867798>,
<-0.3241127, 0.8550825, -0.4258876>,
<-0.8248546, -0.4891254, -0.3129962>,
<-0.5181594, -0.8266125, -0.2565505>,
<-0.1903029, -0.8944272, -0.4258876>,
<0.6320294, 0.5921311, -0.5172187>,
<0.8606531, 0.309017, -0.4258876>,
<0.2018716, 0.8550825, -0.4956583>,
<0.7147284, -0.4891254, -0.5172187>,
<0.4333553, -0.8266125, -0.3827669>,
<0.07268925, -0.8944272, -0.460773>,
<-0.8398294, 0.3618034, -0.4258876>,
<-0.5452491, 0.7127322, -0.460773>,
<-0.2191601, 0.745356, -0.6434351>,
<-0.722762, -0.436339, -0.552104>,
<-0.4160667, -0.7738261, -0.4956583>,
<0.6997536, 0.3618034, -0.6301101>,
<0.4062656, 0.7127322, -0.5869894>,
<0.04383203, 0.745356, -0.6783205>,
<0.5538289, -0.436339, -0.7214412>,
<0.2724557, -0.7738261, -0.5869894>,
<-0.7348768, 0.2520769, -0.6434351>,
<-0.4402965, 0.6030057, -0.6783205>,
<-0.6625252, -0.2412023, -0.7214412>,
<-0.518368, -0.5786893, -0.6434351>,
<0.541714, 0.2520769, -0.8127722>,
<0.248226, 0.6030057, -0.7696515>,
<0.4515276, -0.2412023, -0.8692179>,
<0.3326926, -0.5786893, -0.7563265>,
<-0.6671526, 0.02174919, -0.7563265>,
<-0.5351104, 0.372678, -0.7696515>,
<-0.4581312, -0.3835526, -0.8127722>,
<0.4469001, 0.02174919, -0.9041033>,
<0.3159502, 0.372678, -0.8825429>,
<0.2303913, -0.3835526, -0.9041033>,
<-0.4673861, 0.1423503, -0.8825429>,
<-0.2583647, -0.2629515, -0.9389886>,
<0.2211363, 0.1423503, -0.973874>,
<0.00462747, -0.2629515, -0.973874>,
<-0.2629922, 0, -0.973874>,
<0, 0, -1.008759>,
}
#local P0 = Archimedean_truncated_icosidodecahedron_verts[92];
#local P1 = Archimedean_truncated_icosidodecahedron_verts[97];
#local P2 = Archimedean_truncated_icosidodecahedron_verts[105];
#local V1 = P1 - P0;
#local V2 = P2 - P0;
#local Axis = vcross(V2, V1);
#local Tran1 = transform { Reorient_Trans(Axis, y) }
#local TV1 = vtransform(V1, Tran1);
#local The_Tran = transform {
 Reorient_Trans(Axis, y)
 Reorient_Trans(TV1, x) }
#local Num = 0;
#while (Num < 120)
 #declare Archimedean_truncated_icosidodecahedron_verts[Num] = vtransform(Archimedean_truncated_icosidodecahedron_verts[Num], The_Tran);
 #local Num = Num + 1;
#end

#macro Archimedean_truncated_icosidodecahedron_faces(Tex4, Tex6, Tex10, OnPlane)
#local Archimedean_truncated_icosidodecahedron_obj = mesh2 {
 vertex_vectors {
  120,
  Archimedean_truncated_icosidodecahedron_verts[0],
  Archimedean_truncated_icosidodecahedron_verts[1],
  Archimedean_truncated_icosidodecahedron_verts[2],
  Archimedean_truncated_icosidodecahedron_verts[3],
  Archimedean_truncated_icosidodecahedron_verts[4],
  Archimedean_truncated_icosidodecahedron_verts[5],
  Archimedean_truncated_icosidodecahedron_verts[6],
  Archimedean_truncated_icosidodecahedron_verts[7],
  Archimedean_truncated_icosidodecahedron_verts[8],
  Archimedean_truncated_icosidodecahedron_verts[9],
  Archimedean_truncated_icosidodecahedron_verts[10],
  Archimedean_truncated_icosidodecahedron_verts[11],
  Archimedean_truncated_icosidodecahedron_verts[12],
  Archimedean_truncated_icosidodecahedron_verts[13],
  Archimedean_truncated_icosidodecahedron_verts[14],
  Archimedean_truncated_icosidodecahedron_verts[15],
  Archimedean_truncated_icosidodecahedron_verts[16],
  Archimedean_truncated_icosidodecahedron_verts[17],
  Archimedean_truncated_icosidodecahedron_verts[18],
  Archimedean_truncated_icosidodecahedron_verts[19],
  Archimedean_truncated_icosidodecahedron_verts[20],
  Archimedean_truncated_icosidodecahedron_verts[21],
  Archimedean_truncated_icosidodecahedron_verts[22],
  Archimedean_truncated_icosidodecahedron_verts[23],
  Archimedean_truncated_icosidodecahedron_verts[24],
  Archimedean_truncated_icosidodecahedron_verts[25],
  Archimedean_truncated_icosidodecahedron_verts[26],
  Archimedean_truncated_icosidodecahedron_verts[27],
  Archimedean_truncated_icosidodecahedron_verts[28],
  Archimedean_truncated_icosidodecahedron_verts[29],
  Archimedean_truncated_icosidodecahedron_verts[30],
  Archimedean_truncated_icosidodecahedron_verts[31],
  Archimedean_truncated_icosidodecahedron_verts[32],
  Archimedean_truncated_icosidodecahedron_verts[33],
  Archimedean_truncated_icosidodecahedron_verts[34],
  Archimedean_truncated_icosidodecahedron_verts[35],
  Archimedean_truncated_icosidodecahedron_verts[36],
  Archimedean_truncated_icosidodecahedron_verts[37],
  Archimedean_truncated_icosidodecahedron_verts[38],
  Archimedean_truncated_icosidodecahedron_verts[39],
  Archimedean_truncated_icosidodecahedron_verts[40],
  Archimedean_truncated_icosidodecahedron_verts[41],
  Archimedean_truncated_icosidodecahedron_verts[42],
  Archimedean_truncated_icosidodecahedron_verts[43],
  Archimedean_truncated_icosidodecahedron_verts[44],
  Archimedean_truncated_icosidodecahedron_verts[45],
  Archimedean_truncated_icosidodecahedron_verts[46],
  Archimedean_truncated_icosidodecahedron_verts[47],
  Archimedean_truncated_icosidodecahedron_verts[48],
  Archimedean_truncated_icosidodecahedron_verts[49],
  Archimedean_truncated_icosidodecahedron_verts[50],
  Archimedean_truncated_icosidodecahedron_verts[51],
  Archimedean_truncated_icosidodecahedron_verts[52],
  Archimedean_truncated_icosidodecahedron_verts[53],
  Archimedean_truncated_icosidodecahedron_verts[54],
  Archimedean_truncated_icosidodecahedron_verts[55],
  Archimedean_truncated_icosidodecahedron_verts[56],
  Archimedean_truncated_icosidodecahedron_verts[57],
  Archimedean_truncated_icosidodecahedron_verts[58],
  Archimedean_truncated_icosidodecahedron_verts[59],
  Archimedean_truncated_icosidodecahedron_verts[60],
  Archimedean_truncated_icosidodecahedron_verts[61],
  Archimedean_truncated_icosidodecahedron_verts[62],
  Archimedean_truncated_icosidodecahedron_verts[63],
  Archimedean_truncated_icosidodecahedron_verts[64],
  Archimedean_truncated_icosidodecahedron_verts[65],
  Archimedean_truncated_icosidodecahedron_verts[66],
  Archimedean_truncated_icosidodecahedron_verts[67],
  Archimedean_truncated_icosidodecahedron_verts[68],
  Archimedean_truncated_icosidodecahedron_verts[69],
  Archimedean_truncated_icosidodecahedron_verts[70],
  Archimedean_truncated_icosidodecahedron_verts[71],
  Archimedean_truncated_icosidodecahedron_verts[72],
  Archimedean_truncated_icosidodecahedron_verts[73],
  Archimedean_truncated_icosidodecahedron_verts[74],
  Archimedean_truncated_icosidodecahedron_verts[75],
  Archimedean_truncated_icosidodecahedron_verts[76],
  Archimedean_truncated_icosidodecahedron_verts[77],
  Archimedean_truncated_icosidodecahedron_verts[78],
  Archimedean_truncated_icosidodecahedron_verts[79],
  Archimedean_truncated_icosidodecahedron_verts[80],
  Archimedean_truncated_icosidodecahedron_verts[81],
  Archimedean_truncated_icosidodecahedron_verts[82],
  Archimedean_truncated_icosidodecahedron_verts[83],
  Archimedean_truncated_icosidodecahedron_verts[84],
  Archimedean_truncated_icosidodecahedron_verts[85],
  Archimedean_truncated_icosidodecahedron_verts[86],
  Archimedean_truncated_icosidodecahedron_verts[87],
  Archimedean_truncated_icosidodecahedron_verts[88],
  Archimedean_truncated_icosidodecahedron_verts[89],
  Archimedean_truncated_icosidodecahedron_verts[90],
  Archimedean_truncated_icosidodecahedron_verts[91],
  Archimedean_truncated_icosidodecahedron_verts[92],
  Archimedean_truncated_icosidodecahedron_verts[93],
  Archimedean_truncated_icosidodecahedron_verts[94],
  Archimedean_truncated_icosidodecahedron_verts[95],
  Archimedean_truncated_icosidodecahedron_verts[96],
  Archimedean_truncated_icosidodecahedron_verts[97],
  Archimedean_truncated_icosidodecahedron_verts[98],
  Archimedean_truncated_icosidodecahedron_verts[99],
  Archimedean_truncated_icosidodecahedron_verts[100],
  Archimedean_truncated_icosidodecahedron_verts[101],
  Archimedean_truncated_icosidodecahedron_verts[102],
  Archimedean_truncated_icosidodecahedron_verts[103],
  Archimedean_truncated_icosidodecahedron_verts[104],
  Archimedean_truncated_icosidodecahedron_verts[105],
  Archimedean_truncated_icosidodecahedron_verts[106],
  Archimedean_truncated_icosidodecahedron_verts[107],
  Archimedean_truncated_icosidodecahedron_verts[108],
  Archimedean_truncated_icosidodecahedron_verts[109],
  Archimedean_truncated_icosidodecahedron_verts[110],
  Archimedean_truncated_icosidodecahedron_verts[111],
  Archimedean_truncated_icosidodecahedron_verts[112],
  Archimedean_truncated_icosidodecahedron_verts[113],
  Archimedean_truncated_icosidodecahedron_verts[114],
  Archimedean_truncated_icosidodecahedron_verts[115],
  Archimedean_truncated_icosidodecahedron_verts[116],
  Archimedean_truncated_icosidodecahedron_verts[117],
  Archimedean_truncated_icosidodecahedron_verts[118],
  Archimedean_truncated_icosidodecahedron_verts[119]
 }
 texture_list {
  3,
  texture { Tex4 },
  texture { Tex6 },
  texture { Tex10 }
 }
 face_indices {
  236,
  <0, 1, 4>, 0,
  <0, 4, 2>, 0,
  <3, 8, 14>, 0,
  <3, 14, 7>, 0,
  <5, 10, 18>, 0,
  <5, 18, 11>, 0,
  <6, 12, 20>, 0,
  <6, 20, 13>, 0,
  <9, 17, 25>, 0,
  <9, 25, 16>, 0,
  <15, 24, 35>, 0,
  <15, 35, 23>, 0,
  <19, 28, 41>, 0,
  <19, 41, 29>, 0,
  <21, 31, 44>, 0,
  <21, 44, 32>, 0,
  <22, 33, 45>, 0,
  <22, 45, 34>, 0,
  <26, 38, 50>, 0,
  <26, 50, 37>, 0,
  <27, 40, 51>, 0,
  <27, 51, 39>, 0,
  <30, 43, 54>, 0,
  <30, 54, 42>, 0,
  <36, 48, 60>, 0,
  <36, 60, 49>, 0,
  <46, 55, 67>, 0,
  <46, 67, 58>, 0,
  <47, 59, 65>, 0,
  <47, 65, 53>, 0,
  <52, 64, 73>, 0,
  <52, 73, 61>, 0,
  <56, 62, 74>, 0,
  <56, 74, 68>, 0,
  <57, 70, 81>, 0,
  <57, 81, 69>, 0,
  <63, 75, 87>, 0,
  <63, 87, 76>, 0,
  <66, 78, 90>, 0,
  <66, 90, 79>, 0,
  <71, 82, 94>, 0,
  <71, 94, 83>, 0,
  <72, 85, 95>, 0,
  <72, 95, 84>, 0,
  <77, 89, 99>, 0,
  <77, 99, 88>, 0,
  <80, 92, 101>, 0,
  <80, 101, 91>, 0,
  <86, 96, 105>, 0,
  <86, 105, 97>, 0,
  <93, 102, 110>, 0,
  <93, 110, 103>, 0,
  <98, 107, 113>, 0,
  <98, 113, 106>, 0,
  <100, 109, 114>, 0,
  <100, 114, 108>, 0,
  <104, 111, 116>, 0,
  <104, 116, 112>, 0,
  <115, 118, 119>, 0,
  <115, 119, 117>, 0,
  <0, 2, 6>, 1,
  <0, 6, 13>, 1,
  <0, 13, 8>, 1,
  <0, 8, 3>, 1,
  <1, 5, 11>, 1,
  <1, 11, 17>, 1,
  <1, 17, 9>, 1,
  <1, 9, 4>, 1,
  <7, 14, 22>, 1,
  <7, 22, 34>, 1,
  <7, 34, 24>, 1,
  <7, 24, 15>, 1,
  <10, 19, 29>, 1,
  <10, 29, 40>, 1,
  <10, 40, 27>, 1,
  <10, 27, 18>, 1,
  <12, 21, 32>, 1,
  <12, 32, 43>, 1,
  <12, 43, 30>, 1,
  <12, 30, 20>, 1,
  <16, 25, 36>, 1,
  <16, 36, 49>, 1,
  <16, 49, 38>, 1,
  <16, 38, 26>, 1,
  <23, 35, 47>, 1,
  <23, 47, 53>, 1,
  <23, 53, 41>, 1,
  <23, 41, 28>, 1,
  <31, 37, 50>, 1,
  <31, 50, 62>, 1,
  <31, 62, 56>, 1,
  <31, 56, 44>, 1,
  <33, 46, 58>, 1,
  <33, 58, 70>, 1,
  <33, 70, 57>, 1,
  <33, 57, 45>, 1,
  <39, 51, 63>, 1,
  <39, 63, 76>, 1,
  <39, 76, 64>, 1,
  <39, 64, 52>, 1,
  <42, 54, 66>, 1,
  <42, 66, 79>, 1,
  <42, 79, 67>, 1,
  <42, 67, 55>, 1,
  <48, 61, 73>, 1,
  <48, 73, 85>, 1,
  <48, 85, 72>, 1,
  <48, 72, 60>, 1,
  <59, 71, 83>, 1,
  <59, 83, 89>, 1,
  <59, 89, 77>, 1,
  <59, 77, 65>, 1,
  <68, 74, 86>, 1,
  <68, 86, 97>, 1,
  <68, 97, 92>, 1,
  <68, 92, 80>, 1,
  <69, 81, 93>, 1,
  <69, 93, 103>, 1,
  <69, 103, 94>, 1,
  <69, 94, 82>, 1,
  <75, 88, 99>, 1,
  <75, 99, 107>, 1,
  <75, 107, 98>, 1,
  <75, 98, 87>, 1,
  <78, 91, 101>, 1,
  <78, 101, 109>, 1,
  <78, 109, 100>, 1,
  <78, 100, 90>, 1,
  <84, 95, 104>, 1,
  <84, 104, 112>, 1,
  <84, 112, 105>, 1,
  <84, 105, 96>, 1,
  <102, 108, 114>, 1,
  <102, 114, 118>, 1,
  <102, 118, 115>, 1,
  <102, 115, 110>, 1,
  <106, 113, 117>, 1,
  <106, 117, 119>, 1,
  <106, 119, 116>, 1,
  <106, 116, 111>, 1,
  <0, 3, 7>, 2,
  <0, 7, 15>, 2,
  <0, 15, 23>, 2,
  <0, 23, 28>, 2,
  <0, 28, 19>, 2,
  <0, 19, 10>, 2,
  <0, 10, 5>, 2,
  <0, 5, 1>, 2,
  <2, 4, 9>, 2,
  <2, 9, 16>, 2,
  <2, 16, 26>, 2,
  <2, 26, 37>, 2,
  <2, 37, 31>, 2,
  <2, 31, 21>, 2,
  <2, 21, 12>, 2,
  <2, 12, 6>, 2,
  <8, 13, 20>, 2,
  <8, 20, 30>, 2,
  <8, 30, 42>, 2,
  <8, 42, 55>, 2,
  <8, 55, 46>, 2,
  <8, 46, 33>, 2,
  <8, 33, 22>, 2,
  <8, 22, 14>, 2,
  <11, 18, 27>, 2,
  <11, 27, 39>, 2,
  <11, 39, 52>, 2,
  <11, 52, 61>, 2,
  <11, 61, 48>, 2,
  <11, 48, 36>, 2,
  <11, 36, 25>, 2,
  <11, 25, 17>, 2,
  <24, 34, 45>, 2,
  <24, 45, 57>, 2,
  <24, 57, 69>, 2,
  <24, 69, 82>, 2,
  <24, 82, 71>, 2,
  <24, 71, 59>, 2,
  <24, 59, 47>, 2,
  <24, 47, 35>, 2,
  <29, 41, 53>, 2,
  <29, 53, 65>, 2,
  <29, 65, 77>, 2,
  <29, 77, 88>, 2,
  <29, 88, 75>, 2,
  <29, 75, 63>, 2,
  <29, 63, 51>, 2,
  <29, 51, 40>, 2,
  <32, 44, 56>, 2,
  <32, 56, 68>, 2,
  <32, 68, 80>, 2,
  <32, 80, 91>, 2,
  <32, 91, 78>, 2,
  <32, 78, 66>, 2,
  <32, 66, 54>, 2,
  <32, 54, 43>, 2,
  <38, 49, 60>, 2,
  <38, 60, 72>, 2,
  <38, 72, 84>, 2,
  <38, 84, 96>, 2,
  <38, 96, 86>, 2,
  <38, 86, 74>, 2,
  <38, 74, 62>, 2,
  <38, 62, 50>, 2,
  <58, 67, 79>, 2,
  <58, 79, 90>, 2,
  <58, 90, 100>, 2,
  <58, 100, 108>, 2,
  <58, 108, 102>, 2,
  <58, 102, 93>, 2,
  <58, 93, 81>, 2,
  <58, 81, 70>, 2,
  <64, 76, 87>, 2,
  <64, 87, 98>, 2,
  <64, 98, 106>, 2,
  <64, 106, 111>, 2,
  <64, 111, 104>, 2,
  <64, 104, 95>, 2,
  <64, 95, 85>, 2,
  <64, 85, 73>, 2,
  <83, 94, 103>, 2,
  <83, 103, 110>, 2,
  <83, 110, 115>, 2,
  <83, 115, 117>, 2,
  <83, 117, 113>, 2,
  <83, 113, 107>, 2,
  <83, 107, 99>, 2,
  <83, 99, 89>, 2,
  <92, 97, 105>, 2,
  <92, 105, 112>, 2,
  <92, 112, 116>, 2,
  <92, 116, 119>, 2,
  <92, 119, 118>, 2,
  <92, 118, 114>, 2,
  <92, 114, 109>, 2,
  <92, 109, 101>, 2
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_truncated_icosidodecahedron_verts[92];
 #local P1 = Archimedean_truncated_icosidodecahedron_verts[97];
 #local P2 = Archimedean_truncated_icosidodecahedron_verts[105];
 #local P3 = Archimedean_truncated_icosidodecahedron_verts[112];
 #local P4 = Archimedean_truncated_icosidodecahedron_verts[116];
 #local P5 = Archimedean_truncated_icosidodecahedron_verts[119];
 #local P6 = Archimedean_truncated_icosidodecahedron_verts[118];
 #local P7 = Archimedean_truncated_icosidodecahedron_verts[114];
 #local P8 = Archimedean_truncated_icosidodecahedron_verts[109];
 #local P9 = Archimedean_truncated_icosidodecahedron_verts[101];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_truncated_icosidodecahedron_obj
  translate -(P0+P1+P2+P3+P4+P5+P6+P7+P8+P9)/10
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_truncated_icosidodecahedron_obj }
#end
#end

#macro Archimedean_truncated_icosidodecahedron_faces2(OnPlane)
#local Archimedean_truncated_icosidodecahedron_obj = mesh2 {
 vertex_vectors {
  120,
  Archimedean_truncated_icosidodecahedron_verts[0],
  Archimedean_truncated_icosidodecahedron_verts[1],
  Archimedean_truncated_icosidodecahedron_verts[2],
  Archimedean_truncated_icosidodecahedron_verts[3],
  Archimedean_truncated_icosidodecahedron_verts[4],
  Archimedean_truncated_icosidodecahedron_verts[5],
  Archimedean_truncated_icosidodecahedron_verts[6],
  Archimedean_truncated_icosidodecahedron_verts[7],
  Archimedean_truncated_icosidodecahedron_verts[8],
  Archimedean_truncated_icosidodecahedron_verts[9],
  Archimedean_truncated_icosidodecahedron_verts[10],
  Archimedean_truncated_icosidodecahedron_verts[11],
  Archimedean_truncated_icosidodecahedron_verts[12],
  Archimedean_truncated_icosidodecahedron_verts[13],
  Archimedean_truncated_icosidodecahedron_verts[14],
  Archimedean_truncated_icosidodecahedron_verts[15],
  Archimedean_truncated_icosidodecahedron_verts[16],
  Archimedean_truncated_icosidodecahedron_verts[17],
  Archimedean_truncated_icosidodecahedron_verts[18],
  Archimedean_truncated_icosidodecahedron_verts[19],
  Archimedean_truncated_icosidodecahedron_verts[20],
  Archimedean_truncated_icosidodecahedron_verts[21],
  Archimedean_truncated_icosidodecahedron_verts[22],
  Archimedean_truncated_icosidodecahedron_verts[23],
  Archimedean_truncated_icosidodecahedron_verts[24],
  Archimedean_truncated_icosidodecahedron_verts[25],
  Archimedean_truncated_icosidodecahedron_verts[26],
  Archimedean_truncated_icosidodecahedron_verts[27],
  Archimedean_truncated_icosidodecahedron_verts[28],
  Archimedean_truncated_icosidodecahedron_verts[29],
  Archimedean_truncated_icosidodecahedron_verts[30],
  Archimedean_truncated_icosidodecahedron_verts[31],
  Archimedean_truncated_icosidodecahedron_verts[32],
  Archimedean_truncated_icosidodecahedron_verts[33],
  Archimedean_truncated_icosidodecahedron_verts[34],
  Archimedean_truncated_icosidodecahedron_verts[35],
  Archimedean_truncated_icosidodecahedron_verts[36],
  Archimedean_truncated_icosidodecahedron_verts[37],
  Archimedean_truncated_icosidodecahedron_verts[38],
  Archimedean_truncated_icosidodecahedron_verts[39],
  Archimedean_truncated_icosidodecahedron_verts[40],
  Archimedean_truncated_icosidodecahedron_verts[41],
  Archimedean_truncated_icosidodecahedron_verts[42],
  Archimedean_truncated_icosidodecahedron_verts[43],
  Archimedean_truncated_icosidodecahedron_verts[44],
  Archimedean_truncated_icosidodecahedron_verts[45],
  Archimedean_truncated_icosidodecahedron_verts[46],
  Archimedean_truncated_icosidodecahedron_verts[47],
  Archimedean_truncated_icosidodecahedron_verts[48],
  Archimedean_truncated_icosidodecahedron_verts[49],
  Archimedean_truncated_icosidodecahedron_verts[50],
  Archimedean_truncated_icosidodecahedron_verts[51],
  Archimedean_truncated_icosidodecahedron_verts[52],
  Archimedean_truncated_icosidodecahedron_verts[53],
  Archimedean_truncated_icosidodecahedron_verts[54],
  Archimedean_truncated_icosidodecahedron_verts[55],
  Archimedean_truncated_icosidodecahedron_verts[56],
  Archimedean_truncated_icosidodecahedron_verts[57],
  Archimedean_truncated_icosidodecahedron_verts[58],
  Archimedean_truncated_icosidodecahedron_verts[59],
  Archimedean_truncated_icosidodecahedron_verts[60],
  Archimedean_truncated_icosidodecahedron_verts[61],
  Archimedean_truncated_icosidodecahedron_verts[62],
  Archimedean_truncated_icosidodecahedron_verts[63],
  Archimedean_truncated_icosidodecahedron_verts[64],
  Archimedean_truncated_icosidodecahedron_verts[65],
  Archimedean_truncated_icosidodecahedron_verts[66],
  Archimedean_truncated_icosidodecahedron_verts[67],
  Archimedean_truncated_icosidodecahedron_verts[68],
  Archimedean_truncated_icosidodecahedron_verts[69],
  Archimedean_truncated_icosidodecahedron_verts[70],
  Archimedean_truncated_icosidodecahedron_verts[71],
  Archimedean_truncated_icosidodecahedron_verts[72],
  Archimedean_truncated_icosidodecahedron_verts[73],
  Archimedean_truncated_icosidodecahedron_verts[74],
  Archimedean_truncated_icosidodecahedron_verts[75],
  Archimedean_truncated_icosidodecahedron_verts[76],
  Archimedean_truncated_icosidodecahedron_verts[77],
  Archimedean_truncated_icosidodecahedron_verts[78],
  Archimedean_truncated_icosidodecahedron_verts[79],
  Archimedean_truncated_icosidodecahedron_verts[80],
  Archimedean_truncated_icosidodecahedron_verts[81],
  Archimedean_truncated_icosidodecahedron_verts[82],
  Archimedean_truncated_icosidodecahedron_verts[83],
  Archimedean_truncated_icosidodecahedron_verts[84],
  Archimedean_truncated_icosidodecahedron_verts[85],
  Archimedean_truncated_icosidodecahedron_verts[86],
  Archimedean_truncated_icosidodecahedron_verts[87],
  Archimedean_truncated_icosidodecahedron_verts[88],
  Archimedean_truncated_icosidodecahedron_verts[89],
  Archimedean_truncated_icosidodecahedron_verts[90],
  Archimedean_truncated_icosidodecahedron_verts[91],
  Archimedean_truncated_icosidodecahedron_verts[92],
  Archimedean_truncated_icosidodecahedron_verts[93],
  Archimedean_truncated_icosidodecahedron_verts[94],
  Archimedean_truncated_icosidodecahedron_verts[95],
  Archimedean_truncated_icosidodecahedron_verts[96],
  Archimedean_truncated_icosidodecahedron_verts[97],
  Archimedean_truncated_icosidodecahedron_verts[98],
  Archimedean_truncated_icosidodecahedron_verts[99],
  Archimedean_truncated_icosidodecahedron_verts[100],
  Archimedean_truncated_icosidodecahedron_verts[101],
  Archimedean_truncated_icosidodecahedron_verts[102],
  Archimedean_truncated_icosidodecahedron_verts[103],
  Archimedean_truncated_icosidodecahedron_verts[104],
  Archimedean_truncated_icosidodecahedron_verts[105],
  Archimedean_truncated_icosidodecahedron_verts[106],
  Archimedean_truncated_icosidodecahedron_verts[107],
  Archimedean_truncated_icosidodecahedron_verts[108],
  Archimedean_truncated_icosidodecahedron_verts[109],
  Archimedean_truncated_icosidodecahedron_verts[110],
  Archimedean_truncated_icosidodecahedron_verts[111],
  Archimedean_truncated_icosidodecahedron_verts[112],
  Archimedean_truncated_icosidodecahedron_verts[113],
  Archimedean_truncated_icosidodecahedron_verts[114],
  Archimedean_truncated_icosidodecahedron_verts[115],
  Archimedean_truncated_icosidodecahedron_verts[116],
  Archimedean_truncated_icosidodecahedron_verts[117],
  Archimedean_truncated_icosidodecahedron_verts[118],
  Archimedean_truncated_icosidodecahedron_verts[119]
 }
 face_indices {
  236,
  <0, 1, 4>,
  <0, 4, 2>,
  <3, 8, 14>,
  <3, 14, 7>,
  <5, 10, 18>,
  <5, 18, 11>,
  <6, 12, 20>,
  <6, 20, 13>,
  <9, 17, 25>,
  <9, 25, 16>,
  <15, 24, 35>,
  <15, 35, 23>,
  <19, 28, 41>,
  <19, 41, 29>,
  <21, 31, 44>,
  <21, 44, 32>,
  <22, 33, 45>,
  <22, 45, 34>,
  <26, 38, 50>,
  <26, 50, 37>,
  <27, 40, 51>,
  <27, 51, 39>,
  <30, 43, 54>,
  <30, 54, 42>,
  <36, 48, 60>,
  <36, 60, 49>,
  <46, 55, 67>,
  <46, 67, 58>,
  <47, 59, 65>,
  <47, 65, 53>,
  <52, 64, 73>,
  <52, 73, 61>,
  <56, 62, 74>,
  <56, 74, 68>,
  <57, 70, 81>,
  <57, 81, 69>,
  <63, 75, 87>,
  <63, 87, 76>,
  <66, 78, 90>,
  <66, 90, 79>,
  <71, 82, 94>,
  <71, 94, 83>,
  <72, 85, 95>,
  <72, 95, 84>,
  <77, 89, 99>,
  <77, 99, 88>,
  <80, 92, 101>,
  <80, 101, 91>,
  <86, 96, 105>,
  <86, 105, 97>,
  <93, 102, 110>,
  <93, 110, 103>,
  <98, 107, 113>,
  <98, 113, 106>,
  <100, 109, 114>,
  <100, 114, 108>,
  <104, 111, 116>,
  <104, 116, 112>,
  <115, 118, 119>,
  <115, 119, 117>,
  <0, 2, 6>,
  <0, 6, 13>,
  <0, 13, 8>,
  <0, 8, 3>,
  <1, 5, 11>,
  <1, 11, 17>,
  <1, 17, 9>,
  <1, 9, 4>,
  <7, 14, 22>,
  <7, 22, 34>,
  <7, 34, 24>,
  <7, 24, 15>,
  <10, 19, 29>,
  <10, 29, 40>,
  <10, 40, 27>,
  <10, 27, 18>,
  <12, 21, 32>,
  <12, 32, 43>,
  <12, 43, 30>,
  <12, 30, 20>,
  <16, 25, 36>,
  <16, 36, 49>,
  <16, 49, 38>,
  <16, 38, 26>,
  <23, 35, 47>,
  <23, 47, 53>,
  <23, 53, 41>,
  <23, 41, 28>,
  <31, 37, 50>,
  <31, 50, 62>,
  <31, 62, 56>,
  <31, 56, 44>,
  <33, 46, 58>,
  <33, 58, 70>,
  <33, 70, 57>,
  <33, 57, 45>,
  <39, 51, 63>,
  <39, 63, 76>,
  <39, 76, 64>,
  <39, 64, 52>,
  <42, 54, 66>,
  <42, 66, 79>,
  <42, 79, 67>,
  <42, 67, 55>,
  <48, 61, 73>,
  <48, 73, 85>,
  <48, 85, 72>,
  <48, 72, 60>,
  <59, 71, 83>,
  <59, 83, 89>,
  <59, 89, 77>,
  <59, 77, 65>,
  <68, 74, 86>,
  <68, 86, 97>,
  <68, 97, 92>,
  <68, 92, 80>,
  <69, 81, 93>,
  <69, 93, 103>,
  <69, 103, 94>,
  <69, 94, 82>,
  <75, 88, 99>,
  <75, 99, 107>,
  <75, 107, 98>,
  <75, 98, 87>,
  <78, 91, 101>,
  <78, 101, 109>,
  <78, 109, 100>,
  <78, 100, 90>,
  <84, 95, 104>,
  <84, 104, 112>,
  <84, 112, 105>,
  <84, 105, 96>,
  <102, 108, 114>,
  <102, 114, 118>,
  <102, 118, 115>,
  <102, 115, 110>,
  <106, 113, 117>,
  <106, 117, 119>,
  <106, 119, 116>,
  <106, 116, 111>,
  <0, 3, 7>,
  <0, 7, 15>,
  <0, 15, 23>,
  <0, 23, 28>,
  <0, 28, 19>,
  <0, 19, 10>,
  <0, 10, 5>,
  <0, 5, 1>,
  <2, 4, 9>,
  <2, 9, 16>,
  <2, 16, 26>,
  <2, 26, 37>,
  <2, 37, 31>,
  <2, 31, 21>,
  <2, 21, 12>,
  <2, 12, 6>,
  <8, 13, 20>,
  <8, 20, 30>,
  <8, 30, 42>,
  <8, 42, 55>,
  <8, 55, 46>,
  <8, 46, 33>,
  <8, 33, 22>,
  <8, 22, 14>,
  <11, 18, 27>,
  <11, 27, 39>,
  <11, 39, 52>,
  <11, 52, 61>,
  <11, 61, 48>,
  <11, 48, 36>,
  <11, 36, 25>,
  <11, 25, 17>,
  <24, 34, 45>,
  <24, 45, 57>,
  <24, 57, 69>,
  <24, 69, 82>,
  <24, 82, 71>,
  <24, 71, 59>,
  <24, 59, 47>,
  <24, 47, 35>,
  <29, 41, 53>,
  <29, 53, 65>,
  <29, 65, 77>,
  <29, 77, 88>,
  <29, 88, 75>,
  <29, 75, 63>,
  <29, 63, 51>,
  <29, 51, 40>,
  <32, 44, 56>,
  <32, 56, 68>,
  <32, 68, 80>,
  <32, 80, 91>,
  <32, 91, 78>,
  <32, 78, 66>,
  <32, 66, 54>,
  <32, 54, 43>,
  <38, 49, 60>,
  <38, 60, 72>,
  <38, 72, 84>,
  <38, 84, 96>,
  <38, 96, 86>,
  <38, 86, 74>,
  <38, 74, 62>,
  <38, 62, 50>,
  <58, 67, 79>,
  <58, 79, 90>,
  <58, 90, 100>,
  <58, 100, 108>,
  <58, 108, 102>,
  <58, 102, 93>,
  <58, 93, 81>,
  <58, 81, 70>,
  <64, 76, 87>,
  <64, 87, 98>,
  <64, 98, 106>,
  <64, 106, 111>,
  <64, 111, 104>,
  <64, 104, 95>,
  <64, 95, 85>,
  <64, 85, 73>,
  <83, 94, 103>,
  <83, 103, 110>,
  <83, 110, 115>,
  <83, 115, 117>,
  <83, 117, 113>,
  <83, 113, 107>,
  <83, 107, 99>,
  <83, 99, 89>,
  <92, 97, 105>,
  <92, 105, 112>,
  <92, 112, 116>,
  <92, 116, 119>,
  <92, 119, 118>,
  <92, 118, 114>,
  <92, 114, 109>,
  <92, 109, 101>
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_truncated_icosidodecahedron_verts[92];
 #local P1 = Archimedean_truncated_icosidodecahedron_verts[97];
 #local P2 = Archimedean_truncated_icosidodecahedron_verts[105];
 #local P3 = Archimedean_truncated_icosidodecahedron_verts[112];
 #local P4 = Archimedean_truncated_icosidodecahedron_verts[116];
 #local P5 = Archimedean_truncated_icosidodecahedron_verts[119];
 #local P6 = Archimedean_truncated_icosidodecahedron_verts[118];
 #local P7 = Archimedean_truncated_icosidodecahedron_verts[114];
 #local P8 = Archimedean_truncated_icosidodecahedron_verts[109];
 #local P9 = Archimedean_truncated_icosidodecahedron_verts[101];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_truncated_icosidodecahedron_obj
  translate -(P0+P1+P2+P3+P4+P5+P6+P7+P8+P9)/10
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_truncated_icosidodecahedron_obj }
#end
#end

#macro Archimedean_truncated_icosidodecahedron_edges(RadEdg, RadVer, TexEdg, TexVer, OnPlane)
union {
 union {
  sphere { Archimedean_truncated_icosidodecahedron_verts[0], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[1], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[2], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[3], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[4], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[5], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[6], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[7], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[8], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[9], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[10], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[11], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[12], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[13], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[14], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[15], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[16], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[17], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[18], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[19], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[20], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[21], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[22], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[23], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[24], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[25], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[26], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[27], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[28], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[29], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[30], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[31], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[32], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[33], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[34], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[35], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[36], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[37], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[38], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[39], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[40], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[41], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[42], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[43], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[44], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[45], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[46], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[47], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[48], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[49], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[50], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[51], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[52], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[53], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[54], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[55], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[56], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[57], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[58], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[59], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[60], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[61], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[62], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[63], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[64], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[65], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[66], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[67], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[68], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[69], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[70], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[71], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[72], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[73], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[74], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[75], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[76], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[77], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[78], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[79], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[80], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[81], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[82], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[83], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[84], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[85], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[86], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[87], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[88], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[89], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[90], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[91], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[92], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[93], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[94], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[95], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[96], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[97], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[98], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[99], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[100], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[101], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[102], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[103], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[104], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[105], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[106], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[107], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[108], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[109], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[110], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[111], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[112], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[113], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[114], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[115], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[116], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[117], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[118], RadVer }
  sphere { Archimedean_truncated_icosidodecahedron_verts[119], RadVer }
  texture { TexVer } }
 union {
  cylinder { Archimedean_truncated_icosidodecahedron_verts[0], Archimedean_truncated_icosidodecahedron_verts[1], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[1], Archimedean_truncated_icosidodecahedron_verts[4], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[4], Archimedean_truncated_icosidodecahedron_verts[2], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[2], Archimedean_truncated_icosidodecahedron_verts[0], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[3], Archimedean_truncated_icosidodecahedron_verts[8], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[8], Archimedean_truncated_icosidodecahedron_verts[14], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[14], Archimedean_truncated_icosidodecahedron_verts[7], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[7], Archimedean_truncated_icosidodecahedron_verts[3], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[5], Archimedean_truncated_icosidodecahedron_verts[10], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[10], Archimedean_truncated_icosidodecahedron_verts[18], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[18], Archimedean_truncated_icosidodecahedron_verts[11], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[11], Archimedean_truncated_icosidodecahedron_verts[5], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[6], Archimedean_truncated_icosidodecahedron_verts[12], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[12], Archimedean_truncated_icosidodecahedron_verts[20], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[20], Archimedean_truncated_icosidodecahedron_verts[13], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[13], Archimedean_truncated_icosidodecahedron_verts[6], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[9], Archimedean_truncated_icosidodecahedron_verts[17], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[17], Archimedean_truncated_icosidodecahedron_verts[25], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[25], Archimedean_truncated_icosidodecahedron_verts[16], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[16], Archimedean_truncated_icosidodecahedron_verts[9], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[15], Archimedean_truncated_icosidodecahedron_verts[24], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[24], Archimedean_truncated_icosidodecahedron_verts[35], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[35], Archimedean_truncated_icosidodecahedron_verts[23], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[23], Archimedean_truncated_icosidodecahedron_verts[15], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[19], Archimedean_truncated_icosidodecahedron_verts[28], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[28], Archimedean_truncated_icosidodecahedron_verts[41], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[41], Archimedean_truncated_icosidodecahedron_verts[29], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[29], Archimedean_truncated_icosidodecahedron_verts[19], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[21], Archimedean_truncated_icosidodecahedron_verts[31], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[31], Archimedean_truncated_icosidodecahedron_verts[44], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[44], Archimedean_truncated_icosidodecahedron_verts[32], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[32], Archimedean_truncated_icosidodecahedron_verts[21], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[22], Archimedean_truncated_icosidodecahedron_verts[33], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[33], Archimedean_truncated_icosidodecahedron_verts[45], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[45], Archimedean_truncated_icosidodecahedron_verts[34], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[34], Archimedean_truncated_icosidodecahedron_verts[22], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[26], Archimedean_truncated_icosidodecahedron_verts[38], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[38], Archimedean_truncated_icosidodecahedron_verts[50], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[50], Archimedean_truncated_icosidodecahedron_verts[37], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[37], Archimedean_truncated_icosidodecahedron_verts[26], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[27], Archimedean_truncated_icosidodecahedron_verts[40], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[40], Archimedean_truncated_icosidodecahedron_verts[51], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[51], Archimedean_truncated_icosidodecahedron_verts[39], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[39], Archimedean_truncated_icosidodecahedron_verts[27], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[30], Archimedean_truncated_icosidodecahedron_verts[43], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[43], Archimedean_truncated_icosidodecahedron_verts[54], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[54], Archimedean_truncated_icosidodecahedron_verts[42], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[42], Archimedean_truncated_icosidodecahedron_verts[30], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[36], Archimedean_truncated_icosidodecahedron_verts[48], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[48], Archimedean_truncated_icosidodecahedron_verts[60], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[60], Archimedean_truncated_icosidodecahedron_verts[49], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[49], Archimedean_truncated_icosidodecahedron_verts[36], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[46], Archimedean_truncated_icosidodecahedron_verts[55], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[55], Archimedean_truncated_icosidodecahedron_verts[67], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[67], Archimedean_truncated_icosidodecahedron_verts[58], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[58], Archimedean_truncated_icosidodecahedron_verts[46], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[47], Archimedean_truncated_icosidodecahedron_verts[59], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[59], Archimedean_truncated_icosidodecahedron_verts[65], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[65], Archimedean_truncated_icosidodecahedron_verts[53], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[53], Archimedean_truncated_icosidodecahedron_verts[47], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[52], Archimedean_truncated_icosidodecahedron_verts[64], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[64], Archimedean_truncated_icosidodecahedron_verts[73], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[73], Archimedean_truncated_icosidodecahedron_verts[61], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[61], Archimedean_truncated_icosidodecahedron_verts[52], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[56], Archimedean_truncated_icosidodecahedron_verts[62], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[62], Archimedean_truncated_icosidodecahedron_verts[74], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[74], Archimedean_truncated_icosidodecahedron_verts[68], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[68], Archimedean_truncated_icosidodecahedron_verts[56], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[57], Archimedean_truncated_icosidodecahedron_verts[70], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[70], Archimedean_truncated_icosidodecahedron_verts[81], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[81], Archimedean_truncated_icosidodecahedron_verts[69], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[69], Archimedean_truncated_icosidodecahedron_verts[57], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[63], Archimedean_truncated_icosidodecahedron_verts[75], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[75], Archimedean_truncated_icosidodecahedron_verts[87], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[87], Archimedean_truncated_icosidodecahedron_verts[76], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[76], Archimedean_truncated_icosidodecahedron_verts[63], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[66], Archimedean_truncated_icosidodecahedron_verts[78], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[78], Archimedean_truncated_icosidodecahedron_verts[90], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[90], Archimedean_truncated_icosidodecahedron_verts[79], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[79], Archimedean_truncated_icosidodecahedron_verts[66], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[71], Archimedean_truncated_icosidodecahedron_verts[82], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[82], Archimedean_truncated_icosidodecahedron_verts[94], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[94], Archimedean_truncated_icosidodecahedron_verts[83], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[83], Archimedean_truncated_icosidodecahedron_verts[71], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[72], Archimedean_truncated_icosidodecahedron_verts[85], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[85], Archimedean_truncated_icosidodecahedron_verts[95], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[95], Archimedean_truncated_icosidodecahedron_verts[84], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[84], Archimedean_truncated_icosidodecahedron_verts[72], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[77], Archimedean_truncated_icosidodecahedron_verts[89], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[89], Archimedean_truncated_icosidodecahedron_verts[99], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[99], Archimedean_truncated_icosidodecahedron_verts[88], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[88], Archimedean_truncated_icosidodecahedron_verts[77], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[80], Archimedean_truncated_icosidodecahedron_verts[92], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[92], Archimedean_truncated_icosidodecahedron_verts[101], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[101], Archimedean_truncated_icosidodecahedron_verts[91], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[91], Archimedean_truncated_icosidodecahedron_verts[80], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[86], Archimedean_truncated_icosidodecahedron_verts[96], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[96], Archimedean_truncated_icosidodecahedron_verts[105], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[105], Archimedean_truncated_icosidodecahedron_verts[97], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[97], Archimedean_truncated_icosidodecahedron_verts[86], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[93], Archimedean_truncated_icosidodecahedron_verts[102], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[102], Archimedean_truncated_icosidodecahedron_verts[110], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[110], Archimedean_truncated_icosidodecahedron_verts[103], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[103], Archimedean_truncated_icosidodecahedron_verts[93], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[98], Archimedean_truncated_icosidodecahedron_verts[107], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[107], Archimedean_truncated_icosidodecahedron_verts[113], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[113], Archimedean_truncated_icosidodecahedron_verts[106], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[106], Archimedean_truncated_icosidodecahedron_verts[98], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[100], Archimedean_truncated_icosidodecahedron_verts[109], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[109], Archimedean_truncated_icosidodecahedron_verts[114], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[114], Archimedean_truncated_icosidodecahedron_verts[108], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[108], Archimedean_truncated_icosidodecahedron_verts[100], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[104], Archimedean_truncated_icosidodecahedron_verts[111], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[111], Archimedean_truncated_icosidodecahedron_verts[116], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[116], Archimedean_truncated_icosidodecahedron_verts[112], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[112], Archimedean_truncated_icosidodecahedron_verts[104], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[115], Archimedean_truncated_icosidodecahedron_verts[118], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[118], Archimedean_truncated_icosidodecahedron_verts[119], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[119], Archimedean_truncated_icosidodecahedron_verts[117], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[117], Archimedean_truncated_icosidodecahedron_verts[115], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[2], Archimedean_truncated_icosidodecahedron_verts[6], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[13], Archimedean_truncated_icosidodecahedron_verts[8], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[3], Archimedean_truncated_icosidodecahedron_verts[0], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[1], Archimedean_truncated_icosidodecahedron_verts[5], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[11], Archimedean_truncated_icosidodecahedron_verts[17], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[9], Archimedean_truncated_icosidodecahedron_verts[4], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[14], Archimedean_truncated_icosidodecahedron_verts[22], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[34], Archimedean_truncated_icosidodecahedron_verts[24], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[15], Archimedean_truncated_icosidodecahedron_verts[7], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[10], Archimedean_truncated_icosidodecahedron_verts[19], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[29], Archimedean_truncated_icosidodecahedron_verts[40], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[27], Archimedean_truncated_icosidodecahedron_verts[18], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[12], Archimedean_truncated_icosidodecahedron_verts[21], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[32], Archimedean_truncated_icosidodecahedron_verts[43], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[30], Archimedean_truncated_icosidodecahedron_verts[20], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[25], Archimedean_truncated_icosidodecahedron_verts[36], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[49], Archimedean_truncated_icosidodecahedron_verts[38], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[26], Archimedean_truncated_icosidodecahedron_verts[16], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[35], Archimedean_truncated_icosidodecahedron_verts[47], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[53], Archimedean_truncated_icosidodecahedron_verts[41], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[28], Archimedean_truncated_icosidodecahedron_verts[23], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[31], Archimedean_truncated_icosidodecahedron_verts[37], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[50], Archimedean_truncated_icosidodecahedron_verts[62], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[56], Archimedean_truncated_icosidodecahedron_verts[44], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[33], Archimedean_truncated_icosidodecahedron_verts[46], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[58], Archimedean_truncated_icosidodecahedron_verts[70], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[57], Archimedean_truncated_icosidodecahedron_verts[45], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[51], Archimedean_truncated_icosidodecahedron_verts[63], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[76], Archimedean_truncated_icosidodecahedron_verts[64], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[52], Archimedean_truncated_icosidodecahedron_verts[39], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[54], Archimedean_truncated_icosidodecahedron_verts[66], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[79], Archimedean_truncated_icosidodecahedron_verts[67], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[55], Archimedean_truncated_icosidodecahedron_verts[42], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[48], Archimedean_truncated_icosidodecahedron_verts[61], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[73], Archimedean_truncated_icosidodecahedron_verts[85], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[72], Archimedean_truncated_icosidodecahedron_verts[60], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[59], Archimedean_truncated_icosidodecahedron_verts[71], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[83], Archimedean_truncated_icosidodecahedron_verts[89], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[77], Archimedean_truncated_icosidodecahedron_verts[65], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[74], Archimedean_truncated_icosidodecahedron_verts[86], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[97], Archimedean_truncated_icosidodecahedron_verts[92], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[80], Archimedean_truncated_icosidodecahedron_verts[68], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[81], Archimedean_truncated_icosidodecahedron_verts[93], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[103], Archimedean_truncated_icosidodecahedron_verts[94], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[82], Archimedean_truncated_icosidodecahedron_verts[69], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[75], Archimedean_truncated_icosidodecahedron_verts[88], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[99], Archimedean_truncated_icosidodecahedron_verts[107], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[98], Archimedean_truncated_icosidodecahedron_verts[87], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[78], Archimedean_truncated_icosidodecahedron_verts[91], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[101], Archimedean_truncated_icosidodecahedron_verts[109], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[100], Archimedean_truncated_icosidodecahedron_verts[90], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[95], Archimedean_truncated_icosidodecahedron_verts[104], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[112], Archimedean_truncated_icosidodecahedron_verts[105], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[96], Archimedean_truncated_icosidodecahedron_verts[84], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[102], Archimedean_truncated_icosidodecahedron_verts[108], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[114], Archimedean_truncated_icosidodecahedron_verts[118], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[115], Archimedean_truncated_icosidodecahedron_verts[110], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[113], Archimedean_truncated_icosidodecahedron_verts[117], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[119], Archimedean_truncated_icosidodecahedron_verts[116], RadEdg }
  cylinder { Archimedean_truncated_icosidodecahedron_verts[111], Archimedean_truncated_icosidodecahedron_verts[106], RadEdg }
  texture { TexEdg } }
#if (OnPlane)
 #local P0 = Archimedean_truncated_icosidodecahedron_verts[92];
 #local P1 = Archimedean_truncated_icosidodecahedron_verts[97];
 #local P2 = Archimedean_truncated_icosidodecahedron_verts[105];
 #local P3 = Archimedean_truncated_icosidodecahedron_verts[112];
 #local P4 = Archimedean_truncated_icosidodecahedron_verts[116];
 #local P5 = Archimedean_truncated_icosidodecahedron_verts[119];
 #local P6 = Archimedean_truncated_icosidodecahedron_verts[118];
 #local P7 = Archimedean_truncated_icosidodecahedron_verts[114];
 #local P8 = Archimedean_truncated_icosidodecahedron_verts[109];
 #local P9 = Archimedean_truncated_icosidodecahedron_verts[101];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
  translate -(P0+P1+P2+P3+P4+P5+P6+P7+P8+P9)/10
  Reorient_Trans(Axis, y)
  translate y*max(RadEdg, RadVer)
#end
 }
#end

#declare Archimedean_snub_icosidodecahedron_verts = array[60]
{
<0, 0, 1.028031>,
<0.4638569, 0, 0.9174342>,
<0.2187436, 0.4090409, 0.9174342>,
<-0.2575486, 0.3857874, 0.9174342>,
<-0.4616509, -0.04518499, 0.9174342>,
<-0.177858, -0.4284037, 0.9174342>,
<0.5726782, -0.4284037, 0.7384841>,
<0.8259401, -0.04518499, 0.6104342>,
<0.6437955, 0.3857874, 0.702527>,
<0.349648, 0.7496433, 0.6104342>,
<-0.421009, 0.7120184, 0.6104342>,
<-0.6783139, 0.3212396, 0.702527>,
<-0.6031536, -0.4466658, 0.702527>,
<-0.2749612, -0.7801379, 0.6104342>,
<0.1760766, -0.6931717, 0.7384841>,
<0.5208138, -0.7801379, 0.4206978>,
<0.8552518, -0.4466658, 0.3547998>,
<1.01294, -0.03548596, 0.1718776>,
<0.7182239, 0.661842, 0.3208868>,
<0.3633691, 0.9454568, 0.1758496>,
<-0.04574087, 0.9368937, 0.4206978>,
<-0.4537394, 0.905564, 0.1758496>,
<-0.7792791, 0.5887312, 0.3208868>,
<-0.9537217, 0.1462217, 0.3547998>
<-0.9072701, -0.3283699, 0.3547998>,
<-0.6503371, -0.7286577, 0.3208868>,
<0.08459482, -0.9611501, 0.3547998>,
<0.3949153, -0.9491262, -0.007072558>,
<0.9360473, -0.409557, -0.1136978>,
<0.9829382, 0.02692292, -0.2999274>,
<0.9463677, 0.4014808, -0.007072558>,
<0.6704578, 0.7662826, -0.1419366>,
<-0.05007646, 1.025698, -0.04779978>,
<-0.4294337, 0.8845784, -0.2999274>,
<-0.9561681, 0.3719321, -0.06525234>,
<-1.022036, -0.1000338, -0.04779978>,
<-0.8659056, -0.5502712, -0.06525234>,
<-0.5227761, -0.8778535, -0.1136978>,
<-0.06856319, -1.021542, -0.09273844>,
<0.2232046, -0.8974878, -0.4489366>,
<0.6515438, -0.7200947, -0.3373472>,
<0.7969535, -0.3253959, -0.5619888>,
<0.8066872, 0.4395354, -0.461425>,
<0.4468035, 0.735788, -0.5619888>,
<0.001488801, 0.8961155, -0.503809>,
<-0.3535403, 0.6537658, -0.7102452>,
<-0.7399517, 0.5547758, -0.4489366>,
<-0.9120238, 0.1102196, -0.461425>,
<-0.6593998, -0.6182798, -0.4896639>,
<-0.2490651, -0.8608088, -0.503809>,
<0.4301047, -0.5764987, -0.734512>,
<0.5057577, -0.1305283, -0.8854492>,
<0.5117735, 0.3422252, -0.8232973>,
<0.09739587, 0.5771941, -0.8451093>,
<-0.6018946, 0.2552591, -0.7933564>,
<-0.6879024, -0.2100741, -0.734512>,
<-0.3340437, -0.5171509, -0.8232973>,
<0.08570633, -0.3414376, -0.9658797>,
<0.1277354, 0.1313635, -1.011571>,
<-0.3044499, -0.06760332, -0.979586>,
}
#local P0 = Archimedean_snub_icosidodecahedron_verts[45];
#local P1 = Archimedean_snub_icosidodecahedron_verts[53];
#local P2 = Archimedean_snub_icosidodecahedron_verts[58];
#local V1 = P1 - P0;
#local V2 = P2 - P0;
#local Axis = vcross(V2, V1);
#local Tran1 = transform { Reorient_Trans(Axis, y) }
#local TV1 = vtransform(V1, Tran1);
#local The_Tran = transform {
 Reorient_Trans(Axis, y)
 Reorient_Trans(TV1, x) }
#local Num = 0;
#while (Num < 60)
 #declare Archimedean_snub_icosidodecahedron_verts[Num] = vtransform(Archimedean_snub_icosidodecahedron_verts[Num], The_Tran);
 #local Num = Num + 1;
#end

#macro Archimedean_snub_icosidodecahedron_faces(Tex3, Tex5, OnPlane)
#local Archimedean_snub_icosidodecahedron_obj = mesh2 {
 vertex_vectors {
  60,
  Archimedean_snub_icosidodecahedron_verts[0],
  Archimedean_snub_icosidodecahedron_verts[1],
  Archimedean_snub_icosidodecahedron_verts[2],
  Archimedean_snub_icosidodecahedron_verts[3],
  Archimedean_snub_icosidodecahedron_verts[4],
  Archimedean_snub_icosidodecahedron_verts[5],
  Archimedean_snub_icosidodecahedron_verts[6],
  Archimedean_snub_icosidodecahedron_verts[7],
  Archimedean_snub_icosidodecahedron_verts[8],
  Archimedean_snub_icosidodecahedron_verts[9],
  Archimedean_snub_icosidodecahedron_verts[10],
  Archimedean_snub_icosidodecahedron_verts[11],
  Archimedean_snub_icosidodecahedron_verts[12],
  Archimedean_snub_icosidodecahedron_verts[13],
  Archimedean_snub_icosidodecahedron_verts[14],
  Archimedean_snub_icosidodecahedron_verts[15],
  Archimedean_snub_icosidodecahedron_verts[16],
  Archimedean_snub_icosidodecahedron_verts[17],
  Archimedean_snub_icosidodecahedron_verts[18],
  Archimedean_snub_icosidodecahedron_verts[19],
  Archimedean_snub_icosidodecahedron_verts[20],
  Archimedean_snub_icosidodecahedron_verts[21],
  Archimedean_snub_icosidodecahedron_verts[22],
  Archimedean_snub_icosidodecahedron_verts[23],
  Archimedean_snub_icosidodecahedron_verts[24],
  Archimedean_snub_icosidodecahedron_verts[25],
  Archimedean_snub_icosidodecahedron_verts[26],
  Archimedean_snub_icosidodecahedron_verts[27],
  Archimedean_snub_icosidodecahedron_verts[28],
  Archimedean_snub_icosidodecahedron_verts[29],
  Archimedean_snub_icosidodecahedron_verts[30],
  Archimedean_snub_icosidodecahedron_verts[31],
  Archimedean_snub_icosidodecahedron_verts[32],
  Archimedean_snub_icosidodecahedron_verts[33],
  Archimedean_snub_icosidodecahedron_verts[34],
  Archimedean_snub_icosidodecahedron_verts[35],
  Archimedean_snub_icosidodecahedron_verts[36],
  Archimedean_snub_icosidodecahedron_verts[37],
  Archimedean_snub_icosidodecahedron_verts[38],
  Archimedean_snub_icosidodecahedron_verts[39],
  Archimedean_snub_icosidodecahedron_verts[40],
  Archimedean_snub_icosidodecahedron_verts[41],
  Archimedean_snub_icosidodecahedron_verts[42],
  Archimedean_snub_icosidodecahedron_verts[43],
  Archimedean_snub_icosidodecahedron_verts[44],
  Archimedean_snub_icosidodecahedron_verts[45],
  Archimedean_snub_icosidodecahedron_verts[46],
  Archimedean_snub_icosidodecahedron_verts[47],
  Archimedean_snub_icosidodecahedron_verts[48],
  Archimedean_snub_icosidodecahedron_verts[49],
  Archimedean_snub_icosidodecahedron_verts[50],
  Archimedean_snub_icosidodecahedron_verts[51],
  Archimedean_snub_icosidodecahedron_verts[52],
  Archimedean_snub_icosidodecahedron_verts[53],
  Archimedean_snub_icosidodecahedron_verts[54],
  Archimedean_snub_icosidodecahedron_verts[55],
  Archimedean_snub_icosidodecahedron_verts[56],
  Archimedean_snub_icosidodecahedron_verts[57],
  Archimedean_snub_icosidodecahedron_verts[58],
  Archimedean_snub_icosidodecahedron_verts[59]
 }
 texture_list {
  2,
  texture { Tex3 },
  texture { Tex5 }
 }
 face_indices {
  116,
  <0, 1, 2>, 0,
  <0, 2, 3>, 0,
  <0, 3, 4>, 0,
  <0, 4, 5>, 0,
  <1, 6, 7>, 0,
  <1, 7, 8>, 0,
  <1, 8, 2>, 0,
  <2, 8, 9>, 0,
  <3, 10, 11>, 0,
  <3, 11, 4>, 0,
  <4, 12, 5>, 0,
  <5, 12, 13>, 0,
  <5, 13, 14>, 0,
  <6, 14, 15>, 0,
  <6, 15, 16>, 0,
  <6, 16, 7>, 0,
  <7, 16, 17>, 0,
  <8, 18, 9>, 0,
  <9, 18, 19>, 0,
  <9, 19, 20>, 0,
  <10, 20, 21>, 0,
  <10, 21, 22>, 0,
  <10, 22, 11>, 0,
  <11, 22, 23>, 0,
  <12, 24, 25>, 0,
  <12, 25, 13>, 0,
  <13, 26, 14>, 0,
  <14, 26, 15>, 0,
  <15, 26, 27>, 0,
  <16, 28, 17>, 0,
  <17, 28, 29>, 0,
  <17, 29, 30>, 0,
  <18, 30, 31>, 0,
  <18, 31, 19>, 0,
  <19, 32, 20>, 0,
  <20, 32, 21>, 0,
  <21, 32, 33>, 0,
  <22, 34, 23>, 0,
  <23, 34, 35>, 0,
  <23, 35, 24>, 0,
  <24, 35, 36>, 0,
  <24, 36, 25>, 0,
  <25, 36, 37>, 0,
  <26, 38, 27>, 0,
  <27, 38, 39>, 0,
  <27, 39, 40>, 0,
  <28, 40, 41>, 0,
  <28, 41, 29>, 0,
  <29, 42, 30>, 0,
  <30, 42, 31>, 0,
  <31, 42, 43>, 0,
  <32, 44, 33>, 0,
  <33, 44, 45>, 0,
  <33, 45, 46>, 0,
  <34, 46, 47>, 0,
  <34, 47, 35>, 0,
  <36, 48, 37>, 0,
  <37, 48, 49>, 0,
  <37, 49, 38>, 0,
  <38, 49, 39>, 0,
  <39, 50, 40>, 0,
  <40, 50, 41>, 0,
  <41, 50, 51>, 0,
  <42, 52, 43>, 0,
  <43, 52, 53>, 0,
  <43, 53, 44>, 0,
  <44, 53, 45>, 0,
  <45, 54, 46>, 0,
  <46, 54, 47>, 0,
  <47, 54, 55>, 0,
  <48, 55, 56>, 0,
  <48, 56, 49>, 0,
  <50, 57, 51>, 0,
  <51, 57, 58>, 0,
  <51, 58, 52>, 0,
  <52, 58, 53>, 0,
  <54, 59, 55>, 0,
  <55, 59, 56>, 0,
  <56, 59, 57>, 0,
  <57, 59, 58>, 0,
  <0, 5, 14>, 1,
  <0, 14, 6>, 1,
  <0, 6, 1>, 1,
  <2, 9, 20>, 1,
  <2, 20, 10>, 1,
  <2, 10, 3>, 1,
  <4, 11, 23>, 1,
  <4, 23, 24>, 1,
  <4, 24, 12>, 1,
  <7, 17, 30>, 1,
  <7, 30, 18>, 1,
  <7, 18, 8>, 1,
  <13, 25, 37>, 1,
  <13, 37, 38>, 1,
  <13, 38, 26>, 1,
  <15, 27, 40>, 1,
  <15, 40, 28>, 1,
  <15, 28, 16>, 1,
  <19, 31, 43>, 1,
  <19, 43, 44>, 1,
  <19, 44, 32>, 1,
  <21, 33, 46>, 1,
  <21, 46, 34>, 1,
  <21, 34, 22>, 1,
  <29, 41, 51>, 1,
  <29, 51, 52>, 1,
  <29, 52, 42>, 1,
  <35, 47, 55>, 1,
  <35, 55, 48>, 1,
  <35, 48, 36>, 1,
  <39, 49, 56>, 1,
  <39, 56, 57>, 1,
  <39, 57, 50>, 1,
  <45, 53, 58>, 1,
  <45, 58, 59>, 1,
  <45, 59, 54>, 1
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_snub_icosidodecahedron_verts[45];
 #local P1 = Archimedean_snub_icosidodecahedron_verts[53];
 #local P2 = Archimedean_snub_icosidodecahedron_verts[58];
 #local P3 = Archimedean_snub_icosidodecahedron_verts[59];
 #local P4 = Archimedean_snub_icosidodecahedron_verts[54];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_snub_icosidodecahedron_obj
  translate -(P0+P1+P2+P3+P4)/5
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_snub_icosidodecahedron_obj }
#end
#end

#macro Archimedean_snub_icosidodecahedron_faces2(OnPlane)
#local Archimedean_snub_icosidodecahedron_obj = mesh2 {
 vertex_vectors {
  60,
  Archimedean_snub_icosidodecahedron_verts[0],
  Archimedean_snub_icosidodecahedron_verts[1],
  Archimedean_snub_icosidodecahedron_verts[2],
  Archimedean_snub_icosidodecahedron_verts[3],
  Archimedean_snub_icosidodecahedron_verts[4],
  Archimedean_snub_icosidodecahedron_verts[5],
  Archimedean_snub_icosidodecahedron_verts[6],
  Archimedean_snub_icosidodecahedron_verts[7],
  Archimedean_snub_icosidodecahedron_verts[8],
  Archimedean_snub_icosidodecahedron_verts[9],
  Archimedean_snub_icosidodecahedron_verts[10],
  Archimedean_snub_icosidodecahedron_verts[11],
  Archimedean_snub_icosidodecahedron_verts[12],
  Archimedean_snub_icosidodecahedron_verts[13],
  Archimedean_snub_icosidodecahedron_verts[14],
  Archimedean_snub_icosidodecahedron_verts[15],
  Archimedean_snub_icosidodecahedron_verts[16],
  Archimedean_snub_icosidodecahedron_verts[17],
  Archimedean_snub_icosidodecahedron_verts[18],
  Archimedean_snub_icosidodecahedron_verts[19],
  Archimedean_snub_icosidodecahedron_verts[20],
  Archimedean_snub_icosidodecahedron_verts[21],
  Archimedean_snub_icosidodecahedron_verts[22],
  Archimedean_snub_icosidodecahedron_verts[23],
  Archimedean_snub_icosidodecahedron_verts[24],
  Archimedean_snub_icosidodecahedron_verts[25],
  Archimedean_snub_icosidodecahedron_verts[26],
  Archimedean_snub_icosidodecahedron_verts[27],
  Archimedean_snub_icosidodecahedron_verts[28],
  Archimedean_snub_icosidodecahedron_verts[29],
  Archimedean_snub_icosidodecahedron_verts[30],
  Archimedean_snub_icosidodecahedron_verts[31],
  Archimedean_snub_icosidodecahedron_verts[32],
  Archimedean_snub_icosidodecahedron_verts[33],
  Archimedean_snub_icosidodecahedron_verts[34],
  Archimedean_snub_icosidodecahedron_verts[35],
  Archimedean_snub_icosidodecahedron_verts[36],
  Archimedean_snub_icosidodecahedron_verts[37],
  Archimedean_snub_icosidodecahedron_verts[38],
  Archimedean_snub_icosidodecahedron_verts[39],
  Archimedean_snub_icosidodecahedron_verts[40],
  Archimedean_snub_icosidodecahedron_verts[41],
  Archimedean_snub_icosidodecahedron_verts[42],
  Archimedean_snub_icosidodecahedron_verts[43],
  Archimedean_snub_icosidodecahedron_verts[44],
  Archimedean_snub_icosidodecahedron_verts[45],
  Archimedean_snub_icosidodecahedron_verts[46],
  Archimedean_snub_icosidodecahedron_verts[47],
  Archimedean_snub_icosidodecahedron_verts[48],
  Archimedean_snub_icosidodecahedron_verts[49],
  Archimedean_snub_icosidodecahedron_verts[50],
  Archimedean_snub_icosidodecahedron_verts[51],
  Archimedean_snub_icosidodecahedron_verts[52],
  Archimedean_snub_icosidodecahedron_verts[53],
  Archimedean_snub_icosidodecahedron_verts[54],
  Archimedean_snub_icosidodecahedron_verts[55],
  Archimedean_snub_icosidodecahedron_verts[56],
  Archimedean_snub_icosidodecahedron_verts[57],
  Archimedean_snub_icosidodecahedron_verts[58],
  Archimedean_snub_icosidodecahedron_verts[59]
 }
 face_indices {
  116,
  <0, 1, 2>,
  <0, 2, 3>,
  <0, 3, 4>,
  <0, 4, 5>,
  <1, 6, 7>,
  <1, 7, 8>,
  <1, 8, 2>,
  <2, 8, 9>,
  <3, 10, 11>,
  <3, 11, 4>,
  <4, 12, 5>,
  <5, 12, 13>,
  <5, 13, 14>,
  <6, 14, 15>,
  <6, 15, 16>,
  <6, 16, 7>,
  <7, 16, 17>,
  <8, 18, 9>,
  <9, 18, 19>,
  <9, 19, 20>,
  <10, 20, 21>,
  <10, 21, 22>,
  <10, 22, 11>,
  <11, 22, 23>,
  <12, 24, 25>,
  <12, 25, 13>,
  <13, 26, 14>,
  <14, 26, 15>,
  <15, 26, 27>,
  <16, 28, 17>,
  <17, 28, 29>,
  <17, 29, 30>,
  <18, 30, 31>,
  <18, 31, 19>,
  <19, 32, 20>,
  <20, 32, 21>,
  <21, 32, 33>,
  <22, 34, 23>,
  <23, 34, 35>,
  <23, 35, 24>,
  <24, 35, 36>,
  <24, 36, 25>,
  <25, 36, 37>,
  <26, 38, 27>,
  <27, 38, 39>,
  <27, 39, 40>,
  <28, 40, 41>,
  <28, 41, 29>,
  <29, 42, 30>,
  <30, 42, 31>,
  <31, 42, 43>,
  <32, 44, 33>,
  <33, 44, 45>,
  <33, 45, 46>,
  <34, 46, 47>,
  <34, 47, 35>,
  <36, 48, 37>,
  <37, 48, 49>,
  <37, 49, 38>,
  <38, 49, 39>,
  <39, 50, 40>,
  <40, 50, 41>,
  <41, 50, 51>,
  <42, 52, 43>,
  <43, 52, 53>,
  <43, 53, 44>,
  <44, 53, 45>,
  <45, 54, 46>,
  <46, 54, 47>,
  <47, 54, 55>,
  <48, 55, 56>,
  <48, 56, 49>,
  <50, 57, 51>,
  <51, 57, 58>,
  <51, 58, 52>,
  <52, 58, 53>,
  <54, 59, 55>,
  <55, 59, 56>,
  <56, 59, 57>,
  <57, 59, 58>,
  <0, 5, 14>,
  <0, 14, 6>,
  <0, 6, 1>,
  <2, 9, 20>,
  <2, 20, 10>,
  <2, 10, 3>,
  <4, 11, 23>,
  <4, 23, 24>,
  <4, 24, 12>,
  <7, 17, 30>,
  <7, 30, 18>,
  <7, 18, 8>,
  <13, 25, 37>,
  <13, 37, 38>,
  <13, 38, 26>,
  <15, 27, 40>,
  <15, 40, 28>,
  <15, 28, 16>,
  <19, 31, 43>,
  <19, 43, 44>,
  <19, 44, 32>,
  <21, 33, 46>,
  <21, 46, 34>,
  <21, 34, 22>,
  <29, 41, 51>,
  <29, 51, 52>,
  <29, 52, 42>,
  <35, 47, 55>,
  <35, 55, 48>,
  <35, 48, 36>,
  <39, 49, 56>,
  <39, 56, 57>,
  <39, 57, 50>,
  <45, 53, 58>,
  <45, 58, 59>,
  <45, 59, 54>
 }
 inside_vector y
 hollow }
#if (OnPlane)
 #local P0 = Archimedean_snub_icosidodecahedron_verts[45];
 #local P1 = Archimedean_snub_icosidodecahedron_verts[53];
 #local P2 = Archimedean_snub_icosidodecahedron_verts[58];
 #local P3 = Archimedean_snub_icosidodecahedron_verts[59];
 #local P4 = Archimedean_snub_icosidodecahedron_verts[54];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
 object {
  Archimedean_snub_icosidodecahedron_obj
  translate -(P0+P1+P2+P3+P4)/5
  Reorient_Trans(Axis, y)
 }
#else
 object { Archimedean_snub_icosidodecahedron_obj }
#end
#end

#macro Archimedean_snub_icosidodecahedron_edges(RadEdg, RadVer, TexEdg, TexVer, OnPlane)
union {
 union {
  sphere { Archimedean_snub_icosidodecahedron_verts[0], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[1], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[2], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[3], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[4], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[5], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[6], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[7], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[8], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[9], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[10], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[11], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[12], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[13], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[14], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[15], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[16], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[17], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[18], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[19], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[20], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[21], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[22], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[23], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[24], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[25], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[26], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[27], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[28], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[29], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[30], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[31], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[32], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[33], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[34], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[35], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[36], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[37], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[38], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[39], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[40], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[41], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[42], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[43], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[44], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[45], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[46], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[47], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[48], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[49], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[50], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[51], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[52], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[53], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[54], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[55], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[56], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[57], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[58], RadVer }
  sphere { Archimedean_snub_icosidodecahedron_verts[59], RadVer }
  texture { TexVer } }
 union {
  cylinder { Archimedean_snub_icosidodecahedron_verts[0], Archimedean_snub_icosidodecahedron_verts[1], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[1], Archimedean_snub_icosidodecahedron_verts[2], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[2], Archimedean_snub_icosidodecahedron_verts[0], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[2], Archimedean_snub_icosidodecahedron_verts[3], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[3], Archimedean_snub_icosidodecahedron_verts[0], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[3], Archimedean_snub_icosidodecahedron_verts[4], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[4], Archimedean_snub_icosidodecahedron_verts[0], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[4], Archimedean_snub_icosidodecahedron_verts[5], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[5], Archimedean_snub_icosidodecahedron_verts[0], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[1], Archimedean_snub_icosidodecahedron_verts[6], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[6], Archimedean_snub_icosidodecahedron_verts[7], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[7], Archimedean_snub_icosidodecahedron_verts[1], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[7], Archimedean_snub_icosidodecahedron_verts[8], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[8], Archimedean_snub_icosidodecahedron_verts[1], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[8], Archimedean_snub_icosidodecahedron_verts[2], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[8], Archimedean_snub_icosidodecahedron_verts[9], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[9], Archimedean_snub_icosidodecahedron_verts[2], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[3], Archimedean_snub_icosidodecahedron_verts[10], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[10], Archimedean_snub_icosidodecahedron_verts[11], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[11], Archimedean_snub_icosidodecahedron_verts[3], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[11], Archimedean_snub_icosidodecahedron_verts[4], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[4], Archimedean_snub_icosidodecahedron_verts[12], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[12], Archimedean_snub_icosidodecahedron_verts[5], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[12], Archimedean_snub_icosidodecahedron_verts[13], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[13], Archimedean_snub_icosidodecahedron_verts[5], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[13], Archimedean_snub_icosidodecahedron_verts[14], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[14], Archimedean_snub_icosidodecahedron_verts[5], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[6], Archimedean_snub_icosidodecahedron_verts[14], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[14], Archimedean_snub_icosidodecahedron_verts[15], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[15], Archimedean_snub_icosidodecahedron_verts[6], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[15], Archimedean_snub_icosidodecahedron_verts[16], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[16], Archimedean_snub_icosidodecahedron_verts[6], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[16], Archimedean_snub_icosidodecahedron_verts[7], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[16], Archimedean_snub_icosidodecahedron_verts[17], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[17], Archimedean_snub_icosidodecahedron_verts[7], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[8], Archimedean_snub_icosidodecahedron_verts[18], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[18], Archimedean_snub_icosidodecahedron_verts[9], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[18], Archimedean_snub_icosidodecahedron_verts[19], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[19], Archimedean_snub_icosidodecahedron_verts[9], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[19], Archimedean_snub_icosidodecahedron_verts[20], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[20], Archimedean_snub_icosidodecahedron_verts[9], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[10], Archimedean_snub_icosidodecahedron_verts[20], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[20], Archimedean_snub_icosidodecahedron_verts[21], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[21], Archimedean_snub_icosidodecahedron_verts[10], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[21], Archimedean_snub_icosidodecahedron_verts[22], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[22], Archimedean_snub_icosidodecahedron_verts[10], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[22], Archimedean_snub_icosidodecahedron_verts[11], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[22], Archimedean_snub_icosidodecahedron_verts[23], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[23], Archimedean_snub_icosidodecahedron_verts[11], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[12], Archimedean_snub_icosidodecahedron_verts[24], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[24], Archimedean_snub_icosidodecahedron_verts[25], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[25], Archimedean_snub_icosidodecahedron_verts[12], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[25], Archimedean_snub_icosidodecahedron_verts[13], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[13], Archimedean_snub_icosidodecahedron_verts[26], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[26], Archimedean_snub_icosidodecahedron_verts[14], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[26], Archimedean_snub_icosidodecahedron_verts[15], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[26], Archimedean_snub_icosidodecahedron_verts[27], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[27], Archimedean_snub_icosidodecahedron_verts[15], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[16], Archimedean_snub_icosidodecahedron_verts[28], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[28], Archimedean_snub_icosidodecahedron_verts[17], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[28], Archimedean_snub_icosidodecahedron_verts[29], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[29], Archimedean_snub_icosidodecahedron_verts[17], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[29], Archimedean_snub_icosidodecahedron_verts[30], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[30], Archimedean_snub_icosidodecahedron_verts[17], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[18], Archimedean_snub_icosidodecahedron_verts[30], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[30], Archimedean_snub_icosidodecahedron_verts[31], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[31], Archimedean_snub_icosidodecahedron_verts[18], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[31], Archimedean_snub_icosidodecahedron_verts[19], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[19], Archimedean_snub_icosidodecahedron_verts[32], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[32], Archimedean_snub_icosidodecahedron_verts[20], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[32], Archimedean_snub_icosidodecahedron_verts[21], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[32], Archimedean_snub_icosidodecahedron_verts[33], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[33], Archimedean_snub_icosidodecahedron_verts[21], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[22], Archimedean_snub_icosidodecahedron_verts[34], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[34], Archimedean_snub_icosidodecahedron_verts[23], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[34], Archimedean_snub_icosidodecahedron_verts[35], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[35], Archimedean_snub_icosidodecahedron_verts[23], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[35], Archimedean_snub_icosidodecahedron_verts[24], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[24], Archimedean_snub_icosidodecahedron_verts[23], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[35], Archimedean_snub_icosidodecahedron_verts[36], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[36], Archimedean_snub_icosidodecahedron_verts[24], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[36], Archimedean_snub_icosidodecahedron_verts[25], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[36], Archimedean_snub_icosidodecahedron_verts[37], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[37], Archimedean_snub_icosidodecahedron_verts[25], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[26], Archimedean_snub_icosidodecahedron_verts[38], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[38], Archimedean_snub_icosidodecahedron_verts[27], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[38], Archimedean_snub_icosidodecahedron_verts[39], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[39], Archimedean_snub_icosidodecahedron_verts[27], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[39], Archimedean_snub_icosidodecahedron_verts[40], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[40], Archimedean_snub_icosidodecahedron_verts[27], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[28], Archimedean_snub_icosidodecahedron_verts[40], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[40], Archimedean_snub_icosidodecahedron_verts[41], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[41], Archimedean_snub_icosidodecahedron_verts[28], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[41], Archimedean_snub_icosidodecahedron_verts[29], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[29], Archimedean_snub_icosidodecahedron_verts[42], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[42], Archimedean_snub_icosidodecahedron_verts[30], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[42], Archimedean_snub_icosidodecahedron_verts[31], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[42], Archimedean_snub_icosidodecahedron_verts[43], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[43], Archimedean_snub_icosidodecahedron_verts[31], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[32], Archimedean_snub_icosidodecahedron_verts[44], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[44], Archimedean_snub_icosidodecahedron_verts[33], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[44], Archimedean_snub_icosidodecahedron_verts[45], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[45], Archimedean_snub_icosidodecahedron_verts[33], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[45], Archimedean_snub_icosidodecahedron_verts[46], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[46], Archimedean_snub_icosidodecahedron_verts[33], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[34], Archimedean_snub_icosidodecahedron_verts[46], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[46], Archimedean_snub_icosidodecahedron_verts[47], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[47], Archimedean_snub_icosidodecahedron_verts[34], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[47], Archimedean_snub_icosidodecahedron_verts[35], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[36], Archimedean_snub_icosidodecahedron_verts[48], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[48], Archimedean_snub_icosidodecahedron_verts[37], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[48], Archimedean_snub_icosidodecahedron_verts[49], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[49], Archimedean_snub_icosidodecahedron_verts[37], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[49], Archimedean_snub_icosidodecahedron_verts[38], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[38], Archimedean_snub_icosidodecahedron_verts[37], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[49], Archimedean_snub_icosidodecahedron_verts[39], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[39], Archimedean_snub_icosidodecahedron_verts[50], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[50], Archimedean_snub_icosidodecahedron_verts[40], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[50], Archimedean_snub_icosidodecahedron_verts[41], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[50], Archimedean_snub_icosidodecahedron_verts[51], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[51], Archimedean_snub_icosidodecahedron_verts[41], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[42], Archimedean_snub_icosidodecahedron_verts[52], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[52], Archimedean_snub_icosidodecahedron_verts[43], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[52], Archimedean_snub_icosidodecahedron_verts[53], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[53], Archimedean_snub_icosidodecahedron_verts[43], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[53], Archimedean_snub_icosidodecahedron_verts[44], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[44], Archimedean_snub_icosidodecahedron_verts[43], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[53], Archimedean_snub_icosidodecahedron_verts[45], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[45], Archimedean_snub_icosidodecahedron_verts[54], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[54], Archimedean_snub_icosidodecahedron_verts[46], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[54], Archimedean_snub_icosidodecahedron_verts[47], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[54], Archimedean_snub_icosidodecahedron_verts[55], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[55], Archimedean_snub_icosidodecahedron_verts[47], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[48], Archimedean_snub_icosidodecahedron_verts[55], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[55], Archimedean_snub_icosidodecahedron_verts[56], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[56], Archimedean_snub_icosidodecahedron_verts[48], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[56], Archimedean_snub_icosidodecahedron_verts[49], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[50], Archimedean_snub_icosidodecahedron_verts[57], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[57], Archimedean_snub_icosidodecahedron_verts[51], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[57], Archimedean_snub_icosidodecahedron_verts[58], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[58], Archimedean_snub_icosidodecahedron_verts[51], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[58], Archimedean_snub_icosidodecahedron_verts[52], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[52], Archimedean_snub_icosidodecahedron_verts[51], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[58], Archimedean_snub_icosidodecahedron_verts[53], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[54], Archimedean_snub_icosidodecahedron_verts[59], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[59], Archimedean_snub_icosidodecahedron_verts[55], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[59], Archimedean_snub_icosidodecahedron_verts[56], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[59], Archimedean_snub_icosidodecahedron_verts[57], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[57], Archimedean_snub_icosidodecahedron_verts[56], RadEdg }
  cylinder { Archimedean_snub_icosidodecahedron_verts[59], Archimedean_snub_icosidodecahedron_verts[58], RadEdg }
  texture { TexEdg } }
#if (OnPlane)
 #local P0 = Archimedean_snub_icosidodecahedron_verts[45];
 #local P1 = Archimedean_snub_icosidodecahedron_verts[53];
 #local P2 = Archimedean_snub_icosidodecahedron_verts[58];
 #local P3 = Archimedean_snub_icosidodecahedron_verts[59];
 #local P4 = Archimedean_snub_icosidodecahedron_verts[54];
 #local V1 = P1 - P0;
 #local V2 = P2 - P0;
 #local Axis = vcross(V2, V1);
  translate -(P0+P1+P2+P3+P4)/5
  Reorient_Trans(Axis, y)
  translate y*max(RadEdg, RadVer)
#end
 }
#end

global_settings {
 assumed_gamma 1
 radiosity { 
  pretrace_start 0.08
  pretrace_end 0.01
  error_bound 0.2
  count 150
  low_error_factor 0.5
  minimum_reuse 0.01
  recursion_limit 1
  nearest_count 4
  gray_threshold 0
  brightness 1 } }

camera {
 location <-5, 15, -10>
 up y
 right x
 angle 45
 look_at <0, 0, 0> }

light_source {
 <100, 150, -25> color rgb 1
 area_light 25*x, 25*y, 8, 8 circular orient adaptive 1 jitter }

// -----
// Create an array of objects containing the plain faces polyhedra.
// -----
#declare Archimedeans = array[13];
#declare Archimedeans[0] = object { Archimedean_truncated_tetrahedron_faces2(yes) }
#declare Archimedeans[1] = object { Archimedean_cuboctahedron_faces2(yes) }
#declare Archimedeans[2] = object { Archimedean_truncated_cube_faces2(yes) }
#declare Archimedeans[3] = object { Archimedean_truncated_octahedron_faces2(yes) }
#declare Archimedeans[4] = object { Archimedean_rhombicuboctahedron_faces2(yes) }
#declare Archimedeans[5] = object { Archimedean_truncated_cuboctahedron_faces2(yes) }
#declare Archimedeans[6] = object { Archimedean_snub_cuboctahedron_faces2(yes) }
#declare Archimedeans[7] = object { Archimedean_icosidodecahedron_faces2(yes) }
#declare Archimedeans[8] = object { Archimedean_truncated_dodecahedron_faces2(yes) }
#declare Archimedeans[9] = object { Archimedean_truncated_icosahedron_faces2(yes) }
#declare Archimedeans[10] = object { Archimedean_rhombicosidodecahedron_faces2(yes) }
#declare Archimedeans[11] = object { Archimedean_truncated_icosidodecahedron_faces2(yes) }
#declare Archimedeans[12] = object { Archimedean_snub_icosidodecahedron_faces2(yes) }

// -----
// Create an array of objects containing the edges/vertices of the polyhedra.
// -----
#declare EdgeT = texture { pigment { rgb 1 } finish { ambient 0 specular 1 roughness 0.01 } }
#declare VertT = texture { pigment { rgb 0.75 } finish { ambient 0 specular 1 roughness 0.01 } }
#declare R_Edge = 0.03;
#declare R_Vertex = 0.06;
#declare Archimedean_skels = array[13];
#declare Archimedean_skels[0] = object { Archimedean_truncated_tetrahedron_edges(R_Edge, R_Vertex, EdgeT, VertT, yes) }
#declare Archimedean_skels[1] = object { Archimedean_cuboctahedron_edges(R_Edge, R_Vertex, EdgeT, VertT, yes) }
#declare Archimedean_skels[2] = object { Archimedean_truncated_cube_edges(R_Edge, R_Vertex, EdgeT, VertT, yes) }
#declare Archimedean_skels[3] = object { Archimedean_truncated_octahedron_edges(R_Edge, R_Vertex, EdgeT, VertT, yes) }
#declare Archimedean_skels[4] = object { Archimedean_rhombicuboctahedron_edges(R_Edge, R_Vertex, EdgeT, VertT, yes) }
#declare Archimedean_skels[5] = object { Archimedean_truncated_cuboctahedron_edges(R_Edge, R_Vertex, EdgeT, VertT, yes) }
#declare Archimedean_skels[6] = object { Archimedean_snub_cuboctahedron_edges(R_Edge, R_Vertex, EdgeT, VertT, yes) }
#declare Archimedean_skels[7] = object { Archimedean_icosidodecahedron_edges(R_Edge, R_Vertex, EdgeT, VertT, yes) }
#declare Archimedean_skels[8] = object { Archimedean_truncated_dodecahedron_edges(R_Edge, R_Vertex, EdgeT, VertT, yes) }
#declare Archimedean_skels[9] = object { Archimedean_truncated_icosahedron_edges(R_Edge, R_Vertex, EdgeT, VertT, yes) }
#declare Archimedean_skels[10] = object { Archimedean_rhombicosidodecahedron_edges(R_Edge, R_Vertex, EdgeT, VertT, yes) }
#declare Archimedean_skels[11] = object { Archimedean_truncated_icosidodecahedron_edges(R_Edge, R_Vertex, EdgeT, VertT, yes) }
#declare Archimedean_skels[12] = object { Archimedean_snub_icosidodecahedron_edges(R_Edge, R_Vertex, EdgeT, VertT, yes) }

// -----
// Loop through arrays and place the polyhedra (faces+edges) in a circular pattern.
// -----
// Please note that the faces need to be vertically translated by R_Vertex so they line up
// with the edges.
// -----
#declare Ang = 0;
#declare Num = 0;
#while (Num < 13)
 object { Archimedeans[Num] translate <0, 0.06, -5> rotate y*Ang pigment { rgb 1 } finish { ambient 0 } }
 object { Archimedean_skels[Num] translate <0, 0, -5> rotate y*Ang }
 #declare Num = Num +  1;
 #declare Ang = Ang + 360/13;
#end

plane { y, 0 pigment { rgb 0.66 } finish { ambient 0 } }
background { rgb <0.1, 0.2, 0.25> }
</textarea>



<!-- Sample file : tree.pov -->

<textarea id="tree.pov" name="tree.pov" style="display:none;">
//=========================================
// Leaf & Tree examples for the MakeTree macro
//==========================================  
// Copyright 1999-2004 Gilles Tran http://www.oyonale.com
// -----------------------------------------
// This work is licensed under the Creative Commons Attribution License. 
// To view a copy of this license, visit http://creativecommons.org/licenses/by/2.0/ 
// or send a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.
// You are free:
// - to copy, distribute, display, and perform the work
// - to make derivative works
// - to make commercial use of the work
// Under the following conditions:
// - Attribution. You must give the original author credit.
// - For any reuse or distribution, you must make clear to others the license terms of this work.
// - Any of these conditions can be waived if you get permission from the copyright holder.
// Your fair use and other rights are in no way affected by the above. 
//==========================================  
// Classic tree example
//-----------------------------------------
// This file calls the MakeTree and MakeLeaf macros
// and defines the textures and parameters
// Set the [dofile] parameter to "true"
// when you want to create the final file
//-----------------------------------------
#include "colors.inc"

//=========================================
// Leaf & Tree examples for the MakeTree macro
//==========================================  
// Copyright 1999-2004 Gilles Tran http://www.oyonale.com
// -----------------------------------------
// This work is licensed under the Creative Commons Attribution License. 
// To view a copy of this license, visit http://creativecommons.org/licenses/by/2.0/ 
// or send a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.
// You are free:
// - to copy, distribute, display, and perform the work
// - to make derivative works
// - to make commercial use of the work
// Under the following conditions:
// - Attribution. You must give the original author credit.
// - For any reuse or distribution, you must make clear to others the license terms of this work.
// - Any of these conditions can be waived if you get permission from the copyright holder.
// Your fair use and other rights are in no way affected by the above. 
//==========================================  
// Curved tree with long branches
// The curvature is obtained through the vpush vector <1,-0.8,0>
#include "colors.inc"
//=========================================
// Some tree textures
//=========================================
// simple tree texture for tests
//-----------------------------------------
#declare txtTree_0=texture{pigment{Tan}}
//-----------------------------------------
// tree texture with a image_map
//-----------------------------------------
//#declare txtTree_1=texture{pigment{image_map{png "treepig.png"  map_type 2  interpolate 2 }}}
//-----------------------------------------
// crackle tree textures
//-----------------------------------------
#declare colBark=rgb <1,0.6,0.31>; // nice brown
#declare txtTree_2=texture{pigment{crackle turbulence 0.4 lambda 3.2 color_map{[0 color colBark*.3][0.1 color colBark*.4][0.6 color colBark*.8] [1 color colBark*1.2]}}       
finish{ambient 0.1} scale <0.2,0.7,0.2>*1}                 
//-----------------------------------------
#declare colBark=rgb <1,0.8,0.51>*0.8; // dirty brown
#declare txtTree_3=texture{pigment{crackle turbulence 0.4 lambda 3.2 color_map{[0 color colBark*.3][0.1 color colBark*.4][0.6 color colBark*.8] [1 color colBark*1.2]}}       
finish{ambient 0.1} scale <0.2,0.7,0.2>*1}                 
//-----------------------------------------
#declare colBark=rgb <1,0.8,0.51>*2; // light brown
#declare txtTree_4=texture{pigment{crackle turbulence 0.4 lambda 3.2 color_map{[0 color colBark*.3][0.1 color colBark*.4][0.6 color colBark*.8] [1 color colBark*1.2]}}       
finish{ambient 0.1} scale <0.2,0.7,0.2>*1}                 

//-----------------------------------------
// birch-like tree texture
//-----------------------------------------
#declare colBark=rgb <1,0.8,0.64>; // light brown, white
#declare txtTree_5=texture{pigment{gradient y turbulence 0.7 lambda 4 color_map{[0 color colBark*.3] [0.1 color colBark][0.9 color colBark][1 color colBark*.4]}} finish{ambient 0.1}}
texture{pigment{bozo turbulence 0.7 lambda 4 color_map{[0 color colBark*.2][0.1 color colBark*.3] [0.3 color colBark*.4][0.4 color Clear][0.9 color Clear][1 color colBark*.4] }}finish{ambient 0.1}}                 

//-----------------------------------------
// spiral tree texture
//-----------------------------------------
#declare colBark=rgb <1,0.6,0.2>;
#declare txtTree_6=texture{pigment{spiral1 8 turbulence 0.5 lambda 4 color_map{[0 color colBark*.3] [0.3 color colBark*0.5][0.9 color colBark][1 color colBark*.4] }} finish{ambient 0.1} scale <1,3,1>}                
texture{pigment{bozo turbulence 0.7 lambda 3 color_map{[0 color Clear][0.1 color colBark*.1] [0.4 color Clear][0.9 color Clear][1 color colBark*.4] }} finish{ambient 0.1}}                 

//=========================================
// Leaf color and textures
//-----------------------------------------
// Simple leaf textures
//-----------------------------------------
#declare colLeaf=rgb <0.4,1,0.3>*0.4; // nice green
#declare txtLeaf_0=texture{pigment{colLeaf} finish{ambient 0.1 specular 0.3 roughness 0.01}}
//-----------------------------------------
#declare colLeaf=rgb <0.6,1,0.3>*0.8; // yellow clear green
#declare txtLeaf_1=texture{pigment{colLeaf} finish{ambient 0.1 specular 0.3 roughness 0.01}}
//-----------------------------------------
#declare colLeaf=rgb <0.65,1,0.3>*0.3; // olive green
#declare txtLeaf_3=texture{pigment{colLeaf} finish{ambient 0.1 specular 0.3 roughness 0.01}}
//-----------------------------------------
// Automn leaf (bad...)
//-----------------------------------------
#declare colLeaf_1=rgb <0.4,1,0.3>*0.4; // green
#declare colLeaf_2=rgb <1,0.8,0.3>*0.8; // yellow
#declare colLeaf_3=rgb <1,0.2,0.1>*0.8; // red
#declare txtLeaf_4=texture{
pigment{bozo turbulence 0.5        
        color_map{[0.0 color colLeaf_1][0.3 color colLeaf_2] [0.5 color colLeaf_3][0.7 color colLeaf_2][1.0 color colLeaf_1] }}       
        finish{ambient 0.1 specular 0.3 roughness 0.01}}                 
//-----------------------------------------
// Yellow and greenish (need scaling)
//-----------------------------------------
#declare colLeaf_1=rgb <0.7,1,0.2>*0.8; // greenish 
#declare colLeaf_2=rgb <1,0.7,0.2>*0.8; // yellow
#declare txtLeaf_5=texture{pigment{agate color_map{[0.0 color colLeaf_1][0.3 color colLeaf_2] [0.7 color colLeaf_2][1.0 color colLeaf_1] }}       
        finish{ambient 0.1 specular 0.3 roughness 0.01} scale 10}                 


//=========================================
// MakeTree 1.0c
//=========================================
// Leaf & Tree macro for Pov-ray 3.1 & higher
//==========================================  
// Copyright 1999-2004 Gilles Tran http://www.oyonale.com
// -----------------------------------------
// This work is licensed under the Creative Commons Attribution License. 
// To view a copy of this license, visit http://creativecommons.org/licenses/by/2.0/ 
// or send a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.
// You are free:
// - to copy, distribute, display, and perform the work
// - to make derivative works
// - to make commercial use of the work
// Under the following conditions:
// - Attribution. You must give the original author credit.
// - For any reuse or distribution, you must make clear to others the license terms of this work.
// - Any of these conditions can be waived if you get permission from the copyright holder.
// Your fair use and other rights are in no way affected by the above. 
//==========================================  
// This file contains 4 macros to build trees
// MakeTree : "wrapper" macro for the MakeBranch macro
// MakeBranch : recursive macro that creates a tree structure
// MakeRoot : recursive macro that creates a 2-level root branch
// MakeLeaf : creates different kinds of leaves
// and 2 vector utilities : vCone and mAlign
//-----------------------------------------
// Look at the end of this file for definition of parameters
// See extree*.pov files for examples of leaf & tree definitions 
// See the showtree.pov file for a template of how to use the include files generated by these macros
//-----------------------------------------
// The size of the leafless tree (lower and upper corner of the containing box)
// is displayed after parsing, and a line is added at the end of generated file (if dofile=true)
//-----------------------------------------
// Credits go to :
// Daniel Skarda for providing the first algorithm I used for tree recursivity
// Margus Ramst for ideas taken from his worm.inc & fur.inc macro
// Steve Pigeon for parameter ideas from his arbre.inc macro
// Ken Tyler for adding leaves in the previous version of this macro
// John VanSickle for his tutorials on vector calculations
//-----------------------------------------
// Release history
// 1.0c August 13, 2004
//      - replace "warning" by "debug" for POV 3.6 compatibility
//
// 1.0b April 10, 1999
//      - bug fixes (leaves with stalks weren't properly centered at <0,0,0> in the files)
//
// 1.0a April 1, 1999
//      - display of container size both on screen and at the end of the file
//
// 1.0  March 26, 1999
//      - initial release

//=========================================
// macro MakeBranch
//-----------------------------------------
// This is the main tree macro.
// This macro can create trees that look realistic but no particular tree species.
// It cannot create cone-like trees such as pine trees.
// Beware that large recursion levels (>6) can lead to large parsing times.

// Basically, the MakeBranch creates a branch at position [pos], in the direction [vb].
// The branch is made of segments. 
// [nb] other branches grow on this branch and then the macro calls itself.
// It goes on until a certain level of recursivity [level0] is attained.

// - Leaves are turned on by setting the [leafproba] parameter > 0->1
// - Roots are turned on by setting the [rootproba] parameter > 0->1
// - Trunk twigs are turned on by setting the [twigproba] parameter > 0->1
// - Gravity, antigravity or wind are turned on by the [vpush] vector.
// - Gnarledness is turned on by setting the [fgnarl] value > 0
// - The [dotexture] flag (true/false) applies the txtTree texture to the
//   branch and root segments according to their position

// Look at the end of this file or in the extree*.pov files for other parameter definitions.

//-----------------------------------------
// Note on creation of include files
//-----------------------------------------
// Trees can take long to parse so once you created one you like
// you may want to save it as an include file for later use.
// For this, set the [dofile] parameter to true
// and give names to the tree file, the foliage file and the leaf file
// See the end of this file or the extree*.pov files for examples

//-----------------------------------------
// Note on texturing
//-----------------------------------------
// You will need to define two textures, one for the leaf (txtLeaf) and one for the tree bark (txtTree)
// How the texture is applied depends on the choice of the [dotexture] parameter during the tree generation
// If dotexture=true, then the tree include file contains already the call for the texture
//                    and the texture is positionned according to its position in the tree. This allows for
//                    more realistic texturing but can be expensive memorywise.
// If dotexture=false then you need to apply it here.
// The leaf texture is applied on the whole foliage (though you can add it manually in the leaf include file
// if you want to have leaves individually textured).
//-----------------------------------------

#macro MakeBranch(level,pos,vb,dotop) 
#if (level>level0-3) #debug concat("level ",str(level,0,0),"\n") #end
#if (level>0)     
//-----------------------------------------
// The branch is made up of segments
// First we create the branch segments
//-----------------------------------------
#local nseg=max(1,nseg0-level0+level);  // number of branch segments
#local lbseg=lb[level]/nseg; // length of branch segment
#local posb=array[nseg+1] // consecutive branch positions
#local posb[0]=pos; // start of the branch

#local i=0;

#local ay= 360*(0.5-rand(rd));
#while (i<nseg)
        //-----------------------------------------
        // Segment calculation and positionning
        //-----------------------------------------
        #local rbseg1=rb[level]+(rb[level-1]-rb[level])*i/nseg; // start radius of segment
        #local rbseg2=rb[level]+(rb[level-1]-rb[level])*(i+1)/nseg;// end radius of segment
        // calculates the force (wind, gravity) to apply to the segment
        // the force is stronger at the end of the branch
        #if (vlength(vpush)=0) #local vp=vpush; #else #local vp=vnormalize(vpush)*i/nseg; #end

        // then we add the gnarledness
        #local vg=<0.5-rand(rd),0.5-rand(rd),0.5-rand(rd)>;
        #if (vlength(vg)>0) #local vg=vnormalize(vg); #end

        // now we calculate the position ; vb is the original direction of the segment
         #local posb[i+1]=posb[i]+lbseg*vnormalize(vb+vp*fpush+vg*fgnarl)*(1+(0.5-rand(rd))*stdlseg);
        // segments must be kept over the ground
        #if (posb[i+1].y<aboveground) 
                #local posb[i+1]=<posb[i+1].x,aboveground+rand(rd)*i/nseg,posb[i+1].z>; 
        #end
        // segments must be kept under the sky !

        #if (posb[i+1].y>belowsky) 
                #local posb[i+1]=<posb[i+1].x,belowsky-rand(rd)*i/nseg,posb[i+1].z>; 
        #end

        //-----------------------------------------
        // a cone and a sphere : this is where the tree is created
        //-----------------------------------------
        //#debug concat("x",str(posb[i+1].x,0,3)," y ",str(posb[i+1].y,0,3)," z ",str(posb[i+1].z,0,3),">\n")
        #if(dofile = true)
                #if (dotexture = true) // texture is applied to the branch segment

                        #write(filehandle,"union{cone{",posb[i],",",rbseg1,",",posb[i+1],",",rbseg2,"}\n")
                        #write(filehandle,"sphere{",posb[i],",",rbseg1,"}\n")
                        #write(filehandle,"texture{txtTree ")
                        mAlign(posb[i],posb[i+1],true)
                        #write(filehandle,"}}\n")
                #else
                        #write(filehandle,"cone{",posb[i],",",rbseg1,",",posb[i+1],",",rbseg2,"}\n")
                        #write(filehandle,"sphere{",posb[i],",",rbseg1,"}\n")
                
                #end
        #end                                                
                union{
                        cone{posb[i],rbseg1,posb[i+1],rbseg2}
                        sphere{posb[i],rbseg1}
                        #if (dotexture= true)
                                texture{txtTree mAlign(posb[i],posb[i+1],false)}
                        #end
                }   
        //-----------------------------------------
        // Leaf calculation and positionning
        // This could be improved a lot (for now the leaves just hang from the branch)
        //-----------------------------------------
        #if (rand(rdl)<=leafproba & level<=leaflevel)
                #local alz=alz0*(0.5-rand(rdl));
                #local alx=alx0+stdalx*(0.5-rand(rdl));
                #local P1=posb[i];
                #local P2=posb[i+1];
                #local aly=degrees(atan2(P2.x-P1.x,P2.z-P1.z+0.0001))-180;

                #if (dofile = true)
                        #write(filehandle2,"object{Leaf scale ",(1+stdlsize*rand(rdl))," rotate z*",alz," rotate x*",alx," rotate y*",aly, " translate <",P2.x,",",P2.y,",",P2.z,">}\n")
                #end                                                                 
                object{Leaf scale (1+stdlsize*rand(rdl)) rotate z*alz rotate x*alx rotate y*aly translate P2}
        
        #end
        #if (posb[i+1].x>xMax) #declare xMax=posb[i+1].x; #end
        #if (posb[i+1].y>yMax) #declare yMax=posb[i+1].y; #end
        #if (posb[i+1].z>zMax) #declare zMax=posb[i+1].z; #end
        #if (posb[i+1].x<xMin) #declare xMin=posb[i+1].x; #end
        #if (posb[i+1].y<yMin) #declare yMin=posb[i+1].y; #end
        #if (posb[i+1].z<zMin) #declare zMin=posb[i+1].z; #end
        #local i=i+1;

#end            
//-----------------------------------------
// All segments are now created for the branch
//-----------------------------------------
// Then we create the new branches
//-----------------------------------------
// One branch must continue the present one (otherwise we would get a stump)
//-----------------------------------------
#local new_level=level-1;                  
#local ax=ab[level]+ stdax*(0.5-rand(rd));
#local ay=stday*(0.5-rand(rd));
#local new_vb=vCone(posb[nseg-1],posb[nseg],ax,ay)
MakeBranch(new_level,posb[nseg],new_vb,false)
//-----------------------------------------
// The nb-1 other branches grow on the present branch
//-----------------------------------------
#local j=1;      
#while (j<nb)
        #if (rand(rd)<=branchproba)
//                #local i=int(jb*nseg)+j*(nseg-int(jb*nseg))/nb; // spiraling branches effect
                #local i=int(jb*nseg)+rand(rd)*(nseg-int(jb*nseg));
                #local ay=j*360/nb + stday*(0.5-rand(rd));
                #local ax=ab[level]+ stdax*(0.5-rand(rd));
                #local new_vb=vCone(posb[i],posb[i+1],ax,ay)
                #local new_pos=posb[i]+(posb[i+1]-posb[i])*rand(rd);
                MakeBranch(new_level,new_pos,new_vb,false)
        #end
        #local j=j+1;
#end

//-----------------------------------------
// Sometimes it's better to add a vertical branch on the trunk (dotop=true)
//-----------------------------------------
#if (dotop=true & level=level0)
        #local ax=stdax*(0.5-rand(rd));
        #local ay=stday*(0.5-rand(rd));
        #local new_vb=vCone(posb[nseg-1],posb[nseg],ax,ay)
        MakeBranch(new_level,posb[nseg],new_vb,true)
#end
//-----------------------------------------
// Do you want some twigs on the trunk ?
//-----------------------------------------
#if (twigproba>0 & level=level0)
        #local i=0;
        #while (i<nseg)
                #if (rand(rd)<=twigproba)
                        #local ay=360*(0.5-rand(rd));
                        #local ax=ab[level]+ stdax*(0.5-rand(rd));
                        #local new_vb=vCone(posb[i],posb[i+1],ax,ay)   
                        #local new_pos=posb[i]+(posb[i+1]-posb[i])*rand(rd);
                        MakeBranch(1,new_pos,new_vb,false)
                                
                #end
                #local i=i+1;
        #end

#end
//-----------------------------------------
// Roots anyone ?
//-----------------------------------------
#if (rootproba>0 & level=level0)                         
        #local new_vb=vroot;
        #local new_pos=yroot;
        #local i=0;
        #while (i<nroot)
                #if (rand(rd)<=rootproba)
                        #local ay=((i*360/nroot)+stday*(0.5-rand(rd)));
                        #if (dofile=true)
                                #write(filehandle,"union{\n")
                        #end
                        union{MakeRoot(new_level,new_pos,new_vb) rotate ay*y}
                        #if (dofile=true)
                                #write(filehandle,"rotate y*",ay,"}\n")
                        #end
                #end
                #local i=i+1;
        #end
#end                        

//-----------------------------------------
#end
#end
//-----------------------------------------
// end of macro MakeBranch
//=========================================

//=========================================
// macro MakeRoot
//-----------------------------------------
// Creates a two-level root
// It has the size of a level0-1 branch
// and starts at yroot, in the vroot direction
// Each root branch is rotated in the MakeBranch macro
//-----------------------------------------
#macro MakeRoot(level,pos,vb) 
//-----------------------------------------
// The root is made up of segments
// First we create the root segments
//-----------------------------------------
#if (level>level0-2)
#debug concat("root level ",str(level,0,0),"\n")
#local nseg=max(1,nseg0-level0+level);  // number of branch root segments
#local lbseg=lb[level]/nseg; // length of branch root segment
#local posb=array[nseg+1] // consecutive branch root positions
#local posb[0]=pos; // start of the root

#local i=0;

#local ay= 360*(0.5-rand(rd));                                               
#while (i<nseg)
//        #debug concat("i ",str(i,0,0),"\n")
        //-----------------------------------------
        // Segment calculation and positionning
        //-----------------------------------------
        #local rbseg1=rb[level]*(1-i/nseg); // start radius of segment
        #local rbseg2=rb[level]*(1-(i+1)/nseg); // start radius of segment
        // calculates the gravity to apply to the segment
        // the force is stronger at the end of the root
        #local vp=-y*i/nseg; #if (vlength(vp)>0) #local vp=vnormalize(vp); #end

        // then we add the gnarledness
        #local vg=<(0.5-rand(rd))*2,0.5-rand(rd),2*(0.5-rand(rd))>;
        #if (vlength(vg)>0) #local vg=vnormalize(vg); #end

        // now we calculate the position ; vb is the original direction of the segment
        #local posb[i+1]=posb[i]+lbseg*vnormalize(vb+vp*0.2+vg*fgnarl)*(1+(0.5-rand(rd))*stdlseg);
        #if (posb[i+1].y>0 & (i/nseg)>=0.3) #local posb[i+1]=<posb[i+1].x,0,posb[i+1].z>; #end
//        #debug concat("i=",str(i,0,0)," x=",str(posb[i+1].x,0,3)," y=",str(posb[i+1].y,0,3)," z=",str(posb[i+1].z,0,3),"\n")

        //-----------------------------------------
        // a cone and a sphere : this is where the root is created
        //-----------------------------------------

//        #debug concat("rbseg1 ",str(vlength(posb[i]),0,3)," rbseg2 ",str(vlength(posb[i]),0,3),"\n")
        #if (dofile = true)
                #if (dotexture = true) // texture is applied to the root segment
                        #write(filehandle,"union{cone{",posb[i],",",rbseg1,",",posb[i+1],",",rbseg2,"}\n")
                        #write(filehandle,"sphere{",posb[i],",",rbseg1,"}\n")
                        #write(filehandle,"texture{txtTree ")
                        mAlign(posb[i],posb[i+1],true)
                        #write(filehandle,"}}\n")
                #else                   // no texture applied (faster parsing)
                        #write(filehandle,"cone{",posb[i],",",rbseg1,",",posb[i+1],",",rbseg2,"}\n")
                        #write(filehandle,"sphere{",posb[i],",",rbseg1,"}\n")
              
                #end
        #end
        union{
                cone{posb[i],rbseg1,posb[i+1],rbseg2}
                sphere{posb[i],rbseg1}
                #if (dotexture = true)
                        texture{txtTree mAlign(posb[i],posb[i+1],false)}
                #end
                }
        #if (posb[i+1].x>xMax) #declare xMax=posb[i+1].x; #end
        #if (posb[i+1].y>yMax) #declare yMax=posb[i+1].y; #end
        #if (posb[i+1].z>zMax) #declare zMax=posb[i+1].z; #end
        #if (posb[i+1].x<xMin) #declare xMin=posb[i+1].x; #end
        #if (posb[i+1].y<yMin) #declare yMin=posb[i+1].y; #end
        #if (posb[i+1].z<zMin) #declare zMin=posb[i+1].z; #end


        #local i=i+1;

#end    


//-----------------------------------------
// All segments are now created for the root branch
//-----------------------------------------
// The [nb] other roots grow on the present root branch
//-----------------------------------------
#local j=0;      
#local new_level=level-1;
#while (j<nb)
        #if (rand(rd)<=branchproba)
                #local i=int(jb*nseg)+j*(nseg-int(jb*nseg))/nb;
                #local ay=360*(0.5-rand(rd));
                #local ax=ab[level]+ stdax*(0.5-rand(rd));
                #local new_vb=vCone(posb[i],posb[i+1],ax,ay)
                #if (new_vb.y>0) #local new_vb=<new_vb.x,-rand(rd)*new_vb.y,new_vb.z>;#end
                #local new_pos=posb[i]+(posb[i+1]-posb[i])*rand(rd);
                MakeRoot(new_level,new_pos,new_vb)
        #end
        #local j=j+1;

#end

#end        
#end
//-----------------------------------------
// end of macro MakeRoot
//=========================================

//=========================================
// macro MakeTree
//-----------------------------------------
// Only a wrapper for the MakeBranch macro
//-----------------------------------------
#macro MakeTree()
// First initialize the container dimension
#declare xMax=pos0.x;
#declare yMax=pos0.y;
#declare zMax=pos0.z;
#declare xMin=pos0.x;
#declare yMin=pos0.y;
#declare zMin=pos0.z;

// Fill the size and angle values for each recursion level
FillTreeArrays(level0,lb0,qlb,rb0,qrb,ab0,qab)
       #if(dofile=true)
            #debug concat(ftname," tree file creation start\n")
            #fopen filehandle ftname write      // creates the tree file (contains the branches)
            #write(filehandle,"union{\n")
            #if (leafproba>0)
                #debug concat(fvname," foliage file creation starts\n")
                #fopen filehandle2 fvname write    // creates the foliage file (contains the leaf meshes)
                #write(filehandle2,"union{\n")
            #end
       #end

// Create the tree
       union{MakeBranch(level0,pos0,v0,dotop)}
       
       #if(dofile = true)
            #if (leafproba>0)
                #write (filehandle2,"}\n")          // close the foliage file
                #fclose filehandle2
                #debug concat(fvname," foliage file created\n")
            #end
            #write (filehandle,"}\n")           // closes the tree file
            #write (filehandle,"// Tree in box{<",xMin,",",yMin,",",zMin,">,<",xMax,",",yMax,",",zMax,"> pigment{Green}}\n")
            #fclose filehandle
            #debug concat(ftname," tree file created\n")
       #end
       #debug concat("Tree goes from <",str(xMin,0,3),",",str(yMin,0,3),",",str(zMin,0,3),"> to <",str(xMax,0,3),",",str(yMax,0,3),",",str(zMax,0,3),">\n")

#end
//-----------------------------------------
// end of MakeTree macro
//=========================================

//=========================================
// macro FillTreeArrays
//-----------------------------------------
// This utility macro fills the branch length, radius and angle arrays
// for each recursion level
//-----------------------------------------
#macro FillTreeArrays(level,lb0,qlb,rb0,qrb,ab0,qab)
#declare lb=array[level+1]
#declare rb=array[level+1]
#declare ab=array[level+1]
#local i=level;
#declare lb[i]=lb0;
#declare rb[i]=rb0;
#declare ab[i]=ab0;
#debug concat("level=",str(i,0,0)," lb=",str(lb[i],0,3)," rb=",str(rb[i],0,3),"\n")
#local i=level-1;  
#while (i>=0)
        #declare lb[i]=lb[i+1]*qlb;
        #declare rb[i]=rb[i+1]*qrb;
        #declare ab[i]=ab[i+1]*qab;
#debug concat("level=",str(i,0,0)," lb=",str(lb[i],0,3)," rb=",str(rb[i],0,3),"\n")
        
#local i=i-1;
#end
#end                        
//-----------------------------------------
// end of macro FillTreeArrays
//=========================================

//=========================================
// macro MakeLeaf
//-----------------------------------------
// Creates a mesh of a curved leaf in the -z direction and that bends downward
// The leaf has a stalk in the z direction and is folded in two
// The leaf is not smoothed
// Note 1 : the final leaf is positionned at <0,0,0>
// Note 2 : in fact the leaf is built in the z direction and rotated y*180 later
//-----------------------------------------
/*
#declare lsize=0.3;  // leaf size
#declare seg=20;     // nb of leaf segments and stalk segments : increase to smooth
#declare ll=5;       // leaf length
#declare wl=0.6;     // leaf width 
#declare fl=0.2;     // depth of leaf fold
#declare lpow=1;     // modifies the leaf shape : lpow=3 makes heart-shaped leaf
#declare al=100;     // leaf bending angle : the leaf bends forward until this angle
#declare apow=1;     // curve power, how slow the leaf bends
#declare ndents=0;   // dents in the leaf (8 = "oak" leaf). May require a high seg >20
#declare nlobes=5;   // number of lobes (individual leaves)
#declare alobes=160; // angle made by all the lobes
#declare qlobes=0.9; // size of the farest lobe (0.9 = size will be 0.9*leaf length)                               
#declare ls=5;       // stalk length (0=no stalk)
#declare ws=0.2;     // width of stalk
#declare as=30;      // stalk bending angle : the leaf bends backward
#declare dofile=false;          // true creates a file ; false otherwise
#declare ffname="gtleaf.inc";   // file name
*/
//-----------------------------------------
// Leaf examples
//-----------------------------------------
// 5-lobes leaf
// #declare Leaf=object{MakeLeaf(0.3,10,5,0.6,0.2,1,100,1,0,5,160,0.9,3,0.12,10,dofile,ffname)}
// Wide, heart-shaped leaf
// #declare Leaf=object{MakeLeaf(0.3,10,5,2,0.4,3,100,1,0,1,0,0,3,0.12,10,dofile,ffname)} 
// "Oak", dented leaf (ndents=8)
// #declare Leaf=object{MakeLeaf(0.3,40,5,1,0.1,1,100,1,8,1,0,0,3,0.12,10,dofile,ffname)}
// Trilobed, narrow, very dented leaf (ndents=20)
//#declare Leaf=object{MakeLeaf(0.3,40,5,0.3,0.1,1,100,1,20,3,140,0.6,3,0.12,10,dofile,ffname)} 
// Wide, star-shaped, leaf
//#declare Leaf=object{MakeLeaf(0.3,10,4,1,0.4,1,100,0.5,1,5,200,0.5,3,0.12,10,dofile,ffname)} 
// Narrow, long, leaf, very pointy (lpow=3)
//#declare Leaf=object{MakeLeaf(0.3,60,15,1,0.3,3,140,1,0,1,0,0,3,0.12,10,dofile,ffname)}
// Narrow, long, leaf, straight borders (lpow=0.3)
//#declare Leaf=object{MakeLeaf(0.3,60,15,1,0.3,0.3,100,1,0,1,0,0,3,0.12,10,dofile,ffname)}
// Twin short leaf
//#declare Leaf=object{MakeLeaf(0.3,40,5,0.7,0.5,1,100,1,0,2,80,0.6,3,0.1,10,dofile,ffname)} 
// 7 lobes leaf (conic when seen from the side)
//#declare Leaf=object{MakeLeaf(0.3,40,5,1,0.5,2,100,1,0,7,280,0.8,3,0.1,10,dofile,ffname)} 
// 7 lobes leaf (flat when seen from the side)
//#declare Leaf=object{MakeLeaf(0.3,40,5,1,0.5,2,100,1,0,7,280,0.8,10,0.1,-40,dofile,ffname)} 
//-----------------------------------------
#macro MakeLeaf(lsize,seg,ll,wl,fl,lpow,al,apow,ndents,nlobes,alobes,qlobes,ls,ws,as,dofile,ffname)
#debug "create leaf\n"
#if(dofile=true)          
        #debug concat(ffname," individual leaf file creation starts\n")

        #fopen filehandle ffname write  // creates the leaf mesh (individual leaf)
        #write(filehandle,"mesh{\n")
#end
mesh{
//-----------------------------------------
// leaf
//-----------------------------------------
// leaf points
//-----------------------------------------
#local lseg=ll/seg;  // length of leaf segment
#local nI=3; #local nJ=seg+1;
#local nP=nI*nJ; #local P=array[nP] // array of leaf points
#local pl=<0,0,0>;   // start of leaf
#local j=0; 
#while (j<nJ)          
        #local tl=j/seg;
        #if (j>0) #local pl=pl+lseg*vaxis_rotate(z,x,pow(tl,apow)*al);#end
        
                #local P[j*nI]=pl-x*wl*(pow(sin(tl*pi),lpow)*(2+(pow(sin(tl*pi*ndents),2))))/3;
                #local P[j*nI+1]=pl-y*fl*sin(tl*pi);
                #local P[j*nI+2]=pl+x*wl*(pow(sin(tl*pi),lpow)*(2+(pow(sin(tl*pi*ndents),2))))/3;
        #local j=j+1;        
#end   

//-----------------------------------------
// leaf triangles
//-----------------------------------------
#local q=0;
#while (q<(nI*(nJ-1)-1))
#local i=mod(q,nI);#local j=(q-i)/nI;
#if (i <nI-1)        
        #if (nlobes>1)
        
                #local j=0;
                #local a=-alobes/2;
                #while (j<nlobes)    
                        #local sc=qlobes+(1-qlobes)*sin(j*pi/(nlobes-1));
                        triangle{vaxis_rotate(P[q]*sc,z,a),vaxis_rotate(P[q+1]*sc,z,a),vaxis_rotate(P[q+nI+1]*sc,z,a)}
                        triangle{vaxis_rotate(P[q]*sc,z,a),vaxis_rotate(P[q+nI]*sc,z,a),vaxis_rotate(P[q+nI+1]*sc,z,a)}
                        #if (dofile=true)
                                #local tt1=vaxis_rotate(P[q]*sc,z,a);
                                #local tt2=vaxis_rotate(P[q+1]*sc,z,a);
                                #local tt3=vaxis_rotate(P[q+nI+1]*sc,z,a);
                                #local tt4=vaxis_rotate(P[q+nI]*sc,z,a);
                                #write(filehandle,"triangle{<",tt1.x,",",tt1.y,",",tt1.z,">,<",tt2.x,",",tt2.y,",",tt2.z,">,<",tt3.x,",",tt3.y,",",tt3.z,">}\n")
                                #write(filehandle,"triangle{<",tt1.x,",",tt1.y,",",tt1.z,">,<",tt4.x,",",tt4.y,",",tt4.z,">,<",tt3.x,",",tt3.y,",",tt3.z,">}\n")
                        #end
                        #local j=j+1;
                        #local a=a+alobes/(nlobes-1);
                #end
         #else

                triangle{P[q],P[q+1],P[q+nI+1]} triangle{P[q],P[q+nI],P[q+nI+1]}
                #if (dofile=true)
                        #write(filehandle,"triangle{<",P[q].x,",",P[q].y,",",P[q].z,">,<",P[q+1].x,",",P[q+1].y,",",P[q+1].z,">,<",P[q+nI+1].x,",",P[q+nI+1].y,",",P[q+nI+1].z,">}\n")
                        #write(filehandle,"triangle{<",P[q].x,",",P[q].y,",",P[q].z,">,<",P[q+nI].x,",",P[q+nI].y,",",P[q+nI].z,">,<",P[q+nI+1].x,",",P[q+nI+1].y,",",P[q+nI+1].z,">}\n")
                #end

         #end
         
#end
#local q=q+1;
#end        

//-----------------------------------------
// stalk
//-----------------------------------------
#if (ls>0) // only if a stalk length is >0
//-----------------------------------------
// stalk points
//-----------------------------------------
#local lseg=ls/seg;

        #local nI=2; #local nJ=seg+1;
        #local nP=nI*nJ; #local P=array[nP]
        #local pl=<0,0,0>; 
        #local j=0; 
        #while (j<nJ)          
                #local tl=j/seg;
                #if (j>0) #local pl=pl+lseg*vaxis_rotate(-z,x,-pow(tl,apow)*as);#end
                #local P[j*nI]=pl-x*ws;
                #local P[j*nI+1]=pl+x*ws;
                #local j=j+1;        
        #end   

//-----------------------------------------
// stalk triangles
//-----------------------------------------
#local q=0;
#while (q<(nI*(nJ-1)-1))
#local i=mod(q,nI);#local j=(q-i)/nI;
        #if (i <nI-1) 
                triangle{P[q],P[q+1],P[q+nI+1]} triangle{P[q],P[q+nI],P[q+nI+1]} 
                #if (dofile=true)
                        #write(filehandle,"triangle{<",P[q].x,",",P[q].y,",",P[q].z,">,<",P[q+1].x,",",P[q+1].y,",",P[q+1].z,">,<",P[q+nI+1].x,",",P[q+nI+1].y,",",P[q+nI+1].z,">}\n")
                        #write(filehandle,"triangle{<",P[q].x,",",P[q].y,",",P[q].z,">,<",P[q+nI].x,",",P[q+nI].y,",",P[q+nI].z,">,<",P[q+nI+1].x,",",P[q+nI+1].y,",",P[q+nI+1].z,">}\n")
                #end
                
        #end
#local q=q+1;
#end        
translate <0,-P[nP-1].y,-P[nP-1].z> // centers the leaf at origin
#if (dofile=true)
        #write (filehandle,"translate <0,",-P[nP-1].y,",",-P[nP-1].z,">\n")
#end
#end
//-----------------------------------------
// end of stalk
//-----------------------------------------
scale lsize  // resizes the mesh
rotate y*180 // required so that the leaf points at -z

#if(dofile = true)
        #write (filehandle,"scale ",lsize," rotate y*180}\n")
        #fclose filehandle
        #debug concat(ffname," individual leaf file created\n")

#end
}
#debug "end of leaf creation\n"
#end
//-----------------------------------------
// end of MakeLeaf macro
//=========================================


//=======================================
// macro vCone
//-----------------------------------------
// returns a normalized vector rotated on x (ax) and y (ay)
// along the P2-P1 vector
#macro vCone(P1,P2,ax,ay)
#local p = vaxis_rotate(vaxis_rotate(y,x,ax),y,ay);
#local yV1=vnormalize(P2-P1);
#local xV1=vnormalize(vcross(yV1,z));
#local zV1=vcross(xV1,yV1);
#local answer=vnormalize(<p.x*xV1.x + p.y*yV1.x + p.z*zV1.x,p.x*xV1.y + p.y*yV1.y + p.z*zV1.y,p.x*xV1.z + p.y*yV1.z + p.z*zV1.z>);
answer;
#end   
//-----------------------------------------
// end of vCone macro
//=========================================


//=========================================
// macro mAlign
//-----------------------------------------
// returns a matrix operation that aligns an object or texture along P2-P1
// the object is translated to P1
// translate to P2-P1 if you want the object to be on P2
#macro mAlign(P1,P2,dofile)
#local yV1=vnormalize(P2-P1);
#local xV1=vnormalize(vcross(yV1,z));
#local zV1=vcross(xV1,yV1);
        #if(dofile = true)
                #write(filehandle,"matrix <",xV1.x,",",xV1.y,",",xV1.z,",",yV1.x,",",yV1.y,",",yV1.z,",",zV1.x,",",zV1.y,",",zV1.z,",",P1.x,",",P1.y,",",P1.z,"> ")
        #else
                matrix <xV1.x,xV1.y,xV1.z,yV1.x,yV1.y,yV1.z,zV1.x,zV1.y,zV1.z,P1.x,P1.y,P1.z>

        #end
#end   
//-----------------------------------------
// end of mAlign macro
//=========================================

/*
//=========================================
// Tree macro Parameters
//-----------------------------------------
// These parameters must be declared before calling the tree macro
//-----------------------------------------
#declare dofile=false;    // true creates a tree file ; false otherwise
#declare dotexture=true;  // true creates a textured tree (with the texture following the branch); false otherwise
#declare ftname="gttree4.inc" // file name for tree
#declare fvname="gtleaves4.inc" // file name for tree foliage
#declare ffname="gtleaf4.inc" // file name for individual leaf (mesh)
#declare txtTree=texture{txtTree3} // Bark texture

//-----------------------------------------
// Random streams
// one stream for branches and another one for leaves
// so that the leafed tree has the same structure as the leafless one
//-----------------------------------------
#declare rsd=213;      // random seed
#declare rd=seed(rsd);  // random stream for branches
#declare rdl=seed(rsd); // separate random stream for leaves

//-----------------------------------------
// Tree structure parameters        
//-----------------------------------------
// test with low level0 and neseg0 
// High (>=6) recursion levels [level0] gives more complex trees
// High (>=6) segment numbers [nseg0] level gives smoother trees
//-----------------------------------------
#declare level0=4;      // recursion level
#declare nseg0=3;       // initial number of branch segments (decreases of one at each level)
#declare nb=3;          // max number of branches per level
#declare dotop=false;   // if true, generates an extra branch on top of trunk (sometimes necessary to give more verticality)

#declare lb0=20;        // initial branch length
#declare rb0=1;         // initial branch radius
#declare ab0=25;        // initial branch angle (x angle between the trunk and the first branch)
#declare qlb=0.7;       // branch length decrease ratio (1=constant length)
#declare qrb=0.6;       // branch radius decrease ratio (1=constant radius)
#declare qab=1;       // branch angle decrease ratio (1=constant angle)
#declare stdax=10;      // stdev of x angle (angle x = ax+(0.5-rand)*stdax)
#declare stday=10;      // stdev of y angle (angle y = ay+(0.5-rand)*stday)

#declare branchproba=0.9; // probability of branch apparition 
#declare jb=0.4;        // secondary branches start after this ratio of branch length

#declare fgnarl=0.3;    // gnarledness factor - keep it low <0.8
#declare stdlseg=0.5;     // stddev of branch segment length (0...1) (adds more randomness to branch length)

#declare twigproba=0; // probability to have a twig on a trunk segment

#declare v0=<0,1,0>;    // initial direction - change to give an initial orientation
#declare pos0=<0,0,0>;  // initial trunk position (no need to change this one)

//-----------------------------------------
// constraints parameters
//-----------------------------------------
#declare vpush=<0,-0.2,0>;// direction of push (wind, gravity...) <0,-1,0> = gravity ; <0,1,0> = antigravity
#declare fpush=0.7;       // force of push
#declare aboveground=4; // constrains the branches above this level 
#declare belowsky=1000;  // constrains the branches below this level 

//-----------------------------------------
// root parameters
//-----------------------------------------
#declare rootproba=1;   // probability of root 0=no root ; 1=all [nroot] roots
#declare nroot=5;      // number of main roots;
#declare vroot=<1,-0.4,0>; // initial direction of root 
#declare yroot=<0,0.5,0>;   // initial position of root above ground

//-----------------------------------------
// leaf position parameters
//-----------------------------------------
#declare leafproba=1;   // probability of leaf 0=no leaf ; 1=leaf on each segment
#declare leaflevel=4;   // level where the leaves start to appear
#declare alz0=100;       // max z angle for leaf
#declare alx0=-10;      // start x angle for leaf
#declare stdalx=20;     // stddev x angle for leaf
#declare stdlsize=0.1;  // stddev of leaf size 0=constant size; size = leafsize*(1+stdlsize*rand)

//-----------------------------------------
// leaf structure parameters
//-----------------------------------------
#declare txtLeaf=texture{txtLeaf1} // Leaf texture
#declare lsize=0.3;     // leaf size
#declare seg=10;        // nb of leaf segments and stalk segments : increase to smooth
#declare ll=5;          // leaf length
#declare wl=1;          // leaf width 
#declare fl=0.5;        // depth of leaf fold
#declare lpow=1;        // modifies the leaf shape : lpow=3 makes heart-shaped leaf
#declare al=100;        // leaf bending angle : the leaf bends backward until this angle
#declare apow=1;        // curve power, how slow the leaf bends
#declare ndents=0;      // dents in the leaf (8 = "oak" leaf). May require a high seg >20
#declare nlobes=1;      // number of lobes (individual leaves)
#declare alobes=0;    // angle made by all the lobes
#declare qlobes=1;    // size of the farest lobe (0.9 = size will be 0.9*leaf length)                               
#declare ls=3;          // stalk length (0=no stalk)
#declare ws=0.1;        // width of stalk
#declare as=10;         // stalk bending angle : the stalk bends forward
//-----------------------------------------
// end of parameters
//=========================================
*/
//MakeTree()
//background{color rgb <0.8,0.9,1>}
//plane{y,0 pigment{rgb<1,0.7,0.3>}}


//=========================================
// Camera & light
//-----------------------------------------
#declare PdV=<0, 4 , -110>;
#declare PdA=<0,25,0>;
camera {location  PdV direction <0.0 , 0.0 , 1.7 > up y  right 4*x/3 look_at   PdA}
//-----------------------------------------
light_source{PdV color White*0.5  shadowless}
light_source{<130,40,-200> color White*1.8}
//=========================================
// Tree macro Parameters
//-----------------------------------------
// These parameters must be declared before calling the tree macro
//-----------------------------------------
#declare dofile=false;    // true creates a tree file ; false otherwise
#declare dotexture=true;  // true creates a textured tree (with the texture following the branch); false otherwise
#declare ftname="gttree1.inc" // file name for tree
#declare fvname="gtfoliage1.inc" // file name for foliage
#declare ffname="gtleaf1.inc" // file name for leaf
#declare txtTree=texture{txtTree_3} // Bark texture

//-----------------------------------------
// Random streams
// one stream for branches and another one for leaves
// so that the leafed tree has the same structure as the leafless one
//-----------------------------------------
#declare rsd=1431;      // random seed
#declare rsd=1432;      // random seed
#declare rsd=1433;      // random seed
#declare rd=seed(rsd);  // random stream for branches
#declare rdl=seed(rsd); // separate random stream for leaves

//-----------------------------------------
// Tree structure parameters        
// test with low level0 and nseg0 (3 or 4)
// High (>=6) recursion levels [level0] gives more complex trees
// High (>=6) segment numbers [nseg0] gives smoother trees
//-----------------------------------------
#declare level0=7;      // recursion level
//#declare level0=3;      // recursion level
#declare nseg0=12;       // initial number of branch segments (decreases of one at each level)
#declare nb=3;          // max number of branches per level
#declare dotop=true;   // if true, generates an extra branch on top of trunk (sometimes necessary to give more verticality)

#declare lb0=25;        // initial branch length
#declare rb0=1.4;         // initial branch radius
#declare ab0=35;        // initial branch angle (x angle between the trunk and the first branch)
#declare qlb=0.67;       // branch length decrease ratio (1=constant length)
#declare qrb=0.59;       // branch radius decrease ratio (1=constant radius)
#declare qab=0.88;       // branch angle decrease ratio (1=constant angle)
#declare stdax=10;      // stdev of x angle (angle x = ax+(0.5-rand)*stdax)
#declare stday=10;      // stdev of y angle (angle y = ay+(0.5-rand)*stday)

#declare branchproba=1; // probability of branch apparition 
#declare jb=0.7;        // secondary branches start after this ratio of branch length

#declare fgnarl=0.25;    // gnarledness factor - keep it low <0.8
#declare stdlseg=0.5;     // stddev of branch segment length (0...1) (adds more randomness to branch length)

#declare twigproba=0.59; // probability to have a twig on a trunk segment

#declare v0=<0,1,0>;    // initial direction - change to give an initial orientation
#declare pos0=<0,0,0>;  // initial trunk position (no need to change this one)

//-----------------------------------------
// constraints parameters
//-----------------------------------------
#declare vpush=<0,-1,0>;// direction of push (wind, gravity...) <0,-1,0> = gravity ; <0,1,0> = antigravity
#declare fpush=0.2;       // force of push
#declare aboveground=0; // constrains the branches above this level 
#declare belowsky=140;  // constrains the branches below this level 

//-----------------------------------------
// root parameters
//-----------------------------------------
#declare rootproba=1;   // probability of root 0=no root ; 1=all [nb] roots
#declare nroot=5;      // number of roots;
#declare vroot=<1,0,0>; // initial direction of root 
#declare yroot=<0,0.5,0>;   // initial position of root above ground

//-----------------------------------------
// leaf position parameters
//-----------------------------------------
#declare leafproba=0.8;   // probability of leaf 0=no leaf ; 1=leaf on each segment
#declare leaflevel=4;   // level where the leaves start to appear
#declare alz0=100;       // max z angle for leaf
#declare alx0=-10;      // start x angle for leaf
#declare stdalx=40;     // std x angle for leaf
#declare stdlsize=0.1;     // stddev of leaf size 0=constant size; size = leafsize*(1+stdlsize*rand)

//-----------------------------------------
// leaf structure parameters
//-----------------------------------------
#declare txtLeaf=texture{txtLeaf_0} // Leaf texture
#declare lsize=0.3;     // leaf size
#declare seg=10;        // nb of leaf segments and stalk segments : increase to smooth
#declare ll=5;          // leaf length
#declare wl=1.2;          // leaf width 
#declare fl=0.5;        // depth of leaf fold
#declare lpow=1;        // modifies the leaf shape : lpow=3 makes heart-shaped leaf
#declare al=100;        // leaf bending angle : the leaf bends backward until this angle
#declare apow=1;        // curve power, how slow the leaf bends
#declare ndents=0;      // dents in the leaf (8 = "oak" leaf). May require a high seg >20
#declare nlobes=3;      // number of lobes (individual leaves)
#declare alobes=110;    // angle made by all the lobes
#declare qlobes=0.7;    // size of the farest lobe (0.9 = size will be 0.9*leaf length)                               
#declare ls=3;          // stalk length (0=no stalk)
#declare ws=0.12;        // width of stalk
#declare as=10;         // stalk bending angle : the stalk bends forward
//-----------------------------------------
// end of parameters
//=========================================

//=========================================
// Make the tree now !
//-----------------------------------------

object{
        #if (leafproba>0)
        #declare Leaf=object{MakeLeaf(lsize,seg,ll,wl,fl,lpow,al,apow,
                 ndents,nlobes,alobes,qlobes,ls,ws,as,dofile,ffname)
                 #if (dotexture=false)  // no texture applied to tree segments, so the leaf texture must be used for the individual leaf
                        texture{txtLeaf}
                 #end
        } 
        
        #end              
        MakeTree()
        
        #if (dotexture = true) // texture is already applied to tree so that we can safely apply the leaf texture to the leaves
                texture {txtLeaf}
        #else

                texture {txtTree} // apply tree texture  regardless of the tree structure
        #end
}

plane{y,0 pigment{rgb<1,0.7,0.3>}}


background{color rgb <0.8,0.9,1>}

//tests for tree texture, leaf and leaf textures
//cylinder{0,y*4,1 texture{txtTree} scale 10}
//#declare Leaf=object{MakeLeaf(lsize,seg,ll,wl,fl,lpow,al,apow,ndents,nlobes,alobes,qlobes,ls,ws,as,dofile,ffname)  texture{txtLeaf}} 
//object{Leaf scale 15 rotate y*1 translate y*30 texture{txtLeaf} }

</textarea>


<!-- Sample file : lostbus.pov -->

<textarea id="lostbus.pov" name="lostbus.pov" style="display:none;">
// =========================================
// The lost bus - Demo file for the MakeSnow macro
// -----------------------------------------
// Made for Persistence of vision 3.6
// =========================================
// Copyright 1999-2004 Gilles Tran http://www.oyonale.com
// -----------------------------------------
// This work is licensed under the Creative Commons Attribution License. 
// To view a copy of this license, visit http://creativecommons.org/licenses/by/2.0/ 
// or send a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.
// You are free:
// - to copy, distribute, display, and perform the work
// - to make derivative works
// - to make commercial use of the work
// Under the following conditions:
// - Attribution. You must give the original author credit.
// - For any reuse or distribution, you must make clear to others the license terms of this work.
// - Any of these conditions can be waived if you get permission from the copyright holder.
// Your fair use and other rights are in no way affected by the above. 
// ==========================================  
// This image creates several objects and drops snow on them
// - a bus
// - cylinders 
// - twigs
// Render this image with a 2.67 ratio such as 1600*600 or 800*300
// -----------------------------------------
// It's a test scene. I may or may not improve it one day
// with a better bus model, more props etc. so that it can be rendered
// at bigger size
// -----------------------------------------
// Render stats on a Pentium 4 1.7 Gz, 1 Gb Ram
// 1600 * 600 +A0.3
// Parsing time 4mn 17S
// Render time 4h55
// RAM 66 Mb
// -----------------------------------------
#include "colors.inc"
#include "textures.inc"
#include "functions.inc"
#include "transforms.inc"

// ========================================
// MakeSnow macro
// -----------------------------------------
// Made for Persistence of vision 3.6
//==========================================  
// Copyright 2003 Gilles Tran http://www.oyonale.com
// -----------------------------------------
// This work is licensed under the Creative Commons Attribution License. 
// To view a copy of this license, visit http://creativecommons.org/licenses/by/2.0/ 
// or send a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.
// You are free:
// - to copy, distribute, display, and perform the work
// - to make derivative works
// - to make commercial use of the work
// Under the following conditions:
// - Attribution. You must give the original author credit.
// - For any reuse or distribution, you must make clear to others the license terms of this work.
// - Any of these conditions can be waived if you get permission from the copyright holder.
// Your fair use and other rights are in no way affected by the above. 
//==========================================  
// This macro project blob elements on an object, making it look like it is covered by snow.
// It was first developed to be used on trees, and it works better on complex shapes than on flat ones.
// Note: this macro uses the trace() function. This means that every surface will be detected, including 
// transparent ones used for media for instance.

// #declare Particles=12000; // number of snow particles
//      More particles = more parsing time and smoother effect
//      The macro loops until this number of "hits" is completed ("misses" do not count).

// #declare Size=2; // size of the largest snow particle
//       Sizes between 2 and 100 should be OK for objects whose size is expressed in centimetres

// #declare Thickness=1; // thickness of the particles
//     
// #declare MinHeight=0; // snow starts falling from this height ( 1 = max height of the object)
// #declare MaxHeight=1.1; // snow stops falling from this height  ( 1 = max height of the object)
//       Using MinHeight < 1 makes it possible to have snow on lower parts of the object that are protected 
//       by overhangs, higher branches and such, but it may requires more particles to get a proper effect

// #declare Direction=-y+x*0.1+z*0.3; // Direction of gravity, wind etc.(-y = vertical, no wind)
//     
#include "transforms.inc"
#macro MakeSnow(Obj,Particles,Size,Thickness,MinHeight,MaxHeight,Direction)
    #ifndef (T_Snow)
        #local T_Snow=texture{
            pigment{rgb 1}
            finish{ambient 0 diffuse 1}
        }
    #end
    #ifndef (rd)
        #local rd=seed(2003);
    #end
    #local Obj2=object{Obj Reorient_Trans(-y,<-Direction.x,Direction.y,-Direction.z>)}
    #local Min=min_extent(Obj2);
    #local Max=max_extent(Obj2);
    blob{
        threshold 0.6
        #local i=0; // first layer
        #debug "first layer of snow\n"
        #while (i<Particles/3)
            #local Start=<Min.x+rand(rd)*(Max.x-Min.x),(MinHeight+rand(rd)*(MaxHeight-MinHeight))*Max.y,Min.z+rand(rd)*(Max.z-Min.z)>;
            #local Norm=<0,0,0>;
            #local Inter= trace (Obj2, Start, -y, Norm );
            #if (vlength(Norm)!=0)
                #local Angle=pow((180-abs(degrees(acos(min(1,vdot(vnormalize(Norm),y))))))/180,2);
                #local FlakeSize=Angle*<1+rand(rd)*1.3,(Angle*0.5+rand(rd))*Thickness,1+rand(rd)*1.3>;
                sphere{0,Size*2,1 scale FlakeSize Reorient_Trans(y,Norm) translate Inter}
                #if (mod(i,1000)=0) 
                    #debug concat(str(i,0,0),"\n")
                #end
                #local i=i+1;
            #end
        #end 
        #local  i=0;
        #debug "second layer of snow\n"
        #while (i<Particles*2/3) // second layer of smaller particles
            #local Start=<Min.x+rand(rd)*(Max.x-Min.x),(MinHeight+rand(rd)*(MaxHeight-MinHeight))*Max.y,Min.z+rand(rd)*(Max.z-Min.z)>;
            #local Norm=<0,0,0>;
            #local Inter= trace (Obj2, Start, -y, Norm );
            #if (vlength(Norm)!=0)
                #local Angle=pow((180-abs(degrees(acos(min(1,vdot(vnormalize(Norm),y))))))/180,2);
                #local FlakeSize=Angle*<1+rand(rd)*1.3,(Angle*0.5+rand(rd))*Thickness,1+rand(rd)*1.3>;
                sphere{0,Size*2,1 scale FlakeSize*0.25 Reorient_Trans(y,Norm) translate Inter}
                #if (mod(i,1000)=0) 
                    #debug concat(str(i,0,0),"\n")
                #end
                #local i=i+1;
            #end
        #end 
        texture{T_Snow}
        Reorient_Trans(<-Direction.x,Direction.y,-Direction.z>,-y)
    }
#end    


//---------------------------------------
// Switches
//---------------------------------------
#declare TwigsSnowOK=1; // drop snows on the twigs
#declare BusSnowOK=1; // drop snow on the bus
#declare SideSnowOK=1; // drop snows on the road sides
#declare SlushOK=1; // creates slush on the road
#declare RadOK=2; // radiosity quality (2=better)

#declare ReflectionOK=1; // turns on the reflection
//---------------------------------------
// Settings
//---------------------------------------
// Low-quality radiosity is fast enough to be used for testing

global_settings{
    assumed_gamma 1
    max_trace_level 20
    radiosity{
        #if (RadOK<2)
            pretrace_start 1 
            pretrace_end   1
            count 10 error_bound 1 
        #else
            count 100 error_bound 1 
        #end
        nearest_count 5        // CHANGE - range from 1 to 3 - should correspond with pretrace_end
        recursion_limit 1    // CHANGE
        low_error_factor 1  // leave this
        gray_threshold 0  // leave this
        minimum_reuse 0.015  // leave this
        brightness 1         // leave this
        adc_bailout 0.01/2   // CHANGE - use adc_bailout
        media off
    }
}
//---------------------------------------
// Camera
//---------------------------------------
camera {
  location  <0.0, 140,-1500>
  direction 2*z
  right     x*image_width/image_height
  look_at   y*200
  rotate -y*40
}
//---------------------------------------
// Common textures
//---------------------------------------
#declare T_Clear=texture{pigment{Clear}finish{ambient 0 diffuse 0}}
#declare T_Snow=texture{
    pigment{White}
    finish{ambient 0 diffuse 1}
}
#declare T_Snow2=texture{
    pigment{White}
    finish{
        ambient 0 
        diffuse 1
        specular 1 
        roughness 1/1000 
        reflection {0.4*ReflectionOK} 
    }
}
//---------------------------------------
// Sky
//---------------------------------------
#declare colSky1=rgb <97,138,165>/255;
#declare colSky2=rgb <205,227,234>/255;
#declare P_Sky=pigment{
    gradient z
    pigment_map{
//        [0 pigment_pattern{function{max(0,min(1,y))}} color_map{[0 colSky1*0.5][0.5 colSky2*0.5]}]
//        [1 pigment_pattern{function{max(0,min(1,y))}} color_map{[0 colSky1][0.5 colSky2*2]}]
        [0 pigment_pattern{function{max(0,min(1,y))}} color_map{[0 colSky2*2][0.5 colSky1*2]}]
        [1 pigment_pattern{function{max(0,min(1,y))}} color_map{[0 colSky2*2][0.3 colSky1*0.4]}]
    }
    scale <1,1,2>
    translate -z
}

sky_sphere{
    pigment{P_Sky}
}

//---------------------------------------
// Fog
//---------------------------------------

fog{fog_type 2 color colSky1 distance 5000 fog_alt 500}
/*
// Below a media atmosphere for those with some computer power!
box{<-10000,-1,-1800>,<10000,10000,10000>
    texture{T_Clear}
    hollow
    interior{
        media{
            scattering {1, colSky1*30/100000 extinction 0}
            intervals 20
        }
    }
    rotate y*-40
}
*/
//---------------------------------------
// Forest
//---------------------------------------
// just a couple of semi-transparent planes
union{
    triangle{0,x,x+y}
    triangle{0,y,x+y}
    hollow
    scale <100,1.3,1>
    texture{
       function{max(0,min(1,y))} 
       turbulence 0.3 lambda 5
       texture_map{
        [0 pigment{colSky2*0.1} finish{ambient 0 diffuse 0.1}]
        [0.7 pigment{colSky2*0.3} finish{ambient 0 diffuse 0.6}]
        [1 T_Clear]
       }
    }        
    scale 500
    rotate -y*40
    translate <-13000,0,3000>
}

union{
    triangle{0,x,x+y}
    triangle{0,y,x+y}
    hollow
    translate -x*0.5
    scale <200,1,1>
    texture{
       function{max(0,min(1,y))} 
       turbulence 0.4 lambda 4
       texture_map{
        [0 pigment{colSky2*0.3} finish{ambient 0 diffuse 0.1}]
        [0.4 pigment{colSky2*0.3} finish{ambient 0 diffuse 0.6}]
        [0.7 T_Clear]
       }
    }        
    scale 3000
    rotate -y*40
    translate <-25000,0,20000>
}

//---------------------------------------
// Background
//---------------------------------------
#declare Resolution=200;
#declare Terrain= height_field {
    function Resolution,Resolution {
        f_ridged_mf( x, y, z,0.6, 3, 12, -1, 3,3 )*0.2*(1-y*0.98)
    }          
    texture{ // the terrain fades into the background
        gradient z
        texture_map{
            [0 T_Snow]
            [1 pigment{colSky1} finish{ambient 0 diffuse 0.3}]
        }
    }
    translate -x*0.5                  
    scale <10000,200,1400>
}
object{Terrain
    rotate -y*40
    translate <-4000,0,4000>
}                      
//---------------------------------------
// Sun
//---------------------------------------                        
// Not really needed
//light_source {-z*10000 White*0.2 rotate x*80 rotate y*10}

//---------------------------------------
// License plate
//---------------------------------------
// Generates a French license plate with the European flag
// The number is random (from the Paris region)
// It was created originally to generate license plates at random

#declare rd=seed(0);
#declare L=530/123;
#declare B=L*10/530;
#declare B2=L*58/530;
#declare L2=L-2*B-B2;
#declare colPlate=rgb <255,220,63>/255;
#declare Star=union{
    #declare i=0;
    #while (i<360)
            triangle{0,x,<cos(pi/5),cos(pi/5)/tan(pi/10),0> rotate -z*i}
            triangle{0,x,<cos(pi/5),-cos(pi/5)/tan(pi/10),0> rotate -z*i}
            #declare i=i+72;
    #end
    rotate z*18
}
#declare Plate=union{
    box{0,1 translate <-0.5,-0.5,0> scale <530/123,1,1> pigment{colPlate} finish{ambient 0 diffuse 0.6}}
    union{
        box{0,<L,-B,-0.001> translate <-L/2,0.5,0>}
        box{0,<L,B,-0.001> translate <-L/2,-0.5,0>}
        box{0,<B,1,-0.001> translate <-L/2,-0.5,0>}
        box{0,<-B,1,-0.001> translate <L/2,-0.5,0>}
        texture{pigment{White*0.3}finish{ambient 0 diffuse 0.6}}
    }
    union{
            box{0,<B2,1-2*B,-0.001> pigment{rgb <63,63,161>/255} finish{ambient 0 diffuse 0.6}}
            union{
                #declare i=0;
                #while (i<12)
                    object{Star translate x*15 rotate z*i*360/12}
                    #declare i=i+1;
                #end
                pigment{Yellow}
                finish{ambient 0 diffuse 0.6}
                scale B2/65
                translate -z*0.002+y*0.65+x*B2/2
            }
            #declare F=text{ttf "cyrvetic.ttf" "F" 0.01, 0}
            object{F Center_Trans(F,x) scale 0.8*B2 translate -z*0.002+y*0.1+x*B2/2 pigment{White}finish{ambient 1}}


            translate <-L/2+B,-0.5+B,0>
    }       
    #declare PlateString=concat(str(int(rand(rd)*9)+1,0,0),str(int(rand(rd)*10),0,0),str(int(rand(rd)*10),0,0));
    #if (rand(rd)>0.1)#declare PlateString=concat(PlateString,str(int(rand(rd)*10),0,0));#end
    #declare PlateString=concat(PlateString," ",chr(65+int(17*rand(rd))),chr(65+int(26*rand(rd))),chr(65+int(26*rand(rd)))," ");
    #if (rand(rd)>0.5)
        #declare PlateString=concat(PlateString,str(9,0,0),str(int(rand(rd)*5)+1,0,0));
    #else
        #declare PlateString=concat(PlateString,"75");
    #end            
    #declare PlateNumber=text{ttf "cyrvetic.ttf" PlateString 0.01, 0}
    #declare Max=max_extent(PlateNumber);
    #declare Min=min_extent(PlateNumber);
    object{
        PlateNumber scale <(L2-4*B)/(Max.x-Min.x),(1-4*B)/(Max.y),1>
        translate -y*0.5+y*2*B+x*(B*3+B2-L/2)
        translate -z*0.003
        pigment{White*0.3}
        finish{ambient 0 diffuse 0.6} 
    }
}        
//---------------------------------------
// Bus
//---------------------------------------
// This bus can be seen in the background of my IRTC picture "The little riding dragon" (December 2001)
// It has no interior and is not meant for close-ups

#declare rW=0.01;
#declare rW2=0.1;
#declare yBus=3.6;
#declare yBusGround=0.36;
#declare yBusSide1=1.65;
#declare yBusWindow=1.09;
#declare yBusSide2=yBusSide1+yBusWindow;
#declare yBusRoof=0.15;
#declare yBusSide=yBusSide1+yBusWindow+yBusRoof;
#declare xBusCabin=0.84;
#declare yBusCabin=2.72;
#declare yBusCabin=yBusSide-yBusRoof*2;
#declare yBusCabin1=1.45;
#declare yBusFrontWindow=1.21;
#declare xBusWindow1=0.05;
#declare xBusCabinWindow=xBusCabin-2*xBusWindow1-rW-rW2;
#declare yBusCabinWindow=yBusCabin-yBusCabin1-xBusWindow1; //1.03;
#declare rWheel=0.6;
#declare rTyre=0.3;
#declare rHub=rWheel-rTyre;
#declare wTyre=0.3;
#declare rWheelHole=rWheel+0.1;
#declare yBus=3.35;
#declare zBus=2.35;
#declare xBusWindow=1.38;
#declare xBusWindow2=xBusWindow-xBusWindow1;
#declare xBusSide1=0.18;
#declare xBusSide=xBusWindow*5+xBusSide1;
#declare xBusBodyCabin=7.91;
#declare tBus=0.03;
#declare rBusBack=0.65;
#declare xBusFront=0.3;
#declare xBusMirror=0.15;
#declare yBusMirror=0.41;
#declare T_BusMetal=texture{
    pigment{rgb 0.8*<244,235,235>/255}
    normal{bumps 0.3 scale 2}
    finish{ambient 0 diffuse 1 specular 1 roughness 1/1000 reflection {0.4*ReflectionOK metallic} metallic brilliance 2 }
}                    

#declare T_BusGlass=texture{
    pigment{rgbt<1,1,1,1>*0.9} 
    normal{bumps 0.05 scale 2}
    finish{
        ambient 0 
        diffuse 0 
        specular 1 
        roughness 1/1000 
        reflection {0,0.99*ReflectionOK fresnel on}
        conserve_energy
    }
}
#declare T_BusHLight=texture{ pigment{White*2} finish{ambient 1 diffuse 0 }}
#declare T_BusRLight1=texture{ pigment{Red*2}finish{ambient 1 diffuse 0 }}
#declare T_BusRLight2=texture{ pigment{Orange}finish{ambient 0 diffuse 1 }}
#declare T_BusPaint = texture{// body paint
            pigment{
                gradient y
                color_map{
                    [0.4 White]
                    [0.4 White*0.1]
                    [0.42 White*0.1]
                    [0.42 rgb <1,0.3,0.2>*0.5]
                    [0.7 rgb <1,0.3,0.2>*0.5]
                    [0.7 rgb <247,157,27>*0.5/255]
                }
            }
            normal{bumps 0.1 scale 3} 
            finish{
                ambient 0 
                diffuse 1 
                specular 1 
                roughness 1/1000 
                reflection {0.4*ReflectionOK} 
            }
        } 

#declare T_Tyre=texture{ pigment{rgb 0.3} finish{ambient 0 diffuse 0.6 reflection{0.2*ReflectionOK}}}
#declare pWheelFront=0.1+rWheelHole;
#declare pWheelRear=xBusSide-rWheelHole*2;
#declare tBusGlass=0.01;
#declare zBusBackWindow=zBus-2*rBusBack;
#declare zBusBackWindow2=zBusBackWindow-2*(rW+rW2+xBusWindow1);
#declare zBusHLight=0.31;
#declare rBusRLight=0.05;
#declare BusWindow=box{0,<xBusWindow,yBusWindow,tBus>}
#declare BusWindowAngle=union{
    difference{
        box{0,<rW+rW2,rW+rW2,tBus>}
        cylinder{-z*tBus,z*tBus*2,rW2+rW translate <rW+rW2,rW+rW2,0>}
    }
    difference{
        torus{rW2,rW rotate x*-90}
        plane{y,0 inverse}
        plane{x,0 inverse}
        translate <rW+rW2,rW+rW2,0>      
        texture{T_BusMetal}
    }    
}    
#declare BusWindow=union{    
    union{
        cylinder{0,x*(xBusWindow2-2*(rW+rW2)),rW translate <rW+rW2,rW,0>}    
        cylinder{0,x*(xBusWindow2-2*(rW+rW2)),rW translate <rW+rW2,yBusWindow-rW,0>}    
        cylinder{0,y*(yBusWindow-2*(rW+rW2)),rW translate <rW,rW+rW2,0>}
        cylinder{0,y*(yBusWindow-2*(rW+rW2)),rW translate <xBusWindow2-rW,rW+rW2,0>}
        cylinder{0,x*xBusWindow2,rW translate y*yBusWindow*0.7}
        texture{T_BusMetal}
    }
    object{BusWindowAngle}
    object{BusWindowAngle scale <-1,1,1> translate x*xBusWindow2}
    object{BusWindowAngle scale <1,-1,1> translate y*yBusWindow}
    object{BusWindowAngle scale <-1,-1,1> translate x*xBusWindow2+y*yBusWindow}
    box{0,<xBusWindow2,yBusWindow,tBusGlass>
        translate z*tBus*0.001
    }
    box{0,<xBusWindow1,yBusWindow,tBus> translate x*xBusWindow2}
}                                                                  
#declare Wheel=union{
    union{
        cylinder{0,z*wTyre,rWheel}
        torus{rWheel-(rWheel-rHub)/2,(rWheel-rHub)/2 rotate x*90 scale <1,1,0.3>}
        texture{T_Tyre}
    }
    difference{
        cylinder{-z*rHub*0.2,0,rHub*0.75}
        cylinder{-z*rHub*1.1,z*0.1,rHub*0.75}
    }
    sphere{0,rHub scale <1,1,rHub/3>}
    texture{T_BusMetal}
}
#declare BusSide=union{
    box{<0,0,0>,<0-rWheelHole,tBus,zBus/2>}
    box{<pWheelFront+rWheelHole,0,0>,<pWheelRear-rWheelHole,tBus,zBus/2>}
    box{<pWheelRear+rWheelHole,0,0>,<xBusSide,tBus,zBus/2>}
    
    difference{
        box{0,<xBusSide,yBusSide1,tBus>}
        cylinder{-z*tBus,z*tBus*2,rWheelHole translate x*pWheelFront}
        cylinder{-z*tBus,z*tBus*2,rWheelHole translate x*pWheelRear}
    }                            
    union{
        object{Wheel rotate y*20 translate x*pWheelFront}
        object{Wheel translate x*pWheelRear}
        translate z*0.15+y*0.1
    }     
    // trimming     
    union{
        union{
            difference{torus{rWheelHole,rW2 rotate x*90}plane{y,0} translate x*pWheelFront}
            difference{torus{rWheelHole,rW2 rotate x*90}plane{y,0} translate x*pWheelRear}
            union{
                cylinder{0,x*(pWheelFront-rWheelHole),rW2}
                cylinder{x*(pWheelFront+rWheelHole),x*(pWheelRear-rWheelHole),rW2}
                cylinder{x*(pWheelRear+rWheelHole),x*xBusSide,rW2}
                translate y*rW2
            }
            scale <1,1,rW/rW2>
        }
        cylinder{x*xBusCabin,x*xBusSide,rW*2 scale <1,1,1/2> translate y*(yBusSide1-rW2)}
        cylinder{x*xBusCabin,x*xBusSide,rW*2 scale <1,1,1/2> translate y*(yBusSide1-rW2*2)}
        cylinder{-y*(yBusSide1-yBusCabin1),x*xBusCabin,rW*2 scale <1,1,1/2> translate y*(yBusSide1-rW2)}
        cylinder{-y*(yBusSide1-yBusCabin1),x*xBusCabin,rW*2 scale <1,1,1/2> translate y*(yBusSide1-rW2*2)}
        texture{T_BusMetal}
    }
    union{
        box{0,<xBusSide1,yBusWindow,tBus>}
        union{
            union{ // windows
                #declare I=0;#while (I<5) object{BusWindow translate x*xBusWindow*I}#declare I=I+1;#end
                texture{ 
                    gradient y
                    turbulence 0.4
                    texture_map{
                        [0 T_BusGlass]
                        [0.4 bozo turbulence 0.3 scale 1/30 texture_map{[0.3 T_Snow][0.5 T_BusGlass]}]
                        [0.5 T_Snow2]
                    }
                    scale yBusWindow
                }
                
                translate x*xBusSide1
            }
            difference{
                cylinder{0,x*xBusSide,yBusRoof}
                cylinder{-x*0.1,x*xBusSide*1.1,yBusRoof-tBus}
                plane{y,0}
                plane{z,0 inverse}
                translate <0,yBusWindow,yBusRoof>
            }
        }
        translate y*yBusSide1
    }
    translate -zBus*z/2
}             
#declare BusRoof=union{
        box{<0,-tBus,-zBus/2+yBusRoof>,<xBusSide,0,zBus/2-yBusRoof>}     
        difference{
            cylinder{z*(-zBus/2+yBusRoof),z*(zBus/2-yBusRoof),yBusRoof}
            cylinder{z*(-zBus/2+yBusRoof)*1.1,z*(zBus/2-yBusRoof)*1.1,yBusRoof-tBus}
            plane{x,0 inverse}
            plane{y,0}
            scale <xBusCabin/yBusRoof,1,1>
            translate -y*yBusRoof
        }
        difference{
            union{
                sphere{0,yBusRoof translate z*(-zBus/2+yBusRoof)}
                sphere{0,yBusRoof translate -z*(-zBus/2+yBusRoof)}
            }
            plane{x,0 inverse}
            plane{y,0}
            scale <xBusCabin/yBusRoof,1,1>
            translate -y*yBusRoof
        }
        difference{
            union{
                cylinder{-y*yBusRoof,0,yBusRoof translate z*(-zBus/2+yBusRoof)}
                cylinder{-y*yBusRoof,0,yBusRoof translate -z*(-zBus/2+yBusRoof)}
            }
            plane{x,0 inverse}
            scale <xBusCabin/yBusRoof,1,1>
            translate -y*yBusRoof
        }            
        translate y*yBusSide
}
#declare BusBackCorner=union{
    box{0,<rW+rW2,yBusSide1,tBus>}
    union{
        union{
            cylinder{0,x*(rW+rW2),rW2 scale <1,1,rW/rW2>}
            difference{torus{rBusBack,rW} plane{x,0} plane{z,0 inverse} scale <1,rW2/rW,1> translate z*rBusBack+x*(rW+rW2)}
            translate y*rW2
        }
        union{
            cylinder{0,x*(rW+rW2),rW*2 scale <1,1,1/2>}
            difference{torus{rBusBack,rW} plane{x,0} plane{z,0 inverse} scale <1,2,1> translate z*rBusBack+x*(rW+rW2)}
            translate y*(yBusSide1-rW2)
        }
        union{
            cylinder{0,x*(rW+rW2),rW*2 scale <1,1,1/2>}
            difference{torus{rBusBack,rW} plane{x,0} plane{z,0 inverse} scale <1,2,1> translate z*rBusBack+x*(rW+rW2)}
            translate y*(yBusSide1-rW2*2)
        }
        texture{T_BusMetal} 
    }
    box{-y*tBus,<rW+rW2,0,rBusBack-yBusRoof> translate <0,yBusSide,yBusRoof>}
    difference{
        cylinder{0,x*(rW+rW2),yBusRoof}
        cylinder{-x*0.1,x*(rW+rW2)*1.1,yBusRoof-tBus}
        plane{z,0 inverse}
        plane{y,0}
        translate y*yBusSide2+z*yBusRoof
    }                     
    union{
        object{BusWindowAngle}
        object{BusWindowAngle scale <1,-1,1> translate y*yBusWindow}
        cylinder{0,y*(yBusWindow-2*(rW+rW2)),rW translate <rW,rW+rW2,0>texture{T_BusMetal}}
        translate y*yBusSide1
    }
    // corner                                       
    union{
        difference{
            union{
                difference{
                    cylinder{0,y*yBusSide1,rBusBack}
                    cylinder{-y*0.1,y*yBusSide*1.1,rBusBack}
                }                         
                union{
                    torus{rBusBack,rW translate y*(yBusSide1+rW)}
                    torus{rBusBack,rW translate y*(yBusSide2-rW)}
                    texture{T_BusMetal}
                }
            }
            plane{z,0 inverse}
            plane{x,0}
        }                
        union{
            difference{     
                torus{rBusBack-yBusRoof,yBusRoof}
                torus{rBusBack-yBusRoof,yBusRoof-tBus}
                cylinder{-y*yBusRoof*2,y*yBusRoof*2,rBusBack-yBusRoof}
                plane{y,0}
                plane{z,0 inverse}
                plane{x,0}
            }
            difference{
                cylinder{-y*tBus,0,rBusBack-yBusRoof}
                plane{z,0 inverse}
                plane{x,0}
                translate y*yBusRoof
            }
            translate y*yBusSide2
        }
        translate <rW+rW2,0,rBusBack>
    }
    union{
        object{BusWindowAngle scale <-1,1,1>}
        object{BusWindowAngle scale <-1,-1,1> translate y*yBusWindow}
        cylinder{0,y*(yBusWindow-2*(rW+rW2)),rW translate y*(rW+rW2)-x*rW texture{T_BusMetal}}
        translate x*(rW+rW2+rBusBack)
        rotate -y*90
        translate y*yBusSide1+x*(rBusBack+rW+rW2)
    }               
    union{
        box{0,<rW+rW2,yBusWindow,tBusGlass> translate z*0.001}
        difference{
            cylinder{0,y*yBusWindow,rBusBack}
            cylinder{-y*0.1,y*yBusWindow*1.1,rBusBack-tBus}
            plane{x,0}
            plane{z,0 inverse}
            translate <rW+rW2,0,rBusBack>
        }                         
        box{0,<rW+rW2,yBusWindow,tBusGlass> translate z*0.001 rotate y*-90 translate <rW+rW2+rBusBack,0,rBusBack>}
        texture{ 
            gradient y
            turbulence 0.4
            texture_map{
                [0 T_BusGlass]
                [0.4 bozo turbulence 1 scale 1/30 texture_map{[0.3 T_Snow][0.5 T_BusGlass]}]
                [0.5 T_Snow2]
            }
            scale yBusWindow
        }
        translate y*yBusSide1
    }
    
    translate -z*zBus/2
}                                  
#declare BusRLight1=union{
    union{
        torus{rBusRLight,rW rotate x*90}
        cylinder{0,z*rBusBack,rW*2+rBusRLight}
        texture{T_BusMetal}
    }
    sphere{0,rBusRLight scale <1,1,3> texture{T_BusRLight1}}
}
#declare BusRLight2=union{
    union{
        torus{rBusRLight,rW rotate x*90}
        cylinder{0,z*rBusBack,rW*2+rBusRLight}
        texture{T_BusMetal}
    }
    sphere{0,rBusRLight scale <1,1,1> texture{T_BusRLight2}}
}
#declare BusRLight=union{
    object{BusRLight2 }
    object{BusRLight1 translate y*rBusRLight*5}
    object{BusRLight1 translate y*rBusRLight*10}
    translate y*yBusSide1*0.45
}                    




#declare BusBackWindow=union{             
    object{BusRLight translate -x*rBusBack*0.5}
    object{BusRLight scale <-1,1,1> translate x*(zBusBackWindow+rBusBack*0.5)}
    box{0,<zBusBackWindow,yBusSide1,tBus>}
    difference{
        superellipsoid{<0.1,0.1>}
        superellipsoid{<0.1,0.1> scale 0.4 translate -z}
        scale <zBusBackWindow/2,yBusSide1/4,tBus> 
        translate <zBusBackWindow/2,yBusSide1/2,0>
    }
    superellipsoid{<0.1,0.1> scale <zBusBackWindow/2,tBus,tBus*2> translate <zBusBackWindow/2,yBusSide1*0.75-tBus*3,0> texture{T_BusMetal}}
    union{
        cylinder{0,zBusBackWindow*x,rW2 scale <1,1,rW/rW2> translate y*rW2}
        cylinder{0,zBusBackWindow*x,rW*2 scale <1,1,1/2> translate y*(yBusSide1-rW2)}
        cylinder{0,zBusBackWindow*x,rW*2 scale <1,1,1/2> translate y*(yBusSide1-rW2*2)}
        texture{T_BusMetal} 
    }        
    union{
        union{
            cylinder{0,x*(zBusBackWindow2-2*(rW+rW2)),rW translate <rW+rW2,rW,0>}    
            cylinder{0,x*(zBusBackWindow2-2*(rW+rW2)),rW translate <rW+rW2,yBusWindow-rW,0>}    
            cylinder{0,y*(yBusWindow-2*(rW+rW2)),rW translate <rW,rW+rW2,0>}
            cylinder{0,y*(yBusWindow-2*(rW+rW2)),rW translate <zBusBackWindow2-rW,rW+rW2,0>}
            texture{T_BusMetal}
        }
        object{BusWindowAngle}
        object{BusWindowAngle scale <-1,1,1> translate x*zBusBackWindow2}
        object{BusWindowAngle scale <1,-1,1> translate y*yBusWindow}
        object{BusWindowAngle scale <-1,-1,1> translate x*zBusBackWindow2+y*yBusWindow}
    
        box{0,<zBusBackWindow2,yBusWindow,tBusGlass> 
            texture{ 
                gradient y
                turbulence 0.4
                texture_map{
                    [0 T_BusGlass]
                    [0.4 bozo turbulence 1 scale 1/30 texture_map{[0.3 T_Snow][0.5 T_BusGlass]}]
                    [0.5 T_Snow2]
                }
                scale yBusWindow
            }
            translate z*tBus*0.001
        }
        translate y*yBusSide1+x*(rW+rW2+xBusWindow1)
    }
    box{0,<xBusWindow1,yBusWindow,tBus> translate <rW+rW2,yBusSide1,0>}
    box{0,<xBusWindow1,yBusWindow,tBus> scale <-1,1,1> translate <zBusBackWindow-rW-rW2,yBusSide1,0>}
    translate -x*zBusBackWindow/2
    rotate y*-90
}                     


#declare BumperRear=union{
    #declare BumperRearSide=difference{
            union{                       
                union{
                    torus{rBusBack+tBus,tBus}
                    torus{rBusBack+tBus,tBus translate y*rW2*2}
                }
                cylinder{0,y*rW2*2,rBusBack}
            }
            plane{x,0}
            plane{z,0 inverse}
            translate -z*(zBus/2-rBusBack)
    }
    
    object{BumperRearSide}
    object{BumperRearSide scale <1,1,-1>}
    union{
        box{<-tBus,0,-zBus/2+rBusBack>,<0,rW2*2,zBus/2-rBusBack>}
        union{
            cylinder{-z*(zBus/2-rBusBack),z*(zBus/2-rBusBack),tBus}
            cylinder{-z*(zBus/2-rBusBack),z*(zBus/2-rBusBack),tBus translate y*rW2*2}
        }
        translate x*rBusBack        
    }
    texture{T_BusMetal}
    translate x*(rW+rW2+rBusBack/2)+y*rW2
}
#declare BusBack=union{  
    object{BumperRear}
    object{BusBackCorner}
    object{BusBackCorner scale <1,1,-1>}
    object{BusBackWindow translate x*(rW+rW2+rBusBack)}
    union{
        difference{
            cylinder{-z*zBusBackWindow/2,z*zBusBackWindow/2,yBusRoof}
            cylinder{-z*zBusBackWindow,z*zBusBackWindow,yBusRoof-tBus}
            plane{y,0}
            plane{x,0}
            translate x*(rW+rW2+rBusBack-yBusRoof)
        }                    
        box{<0,-tBus,-zBusBackWindow/2>,<rW+rW2+rBusBack-yBusRoof,0,zBusBackWindow/2> translate y*yBusRoof}
        translate y*yBusSide2
    }             
    scale <0.5,1,1>
    translate x*xBusSide
}                        


#declare BusMirror=union{
    difference{
        superellipsoid{<0.1,0.1> texture{T_BusMetal}}
        superellipsoid{<0.1,0.1> scale 0.8 translate -z texture{pigment{rgb 0}finish{ambient 0 diffuse 0 reflection 1*ReflectionOK}}}
        scale <xBusMirror/2,yBusMirror/2,rW>
        rotate z*1
        translate -z*rW*2
    }                                                          
    union{
        cylinder{-z*rW*2-y*yBusMirror*0.3,<xBusMirror*2,-yBusMirror*0.4,0>,rW}
        cylinder{-z*rW*2+y*yBusMirror*0.3,<xBusMirror*2,yBusMirror*0.4,0>,rW}
        cylinder{-y*yBusMirror*0.41,y*yBusMirror*0.41,rW*1.1 translate x*xBusMirror*2}
        translate z*rW
    }
    texture{T_BusMetal}
    translate <-xBusMirror*2+rW,yBusCabin1*1.1,0>
    rotate y*-90
}
#declare BusCabinSide=union{
    object{BusMirror}
    object{BusRLight2 scale <2,1,0.5> translate <rBusRLight*5,yBusCabin1-4*rW2-rBusRLight*2>}
    box{0,<xBusCabin,yBusCabin1,tBus>}
    // base trimming
    union{     
        cylinder{0,x*xBusCabin,rW2 scale <1,1,rW/rW2> translate y*rW2}
        cylinder{0,x*xBusCabin,rW*2 scale <1,1,0.5> translate y*(yBusCabin1-rW2)}
        cylinder{0,x*xBusCabin,rW*2 scale <1,1,0.5> translate y*(yBusCabin1-rW2*2)}
        texture{T_BusMetal}
    }
    union{                                
        box{0,<xBusWindow1,yBusCabinWindow+xBusWindow1,tBus> translate x*(rW+rW2)}
        box{0,<xBusWindow1,yBusCabinWindow+xBusWindow1,tBus> scale <-1,1,1> translate x*xBusCabin}
        
        translate y*yBusCabin1
    }                                    
    
    box{0,<xBusCabin,xBusWindow1,tBus> scale <1,-1,1> translate y*yBusCabin}
    union{
        object{BusWindowAngle scale <-1,1,1>}
        object{BusWindowAngle scale <-1,-1,1> translate y*yBusCabinWindow}
        cylinder{0,y*(yBusCabinWindow-2*(rW+rW2)),rW translate <0,rW+rW2,0> texture{T_BusMetal}}
        translate y*yBusCabin1+x*(rW+rW2)
    }    
    union{    
        union{
            cylinder{0,x*(xBusCabinWindow-2*(rW+rW2)),rW translate <rW+rW2,rW,0>}    
            cylinder{0,x*(xBusCabinWindow-2*(rW+rW2)),rW translate <rW+rW2,yBusCabinWindow-rW,0>}    
            cylinder{0,y*(yBusCabinWindow-2*(rW+rW2)),rW translate <rW,rW+rW2,0>}
            cylinder{0,y*(yBusCabinWindow-2*(rW+rW2)),rW translate <xBusCabinWindow-rW,rW+rW2,0>}
            texture{T_BusMetal}
        }
        object{BusWindowAngle}
        object{BusWindowAngle scale <-1,1,1> translate x*xBusCabinWindow}
        object{BusWindowAngle scale <1,-1,1> translate y*yBusCabinWindow}
        object{BusWindowAngle scale <-1,-1,1> translate x*xBusCabinWindow+y*yBusCabinWindow}
        translate <xBusWindow1+rW+rW2,yBusCabin1,0>
    }
    box{0,<xBusCabin,yBusCabinWindow,tBusGlass> 
        texture{ 
            gradient y
            turbulence 0.4
            texture_map{
                [0 T_BusGlass]
                [0.4 bozo turbulence 1 scale 1/30 texture_map{[0.3 T_Snow][0.5 T_BusGlass]}]
                [0.5 T_Snow2]
            }
            scale yBusCabinWindow
        }
        translate z*tBus*0.001+yBusCabin1*y
    }
    translate <-xBusCabin,0,-zBus/2>
}        
#declare BusCabinRoof=union{
    difference{
        cylinder{0,x*xBusCabin,zBus/2}
        cylinder{-x*0.1,x*xBusCabin*1.1,-tBus+zBus/2}
        plane{y,0}
        scale <1,yBusRoof*3/zBus,1>
    }                          
    translate y*yBusCabin-x*xBusCabin
}                           
#declare BumperFront=union{
    object{Plate scale zBus*0.35/L rotate y*90 translate -x*xBusFront+y*rW2}
    difference{
        union{
            union{
                torus{zBus/2+tBus,tBus}
                torus{zBus/2+tBus,tBus translate y*rW2*2}
//                texture{T_Tyre}
            }
            cylinder{0,y*rW2*2,zBus/2}
        }
        plane{x,0 inverse}
        scale <xBusFront*2/zBus,1,1>
    }               
    union{
        superellipsoid{<0.1,0.1> scale <rW2,rW2*1.5,rW2/2> translate -z*zBus*0.25}
        superellipsoid{<0.1,0.1> scale <rW2,rW2*1.5,rW2/2> translate z*zBus*0.25}
        translate y*rW2-x*xBusFront*0.8
        texture{T_Tyre}
    }
    texture{T_BusMetal}
    translate -x*tBus+y*rW2
}                      
#declare BusGrid1=difference{
    torus{zBus/2,rW*2}
    plane{x,0 inverse}
    scale <xBusFront*2/zBus,1,1>
    texture{T_BusMetal}
}                         
#declare BusGrid1a=difference{
    torus{zBus/2,rW*2}
    plane{x,0 inverse}
    box{<-zBus*0.6,-rW*3,0>,<0,rW*3,zBusHLight> translate z*zBus*0.37}
    box{<-zBus*0.6,-rW*3,0>,<0,rW*3,zBusHLight> translate z*zBus*0.37 scale <1,1,-1>}
    scale <xBusFront*2/zBus,1,1>
    texture{T_BusMetal}
}                         
#declare yBusHLight=yBusCabin1-4*rW2-yBusCabin1/3;
#declare colHLight=rgb <249,225,100>/255;
#declare colRLight=Red;
#declare BusHLight=union{ // headlight object
    sphere{0,0.7 texture{T_BusHLight}}
    torus{0.75,0.05 rotate z*90 texture{T_BusMetal}}
    scale <0.3,0.5,1>
    translate -x
}                     
#declare BusHLightSource=union{ // headlight light and halo
    sphere{ // halo
        0, 0.4 
        hollow 
        no_shadow
        pigment{Clear}
        interior{
            media{ 
                emission 1/8
                samples 1,1 
                intervals 1 
                confidence .1
                density{ 
                    spherical 
                    poly_wave 10 
                    density_map{
                        [0 rgb 0]
                        [0.5 colHLight*0.5]
                        [1 rgb 1]
                    }
                }
            }
        }
        scale 8
        scale <0.3,0.5,1>
        translate -x
    }                     
    light_source{
        -x*2
        colHLight*80
        fade_power 2
        fade_distance 180
        spotlight
        point_at -x*100-y*5
        radius 10
        falloff 30
    
    }
}
#declare BusRLightSource=light_source{ // rear light
    0
    colRLight*80
    fade_power 2
    fade_distance 50
    spotlight
    point_at -z*100-y*10
    radius 5
    falloff 20
    tightness 0
    
    translate y*yBusSide1*0.45
}
#declare BusHLight2=union{
    superellipsoid{<0.2,0.2>}
    object{BusHLight translate -y*0.5}
    object{BusHLight translate y*0.5}
    scale <zBusHLight,yBusHLight/2,zBusHLight/2> 
    translate <rW2*0.5,yBusHLight/2,zBusHLight/2>
    translate z*zBus*0.37+y*(yBusCabin1/3)
}
#declare BusHLightSeparate=union{
    object{BusHLightSource translate -y*0.5}
    object{BusHLightSource translate y*0.5}
    scale <zBusHLight,yBusHLight/2,zBusHLight/2> 
    translate <rW2*0.5,yBusHLight/2,zBusHLight/2>
    translate z*zBus*0.37+y*(yBusCabin1/3)
}
#declare BusFront=union{         
    object{BumperFront}
    object{BusHLight2}
    object{BusHLight2 scale <1,1,-1>}
    object{BusGrid1 translate y*(yBusCabin1/3)}
    object{BusGrid1 translate y*(yBusCabin1-4*rW2)}
    #declare I=1;
    #while (I<6)       
        object{BusGrid1a translate y*(yBusCabin1/3+I*(yBusCabin1-4*rW2-yBusCabin1/3)/6)}
        #declare I=I+1;
    #end
    union{
        #declare I=0;
        #while (I<=24)       
            cylinder{0,y*yBusHLight,rW*2 translate -x*zBus/2 rotate y*(-90+I*180/24)}
            #declare I=I+1;
        #end
        scale <xBusFront*2/zBus,1,1>
        translate y*yBusCabin1/3
        texture{T_BusMetal}
    }
    cylinder{y*yBusCabin1,y*(yBusCabin-xBusWindow1),rW*2 
        translate -x*zBus/2 
        scale <xBusFront*2/zBus,1,1>
        texture{T_BusMetal}
    }    
    difference{                       
        union{
            cylinder{0,y*yBusCabin1/3,zBus/2}
            cylinder{y*yBusCabin1/3,y*(yBusCabin1-4*rW2),(zBus/2)-tBus*4 texture{pigment {rgb 0.3}}}
            cylinder{y*(yBusCabin1-4*rW2),y*yBusCabin1,zBus/2}
        }
        plane{x,0 inverse}
        scale <xBusFront*2/zBus,1,1>
    }         
    
    difference{
        cylinder{-y*xBusWindow1,0,zBus/2}
        cylinder{-y*xBusWindow1*1.1,y*0.1,zBus/2-tBus}
        plane{x,0 inverse}
        scale <xBusFront*2/zBus,1,1>
        translate y*yBusCabin
    }    
    union{
        difference{
            cylinder{y*yBusCabin1,y*(yBusCabin-xBusWindow1),zBus/2}
            cylinder{y*yBusCabin1-y,y*(yBusCabin-xBusWindow1)+y,zBus/2}
            plane{x,0 inverse}
        }
        // wipers
        #declare rWiper=rW;
        #declare yWiper=yBusCabin1*0.9/2;
        #declare Wiper=union{
            cylinder{0,y*yWiper,rWiper}
            cylinder{-z*0.8*yWiper/2,z*0.8*yWiper/2,rWiper rotate x*-60 translate y*yWiper}
            rotate -x*50
            texture{T_BusMetal}
        }
        union{
            object{Wiper translate -x*zBus/2-x*rW rotate y*-35 pigment{White}}
            object{Wiper translate -x*zBus/2-x*rW rotate y*35 pigment{White}}
            translate y*yBusCabin1
        }
        scale <xBusFront*2/zBus,1,1>
        texture{ // front glass texture
            pigment_pattern{
                cylindrical
                turbulence 0.1
                warp{repeat z/2 flip z}
                translate -z*0.5
            }
            texture_map{
                [0.3 T_Snow2]
                [0.4 bozo turbulence 1 scale 1/30 texture_map{[0.3 T_Snow][0.5 T_BusGlass]}]
                [0.5 T_BusGlass]
            }
            rotate z*90
            scale zBus/2
            translate y*(yBusCabin1)
        }
    }    
    difference{
        union{
            torus{zBus/2,rW translate y*yBusCabin1}
            torus{zBus/2,rW translate y*(yBusCabin-xBusWindow1)}
        }
        plane{x,0 inverse}
        scale <xBusFront*2/zBus,1,1>
        texture{T_BusMetal}
    }
    difference{
        sphere{0,zBus/2}
        sphere{0,zBus/2-tBus}
        plane{x,0 inverse}
        plane{y,0}
        scale <xBusFront*2/zBus,yBusRoof*3/zBus,1>
        translate y*yBusCabin
    }    
    // base trimming     
    union{
        difference{torus{zBus/2,rW} plane{x,0 inverse} scale <xBusFront*2/zBus,rW2/rW,1> translate y*rW2}
        difference{torus{zBus/2,rW} plane{x,0 inverse} scale <xBusFront*2/zBus,2,1> translate y*(yBusCabin1-rW2)}
        difference{torus{zBus/2,rW} plane{x,0 inverse} scale <xBusFront*2/zBus,2,1> translate y*(yBusCabin1-rW2*2)}
        texture{T_BusMetal}
    }
    translate -x*xBusCabin
}
#declare BusCabin=union{
    object{BusCabinSide}
    object{BusCabinSide scale <1,1,-1>}
    object{BusCabinRoof}
    object{BusFront}
}
#declare Bus=union{
    object{BusSide}
    object{BusSide scale <1,1,-1>}
    object{BusRoof}     
    object{BusBack}
    object{BusCabin}
    translate y*(rWheel-0.1)
    texture{T_BusPaint}
    scale 100
    rotate y*-90
    rotate z*5
}

// the reason the halo and lights are dealt separately is that otherwise the snow macro interacts with them
#declare BusHLights=union{
    object{BusHLightSeparate}
    object{BusHLightSeparate scale <1,1,-1>}
    translate -x*xBusCabin*0.8
    translate y*(rWheel-0.1)
    scale 100
    rotate y*-90
    rotate z*5
}
#declare BusRLights=union{
    object{BusRLightSource translate -x*rBusBack*0.5}
    object{BusRLightSource scale <-1,1,1> translate x*(zBusBackWindow+rBusBack*0.5)}
    translate -x*zBusBackWindow/2
    rotate y*-90
    translate x*(rW+rW2+rBusBack)
    scale <0.5,1,1>
    translate x*xBusSide*1.1
    translate y*(rWheel-0.1)
    scale 100
    rotate y*-90
    rotate z*5
}


//---------------------------------------
// Twigs
//---------------------------------------
// This macro was used in "The lovers" and in "The dark side of the trees"
#macro CYL(L,R)
    #local R2=R;
    #local SC=3;
    #local SC2=0.2;
    #local QQ=rand(rd)*10;
    isosurface{
        function{
            sqrt(pow(x,2)+pow(z,2))-1 //+f_noise3d(x*SC,y*SC,z*SC)*SC2-1
            + f_noise3d(x*SC+QQ, y*SC+QQ, z*SC+QQ)*SC2
            + abs(pow(sin(y*pi),0.2))*0.5

        }
        max_gradient 6
        contained_by{box{<-1,0.001,-1.1>,<1,0.999,1>}}
        scale <R2,L,R2>
    }
#end
#declare Shoot=isosurface {
    function {
        sqrt(pow(x,2) + pow(y,2) + pow(z,2)) - 0.9
        + sin(6*atan2(x, z))*0.1
    }
    threshold 0
    max_gradient 3
    contained_by {sphere {0, 1}}
}

#macro mTwig(TN, TL, TPOS0, TR, TA, TB)
// TN number of segments
// TL length of segments
// TPOS0 start of branch     
// TR start radius
// TA angle z
// TB angle x
    #local TI=0;
    #local TPOS=TPOS0;
    #while (TI<TN)
        #local TK=TI/TN;
        #local TL=TL*(0.8+rand(rd)*0.1);
        #local TRT=360*rand(rd);
        #local TR2=TR+(RN-TR)*TK;
        #local TT=transform {rotate y*TRT rotate -z*TA rotate x*TB translate TPOS}
        object{CYL(TL,TR2) transform TT}
        #if (TI=TN-1)
            object{Shoot scale <1,1.4,1>*RN
                translate y*TL transform TT
            }
        #end
        union{
            #local LC=TR2*(1+rand(rd));
            cone{0,TR2*0.5,x*LC,TR2*0.15} 
            sphere{0,TR2*0.15 translate x*LC}
            rotate z*50 rotate TRT*y transform TT
        }
        union{
            #local LC=TR2*(1+rand(rd));
            cone{0,TR2*0.5,x*LC,TR2*0.15} 
            sphere{0,TR2*0.15 translate x*LC}
            rotate z*50 rotate (TRT+180)*y transform TT
        }
        #local TT0=transform{translate y*TL rotate -z*TA rotate x*TB}
        #local TPOS=TPOS+vtransform(<0,0,0>,TT0);
        #local TA=TA+(0.5-rand(rd))*20;
        #local TB=TB+(0.5-rand(rd))*20;
        #local TI=TI+1;
    #end

#end

#macro mBranch(N,L,POS0,R,A,B, PA, PB)
// N number of segments
// L length of segments
// POS0 start of branch     
// R start radius
// A angle z
// B angle x
// PA increment angle A
// PB increment angle B
    union{
        #local I=0;
        #local R0=R;
        #local RN=0.02;
        #local POS=POS0;
        #local TA=-30*rand(rd)+60;
        #while (I<N)
            #local K=I/N;
            #local L=L*(0.8+rand(rd)*0.1);
            #local RT=360*rand(rd);
            #local RB=R0+(RN-R0)*K;
            #local T=transform { rotate -z*A rotate x*B translate POS}
            object{CYL(L,RB) transform T}
            union{
                #local LC=RB*(1+rand(rd));
                cone{0,RB*0.3,x*LC,RB*0.15} 
                sphere{0,RB*0.15 translate x*LC}
                rotate z*50 rotate RT*y transform T
            }
            union{
                #local LC=RB*(1+rand(rd));
                cone{0,RB*0.3,x*LC,RB*0.15} 
                sphere{0,RB*0.15 translate x*LC}
                rotate z*50 rotate (RT+180)*y transform T
            }

            #if (I=N-1)
                object{Shoot scale <1,1.4,1>*RN
                    translate y*L transform T
                }
            #end
            #if (rand(rd)<0.5)
                #declare TA=-TA;
                mTwig(1+int(rand(rd)*(N-1)*0.7),L*0.8,POS,RB*0.8,TA,0)
            #end                                            
            
            #local T0=transform{translate y*L rotate -z*A rotate x*B}
            #local POS=POS+vtransform(<0,0,0>,T0);
            #local A=A+PA;
            #local B=B+PB;
            #local I=I+1;
        #end
    }
#end

#debug "twigs\n"
#declare Twigs=union{
        #declare NBR=1;
        #declare rd=seed(0);
        mBranch(7,0.8,<-0.1,0,0>,0.06,10,-10,5,5)
        #declare rd=seed(40);
        #declare NBR=2;
        mBranch(7,0.8,<0,0,0>,0.06,-10,10,-5,5)
        #declare NBR=3;
        object{mBranch(7,0.8,<0,0,0>,0.06,10,10,5,-10) rotate y*120 translate <0.1,-0.3,0>}
        object{mBranch(7,0.8,<0,0,0>,0.06,10,10,5,10) rotate y*40 translate <-0.2,-0.3,-0.3>}
        scale 100
        texture{
            pigment{
                granite
                turbulence 0.4
                color_map{
                    [0 rgb <108/255,95/255,74/255>]
                    [0.4 rgb <108/255,95/255,74/255>*255/108]
                }
            }       
            finish{ambient 0 diffuse 0.3}
            scale 4
        }
    rotate y*60
}    



//---------------------------------------
// Snow on twigs
//---------------------------------------
#declare Particles=9000; // number of snow particles
#declare Size=1.5; // size of the largest snow particle
#declare Thickness=1; // thickness of the particles      
#declare MinHeight=0; // snow starts falling from this height ( 1 = max height of the object)
#declare MaxHeight=1.1; // snow stops falling from this height  ( 1 = max height of the object)
#declare Direction=-y+x*0.1+z*0.3; // Direction of gravity, wind etc.(-y = vertical, no wind)
union{
    object{Twigs}
    #if (TwigsSnowOK=1)
        object{MakeSnow(Twigs,Particles,Size,Thickness,MinHeight,MaxHeight,Direction)}
    #end
    translate <570,20,-780>
}
//---------------------------------------
// Road
//---------------------------------------
// Just a flattened cylinder
#declare T_Concrete=texture{
    // the crackle pattern creates patches of varying reflection and color
    pigment_pattern{crackle turbulence 0.3 scale 400*<0.4,1,20>}
    texture_map{
        [0
            pigment{
                crackle
                color_map{
                    [0 rgb <91,104,100>*0.5/255]
                    [1 rgb <91,104,100>*1/255]
                }
            }
            normal{
                average
                normal_map{
                    [1 crackle bump_size 0.5]
                    [1 bozo 2 scale 30]
                }
            }
            finish{ambient 0 diffuse 0.6 reflection{0,0.8*ReflectionOK}}
        ]
        [1
            pigment{
                crackle
                color_map{
                    [0 rgb <97,104,100>*0.3/255]
                    [1 rgb <97,104,100>*0.8/255]
                }
            }
            normal{
                average
                normal_map{
                    [1 crackle bump_size 0.5]
                    [1 bozo 2 scale 30]
                }
            }
            finish{ambient 0 diffuse 0.6 reflection{0,0.1*ReflectionOK}}
        ]
    }
    scale 1/200
} 

#declare T_Stripe=texture{ // middle of the road
    gradient z
    texture_map{
        [0.5 T_Concrete]
        [0.5 
            pigment{White}
            normal{crackle bump_size 2 scale 1/200}
            finish{ambient 0 diffuse 0.5 reflection{0,0.4*ReflectionOK}}
        ]
    }
}
#declare T_Road=texture{
    pigment_pattern{gradient x turbulence 0.01}
    texture_map{
        [0.49 T_Concrete]
        [0.49 T_Stripe]
        [0.51 T_Stripe]
        [0.51 T_Concrete]
    }
    translate -x*0.5
    scale 2
}


cylinder{-z*2000,z*100000,1 scale <350,10,200> texture{T_Road scale 350}}

plane{y,0 texture{pigment{White} finish{ambient 0 diffuse 1}}}


//---------------------------------------
// Road sides
//---------------------------------------
// Two cylinders with snow
#declare rd=seed(1899);
#declare Thickness=1; // thickness of the particles      
#declare MinHeight=0; // snow starts falling from this height ( 1 = max height of the object)
#declare MaxHeight=1.1; // snow stops falling from this height  ( 1 = max height of the object)
#declare Direction=-y; // Direction of gravity, wind etc.(-y = vertical, no wind)
#declare SideLeft=cylinder{0,z*6100,1 scale <300,50,1> texture{T_Snow} translate -x*650-z*800}
#declare SideRight=cylinder{0,z*4000,1 scale <200,40,1> texture{T_Snow} translate x*650-z*1000}

object{SideLeft}
object{SideRight}

#if (SideSnowOK=1)
    #debug "snow side left\n"
    #declare Particles=30000; // number of snow particles
    #declare Size=10; // size of the largest snow particle
    object{MakeSnow(SideLeft,Particles,Size,Thickness,MinHeight,MaxHeight,-x*0.4-y)}
    #debug "snow right left\n"
    #declare Particles=30000; // number of snow particles
    #declare Size=15; // size of the largest snow particle
    object{MakeSnow(SideRight,Particles,Size,Thickness,MinHeight,MaxHeight,Direction)}
#end



//---------------------------------------
// Bus with snow
//---------------------------------------
#debug "snow bus\n"
union{
    object{Bus}
    object{BusHLights}
    object{BusRLights}
    #if (BusSnowOK=1)
        object{MakeSnow(Bus,12000,7,Thickness,MinHeight,MaxHeight,-y-x*0.1-z*0.1)}
        object{MakeSnow(Bus,2000,7,Thickness,0.5,MaxHeight,-y+x*0.1-z*0.1)}
        object{MakeSnow(Bus,6000,7,Thickness,0,0.6,-y-x*0.1-z*0.2)}
    #end
    rotate z*-15
    translate -x*350+z*2000+y*20
}

//---------------------------------------
// Slush
//---------------------------------------
// Some dirty snow in the middle of the road
#if (SlushOK=1)
    #declare T_Snow=texture{//pigment{Red}
        pigment{rgbt <0.8,0.8,0.8,0.6>}
        finish{ambient 0 diffuse 0.8}
    } 
    #declare Size=7;
    #declare SideCentral=cone{0,1,z*1500,0.2 scale <100,10,1> texture{pigment{White*0.4}}}
    #declare Slush=object{MakeSnow(SideCentral,2000,Size,Thickness,MinHeight,MaxHeight,-x*0.4-y)}
    union{
        object{Slush translate -z*800-x*50}
        object{Slush rotate y*180 translate z*3000+x*50}                                 
        translate y*10
    }
    
    #declare Size=5;
    #declare Spot=sphere{0,1 scale <300,10,500>}
    #declare Slush2=object{MakeSnow(Spot,2000,Size,Thickness,MinHeight,MaxHeight,-y)}
    object{Slush2 translate <100,0,200>}
    object{Slush2 rotate y*10 translate <40,0,-200>}
    object{Slush2 rotate -y*10 scale <-1,1,-1> translate <40,0,1000>}
    
#end
</textarea>


<!-- Sample file : brushes.pov -->

<textarea id="brushes.pov" name="brushes.pov" style="display:none;">
// ==========================================
// Make-up brushes and other beauty props
// -----------------------------------------
// Made for Persistence of vision 3.6
// =========================================
// Copyright 2001-2004 Gilles Tran http://www.oyonale.com
// -----------------------------------------
// This work is licensed under the Creative Commons Attribution License. 
// To view a copy of this license, visit http://creativecommons.org/licenses/by/2.0/ 
// or send a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.
// You are free:
// - to copy, distribute, display, and perform the work
// - to make derivative works
// - to make commercial use of the work
// Under the following conditions:
// - Attribution. You must give the original author credit.
// - For any reuse or distribution, you must make clear to others the license terms of this work.
// - Any of these conditions can be waived if you get permission from the copyright holder.
// Your fair use and other rights are in no way affected by the above. 
// ==========================================  


#include "colors.inc"
#include "textures.inc"
#include "metals.inc"
#include "woods.inc"
camera{
    location  <0, 0.3, -0.6>
    direction z*2.3
    right     4*x/3
    look_at   <0, 0.1,  -0.1>
}               
background{rgb<1,0.98,0.96>}
light_source{<-10,10,-10>*10 color White*1.3}
light_source{<0, 0.6, -0.6> color White*0.3 shadowless}
plane{y,0 texture{pigment{rgb<1,0.98,0.96>} finish{ambient 0 diffuse 1}}}

//============================                     
// Make-up brush, round (1)
//============================                     
#declare T_Handle1=texture{T_Silver_5C}
#declare T_Head1=texture{
    pigment{
        radial
        frequency 100
        turbulence 0.03
        lambda 3
        color_map{
            [0 Black]
            [0.5 rgb<1,0.7,0.2>*0.4]
            [1 Black]
        }
    }
    normal{radial 1 frequency 100 turbulence 0.03 lambda 3}
    finish{ambient 0 diffuse 1 specular 0.2 roughness 0.001}
    scale <1,4,1>
}     
#declare T_Head1a=texture{
    pigment{
        radial
        frequency 100
        turbulence 0.03
        lambda 3
        color_map{
            [0 Clear]
            [0.5 rgb<1,0.7,0.2>*0.4]
            [1 Clear]
        }
    }
    normal{radial 1 frequency 100 turbulence 0.03 lambda 3}
    finish{ambient 0 diffuse 1 specular 0.2 roughness 0.001}
    scale <1,4,1>
}     

#declare Brush1 = lathe{
    #declare eP=0.6;
	cubic_spline
	15,	<0,1>,	<0,1>,	<0.100765,0.989652>,	<0.143949,0.968059>,	<0.172739,0.921276>,
	<0.129554,0.809715>,	<0.097166,0.705352>,	<0.082771,0.608186>,	<0.093567,0.600989>,	<0.071975,0.561403>,
	<0.057580,0.482230>,	<0.057580,0.385065>,	<0.061178,0.053981>,	<0.021592,0.000000>,	<0.039586,-0.028790>
	texture{
	    gradient y
	    texture_map{
	        [eP T_Handle1]
	        [eP T_Head1]
	        [1 T_Head1a]
	    }
	}
}	                        
//============================                     
// Make-up brush, round (2)
//============================                     
#declare T_Handle2=texture{T_Silver_4D}
#declare T_Head2=texture{
    pigment{
        radial
        frequency 100
        turbulence 0.03
        lambda 3
        color_map{
            [0 Clear]
            [0.5 rgb<1,0.8,0.2>]
            [1 Clear]
        }
    }
    normal{radial 1 frequency 100 turbulence 0.03 lambda 3}
    finish{ambient 0 diffuse 1 specular 0.2 roughness 0.001}
    scale <1,4,1>
}     

#declare Brush2 = lathe{
    #declare eP=0.7;
	cubic_spline
	13,	<0,1>,	<0,1>,	<0.121441,0.974489>,	<0.148099,0.876743>,
	<0.130327,0.790846>,	<0.068125,0.678291>,	<0.077011,0.672367>,	<0.047392,0.503535>,
	<0.038506,0.396904>,	<0.038506,0.316931>,	<0.041468,0.044430>,	<0.008886,0.000000>,	<0.023696,-0.023696>
	texture{
	    gradient y
	    texture_map{
	        [eP T_Handle2]
	        [eP T_Head1]
	        [1 T_Head2]
	    }
	}
}
//============================                     
// Make-up brush, round (3)
//============================                     
#declare T_Handle3=texture{T_Chrome_4D}
#declare Brush3 = lathe{
    #declare eP=0.67;
	cubic_spline
	13,	<0,1>,	<0,1>,	<0.192361,0.988440>,	<0.150930,0.908537>,
	<0.106538,0.816795>,	<0.068066,0.677703>,	<0.076944,0.671784>,	<0.085823,0.639231>,
	<0.068066,0.618515>,	<0.038472,0.355128>,	<0.041432,0.044391>,	<0.008878,0.000000>,
	<0.023675,-0.023675>
	texture{
	    gradient y
	    texture_map{
	        [0.63 pigment{color Red*0.8} finish{ambient 0 diffuse 1 specular 0.2 roughness 0.0001 reflection 0.2}]
	        [0.63 T_Handle1]
	        [eP T_Handle1]
	        [eP T_Head1]
	        [1 T_Head1a]
	    }
	}
}
                                       
//============================                     
// Make-up brush, flat (4)
//============================                     
#declare T_Handle4=texture{T_Gold_4E}
#declare Brush4 = lathe{
    #declare eP=0.93;
	cubic_spline
	11,
	<0.012925,0.995192>,	<0.012925,1.000362>,	<0.041359,0.987437>,	<0.038774,0.930569>,	<0.046528,0.915060>,
	<0.038774,0.780644>,	<0.031019,0.604870>,	<0.036189,0.276586>,	<0.038774,0.038774>,	<0.010340,0.000000>,
	<0.023264,-0.020679>
	texture{
	    gradient y
	    texture_map{
	        [eP T_Handle4]
	        [eP T_Head1]
	    }
	}
}
//============================                     
// Pot with brushes
//============================                     
#declare Pot1=union{
    #declare rPot1=0.075/2;
    #declare ePot1=0.006;
    #declare yPot1=0.067;
    union{
        torus{rPot1-ePot1*0.5,ePot1*0.5 scale <1,0.5,1> translate y*yPot1}
        difference{
            cylinder{0,y*yPot1,rPot1}
            cylinder{-y*ePot1,y*yPot1*1.1,rPot1-ePot1}
        }
        translate y*ePot1
    }
    torus{rPot1-ePot1*0.5,ePot1*0.5 translate y*ePot1*0.5 scale <1,2,1>}
    texture{
        pigment{Turquoise}
//        pigment{image_map{png "potmap" map_type 2} scale yPot1}
        normal{bumps 0.2  scale 0.02} //bumps 0.3 scale 0.03}
        finish{ambient 0 diffuse 1 specular 0.1 roughness 0.001 reflection 0.1}
    }
}
#declare Pot=union{
    object{Pot1}   
    
    union{
        object{Brush1 scale 0.10 rotate -z*20 translate <0.02,0.05,0>}
        object{Brush2 scale 0.11 rotate z*20 rotate y*30 translate <-0.02,0.04,0>}
        object{Brush2 scale 0.12 rotate z*30 rotate -y*30 translate <0,0.04,0>}
        object{Brush3 scale 0.09 rotate -z*15 rotate y*70 translate <0,0.04,0>}
        object{Brush4 scale 0.15 rotate -z*15 rotate -y*70 translate <0,0.04,0>}
        object{Brush4 scale 0.14 rotate -z*15 rotate -y*100 translate <0,0.04,0>}
        translate y*ePot1
    }
    
}                    


//============================                     
// Hairbrush
//============================                     
#declare Hairbrush=union{
    #declare rPg1=1;
    #declare rPg2=1.4;
    #declare rPg3=2;
    #declare zPg1=12;
    #declare zPg2=2;
    #declare zPg3=10;
    #declare ni=10;
    #declare nj=10;
    union{
        cylinder{0,z*zPg1,rPg1}
        sphere{0,rPg1 scale <1,1,0.7>}
        texture{T_Silver_1C finish{ambient 0}}
    }            
    union{
        cylinder{0,z*zPg2,rPg2 translate z*zPg1}
        sphere{0,rPg2*0.95 scale <1,1,0.7> translate z*zPg1}
        texture{pigment{Black} normal{bumps 0.2 scale 0.001} finish{ambient 0 diffuse 1 specular 0.5 roughness 0.1}}}
    #declare rd=seed(0);
    union{
        union{
            cylinder{0,z*zPg3,rPg3}
            sphere{0,rPg3*0.95 scale <1,1,0.7>}
            sphere{0,rPg3*0.95 scale <1,1,0.7> translate z*zPg3}
            texture{T_Wood32
                normal{bumps 0.2 scale 0.001}
                finish{ambient 0 diffuse 1 specular 0.3 roughness 0.1}
            }
        }                                                             
        union{
            #declare i=0;
            #while (i<ni)
                #declare j=0;
                #while (j<nj)
                    cylinder{0,y*1.2,0.08 rotate x*10*rand(rd) rotate y*360*rand(rd) translate <0,rPg3,i*0.95*zPg3/ni+0.8> rotate j*360/nj*z}
                    cylinder{0,y*1.1,0.08 rotate x*10*rand(rd) rotate y*360*rand(rd) translate <0,rPg3,i*0.95*zPg3/ni+0.8> rotate j*360/nj*z}
                    cylinder{0,y*1.3,0.08 rotate x*10*rand(rd) rotate y*360*rand(rd) translate <0,rPg3,i*0.95*zPg3/ni+0.8> rotate j*360/nj*z}
                    cylinder{0,y*1.4,0.08 rotate x*10*rand(rd) rotate y*360*rand(rd) translate <0,rPg3,i*0.95*zPg3/ni+0.8> rotate j*360/nj*z}
                    cylinder{0,y*0.9,0.08 rotate x*10*rand(rd) rotate y*360*rand(rd) translate <0,rPg3,i*0.95*zPg3/ni+0.8> rotate j*360/nj*z}
                    cylinder{0,y*1.5,0.08 rotate x*10*rand(rd) rotate y*360*rand(rd) translate <0,rPg3,i*0.95*zPg3/ni+0.8> rotate j*360/nj*z}
                    #declare j=j+1;
                #end
                #declare i=i+1;
            #end
            texture{pigment{rgb<1,0.6,0.3>*0.04} finish{ambient 0 diffuse 1 specular 0.3 roughness 0.1}}
        }
        translate z*(zPg1+zPg2)
    }
    translate y*rPg1
    rotate -x*8
    scale 0.01            
}
//============================                     
// Lipstick tubes
//============================                     
#declare Lipstick1=union{
    cylinder{0,y*0.045,0.01}
    cylinder{y*0.047,y*0.06,0.01}
    cylinder{0,y*0.06,0.008}
    sphere{0,0.01 scale <1,0.5,1> translate y*0.06}
    texture{T_Brass_1C finish{ambient 0}}
}
#declare Lipstick2=union{
    cylinder{0,y*0.055,0.011}
    cylinder{y*0.057,y*0.07,0.011}
    cylinder{0,y*0.06,0.009}
    sphere{0,0.011 scale <1,2,1> translate y*0.07}
    texture{T_Gold_1C finish{ambient 0}}
}                    

//==========================================
// Objects
//==========================================
object{Pot rotate y*-20 translate <-0.05,0,-0.02>}
object{Hairbrush rotate y*80 translate <-0.12,0,-0.13>}
object{Lipstick1 translate <-0.1,0,-0.04>}
object{Lipstick2 translate <-0.12,0,-0.06>}

</textarea>

<!-- Sample file : torusknot.pov -->

<textarea id="torusknot.pov" name="torusknot.pov" style="display:none;">
//******************************************************************************************
//* Torus Knot, by Paul Nylander, bugman123.com, 5/24/05
//* runtime: 20 seconds
//******************************************************************************************

#declare P=11; #declare Q=3; #declare k=P/Q; #declare R=1; #declare r=0.4; #declare rtube=0.1;

camera{location <0,2,2> look_at <0,0,-0.5> up z right x*image_width/image_height sky z}
light_source{<0,0,3>,1}

//Basic Functions
#local hue=array[7] {<0,1,0,0>,<1/6,1,1,0>,<1/3,0,1,0>,<1/2,0,1,1>,<2/3,0,0,1>,<5/6,1,0,1>,<1,1,0,0>};
#macro Gradient(hue,grad) #local n=dimension_size(grad,1); #local i=0;
 #while(i<n & grad[min(i,n-1)].x<hue) #local i=i+1; #end
 #if(i>0 & i<n) #local x1=grad[i-1].x; #local x2=grad[i].x; #local c=((x2-hue)*grad[i-1]+(hue-x1)*grad[i])/(x2-x1); #else #local c=grad[min(i,n-1)]; #end
 <c.y,c.z,c.t>
#end

//Parametric Plotting, function f must be defined before this function can be called
#macro ParametricPlot3D(u1,u2,du, v1,v2,dv) #local imax=int((u2-u1)/du); #local jmax=int((v2-v1)/dv);
 #local Mesh=array[imax+1][jmax+1]; #local i=0;
 #while(i<=imax) #local U=u1+i*du; #local j=0; #while(j<=jmax) #local Mesh[i][j]=f(U,v1+j*dv); #local j=j+1; #end #local i=i+1; #end
 DrawMesh(Mesh)
#end
#macro pt(p) <p.x,p.y,p.z> #end
#macro det3(a,b,c,d,e,f,g,h,i) -c*e*g+b*f*g+c*d*h-a*f*h-b*d*i+a*e*i #end // 3◊3 matrix
#macro color_triangle(p1,n1,c1, p2,n2,c2, p3,n3,c3) // adapted from Chris Colefax's triangle mapping macro
 #local nx=p2-p1; #local ny=p3-p1; #local nz=vcross(nx,ny);
 smooth_triangle{p1,n1,p2,n2,p3,n3 texture{
  #if(det3(nx.x,nx.y,nx.z, ny.x,ny.y,ny.z, nz.x,nz.y,nz.z)=0) pigment{rgb c1} #else pigment{
   average pigment_map{
    [1 gradient x color_map{[0 rgbt <0,0,0,0.5>][1 rgbt <3*c2.x,3*c2.y,3*c2.z,0.5>]}]
    [1 gradient y color_map{[0 rgbt <0,0,0,0.5>][1 rgbt <3*c3.x,3*c3.y,3*c3.z,0.5>]}]
    [1 gradient z color_map{[0 rgbt <0,0,0,0.5>][1 rgbt <3*c1.x,3*c1.y,3*c1.z,0.5>]}]
   }
   matrix <1.01,0,1, 0,1.01,1, 0,0,1, -0.002,-0.002,-1>
   matrix <nx.x,nx.y,nx.z, ny.x,ny.y,ny.z, nz.x,nz.y,nz.z, p1.x,p1.y,p1.z>
  } #end
  finish{reflection 0.4 specular 0.4}
 }}
#end
#macro colorquad(p1,n1,c1, p2,n2,c2, p3,n3,c3, p4,n4,c4)
 #if(vlength(p3-p1)<vlength(p4-p2))
  color_triangle(p1,n1,c1, p2,n2,c2, p3,n3,c3) color_triangle(p1,n1,c1, p3,n3,c3, p4,n4,c4)
 #else
  color_triangle(p1,n1,c1, p2,n2,c2, p4,n4,c4) color_triangle(p2,n2,c2, p3,n3,c3, p4,n4,c4)
 #end
#end
#macro DrawMesh(Mesh)
 #local imax=dimension_size(Mesh,1); #local jmax=dimension_size(Mesh,2); #local normals=array[imax][jmax];
 #local i=0;
 #while(i<imax) #local j=0; #while(j<jmax) #local normals[i][j]=<0,0,0>; #local j=j+1; #end #local i=i+1; #end
 #local i=0;
 #while(i<imax-1) #local j=0; // adapted from Tim Wenclawiak's Make_Normals function
  #while(j<jmax-1)
   #local p0=(Mesh[i][j]+Mesh[i][j+1]+Mesh[i+1][j]+Mesh[i+1][j+1])/4;
   #local N=vcross(pt(Mesh[i+1][j]-p0),pt(Mesh[i+1][j+1]-p0));
   #local E=vcross(pt(Mesh[i+1][j+1]-p0),pt(Mesh[i][j+1]-p0));
   #local S=vcross(pt(Mesh[i][j+1]-p0),pt(Mesh[i][j]-p0));
   #local W=vcross(pt(Mesh[i][j]-p0),pt(Mesh[i+1][j]-p0));
   #local normals[i][j]=normals[i][j]+S+W;
   #local normals[i+1][j]=normals[i+1][j]+N+W;
   #local normals[i][j+1]=normals[i][j+1]+S+E;
   #local normals[i+1][j+1]=normals[i+1][j+1]+N+E;
   #local j=j+1;
  #end
  #local i=i+1;
 #end
 #local i=0;
 #while(i<imax) #local j=0; #while(j<jmax) #local normals[i][j]=vnormalize(normals[i][j]); #local j=j+1; #end #local i=i+1; #end
 #local i=0;
 #while (i<imax-1) #local j=0;
  #while (j<jmax-1)
   colorquad(
    pt(Mesh[i  ][j  ]),normals[i  ][j  ],Gradient(Mesh[i  ][j  ].t,hue),
    pt(Mesh[i+1][j  ]),normals[i+1][j  ],Gradient(Mesh[i+1][j  ].t,hue),
    pt(Mesh[i+1][j+1]),normals[i+1][j+1],Gradient(Mesh[i+1][j+1].t,hue),
    pt(Mesh[i  ][j+1]),normals[i  ][j+1],Gradient(Mesh[i  ][j+1].t,hue)
   )
   #local j=j+1;
  #end
  #local i=i+1;
 #end
#end                 

//Tube Plot, Torus Knot
#declare dt=0.001;
#macro Sqr(X) X*X #end
#macro p(theta) #local phi=k*theta; #local rxy=R+r*cos(phi); <rxy*cos(theta),rxy*sin(theta),r*sin(phi)> #end
#macro f(t0,theta)
 #local p1=p(t0-dt); #local p2=p(t0); #local p3=p(t0+dt);
 #local dp=(p3-p1)/(2*dt); // finite difference derivative
 #local ddp=(p1-2*p2+p3)/Sqr(dt); // central differencing
 #local tangent=vnormalize(dp);
 #local normal1=vnormalize(ddp*vdot(dp,dp)-dp*vdot(dp,ddp));
 #local normal2=vcross(tangent,normal1);
 #local p0=p2+rtube*(normal1*cos(theta)+normal2*sin(theta));
 <p0.x,p0.y,p0.z,mod(t0/(2*pi),1)>
#end
ParametricPlot3D(0,2*Q*pi,pi/36, 0,2*pi,pi/6)

</textarea>


<!-- Sample file : dodec.pov -->

<textarea id="dodec.pov" name="dodec.pov" style="display:none;">
// Persistence of Vision Ray Tracer Scene Description File
// File: Dodec.pov
// Vers: 3.5
// Desc: Dodecahedron & small stellated dodecahedron
// Date: 2006.13.05
// Auth: PM 2Ring
//
// -d +A0.2 +AM2 +R4
// -F -A0.4 +AM2 +R1
// +A0.5 +AM2 +R2
// -d +A0.1 +AM2 +R4 +w1200 +h900
// +A0.3 +AM2 +R3
// -d +A0.5 +AM2 +R2 +w1200 +h900
// +A0.2 +AM2 +R2 +w1200 +h900 +FN
//

global_settings {
  assumed_gamma 1
  max_trace_level 50 //  7
}

#include "colors.inc"

#declare Area_Lights = 0;
#declare Do_Floor = 1*8;

#declare Reflect = 1*.75;

#declare WorldRad = 40;

//#declare CamLoc = <0, 15, -6.25> * .95;
//#declare CamLoc = <0, 4, -5> * 1;

#declare CamLoc = <0, 2, -6.25>* 2.0;
//#declare LookAt = 0;

//#declare CamLoc = <2.5, -3, 0.75>;
#declare LookAt = y*1.2;

camera {
  location CamLoc
  look_at LookAt
  right x*image_width/image_height up y
  direction z
  angle 30
}

#if(1)
light_source {
  <-0.75, 5, -3> * 4.5
  //rgb 1
  rgb 100 fade_distance 2.0 fade_power 2        //1.65 2.25

  #if(Area_Lights)
    #declare AL = 9;
    #declare ASize = 0.75;
    area_light x*ASize, z*ASize, AL, AL
    adaptive 1 // 2
    jitter
    circular
    orient
  #end
}
#end

light_source {CamLoc rgb .1 shadowless}

//---Textures--------------------------------------------------------------

//For sky
#declare CMGray0 = color_map {[0.2 rgb 0.1][0.8 rgb .9]}

//For ground
#declare CMGray1 = color_map {[0 rgb .60][1 rgb 1.0]}

//Block finish
#declare FShiny =
finish{
  ambient 0.075
  diffuse .8
  specular .75 roughness 3e-4
  phong .5 phong_size 5

  #if(Reflect)
    //reflection .175*Reflect
    reflection {0.05, 1 fresnel}
  #end
  conserve_energy
}

#declare FGlass =
finish
{
  ambient 0
  diffuse 0.15 //.2

  #if(Reflect)
    reflection {0.05*Reflect, 1*Reflect fresnel}
  #end

  specular .75
  roughness 1E-4
  //brilliance 1.5
  conserve_energy
}

#declare TGlass = texture
{
  pigment { color rgbf <0.985, .9975, .990, 1> }
  //pigment { color rgbf <0.985, .9975, 1, 1> }
  finish{FGlass}
}

#declare FGround =
finish{
  ambient 0.05
  specular .25 roughness 3e-4
  reflection .75*Reflect diffuse .7 //2
}

#declare TGround =
texture{
  //pigment{granite scale 75 colour_map{CMGray1}}
  //pigment{checker rgb 0, rgb 1 rotate 45*y scale 2}
  pigment{rgb 0*.75}
  finish{FGround}
}

//Tile textures
#declare Tex1=
texture{
  pigment{rgb 0}
  finish{FGround}
}

#declare Tex2=
texture{
  pigment{rgb 1}
  finish{FGround}
}

#declare Tex3=
texture{
  pigment{rgb 0.5}
  finish{FGround}
}

#declare TSky =
texture{
  pigment {
    function{abs(y)}
    color_map{CMGray0}
  }
  finish{ambient 0.1 diffuse 0.85}
}

//---Macros-------------------------------------------

#macro FaceColour0(N)#end

#macro FaceColour(N)
  #local Hue = 180 + 240*(mod(7+N,11))/11;
  //#local Hue = 240*mod(N,2);

  pigment{colour CHSV2RGB(<Hue, .75, .95>)filter 0.9}  // transmit 0.65
  //pigment{colour CHSV2RGB(<Hue, .65, .85>)}
  //pigment{rgb x}
  finish{FShiny}
  //finish{FGlass}
#end

#macro Pentamid(A, B, C, D, E, F)
  intersection
  {
    object{Planes[A] inverse}
    object{Planes[B]}
    object{Planes[C]}
    object{Planes[D]}
    object{Planes[E]}
    object{Planes[F]}
  }
#end

// ---Penrose triangle macros-------------------------------------

#declare Phi=(sqrt(5)+1)/2;            //The Golden ratio
#declare phi=Phi-1;

//Interpolate from A to B
#macro inter(A,B,r) (A*(1-r)+B*r) #end

#macro PutSlim(A,B,C,P)
  #if(P)
    #local T1 = Tex1;
    #local T2 = Tex2;
  #else
    #local T1 = Tex2;
    #local T2 = Tex1;
  #end

  #local E = inter(A,B,.5);
  #local F = inter(A,C,phi);
  #local G = inter(B,C,Phi/2);

  triangle{A,E,F texture{T1}}
  triangle{C,F,G texture{Tex3}}
  triangle{B,E,F texture{T2}}
  triangle{B,G,F texture{T2}}
#end

#macro PutWide(A,B,C,P)
  #if(P)
    #local T2 = Tex2;
  #else
    #local T2 = Tex1;
  #end

  #local E = inter(B,A,Phi/2);
  #local F = inter(B,C,phi);

  triangle{B,E,F texture{T2}}
  triangle{A,F,E texture{Tex3}}
  triangle{A,F,C texture{Tex3}}
#end

#macro Slim(A,B,C,D,P)
  #if(D=0)
    PutSlim(A,B,C,P)
  #else
    #local E = inter(A,B,phi);
    #local F = inter(C,A,phi);

    Wide(F,E,A,D-1,P)
    Slim(C,E,F,D-1,P)
    Slim(C,E,B,D-1,P)
  #end
#end

#macro Wide(A,B,C,D,P)
  #if(D=0)
    PutWide(A,B,C,P)
  #else
    #local E = inter(C,B,phi);

    Wide(E,A,B,D-1,1-P)
    Slim(C,A,E,D-1,1-P)
  #end
#end

// ----------------------------------------

#declare Top = 0*-1E-4;     //Tile top height
#declare Ang = pi/5;
#declare Ang0 = radians(-117);
#declare Ang1 = radians(-81);
#declare Rad = WorldRad;
#declare Rdepth = Do_Floor;

#if(Do_Floor)
#declare Wedge=mesh{
  Slim(0, <cos(Ang0), 0, sin(Ang0)>*Rad, <cos(Ang1), 0, sin(Ang1)>*Rad,
Rdepth, 0)
  translate Top*y
}

#declare Floor =
union{
#declare I=0;
#while(I<5)
  object {Wedge rotate y*72*I}
  object {Wedge matrix <0,0,-1, 0,1,0, -1,0,0, 0,0,0> rotate y*72*I}
  #declare I=I+1;
#end
  rotate 9*y
}
#end

//--------------------------The objects-------------------

//Pre-compute dodecahedron planes
#declare Planes = array[12];
#declare Planes[0] = plane { y, 1 FaceColour(0)};
#declare Planes[11] = plane {-y, 1 FaceColour(11)};
#declare I=1;
#while(I<=5)
  #declare Planes[I] =   plane {<0,  1, -2>, 1 rotate y*(36+72*I)
FaceColour(I)};
  #declare Planes[I+5] = plane {<0, -1, -2>, 1 rotate y*72*I
FaceColour(I+5)};
  #declare I=I+1;
#end

#declare Dodecahedron =
intersection
{
  #declare I=0;
  #while(I<12)
    object{Planes[I]}
    #declare I=I+1;
  #end

  bounded_by {sphere {0, 1.258409}}      //(2-Phi)*sqrt(3*Phi+6)
}

#declare SSDodec =
//union
merge
{
  Pentamid(0, 1, 2, 3, 4, 5)
  Pentamid(1, 0, 2, 5, 6, 7)
  Pentamid(2, 0, 1, 3, 7, 8)
  Pentamid(3, 0, 2, 4, 8, 9)
  Pentamid(4, 0, 3, 5, 9, 10)
  Pentamid(5, 0, 1, 4, 6, 10)
  Pentamid(6, 11, 10, 7, 5, 1)
  Pentamid(7, 11, 8, 6, 2, 1)
  Pentamid(8, 11, 9, 7, 3, 2)
  Pentamid(9, 11, 10, 8, 4, 3)
  Pentamid(10, 11, 9, 6, 5, 4)
  Pentamid(11, 10, 9, 8, 7, 6)
  object{Dodecahedron}

  //interior{ior 1.5 dispersion 1.1 dispersion_samples 5}
  interior{ior 1.5}

  bounded_by {sphere {0, sqrt(5)}}
  rotate x*degrees(atan(3-sqrt(5)))

  translate y*1.7761
}

#declare Ground =
  cylinder{
  -y, Top*y, WorldRad
  texture{TGround}
}

#declare Sky =
sphere {0,1 inverse
  texture{TSky}
  scale WorldRad
}

//--------------------------The actual scene-------------------

#if(1)
  object{Sky}
#else
  background{rgb 0.5}
#end

#if(Do_Floor)
  object{Floor}
#else
  object{Ground}
#end

#if(1)
object{
  //Dodecahedron
  SSDodec
  //texture{TGlass}

  //translate y
  rotate y*(180 - 3*18)

  //scale 1.25
  //translate -Phi*z
}
#end

</textarea>


<!-- Sample file : boyssurface.pov -->

<textarea id="boyssurface.pov" name="boyssurface.pov" style="display:none;">
//******************************************************************************************
//* Boy's Surface, by Paul Nylander, bugman123.com, 5/24/05
//* runtime: 1.8 minutes
//******************************************************************************************

camera{location <0,0,4.5> look_at <0,0,0> right x*image_width/image_height up y sky z}
light_source{<3,0,3>,1} light_source{<-1.5,2.59808,2>,1} light_source{<-1.5,-2.59808,2>,1}

//Basic Functions
//#macro square(X) X*X #end
#macro hue(h) #local X=mod(6*h,1); #local c=<0,0,0>;
 #switch(mod(floor(6*h),6))
  #case(0) #local c=<1,X,0>; #break
  #case(1) #local c=<1-X,1,0>; #break
  #case(2) #local c=<0,1,X>; #break
  #case(3) #local c=<0,1-X,1>; #break
  #case(4) #local c=<X,0,1>; #break
  #case(5) #local c=<1,0,1-X>; #break
 #end
 c
#end

//Complex Functions
#macro Complex(X,Y) <X,Y> #end
#declare I=Complex(0,1);
#macro Re(Z) Z.x #end
#macro Im(Z) Z.y #end
#macro Abs(Z) vlength(Z) #end
#macro Arg(Z) atan2(Im(Z),Re(Z)) #end
#macro Sqr(Z) Complex(square(Re(Z))-square(Im(Z)),2*Re(Z)*Im(Z)) #end
#macro Pow(Z,n) #local r=Abs(Z); #if(r=0) #local z2=Complex(0,0); #else #local theta=n*Arg(Z); #local z2=pow(r,n)*Complex(cos(theta),sin(theta)); #end z2 #end
#macro Sqrt(Z) Pow(Z,1/2) #end
#macro Mult(z1,z2) Complex(Re(z1)*Re(z2)-Im(z1)*Im(z2),Im(z1)*Re(z2)+Re(z1)*Im(z2)) #end
#macro Div(z1,z2) Mult(z1,Pow(z2,-1)) #end
#macro Exp(Z) exp(Re(Z))*Complex(cos(Im(Z)),sin(Im(Z))) #end

//Parametric Plotting, function f must be defined before this function can be called
#macro ParametricPlot3D(u1,u2,du, v1,v2,dv) #local imax=int((u2-u1)/du); #local jmax=int((v2-v1)/dv);
 #local Mesh=array[imax+1][jmax+1]; #local i=0;
 #while(i<=imax) #local U=u1+i*du; #local j=0; #while(j<=jmax) #local Mesh[i][j]=f(U,v1+j*dv); #local j=j+1; #end #local i=i+1; #end
 DrawMesh(Mesh)
#end
#macro pt(p) <p.x,p.y,p.z> #end
#macro det3(a,b,c,d,e,f,g,h,i) -c*e*g+b*f*g+c*d*h-a*f*h-b*d*i+a*e*i #end // 3◊3 matrix
#macro color_triangle(p1,n1,c1, p2,n2,c2, p3,n3,c3) // adapted from Chris Colefax's triangle mapping macro
 #local nx=p2-p1; #local ny=p3-p1; #local nz=vcross(nx,ny);
 smooth_triangle{p1,n1,p2,n2,p3,n3 texture{
  #if(det3(nx.x,nx.y,nx.z, ny.x,ny.y,ny.z, nz.x,nz.y,nz.z)=0) pigment{rgb c1} #else pigment{
   average pigment_map{
    [1 gradient x color_map{[0 rgbt <0,0,0,0.5>][1 rgbt <3*c2.x,3*c2.y,3*c2.z,0.5>]}]
    [1 gradient y color_map{[0 rgbt <0,0,0,0.5>][1 rgbt <3*c3.x,3*c3.y,3*c3.z,0.5>]}]
    [1 gradient z color_map{[0 rgbt <0,0,0,0.5>][1 rgbt <3*c1.x,3*c1.y,3*c1.z,0.5>]}]
   }
   matrix <1.01,0,1, 0,1.01,1, 0,0,1, -0.002,-0.002,-1>
   matrix <nx.x,nx.y,nx.z, ny.x,ny.y,ny.z, nz.x,nz.y,nz.z, p1.x,p1.y,p1.z>
  } #end
  finish{reflection 0.4 specular 0.4}
 }}
#end
#macro colorquad(p1,n1,c1, p2,n2,c2, p3,n3,c3, p4,n4,c4)
 #if(vlength(p3-p1)<vlength(p4-p2))
  color_triangle(p1,n1,c1, p2,n2,c2, p3,n3,c3) color_triangle(p1,n1,c1, p3,n3,c3, p4,n4,c4)
 #else
  color_triangle(p1,n1,c1, p2,n2,c2, p4,n4,c4) color_triangle(p2,n2,c2, p3,n3,c3, p4,n4,c4)
 #end
#end
#macro DrawMesh(Mesh)
 #local imax=dimension_size(Mesh,1); #local jmax=dimension_size(Mesh,2); #local normals=array[imax][jmax];
 #local i=0;
 #while(i<imax) #local j=0; #while(j<jmax) #local normals[i][j]=<0,0,0>; #local j=j+1; #end #local i=i+1; #end
 #local i=0;
 #while(i<imax-1) #local j=0; // adapted from Tim Wenclawiak's Make_Normals function
  #while(j<jmax-1)
   #local p0=(Mesh[i][j]+Mesh[i][j+1]+Mesh[i+1][j]+Mesh[i+1][j+1])/4;
   #local N=vcross(pt(Mesh[i+1][j]-p0),pt(Mesh[i+1][j+1]-p0));
   #local E=vcross(pt(Mesh[i+1][j+1]-p0),pt(Mesh[i][j+1]-p0));
   #local S=vcross(pt(Mesh[i][j+1]-p0),pt(Mesh[i][j]-p0));
   #local W=vcross(pt(Mesh[i][j]-p0),pt(Mesh[i+1][j]-p0));
   #local normals[i][j]=normals[i][j]+S+W;
   #local normals[i+1][j]=normals[i+1][j]+N+W;
   #local normals[i][j+1]=normals[i][j+1]+S+E;
   #local normals[i+1][j+1]=normals[i+1][j+1]+N+E;
   #local j=j+1;
  #end
  #local i=i+1;
 #end
 #local i=0;
 #while(i<imax) #local j=0; #while(j<jmax) #local normals[i][j]=vnormalize(normals[i][j]); #local j=j+1; #end #local i=i+1; #end
 #local i=0;
 #while (i<imax-1) #local j=0;
  #while (j<jmax-1)
   colorquad(
    pt(Mesh[i  ][j  ]),normals[i  ][j  ],hue(Mesh[i  ][j  ].t),
    pt(Mesh[i+1][j  ]),normals[i+1][j  ],hue(Mesh[i+1][j  ].t),
    pt(Mesh[i+1][j+1]),normals[i+1][j+1],hue(Mesh[i+1][j+1].t),
    pt(Mesh[i  ][j+1]),normals[i  ][j+1],hue(Mesh[i  ][j+1].t)
   )
   #local j=j+1;
  #end
  #local i=i+1;
 #end
#end                  

//Boy's Surface Calculations
#macro Boys(r,theta)
 #local Z=r*Exp(I*theta); #local d=Pow(Z,6)+sqrt(5)*Pow(Z,3)-Complex(1,0);
 #local M=<Re(Div(Mult(I,Pow(Z,5)-Z),d)),Re(Div(Pow(Z,5)+Z,d)),Re(Div(2*Mult(I,Pow(Z,6)+Complex(1,0))/3,d))>+<0,0,0.5>;
 M/((M.x)*(M.x)+(M.y)*(M.y)+(M.z)*(M.z))
#end
#macro f(r,theta) #local p=Boys(r,theta); <p.x,p.y,p.z,r> #end
ParametricPlot3D(0,1,1/45, -pi,pi,2*pi/180)

</textarea>



<!-- Sample file : xxxxxx.pov -->

<textarea id="xxxxxx.pov" name="xxxxxx.pov" style="display:none;">

</textarea>


    <!-- Generate Token Id -->
	<script type="text/javascript">
	    function generateTokenId()
	    {
    	  document.getElementById("token_id").value = new Date().getTime();
	    }
    </script>

	<!-- Retrieve Sample filename -->
	<script type="text/javascript">

    $(".dropdown-menu li a").click(function(){
      var selFilename = $(this).text();
	  var selText = document.getElementById(selFilename).value ;
	  changeTextArea(selText);
	  document.getElementById("scenelabel").innerHTML = selFilename;
    });
	
    </script>

    <!-- Change TextArea with sample file content -->
	<script type="text/javascript">

    function changeTextArea(text)
    {
      document.getElementById("scene").value = text;
    }
	
    </script>
		
	<!-- Update slide bars -->
	<script type="text/javascript">
	function changeWidthValue(newValue)
	{
		document.getElementById("widthvalue").value = newValue;
	}
	function changeHeightValue(newValue)
	{
		document.getElementById("heightvalue").value=newValue;
	}
	function changeWidthSliderValue(newValue)
	{
		document.getElementById("widthslider").value=newValue;
	}
	function changeHeightSliderValue(newValue)
	{
		document.getElementById("heightslider").value=newValue;
	}
	</script>
	
</body>

</html>

